/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],Z=function(G){for(var e=[],m=0,A=G.length;m<A;m++)e[m]=Q[G[m]];return e};define(Q[85],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(A,O){if(!A)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}e.ok=m}),define(Q[62],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function A(D){const d=[];for(let y in D)m.call(D,y)&&d.push(D[y]);return d}e.values=A;function O(D,d){for(let y in D)if(m.call(D,y)&&d({key:y,value:D[y]},function(){delete D[y]})===!1)return}e.forEach=O;function R(D,d){const y=Object.create(null);for(const b of D){const a=d(b);let C=y[a];C||(C=y[a]=[]),C.push(b)}return y}e.groupBy=R;function T(D){const d=Object.create(null);return D&&D.forEach((y,b)=>{d[b]=y}),d}e.fromMap=T;function L(D,d){const y=[],b=[];for(let a of D)d.has(a)||y.push(a);for(let a of d)D.has(a)||b.push(a);return{removed:y,added:b}}e.diffSets=L;function f(D,d){const y=[],b=[];for(let[a,C]of D)d.has(a)||y.push(C);for(let[a,C]of d)D.has(a)||b.push(C);return{removed:y,added:b}}e.diffMaps=f;class g{constructor(){this.map=new Map}add(d,y){let b=this.map.get(d);b||(b=new Set,this.map.set(d,b)),b.add(y)}delete(d,y){const b=this.map.get(d);!b||(b.delete(y),b.size===0&&this.map.delete(d))}forEach(d,y){const b=this.map.get(d);!b||b.forEach(y)}}e.SetMap=g}),define(Q[86],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function m(f){return(g,D,d)=>{let y=null,b=null;if(typeof d.value=="function"?(y="value",b=d.value):typeof d.get=="function"&&(y="get",b=d.get),!b)throw new Error("not supported");d[y]=f(b,D)}}e.createDecorator=m;let A=0;function O(){const f=`$memoize${A++}`;let g;const D=function(y,b,a){let C=null,E=null;if(typeof a.value=="function"?(C="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(C="get",E=a.get),!E)throw new Error("not supported");const p=`${f}:${b}`;a[C]=function(...w){return g=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,w)}),this[p]}};return D.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(d=>{d.indexOf(f)===0&&delete g[d]})},D}e.createMemoizer=O;function R(f,g,D){return O()(f,g,D)}e.memoize=R;function T(f,g,D){return m((d,y)=>{const b=`$debounce$${y}`,a=`$debounce$result$${y}`;return function(...C){this[a]||(this[a]=D?D():void 0),clearTimeout(this[b]),g&&(this[a]=g(this[a],...C),C=[this[a]]),this[b]=setTimeout(()=>{d.apply(this,C),this[a]=D?D():void 0},f)}})}e.debounce=T;function L(f,g,D){return m((d,y)=>{const b=`$throttle$timer$${y}`,a=`$throttle$result$${y}`,C=`$throttle$lastRun$${y}`,E=`$throttle$pending$${y}`;return function(...p){if(this[a]||(this[a]=D?D():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),g&&(this[a]=g(this[a],...p)),!this[E]){const w=this[C]+f;w<=Date.now()?(this[C]=Date.now(),d.apply(this,[this[a]]),this[a]=D?D():void 0):(this[E]=!0,this[b]=setTimeout(()=>{this[E]=!1,this[C]=Date.now(),d.apply(this,[this[a]]),this[a]=D?D():void 0},w-Date.now()))}}})}e.throttle=L}),define(Q[11],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function O(i){f(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=O;function R(i){f(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=R;function T(i){if(i instanceof Error){let{name:t,message:n}=i;const r=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:r}}return i}e.transformErrorForSerialization=T;const L="Canceled";function f(i){return i instanceof Error&&i.name===L&&i.message===L}e.isPromiseCanceledError=f;class g extends Error{constructor(){super(L);this.name=this.message}}e.CancellationError=g;function D(){const i=new Error(L);return i.name=i.message,i}e.canceled=D;function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=d;function y(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=y;function b(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function a(i){const t=new Error(`${i} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function C(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=C;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function v(i){const t=i;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function o(i,t=Object.create(null)){const n=new Error(i);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=o}),define(Q[18],Z([0,1,11]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(B,M=0){return B[B.length-(1+M)]}e.tail=A;function O(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=O;function R(B,M,F=(k,U)=>k===U){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let k=0,U=B.length;k<U;k++)if(!F(B[k],M[k]))return!1;return!0}e.equals=R;function T(B,M,F){let k=0,U=B.length-1;for(;k<=U;){const j=(k+U)/2|0,z=F(B[j],M);if(z<0)k=j+1;else if(z>0)U=j-1;else return j}return-(k+1)}e.binarySearch=T;function L(B,M){let F=0,k=B.length;if(k===0)return 0;for(;F<k;){const U=Math.floor((F+k)/2);M(B[U])?k=U:F=U+1}return F}e.findFirstInSorted=L;function f(B,M,F){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let k=M[Math.floor(M.length*Math.random())],U=[],j=[],z=[];for(let H of M){const K=F(H,k);K<0?U.push(H):K>0?j.push(H):z.push(H)}return B<U.length?f(B,U,F):B<U.length+z.length?z[0]:f(B-(U.length+z.length),j,F)}e.quickSelect=f;function g(B,M){const F=[];let k;for(const U of B.slice(0).sort(M))!k||M(k[0],U)!==0?(k=[U],F.push(k)):k.push(U);return F}e.groupBy=g;function D(B,M,F){const k=[];function U(H,K,te){if(!(K===0&&te.length===0)){const X=k[k.length-1];X&&X.start+X.deleteCount===H?(X.deleteCount+=K,X.toInsert.push(...te)):k.push({start:H,deleteCount:K,toInsert:te})}}let j=0,z=0;for(;;){if(j===B.length){U(j,0,M.slice(z));break}if(z===M.length){U(j,B.length-j,[]);break}const H=B[j],K=M[z],te=F(H,K);te===0?(j+=1,z+=1):te<0?(U(j,1,[]),j+=1):te>0&&(U(j,0,[K]),z+=1)}return k}e.sortedDiff=D;function d(B,M,F){const k=D(B,M,F),U=[],j=[];for(const z of k)U.push(...B.slice(z.start,z.start+z.deleteCount)),j.push(...z.toInsert);return{removed:U,added:j}}e.delta=d;function y(B,M,F){if(F===0)return[];const k=B.slice(0,F).sort(M);return a(B,M,k,F,B.length),k}e.top=y;function b(B,M,F,k,U){return F===0?Promise.resolve([]):new Promise((j,z)=>{(async()=>{const H=B.length,K=B.slice(0,F).sort(M);for(let te=F,X=Math.min(F+k,H);te<H;te=X,X=Math.min(X+k,H)){if(te>F&&await new Promise(ie=>setTimeout(ie)),U&&U.isCancellationRequested)throw(0,m.canceled)();a(B,M,K,te,X)}return K})().then(j,z)})}e.topAsync=b;function a(B,M,F,k,U){for(const j=F.length;k<U;k++){const z=B[k];if(M(z,F[j-1])<0){F.pop();const H=L(F,K=>M(z,K)<0);F.splice(H,0,z)}}}function C(B){return B.filter(M=>!!M)}e.coalesce=C;function E(B){let M=0;for(let F=0;F<B.length;F++)B[F]&&(B[M]=B[F],M+=1);B.length=M}e.coalesceInPlace=E;function p(B,M,F){B.splice(F,0,B.splice(M,1)[0])}e.move=p;function w(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=w;function v(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=v;function o(B,M){if(!M)return B.filter((k,U)=>B.indexOf(k)===U);const F=Object.create(null);return B.filter(k=>{const U=M(k);return F[U]?!1:(F[U]=!0,!0)})}e.distinct=o;function i(B){const M=new Set;return B.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=i;function t(B){const M=Object.create(null);return F=>{const k=B(F);return M[k]?!1:(M[k]=!0,!0)}}e.uniqueFilter=t;function n(B,M){for(let F=B.length-1;F>=0;F--){const k=B[F];if(M(k))return F}return-1}e.lastIndex=n;function r(B,M){return B.length>0?B[0]:M}e.firstOrDefault=r;function c(B,M,F=(k,U)=>k===U){let k=0;for(let U=0,j=Math.min(B.length,M.length);U<j&&F(B[U],M[U]);U++)k++;return k}e.commonPrefixLength=c;function s(B){return[].concat(...B)}e.flatten=s;function l(B,M){let F=typeof M=="number"?B:0;typeof M=="number"?F=B:(F=0,M=B);const k=[];if(F<=M)for(let U=F;U<M;U++)k.push(U);else for(let U=F;U>M;U--)k.push(U);return k}e.range=l;function h(B,M,F){return B.reduce((k,U)=>(k[M(U)]=F?F(U):U,k),Object.create(null))}e.index=h;function S(B,M){return B.push(M),()=>I(B,M)}e.insert=S;function I(B,M){const F=B.indexOf(M);if(F>-1)return B.splice(F,1),M}e.remove=I;function u(B,M,F){const k=B.slice(0,M),U=B.slice(M);return k.concat(F,U)}e.arrayInsert=u;function P(B,M){let F;if(typeof M=="number"){let k=M;F=()=>{const U=Math.sin(k++)*179426549;return U-Math.floor(U)}}else F=Math.random;for(let k=B.length-1;k>0;k-=1){const U=Math.floor(F()*(k+1)),j=B[k];B[k]=B[U],B[U]=j}}e.shuffle=P;function _(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.unshift(M))}e.pushToStart=_;function q(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.push(M))}e.pushToEnd=q;function W(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=W;function N(B){return Array.isArray(B)?B:[B]}e.asArray=N;function $(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=$;function V(B,M){for(const F of B){const k=M(F);if(k!==void 0)return k}}e.mapFind=V}),define(Q[63],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(A){const O=this;let R=!1,T;return function(){return R||(R=!0,T=A.apply(O,arguments)),T}}e.once=m}),define(Q[52],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(A){function O(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=O;const R=Object.freeze([]);function T(){return R}A.empty=T;function*L(i){yield i}A.single=L;function f(i){return i||R}A.from=f;function g(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=g;function D(i){return i[Symbol.iterator]().next().value}A.first=D;function d(i,t){for(const n of i)if(t(n))return!0;return!1}A.some=d;function y(i,t){for(const n of i)if(t(n))return n}A.find=y;function*b(i,t){for(const n of i)t(n)&&(yield n)}A.filter=b;function*a(i,t){for(const n of i)yield t(n)}A.map=a;function*C(...i){for(const t of i)for(const n of t)yield n}A.concat=C;function*E(i){for(const t of i)for(const n of t)yield n}A.concatNested=E;function p(i,t,n){let r=n;for(const c of i)r=t(r,c);return r}A.reduce=p;function*w(i,t,n=i.length){for(t<0&&(t+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);t<n;t++)yield i[t]}A.slice=w;function v(i,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,i];const r=i[Symbol.iterator]();for(let c=0;c<t;c++){const s=r.next();if(s.done)return[n,A.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return r}}]}A.consume=v;function o(i,t,n=(r,c)=>r===c){const r=i[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const s=r.next(),l=c.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!n(s.value,l.value))return!1}}A.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(Q[32],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function T(t,n=!1){let r=0,c=t.length,s="",l=0,h=16,S=0;function I($){let V=0,B=0;for(;V<$;){const M=t.charCodeAt(r);if(M>=48&&M<=57)B=B*16+M-48;else if(M>=65&&M<=70)B=B*16+M-65+10;else if(M>=97&&M<=102)B=B*16+M-97+10;else break;r++,V++}return V<$&&(B=-1),B}function u($){r=$,s="",l=0,h=16,S=0}function P(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return S=3,t.substring($,r);let V=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;V=r}else S=3;return t.substring($,V)}function _(){let $="",V=r;for(;;){if(r>=c){$+=t.substring(V,r),S=2;break}const B=t.charCodeAt(r);if(B===34){$+=t.substring(V,r),r++;break}if(B===92){if($+=t.substring(V,r),r++,r>=c){S=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const F=I(4);F>=0?$+=String.fromCharCode(F):S=4;break;default:S=5}V=r;continue}if(B>=0&&B<=31)if(f(B)){$+=t.substring(V,r),S=2;break}else S=6;r++}return $}function q(){if(s="",S=0,l=r,r>=c)return l=c,h=17;let $=t.charCodeAt(r);if(L($)){do r++,s+=String.fromCharCode($),$=t.charCodeAt(r);while(L($));return h=15}if(f($))return r++,s+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),h=14;switch($){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,s=_(),h=10;case 47:const V=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!f(t.charCodeAt(r));)r++;return s=t.substring(V,r),h=12}if(t.charCodeAt(r+1)===42){r+=2;const B=c-1;let M=!1;for(;r<B;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,S=1),s=t.substring(V,r),h=13}return s+=String.fromCharCode($),r++,h=16;case 45:if(s+=String.fromCharCode($),r++,r===c||!g(t.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),h=11;default:for(;r<c&&W($);)r++,$=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode($),r++,h=16}}function W($){if(L($)||f($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=q();while($>=12&&$<=15);return $}return{setPosition:u,getPosition:()=>r,scan:n?N:q,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>S}}e.createScanner=T;function L(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function d(t,n){const r=[],c=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function S(I,u,P,_){l.value=I,l.offset=u,l.length=P,l.type=_,l.colonOffset=void 0,s=l}try{v(t,{onObjectBegin:(I,u)=>{if(n<=I)throw c;s=void 0,h=n>I,r.push("")},onObjectProperty:(I,u,P)=>{if(n<u||(S(I,u,P,"property"),r[r.length-1]=I,n<=u+P))throw c},onObjectEnd:(I,u)=>{if(n<=I)throw c;s=void 0,r.pop()},onArrayBegin:(I,u)=>{if(n<=I)throw c;s=void 0,r.push(0)},onArrayEnd:(I,u)=>{if(n<=I)throw c;s=void 0,r.pop()},onLiteralValue:(I,u,P)=>{if(n<u||(S(I,u,P,i(I)),n<=u+P))throw c},onSeparator:(I,u,P)=>{if(n<=u)throw c;if(I===":"&&s&&s.type==="property")s.colonOffset=u,h=!1,s=void 0;else if(I===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(h=!0,r[r.length-1]=""),s=void 0}}})}catch(I){if(I!==c)throw I}return{path:r,previousNode:s,isAtPropertyKey:h,matches:I=>{let u=0;for(let P=0;u<I.length&&P<r.length;P++)if(I[u]===r[P]||I[u]==="*")u++;else if(I[u]!=="**")return!1;return u===I.length}}}e.getLocation=d;function y(t,n=[],r=R.DEFAULT){let c=null,s=[];const l=[];function h(I){Array.isArray(s)?s.push(I):c!==null&&(s[c]=I)}return v(t,{onObjectBegin:()=>{const I={};h(I),l.push(s),s=I,c=null},onObjectProperty:I=>{c=I},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const I=[];h(I),l.push(s),s=I,c=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:h,onError:(I,u,P)=>{n.push({error:I,offset:u,length:P})}},r),s[0]}e.parse=y;function b(t,n=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){c.type==="property"&&(c.length=I-c.offset,c=c.parent)}function l(I){return c.children.push(I),I}v(t,{onObjectBegin:I=>{c=l({type:"object",offset:I,length:-1,parent:c,children:[]})},onObjectProperty:(I,u,P)=>{c=l({type:"property",offset:u,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:I,offset:u,length:P,parent:c})},onObjectEnd:(I,u)=>{c.length=I+u-c.offset,c=c.parent,s(I+u)},onArrayBegin:(I,u)=>{c=l({type:"array",offset:I,length:-1,parent:c,children:[]})},onArrayEnd:(I,u)=>{c.length=I+u-c.offset,c=c.parent,s(I+u)},onLiteralValue:(I,u,P)=>{l({type:i(I),offset:u,length:P,parent:c,value:I}),s(u+P)},onSeparator:(I,u,P)=>{c.type==="property"&&(I===":"?c.colonOffset=u:I===","&&s(u))},onError:(I,u,P)=>{n.push({error:I,offset:u,length:P})}},r);const S=c.children[0];return S&&delete S.parent,S}e.parseTree=b;function a(t,n){if(!!t){let r=t;for(let c of n)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===c){r=l.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}}e.findNodeAtLocation=a;function C(t){if(!t.parent||!t.parent.children)return[];const n=C(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=C;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let r of t.children){const c=r.children[1];c&&(n[r.children[0].value]=E(c))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=p;function w(t,n,r=!1){if(p(t,n,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=n;s++){const l=w(c[s],n,r);if(l)return l}return t}}e.findNodeAtOffset=w;function v(t,n,r=R.DEFAULT){const c=T(t,!1);function s(K){return K?()=>K(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(K){return K?te=>K(te,c.getTokenOffset(),c.getTokenLength()):()=>!0}const h=s(n.onObjectBegin),S=l(n.onObjectProperty),I=s(n.onObjectEnd),u=s(n.onArrayBegin),P=s(n.onArrayEnd),_=l(n.onLiteralValue),q=l(n.onSeparator),W=s(n.onComment),N=l(n.onError),$=r&&r.disallowComments,V=r&&r.allowTrailingComma;function B(){for(;;){const K=c.scan();switch(c.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:$||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:$?M(10):W();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,te=[],X=[]){if(N(K),te.length+X.length>0){let ie=c.getToken();for(;ie!==17;){if(te.indexOf(ie)!==-1){B();break}else if(X.indexOf(ie)!==-1)break;ie=B()}}}function F(K){const te=c.getTokenValue();return K?_(te):S(te),B(),!0}function k(){switch(c.getToken()){case 11:let K=0;try{K=JSON.parse(c.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch(te){M(2)}_(K);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return B(),!0}function U(){return c.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),c.getToken()===6?(q(":"),B(),H()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){h(),B();let K=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),q(","),B(),c.getToken()===2&&V)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return I(),c.getToken()!==2?M(7,[2],[]):B(),!0}function z(){u(),B();let K=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),q(","),B(),c.getToken()===4&&V)break}else K&&M(6,[],[]);H()||M(4,[],[4,5]),K=!0}return P(),c.getToken()!==4?M(8,[4],[]):B(),!0}function H(){switch(c.getToken()){case 3:return z();case 1:return j();case 10:return F(!0);default:return k()}}return B(),c.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):H()?(c.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=v;function o(t,n){let r=T(t),c=[],s,l=0,h;do switch(h=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==h&&c.push(t.substring(l,h)),n!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(s!==17);return c.join("")}e.stripComments=o;function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=i}),define(Q[46],Z([0,1,32]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(f,g,D){let d,y,b,a,C;if(g){for(a=g.offset,C=a+g.length,b=a;b>0&&!L(f,b-1);)b--;let l=C;for(;l<f.length&&!L(f,l);)l++;y=f.substring(b,l),d=R(y,D)}else y=f,d=0,b=0,a=0,C=f.length;const E=T(D,f);let p=!1,w=0,v;D.insertSpaces?v=O(" ",D.tabSize||4):v="	";const o=(0,m.createScanner)(y,!1);let i=!1;function t(){return E+O(v,d+w)}function n(){let l=o.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=o.scan();return i=l===16||o.getTokenError()!==0,l}const r=[];function c(l,h,S){!i&&h<C&&S>a&&f.substring(h,S)!==l&&r.push({offset:h,length:S-h,content:l})}let s=n();if(s!==17){const l=o.getTokenOffset()+b,h=O(v,d);c(h,b,l)}for(;s!==17;){let l=o.getTokenOffset()+o.getTokenLength()+b,h=n(),S="";for(;!p&&(h===12||h===13);){const u=o.getTokenOffset()+b;c(" ",l,u),l=o.getTokenOffset()+o.getTokenLength()+b,S=h===12?t():"",h=n()}if(h===2)s!==1&&(w--,S=t());else if(h===4)s!==3&&(w--,S=t());else{switch(s){case 3:case 1:w++,S=t();break;case 5:case 12:S=t();break;case 13:p?S=t():S=" ";break;case 6:S=" ";break;case 10:if(h===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?S=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}p&&(h===12||h===13)&&(S=t())}const I=o.getTokenOffset()+b;c(S,l,I),s=h}return r}e.format=A;function O(f,g){let D="";for(let d=0;d<g;d++)D+=f;return D}function R(f,g){let D=0,d=0;const y=g.tabSize||4;for(;D<f.length;){const b=f.charAt(D);if(b===" ")d++;else if(b==="	")d+=y;else break;D++}return Math.floor(d/y)}function T(f,g){for(let D=0;D<g.length;D++){const d=g.charAt(D);if(d==="\r")return D+1<g.length&&g.charAt(D+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=T;function L(f,g){return`\r
`.indexOf(f.charAt(g))!==-1}e.isEOL=L}),define(Q[41],Z([0,1,32,46]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function O(g,D,d){return R(g,D,void 0,d)}e.removeProperty=O;function R(g,D,d,y,b){const a=D.slice(),C=[],E=(0,m.parseTree)(g,C);let p,w;for(;a.length>0&&(w=a.pop(),p=(0,m.findNodeAtLocation)(E,a),p===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if(p)if(p.type==="object"&&typeof w=="string"&&Array.isArray(p.children)){const v=(0,m.findNodeAtLocation)(p,[w]);if(v!==void 0)if(d===void 0){if(!v.parent)throw new Error("Malformed AST");const o=p.children.indexOf(v.parent);let i,t=v.parent.offset+v.parent.length;if(o>0){const n=p.children[o-1];i=n.offset+n.length}else i=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return T(g,{offset:i,length:t-i,content:""},y)}else return T(g,{offset:v.offset,length:v.length,content:JSON.stringify(d)},y);else{if(d===void 0)return[];const o=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,i=b?b(p.children.map(n=>n.children[0].value)):p.children.length;let t;if(i>0){const n=p.children[i-1];t={offset:n.offset+n.length,length:0,content:","+o}}else p.children.length===0?t={offset:p.offset+1,length:0,content:o}:t={offset:p.offset+1,length:0,content:o+","};return T(g,t,y)}}else if(p.type==="array"&&typeof w=="number"&&Array.isArray(p.children))if(d!==void 0){const v=`${JSON.stringify(d)}`;let o;if(p.children.length===0||w===0)o={offset:p.offset+1,length:0,content:p.children.length===0?v:v+","};else{const i=w===-1||w>p.children.length?p.children.length:w,t=p.children[i-1];o={offset:t.offset+t.length,length:0,content:","+v}}return T(g,o,y)}else{const v=w,o=p.children[v];let i;if(p.children.length===1)i={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===v){const t=p.children[v-1],n=t.offset+t.length,r=p.offset+p.length;i={offset:n,length:r-2-n,content:""}}else i={offset:o.offset,length:p.children[v+1].offset-o.offset,content:""};return T(g,i,y)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${p.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return T(g,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(d)},y)}}e.setProperty=R;function T(g,D,d){let y=L(g,D),b=D.offset,a=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;b>0&&!(0,A.isEOL)(y,b-1);)b--;for(;a<y.length&&!(0,A.isEOL)(y,a);)a++}const C=(0,A.format)(y,{offset:b,length:a-b},d);for(let p=C.length-1;p>=0;p--){const w=C[p];y=L(y,w),b=Math.min(b,w.offset),a=Math.max(a,w.offset+w.length),a+=w.content.length-w.length}const E=g.length-(y.length-a)-b;return[{offset:b,length:E,content:y.substring(b,a)}]}e.withFormatting=T;function L(g,D){return g.substring(0,D.offset)+D.content+g.substring(D.offset+D.length)}e.applyEdit=L;function f(g,D){let d=D.slice(0).sort((b,a)=>{const C=b.offset-a.offset;return C===0?b.length-a.length:C}),y=g.length;for(let b=d.length-1;b>=0;b--){let a=d[b];if(a.offset+a.length<=y)g=L(g,a);else throw new Error("Overlapping edit");y=a.offset}return g}e.applyEdits=f}),define(Q[2],Z([0,1,63,52]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const O=!1;let R=null;function T(v){R=v}if(e.setDisposableTracker=T,O){const v="__is_disposable_tracked__";R=new class{trackDisposable(o){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[v]||console.log(i)},3e3)}markTracked(o){if(o&&o!==C.None)try{o[v]=!0}catch(i){}}}}function L(v){!R||R.markTracked(v)}function f(v){return R&&R.trackDisposable(v),v}e.trackDisposable=f;class g extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=g;function D(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=D;function d(v){if(A.Iterable.is(v)){let o=[];for(const i of v)if(i){L(i);try{i.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new g(o);return Array.isArray(v)?[]:v}else if(v)return L(v),v.dispose(),v}e.dispose=d;function y(...v){return v.forEach(L),b(()=>d(v))}e.combinedDisposable=y;function b(v){const o=f({dispose:()=>{L(o),v()}});return o}e.toDisposable=b;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(L(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return L(o),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new a,f(this)}dispose(){L(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var i;this._isDisposed||o===this._value||((i=this._value)===null||i===void 0||i.dispose(),o&&L(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,L(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=E;class p{constructor(){this.references=new Map}acquire(o,...i){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...i)},this.references.set(o,t));const{object:n}=t,r=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=p;class w{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=w}),define(Q[64],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(R){this.element=R,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class A{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,T){const L=new m(R);if(this._first===m.Undefined)this._first=L,this._last=L;else if(T){const g=this._last;this._last=L,L.prev=g,g.next=L}else{const g=this._first;this._first=L,L.next=g,g.prev=L}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(L))}}shift(){if(this._first!==m.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==m.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==m.Undefined&&R.next!==m.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===m.Undefined&&R.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):R.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):R.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==m.Undefined;)yield R.element,R=R.next}}e.LinkedList=A});"use strict";(function(){function G(O){const R=[];typeof O=="number"&&R.push("code/timeOrigin",O);function T(f){R.push(f,Date.now())}function L(){const f=[];for(let g=0;g<R.length;g+=2)f.push({name:R[g],startTime:R[g+1]});return f}return{mark:T,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(O+T.startTime)});return R}};if(typeof process=="object"){const O=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function m(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))})(),define(Q[7],Z([0,1]),function(G,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let O=!1,R=!1,T=!1,L=!1,f=!1,g=!1,D=!1,d,y=A,b,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof process!="undefined"?C=process:typeof e.globals.vscode!="undefined"&&(C=e.globals.vscode.process);const E=typeof((m=C==null?void 0:C.versions)===null||m===void 0?void 0:m.electron)=="string"&&C.type==="renderer";if(e.isElectronSandboxed=E&&(C==null?void 0:C.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const c=C==null?void 0:C.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,O=a.indexOf("Windows")>=0,R=a.indexOf("Macintosh")>=0,D=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=a.indexOf("Linux")>=0,g=!0,d=navigator.language,y=d;else if(typeof C=="object"){O=C.platform==="win32",R=C.platform==="darwin",T=C.platform==="linux",L=T&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,d=A,y=A;const c=C.env.VSCODE_NLS_CONFIG;if(c)try{const s=JSON.parse(c),l=s.availableLanguages["*"];d=s.locale,y=l||A,b=s._translationsConfigFile}catch(s){}f=!0}else console.error("Unable to resolve platform.");var p;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let v=0;R?v=1:O?v=3:T&&(v=2),e.isWindows=O,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=L,e.isNative=f,e.isWeb=g,e.isIOS=D,e.platform=v,e.userAgent=a,e.language=y;var o;(function(c){function s(){return e.language}c.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=l;function h(){return e.language==="en"}c.isDefault=h})(o=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let I=0,u=l.length;I<u;I++){const P=l[I];if(P.id===S.data.vscodeSetImmediateId){l.splice(I,1),P.callback();return}}});let h=0;return S=>{const I=++h;l.push({id:I,callback:S}),e.globals.postMessage({vscodeSetImmediateId:I},"*")}}if(typeof(C==null?void 0:C.nextTick)=="function")return C.nextTick.bind(C);const s=Promise.resolve();return l=>s.then(l)}();var i;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||D?2:O?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,t=new Uint16Array(c.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(Q[36],Z([0,1,7]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof process!="undefined")A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(O){return process.nextTick(O)}};else if(typeof m.globals.vscode!="undefined"){const O=m.globals.vscode.process;A={get platform(){return O.platform},get env(){return O.env},cwd(){return O.cwd()},nextTick(R){return(0,m.setImmediate)(R)}}}else A={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(O){return(0,m.setImmediate)(O)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(Q[8],Z([0,1,36]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,O=97,R=90,T=122,L=46,f=47,g=92,D=58,d=63;class y extends Error{constructor(o,i,t){let n;typeof i=="string"&&i.indexOf("not ")===0?(n="must not be",i=i.replace(/^not /,"")):n="must be";const r=o.indexOf(".")!==-1?"property":"argument";let c=`The "${o}" ${r} ${n} of type ${i}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function b(v,o){if(typeof v!="string")throw new y(o,"string",v)}function a(v){return v===f||v===g}function C(v){return v===f}function E(v){return v>=A&&v<=R||v>=O&&v<=T}function p(v,o,i,t){let n="",r=0,c=-1,s=0,l=0;for(let h=0;h<=v.length;++h){if(h<v.length)l=v.charCodeAt(h);else{if(t(l))break;l=f}if(t(l)){if(!(c===h-1||s===1))if(s===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==L||n.charCodeAt(n.length-2)!==L){if(n.length>2){const S=n.lastIndexOf(i);S===-1?(n="",r=0):(n=n.slice(0,S),r=n.length-1-n.lastIndexOf(i)),c=h,s=0;continue}else if(n.length!==0){n="",r=0,c=h,s=0;continue}}o&&(n+=n.length>0?`${i}..`:"..",r=2)}else n.length>0?n+=`${i}${v.slice(c+1,h)}`:n=v.slice(c+1,h),r=h-c-1;c=h,s=0}else l===L&&s!==-1?++s:s=-1}return n}function w(v,o){if(o===null||typeof o!="object")throw new y("pathObject","Object",o);const i=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return i?i===o.root?`${i}${t}`:`${i}${v}${t}`:t}e.win32={resolve(...v){let o="",i="",t=!1;for(let n=v.length-1;n>=-1;n--){let r;if(n>=0){if(r=v[n],b(r,"path"),r.length===0)continue}else o.length===0?r=m.cwd():(r=m.env[`=${o}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const c=r.length;let s=0,l="",h=!1;const S=r.charCodeAt(0);if(c===1)a(S)&&(s=1,h=!0);else if(a(S))if(h=!0,a(r.charCodeAt(1))){let I=2,u=I;for(;I<c&&!a(r.charCodeAt(I));)I++;if(I<c&&I!==u){const P=r.slice(u,I);for(u=I;I<c&&a(r.charCodeAt(I));)I++;if(I<c&&I!==u){for(u=I;I<c&&!a(r.charCodeAt(I));)I++;(I===c||I!==u)&&(l=`\\\\${P}\\${r.slice(u,I)}`,s=I)}}}else s=1;else E(S)&&r.charCodeAt(1)===D&&(l=r.slice(0,2),s=2,c>2&&a(r.charCodeAt(2))&&(h=!0,s=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(i=`${r.slice(s)}\\${i}`,t=h,h&&o.length>0)break}return i=p(i,!t,"\\",a),t?`${o}\\${i}`:`${o}${i}`||"."},normalize(v){b(v,"path");const o=v.length;if(o===0)return".";let i=0,t,n=!1;const r=v.charCodeAt(0);if(o===1)return C(r)?"\\":v;if(a(r))if(n=!0,a(v.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(v.charCodeAt(s));)s++;if(s<o&&s!==l){const h=v.slice(l,s);for(l=s;s<o&&a(v.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(v.charCodeAt(s));)s++;if(s===o)return`\\\\${h}\\${v.slice(l)}\\`;s!==l&&(t=`\\\\${h}\\${v.slice(l,s)}`,i=s)}}}else i=1;else E(r)&&v.charCodeAt(1)===D&&(t=v.slice(0,2),i=2,o>2&&a(v.charCodeAt(2))&&(n=!0,i=3));let c=i<o?p(v.slice(i),!n,"\\",a):"";return c.length===0&&!n&&(c="."),c.length>0&&a(v.charCodeAt(o-1))&&(c+="\\"),t===void 0?n?`\\${c}`:c:n?`${t}\\${c}`:`${t}${c}`},isAbsolute(v){b(v,"path");const o=v.length;if(o===0)return!1;const i=v.charCodeAt(0);return a(i)||o>2&&E(i)&&v.charCodeAt(1)===D&&a(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let o,i;for(let r=0;r<v.length;++r){const c=v[r];b(c,"path"),c.length>0&&(o===void 0?o=i=c:o+=`\\${c}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++n;const r=i.length;r>1&&a(i.charCodeAt(1))&&(++n,r>2&&(a(i.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&a(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(v,o){if(b(v,"from"),b(o,"to"),v===o)return"";const i=e.win32.resolve(v),t=e.win32.resolve(o);if(i===t||(v=i.toLowerCase(),o=t.toLowerCase(),v===o))return"";let n=0;for(;n<v.length&&v.charCodeAt(n)===g;)n++;let r=v.length;for(;r-1>n&&v.charCodeAt(r-1)===g;)r--;const c=r-n;let s=0;for(;s<o.length&&o.charCodeAt(s)===g;)s++;let l=o.length;for(;l-1>s&&o.charCodeAt(l-1)===g;)l--;const h=l-s,S=c<h?c:h;let I=-1,u=0;for(;u<S;u++){const _=v.charCodeAt(n+u);if(_!==o.charCodeAt(s+u))break;_===g&&(I=u)}if(u!==S){if(I===-1)return t}else{if(h>S){if(o.charCodeAt(s+u)===g)return t.slice(s+u+1);if(u===2)return t.slice(s+u)}c>S&&(v.charCodeAt(n+u)===g?I=u:u===2&&(I=3)),I===-1&&(I=0)}let P="";for(u=n+I+1;u<=r;++u)(u===r||v.charCodeAt(u)===g)&&(P+=P.length===0?"..":"\\..");return s+=I,P.length>0?`${P}${t.slice(s,l)}`:(t.charCodeAt(s)===g&&++s,t.slice(s,l))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const o=e.win32.resolve(v);if(o.length<=2)return v;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const i=o.charCodeAt(2);if(i!==d&&i!==L)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(E(o.charCodeAt(0))&&o.charCodeAt(1)===D&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return v},dirname(v){b(v,"path");const o=v.length;if(o===0)return".";let i=-1,t=0;const n=v.charCodeAt(0);if(o===1)return a(n)?v:".";if(a(n)){if(i=t=1,a(v.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(v.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&a(v.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(v.charCodeAt(s));)s++;if(s===o)return v;s!==l&&(i=t=s+1)}}}}else E(n)&&v.charCodeAt(1)===D&&(i=o>2&&a(v.charCodeAt(2))?3:2,t=i);let r=-1,c=!0;for(let s=o-1;s>=t;--s)if(a(v.charCodeAt(s))){if(!c){r=s;break}}else c=!1;if(r===-1){if(i===-1)return".";r=i}return v.slice(0,r)},basename(v,o){o!==void 0&&b(o,"ext"),b(v,"path");let i=0,t=-1,n=!0,r;if(v.length>=2&&E(v.charCodeAt(0))&&v.charCodeAt(1)===D&&(i=2),o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let c=o.length-1,s=-1;for(r=v.length-1;r>=i;--r){const l=v.charCodeAt(r);if(a(l)){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=v.length),v.slice(i,t)}for(r=v.length-1;r>=i;--r)if(a(v.charCodeAt(r))){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":v.slice(i,t)},extname(v){b(v,"path");let o=0,i=-1,t=0,n=-1,r=!0,c=0;v.length>=2&&v.charCodeAt(1)===D&&E(v.charCodeAt(0))&&(o=t=2);for(let s=v.length-1;s>=o;--s){const l=v.charCodeAt(s);if(a(l)){if(!r){t=s+1;break}continue}n===-1&&(r=!1,n=s+1),l===L?i===-1?i=s:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||n===-1||c===0||c===1&&i===n-1&&i===t+1?"":v.slice(i,n)},format:w.bind(null,"\\"),parse(v){b(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const i=v.length;let t=0,n=v.charCodeAt(0);if(i===1)return a(n)?(o.root=o.dir=v,o):(o.base=o.name=v,o);if(a(n)){if(t=1,a(v.charCodeAt(1))){let I=2,u=I;for(;I<i&&!a(v.charCodeAt(I));)I++;if(I<i&&I!==u){for(u=I;I<i&&a(v.charCodeAt(I));)I++;if(I<i&&I!==u){for(u=I;I<i&&!a(v.charCodeAt(I));)I++;I===i?t=I:I!==u&&(t=I+1)}}}}else if(E(n)&&v.charCodeAt(1)===D){if(i<=2)return o.root=o.dir=v,o;if(t=2,a(v.charCodeAt(2))){if(i===3)return o.root=o.dir=v,o;t=3}}t>0&&(o.root=v.slice(0,t));let r=-1,c=t,s=-1,l=!0,h=v.length-1,S=0;for(;h>=t;--h){if(n=v.charCodeAt(h),a(n)){if(!l){c=h+1;break}continue}s===-1&&(l=!1,s=h+1),n===L?r===-1?r=h:S!==1&&(S=1):r!==-1&&(S=-1)}return s!==-1&&(r===-1||S===0||S===1&&r===s-1&&r===c+1?o.base=o.name=v.slice(c,s):(o.name=v.slice(c,r),o.base=v.slice(c,s),o.ext=v.slice(r,s))),c>0&&c!==t?o.dir=v.slice(0,c-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let o="",i=!1;for(let t=v.length-1;t>=-1&&!i;t--){const n=t>=0?v[t]:m.cwd();b(n,"path"),n.length!==0&&(o=`${n}/${o}`,i=n.charCodeAt(0)===f)}return o=p(o,!i,"/",C),i?`/${o}`:o.length>0?o:"."},normalize(v){if(b(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===f,i=v.charCodeAt(v.length-1)===f;return v=p(v,!o,"/",C),v.length===0?o?"/":i?"./":".":(i&&(v+="/"),o?`/${v}`:v)},isAbsolute(v){return b(v,"path"),v.length>0&&v.charCodeAt(0)===f},join(...v){if(v.length===0)return".";let o;for(let i=0;i<v.length;++i){const t=v[i];b(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(v,o){if(b(v,"from"),b(o,"to"),v===o||(v=e.posix.resolve(v),o=e.posix.resolve(o),v===o))return"";const i=1,t=v.length,n=t-i,r=1,c=o.length-r,s=n<c?n:c;let l=-1,h=0;for(;h<s;h++){const I=v.charCodeAt(i+h);if(I!==o.charCodeAt(r+h))break;I===f&&(l=h)}if(h===s)if(c>s){if(o.charCodeAt(r+h)===f)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else n>s&&(v.charCodeAt(i+h)===f?l=h:h===0&&(l=0));let S="";for(h=i+l+1;h<=t;++h)(h===t||v.charCodeAt(h)===f)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+l)}`},toNamespacedPath(v){return v},dirname(v){if(b(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===f;let i=-1,t=!0;for(let n=v.length-1;n>=1;--n)if(v.charCodeAt(n)===f){if(!t){i=n;break}}else t=!1;return i===-1?o?"/":".":o&&i===1?"//":v.slice(0,i)},basename(v,o){o!==void 0&&b(o,"ext"),b(v,"path");let i=0,t=-1,n=!0,r;if(o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let c=o.length-1,s=-1;for(r=v.length-1;r>=0;--r){const l=v.charCodeAt(r);if(l===f){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=v.length),v.slice(i,t)}for(r=v.length-1;r>=0;--r)if(v.charCodeAt(r)===f){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":v.slice(i,t)},extname(v){b(v,"path");let o=-1,i=0,t=-1,n=!0,r=0;for(let c=v.length-1;c>=0;--c){const s=v.charCodeAt(c);if(s===f){if(!n){i=c+1;break}continue}t===-1&&(n=!1,t=c+1),s===L?o===-1?o=c:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===i+1?"":v.slice(o,t)},format:w.bind(null,"/"),parse(v){b(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const i=v.charCodeAt(0)===f;let t;i?(o.root="/",t=1):t=0;let n=-1,r=0,c=-1,s=!0,l=v.length-1,h=0;for(;l>=t;--l){const S=v.charCodeAt(l);if(S===f){if(!s){r=l+1;break}continue}c===-1&&(s=!1,c=l+1),S===L?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}if(c!==-1){const S=r===0&&i?1:r;n===-1||h===0||h===1&&n===c-1&&n===r+1?o.base=o.name=v.slice(S,c):(o.name=v.slice(S,n),o.base=v.slice(S,c),o.ext=v.slice(n,c))}return r>0?o.dir=v.slice(0,r-1):i&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var m=e();for(var A in m)(typeof exports=="object"?exports:G)[A]=m[A]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function m(A){if(e[A])return e[A].exports;var O=e[A]={i:A,l:!1,exports:{}};return G[A].call(O.exports,O,O.exports,m),O.l=!0,O.exports}return m.m=G,m.c=e,m.d=function(A,O,R){m.o(A,O)||Object.defineProperty(A,O,{enumerable:!0,get:R})},m.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},m.t=function(A,O){if(1&O&&(A=m(A)),8&O||4&O&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(m.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&O&&typeof A!="string")for(var T in A)m.d(R,T,function(L){return A[L]}.bind(null,T));return R},m.n=function(A){var O=A&&A.__esModule?function(){return A.default}:function(){return A};return m.d(O,"a",O),O},m.o=function(A,O){return Object.prototype.hasOwnProperty.call(A,O)},m.p="",m(m.s=0)}([function(G,e,m){(function(A){var O;e=G.exports=X,O=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],f=e.src=[],g=0,D=g++;f[D]="0|[1-9]\\d*";var d=g++;f[d]="[0-9]+";var y=g++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;f[b]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var a=g++;f[a]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var C=g++;f[C]="(?:"+f[D]+"|"+f[y]+")";var E=g++;f[E]="(?:"+f[d]+"|"+f[y]+")";var p=g++;f[p]="(?:-("+f[C]+"(?:\\."+f[C]+")*))";var w=g++;f[w]="(?:-?("+f[E]+"(?:\\."+f[E]+")*))";var v=g++;f[v]="[0-9A-Za-z-]+";var o=g++;f[o]="(?:\\+("+f[v]+"(?:\\."+f[v]+")*))";var i=g++,t="v?"+f[b]+f[p]+"?"+f[o]+"?";f[i]="^"+t+"$";var n="[v=\\s]*"+f[a]+f[w]+"?"+f[o]+"?",r=g++;f[r]="^"+n+"$";var c=g++;f[c]="((?:<|>)?=?)";var s=g++;f[s]=f[d]+"|x|X|\\*";var l=g++;f[l]=f[D]+"|x|X|\\*";var h=g++;f[h]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[p]+")?"+f[o]+"?)?)?";var S=g++;f[S]="[v=\\s]*("+f[s]+")(?:\\.("+f[s]+")(?:\\.("+f[s]+")(?:"+f[w]+")?"+f[o]+"?)?)?";var I=g++;f[I]="^"+f[c]+"\\s*"+f[h]+"$";var u=g++;f[u]="^"+f[c]+"\\s*"+f[S]+"$";var P=g++;f[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=g++;f[_]="(?:~>?)";var q=g++;f[q]="(\\s*)"+f[_]+"\\s+",L[q]=new RegExp(f[q],"g");var W=g++;f[W]="^"+f[_]+f[h]+"$";var N=g++;f[N]="^"+f[_]+f[S]+"$";var $=g++;f[$]="(?:\\^)";var V=g++;f[V]="(\\s*)"+f[$]+"\\s+",L[V]=new RegExp(f[V],"g");var B=g++;f[B]="^"+f[$]+f[h]+"$";var M=g++;f[M]="^"+f[$]+f[S]+"$";var F=g++;f[F]="^"+f[c]+"\\s*("+n+")$|^$";var k=g++;f[k]="^"+f[c]+"\\s*("+t+")$|^$";var U=g++;f[U]="(\\s*)"+f[c]+"\\s*("+n+"|"+f[h]+")",L[U]=new RegExp(f[U],"g");var j=g++;f[j]="^\\s*("+f[h]+")\\s+-\\s+("+f[h]+")\\s*$";var z=g++;f[z]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var H=g++;f[H]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)O(K,f[K]),L[K]||(L[K]=new RegExp(f[K]));function te(J,ne){if(J instanceof X)return J;if(typeof J!="string"||J.length>R||!(ne?L[r]:L[i]).test(J))return null;try{return new X(J,ne)}catch(re){return null}}function X(J,ne){if(J instanceof X){if(J.loose===ne)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof X))return new X(J,ne);O("SemVer",J,ne),this.loose=ne;var re=J.trim().match(ne?L[r]:L[i]);if(!re)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var x=+ge;if(x>=0&&x<T)return x}return ge}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=te,e.valid=function(J,ne){var re=te(J,ne);return re?re.version:null},e.clean=function(J,ne){var re=te(J.trim().replace(/^[=v]+/,""),ne);return re?re.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return O("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),se(this.major,J.major)||se(this.minor,J.minor)||se(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ne=0;do{var re=this.prerelease[ne],ge=J.prerelease[ne];if(O("prerelease compare",ne,re,ge),re===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(re===void 0)return-1;if(re!==ge)return se(re,ge)}while(++ne)},X.prototype.inc=function(J,ne){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ne);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ne);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ne),this.inc("pre",ne);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ne),this.inc("pre",ne);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ne&&(this.prerelease[0]===ne?isNaN(this.prerelease[1])&&(this.prerelease=[ne,0]):this.prerelease=[ne,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ne,re,ge){typeof re=="string"&&(ge=re,re=void 0);try{return new X(J,re).inc(ne,ge).version}catch(x){return null}},e.diff=function(J,ne){if(we(J,ne))return null;var re=te(J),ge=te(ne);if(re.prerelease.length||ge.prerelease.length){for(var x in re)if((x==="major"||x==="minor"||x==="patch")&&re[x]!==ge[x])return"pre"+x;return"prerelease"}for(var x in re)if((x==="major"||x==="minor"||x==="patch")&&re[x]!==ge[x])return x},e.compareIdentifiers=se;var ie=/^[0-9]+$/;function se(J,ne){var re=ie.test(J),ge=ie.test(ne);return re&&ge&&(J=+J,ne=+ne),re&&!ge?-1:ge&&!re?1:J<ne?-1:J>ne?1:0}function ce(J,ne,re){return new X(J,re).compare(new X(ne,re))}function he(J,ne,re){return ce(J,ne,re)>0}function me(J,ne,re){return ce(J,ne,re)<0}function we(J,ne,re){return ce(J,ne,re)===0}function Ie(J,ne,re){return ce(J,ne,re)!==0}function ke(J,ne,re){return ce(J,ne,re)>=0}function Ue(J,ne,re){return ce(J,ne,re)<=0}function Fe(J,ne,re,ge){var x;switch(ne){case"===":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),x=J===re;break;case"!==":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),x=J!==re;break;case"":case"=":case"==":x=we(J,re,ge);break;case"!=":x=Ie(J,re,ge);break;case">":x=he(J,re,ge);break;case">=":x=ke(J,re,ge);break;case"<":x=me(J,re,ge);break;case"<=":x=Ue(J,re,ge);break;default:throw new TypeError("Invalid operator: "+ne)}return x}function _e(J,ne){if(J instanceof _e){if(J.loose===ne)return J;J=J.value}if(!(this instanceof _e))return new _e(J,ne);O("comparator",J,ne),this.loose=ne,this.parse(J),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(J,ne){return se(ne,J)},e.major=function(J,ne){return new X(J,ne).major},e.minor=function(J,ne){return new X(J,ne).minor},e.patch=function(J,ne){return new X(J,ne).patch},e.compare=ce,e.compareLoose=function(J,ne){return ce(J,ne,!0)},e.rcompare=function(J,ne,re){return ce(ne,J,re)},e.sort=function(J,ne){return J.sort(function(re,ge){return e.compare(re,ge,ne)})},e.rsort=function(J,ne){return J.sort(function(re,ge){return e.rcompare(re,ge,ne)})},e.gt=he,e.lt=me,e.eq=we,e.neq=Ie,e.gte=ke,e.lte=Ue,e.cmp=Fe,e.Comparator=_e;var Me={};function De(J,ne){if(J instanceof De)return J.loose===ne?J:new De(J.raw,ne);if(J instanceof _e)return new De(J.value,ne);if(!(this instanceof De))return new De(J,ne);if(this.loose=ne,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function $e(J,ne,re,ge,x,ee,oe,ae,le,de,ve,ye,Ee){return((ne=Ae(re)?"":Ae(ge)?">="+re+".0.0":Ae(x)?">="+re+"."+ge+".0":">="+ne)+" "+(ae=Ae(le)?"":Ae(de)?"<"+(+le+1)+".0.0":Ae(ve)?"<"+le+"."+(+de+1)+".0":ye?"<="+le+"."+de+"."+ve+"-"+ye:"<="+ae)).trim()}function He(J,ne){for(var re=0;re<J.length;re++)if(!J[re].test(ne))return!1;if(ne.prerelease.length){for(re=0;re<J.length;re++)if(O(J[re].semver),J[re].semver!==Me&&J[re].semver.prerelease.length>0){var ge=J[re].semver;if(ge.major===ne.major&&ge.minor===ne.minor&&ge.patch===ne.patch)return!0}return!1}return!0}function Ne(J,ne,re){try{ne=new De(ne,re)}catch(ge){return!1}return ne.test(J)}function ze(J,ne,re,ge){var x,ee,oe,ae,le;switch(J=new X(J,ge),ne=new De(ne,ge),re){case">":x=he,ee=Ue,oe=me,ae=">",le=">=";break;case"<":x=me,ee=ke,oe=he,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(J,ne,ge))return!1;for(var de=0;de<ne.set.length;++de){var ve=ne.set[de],ye=null,Ee=null;if(ve.forEach(function(be){be.semver===Me&&(be=new _e(">=0.0.0")),ye=ye||be,Ee=Ee||be,x(be.semver,ye.semver,ge)?ye=be:oe(be.semver,Ee.semver,ge)&&(Ee=be)}),ye.operator===ae||ye.operator===le||(!Ee.operator||Ee.operator===ae)&&ee(J,Ee.semver)||Ee.operator===le&&oe(J,Ee.semver))return!1}return!0}_e.prototype.parse=function(J){var ne=this.loose?L[F]:L[k],re=J.match(ne);if(!re)throw new TypeError("Invalid comparator: "+J);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new X(re[2],this.loose):this.semver=Me},_e.prototype.toString=function(){return this.value},_e.prototype.test=function(J){return O("Comparator.test",J,this.loose),this.semver===Me||(typeof J=="string"&&(J=new X(J,this.loose)),Fe(J,this.operator,this.semver,this.loose))},_e.prototype.intersects=function(J,ne){if(!(J instanceof _e))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new De(J.value,ne),Ne(this.value,re,ne);if(J.operator==="")return re=new De(this.value,ne),Ne(J.semver,re,ne);var ge=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),x=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),ee=this.semver.version===J.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ae=Fe(this.semver,"<",J.semver,ne)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),le=Fe(this.semver,">",J.semver,ne)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ge||x||ee&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(J){var ne=this.loose;J=J.trim(),O("range",J,ne);var re=ne?L[z]:L[j];J=J.replace(re,$e),O("hyphen replace",J),J=J.replace(L[U],"$1$2$3"),O("comparator trim",J,L[U]),J=(J=(J=J.replace(L[q],"$1~")).replace(L[V],"$1^")).split(/\s+/).join(" ");var ge=ne?L[F]:L[k],x=J.split(" ").map(function(ee){return function(oe,ae){return O("comp",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){O("caret",ye,Ee);var be=Ee?L[M]:L[B];return ye.replace(be,function(Le,Se,pe,Ce,Re){var Te;return O("caret",ye,Le,Se,pe,Ce,Re),Ae(Se)?Te="":Ae(pe)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Te=Se==="0"?">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+".0 <"+(+Se+1)+".0.0":Re?(O("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+Re+" <"+(+Se+1)+".0.0"):(O("no pr"),Te=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+" <"+(+Se+1)+".0.0"),O("caret return",Te),Te})}(ve,de)}).join(" ")}(oe,ae),O("caret",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){var be=Ee?L[N]:L[W];return ye.replace(be,function(Le,Se,pe,Ce,Re){var Te;return O("tilde",ye,Le,Se,pe,Ce,Re),Ae(Se)?Te="":Ae(pe)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Te=">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":Re?(O("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0"):Te=">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0",O("tilde return",Te),Te})}(ve,de)}).join(" ")}(oe,ae),O("tildes",oe),oe=function(le,de){return O("replaceXRanges",le,de),le.split(/\s+/).map(function(ve){return function(ye,Ee){ye=ye.trim();var be=Ee?L[u]:L[I];return ye.replace(be,function(Le,Se,pe,Ce,Re,Te){O("xRange",ye,Le,Se,pe,Ce,Re,Te);var fe=Ae(pe),Pe=fe||Ae(Ce),Oe=Pe||Ae(Re);return Se==="="&&Oe&&(Se=""),fe?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Oe?(Pe&&(Ce=0),Oe&&(Re=0),Se===">"?(Se=">=",Pe?(pe=+pe+1,Ce=0,Re=0):Oe&&(Ce=+Ce+1,Re=0)):Se==="<="&&(Se="<",Pe?pe=+pe+1:Ce=+Ce+1),Le=Se+pe+"."+Ce+"."+Re):Pe?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Oe&&(Le=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),O("xRange return",Le),Le})}(ve,de)}).join(" ")}(oe,ae),O("xrange",oe),oe=function(le,de){return O("replaceStars",le,de),le.trim().replace(L[H],"")}(oe,ae),O("stars",oe),oe}(ee,ne)}).join(" ").split(/\s+/);return this.loose&&(x=x.filter(function(ee){return!!ee.match(ge)})),x=x.map(function(ee){return new _e(ee,ne)})},De.prototype.intersects=function(J,ne){if(!(J instanceof De))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(ge){return J.set.some(function(x){return x.every(function(ee){return ge.intersects(ee,ne)})})})})},e.toComparators=function(J,ne){return new De(J,ne).set.map(function(re){return re.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},De.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var ne=0;ne<this.set.length;ne++)if(He(this.set[ne],J))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(J,ne,re){var ge=null,x=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&x.compare(oe)!==-1||(x=new X(ge=oe,re)))}),ge},e.minSatisfying=function(J,ne,re){var ge=null,x=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&x.compare(oe)!==1||(x=new X(ge=oe,re)))}),ge},e.validRange=function(J,ne){try{return new De(J,ne).range||"*"}catch(re){return null}},e.ltr=function(J,ne,re){return ze(J,ne,"<",re)},e.gtr=function(J,ne,re){return ze(J,ne,">",re)},e.outside=ze,e.prerelease=function(J,ne){var re=te(J,ne);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(J,ne,re){return J=new De(J,re),ne=new De(ne,re),J.intersects(ne)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var ne=J.match(L[P]);return ne==null?null:te((ne[1]||"0")+"."+(ne[2]||"0")+"."+(ne[3]||"0"))}}).call(this,m(1))},function(G,e){var m,A,O=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function L(E){if(m===setTimeout)return setTimeout(E,0);if((m===R||!m)&&setTimeout)return m=setTimeout,setTimeout(E,0);try{return m(E,0)}catch(p){try{return m.call(null,E,0)}catch(w){return m.call(this,E,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:R}catch(E){m=R}try{A=typeof clearTimeout=="function"?clearTimeout:T}catch(E){A=T}})();var f,g=[],D=!1,d=-1;function y(){D&&f&&(D=!1,f.length?g=f.concat(g):d=-1,g.length&&b())}function b(){if(!D){var E=L(y);D=!0;for(var p=g.length;p;){for(f=g,g=[];++d<p;)f&&f[d].run();d=-1,p=g.length}f=null,D=!1,function(w){if(A===clearTimeout)return clearTimeout(w);if((A===T||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(w);try{A(w)}catch(v){try{return A.call(null,w)}catch(o){return A.call(this,w)}}}(E)}}function a(E,p){this.fun=E,this.array=p}function C(){}O.nextTick=function(E){var p=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)p[w-1]=arguments[w];g.push(new a(E,p)),g.length!==1||D||L(b)},a.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=C,O.addListener=C,O.once=C,O.off=C,O.removeListener=C,O.removeAllListeners=C,O.emit=C,O.prependListener=C,O.prependOnceListener=C,O.listeners=function(E){return[]},O.binding=function(E){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(E){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(Q[87],Z([0,1,7]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=m.globals.performance&&typeof m.globals.performance.now=="function";class O{constructor(T){this._highResolution=A&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new O(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=O}),define(Q[3],Z([0,1,11,63,2,64,87]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var L;(function(p){p.None=()=>O.Disposable.None;function w(N){return($,V=null,B)=>{let M=!1,F;return F=N(k=>{if(!M)return F?F.dispose():M=!0,$.call(V,k)},null,B),M&&F.dispose(),F}}p.once=w;function v(N,$){return c((V,B=null,M)=>N(F=>V.call(B,$(F)),null,M))}p.map=v;function o(N,$){return c((V,B=null,M)=>N(F=>{$(F),V.call(B,F)},null,M))}p.forEach=o;function i(N,$){return c((V,B=null,M)=>N(F=>$(F)&&V.call(B,F),null,M))}p.filter=i;function t(N){return N}p.signal=t;function n(...N){return($,V=null,B)=>(0,O.combinedDisposable)(...N.map(M=>M(F=>$.call(V,F),null,B)))}p.any=n;function r(N,$,V){let B=V;return v(N,M=>(B=$(B,M),B))}p.reduce=r;function c(N){let $;const V=new y({onFirstListenerAdd(){$=N(V.fire,V)},onLastListenerRemove(){$.dispose()}});return V.event}p.snapshot=c;function s(N,$,V=100,B=!1,M){let F,k,U,j=0;const z=new y({leakWarningThreshold:M,onFirstListenerAdd(){F=N(H=>{j++,k=$(k,H),B&&!U&&(z.fire(k),k=void 0),clearTimeout(U),U=setTimeout(()=>{const K=k;k=void 0,U=void 0,(!B||j>1)&&z.fire(K),j=0},V)})},onLastListenerRemove(){F.dispose()}});return z.event}p.debounce=s;function l(N){const $=new Date().getTime();return v(w(N),V=>new Date().getTime()-$)}p.stopwatch=l;function h(N){let $=!0,V;return i(N,B=>{const M=$||B!==V;return $=!1,V=B,M})}p.latch=h;function S(N,$=!1,V=[]){let B=V.slice(),M=N(U=>{B?B.push(U):k.fire(U)});const F=()=>{B&&B.forEach(U=>k.fire(U)),B=null},k=new y({onFirstListenerAdd(){M||(M=N(U=>k.fire(U)))},onFirstListenerDidAdd(){B&&($?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return k.event}p.buffer=S;class I{constructor($){this.event=$}map($){return new I(v(this.event,$))}forEach($){return new I(o(this.event,$))}filter($){return new I(i(this.event,$))}reduce($,V){return new I(r(this.event,$,V))}latch(){return new I(h(this.event))}debounce($,V=100,B=!1,M){return new I(s(this.event,$,V,B,M))}on($,V,B){return this.event($,V,B)}once($,V,B){return w(this.event)($,V,B)}}function u(N){return new I(N)}p.chain=u;function P(N,$,V=B=>B){const B=(...U)=>k.fire(V(...U)),M=()=>N.on($,B),F=()=>N.removeListener($,B),k=new y({onFirstListenerAdd:M,onLastListenerRemove:F});return k.event}p.fromNodeEventEmitter=P;function _(N,$,V=B=>B){const B=(...U)=>k.fire(V(...U)),M=()=>N.addEventListener($,B),F=()=>N.removeEventListener($,B),k=new y({onFirstListenerAdd:M,onLastListenerRemove:F});return k.event}p.fromDOMEventEmitter=_;function q(N){const $=new y;let V=!1;return N.then(void 0,()=>null).then(()=>{V?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),V=!0,$.event}p.fromPromise=q;function W(N){return new Promise($=>w(N)($))}p.toPromise=W})(L=e.Event||(e.Event={}));class f{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${f._idPool++}`}start(w){this._stopWatch=new T.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let g=-1;function D(p){const w=g;return g=p,{dispose(){g=w}}}e.setGlobalLeakWarningThreshold=D;class d{constructor(w,v=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let v=g;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),!(v<=0||w<v)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(o)||0;if(this._stacks.set(o,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let t,n=0;for(const[r,c]of this._stacks)(!t||n<c)&&(t=r,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class y{constructor(w){var v;this._disposed=!1,this._options=w,this._leakageMon=g>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((v=this._options)===null||v===void 0?void 0:v._profName)?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(w,v,o)=>{var i;this._listeners||(this._listeners=new R.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(v?[w,v]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,v);const r=(i=this._leakageMon)===null||i===void 0?void 0:i.check(this._listeners.size);let c;return c={dispose:()=>{r&&r(),c.dispose=y._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof O.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(w){var v,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,w]);for((v=this._perfMon)===null||v===void 0||v.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,t]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,t):i[0].call(i[1],t)}catch(n){(0,m.onUnexpectedError)(n)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var w,v,o;(w=this._listeners)===null||w===void 0||w.clear(),(v=this._deliveryQueue)===null||v===void 0||v.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class b extends y{constructor(w){super(w);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=b;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const v={event:w,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const o=()=>{this.hasListeners&&this.unhook(v);const i=this.events.indexOf(v);this.events.splice(i,1)};return(0,O.toDisposable)((0,A.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(v=>this.emitter.fire(v))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class C{constructor(){this.buffers=[]}wrapEvent(w){return(v,o,i)=>w(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>v.call(o,t)):v.call(o,t)},void 0,i)}bufferEvents(w){const v=[];this.buffers.push(v);const o=w();return this.buffers.pop(),v.forEach(i=>i()),o}}e.EventBufferer=C;class E{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=O.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Q[30],Z([0,1,3]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(L,f){const g=setTimeout(L.bind(f),0);return{dispose(){clearTimeout(g)}}});var O;(function(L){function f(g){return g===L.None||g===L.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}L.isCancellationToken=f,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(O=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=O.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=O.None}}e.CancellationTokenSource=T}),define(Q[47],Z([0,1,11,2]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function O(E){const p=E;return p&&[p.on,p.pause,p.resume,p.destroy].every(w=>typeof w=="function")}e.isReadableStream=O;function R(E){const p=E;return p&&O(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=R;function T(E,p){return new L(E,p)}e.newWriteableStream=T;class L{constructor(p,w){this.reducer=p,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(w=>w(p))}emitError(p){this.listeners.error.length===0?(0,m.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(w=>w(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,w){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(p,w){if(!this.state.destroyed){let v;switch(p){case"data":v=this.listeners.data;break;case"end":v=this.listeners.end;break;case"error":v=this.listeners.error;break}if(v){const o=v.indexOf(w);o>=0&&v.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(v=>v())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(E,p){const w=[];let v;for(;(v=E.read())!==null;)w.push(v);return p(w)}e.consumeReadable=f;function g(E,p,w){const v=[];let o;for(;(o=E.read())!==null&&v.length<w;)v.push(o);return o===null&&v.length>0?p(v):{read:()=>{if(v.length>0)return v.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return E.read()}}}e.peekReadable=g;function D(E,p){return new Promise((w,v)=>{const o=[];d(E,{onData:i=>{p&&o.push(i)},onError:i=>{p?v(i):w(void 0)},onEnd:()=>{w(p?p(o):void 0)}})})}e.consumeStream=D;function d(E,p){E.on("error",w=>p.onError(w)),E.on("end",()=>p.onEnd()),E.on("data",w=>p.onData(w))}e.listenStream=d;function y(E,p){return new Promise((w,v)=>{const o=new A.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>p)return o.dispose(),E.pause(),w({stream:E,buffer:i,ended:!1})},n=c=>v(c),r=()=>w({stream:E,buffer:i,ended:!0});o.add((0,A.toDisposable)(()=>E.removeListener("error",n))),E.on("error",n),o.add((0,A.toDisposable)(()=>E.removeListener("end",r))),E.on("end",r),o.add((0,A.toDisposable)(()=>E.removeListener("data",t))),E.on("data",t)})}e.peekStream=y;function b(E,p){const w=T(p);return w.end(E),w}e.toStream=b;function a(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=a;function C(E,p,w){const v=T(w);return d(E,{onData:o=>v.write(p.data(o)),onError:o=>v.error(p.error?p.error(o):o),onEnd:()=>v.end()}),v}e.transform=C}),define(Q[21],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=m;const A=/{(\d+)}/g;function O(x,...ee){return ee.length===0?x:x.replace(A,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=ee.length?oe:ee[le]})}e.format=O;function R(x){return x.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=R;function T(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function L(x,ee){let oe=0;const ae=ee.charCodeAt(0);for(let le=x.length-1;le>=0;le--)x.charCodeAt(le)===ae&&oe++;return oe}e.count=L;function f(x,ee,oe="\u2026"){return x.length<=ee?x:`${x.substr(0,ee)}${oe}`}e.truncate=f;function g(x,ee=" "){const oe=D(x,ee);return d(oe,ee)}e.trim=g;function D(x,ee){if(!x||!ee)return x;const oe=ee.length;if(oe===0||x.length===0)return x;let ae=0;for(;x.indexOf(ee,ae)===ae;)ae=ae+oe;return x.substring(ae)}e.ltrim=D;function d(x,ee){if(!x||!ee)return x;const oe=ee.length,ae=x.length;if(oe===0||ae===0)return x;let le=ae,de=-1;for(;de=x.lastIndexOf(ee,le-1),!(de===-1||de+oe!==le);){if(de===0)return"";le=de}return x.substring(0,le)}e.rtrim=d;function y(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function b(x){return x.replace(/\*/g,"")}e.stripWildcards=b;function a(x,ee,oe={}){if(!x)throw new Error("Cannot create regex from empty string");ee||(x=T(x)),oe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(x,ae)}e.createRegExp=a;function C(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function E(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function p(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=p;function w(x){return x.split(/\r\n|\r|\n/)}e.splitLines=w;function v(x){for(let ee=0,oe=x.length;ee<oe;ee++){const ae=x.charCodeAt(ee);if(ae!==32&&ae!==9)return ee}return-1}e.firstNonWhitespaceIndex=v;function o(x,ee=0,oe=x.length){for(let ae=ee;ae<oe;ae++){const le=x.charCodeAt(ae);if(le!==32&&le!==9)return x.substring(ee,ae)}return x.substring(ee,oe)}e.getLeadingWhitespace=o;function i(x,ee=x.length-1){for(let oe=ee;oe>=0;oe--){const ae=x.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=i;function t(x,ee){return x<ee?-1:x>ee?1:0}e.compare=t;function n(x,ee,oe=0,ae=x.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=x.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee<be)return-1;if(Ee>be)return 1}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function r(x,ee){return c(x,ee,0,x.length,0,ee.length)}e.compareIgnoreCase=r;function c(x,ee,oe=0,ae=x.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=x.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee!==be){const Le=Ee-be;if(!(Le===32&&l(be))&&!(Le===-32&&l(Ee)))return s(Ee)&&s(be)?Le:n(x.toLowerCase(),ee.toLowerCase(),oe,ae,le,de)}}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=c;function s(x){return x>=97&&x<=122}e.isLowerAsciiLetter=s;function l(x){return x>=65&&x<=90}e.isUpperAsciiLetter=l;function h(x){return s(x)||l(x)}function S(x,ee){return x.length===ee.length&&I(x,ee)}e.equalsIgnoreCase=S;function I(x,ee,oe=x.length){for(let ae=0;ae<oe;ae++){const le=x.charCodeAt(ae),de=ee.charCodeAt(ae);if(le!==de){if(h(le)&&h(de)){const ve=Math.abs(le-de);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(de).toLowerCase())return!1}}return!0}function u(x,ee){const oe=ee.length;return ee.length>x.length?!1:I(x,ee,oe)}e.startsWithIgnoreCase=u;function P(x,ee){let oe,ae=Math.min(x.length,ee.length);for(oe=0;oe<ae;oe++)if(x.charCodeAt(oe)!==ee.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(x,ee){let oe,ae=Math.min(x.length,ee.length);const le=x.length-1,de=ee.length-1;for(oe=0;oe<ae;oe++)if(x.charCodeAt(le-oe)!==ee.charCodeAt(de-oe))return oe;return ae}e.commonSuffixLength=_;function q(x){return 55296<=x&&x<=56319}e.isHighSurrogate=q;function W(x){return 56320<=x&&x<=57343}e.isLowSurrogate=W;function N(x,ee){return(x-55296<<10)+(ee-56320)+65536}e.computeCodePoint=N;function $(x,ee,oe){const ae=x.charCodeAt(oe);if(q(ae)&&oe+1<ee){const le=x.charCodeAt(oe+1);if(W(le))return N(ae,le)}return ae}e.getNextCodePoint=$;function V(x,ee){const oe=x.charCodeAt(ee-1);if(W(oe)&&ee>1){const ae=x.charCodeAt(ee-2);if(q(ae))return N(ae,oe)}return oe}function B(x,ee){const oe=re.getInstance(),ae=ee,le=x.length,de=$(x,le,ee);ee+=de>=65536?2:1;let ve=oe.getGraphemeBreakType(de);for(;ee<le;){const ye=$(x,le,ee),Ee=oe.getGraphemeBreakType(ye);if(J(ve,Ee))break;ee+=ye>=65536?2:1,ve=Ee}return ee-ae}e.nextCharLength=B;function M(x,ee){const oe=re.getInstance(),ae=ee,le=V(x,ee);ee-=le>=65536?2:1;let de=oe.getGraphemeBreakType(le);for(;ee>0;){const ve=V(x,ee),ye=oe.getGraphemeBreakType(ve);if(J(ye,de))break;ee-=ve>=65536?2:1,de=ye}return ae-ee}e.prevCharLength=M;function F(x,ee){const oe=re.getInstance(),ae=x.length,le=ee,de=$(x,ae,ee),ve=oe.getGraphemeBreakType(de);ee+=de>=65536?2:1;let ye=ve;for(;ee<ae;){const be=$(x,ae,ee),Le=oe.getGraphemeBreakType(be);if(J(ye,Le))break;ee+=be>=65536?2:1,ye=Le}const Ee=ee;for(ee=le,ye=ve;ee>0;){const be=V(x,ee),Le=oe.getGraphemeBreakType(be);if(J(Le,ye))break;ee-=be>=65536?2:1,ye=Le}return[ee,Ee]}function k(x,ee){return ee>0&&W(x.charCodeAt(ee))?F(x,ee-1):F(x,ee)}e.getCharContainingOffset=k;function U(x){const ee=x.length;let oe=0,ae=0;for(;ae<ee;){const ve=$(x,ee,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let de=0;for(;ae<ee;){const ve=$(x,ee,ae);ae+=ve>=65536?2:1,ve<128?le[de++]=ve:ve<2048?(le[de++]=192|(ve&1984)>>>6,le[de++]=128|(ve&63)>>>0):ve<65536?(le[de++]=224|(ve&61440)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0):(le[de++]=240|(ve&1835008)>>>18,le[de++]=128|(ve&258048)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=U;function j(x){const ee=x.byteLength,oe=[];let ae=0;for(;ae<ee;){const le=x[ae];let de;if(le>=240&&ae+3<ee?de=(x[ae++]&7)<<18>>>0|(x[ae++]&63)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=224&&ae+2<ee?de=(x[ae++]&15)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=192&&ae+1<ee?de=(x[ae++]&31)<<6>>>0|(x[ae++]&63)<<0>>>0:de=x[ae++],de>=0&&de<=55295||de>=57344&&de<=65535)oe.push(String.fromCharCode(de));else if(de>=65536&&de<=1114111){const ve=de-65536,ye=55296+((ve&1047552)>>>10),Ee=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(ye)),oe.push(String.fromCharCode(Ee))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=j;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(x){return z.test(x)}e.containsRTL=H;const K=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function te(x){return K.test(x)}e.containsEmoji=te;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(x){return X.test(x)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=se;function ce(x){for(let ee=0,oe=x.length;ee<oe;ee++)if(he(x.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=ce;function he(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=he;function me(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=me;function we(x,ee){if(x.length<ee)return x;const oe=/\b/g;let ae=0;for(;oe.test(x)&&!(x.length-oe.lastIndex<ee);)ae=oe.lastIndex,oe.lastIndex+=1;return x.substring(ae).replace(/^\s/,"")}e.lcut=we;const Ie=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Ue=/\x1b\[0?m/g;function Fe(x){return x&&(x=x.replace(Ie,""),x=x.replace(ke,""),x=x.replace(Ue,"")),x}e.removeAnsiEscapeCodes=Fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Me(x){return _e(x)?x.substr(1):x}e.stripUTF8BOM=Me;function De(x,ee){if(!x||!ee||x.length<ee.length)return!1;const oe=ee.length,ae=x.toLowerCase();let le=0,de=-1;for(;le<oe;){const ve=ae.indexOf(ee[le],de+1);if(ve<0)return!1;de=ve,le++}return!0}e.fuzzyContains=De;function Ae(x,ee=!1){return x?(ee&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Ae;function $e(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=$e;function He(x,ee=1){if(ee===0)return"";let oe=-1;do oe=x.indexOf(`
`,oe+1),ee--;while(ee>0&&oe>=0);return oe===-1?x:(x[oe-1]==="\r"&&oe--,x.substr(0,oe))}e.getNLines=He;function Ne(x){const ee=90-65+1;return x=x%(2*ee),x<ee?String.fromCharCode(97+x):String.fromCharCode(65+x-ee)}e.singleLetterHash=Ne;function ze(x){return re.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=ze;function J(x,ee){return x===0?ee!==5&&ee!==7:x===2&&ee===3?!1:x===4||x===2||x===3||ee===4||ee===2||ee===3?!0:!(x===8&&(ee===8||ee===9||ee===11||ee===12)||(x===11||x===9)&&(ee===9||ee===10)||(x===12||x===10)&&ee===10||ee===5||ee===13||ee===7||x===1||x===13&&ee===14||x===6&&ee===6)}e.breakBetweenGraphemeBreakType=J;var ne;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class re{constructor(){this._data=ge()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(ee<oe[3*le])le=2*le;else if(ee>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}re._INSTANCE=null;function ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[22],Z([0,1,21,47]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let L,f;class g{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return O?new g(Buffer.allocUnsafe(s)):new g(new Uint8Array(s))}static wrap(s){return O&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new g(s)}static fromString(s,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&O?new g(Buffer.from(s)):R?(L||(L=new TextEncoder),new g(L.encode(s))):new g(m.encodeUTF8(s))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let I=0,u=s.length;I<u;I++)l+=s[I].byteLength}const h=g.alloc(l);let S=0;for(let I=0,u=s.length;I<u;I++){const P=s[I];h.set(P,S),S+=P.byteLength}return h}toString(){return O?this.buffer.toString():T?(f||(f=new TextDecoder),f.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(s,l){return new g(this.buffer.subarray(s,l))}set(s,l){s instanceof g?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return y(this.buffer,s)}writeUInt32BE(s,l){b(this.buffer,s,l)}readUInt32LE(s){return a(this.buffer,s)}writeUInt32LE(s,l){C(this.buffer,s,l)}readUInt8(s){return E(this.buffer,s)}writeUInt8(s,l){p(this.buffer,s,l)}}e.VSBuffer=g;function D(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0}e.readUInt16LE=D;function d(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255}e.writeUInt16LE=d;function y(c,s){return c[s]*2**24+c[s+1]*2**16+c[s+2]*2**8+c[s+3]}e.readUInt32BE=y;function b(c,s,l){c[l+3]=s,s=s>>>8,c[l+2]=s,s=s>>>8,c[l+1]=s,s=s>>>8,c[l]=s}e.writeUInt32BE=b;function a(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0|c[s+2]<<16>>>0|c[s+3]<<24>>>0}e.readUInt32LE=a;function C(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255,s=s>>>8,c[l+2]=s&255,s=s>>>8,c[l+3]=s&255}e.writeUInt32LE=C;function E(c,s){return c[s]}e.readUInt8=E;function p(c,s,l){c[l]=s}e.writeUInt8=p;function w(c){return A.consumeReadable(c,s=>g.concat(s))}e.readableToBuffer=w;function v(c){return A.toReadable(c)}e.bufferToReadable=v;function o(c){return A.consumeStream(c,s=>g.concat(s))}e.streamToBuffer=o;async function i(c){return c.ended?g.concat(c.buffer):g.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=i;function t(c){return A.toStream(c,s=>g.concat(s))}e.bufferToStream=t;function n(c){return A.transform(c,{data:s=>typeof s=="string"?g.fromString(s):g.wrap(s)},s=>g.concat(s))}e.streamToBufferReadableStream=n;function r(c){return A.newWriteableStream(s=>g.concat(s),c)}e.newWriteableBufferStream=r}),define(Q[17],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(s){return Array.isArray(s)}e.isArray=m;function A(s){return typeof s=="string"}e.isString=A;function O(s){return Array.isArray(s)&&s.every(l=>A(l))}e.isStringArray=O;function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=R;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function L(s){return s===!0||s===!1}e.isBoolean=L;function f(s){return typeof s=="undefined"}e.isUndefined=f;function g(s){return!D(s)}e.isDefined=g;function D(s){return f(s)||s===null}e.isUndefinedOrNull=D;function d(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=d;function y(s){if(D(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=y;function b(...s){const l=[];for(let h=0;h<s.length;h++){const S=s[h];if(D(S))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(S)}return l}e.assertAllDefined=b;const a=Object.prototype.hasOwnProperty;function C(s){if(!R(s))return!1;for(let l in s)if(a.call(s,l))return!1;return!0}e.isEmptyObject=C;function E(s){return typeof s=="function"}e.isFunction=E;function p(...s){return s.length>0&&s.every(E)}e.areFunctions=p;function w(s,l){const h=Math.min(s.length,l.length);for(let S=0;S<h;S++)v(s[S],l[S])}e.validateConstraints=w;function v(s,l){if(A(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(E(l)){try{if(s instanceof l)return}catch(h){}if(!D(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function o(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=o;function i(s){const l=[];for(const h of o(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=i;function t(s,l){const h=I=>function(){const u=Array.prototype.slice.call(arguments,0);return l(I,u)};let S={};for(const I of s)S[I]=h(I);return S}e.createProxyObject=t;function n(s){return s===null?void 0:s}e.withNullAsUndefined=n;function r(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=r;function c(s){return class{constructor(){return new Proxy({},{get(l,h){if(l[h])return l[h];throw new Error(`Not Implemented: ${s}->${String(h)}`)}})}}}e.NotImplementedProxy=c}),define(Q[42],Z([0,1,7,21,8,17]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function L(n){return n.replace(/[\\/]/g,O.posix.sep)}e.toSlashes=L;function f(n,r=O.posix.sep){if(!n)return"";const c=n.length,s=n.charCodeAt(0);if(T(s)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let h=3;const S=h;for(;h<c&&!T(n.charCodeAt(h));h++);if(S!==h&&!T(n.charCodeAt(h+1))){for(h+=1;h<c;h++)if(T(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,r)}}return r}else if(E(s)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(T(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=f;function g(n){if(!m.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let c=2;const s=c;for(;c<n.length&&(r=n.charCodeAt(c),r!==92);c++);return!(s===c||(r=n.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=g;const D=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(n,r=m.isWindows){const c=r?D:d;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||r&&y.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=b;function a(n,r,c){const s=n===r;return!c||s?s:!n||!r?!1:(0,A.equalsIgnoreCase)(n,r)}e.isEqual=a;function C(n,r,c,s=O.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(c){if(!(0,A.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let h=r.length;return r.charAt(r.length-1)===s&&h--,n.charAt(h)===s}return r.charAt(r.length-1)!==s&&(r+=s),n.indexOf(r)===0}e.isEqualOrParent=C;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function p(n,r){return m.isWindows&&n.endsWith(":")&&(n+=O.sep),(0,O.isAbsolute)(n)||(n=(0,O.join)(r,n)),n=(0,O.normalize)(n),m.isWindows?(n=(0,A.rtrim)(n,O.sep),n.endsWith(":")&&(n+=O.sep)):(n=(0,A.rtrim)(n,O.sep),n||(n=O.sep)),n}e.sanitizeFilePath=p;function w(n){const r=(0,O.normalize)(n);return m.isWindows?n.length>3?!1:v(r)&&(n.length===2||r.charCodeAt(2)===92):r===O.posix.sep}e.isRootOrDriveLetter=w;function v(n){return m.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function o(n){return v(n)?n[0]:void 0}e.getDriveLetter=o;function i(n,r,c){return r.length>n.length?-1:n===r?0:(c&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=i;function t(n){const r=n.split(":");let c,s,l;if(r.forEach(h=>{const S=Number(h);(0,R.isNumber)(S)?s===void 0?s=S:l===void 0&&(l=S):c=c?[c,h].join(":"):h}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:s!==void 0?s:void 0,column:l!==void 0?l:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[26],Z([0,1,17]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const C=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?C[E]=A(a[E]):C[E]=a[E]}),C}e.deepClone=A;function O(a){if(!a||typeof a!="object")return a;const C=[a];for(;C.length>0;){const E=C.shift();Object.freeze(E);for(const p in E)if(R.call(E,p)){const w=E[p];typeof w=="object"&&!Object.isFrozen(w)&&C.push(w)}}return a}e.deepFreeze=O;const R=Object.prototype.hasOwnProperty;function T(a,C){return L(a,C,new Set)}e.cloneAndChange=T;function L(a,C,E){if((0,m.isUndefinedOrNull)(a))return a;const p=C(a);if(typeof p!="undefined")return p;if((0,m.isArray)(a)){const w=[];for(const v of a)w.push(L(v,C,E));return w}if((0,m.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const w={};for(let v in a)R.call(a,v)&&(w[v]=L(a[v],C,E));return E.delete(a),w}return a}function f(a,C,E=!0){return(0,m.isObject)(a)?((0,m.isObject)(C)&&Object.keys(C).forEach(p=>{p in a?E&&((0,m.isObject)(a[p])&&(0,m.isObject)(C[p])?f(a[p],C[p],E):a[p]=C[p]):a[p]=C[p]}),a):C}e.mixin=f;function g(a,C){if(a===C)return!0;if(a==null||C===null||C===void 0||typeof a!=typeof C||typeof a!="object"||Array.isArray(a)!==Array.isArray(C))return!1;let E,p;if(Array.isArray(a)){if(a.length!==C.length)return!1;for(E=0;E<a.length;E++)if(!g(a[E],C[E]))return!1}else{const w=[];for(p in a)w.push(p);w.sort();const v=[];for(p in C)v.push(p);if(v.sort(),!g(w,v))return!1;for(E=0;E<w.length;E++)if(!g(a[w[E]],C[w[E]]))return!1}return!0}e.equals=g;function D(a){const C=new Set;return JSON.stringify(a,(E,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(C.has(p))return"[Circular]";C.add(p)}return p})}e.safeStringify=D;function d(a,C,E){const p=C(a);return typeof p=="undefined"?E:p}e.getOrDefault=d;function y(a,C){const E=Object.create(null);return!a||!C||Object.keys(C).forEach(w=>{const v=a[w],o=C[w];g(v,o)||(E[w]=o)}),E}e.distinct=y;function b(a,C){const E=C.toLowerCase(),p=Object.keys(a).find(w=>w.toLowerCase()===E);return p?a[p]:a[C]}e.getCaseInsensitive=b}),define(Q[5],Z([0,1,7,8]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const O=/^\w[\w\d+.-]*$/,R=/^\//,T=/^\/\//;function L(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!O.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,c){return!r&&!c?"file":r}function g(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==d&&(c=d+c):c=d;break}return c}const D="",d="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(c,s,l,h,S,I=!1){typeof c=="object"?(this.scheme=c.scheme||D,this.authority=c.authority||D,this.path=c.path||D,this.query=c.query||D,this.fragment=c.fragment||D):(this.scheme=f(c,I),this.authority=s||D,this.path=g(this.scheme,l||D),this.query=h||D,this.fragment=S||D,L(this,I))}static isUri(c){return c instanceof b?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return v(this,!1)}with(c){if(!c)return this;let{scheme:s,authority:l,path:h,query:S,fragment:I}=c;return s===void 0?s=this.scheme:s===null&&(s=D),l===void 0?l=this.authority:l===null&&(l=D),h===void 0?h=this.path:h===null&&(h=D),S===void 0?S=this.query:S===null&&(S=D),I===void 0?I=this.fragment:I===null&&(I=D),s===this.scheme&&l===this.authority&&h===this.path&&S===this.query&&I===this.fragment?this:new C(s,l,h,S,I)}static parse(c,s=!1){const l=y.exec(c);return l?new C(l[2]||D,n(l[4]||D),n(l[5]||D),n(l[7]||D),n(l[9]||D),s):new C(D,D,D,D,D)}static file(c){let s=D;if(m.isWindows&&(c=c.replace(/\\/g,d)),c[0]===d&&c[1]===d){const l=c.indexOf(d,2);l===-1?(s=c.substring(2),c=d):(s=c.substring(2,l),c=c.substring(l)||d)}return new C("file",s,c,D,D)}static from(c){return new C(c.scheme,c.authority,c.path,c.query,c.fragment)}static joinPath(c,...s){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return m.isWindows&&c.scheme==="file"?l=b.file(A.win32.join(v(c,!0),...s)).path:l=A.posix.join(c.path,...s),c.with({path:l})}toString(c=!1){return o(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof b)return c;{const s=new C(c);return s._formatted=c.external,s._fsPath=c._sep===a?c.fsPath:null,s}}else return c}}e.URI=b;const a=m.isWindows?1:void 0;class C extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(c=!1){return c?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,c){let s,l=-1;for(let h=0;h<r.length;h++){const S=r.charCodeAt(h);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||c&&S===47)l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s!==void 0&&(s+=r.charAt(h));else{s===void 0&&(s=r.substr(0,h));const I=E[S];I!==void 0?(l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s+=I):l===-1&&(l=h)}}return l!==-1&&(s+=encodeURIComponent(r.substring(l))),s!==void 0?s:r}function w(r){let c;for(let s=0;s<r.length;s++){const l=r.charCodeAt(s);l===35||l===63?(c===void 0&&(c=r.substr(0,s)),c+=E[l]):c!==void 0&&(c+=r[s])}return c!==void 0?c:r}function v(r,c){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,m.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=v;function o(r,c){const s=c?w:p;let l="",{scheme:h,authority:S,path:I,query:u,fragment:P}=r;if(h&&(l+=h,l+=":"),(S||h==="file")&&(l+=d,l+=d),S){let _=S.indexOf("@");if(_!==-1){const q=S.substr(0,_);S=S.substr(_+1),_=q.indexOf(":"),_===-1?l+=s(q,!1):(l+=s(q.substr(0,_),!1),l+=":",l+=s(q.substr(_+1),!1)),l+="@"}S=S.toLowerCase(),_=S.indexOf(":"),_===-1?l+=s(S,!1):(l+=s(S.substr(0,_),!1),l+=S.substr(_))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const _=I.charCodeAt(1);_>=65&&_<=90&&(I=`/${String.fromCharCode(_+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const _=I.charCodeAt(0);_>=65&&_<=90&&(I=`${String.fromCharCode(_+32)}:${I.substr(2)}`)}l+=s(I,!0)}return u&&(l+="?",l+=s(u,!1)),P&&(l+="#",l+=c?P:p(P,!1)),l}function i(r){try{return decodeURIComponent(r)}catch(c){return r.length>3?r.substr(0,3)+i(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,c=>i(c)):r}}),define(Q[88],Z([0,1,5]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(g){const D=g;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=A;function O(g){const D=[];let d;try{const y=JSON.parse(g.arguments),b=y[y.length-1];b&&b.__$stack&&(y.pop(),d=b.__$stack),D.push(...y)}catch(y){D.push("Unable to log remote console arguments",g.arguments)}return{args:D,stack:d}}e.parse=O;function R(g){if(typeof g!="string")return R(O(g).stack);const D=g;if(D){const d=T(D),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(y&&y.length===4)return{uri:m.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function T(g){if(!g)return g;const D=g.indexOf(`
`);return D===-1?g:g.substring(0,D)}function L(g,D){const{args:d,stack:y}=O(g),b=typeof d[0]=="string"&&d.length===1;let a=T(y);a&&(a=`(${a.trim()})`);let C=[];if(typeof d[0]=="string"?a&&b?C=[`%c[${D}] %c${d[0]} %c${a}`,f("blue"),f(""),f("grey")]:C=[`%c[${D}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:C=[`%c[${D}]%`,f("blue"),...d],a&&!b&&C.push(a),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,C)}e.log=L;function f(g){return`color: ${g}`}}),define(Q[37],Z([0,1,5,21]),function(G,e,m,A){"use strict";var O,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(o,i,t){let n=o.get(i);return n===void 0&&(n=t,o.set(i,n)),n}e.getOrSet=T;function L(o){const i=[];return o.forEach((t,n)=>{i.push(`${n} => ${t}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=L;function f(o){const i=[];return o.forEach(t=>{i.push(t)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=f;class g{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const t=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=g;class D{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class d{constructor(i=!0,t=!0){this._splitOnBackslash=i,this._caseSensitive=t}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var y;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(y||(y={}));class b{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,A.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new b(i))}static forPaths(){return new C(new d)}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new D)}clear(){this._root=void 0}set(i,t){const n=this._iter.reset(i);let r;for(this._root||(this._root=new a,this._root.segment=n.value()),r=this._root;;){const s=n.cmp(r.segment);if(s>0)r.left||(r.left=new a,r.left.segment=n.value()),r=r.left;else if(s<0)r.right||(r.right=new a,r.right.segment=n.value()),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new a,r.mid.segment=n.value()),r=r.mid;else break}const c=r.value;return r.value=t,r.key=i,c}get(i){var t;return(t=this._getNode(i))===null||t===void 0?void 0:t.value}_getNode(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(i){const t=this._getNode(i);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,t){const n=this._iter.reset(i),r=[];let c=this._root;for(;c;){const s=n.cmp(c.segment);if(s>0)r.push([1,c]),c=c.left;else if(s<0)r.push([-1,c]),c=c.right;else if(n.hasNext())n.next(),r.push([0,c]),c=c.mid;else{for(t?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;r.length>0&&c.isEmpty();){let[l,h]=r.pop();switch(l){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(i){const t=this._iter.reset(i);let n=this._root,r;for(;n;){const c=t.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(t.hasNext())t.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[t,n]of this)i(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=C;class E{constructor(i,t){this[O]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=t!=null?t:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,t){return this.map.set(this.toKey(i),t),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,t){typeof t!="undefined"&&(i=i.bind(t));for(let[n,r]of this.map)i(r,m.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=o=>o.toString();var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class w{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,t=0){const n=this._map.get(i);if(!!n)return t!==0&&this.touch(n,t),n.value}set(i,t,n=0){let r=this._map.get(i);if(r)r.value=t,n!==0&&this.touch(r,n);else{switch(r={key:i,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const t=this._map.get(i);if(!!t)return this._map.delete(i),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,t){const n=this._state;let r=this._head;for(;r;){if(t?i.bind(t)(r.value,r.key,this):i(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.key,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}values(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.value,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}entries(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:[n.key,n.value],done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>i;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const t=i.next,n=i.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}i.next=void 0,i.previous=void 0,this._state++}touch(i,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(i===this._head)return;const n=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(n.previous=r,r.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(t===2){if(i===this._tail)return;const n=i.next,r=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=r,r.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((t,n)=>{i.push([n,t])}),i}fromJSON(i){this.clear();for(const[t,n]of i)this.set(t,n)}}e.LinkedMap=w;class v extends w{constructor(i,t=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,t=2){return super.get(i,t)}peek(i){return super.get(i,0)}set(i,t){return super.set(i,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(Q[89],Z([0,1,22,21,5]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,L)}e.stringify=R;function T(g){let D=JSON.parse(g);return D=f(D),D}e.parse=T;function L(g,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,A.regExpFlags)(D)}:D}function f(g,D=0){if(!g||D>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return O.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof m.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let d=0;d<g.length;++d)g[d]=f(g[d],D+1);else for(const d in g)Object.hasOwnProperty.call(g,d)&&(g[d]=f(g[d],D+1))}return g}e.revive=f}),define(Q[16],Z([0,1,5,7]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var O;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.userData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebook="vscode-notebook",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeSettings="vscode-settings",L.vscodeWorkspaceTrust="vscode-workspace-trust",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.vscodeWebviewResource="vscode-webview-resource",L.extension="extension",L.vscodeFileResource="vscode-file"})(O=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,g,D){this._hosts[f]=g,this._ports[f]=D}setConnectionToken(f,g){this._connectionTokens[f]=g}rewrite(f){if(this._delegate)return this._delegate(f);const g=f.authority;let D=this._hosts[g];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const d=this._ports[g],y=this._connectionTokens[g];let b=`path=${encodeURIComponent(f.path)}`;return typeof y=="string"&&(b+=`&tkn=${encodeURIComponent(y)}`),m.URI.from({scheme:A.isWeb?this._preferredWebSchema:O.vscodeRemoteResource,authority:`${D}:${d}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new R;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(f,g,D){const d=this.toUri(f,g);return d.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(d):A.isNative&&(D||A.isPreferringBrowserCodeLoad)&&d.scheme===O.file?d.with({scheme:O.vscodeFileResource,authority:d.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(f,g){const D=this.toUri(f,g);return D.scheme===O.vscodeFileResource?D.with({scheme:O.file,authority:D.authority!==this.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(f,g){return m.URI.isUri(f)?f:m.URI.parse(g.toUrl(f))}}e.FileAccess=new T}),define(Q[65],Z([0,1,37]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new m.LRUCache(1e4);function O(g){return f(g,"NFC",A)}e.normalizeNFC=O;const R=new m.LRUCache(1e4);function T(g){return f(g,"NFD",R)}e.normalizeNFD=T;const L=/[^\u0000-\u0080]/;function f(g,D,d){if(!e.canNormalize||!g)return g;const y=d.get(g);if(y)return y;let b;return L.test(g)?b=g.normalize(D):b=g,d.set(g,b),b}e.removeAccents=function(){if(e.canNormalize){const g=/[\u0300-\u036f]/g;return function(D){return T(D).replace(g,"")}}else return function(g){return g}}()}),define(Q[12],Z([0,1,42,8,5,21,16,7]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(b){return(0,O.uriToFsPath)(b,!0)}e.originalFSPath=f;class g{constructor(a){this._ignorePathCasing=a}compare(a,C,E=!1){return a===C?0:(0,R.compare)(this.getComparisonKey(a,E),this.getComparisonKey(C,E))}isEqual(a,C,E=!1){return a===C?!0:!a||!C?!1:this.getComparisonKey(a,E)===this.getComparisonKey(C,E)}getComparisonKey(a,C=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,C,E=!1){if(a.scheme===C.scheme){if(a.scheme===T.Schemas.file)return m.isEqualOrParent(f(a),f(C),this._ignorePathCasing(a))&&a.query===C.query&&(E||a.fragment===C.fragment);if((0,e.isEqualAuthority)(a.authority,C.authority))return m.isEqualOrParent(a.path,C.path,this._ignorePathCasing(a),"/")&&a.query===C.query&&(E||a.fragment===C.fragment)}return!1}joinPath(a,...C){return O.URI.joinPath(a,...C)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return A.posix.basename(a.path)}extname(a){return A.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let C;return a.scheme===T.Schemas.file?C=O.URI.file(A.dirname(f(a))).path:(C=A.posix.dirname(a.path),a.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),C="/")),a.with({path:C})}normalizePath(a){if(!a.path.length)return a;let C;return a.scheme===T.Schemas.file?C=O.URI.file(A.normalize(f(a))).path:C=A.posix.normalize(a.path),a.with({path:C})}relativePath(a,C){if(!(a.scheme!==C.scheme||!(0,e.isEqualAuthority)(a.authority,C.authority))){if(a.scheme===T.Schemas.file){const w=A.relative(f(a),f(C));return L.isWindows?m.toSlashes(w):w}let E=a.path||"/",p=C.path||"/";if(this._ignorePathCasing(a)){let w=0;for(const v=Math.min(E.length,p.length);w<v&&!(E.charCodeAt(w)!==p.charCodeAt(w)&&E.charAt(w).toLowerCase()!==p.charAt(w).toLowerCase());w++);E=p.substr(0,w)+E.substr(w)}return A.posix.relative(E,p)}}resolvePath(a,C){if(a.scheme===T.Schemas.file){const E=O.URI.file(A.resolve(f(a),C));return a.with({authority:E.authority,path:E.path})}return C.indexOf("/")===-1&&(C=m.toSlashes(C),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C)),a.with({path:A.posix.resolve(a.path,C)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,C){return a===C||(0,R.equalsIgnoreCase)(a,C)}hasTrailingPathSeparator(a,C=A.sep){if(a.scheme===T.Schemas.file){const E=f(a);return E.length>m.getRoot(E).length&&E[E.length-1]===C}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,C=A.sep){return(0,e.hasTrailingPathSeparator)(a,C)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,C=A.sep){let E=!1;if(a.scheme===T.Schemas.file){const p=f(a);E=p!==void 0&&p.length===m.getRoot(p).length&&p[p.length-1]===C}else{C="/";const p=a.path;E=p.length===1&&p.charCodeAt(p.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,C)?a.with({path:a.path+"/"}):a}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(b=>b.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new g(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(b,a){const C=[];for(let E=0;E<b.length;E++){const p=a(b[E]);b.some((w,v)=>v===E?!1:(0,e.isEqualOrParent)(p,a(w)))||C.push(b[E])}return C}e.distinctParents=D;var d;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function a(C){const E=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,i]=v.split(":");o&&i&&E.set(o,i)});const w=C.path.substring(0,C.path.indexOf(";"));return w&&E.set(b.META_DATA_MIME,w),E}b.parseMetaData=a})(d=e.DataUri||(e.DataUri={}));function y(b,a,C){if(a){let E=b.path;return E&&E[0]!==A.posix.sep&&(E=A.posix.sep+E),b.with({scheme:C,authority:a,path:E})}return b.with({scheme:C})}e.toLocalResource=y}),define(Q[6],Z([0,1,30,11,3,2,64,12]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(F){return!!F&&typeof F.then=="function"}e.isThenable=f;function g(F){const k=new m.CancellationTokenSource,U=F(k.token),j=new Promise((z,H)=>{k.token.onCancellationRequested(()=>{H((0,A.canceled)())}),Promise.resolve(U).then(K=>{k.dispose(),z(K)},K=>{k.dispose(),H(K)})});return new class{cancel(){k.cancel()}then(z,H){return j.then(z,H)}catch(z){return this.then(void 0,z)}finally(z){return j.finally(z)}}}e.createCancelablePromise=g;function D(F,k,U){return Promise.race([F,new Promise(j=>k.onCancellationRequested(()=>j(U)))])}e.raceCancellation=D;async function d(F){let k=-1;const U=F.map((z,H)=>z.then(K=>(k=H,K))),j=await Promise.race(U);return F.forEach((z,H)=>{H!==k&&z.cancel()}),j}e.raceCancellablePromises=d;function y(F,k,U){let j;const z=setTimeout(()=>{j==null||j(void 0),U==null||U()},k);return Promise.race([F.finally(()=>clearTimeout(z)),new Promise(H=>j=H)])}e.raceTimeout=y;function b(F){return new Promise((k,U)=>{const j=F();f(j)?j.then(k,U):k(j)})}e.asPromise=b;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(U,U).then(j)})}return new Promise((U,j)=>{this.queuedPromise.then(U,j)})}return this.activePromise=k(),new Promise((U,j)=>{this.activePromise.then(z=>{this.activePromise=null,U(z)},z=>{this.activePromise=null,j(z)})})}}e.Throttler=a;class C{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}e.Sequencer=C;class E{constructor(){this.promiseMap=new Map}queue(k,U){var j;const H=((j=this.promiseMap.get(k))!==null&&j!==void 0?j:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(k)===H&&this.promiseMap.delete(k)});return this.promiseMap.set(k,H),H}}e.SequencerByKey=E;class p{constructor(k){this.defaultDelay=k,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,U=this.defaultDelay){return this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,z)=>{this.doResolve=j,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class w{constructor(k){this.delayer=new p(k),this.throttler=new a}trigger(k,U){return this.delayer.trigger(()=>this.throttler.queue(k),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class v{constructor(){this._isOpen=!1,this._promise=new Promise((k,U)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class o extends v{constructor(k){super();this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(F,k){return k?new Promise((U,j)=>{const z=setTimeout(U,F);k.onCancellationRequested(()=>{clearTimeout(z),j((0,A.canceled)())})}):g(U=>i(F,U))}e.timeout=i;function t(F,k=0){const U=setTimeout(F,k);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(F){return F.then(void 0,k=>{})}e.ignoreErrors=n;function r(F){const k=[];let U=0;const j=F.length;function z(){return U<j?F[U++]():null}function H(K){K!=null&&k.push(K);const te=z();return te?te.then(H):Promise.resolve(k)}return Promise.resolve(null).then(H)}e.sequence=r;function c(F,k=j=>!!j,U=null){let j=0;const z=F.length,H=()=>{if(j>=z)return Promise.resolve(U);const K=F[j++];return Promise.resolve(K()).then(X=>k(X)?Promise.resolve(X):H())};return H()}e.first=c;function s(F,k=j=>!!j,U=null){if(F.length===0)return Promise.resolve(U);let j=F.length;const z=()=>{var H,K;j=-1;for(const te of F)(K=(H=te).cancel)===null||K===void 0||K.call(H)};return new Promise((H,K)=>{for(const te of F)te.then(X=>{--j>=0&&k(X)?(z(),H(X)):j===0&&H(U)}).catch(X=>{--j>=0&&(z(),K(X))})})}e.firstParallel=s;class l{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new O.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(k){return this._size++,new Promise((U,j)=>{this.outstandingPromises.push({factory:k,c:U,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const U=k.factory();U.then(k.c,k.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.queues=new Map}queueFor(k,U=L.extUri){const j=U.getComparisonKey(k);let z=this.queues.get(j);return z||(z=new h,O.Event.once(z.onFinished)(()=>{z==null||z.dispose(),this.queues.delete(j)}),this.queues.set(j,z)),z}dispose(){this.queues.forEach(k=>k.dispose()),this.queues.clear()}}e.ResourceQueue=S;class I{constructor(k,U){this._token=-1,typeof k=="function"&&typeof U=="number"&&this.setIfNotSet(k,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},U)}setIfNotSet(k,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},U))}}e.TimeoutTimer=I;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,U){this.cancel(),this._token=setInterval(()=>{k()},U)}}e.IntervalTimer=u;class P{constructor(k,U){this.timeoutToken=-1,this.runner=k,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(k,U){super(k,U);this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner&&this.runner(k)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=k=>{const U=setTimeout(()=>k(F));let j=!1;return{dispose(){j||(j=!0,clearTimeout(U))}}}}else e.runWhenIdle=(F,k)=>{const U=requestIdleCallback(F,typeof k=="number"?{timeout:k}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(U))}}}}();class q{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=q;async function W(F,k,U){let j;for(let z=0;z<U;z++)try{return await F()}catch(H){j=H,await i(k)}throw j}e.retry=W;class N{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var k;(k=this._pending)===null||k===void 0||k.cancel()}setPending(k,U,j){return this._pending={taskId:k,cancel:()=>j==null?void 0:j(),promise:U},U.then(()=>this.donePending(k),()=>this.donePending(k)),U}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let U,j;const z=new Promise((H,K)=>{U=H,j=K});this._next={run:k,promise:z,promiseResolve:U,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=N;class ${constructor(k){this.interval=k,this.lastIncrementTime=0,this.value=0}increment(){const k=Date.now();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((k,U)=>{this.completeCallback=k,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(k){return new Promise(U=>{this.completeCallback(k),this.resolved=!0,U()})}error(k){return new Promise(U=>{this.errorCallback(k),this.rejected=!0,U()})}cancel(){new Promise(k=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,k()})}}e.DeferredPromise=V;class B extends O.Emitter{async fireAsync(k,U,j){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const z of this._listeners)this._asyncDeliveryQueue.push([z,k]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[z,H]=this._asyncDeliveryQueue.shift(),K=[],te=Object.assign(Object.assign({},H),{waitUntil:X=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");j&&(X=j(X,typeof z=="function"?z:z[0])),K.push(X)}});try{typeof z=="function"?z.call(void 0,te):z[0].call(z[1],te)}catch(X){(0,A.onUnexpectedError)(X);continue}Object.freeze(K),await M.settled(K).catch(X=>(0,A.onUnexpectedError)(X))}}}}e.AsyncEmitter=B;var M;(function(F){async function k(H){return typeof Promise.allSettled=="function"?U(H):j(H)}F.allSettled=k;async function U(H){return Promise.allSettled(H)}async function j(H){return Promise.all(H.map(K=>K.then(te=>({status:"fulfilled",value:te}),te=>({status:"rejected",reason:te}))))}async function z(H){let K;const te=await Promise.all(H.map(X=>X.then(ie=>ie,ie=>{K||(K=ie)})));if(typeof K!="undefined")throw K;return te}F.settled=z})(M=e.Promises||(e.Promises={}))}),define(Q[90],Z([0,1,21,42,8,37,6]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function L(){return Object.create(null)}e.getEmptyExpression=L;const f="**",g="/",D="[/\\\\]",d="[^/\\\\]",y=/\//g;function b(U){switch(U){case 0:return"";case 1:return`${d}*?`;default:return`(?:${D}|${d}+${D}|${D}${d}+)*?`}}function a(U,j){if(!U)return[];const z=[];let H=!1,K=!1,te="";for(const X of U){switch(X){case j:if(!H&&!K){z.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":K=!0;break;case"]":K=!1;break}te+=X}return te&&z.push(te),z}e.splitGlobAware=a;function C(U){if(!U)return"";let j="";const z=a(U,g);if(z.every(H=>H===f))j=".*";else{let H=!1;z.forEach((K,te)=>{if(K===f){H||(j+=b(2),H=!0);return}let X=!1,ie="",se=!1,ce="";for(const he of K){if(he!=="}"&&X){ie+=he;continue}if(se&&(he!=="]"||!ce)){let me;he==="-"?me=he:(he==="^"||he==="!")&&!ce?me="^":he===g?me="":me=m.escapeRegExpCharacters(he),ce+=me;continue}switch(he){case"{":X=!0;continue;case"[":se=!0;continue;case"}":j+=`(?:${a(ie,",").map(Ie=>C(Ie)).join("|")})`,X=!1,ie="";break;case"]":j+="["+ce+"]",se=!1,ce="";break;case"?":j+=d;continue;case"*":j+=b(1);continue;default:j+=m.escapeRegExpCharacters(he)}}te<z.length-1&&(z[te+1]!==f||te+2<z.length)&&(j+=D),H=!1})}return j}const E=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),n=function(){return!1},r=function(){return null};function c(U,j){if(!U)return r;let z;typeof U!="string"?z=U.pattern:z=U,z=z.trim();const H=`${z}_${!!j.trimForExclusions}`;let K=t.get(H);if(K)return s(K,U);let te;if(E.test(z)){const X=z.substr(4);K=function(ie,se){return typeof ie=="string"&&ie.endsWith(X)?z:null}}else(te=p.exec(l(z,j)))?K=h(te[1],z):(j.trimForExclusions?v:w).test(z)?K=S(z,j):(te=o.exec(l(z,j)))?K=I(te[1].substr(1),z,!0):(te=i.exec(l(z,j)))?K=I(te[1],z,!1):K=u(z);return t.set(H,K),s(K,U)}function s(U,j){return typeof j=="string"?U:function(z,H){return A.isEqualOrParent(z,j.base)?U(O.relative(j.base,z),H):null}}function l(U,j){return j.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function h(U,j){const z=`/${U}`,H=`\\${U}`,K=function(X,ie){return typeof X!="string"?null:ie?ie===U?j:null:X===U||X.endsWith(z)||X.endsWith(H)?j:null},te=[U];return K.basenames=te,K.patterns=[j],K.allBasenames=te,K}function S(U,j){const z=k(U.slice(1,-1).split(",").map(ie=>c(ie,j)).filter(ie=>ie!==r),U),H=z.length;if(!H)return r;if(H===1)return z[0];const K=function(ie,se){for(let ce=0,he=z.length;ce<he;ce++)if(z[ce](ie,se))return U;return null},te=z.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=z.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function I(U,j,z){const H=O.sep===O.posix.sep,K=H?U:U.replace(y,O.sep),te=O.sep+K,X=O.posix.sep+U,ie=z?function(se,ce){return typeof se=="string"&&(se===K||se.endsWith(te)||!H&&(se===U||se.endsWith(X)))?j:null}:function(se,ce){return typeof se=="string"&&(se===K||!H&&se===U)?j:null};return ie.allPaths=[(z?"*/":"./")+U],ie}function u(U){try{const j=new RegExp(`^${C(U)}$`);return function(z){return j.lastIndex=0,typeof z=="string"&&j.test(z)?U:null}}catch(j){return r}}function P(U,j,z){return!U||typeof j!="string"?!1:_(U)(j,void 0,z)}e.match=P;function _(U,j={}){if(!U)return n;if(typeof U=="string"||$(U)){const z=c(U,j);if(z===r)return n;const H=function(K,te){return!!z(K,te)};return z.allBasenames&&(H.allBasenames=z.allBasenames),z.allPaths&&(H.allPaths=z.allPaths),H}return M(U,j)}e.parse=_;function q(U){if(!!U){let j;return z=>(j||(j=(U()||Promise.resolve([])).then(H=>H?N(H):{})),j.then(H=>!!H[z]))}}e.hasSiblingPromiseFn=q;function W(U){if(!!U){let j;return z=>{if(!j){const H=U();j=H?N(H):{}}return!!j[z]}}}e.hasSiblingFn=W;function N(U){const j={};for(const z of U)j[z]=!0;return j}function $(U){const j=U;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=$;function V(U){return U.allBasenames||[]}e.getBasenameTerms=V;function B(U){return U.allPaths||[]}e.getPathTerms=B;function M(U,j){const z=k(Object.getOwnPropertyNames(U).map(ie=>F(ie,U[ie],j)).filter(ie=>ie!==r)),H=z.length;if(!H)return r;if(!z.some(ie=>!!ie.requiresSiblings)){if(H===1)return z[0];const ie=function(he,me){for(let we=0,Ie=z.length;we<Ie;we++){const ke=z[we](he,me);if(ke)return ke}return null},se=z.find(he=>!!he.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ce=z.reduce((he,me)=>me.allPaths?he.concat(me.allPaths):he,[]);return ce.length&&(ie.allPaths=ce),ie}const K=function(ie,se,ce){let he;for(let me=0,we=z.length;me<we;me++){const Ie=z[me];Ie.requiresSiblings&&ce&&(se||(se=O.basename(ie)),he||(he=se.substr(0,se.length-O.extname(ie).length)));const ke=Ie(ie,se,he,ce);if(ke)return ke}return null},te=z.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=z.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function F(U,j,z){if(j===!1)return r;const H=c(U,z);if(H===r)return r;if(typeof j=="boolean")return H;if(j){const K=j.when;if(typeof K=="string"){const te=(X,ie,se,ce)=>{if(!ce||!H(X,ie))return null;const he=K.replace("$(basename)",se),me=ce(he);return(0,T.isThenable)(me)?me.then(we=>we?U:null):me?U:null};return te.requiresSiblings=!0,te}}return H}function k(U,j){const z=U.filter(ie=>!!ie.basenames);if(z.length<2)return U;const H=z.reduce((ie,se)=>{const ce=se.basenames;return ce?ie.concat(ce):ie},[]);let K;if(j){K=[];for(let ie=0,se=H.length;ie<se;ie++)K.push(j)}else K=z.reduce((ie,se)=>{const ce=se.patterns;return ce?ie.concat(ce):ie},[]);const te=function(ie,se){if(typeof ie!="string")return null;if(!se){let he;for(he=ie.length;he>0;he--){const me=ie.charCodeAt(he-1);if(me===47||me===92)break}se=ie.substr(he)}const ce=H.indexOf(se);return ce!==-1?K[ce]:null};te.basenames=H,te.patterns=K,te.allBasenames=H;const X=U.filter(ie=>!ie.basenames);return X.push(te),X}}),define(Q[91],Z([0,1,5]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(D){return D.toJSON()}class O{constructor(d){this._uriTransformer=d}transformIncoming(d){const y=this._uriTransformer.transformIncoming(d);return y===d?d:A(m.URI.from(y))}transformOutgoing(d){const y=this._uriTransformer.transformOutgoing(d);return y===d?d:A(m.URI.from(y))}transformOutgoingURI(d){const y=this._uriTransformer.transformOutgoing(d);return y===d?d:m.URI.from(y)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,d,y){if(!D||y>200)return null;if(typeof D=="object"){if(D instanceof m.URI)return d.transformOutgoing(D);for(let b in D)if(Object.hasOwnProperty.call(D,b)){const a=R(D[b],d,y+1);a!==null&&(D[b]=a)}}return null}function T(D,d){const y=R(D,d,0);return y===null?D:y}e.transformOutgoingURIs=T;function L(D,d,y,b){if(!D||b>200)return null;if(typeof D=="object"){if(D.$mid===1)return y?m.URI.revive(d.transformIncoming(D)):d.transformIncoming(D);for(let a in D)if(Object.hasOwnProperty.call(D,a)){const C=L(D[a],d,y,b+1);C!==null&&(D[a]=C)}}return null}function f(D,d){const y=L(D,d,!1,0);return y===null?D:y}e.transformIncomingURIs=f;function g(D,d){const y=L(D,d,!0,0);return y===null?D:y}e.transformAndReviveIncomingURIs=g}),define(Q[31],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(f){return m.test(f)}e.isUUID=A;const O=new Uint8Array(16),R=[];for(let f=0;f<256;f++)R.push(f.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(f){for(let g=0;g<f.length;g++)f[g]=Math.floor(Math.random()*256);return f};function L(){T(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,g="";return g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g+="-",g+=R[O[f++]],g+=R[O[f++]],g+="-",g+=R[O[f++]],g+=R[O[f++]],g+="-",g+=R[O[f++]],g+=R[O[f++]],g+="-",g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g+=R[O[f++]],g}e.generateUuid=L}),define(Q[66],Z([0,1,202]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(R="utf8"){this.stringDecoder=new m.StringDecoder(R),this.remaining=null}write(R){const T=[],L=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(L.length<1)return T;let f=0,g,D=f;for(;D<L.length;)if(g=L.charCodeAt(D),g===13||g===10){if(T.push(L.substring(f,D)),D++,D<L.length){const d=g;g=L.charCodeAt(D),(d===13&&g===10||d===10&&g===13)&&D++}f=D}else D++;return this.remaining=f<L.length?L.substr(f):null,T}end(){return this.remaining}}e.LineDecoder=A}),define(Q[92],Z([0,1,38]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(L){const f=L.replace(/\-/g,":").toLowerCase();return!A.has(f)}function R(){return new Promise(async(L,f)=>{const g=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{L(await T())}catch(D){f(D)}finally{clearTimeout(g)}})}e.getMac=R;function T(){return new Promise((L,f)=>{try{const g=(0,m.networkInterfaces)();for(const[,D]of Object.entries(g))for(const d of D)if(O(d.mac))return L(d.mac);f("Unable to retrieve mac address (unexpected format)")}catch(g){f(g)}})}}),define(Q[93],Z([0,1,11,31,38,37,92]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,d=0;const y=(0,O.networkInterfaces)();for(let b in y)if(Object.prototype.hasOwnProperty.call(y,b))for(const{mac:a,internal:C}of y[b])C||(d+=1,this._isVirtualMachineMacAdress(a.toUpperCase())&&(D+=1));this._value=d>0?D/d:0}return this._value}};let L;async function f(){return L||(L=(async()=>await g()||A.generateUuid())()),L}e.getMachineId=f;async function g(){try{const D=await new Promise((y,b)=>{G(["crypto"],y,b)}),d=await(0,T.getMac)();return D.createHash("sha256").update(d,"utf8").digest("hex")}catch(D){m.onUnexpectedError(D);return}}}),define(Q[23],Z([0,1,27,38,8,6,7,42,31,65,12,5]),function(G,e,m,A,O,R,T,L,f,g,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function b(V,B=y.UNLINK){if((0,L.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return B===y.UNLINK?C(V):a(V)}e.rimraf=b;async function a(V){try{const B=(0,O.join)((0,A.tmpdir)(),(0,f.generateUuid)());try{await m.promises.rename(V,B)}catch(M){return C(V)}C(B).catch(M=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function C(V){return m.promises.rmdir(V,{recursive:!0,maxRetries:3})}function E(V){if((0,L.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(V,{recursive:!0})}e.rimrafSync=E;async function p(V,B){return o(await(B?w(V):m.promises.readdir(V)))}e.readdir=p;async function w(V){try{return await m.promises.readdir(V,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const B=[],M=await p(V);for(const F of M){let k=!1,U=!1,j=!1;try{const z=await m.promises.lstat((0,O.join)(V,F));k=z.isFile(),U=z.isDirectory(),j=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}B.push({name:F,isFile:()=>k,isDirectory:()=>U,isSymbolicLink:()=>j})}return B}function v(V){return o(m.readdirSync(V))}e.readdirSync=v;function o(V){return V.map(B=>typeof B=="string"?T.isMacintosh?(0,g.normalizeNFC)(B):B:(B.name=T.isMacintosh?(0,g.normalizeNFC)(B.name):B.name,B))}async function i(V){const B=await p(V),M=[];for(const F of B)await n.existsDirectory((0,O.join)(V,F))&&M.push(F);return M}e.readDirsInDir=i;function t(V,B=1e3){return new Promise(M=>{let F=!1;const k=setInterval(()=>{F||(F=!0,m.access(V,U=>{F=!1,U&&(clearInterval(k),M(void 0))}))},B)})}e.whenDeleted=t;var n;(function(V){async function B(k){let U;try{if(U=await m.promises.lstat(k),!U.isSymbolicLink())return{stat:U}}catch(j){}try{return{stat:await m.promises.stat(k),symbolicLink:(U==null?void 0:U.isSymbolicLink())?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(T.isWindows&&j.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(k)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw z}throw j}}V.stat=B;async function M(k){try{const{stat:U,symbolicLink:j}=await V.stat(k);return U.isFile()&&(j==null?void 0:j.dangling)!==!0}catch(U){}return!1}V.existsFile=M;async function F(k){try{const{stat:U,symbolicLink:j}=await V.stat(k);return U.isDirectory()&&(j==null?void 0:j.dangling)!==!0}catch(U){}return!1}V.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(V,B,M){return r.queueFor(d.URI.file(V),D.extUriBiasedIgnorePathCase).queue(()=>{const F=S(M);return new Promise((k,U)=>l(V,B,F,j=>j?U(j):k()))})}e.writeFile=c;let s=!0;function l(V,B,M,F){if(!s)return m.writeFile(V,B,{mode:M.mode,flag:M.flag},F);m.open(V,M.flag,M.mode,(k,U)=>{if(k)return F(k);m.writeFile(U,B,j=>{if(j)return m.close(U,()=>F(j));m.fdatasync(U,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),s=!1),m.close(U,H=>F(H))))})})}function h(V,B,M){const F=S(M);if(!s)return m.writeFileSync(V,B,{mode:F.mode,flag:F.flag});const k=m.openSync(V,F.flag,F.mode);try{m.writeFileSync(k,B);try{m.fdatasyncSync(k)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),s=!1}}finally{m.closeSync(k)}}e.writeFileSync=h;function S(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function I(V,B){if(V!==B){async function M(F){try{const k=await m.promises.lstat(F);if(k.isDirectory()||k.isSymbolicLink())return;const U=await m.promises.open(F,"a");try{await U.utimes(k.atime,new Date)}finally{await U.close()}}catch(k){}}try{await m.promises.rename(V,B),await M(B)}catch(F){if(V.toLowerCase()!==B.toLowerCase()&&F.code==="EXDEV"||V.endsWith("."))await u(V,B,{preserveSymlinks:!1}),await b(V,y.MOVE),await M(B);else throw F}}}e.move=I;async function u(V,B,M){return _(V,B,{root:{source:V,target:B},options:M,handledSourcePaths:new Set})}e.copy=u;const P=511;async function _(V,B,M){if(!M.handledSourcePaths.has(V)){M.handledSourcePaths.add(V);const{stat:F,symbolicLink:k}=await n.stat(V);if(k){if(M.options.preserveSymlinks)try{return await N(V,B,M)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(k.dangling)return}return F.isDirectory()?q(V,B,F.mode&P,M):W(V,B,F.mode&P)}}async function q(V,B,M,F){await m.promises.mkdir(B,{recursive:!0,mode:M});const k=await p(V);for(const U of k)await _((0,O.join)(V,U),(0,O.join)(B,U),F)}async function W(V,B,M){await m.promises.copyFile(V,B),await m.promises.chmod(B,M)}async function N(V,B,M){let F=await m.promises.readlink(V);(0,L.isEqualOrParent)(F,M.root.source,!T.isLinux)&&(F=(0,O.join)(M.root.target,F.substr(M.root.source.length+1))),await m.promises.symlink(F,B)}async function $(V){try{return await m.promises.access(V),!0}catch(B){return!1}}e.exists=$}),define(Q[94],Z([0,1,27,95,21,8,23]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(d){const y=(0,R.dirname)(d);if(d===y)return d;const b=((0,R.basename)(d)||d).toLowerCase();try{const C=(0,T.readdirSync)(y).filter(E=>E.toLowerCase()===b);if(C.length===1){const E=L(y);if(E)return(0,R.join)(E,C[0])}else if(C.length>1){const E=C.indexOf(b);if(E>=0){const p=L(y);if(p)return(0,R.join)(p,C[E])}}}catch(a){}return null}e.realcaseSync=L;async function f(d){try{return await(0,A.promisify)(m.realpath)(d)}catch(y){const b=D(d);return await m.promises.access(b,m.constants.R_OK),b}}e.realpath=f;function g(d){try{return m.realpathSync(d)}catch(y){const b=D(d);return m.accessSync(b,m.constants.R_OK),b}}e.realpathSync=g;function D(d){return(0,O.rtrim)((0,R.normalize)(d),R.sep)}}),define(Q[96],Z([0,1,48,16]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function O(T){return new Promise((L,f)=>{let g;const D=new Map;function d(a,C,E,p,w){const v=D.get(C);if(a===T||v){const o={name:y(E),cmd:E,pid:a,ppid:C,load:p,mem:w};D.set(a,o),a===T&&(g=o),v&&(v.children||(v.children=[]),v.children.push(o),v.children.length>1&&(v.children=v.children.sort((i,t)=>i.pid-t.pid)))}}function y(a){const C=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,p=/--crashes-directory/,w=/\\pipe\\winpty-control/,v=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(E.exec(a))return"watcherService ";if(p.exec(a))return"electron-crash-reporter";if(w.exec(a))return"winpty-process";if(v.exec(a))return"console-window-host (Windows internal process)";let i=o.exec(a);if(i&&i.length===2)return i[1]==="renderer"?C.exec(a)?"shared-process":"window":i[1];const t=/[a-zA-Z-]+\.js/g;let n="";do i=t.exec(a),i&&(n+=i+" ");while(i);return n&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron_node ${n}`:a}if(process.platform==="win32"){const a=C=>C.indexOf("\\\\?\\")===0||C.indexOf("\\??\\")===0?C.substr(4):C.indexOf('"\\\\?\\')===0||C.indexOf('"\\??\\')===0?'"'+C.substr(5):C;new Promise((C,E)=>{G(["windows-process-tree"],C,E)}).then(C=>{C.getProcessList(T,E=>{C.getProcessCpuUsage(E,p=>{const w=new Map;p.forEach(v=>{const o=a(v.commandLine||"");w.set(v.pid,{name:y(o),cmd:o,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),g=w.get(T),g?(w.forEach(v=>{const o=w.get(v.ppid);o&&(o.children||(o.children=[]),o.children.push(v))}),w.forEach(v=>{v.children&&(v.children=v.children.sort((o,i)=>o.pid-i.pid))}),L(g)):f(new Error(`Root process ${T} not found`))})},C.ProcessDataFlag.CommandLine|C.ProcessDataFlag.Memory)})}else{function b(){let a=[g];const C=[];for(;a.length;){const p=a.shift();p&&(C.push(p.pid),p.children&&(a=a.concat(p.children)))}let E=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);E+=" "+C.join(" "),(0,m.exec)(E,{},(p,w,v)=>{if(p||v)f(p||new Error(v.toString()));else{const o=w.toString().split(`
`);for(let i=0;i<C.length;i++){const t=D.get(C[i]);t.load=parseFloat(o[i])}if(!g){f(new Error(`Root process ${T} not found`));return}L(g)}})}(0,m.exec)("which ps",{},(a,C,E)=>{if(a||E)if(process.platform!=="linux")f(a||new Error(E.toString()));else{const p=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,m.exec)(p,{},(w,v,o)=>{w||o?f(w||new Error(o.toString())):(R(v,d),b())})}else{const p=C.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${p} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,o,i)=>{v||i&&!i.includes("screen size is bogus")?f(v||new Error(i.toString())):(R(o,d),process.platform==="linux"?b():g?L(g):f(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=O;function R(T,L){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=T.toString().split(`
`);for(const D of g){const d=f.exec(D.trim());d&&d.length===6&&L(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(Q[97],Z([0,1,8,27,7,65,2,23]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function f(d,y,b){return D({path:d,isDirectory:!1},y,b)}e.watchFile=f;function g(d,y,b){return D({path:d,isDirectory:!0},y,b)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function D(d,y,b){const a=(0,m.basename)(d.path),C=new Map;let E=!1,p=[(0,T.toDisposable)(()=>{C.forEach(w=>(0,T.dispose)(w)),C.clear()})];try{const w=(0,A.watch)(d.path);p.push((0,T.toDisposable)(()=>{w.removeAllListeners(),w.close()}));const v=new Set;d.isDirectory&&(0,L.readdir)(d.path).then(o=>o.forEach(i=>v.add(i))),w.on("error",(o,i)=>{E||b(`Failed to watch ${d.path} for changes using fs.watch() (${o}, ${i})`)}),w.on("change",(o,i)=>{if(!E){let t="";if(i&&(t=i.toString(),O.isMacintosh&&(t=(0,R.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const n=d.isDirectory?(0,m.join)(d.path,t):d.path;if(d.isDirectory)if(o==="rename"){const r=C.get(n);r&&(0,T.dispose)(r);const c=setTimeout(async()=>{C.delete(n);const s=await(0,L.exists)(n);if(!E){let l;s?v.has(t)?l="changed":(l="added",v.add(t)):(v.delete(t),l="deleted"),y(l,n)}},e.CHANGE_BUFFER_DELAY);C.set(n,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let r;v.has(t)?r="changed":(r="added",v.add(t)),y(r,n)}else if(o==="rename"||t!==a){const r=setTimeout(async()=>{const c=await(0,L.exists)(n);E||(c?(y("changed",n),p=[D(d,y,b)]):y("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(p),p=[(0,T.toDisposable)(()=>clearTimeout(r))]}else y("changed",n)}}})}catch(w){(0,L.exists)(d.path).then(v=>{v&&!E&&b(`Failed to watch ${d.path} for changes using fs.watch() (${w.toString()})`)})}return(0,T.toDisposable)(()=>{E=!0,p=(0,T.dispose)(p)})}}),define(Q[33],Z([0,1,3,2,6,30,11,22,18,17,89,21]),function(G,e,m,A,O,R,T,L,f,g,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function b(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function C(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class p{constructor(k){this.buffer=k,this.pos=0}read(k){const U=this.buffer.slice(this.pos,this.pos+k);return this.pos+=U.byteLength,U}}class w{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var v;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(v||(v={}));function o(F){const k=L.VSBuffer.alloc(4);return k.writeUInt32BE(F,0),k}function i(F){return F.read(4).readUInt32BE(0)}function t(F){const k=L.VSBuffer.alloc(1);return k.writeUInt8(F,0),k}const n={Undefined:t(v.Undefined),String:t(v.String),Buffer:t(v.Buffer),VSBuffer:t(v.VSBuffer),Array:t(v.Array),Object:t(v.Object)},r=typeof Buffer!="undefined";function c(F,k){if(typeof k=="undefined")F.write(n.Undefined);else if(typeof k=="string"){const U=L.VSBuffer.fromString(k);F.write(n.String),F.write(o(U.byteLength)),F.write(U)}else if(r&&Buffer.isBuffer(k)){const U=L.VSBuffer.wrap(k);F.write(n.Buffer),F.write(o(U.byteLength)),F.write(U)}else if(k instanceof L.VSBuffer)F.write(n.VSBuffer),F.write(o(k.byteLength)),F.write(k);else if(Array.isArray(k)){F.write(n.Array),F.write(o(k.length));for(const U of k)c(F,U)}else{const U=L.VSBuffer.fromString(JSON.stringify(k));F.write(n.Object),F.write(o(U.byteLength)),F.write(U)}}function s(F){switch(F.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return F.read(i(F)).toString();case v.Buffer:return F.read(i(F)).buffer;case v.VSBuffer:return F.read(i(F));case v.Array:{const U=i(F),j=[];for(let z=0;z<U;z++)j.push(s(F));return j}case v.Object:return JSON.parse(F.read(i(F)).toString())}}class l{constructor(k,U,j=null,z=1e3){this.protocol=k,this.ctx=U,this.logger=j,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(k,U){this.channels.set(k,U),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const U=this.send([k.type]);this.logger&&this.logger.logOutgoing(U,0,1,C(k.type));return}case 201:case 202:case 204:case 203:{const U=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(U,k.id,1,C(k.type),k.data);return}}}send(k,U=void 0){const j=new w;return c(j,k),c(j,U),this.sendBuffer(j.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(U){return 0}}onRawMessage(k){const U=new p(k),j=s(U),z=s(U),H=j[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,j[1],1,`${b(H)}: ${j[2]}.${j[3]}`,z),this.onPromise({type:H,id:j[1],channelName:j[2],name:j[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,j[1],1,`${b(H)}: ${j[2]}.${j[3]}`,z),this.onEventListen({type:H,id:j[1],channelName:j[2],name:j[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,j[1],1,`${b(H)}`),this.disposeActiveRequest({type:H,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,j[1],1,`${b(H)}`),this.disposeActiveRequest({type:H,id:j[1]})}}onPromise(k){const U=this.channels.get(k.channelName);if(!U){this.collectPendingRequest(k);return}const j=new R.CancellationTokenSource;let z;try{z=U.call(this.ctx,k.name,k.arg,j.token)}catch(te){z=Promise.reject(te)}const H=k.id;z.then(te=>{this.sendResponse({id:H,data:te,type:201}),this.activeRequests.delete(k.id)},te=>{te instanceof Error?this.sendResponse({id:H,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:H,data:te,type:203}),this.activeRequests.delete(k.id)});const K=(0,A.toDisposable)(()=>j.cancel());this.activeRequests.set(k.id,K)}onEventListen(k){const U=this.channels.get(k.channelName);if(!U){this.collectPendingRequest(k);return}const j=k.id,H=U.listen(this.ctx,k.name,k.arg)(K=>this.sendResponse({id:j,data:K,type:204}));this.activeRequests.set(k.id,H)}disposeActiveRequest(k){const U=this.activeRequests.get(k.id);U&&(U.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let U=this.pendingRequests.get(k.channelName);U||(U=[],this.pendingRequests.set(k.channelName,U));const j=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:k,timeoutTimer:j})}flushPendingRequests(k){const U=this.pendingRequests.get(k);if(U){for(const j of U)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(k,U=null){this.protocol=k,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=U}getChannel(k){const U=this;return{call(j,z,H){return U.isDisposed?Promise.reject(T.canceled()):U.requestPromise(k,j,z,H)},listen(j,z){return U.isDisposed?Promise.reject(T.canceled()):U.requestEvent(k,j,z)}}}requestPromise(k,U,j,z=R.CancellationToken.None){const H=this.lastRequestId++,te={id:H,type:100,channelName:k,name:U,arg:j};if(z.isCancellationRequested)return Promise.reject(T.canceled());let X;return new Promise((se,ce)=>{if(z.isCancellationRequested)return ce(T.canceled());const he=()=>{const ke=Ue=>{switch(Ue.type){case 201:this.handlers.delete(H),se(Ue.data);break;case 202:this.handlers.delete(H);const Fe=new Error(Ue.data.message);Fe.stack=Ue.data.stack,Fe.name=Ue.data.name,ce(Fe);break;case 203:this.handlers.delete(H),ce(Ue.data);break}};this.handlers.set(H,ke),this.sendRequest(te)};let me=null;this.state===E.Idle?he():(me=(0,O.createCancelablePromise)(ke=>this.whenInitialized()),me.then(()=>{me=null,he()}));const we=()=>{me?(me.cancel(),me=null):this.sendRequest({id:H,type:101}),ce(T.canceled())},Ie=z.onCancellationRequested(we);X=(0,A.combinedDisposable)((0,A.toDisposable)(we),Ie),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(k,U,j){const z=this.lastRequestId++,K={id:z,type:102,channelName:k,name:U,arg:j};let te=null;const X=new m.Emitter({onFirstListenerAdd:()=>{te=(0,O.createCancelablePromise)(se=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(X),this.sendRequest(K)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(X),this.sendRequest({id:z,type:103}))}}),ie=se=>X.fire(se.data);return this.handlers.set(z,ie),X.event}sendRequest(k){switch(k.type){case 100:case 102:{const U=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(U,k.id,0,`${b(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const U=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(U,k.id,0,b(k.type));return}}}send(k,U=void 0){const j=new w;return c(j,k),c(j,U),this.sendBuffer(j.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(U){return 0}}onBuffer(k){const U=new p(k),j=s(U),z=s(U),H=j[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,C(H)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,j[1],0,C(H),z),this.onResponse({type:j[0],id:j[1],data:z})}}onResponse(k){if(k.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(k.id);U&&U(k)}whenInitialized(){return this.state===E.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}e.ChannelClient=S;class I{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:U,onDidClientDisconnect:j})=>{m.Event.once(U.onMessage)(H=>{const K=new p(H),te=s(K),X=new l(U,te),ie=new S(U);this.channels.forEach((ce,he)=>X.registerChannel(he,ce));const se={channelServer:X,channelClient:ie,ctx:te};this._connections.add(se),this._onDidAddConnection.fire(se),j(()=>{X.dispose(),ie.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const k=[];return this._connections.forEach(U=>k.push(U)),k}getChannel(k,U){const j=this;return{call(z,H,K){let te;if((0,g.isFunction)(U)){let ie=(0,f.getRandomElement)(j.connections.filter(U));te=ie?Promise.resolve(ie):m.Event.toPromise(m.Event.filter(j.onDidAddConnection,U))}else te=U.routeCall(j,z,H);const X=te.then(ie=>ie.channelClient.getChannel(k));return P(X).call(z,H,K)},listen(z,H){if((0,g.isFunction)(U))return j.getMulticastEvent(k,U,z,H);const K=U.routeEvent(j,z,H).then(te=>te.channelClient.getChannel(k));return P(K).listen(z,H)}}}getMulticastEvent(k,U,j,z){const H=this;let K=new A.DisposableStore;const te=new m.Emitter({onFirstListenerAdd:()=>{K=new A.DisposableStore;const X=new m.EventMultiplexer,ie=new Map,se=he=>{const we=he.channelClient.getChannel(k).listen(j,z),Ie=X.add(we);ie.set(he,Ie)},ce=he=>{const me=ie.get(he);!me||(me.dispose(),ie.delete(he))};H.connections.filter(U).forEach(se),m.Event.filter(H.onDidAddConnection,U)(se,void 0,K),H.onDidRemoveConnection(ce,void 0,K),X.event(te.fire,te,K),K.add(X)},onLastListenerRemove:()=>{K.dispose()}});return te.event}registerChannel(k,U){this.channels.set(k,U),this._connections.forEach(j=>{j.channelServer.registerChannel(k,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class u{constructor(k,U,j=null){const z=new w;c(z,U),k.send(z.buffer),this.channelClient=new S(k,j),this.channelServer=new l(k,U,j)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,U){this.channelServer.registerChannel(k,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function P(F){return{call(k,U,j){return F.then(z=>z.call(k,U,j))},listen(k,U){const j=new m.Relay;return F.then(z=>j.input=z.listen(k,U)),j.event}}}e.getDelayedChannel=P;function _(F){let k=!1;return{call(U,j,z){return k?F.call(U,j,z):(0,O.timeout)(0).then(()=>k=!0).then(()=>F.call(U,j,z))},listen(U,j){if(k)return F.listen(U,j);const z=new m.Relay;return(0,O.timeout)(0).then(()=>k=!0).then(()=>z.input=F.listen(U,j)),z.event}}}e.getNextTickChannel=_;class q{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const U of k.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await m.Event.toPromise(k.onDidAddConnection),await this.route(k)}}e.StaticRouter=q;var W;(function(F){function k(z,H){const K=z,te=H&&H.disableMarshalling,X=new Map;for(const ie in K)j(ie)&&X.set(ie,m.Event.buffer(K[ie],!0));return new class{listen(ie,se){const ce=X.get(se);if(ce)return ce;throw new Error(`Event not found: ${se}`)}call(ie,se,ce){const he=K[se];if(typeof he=="function"){if(!te&&Array.isArray(ce))for(let me=0;me<ce.length;me++)ce[me]=(0,D.revive)(ce[me]);return he.apply(K,ce)}throw new Error(`Method not found: ${se}`)}}}F.fromService=k;function U(z,H){const K=H&&H.disableMarshalling;return new Proxy({},{get(te,X){var ie;if(typeof X=="string")return((ie=H==null?void 0:H.properties)===null||ie===void 0?void 0:ie.has(X))?H.properties.get(X):j(X)?z.listen(X):async function(...se){let ce;H&&!(0,g.isUndefinedOrNull)(H.context)?ce=[H.context,...se]:ce=se;const he=await z.call(X,ce);return K?he:(0,D.revive)(he)};throw new Error(`Property not found: ${String(X)}`)}})}F.toService=U;function j(z){return z[0]==="o"&&z[1]==="n"&&d.isUpperAsciiLetter(z.charCodeAt(2))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let k=F.toString();if(k!=="[object Object]")return k}return F}function V(F){return Array.isArray(F)?F.map($):$(F)}function B(F,k,U,j,z,H,K){K=V(K);const te=N[z],X=te[j%te.length];let ie=[`%c[${F}]%c[${String(k).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(H)?(ie=ie.concat(K),ie.push(")")):ie.push(K),console.log.apply(console,ie)}e.logWithColors=B;class M{constructor(k,U){this._outgoingPrefix=k,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,U,j,z,H){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,U,j,z,H)}logIncoming(k,U,j,z,H){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,U,j,z,H)}}e.IPCLogger=M}),define(Q[98],Z([0,1,3,33,22]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(f){this.port=f,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",g=>O.VSBuffer.wrap(g.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class T extends A.IPCClient{constructor(f,g){const D=new R(f);super(D,g);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=T}),define(Q[99],Z([0,1,100,3,33,98]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends O.IPCServer{static getOnDidClientConnect(){const f=A.Event.fromNodeEventEmitter(m.ipcRenderer,"vscode:createMessageChannel",(g,D)=>D);return A.Event.map(f,g=>{const{port1:D,port2:d}=new MessageChannel,b={protocol:new R.Protocol(D),onDidClientDisconnect:A.Event.fromDOMEventEmitter(D,"close")};return m.ipcRenderer.postMessage("vscode:createMessageChannelResult",g,[d]),b})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(Q[101],Z([0,1,11,22]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function O(L,f){L.proxyAuthorization&&(L.headers=Object.assign(Object.assign({},L.headers||{}),{"Proxy-Authorization":L.proxyAuthorization}));const g=new XMLHttpRequest;return new Promise((D,d)=>{g.open(L.type||"GET",L.url||"",!0,L.user,L.password),R(g,L),g.responseType="arraybuffer",g.onerror=y=>d(new Error(g.statusText&&"XHR failed: "+g.statusText||"XHR failed")),g.onload=y=>{D({res:{statusCode:g.status,headers:T(g)},stream:(0,A.bufferToStream)(A.VSBuffer.wrap(new Uint8Array(g.response)))})},g.ontimeout=y=>d(new Error(`XHR timeout: ${L.timeout}ms`)),L.timeout&&(g.timeout=L.timeout),g.send(L.data),f.onCancellationRequested(()=>{g.abort(),d((0,m.canceled)())})})}e.request=O;function R(L,f){if(f.headers){e:for(let g in f.headers){switch(g){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}L.setRequestHeader(g,f.headers[g])}}}function T(L){const f=Object.create(null);for(const g of L.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(g){const D=g.indexOf(":");f[g.substr(0,D).trim().toLowerCase()]=g.substr(D+1).trim()}return f}}),define(Q[67],Z([0,1,2,3,6,17]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var T;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));var L;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(L||(L={}));class f extends m.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var y,b;(y=d.changed)===null||y===void 0||y.forEach((a,C)=>this.accept(C,a)),(b=d.deleted)===null||b===void 0||b.forEach(a=>this.accept(a,void 0))}accept(d,y){if(this.state!==L.Closed){let b=!1;(0,R.isUndefinedOrNull)(y)?b=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),b=!0),b&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const b=this.cache.get(d);return(0,R.isUndefinedOrNull)(b)?y:b}getBoolean(d,y){const b=this.get(d);return(0,R.isUndefinedOrNull)(b)?y:b==="true"}getNumber(d,y){const b=this.get(d);return(0,R.isUndefinedOrNull)(b)?y:parseInt(b,10)}async set(d,y){if(this.state!==L.Closed){if((0,R.isUndefinedOrNull)(y))return this.delete(d);const b=String(y);if(this.cache.get(d)!==b)return this.cache.set(d,b),this.pendingInserts.set(d,b),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==L.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,b)=>this.items.set(b,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=g}),define(Q[102],Z([13,14]),function(G,e){return G.create("vs/base/common/date",e)}),define(Q[53],Z([0,1,102]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,O=A*60,R=O*24,T=R*7,L=R*30,f=R*365;function g(d,y){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,m.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(b<30)return(0,m.localize)(1,null);let a;return b<A?(a=b,y?a===1?(0,m.localize)(2,null,a):(0,m.localize)(3,null,a):a===1?(0,m.localize)(4,null,a):(0,m.localize)(5,null,a)):b<O?(a=Math.floor(b/A),y?a===1?(0,m.localize)(6,null,a):(0,m.localize)(7,null,a):a===1?(0,m.localize)(8,null,a):(0,m.localize)(9,null,a)):b<R?(a=Math.floor(b/O),y?a===1?(0,m.localize)(10,null,a):(0,m.localize)(11,null,a):a===1?(0,m.localize)(12,null,a):(0,m.localize)(13,null,a)):b<T?(a=Math.floor(b/R),y?a===1?(0,m.localize)(14,null,a):(0,m.localize)(15,null,a):a===1?(0,m.localize)(16,null,a):(0,m.localize)(17,null,a)):b<L?(a=Math.floor(b/T),y?a===1?(0,m.localize)(18,null,a):(0,m.localize)(19,null,a):a===1?(0,m.localize)(20,null,a):(0,m.localize)(21,null,a)):b<f?(a=Math.floor(b/L),y?a===1?(0,m.localize)(22,null,a):(0,m.localize)(23,null,a):a===1?(0,m.localize)(24,null,a):(0,m.localize)(25,null,a)):(a=Math.floor(b/f),y?a===1?(0,m.localize)(26,null,a):(0,m.localize)(27,null,a):a===1?(0,m.localize)(28,null,a):(0,m.localize)(29,null,a))}e.fromNow=g;function D(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(Q[103],Z([13,14]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Q[43],Z([0,1,103,17,18]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(g,D){return D&&(g.stack||g.stacktrace)?m.localize(0,null,L(g),T(g.stack)||T(g.stacktrace)):L(g)}function T(g){return Array.isArray(g)?g.join(`
`):g}function L(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?m.localize(1,null,g.message):g.message||m.localize(2,null)}function f(g=null,D=!1){if(!g)return m.localize(3,null);if(Array.isArray(g)){const d=O.coalesce(g),y=f(d[0],D);return d.length>1?m.localize(4,null,y,d.length):y}if(A.isString(g))return g;if(g.detail){const d=g.detail;if(d.error)return R(d.error,D);if(d.exception)return R(d.exception,D)}return g.stack?R(g,D):g.message?g.message:m.localize(5,null)}e.toErrorMessage=f}),define(Q[104],Z([13,14]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Q[105],Z([0,1,8,27,23,48,104,36,17,26,42,7,66,16]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function C(i,t){if(d.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const r=R.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],n);return new Promise(c=>{r.once("error",s=>{c({success:!1,error:s})}),r.once("exit",(s,l)=>{c(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(d.isLinux||d.isMacintosh)try{const n=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{R.execFile(n,[i.pid.toString()],{encoding:"utf8",shell:!0},(c,s,l)=>{r(c?{success:!1,error:c}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function E(i=L.env){return i.comspec||"cmd.exe"}e.getWindowsShell=E;class p{constructor(t,n,r,c){if(n!==void 0&&r!==void 0&&c!==void 0)this.cmd=t,this.args=n,this.shell=r,this.options=c;else{const s=t;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(L.env).forEach(l=>{s[l]=L.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(m.sep);return n!==-1&&(t=t.substring(n+1)),p.WellKnowCommands[t]?t:"other"}start(t){return d.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(L.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(n=>{let r,c;const s=new Promise((l,h)=>{r=l,c=h});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(h,S,I)=>{this.childProcess=null;const u=h;u&&u.killed?c({killed:this.terminateRequested,stdout:S.toString(),stderr:I.toString()}):this.handleExec(r,t,h,S,I)})}else{let l=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,r,t,c);const I={terminated:this.terminateRequested};f.isNumber(S)&&(I.cmdCode=S),r(I)};if(this.shell&&d.isWindows){const S=g.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let I=!1,u=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),I=_.quoted,this.args&&this.args.forEach(W=>{_=this.ensureQuotes(W),P.push(_.value),u=u&&_.quoted});const q=["/s","/c"];I?u?q.push('"'+P.join(" ")+'"'):P.length>1?q.push('"'+P[0]+'" '+P.slice(1).join(" ")):q.push('"'+P[0]+'"'):q.push(P.join(" ")),l=R.spawn(E(),q,S)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(f.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,c({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,r,t,c,!0)))}return s})}handleClose(t,n,r,c){}ensureQuotes(t){return p.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,C(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!d.isWindows)return t(!1);const n=R.spawn(E(),["/s","/c"]);n.on("error",r=>t(!0)),n.on("exit",r=>t(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class w extends p{constructor(t,n,r,c){super(t,n,r,c);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,r,c,s){[c,s].forEach((l,h)=>{const S=new y.LineDecoder;S.write(l).forEach(P=>{n({line:P,source:h===0?0:1})});const u=S.end();u&&n({line:u,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,n,r,c,s){const l=new y.LineDecoder,h=new y.LineDecoder;t.stdout.on("data",S=>{l.write(S).forEach(u=>r({line:u,source:0}))}),t.stderr.on("data",S=>{h.write(S).forEach(u=>r({line:u,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(t,n,r,c){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&r({line:l,source:1})}}e.LineProcess=w;function v(i){let t=[],n=!1;const r=function(c){if(n){t.push(c);return}(!i.send(c,l=>{if(l&&console.error(l),n=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(S=>r(S))}})||d.isWindows)&&(n=!0)};return{send:r}}e.createQueuedSender=v;var o;(function(i){async function t(n,r,c){if(m.isAbsolute(n))return n;if(r===void 0&&(r=L.cwd()),m.dirname(n)!=="."||(c===void 0&&f.isString(L.env.PATH)&&(c=L.env.PATH.split(m.delimiter)),c===void 0||c.length===0))return m.join(r,n);async function l(h){return await O.exists(h)?!(await A.promises.stat(h)).isDirectory():!1}for(let h of c){let S;if(m.isAbsolute(h)?S=m.join(h,n):S=m.join(r,h,n),await l(S))return S;let I=S+".com";if(await l(I)||(I=S+".exe",await l(I)))return I}return m.join(r,n)}i.findExecutable=t})(o=e.win32||(e.win32={}))}),define(Q[49],Z([0,1,48,2,6,26,3,105,33,88,30,11,22,7]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends f.ChannelServer{constructor(p){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(v){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",w=>y.VSBuffer.wrap(Buffer.from(w,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=a;class C{constructor(p,w){this.modulePath=p,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new O.Delayer(v),this.child=null,this._client=null}getChannel(p){const w=this;return{call(v,o,i){return w.requestPromise(p,v,o,i)},listen(v,o){return w.requestEvent(p,v,o)}}}requestPromise(p,w,v,o=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(p),t=(0,O.createCancelablePromise)(c=>i.call(w,v,c)),n=o.onCancellationRequested(()=>t.cancel()),r=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,w,v){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let o;const i=new T.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(p).listen(w,v)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env=Object.assign(Object.assign({},(0,R.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(w.env=Object.assign(Object.assign({},w.env),this.options.env)),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),b.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,p,w);const v=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,g.isRemoteConsoleLog)(s)){(0,g.log)(s,`IPC Library: ${this.options.serverName}`);return}v.fire(y.VSBuffer.wrap(Buffer.from(s,"base64")))});const i=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,t=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),n=v.event,r={send:t,onMessage:n};this._client=new f.ChannelClient(r);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",c),this.activeRequests.forEach(h=>(0,A.dispose)(h)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(p){let w=this.channels.get(p);return w||(w=this.client.getChannel(p),this.channels.set(p,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Q[106],Z([13,14]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Q[107],Z([13,14]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[108],Z([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[109],Z([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Q[110],Z([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[111],Z([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[112],Z([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Q[113],Z([13,14]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[114],Z([13,14]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Q[115],Z([13,14]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Q[116],Z([13,14]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Q[117],Z([13,14]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[118],Z([13,14]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Q[119],Z([13,14]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[120],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Q[121],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Q[122],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Q[123],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Q[124],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Q[125],Z([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var ue=this&&this.__decorate||function(G,e,m,A){var O=arguments.length,R=O<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,m):A,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,m,A);else for(var L=G.length-1;L>=0;L--)(T=G[L])&&(R=(O<3?T(R):O>3?T(e,m,R):T(e,m))||R);return O>3&&R&&Object.defineProperty(e,m,R),R};define(Q[126],Z([0,1,8,12,86,53,16,5,36]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(a,C,E){this._args=a,this.paths=C,this.productService=E}get appRoot(){return(0,m.dirname)(T.FileAccess.asFileUri("",G).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(L.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=f.env.VSCODE_PORTABLE;return a?L.URI.file((0,m.join)(a,"argv.json")):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,A.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,m.resolve)(a):(0,m.normalize)((0,m.join)(T.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,m.resolve)(a):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,m.resolve)(a);const C=f.env.VSCODE_EXTENSIONS;if(C)return C;const E=f.env.VSCODE_PORTABLE;return E?(0,m.join)(E,"extensions"):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(C=>/^[^:/?#]+?:\/\//.test(C)?L.URI.parse(C):L.URI.file((0,m.normalize)(C)))}get extensionDevelopmentKind(){var a;return(a=this.args.extensionDevelopmentKind)===null||a===void 0?void 0:a.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?L.URI.parse(a):L.URI.file((0,m.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,A.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([O.memoize],g.prototype,"appRoot",null),ue([O.memoize],g.prototype,"userHome",null),ue([O.memoize],g.prototype,"userDataPath",null),ue([O.memoize],g.prototype,"appSettingsHome",null),ue([O.memoize],g.prototype,"tmpDir",null),ue([O.memoize],g.prototype,"userRoamingDataHome",null),ue([O.memoize],g.prototype,"settingsResource",null),ue([O.memoize],g.prototype,"userDataSyncHome",null),ue([O.memoize],g.prototype,"userDataSyncLogResource",null),ue([O.memoize],g.prototype,"sync",null),ue([O.memoize],g.prototype,"machineSettingsResource",null),ue([O.memoize],g.prototype,"globalStorageHome",null),ue([O.memoize],g.prototype,"workspaceStorageHome",null),ue([O.memoize],g.prototype,"keybindingsResource",null),ue([O.memoize],g.prototype,"keyboardLayoutResource",null),ue([O.memoize],g.prototype,"argvResource",null),ue([O.memoize],g.prototype,"snippetsHome",null),ue([O.memoize],g.prototype,"isExtensionDevelopment",null),ue([O.memoize],g.prototype,"untitledWorkspacesHome",null),ue([O.memoize],g.prototype,"installSourcePath",null),ue([O.memoize],g.prototype,"builtinExtensionsPath",null),ue([O.memoize],g.prototype,"extensionsPath",null),ue([O.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ue([O.memoize],g.prototype,"extensionDevelopmentKind",null),ue([O.memoize],g.prototype,"extensionTestsLocationURI",null),ue([O.memoize],g.prototype,"debugExtensionHost",null),ue([O.memoize],g.prototype,"serviceMachineIdResource",null),ue([O.memoize],g.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=g;function D(b,a){return y(b["inspect-extensions"],b["inspect-brk-extensions"],5870,a,b.debugId)}e.parseExtensionHostPort=D;function d(b,a){return y(b["inspect-search"],b["inspect-brk-search"],5876,a)}e.parseSearchPort=d;function y(b,a,C,E,p){const v=Number(a||b)||(E?null:C),o=v?Boolean(!!a):!1;return{port:v,break:o,debugId:p}}}),function(){"use strict";function G(e,m,A){function O(T){return e.resolve(R(T))}function R(T){const L=process.env.VSCODE_PORTABLE;if(L)return e.join(L,"user-data");const f=T["user-data-dir"];if(f)return f;let g=process.env.VSCODE_APPDATA;if(!g)switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(D,"AppData","Roaming")}break;case"darwin":g=e.join(m.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,A)}return{getUserDataPath:O}}if(typeof define=="function")define(Q[127],Z([0,203,38,16,12]),function(e,m,A,O,R){const T=R.dirname(O.FileAccess.asFileUri("",e)),L=e.__$__nodeRequire(R.joinPath(T,"package.json").fsPath);return G(m,A,L.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=G(m,A,e.name)}else throw new Error("Unknown context")}(),define(Q[128],Z([0,1,38,127,126]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends O.AbstractNativeEnvironmentService{constructor(L,f){super(L,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,A.getUserDataPath)(L)},f)}}e.NativeEnvironmentService=R}),define(Q[129],Z([0,1,5]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const A=/^([^@:]+@)?([^:]+):/,O=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,L=/^\s*url\s*=\s*(.+\S)\s*$/mg,f=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function g(E){const p=E.match(T);return p?p[1]:null}function D(E){if(E.indexOf("://")===-1){const p=E.match(A);return p?g(p[2]):null}try{const p=m.URI.parse(E);if(p.authority)return g(p.authority)}catch(p){}return null}function d(E,p){const w=new Set;let v;for(;v=L.exec(E);){const i=D(v[1]);i&&w.add(i)}const o=new Set(p);return Array.from(w).map(i=>o.has(i)?i:i.replace(f,"a"))}e.getDomainsOfRemotes=d;function y(E){const p=E.match(R);return p?p[2]:null}function b(E,p,w){return E&&p?(w&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${E}${p}`:`${E}/${p}`):null}function a(E,p){if(E.indexOf("://")===-1){const w=E.match(O);if(w)return b(w[2],w[3],p)}try{const w=m.URI.parse(E);if(w.authority)return b(y(w.authority),w.path,p)}catch(w){}return null}function C(E,p=!1){const w=[];let v;for(;v=L.exec(E);){const o=a(v[1],p);o&&w.push(o)}return w}e.getRemotes=C}),define(Q[130],Z([0,1,3,5,91,26,2]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function L(a,C){return A.URI.revive(C?C.transformIncoming(a):a)}function f(a,C){return C?C.transformOutgoingURI(a):a}function g(a,C){C=C||O.DefaultURITransformer;const E=a.manifest,p=(0,O.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},a),{manifest:void 0}),C);return Object.assign(Object.assign({},p),{manifest:E})}function D(a,C){return C?(0,R.cloneAndChange)(a,E=>E instanceof A.URI?C.transformOutgoingURI(E):void 0):a}class d{constructor(C,E){this.service=C,this.getUriTransformer=E,this.onInstallExtension=m.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=m.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=m.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=m.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,E){const p=this.getUriTransformer(C);switch(E){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return m.Event.map(this.onDidInstallExtension,w=>Object.assign(Object.assign({},w),{local:w.local?D(w.local,p):w.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,E,p){const w=this.getUriTransformer(C);switch(E){case"zip":return this.service.zip(g(p[0],w)).then(v=>f(v,w));case"unzip":return this.service.unzip(L(p[0],w));case"install":return this.service.install(L(p[0],w));case"getManifest":return this.service.getManifest(L(p[0],w));case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(g(p[0],w),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(g(p[0],w));case"getInstalled":return this.service.getInstalled(p[0]).then(v=>v.map(o=>D(o,w)));case"updateMetadata":return this.service.updateMetadata(g(p[0],w),p[1]).then(v=>D(v,w));case"updateExtensionScope":return this.service.updateExtensionScope(g(p[0],w),p[1]).then(v=>D(v,w));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class y extends T.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new m.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new m.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new m.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new m.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(E=>this._onInstallExtension.fire(E))),this._register(this.channel.listen("onDidInstallExtension")(E=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},E),{local:E.local?g(E.local,null):E.local})))),this._register(this.channel.listen("onUninstallExtension")(E=>this._onUninstallExtension.fire(E))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this._onDidUninstallExtension.fire(E)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(E=>A.URI.revive(E)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C){return Promise.resolve(this.channel.call("install",[C])).then(E=>g(E,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,E){return Promise.resolve(this.channel.call("installFromGallery",[C,E])).then(p=>g(p,null))}uninstall(C,E){return Promise.resolve(this.channel.call("uninstall",[C,E]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(E=>E.map(p=>g(p,null)))}updateMetadata(C,E){return Promise.resolve(this.channel.call("updateMetadata",[C,E])).then(p=>g(p,null))}updateExtensionScope(C,E){return Promise.resolve(this.channel.call("updateExtensionScope",[C,E])).then(p=>g(p,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class b{constructor(C){this.service=C}listen(C,E){throw new Error("Invalid listen")}call(C,E,p){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Q[131],Z([0,1,26]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function O(R,T){const L=f=>{if(typeof f=="string"){const g=A.exec(f);if(!!g)return T[g[1]]||f}};return(0,m.cloneAndChange)(R,L)}e.localizeManifest=O}),define(Q[132],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class m{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,T,L,f){return this.channel.call("promptImportantExtensionsInstallNotification",[R,T,L,f])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=m;class A{constructor(R){this.service=R}listen(R,T){throw new Error(`Event not found: ${T}`)}call(R,T,L){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0],L[1],L[2],L[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=A}),define(Q[68],Z([0,1,113]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function O(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=O;function R(d){if(!O(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(A);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=R;function T(d){if(!d)return null;let y=d.majorBase,b=d.majorMustEqual,a=d.minorBase,C=d.minorMustEqual,E=d.patchBase,p=d.patchMustEqual;return d.hasCaret&&(y===0||(C=!1),p=!1),{majorBase:y,majorMustEqual:b,minorBase:a,minorMustEqual:C,patchBase:E,patchMustEqual:p,isMinimum:d.hasGreaterEquals}}e.normalizeVersion=T;function L(d,y){let b;typeof d=="string"?b=T(R(d)):b=d;let a;if(typeof y=="string"?a=T(R(y)):a=y,!b||!a)return!1;let C=b.majorBase,E=b.minorBase,p=b.patchBase,w=a.majorBase,v=a.minorBase,o=a.patchBase,i=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?C>w?!0:C<w?!1:E>v?!0:E<v?!1:p>=o:(C===1&&w===0&&(!i||!t||!n)&&(w=1,v=0,o=0,i=!0,t=!1,n=!1),C<w?!1:C>w?!i:E<v?!1:E>v?!t:p<o?!1:p>o?!n:!0)}e.isValidVersion=L;function f(d,y,b){return y.isBuiltin||typeof y.main=="undefined"?!0:D(d,y.engines.vscode,b)}e.isValidExtensionVersion=f;function g(d,y){return d==="*"||D(y,d)}e.isEngineValid=g;function D(d,y,b=[]){let a=T(R(y));if(!a)return b.push(m.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return b.push(m.localize(1,null,y)),!1}else if(!a.majorMustEqual)return b.push(m.localize(2,null,y)),!1;return L(d,a)?!0:(b.push(m.localize(3,null,d,y)),!1)}e.isVersionValid=D}),define(Q[133],Z([0,1,33,49,2,16]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends O.Disposable{constructor(f,g,D,d){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=D,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[134],Z([0,1,33,49,2,16]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends O.Disposable{constructor(f,g,D,d,y={}){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=D,this.verboseLogging=d,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[135],Z([0,1,48,66,90,16]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(f,g,D,d,y){this.watchedFolder=f,this.eventCallback=D,this.logCallback=d,this.verboseLogging=y,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(b=>O.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=m.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,f);const g=new A.LineDecoder;this.handle.stdout.on("data",D=>{const d=[];g.write(D).forEach(y=>{const b=y.split("|");if(b.length===2){const a=Number(b[0]),C=b[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(E=>E(C))){this.verboseLogging&&this.log(C);return}d.push({type:T.changeTypeMap[a],path:C})}else this.log(b[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",D=>this.onError(D)),this.handle.stderr.on("data",D=>this.onError(D)),this.handle.on("exit",(D,d)=>this.onExit(D,d))}onError(f){this.error("process error: "+f.toString())}onExit(f,g){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${g})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[136],Z([0,1,135,8,21]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(L,f,g,D){this.onDidFilesChange=f,this.onLogMessage=g,this.verboseLogging=D,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,O.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(Q[50],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(R,T=[],L=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=m;const A=(O,...R)=>new m(O,R);e.createSyncDescriptor=A}),define(Q[137],Z([0,1,50]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function O(T,L,f){L instanceof m.SyncDescriptor||(L=new m.SyncDescriptor(L,[],f)),A.push([T,L])}e.registerSingleton=O;function R(){return A}e.getSingletonServiceDescriptors=R}),define(Q[138],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=m;class A{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const L=this.lookupOrInsertNode(R),f=this.lookupOrInsertNode(T);L.outgoing.set(this._hashFn(T),f),f.incoming.set(this._hashFn(R),L)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let L of this._nodes.values())L.outgoing.delete(T),L.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let L=this._nodes.get(T);return L||(L=new m(R),this._nodes.set(T,L)),L}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,L]of this._nodes)R.push(`${T}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return R.join(`
`)}}e.Graph=A}),define(Q[4],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function f(g){return g[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=f})(m=e._util||(e._util={})),e.IInstantiationService=O("instantiationService");function A(L,f,g,D){f[m.DI_TARGET]===f?f[m.DI_DEPENDENCIES].push({id:L,index:g,optional:D}):(f[m.DI_DEPENDENCIES]=[{id:L,index:g,optional:D}],f[m.DI_TARGET]=f)}function O(L){if(m.serviceIds.has(L))return m.serviceIds.get(L);const f=function(g,D,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(f,g,d,!1)};return f.toString=()=>L,m.serviceIds.set(L,f),f}e.createDecorator=O;function R(L){return L}e.refineServiceDecorator=R;function T(L){return function(f,g,D){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(L,f,D,!0)}}e.optional=T}),define(Q[139],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,m.createDecorator)("checksumService")}),define(Q[140],Z([0,1,21,4,7]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=O.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",O.isMacintosh),T.set("isLinux",O.isLinux),T.set("isWindows",O.isWindows),T.set("isWeb",O.isWeb),T.set("isMacNative",O.isMacintosh&&!O.isWeb),T.set("isEdge",R.indexOf("Edg/")>=0),T.set("isFirefox",R.indexOf("Firefox")>=0),T.set("isChrome",R.indexOf("Chrome")>=0),T.set("isSafari",R.indexOf("Safari")>=0),T.set("isIPad",R.indexOf("iPad")>=0);const L=Object.prototype.hasOwnProperty;var f;(function(I){I[I.False=0]="False",I[I.True=1]="True",I[I.Defined=2]="Defined",I[I.Not=3]="Not",I[I.Equals=4]="Equals",I[I.NotEquals=5]="NotEquals",I[I.And=6]="And",I[I.Regex=7]="Regex",I[I.NotRegex=8]="NotRegex",I[I.Or=9]="Or",I[I.In=10]="In",I[I.NotIn=11]="NotIn",I[I.Greater=12]="Greater",I[I.GreaterEquals=13]="GreaterEquals",I[I.Smaller=14]="Smaller",I[I.SmallerEquals=15]="SmallerEquals"})(f=e.ContextKeyExprType||(e.ContextKeyExprType={}));class g{static false(){return d.INSTANCE}static true(){return y.INSTANCE}static has(u){return b.create(u)}static equals(u,P){return a.create(u,P)}static notEquals(u,P){return p.create(u,P)}static regex(u,P){return n.create(u,P)}static in(u,P){return C.create(u,P)}static not(u){return w.create(u)}static and(...u){return c.create(u)}static or(...u){return s.create(u)}static greater(u,P){return v.create(u,P)}static less(u,P){return i.create(u,P)}static deserialize(u,P=!1){if(!!u)return this._deserializeOrExpression(u,P)}static _deserializeOrExpression(u,P){let _=u.split("||");return s.create(_.map(q=>this._deserializeAndExpression(q,P)))}static _deserializeAndExpression(u,P){let _=u.split("&&");return c.create(_.map(q=>this._deserializeOne(q,P)))}static _deserializeOne(u,P){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return p.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("==")>=0){let _=u.split("==");return a.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("=~")>=0){let _=u.split("=~");return n.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return C.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return o.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return v.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return i.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?w.create(u.substr(1).trim()):b.create(u)}static _deserializeValue(u,P){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,P){if((0,m.isFalsyOrWhitespace)(u)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),q=u.lastIndexOf("/");if(_===q||_<0){if(P)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let W=u.slice(_+1,q),N=u[q+1]==="i"?"i":"";try{return new RegExp(W,N)}catch($){if(P)throw new Error(`bad regexp-value '${u}', parse error: ${$}`);return console.warn(`bad regexp-value '${u}', parse error: ${$}`),null}}}e.ContextKeyExpr=g;function D(I,u){return I.cmp(u)}class d{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class y{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class b{constructor(u){this.key=u,this.type=2}static create(u){const P=T.get(u);return typeof P=="boolean"?P?y.INSTANCE:d.INSTANCE:new b(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=b;class a{constructor(u,P){this.key=u,this.value=P,this.type=4}static create(u,P){if(typeof P=="boolean")return P?b.create(u):w.create(u);const _=T.get(u);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:d.INSTANCE:new a(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class C{constructor(u,P){this.key=u,this.valueKey=P,this.type=10}static create(u,P){return new C(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const P=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?L.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=C;class E{constructor(u){this._actual=u,this.type=11}static create(u){return new E(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new E(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class p{constructor(u,P){this.key=u,this.value=P,this.type=5}static create(u,P){if(typeof P=="boolean")return P?w.create(u):b.create(u);const _=T.get(u);return typeof _=="boolean"?P===(_?"true":"false")?d.INSTANCE:y.INSTANCE:new p(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class w{constructor(u){this.key=u,this.type=3}static create(u){const P=T.get(u);return typeof P=="boolean"?P?d.INSTANCE:y.INSTANCE:new w(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=w;class v{constructor(u,P){this.key=u,this.value=P,this.type=12}static create(u,P){return new v(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class o{constructor(u,P){this.key=u,this.value=P,this.type=13}static create(u,P){return new o(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class i{constructor(u,P){this.key=u,this.value=P,this.type=14}static create(u,P){return new i(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=i;class t{constructor(u,P){this.key=u,this.value=P,this.type=15}static create(u,P){return new t(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(u,P){this.key=u,this.regexp=P,this.type=7}static create(u,P){return new n(u,P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return P<_?-1:P>_?1:0}equals(u){if(u.type===this.type){const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&P===_}return!1}evaluate(u){let P=u.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class c{constructor(u){this.expr=u,this.type=6}static create(u){return c._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const q=D(this.expr[P],u.expr[P]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(u))return!1;return!0}static _normalizeArr(u){const P=[];let _=!1;for(const q of u)if(!!q){if(q.type===1){_=!0;continue}if(q.type===0)return d.INSTANCE;if(q.type===6){P.push(...q.expr);continue}P.push(q)}if(P.length===0&&_)return y.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(D);P.length>1;){const q=P[P.length-1];if(q.type!==9)break;P.pop();const W=P.pop(),N=s.create(q.expr.map($=>c.create([$,W])));N&&(P.push(N),P.sort(D))}return P.length===1?P[0]:new c(P)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new c(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let P of this.expr)u.push(P.negate());return s.create(u)}}e.ContextKeyAndExpr=c;class s{constructor(u){this.expr=u,this.type=9}static create(u){const P=s._normalizeArr(u);if(P.length!==0)return P.length===1?P[0]:new s(P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const q=D(this.expr[P],u.expr[P]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(u))return!0;return!1}static _normalizeArr(u){let P=[],_=!1;if(u){for(let q=0,W=u.length;q<W;q++){const N=u[q];if(!!N){if(N.type===0){_=!0;continue}if(N.type===1)return[y.INSTANCE];if(N.type===9){P=P.concat(N.expr);continue}P.push(N)}}if(P.length===0&&_)return[d.INSTANCE];P.sort(D)}return P}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new s(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),q=u.shift(),W=[];for(const N of P(_))for(const $ of P(q))W.push(g.and(N,$));u.unshift(g.or(...W))}return u[0]}}e.ContextKeyOrExpr=s;class l extends b{constructor(u,P,_){super(u);this.key=u,this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&l._info.push({key:u,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return g.not(this.key)}isEqualTo(u){return g.equals(this.key,u)}notEqualsTo(u){return g.notEquals(this.key,u)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(I,u){return I<u?-1:I>u?1:0}function S(I,u,P,_){return I<P?-1:I>P?1:u<_?-1:u>_?1:0}}),define(Q[69],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function A(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=A}),define(Q[70],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Q[10],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(G,e){return function(m,A){e(m,A,G)}};define(Q[141],Z([0,1,10,8,23,11,2,6]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let f=class extends T.Disposable{constructor(D){super();this.environmentService=D,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let D=setTimeout(()=>{D=void 0;const d=(0,A.basename)(this.environmentService.logsPath),y=(0,A.dirname)(this.environmentService.logsPath);(0,O.readdir)(y).then(b=>{const C=b.filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter((p,w)=>p!==d),E=C.slice(0,Math.max(0,C.length-9));return L.Promises.settled(E.map(p=>(0,O.rimraf)((0,A.join)(y,p))))}).then(null,R.onUnexpectedError)},10*1e3);this._register((0,T.toDisposable)(()=>{D&&(clearTimeout(D),D=void 0)}))}};f=ue([Y(0,m.IEnvironmentService)],f),e.LogsDataCleaner=f}),define(Q[142],Z([0,1,27,10,8,23,11,2]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let f=class at extends L.Disposable{constructor(D,d){super();this.backupWorkspacesPath=D,this.environmentService=d,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let D=setTimeout(()=>{D=void 0,(async()=>{try{const d=await m.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(d).emptyWorkspaceInfos.map(E=>E.backupFolder),a=await(0,R.readdir)(this.environmentService.workspaceStorageHome.fsPath),C=[];a.forEach(E=>{E.length!==at.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(E)===-1&&C.push((0,R.rimraf)((0,O.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}),await Promise.all(C)}catch(d){(0,T.onUnexpectedError)(d)}})()},30*1e3);this._register((0,L.toDisposable)(()=>{D&&(clearTimeout(D),D=void 0)}))}};f.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,f=ue([Y(1,A.INativeEnvironmentService)],f),e.StorageDataCleaner=f}),define(Q[29],Z([0,1,108,4,16]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var L;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(L=e.SortOrder||(e.SortOrder={}));var f;(function(d){d.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class D extends Error{constructor(y,b){super(y);this.code=b}}e.ExtensionManagementError=D,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(Q[143],Z([0,1,2,29]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let O=class extends m.Disposable{constructor(T){super();this.extensionManagementService=T,this._register(T),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};O=ue([Y(0,A.IExtensionManagementService)],O),e.DeprecatedExtensionsCleaner=O}),define(Q[71],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var A;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(A=e.RecommendationSource||(e.RecommendationSource={}));function O(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=O;var R;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,m.createDecorator)("IExtensionRecommendationNotificationService")}),define(Q[72],Z([0,1,21,4]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function O(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class T{constructor(D){this.value=D,this._lower=D.toLowerCase()}static equals(D,d){if(typeof D=="undefined"||D===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof D=="string"||typeof d=="string"){let y=typeof D=="string"?D:D.value,b=typeof d=="string"?d:d.value;return m.equalsIgnoreCase(y,b)}return D._lower===d._lower}static toKey(D){return typeof D=="string"?D.toLowerCase():D._lower}}e.ExtensionIdentifier=T;function L(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function f(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=f,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[34],Z([0,1,21,72]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function O(b,a){return b.uuid&&a.uuid?b.uuid===a.uuid:b.id===a.id?!0:(0,m.compareIgnoreCase)(b.id,a.id)===0}e.areSameExtensions=O;class R{constructor(a,C){this.version=C,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof R?O(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=R;function T(b,a){return`${b}.${a}`}e.getExtensionId=T;function L(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=L;function f(b,a){return L(T(b,a))}e.getGalleryExtensionId=f;function g(b,a){const C=[],E=p=>{for(const w of C)if(w.some(v=>O(a(v),a(p))))return w;return null};for(const p of b){const w=E(p);w?w.push(p):C.push([p])}return C}e.groupByExtension=g;function D(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function d(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function y(b){const a=new Set;for(const C of b)C.malicious&&a.add(C.id.id);return a}e.getMaliciousExtensionsSet=y}),define(Q[144],Z([0,1,2,8,72,23]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(f,g){super();this.environmentService=f,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(g.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(Q[9],Z([0,1,115,8,5,4,21,17,37]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function g(N){return N.create===!0}e.isFileOpenForWriteOptions=g;var D;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var d;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=y;function b(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=b;function a(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function C(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=C;var E;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=p;function w(N,$){const V=new p(N.toString(),$);return o(V,$),V}e.createFileSystemProviderError=w;function v(N){return N||w((0,m.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=v;function o(N,$){return N.name=$?`${$} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=o;function i(N){if(!N)return E.Unknown;if(N instanceof p)return N.code;const $=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!$)return E.Unknown;switch($[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=i;function t(N){if(N instanceof h)return N.fileOperationResult;switch(i(N)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor($,V,B){this.resource=$,this.operation=V,this.target=B}isOperation($){return this.operation===$}}e.FileOperationEvent=r;var c;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class s{constructor($,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const B of $)switch(B.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(B.resource,B);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...B){var M,F,k,U,j,z;if(!$)return!1;const H=B.length>0;return!!((!H||B.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get($))||V.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr($)))||(!H||B.includes(0))&&(((k=this.updated)===null||k===void 0?void 0:k.get($))||V.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr($)))||(!H||B.includes(2))&&(((j=this.deleted)===null||j===void 0?void 0:j.findSubstr($))||V.includeChildren&&((z=this.deleted)===null||z===void 0?void 0:z.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const V=[],B=$===1?this.added:$===0?this.updated:this.deleted;if(B)for(const[,M]of B)V.push(M);return V}filter($){return new s(this.changes.filter(V=>$(V)),this.ignorePathCasing)}}e.FileChangesEvent=s;function l(N,$,V){return!N||!$||N===$||$.length>N.length?!1:($.charAt($.length-1)!==A.sep&&($+=A.sep),V?(0,T.startsWithIgnoreCase)(N,$):N.indexOf($)===0)}e.isParent=l;class h extends Error{constructor($,V,B){super($);this.fileOperationResult=V,this.options=B}static isFileOperationError($){return $ instanceof Error&&!(0,L.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=h;var S;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=u;async function P(N,$){if(!$.canHandleResource(O.URI.from({scheme:N.scheme})))return new Promise(V=>{const B=$.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===N.scheme&&M.added&&(B.dispose(),V())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,L.isNumber)($)||($=0),$<_.KB?(0,m.localize)(1,null,$.toFixed(0)):$<_.MB?(0,m.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,m.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,m.localize)(4,null,($/_.GB).toFixed(2)):(0,m.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var q;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function W(N){return{maxFileSize:N===0?300*_.MB:16*_.GB,maxHeapSize:N===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=W}),define(Q[145],Z([0,1,146,47,9]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(L){this.fileService=L}checksum(L){return new Promise(async(f,g)=>{const D=(0,m.createHash)("md5"),d=(await this.fileService.readFileStream(L)).value;(0,A.listenStream)(d,{onData:y=>D.update(y.buffer),onError:y=>g(y),onEnd:()=>f(D.digest("base64").replace(/=+$/,""))})})}};R=ue([Y(0,O.IFileService)],R),e.ChecksumService=R}),define(Q[73],Z([0,1,116,22,9,11]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(D,d,y,b,a,C){let E;try{await L(D,d,y,b,a,C)}catch(p){E=p}finally{E&&a.errorTransformer&&(E=a.errorTransformer(E)),typeof E!="undefined"&&y.error(E),y.end()}}e.readFileIntoStream=T;async function L(D,d,y,b,a,C){f(C);const E=await D.open(d,{create:!1});try{f(C);let p=0,w=0,v=a&&typeof a.length=="number"?a.length:void 0,o=A.VSBuffer.alloc(Math.min(a.bufferSize,typeof v=="number"?v:a.bufferSize)),i=a&&typeof a.position=="number"?a.position:0,t=0;do w=await D.read(E,i,o.buffer,t,o.byteLength-t),i+=w,t+=w,p+=w,typeof v=="number"&&(v-=w),t===o.byteLength&&(await y.write(b(o)),o=A.VSBuffer.alloc(Math.min(a.bufferSize,typeof v=="number"?v:a.bufferSize)),t=0);while(w>0&&(typeof v!="number"||v>0)&&f(C)&&g(p,a));if(t>0){let n=t;typeof v=="number"&&(n=Math.min(t,v)),y.write(b(o.slice(0,n)))}}catch(p){throw(0,O.ensureFileSystemProviderError)(p)}finally{await D.close(E)}}function f(D){if(D.isCancellationRequested)throw(0,R.canceled)();return!0}function g(D,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&D>d.limits.memory)throw(0,O.createFileSystemProviderError)((0,m.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&D>d.limits.size)throw(0,O.createFileSystemProviderError)((0,m.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[74],Z([0,1,5,9,7]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(f){return f.map(g=>({type:g.type,resource:m.URI.file(g.path)}))}e.toFileChanges=R;function T(f){const g=new L;for(const D of f)g.processEvent(D);return g.normalize()}e.normalizeFileChanges=T;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const D=this.mapPathToChange.get(g.path);if(D){const d=D.type,y=g.type;d===1&&y===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(D),1)):d===2&&y===1?D.type=0:d===1&&y===0||(D.type=y)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],D=[];return this.normalized.filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,y)=>d.path.length-y.path.length).filter(d=>D.some(y=>(0,A.isParent)(d.path,y,!O.isLinux))?!1:(D.push(d.path),!0)).concat(g)}}}),define(Q[147],Z([0,1,74,2,23,94,97,6,8]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends A.Disposable{constructor(d,y,b,a){super();this.path=d,this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=a,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:y}=await O.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(y)try{b=await(0,R.realpath)(b)}catch(a){if(this.onError(a),y.dangling)return}d.isDirectory()?this._register((0,T.watchFolder)(b,(a,C)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(C))})},a=>this.onError(a))):this._register((0,T.watchFile)(b,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,m.normalizeFileChanges)(y);this.verboseLogging&&b.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(Q[75],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...O){this._entries=new Map;for(let[R,T]of O)this.set(R,T)}set(O,R){const T=this._entries.get(O);return this._entries.set(O,R),T}has(O){return this._entries.has(O)}get(O){return this._entries.get(O)}}e.ServiceCollection=m}),define(Q[148],Z([0,1,11,138,50,4,75,6]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class g extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class D{constructor(a=new T.ServiceCollection,C=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=C,this._parent=E,this._services.set(R.IInstantiationService,this)}createChild(a){return new D(a,this._strict,this)}invokeFunction(a,...C){let E=y.traceInvocation(a),p=!1;try{return a({get:(v,o)=>{if(p)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(v,E);if(!i&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...C)}finally{p=!0,E.stop()}}createInstance(a,...C){let E,p;return a instanceof O.SyncDescriptor?(E=y.traceCreation(a.ctor),p=this._createInstance(a.ctor,a.staticArguments.concat(C),E)):(E=y.traceCreation(a),p=this._createInstance(a,C,E)),E.stop(),p}_createInstance(a,C=[],E){let p=R._util.getServiceDependencies(a).sort((o,i)=>o.index-i.index),w=[];for(const o of p){let i=this._getOrCreateServiceInstance(o.id,E);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);w.push(i)}let v=p.length>0?p[0].index:C.length;if(C.length!==v){console.warn(`[createInstance] First service dependency of ${a.name} at position ${v+1} conflicts with ${C.length} static arguments`);let o=v-C.length;o>0?C=C.concat(new Array(o)):C=C.slice(0,v)}return new a(...[...C,...w])}_setServiceInstance(a,C){if(this._services.get(a)instanceof O.SyncDescriptor)this._services.set(a,C);else if(this._parent)this._parent._setServiceInstance(a,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let C=this._services.get(a);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):C}_getOrCreateServiceInstance(a,C){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,C.branch(a,!0)):(C.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,C,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,C,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,C,E){const p=new A.Graph(o=>o.id.toString());let w=0;const v=[{id:a,desc:C,_trace:E}];for(;v.length;){const o=v.pop();if(p.lookupOrInsertNode(o),w++>1e3)throw new g(p);for(let i of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(i.id);if(!t&&!i.optional&&console.warn(`[createInstance] ${a} depends on ${i.id} which is NOT registered.`),t instanceof O.SyncDescriptor){const n={id:i.id,desc:t,_trace:o._trace.branch(i.id,!0)};p.insertEdge(o,n),v.push(n)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof O.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}p.removeNode(i)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,C,E=[],p,w){if(this._services.get(a)instanceof O.SyncDescriptor)return this._createServiceInstance(C,E,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,C,E,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(a,C=[],E,p){if(E){const w=new L.IdleValue(()=>this._createInstance(a,C,p));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let i=w.value,t=i[o];return typeof t!="function"||(t=t.bind(i),v[o]=t),t},set(v,o,i){return w.value[o]=i,!0}})}else return this._createInstance(a,C,p)}}e.InstantiationService=D;var d;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(d||(d={}));class y{constructor(a,C){this.type=a,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return f?new y(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(a){return f?new y(0,a.name):y._None}branch(a,C){let E=new y(2,a.toString());return this._dep.push([a,C,E]),E}stop(){let a=Date.now()-this._start;y._totals+=a;let C=!1;function E(w,v){let o=[],i=new Array(w+1).join("	");for(const[t,n,r]of v._dep)if(n&&r){C=!0,o.push(`${i}CREATES -> ${t}`);let c=E(w+1,r);c&&o.push(c)}else o.push(`${i}uses -> ${t}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(a>2||C)&&console.log(p.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Q[149],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class m{constructor(O,R){this.server=O,this.router=R}getChannel(O){return this.server.getChannel(O,this.router)}registerChannel(O,R){this.server.registerChannel(O,R)}}e.MessagePortMainProcessService=m}),define(Q[150],Z([0,1,33,50,137,4]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(b,a,C){const E=C.getChannel(b);return L(a)?new a.channelClientCtor(E):m.ProxyChannel.toService(E,a==null?void 0:a.proxyOptions)}}function L(y){const b=y;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let f=class extends T{constructor(b,a,C){super(b,a,C)}};f=ue([Y(2,e.IMainProcessService)],f);function g(y,b,a){(0,O.registerSingleton)(y,new A.SyncDescriptor(f,[b,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=g,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let D=class extends T{constructor(b,a,C){super(b,a,C)}};D=ue([Y(2,e.ISharedProcessService)],D);function d(y,b,a){(0,O.registerSingleton)(y,new A.SyncDescriptor(D,[b,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=d}),define(Q[54],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,m.createDecorator)("localizationsService");function A(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const R of O.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}e.isValidLocalization=A}),define(Q[151],Z([0,1,2,54]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let O=class extends m.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};O=ue([Y(0,A.ILocalizationsService)],O),e.LocalizationsUpdater=O}),define(Q[15],Z([0,1,4,2,7,3,43]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function L(){return new Date().toISOString()}var f;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class g extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class D extends g{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...t]))}debug(i,...t){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...t]))}info(i,...t){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...t]))}warn(i,...t){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...t]))}error(i,...t){if(this.checkLogLevel(f.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([i,...t]))}critical(i,...t){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...t]))}flush(){}format(i){let t="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}t+=(n>0?" ":"")+r}return t}}e.AbstractMessageLogger=D;class d extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!O.isWindows}trace(i,...t){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}debug(i,...t){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}info(i,...t){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}warn(i,...t){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,i,...t):console.warn(`[main ${L()}]`,i,...t))}error(i,...t){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,i,...t):console.error(`[main ${L()}]`,i,...t))}critical(i,...t){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,i,...t):console.error(`[main ${L()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class y extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=y;class b extends g{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,T.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class a extends g{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const n of this.logServices)n.trace(i,...t)}debug(i,...t){for(const n of this.logServices)n.debug(i,...t)}info(i,...t){for(const n of this.logServices)n.info(i,...t)}warn(i,...t){for(const n of this.logServices)n.warn(i,...t)}error(i,...t){for(const n of this.logServices)n.error(i,...t)}critical(i,...t){for(const n of this.logServices)n.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class C extends A.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=C;class E{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=E;function p(o){if(o.verbose)return f.Trace;if(typeof o.logLevel=="string"){const i=w(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function w(o){switch(o){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=w;function v(o){switch(o){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=v}),define(Q[152],Z([0,1,27,2,9,29,10,5,12,34,15,31,55,7,6]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends A.Disposable{constructor(w,v,o,i){super();this.fileService=v,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=L.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,v){await this.cleanUpPromise;const o=this.getName(w),i=(0,f.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const t=(0,f.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(w,t,v),await this.rename(t,i,Date.now()+2*60*1e3)}return i}async delete(w){}async rename(w,v,o){try{await m.promises.rename(w.fsPath,v.fsPath)}catch(i){if(b.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${w} to ${v} with 'EPERM' error. Trying again...`),this.rename(w,v,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const v=[],o=[];for(const n of w.children){const r=this.parse(n.name);r&&o.push([r,n])}const i=(0,g.groupByExtension)(o,([n])=>n),t=[];for(const n of i)n.sort((r,c)=>y.rcompare(r[0].version,c[0].version)),v.push(...n.slice(1).map(r=>r[1].resource)),t.push(n[0][1]);t.sort((n,r)=>n.mtime-r.mtime),v.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(v.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?new g.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase():(0,d.generateUuid)()}parse(w){const v=C.exec(w);return v&&v[1]&&v[2]?new g.ExtensionIdentifierWithVersion({id:v[1]},v[2]):null}};E=ue([Y(0,T.INativeEnvironmentService),Y(1,O.IFileService),Y(2,R.IExtensionGalleryService),Y(3,D.ILogService)],E),e.ExtensionsDownloader=E}),define(Q[153],Z([0,1,2,15,48,43,8,6,3,16,23,10]),function(G,e,m,A,O,R,T,L,f,g,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends m.Disposable{constructor(a,C){super();this.environmentService=a,this.logService=C,this.processesLimiter=new L.Limiter(5)}async postUninstall(a){const C=this.parseScript(a,"uninstall");return C&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${E}`)))),(0,D.rimraf)(this.getExtensionStoragePath(a)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(a,C){const E=`vscode:${C}`;if(a.location.scheme===g.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[E]=="string"){const p=a.manifest.scripts[E].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${E} should be a node script`),null):{script:(0,T.join)(a.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(a,C,E,p,w){return new Promise((v,o)=>{const i=this.start(a,C,E,w);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?o(r):v(void 0)};i.on("error",r=>{n((0,R.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,c)=>{n(r?`post-${C} process exited with code ${r}`:void 0)}),p&&(t=setTimeout(()=>{t=null,i.kill(),o("timed out")},5e3))})}start(a,C,E,p){const w={silent:!0,execArgv:void 0},v=(0,O.fork)(a,[`--type=extension-post-${C}`,...E],w);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=f.Event.fromNodeEventEmitter(v.stdout,"data"),i=f.Event.fromNodeEventEmitter(v.stderr,"data");o(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${C}`,r)),i(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${C}`,r));const t=f.Event.any(f.Event.map(o,r=>({data:`%c${r}`,format:[""]})),f.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return f.Event.debounce(t,(r,c)=>r?{data:r.data+c.data,format:[...r.format,...c.format]}:{data:c.data,format:c.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),v}getExtensionStoragePath(a){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};y=ue([Y(0,d.IEnvironmentService),Y(1,A.ILogService)],y),e.ExtensionsLifecycle=y}),define(Q[154],Z([0,1,114,155,2,9,3,12,37,18,15,22,47,6,30,16,73,52]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends O.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const t=new O.DisposableStore;return t.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new R.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),t.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&t.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,O.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,O.dispose)(t)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){i.push(t)}}),!this.provider.has(o)&&await b.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,L.isAbsolutePath)(o))throw new R.FileOperationError((0,m.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,o.toString()),t}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)||(0,R.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(t){throw(0,R.toFileSystemProviderErrorCode)(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,m.localize)(2,null,this.resourceForError(o)),1):(0,R.ensureFileSystemProviderError)(t)}}async doResolveFile(o,i){const t=await this.withProvider(o),n=this.isPathCaseSensitive(t),r=i==null?void 0:i.resolveTo,c=i==null?void 0:i.resolveSingleChildDescendants,s=i==null?void 0:i.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!s,(S,I)=>(h||(h=f.TernarySearchTree.forUris(()=>!n),h.set(o,!0),(0,g.isNonEmptyArray)(r)&&r.forEach(u=>h.set(u,!0))),Boolean(h.findSuperstr(S.resource)||h.get(S.resource))?!0:S.isDirectory&&c?I===1:!1))}async toFileStat(o,i,t,n,r,c){const{providerExtUri:s}=this.getExtUri(o),l={resource:i,name:s.basename(i),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,R.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&c(l,n)){try{const h=await o.readdir(i),S=await b.Promises.settled(h.map(async([I,u])=>{try{const P=s.joinPath(i,I),_=r?await o.stat(P):{type:u};return await this.toFileStat(o,P,_,h.length,r,c)}catch(P){return this.logService.trace(P),null}}));l.children=(0,g.coalesce)(S)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return b.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(t){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(t){return t}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new R.FileOperationError((0,m.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=d.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,n)),n}async writeFile(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,o,t)||await this.mkdirp(n,r.dirname(o));let s;if((0,R.hasReadWriteCapability)(n)&&!(i instanceof d.VSBuffer))if((0,y.isReadableStream)(i)){const l=await(0,y.peekStream)(i,3);l.ended?s=d.VSBuffer.concat(l.buffer):s=l}else s=(0,y.peekReadable)(i,l=>d.VSBuffer.concat(l),3);else s=i;!(0,R.hasOpenReadWriteCloseCapability)(n)||(0,R.hasReadWriteCapability)(n)&&s instanceof d.VSBuffer?await this.doWriteUnbuffered(n,o,t,s):await this.doWriteBuffered(n,o,t,s instanceof d.VSBuffer?(0,d.bufferToReadable)(s):s)}catch(c){throw new R.FileOperationError((0,m.localize)(4,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let r;try{r=await o.stat(i)}catch(c){return}if((r.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,R.etag)({mtime:t.mtime,size:r.size}))throw new R.FileOperationError((0,m.localize)(7,null),3,t);return r}async readFile(o,i){const t=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(t,o,i):this.doReadFile(t,o,i)}async doReadFileAtomic(o,i,t){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(o,i,t);n(c)}catch(c){r(c)}})})}async doReadFile(o,i,t){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,d.streamToBuffer)(n.value)})}async readFileStream(o,i){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,i)}async doReadFileStream(o,i,t){const n=new a.CancellationTokenSource,r=this.validateReadFile(i,t).then(s=>s,s=>{throw n.cancel(),s});let c;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await r,!((0,R.hasOpenReadWriteCloseCapability)(o)||(0,R.hasFileReadStreamCapability)(o))||(0,R.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(o,i,t):(0,R.hasFileReadStreamCapability)(o)?c=this.readFileStreamed(o,i,n.token,t):c=this.readFileBuffered(o,i,n.token,t);const s=await r;return Object.assign(Object.assign({},s),{value:c})}catch(s){throw c&&await(0,y.consumeStream)(c),new R.FileOperationError((0,m.localize)(8,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),t)}}readFileStreamed(o,i,t,n=Object.create(null)){const r=o.readFileStream(i,n,t);return(0,y.transform)(r,{data:c=>c instanceof d.VSBuffer?c:d.VSBuffer.wrap(c),error:c=>new R.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)},c=>d.VSBuffer.concat(c))}readFileBuffered(o,i,t,n=Object.create(null)){const r=(0,d.newWriteableBufferStream)();return(0,E.readFileIntoStream)(o,i,r,c=>c,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new R.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)}),t),r}readFileUnbuffered(o,i,t){const n=(0,y.newWriteableStream)(r=>d.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(i);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(i,r.byteLength,t),n.end(d.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(o,i){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError((0,m.localize)(11,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==R.ETAG_DISABLED&&i.etag===t.etag)throw new R.FileOperationError((0,m.localize)(12,null),2,i);return this.validateReadFileLimits(o,t.size,i),t}validateReadFileLimits(o,i,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&i>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&i>t.limits.size&&(n=7),typeof n=="number")throw new R.FileOperationError((0,m.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,i,t){return this.doCanMoveCopy(o,i,"move",t)}async canCopy(o,i,t){return this.doCanMoveCopy(o,i,"copy",t)}async doCanMoveCopy(o,i,t,n){if(o.toString()!==i.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,o,c,i,t,n)}catch(r){return r}return!0}async move(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"move",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="move"?2:3,s)),s}async copy(o,i,t){const n=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"copy",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="copy"?3:2,s)),s}async doMoveCopy(o,i,t,n,r,c){if(i.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,i,t,n,r,c);if(s&&!l&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(o===t&&(0,R.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:c});else{const h=await this.resolve(i);h.isDirectory?await this.doCopyFolder(o,h,t,n):await this.doCopyFile(o,i,t,n)}return r}else return o===t?(await o.rename(i,n,{overwrite:c}),r):(await this.doMoveCopy(o,i,t,n,"copy",c),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,t,n){if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,i,t,n);if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,i,t,n)}async doCopyFolder(o,i,t,n){await t.mkdir(n),Array.isArray(i.children)&&await b.Promises.settled(i.children.map(async r=>{const c=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,c):this.doCopyFile(o,r.resource,t,c)}))}async doValidateMoveCopy(o,i,t,n,r,c){let s=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(s=h.isEqual(i,n)),s&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&h.isEqualOrParent(n,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!s){if(!c)throw new R.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(i,n))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,t)),t}async mkdirp(o,i){const t=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&R.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,R.toFileSystemProviderErrorCode)(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(i)),i=n.dirname(i)}for(let r=t.length-1;r>=0;r--){i=n.joinPath(i,t[r]);try{await o.mkdir(i)}catch(c){if((0,R.toFileSystemProviderErrorCode)(c)!==R.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(t){return t}return!0}async doValidateDelete(o,i){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(o)));const r=await this.exists(o);if(!r)throw new R.FileOperationError((0,m.localize)(20,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&r){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(o)))}return t}async del(o,i){const t=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await t.delete(o,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new R.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(o,i).then(r=>{t?(0,O.dispose)(r):n=()=>(0,O.dispose)(r)},r=>this.logService.error(r)),(0,O.toDisposable)(()=>n())}async doWatch(o,i){const t=await this.withProvider(o),n=this.toWatchKey(t,o,i),r=this.activeWatchers.get(n)||{count:0,disposable:t.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,O.toDisposable)(()=>{r.count--,r.count===0&&((0,O.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,t){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,O.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{var r;const c=await o.open(i,{create:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,c,n):await this.doWriteReadableBufferedQueued(o,c,n)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await o.close(c)}})}async doWriteStreamBufferedQueued(o,i,t){let n=0,r;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=d.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,i,c,c.byteLength,n,0),n+=c.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(c,s)=>{(0,y.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(o,i,l,l.byteLength,n,0)}catch(h){return s(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>s(l),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(o,i,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(o,i,t,n,r,c){let s=0;for(;s<n;)s+=await o.write(i,r+s,t.buffer,c+s,n-s)}async doWriteUnbuffered(o,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,t,n))}async doWriteUnbufferedQueued(o,i,t,n){var r;let c;n instanceof d.VSBuffer?c=n:(0,y.isReadableStream)(n)?c=await(0,d.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?c=await(0,d.bufferedStreamToBuffer)(n):c=(0,d.readableToBuffer)(n),await o.writeFile(i,c.buffer,{create:!0,overwrite:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,t,n))}async doPipeBufferedQueued(o,i,t,n){let r,c;try{r=await o.open(i,{create:!1}),c=await t.open(n,{create:!0,unlock:!1});const s=d.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,S=0;do S=await o.read(r,l,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(t,c,s,S,l,h),l+=S,h+=S,h===s.byteLength&&(h=0);while(S>0)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await b.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,t,n))}async doPipeUnbufferedQueued(o,i,t,n){return t.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,t,n))}async doPipeUnbufferedToBufferedQueued(o,i,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const c=await o.readFile(i);await this.doWriteBuffer(t,r,d.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,i,t,n){const r=await(0,d.streamToBuffer)(this.readFileBuffered(o,i,a.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,r)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new R.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};w=ue([Y(0,D.ILogService)],w),e.FileService=w}),define(Q[156],Z([0,1,27,95,2,9,3,7,23,8,12,42,6,15,117,74,134,136,133,147,47,73,18,22]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends O.Disposable{constructor(s,l){var h;super();this.logService=s,this.options=l,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:h}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,h),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await(0,f.readdir)(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(l.map(async S=>{try{let I;S.isSymbolicLink()?I=(await this.stat((0,D.joinPath)(s,S.name))).type:I=this.toType(S),h.push([S.name,I])}catch(I){this.logService.trace(I)}})),h}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let h;return(l==null?void 0:l.dangling)?h=R.FileType.Unknown:s.isFile()?h=R.FileType.File:s.isDirectory()?h=R.FileType.Directory:h=R.FileType.Unknown,l&&(h|=R.FileType.SymbolicLink),h}async readFile(s){try{const l=this.toFilePath(s);return await m.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,h){const S=(0,o.newWriteableStream)(I=>n.VSBuffer.concat(I.map(u=>n.VSBuffer.wrap(u))).buffer);return(0,i.readFileIntoStream)(this,s,S,I=>I.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),h),S}async writeFile(s,l,h){let S;try{const I=this.toFilePath(s);if(!h.create||!h.overwrite){if(await(0,f.exists)(I)){if(!h.overwrite)throw(0,R.createFileSystemProviderError)((0,a.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,R.createFileSystemProviderError)((0,a.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(S,0,l,0,l.byteLength)}catch(I){throw await this.toFileSystemProviderWriteError(s,I)}finally{typeof S=="number"&&await this.close(S)}}async open(s,l){try{const h=this.toFilePath(s);if((0,R.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(h);u.mode&128||await m.promises.chmod(h,u.mode|128)}catch(u){this.logService.trace(u)}let S;if((0,R.isFileOpenForWriteOptions)(l)){if(L.isWindows)try{await m.promises.truncate(h,0),S="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}S||(S="w")}else S="r";const I=await(0,A.promisify)(m.open)(h,S);return this.mapHandleToPos.set(I,0),(0,R.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(I,s),I}catch(h){throw(0,R.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await(0,A.promisify)(m.fdatasync)(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,A.promisify)(m.close)(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,h,S,I){const u=this.normalizePos(s,l);let P=null;try{const _=await(0,A.promisify)(m.read)(s,h,S,I,u);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,u,P)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,h){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof l=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,S+h):this.mapHandleToPos.delete(s)))}async write(s,l,h,S,I){return(0,y.retry)(()=>this.doWrite(s,l,h,S,I),100,3)}async doWrite(s,l,h,S,I){const u=this.normalizePos(s,l);let P=null;try{const _=await(0,A.promisify)(m.write)(s,h,S,I,u);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),_)}finally{this.updatePos(s,u,P)}}async mkdir(s){try{await m.promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const h=this.toFilePath(s);await this.doDelete(h,l)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,l){l.recursive?await(0,f.rimraf)(s,f.RimRafMode.MOVE):await m.promises.unlink(s)}async rename(s,l,h){const S=this.toFilePath(s),I=this.toFilePath(l);if(S!==I)try{await this.validateTargetDeleted(s,l,"move",h.overwrite),await(0,f.move)(S,I)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(2,null,(0,g.basename)(S),(0,g.basename)((0,g.dirname)(I)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,l,h){const S=this.toFilePath(s),I=this.toFilePath(l);if(S!==I)try{await this.validateTargetDeleted(s,l,"copy",h.overwrite),await(0,f.copy)(S,I,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(3,null,(0,g.basename)(S),(0,g.basename)((0,g.dirname)(I)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,l,h,S){const I=this.toFilePath(s),u=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,d.isEqual)(I,u,!0)),P&&h==="copy")throw(0,R.createFileSystemProviderError)((0,a.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,f.exists)(u)){if(!S)throw(0,R.createFileSystemProviderError)((0,a.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const h={path:this.toFilePath(s),excludes:l},S=(0,t.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,O.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,l,h;if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,O.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let S,I;((l=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||l===void 0?void 0:l.usePolling)?(S=E.FileWatcher,I=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?S=p.FileWatcher:S=E.FileWatcher:S=w.FileWatcher,this.recursiveWatcher=new S(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,C.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===b.LogLevel.Trace,I),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new v.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,C.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,O.combinedDisposable)(l,h)}toFilePath(s){return(0,g.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof R.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=R.FileSystemProviderErrorCode.NoPermissions;break;default:l=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let h=this.toFileSystemProviderError(l);if(s&&h.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(h=(0,R.createFileSystemProviderError)(l,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return h}dispose(){super.dispose(),(0,O.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,O.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Q[157],Z([0,1,23,27,146,29,2,10,6,34,15,54,18,3,16,8]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let E=class extends T.Disposable{constructor(v,o,i){super();this.extensionManagementService=v,this.logService=i,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new p(o,i)),this._register(v.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(v.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(v=>{const o=["en",...Object.keys(v)];return(0,y.distinct)(o)})}onDidInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",v.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(v){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(t=>(0,g.areSameExtensions)(t.extensionIdentifier,v)))&&(this.logService.debug("Removing language packs from the extension",v.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[v,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,y.equals)(Object.keys(v),Object.keys(i))}};E=ue([Y(0,R.IExtensionManagementService),Y(1,L.INativeEnvironmentService),Y(2,D.ILogService)],E),e.LocalizationsService=E;let p=class extends T.Disposable{constructor(v,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,i);Object.keys(v).forEach(i=>this.updateHash(v[i]))}createLanguagePacksFromExtension(v,o){const i=o.identifier,t=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of t)if(o.location.scheme===a.Schemas.file&&(0,d.isValidLocalization)(n)){let r=v[n.languageId];r||(r={hash:"",extensions:[],translations:{}},v[n.languageId]=r);let c=r.extensions.filter(s=>(0,g.areSameExtensions)(s.extensionIdentifier,i))[0];c?c.version=o.manifest.version:r.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,C.join)(o.location.fsPath,s.path)}}updateHash(v){if(v){const o=(0,O.createHash)("md5");for(const i of v.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);v.hash=o.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return A.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(t){return{}}}).then(i=>(o=v(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,m.writeFile)(this.languagePacksFilePath,t)}).then(()=>o,i=>this.logService.error(i))})}};p=ue([Y(0,L.INativeEnvironmentService),Y(1,D.ILogService)],p)}),define(Q[158],Z([0,1,15]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(R,T){switch(T){case m.LogLevel.Trace:return R.trace;case m.LogLevel.Debug:return R.debug;case m.LogLevel.Info:return R.info;case m.LogLevel.Warning:return R.warn;case m.LogLevel.Error:return R.error;case m.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class O extends m.AbstractLogger{constructor(T=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(T),this._register(this.onDidChangeLogLevel(L=>{this._logger&&this._logger.setLevel(L)}))}set logger(T){this._logger=T;for(const{level:L,args:f}of this.buffer)A(T,L).apply(T,f);this.buffer=[]}_log(T,...L){this._logger?A(this._logger,T).apply(this._logger,L):this.getLevel()<=T&&this.buffer.push({level:T,args:L})}trace(T,...L){this._log(m.LogLevel.Trace,T,...L)}debug(T,...L){this._log(m.LogLevel.Debug,T,...L)}info(T,...L){this._log(m.LogLevel.Info,T,...L)}warn(T,...L){this._log(m.LogLevel.Warning,T,...L)}error(T,...L){this._log(m.LogLevel.Error,T,...L)}critical(T,...L){this._log(m.LogLevel.Critical,T,...L)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=O}),define(Q[159],Z([0,1,15,9,6,22,12,2,4,158]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const D=5*A.ByteSize.MB;let d=class extends m.AbstractLogger{constructor(a,C,E,p){super();this.name=a,this.resource=C,this.fileService=p,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new O.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const a=arguments[0];if(a instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=a.stack,this._log(m.LogLevel.Error,this.format(C))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(a,C){this._log(a,this.format(C))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(a){if(a.fileOperationResult!==3)throw a}}_log(a,C){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>D&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(E)),E=""),E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(a)}] ${C}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(E))})}getCurrentTimestamp(){const a=p=>p<10?`0${p}`:p,C=p=>p<10?`00${p}`:p<100?`0${p}`:p,E=new Date;return`${E.getFullYear()}-${a(E.getMonth()+1)}-${a(E.getDate())} ${a(E.getHours())}:${a(E.getMinutes())}:${a(E.getSeconds())}.${C(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,T.joinPath)((0,T.dirname)(this.resource),`${(0,T.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(a){return""}}stringifyLogLevel(a){switch(a){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(a){let C="";for(let E=0;E<a.length;E++){let p=a[E];if(typeof p=="object")try{p=JSON.stringify(p)}catch(w){}C+=(E>0?" ":"")+p}return C}};d=ue([Y(3,A.IFileService)],d),e.FileLogger=d;let y=class extends L.Disposable{constructor(a,C,E){super();this.logService=a,this.instantiationService=C,this.fileService=E,this.loggers=new Map,this._register(a.onDidChangeLogLevel(p=>this.loggers.forEach(w=>w.setLevel(p))))}createLogger(a){let C=this.loggers.get(a.toString());return C||(C=new g.BufferLogService(this.logService.getLevel()),this.loggers.set(a.toString(),C),(0,A.whenProviderRegistered)(a,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(d,(0,T.basename)(a),a,this.logService.getLevel()))),C}dispose(){this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}};y=ue([Y(0,m.ILogService),Y(1,f.IInstantiationService),Y(2,A.IFileService)],y),e.FileLoggerService=y}),define(Q[76],Z([0,1,15,3,5]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=A.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(y,b,a){switch(b){case"setLevel":return this.service.setLevel(a)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=R;class T{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){T.setLevel(this.channel,y)}static setLevel(y,b){return y.call("setLevel",b)}}e.LogLevelChannelClient=T;class L{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,b){throw new Error(`Event not found: ${b}`)}async call(y,b,a){switch(b){case"createLogger":this.createLogger(O.URI.revive(a[0]),a[1]);return;case"log":return this.log(O.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1])}throw new Error(`Call not found: ${b}`)}createLogger(y,b){this.loggers.set(y.toString(),this.loggerService.createLogger(y,b))}consoleLog(y,b){let a=console.log;switch(y){case m.LogLevel.Error:a=console.error;break;case m.LogLevel.Warning:a=console.warn;break;case m.LogLevel.Info:a=console.info;break}a.call(console,...b)}log(y,b){const a=this.loggers.get(y.toString());if(!a)throw new Error("Create the logger before logging");for(const[C,E]of b)switch(C){case m.LogLevel.Trace:a.trace(E);break;case m.LogLevel.Debug:a.debug(E);break;case m.LogLevel.Info:a.info(E);break;case m.LogLevel.Warning:a.warn(E);break;case m.LogLevel.Error:a.error(E);break;case m.LogLevel.Critical:a.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=L;class f{constructor(y){this.channel=y}createConsoleMainLogger(){return new m.AdapterLogger({log:(y,b)=>{this.channel.call("consoleLog",[y,b])}})}createLogger(y,b){return new g(this.channel,y,b)}}e.LoggerChannelClient=f;class g extends m.AbstractMessageLogger{constructor(y,b,a){super(a==null?void 0:a.always);this.channel=y,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[b,a]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(y,b){this._log([[y,b]])}_log(y){this.isLoggerCreated?this.channel.call("log",[this.file,y]):this.buffer.push(...y)}}class D extends m.LogService{constructor(y,b){super(b);this.parent=y,this._register(y.onDidChangeLogLevel(a=>b.setLevel(a)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=D}),define(Q[77],Z([0,1,15,9]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function O(f,g,D,d){try{const y=await new Promise((b,a)=>{G(["spdlog"],b,a)});return y.setAsyncMode(8192,500),y.createRotatingLoggerAsync(f,g,D,d)}catch(y){console.error(y)}return null}function R(f,g,D,d){return G.__$__nodeRequire("spdlog").createRotatingLogger(f,g,D,d)}e.createRotatingLogger=R;function T(f,g,D){switch(g){case m.LogLevel.Trace:f.trace(D);break;case m.LogLevel.Debug:f.debug(D);break;case m.LogLevel.Info:f.info(D);break;case m.LogLevel.Warning:f.warn(D);break;case m.LogLevel.Error:f.error(D);break;case m.LogLevel.Critical:f.critical(D);break;default:throw new Error("Invalid log level")}}class L extends m.AbstractMessageLogger{constructor(g,D,d,y){super();this.name=g,this.filepath=D,this.rotating=d,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const g=this.rotating?6:1,D=30/g*A.ByteSize.MB;return O(this.name,this.filepath,D,g).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:y,message:b}of this.buffer)T(this._logger,y,b);this.buffer=[]}})}log(g,D){this._logger?T(this._logger,g,D):this.getLevel()<=g&&this.buffer.push({level:g,message:D})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=L}),define(Q[160],Z([0,1,15,2,12,16,159,77,9,31]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let D=class extends A.Disposable{constructor(y,b){super();this.logService=y,this.fileService=b,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(y.onDidChangeLogLevel(a=>this.logLevelChangeableLoggers.forEach(C=>C.setLevel(a))))}createLogger(y,b){var a;let C=this.loggers.get(y.toString());return C||(y.scheme===R.Schemas.file?(C=new L.SpdLogLogger((b==null?void 0:b.name)||(0,g.generateUuid)(),y.fsPath,!(b==null?void 0:b.donotRotate),this.logService.getLevel()),(b==null?void 0:b.donotUseFormatters)&&C.clearFormatters()):C=new T.FileLogger((a=b==null?void 0:b.name)!==null&&a!==void 0?a:(0,O.basename)(y),y,this.logService.getLevel(),this.fileService),this.loggers.set(y.toString(),C),(b==null?void 0:b.always)?C.setLevel(m.LogLevel.Trace):this.logLevelChangeableLoggers.push(C)),C}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(y=>y.dispose()),this.loggers.clear(),super.dispose()}};D=ue([Y(0,m.ILogService),Y(1,f.IFileService)],D),e.LoggerService=D}),define(Q[56],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,m.createDecorator)("nativeHostService")}),define(Q[57],Z([0,1,16,7,36,12]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(A.isWeb||typeof G=="undefined"||typeof G.__$__nodeRequire!="function")T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.55.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const L=(0,R.dirname)(m.FileAccess.asFileUri("",G));T=G.__$__nodeRequire((0,R.joinPath)(L,"product.json").fsPath);const f=G.__$__nodeRequire((0,R.joinPath)(L,"package.json").fsPath);O.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:f.version})}e.default=T}),define(Q[28],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(Q[161],Z([0,1,27,8,23,28,2,11,15,10]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends T.Disposable{constructor(y,b,a){super();this._environmentService=y,this._logService=b,this._productService=a,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),a=JSON.parse(await m.promises.readFile(A.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(a)){const v=a[w];b[`${v.hash}.${w}`]=!0}const C=A.join(this._environmentService.userDataPath,"clp");if(!await O.exists(C))return;for(let w of await O.readdir(C)){if(b[w]){this._logService.info(`Skipping directory ${w}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",w),await O.rimraf(A.join(C,w))}const p=Date.now();for(let w of Object.keys(b)){const v=A.join(C,w);for(let o of await O.readdir(v))if(o!=="tcf.json"){const i=A.join(v,o),t=await m.promises.stat(i);t.isDirectory()&&p-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",A.join(w,o)),await O.rimraf(i))}}}catch(b){(0,L.onUnexpectedError)(b)}},40*1e3);this._register((0,T.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};D=ue([Y(0,g.INativeEnvironmentService),Y(1,f.ILogService),Y(2,R.IProductService)],D),e.LanguagePackCachedDataCleaner=D}),define(Q[162],Z([0,1,27,8,11,2,23,28]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let f=class{constructor(D,d){this.nodeCachedDataDir=D,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new R.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const D=(0,A.dirname)(this.nodeCachedDataDir),d=(0,A.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,T.readdir)(D).then(b=>{const a=Date.now(),C=[];return b.forEach(E=>{if(E!==d){const p=(0,A.join)(D,E);C.push(m.promises.stat(p).then(w=>{if(w.isDirectory()&&a-w.mtime.getTime()>this._DataMaxAge)return(0,T.rimraf)(p)}))}}),Promise.all(C)}).then(void 0,O.onUnexpectedError)},30*1e3);this._disposables.add((0,R.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};f=ue([Y(1,L.IProductService)],f),e.NodeCachedDataCleaner=f}),define(Q[35],Z([0,1,17,85]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class O{constructor(){this.data=new Map}add(T,L){A.ok(m.isString(T)),A.ok(m.isObject(L)),A.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,L)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new O}),define(Q[78],Z([0,1,35,3]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function O(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class R{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,g){this.schemasById[O(f)]=g,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;m.Registry.add(e.Extensions.JSONContribution,T)}),define(Q[39],Z([0,1,107,3,35,17,78]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=O.Registry.as(T.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,w=!0){this.registerConfigurations([p],w)}registerConfigurations(p,w=!0){const v=[];p.forEach(o=>{v.push(...this.validateAndRegisterProperties(o,w)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(p){const w=[],v=o=>{if(o.properties)for(const i in o.properties)w.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>v(i))};for(const o of p){v(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(p){const w=[],v=[];for(const o of p)for(const i in o)if(w.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const t={type:"object",default:this.defaultValues[i],description:m.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};v.push(d(i)),this.configurationProperties[i]=t,this.defaultLanguageConfigurationOverridesNode.properties[i]=t}else{this.defaultValues[i]=o[i];const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(p){const w=[];for(const v of p)for(const o in v)if(w.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const w of p)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,w=!0,v=3){v=R.isUndefinedOrNull(p.scope)?v:p.scope;let o=[],i=p.properties;if(i)for(let n in i){if(w&&a(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),e.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=R.isUndefinedOrNull(r.scope)?v:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let t=p.allOf;if(t)for(let n of t)o.push(...this.validateAndRegisterProperties(n,w,v));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const w=v=>{let o=v.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let i=v.allOf;i&&i.forEach(w)};w(p)}updateSchema(p,w){switch(e.allSettings.properties[p]=w,w.scope){case 1:e.applicationSettings.properties[p]=w;break;case 2:e.machineSettings.properties[p]=w;break;case 6:e.machineOverridableSettings.properties[p]=w;break;case 3:e.windowSettings.properties[p]=w;break;case 4:e.resourceSettings.properties[p]=w;break;case 5:e.resourceSettings.properties[p]=w,this.resourceLanguageSettingsSchema.properties[p]=w;break}}removeFromSchema(p,w){switch(delete e.allSettings.properties[p],w.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const w=`[${p}]`,v={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,v),e.allSettings.properties[w]=v,e.applicationSettings.properties[w]=v,e.machineSettings.properties[w]=v,e.machineOverridableSettings.properties[w]=v,e.windowSettings.properties[w]=v,e.resourceSettings.properties[w]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,w){let v=this.defaultValues[p];R.isUndefined(v)&&(v=w.default),R.isUndefined(v)&&(v=y(w.type)),w.default=v}}const D="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(D);function d(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=d;function y(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const b=new g;O.Registry.add(e.Extensions.Configuration,b);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?m.localize(5,null,E):b.getConfigurationProperties()[E]!==void 0?m.localize(6,null,E):null:m.localize(4,null)}e.validateProperty=a;function C(){const E=[],p=b.getConfigurationProperties();for(const w of Object.keys(p))E.push([w,p[w].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=C}),define(Q[24],Z([0,1,26,17,5,35,4,39]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function f(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof O.URI)}e.isConfigurationOverrides=f;var g;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function d(n,r){const c=r?n?r.keys.filter(P=>n.keys.indexOf(P)===-1):[...r.keys]:[],s=n?r?n.keys.filter(P=>r.keys.indexOf(P)===-1):[...n.keys]:[],l=[];if(r&&n){for(const P of n.keys)if(r.keys.indexOf(P)!==-1){const _=p(n.contents,P),q=p(r.contents,P);m.equals(_,q)||l.push(P)}}const h=[],S=P=>{const _={};for(const q of P)for(const W of q.identifiers)_[i(W)]=q;return _},I=r?S(r.overrides):{},u=n?S(n.overrides):{};if(Object.keys(I).length)for(const P of c){const _=I[P];_&&h.push([(0,L.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(u).length)for(const P of s){const _=u[P];_&&h.push([(0,L.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(I).length&&Object.keys(u).length)for(const P of l){const _=u[P],q=I[P];if(_&&q){const W=d({contents:_.contents,keys:_.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});h.push([(0,L.overrideIdentifierFromKey)(P),[...W.added,...W.removed,...W.updated]])}}return{added:c,removed:s,updated:l,overrides:h}}e.compare=d;function y(n,r){const c=[];for(const s of Object.keys(n))if(L.OVERRIDE_PROPERTY_PATTERN.test(s)){const l={};for(const h in n[s])l[h]=n[s][h];c.push({identifiers:[(0,L.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(l),contents:b(l,r)})}return c}e.toOverrides=y;function b(n,r){const c=Object.create(null);for(let s in n)a(c,s,n[s],r);return c}e.toValuesTree=b;function a(n,r,c,s){const l=r.split("."),h=l.pop();let S=n;for(let I=0;I<l.length;I++){let u=l[I],P=S[u];switch(typeof P){case"undefined":P=S[u]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${l.slice(0,I+1).join(".")} is ${JSON.stringify(P)}`);return}S=P}if(typeof S=="object"&&S!==null)try{S[h]=c}catch(I){s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(S)}`)}else s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=a;function C(n,r){const c=r.split(".");E(n,c)}e.removeFromValueTree=C;function E(n,r){const c=r.shift();if(r.length===0){delete n[c];return}if(Object.keys(n).indexOf(c)!==-1){const s=n[c];typeof s=="object"&&!Array.isArray(s)&&(E(s,r),Object.keys(s).length===0&&delete n[c])}}function p(n,r,c){function s(S,I){let u=S;for(const P of I){if(typeof u!="object"||u===null)return;u=u[P]}return u}const l=r.split("."),h=s(n,l);return typeof h=="undefined"?c:h}e.getConfigurationValue=p;function w(n,r,c){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in n?A.isObject(n[s])&&A.isObject(r[s])?w(n[s],r[s],c):c&&(n[s]=r[s]):n[s]=r[s])})}e.merge=w;function v(){const n=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=v;function o(){const n=Object.create(null),r=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let c in r){let s=r[c].default;a(n,c,s,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=o;function i(n){return`[${n}]`}e.keyFromOverrideIdentifier=i;function t(n,r,c){const s=n.inspect(r),l=n.inspect(c);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:s.defaultValue}e.getMigratedSettingValue=t}),define(Q[163],Z([0,1,32,37,18,17,26,5,39,24,35,2,3]),function(G,e,m,A,O,R,T,L,f,g,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,g.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,g.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const c of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[c],l=n[c];l&&(typeof s=="object"&&typeof l=="object"?(s=T.deepClone(s),this.mergeContents(s,l)):s=l),r[c]=s}return new b(r,this.keys,this.overrides)}merge(...t){const n=T.deepClone(this.contents),r=T.deepClone(this.overrides),c=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const l of s.overrides){const[h]=r.filter(S=>O.equals(S.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):r.push(T.deepClone(l))}for(const l of s.keys)c.indexOf(l)===-1&&c.push(l)}return new b(n,c,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&R.isObject(t[r])&&R.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=T.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,g.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,g.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=b;class a extends b{constructor(){const t=(0,g.getDefaultValues)(),n=(0,g.getConfigurationKeys)(),r=[];for(const c of Object.keys(t))f.OVERRIDE_PROPERTY_PATTERN.test(c)&&r.push({identifiers:[(0,f.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(t[c]),contents:(0,g.toValuesTree)(t[c],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,r)}}e.DefaultConfigurationModel=a;class C{constructor(t,n){this._name=t,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get errors(){return this._parseErrors}parseContent(t){if(!R.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n)}}parseRaw(t){this._raw=t;const n=this.doParseRaw(t);this._configurationModel=new b(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let n={},r=null,c=[],s=[],l=[];function h(I){Array.isArray(c)?c.push(I):r&&(c[r]=I)}let S={onObjectBegin:()=>{let I={};h(I),s.push(c),c=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{let I=[];h(I),s.push(c),c=I,r=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:h,onError:(I,u,P)=>{l.push({error:I,offset:u,length:P})}};if(t)try{m.visit(t,S),n=c[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return n}doParseRaw(t){if(this._scopes){const s=D.Registry.as(f.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,s,!0,this._scopes)}const n=(0,g.toValuesTree)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),r=Object.keys(t),c=(0,g.toOverrides)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:n,keys:r,overrides:c}}filterByScope(t,n,r,c){const s={};for(let l in t)if(f.OVERRIDE_PROPERTY_PATTERN.test(l)&&r)s[l]=this.filterByScope(t[l],n,!1,c);else{const h=this.getScope(l,n);(h===void 0||c.indexOf(h)!==-1)&&(s[l]=t[l])}return s}getScope(t,n){const r=n[t];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}e.ConfigurationModelParser=C;class E extends d.Disposable{constructor(t,n,r,c){super();this.userSettingsResource=t,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(y.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new b}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=E;class p{constructor(t,n,r=new b,c=new b,s=new A.ResourceMap,l=new b,h=new A.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new b,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(t):c.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const c=this.getConsolidateConfigurationModel(n,r),s=this.getFolderConfigurationModelForResource(n.resource,r),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),I=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,q=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),W=c.getValue(t),N=O.distinct(O.flatten(c.overrides.map($=>$.identifiers))).filter($=>c.getOverrideValue(t,$)!==void 0);return{defaultValue:h,userValue:S,userLocalValue:I,userRemoteValue:u,workspaceValue:P,workspaceFolderValue:_,memoryValue:q,value:W,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(c=>f.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const s=(0,f.overrideIdentifierFromKey)(c),l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),S=[...h.filter(I=>l.indexOf(I)===-1),...l.filter(I=>h.indexOf(I)===-1),...l.filter(I=>!T.equals(this._defaultConfiguration.override(s).getValue(I),t.override(s).getValue(I)))];return[s,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,g.compare)(this.localUserConfiguration,t),l=[...n,...r,...c];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,g.compare)(this.remoteUserConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,g.compare)(this.workspaceConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:c,updated:s,removed:l,overrides:h}=(0,g.compare)(r,n);let S=[...c,...s,...l];return(S.length||!r)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:c,removed:s,overrides:l}=(0,g.compare)(n,void 0);return{keys:[...r,...c,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const c=n.getFolder(t);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(n=r.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:c,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:c,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(c=>n.add(c))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((l,h)=>(l.set(L.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new A.ResourceMap);return new p(n,r,new b,c,s,new b,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function w(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const t=new Set,n=new Map;for(const c of i)c.keys.forEach(s=>t.add(s)),c.overrides.forEach(([s,l])=>{const h=(0,A.getOrSet)(n,s,new Set);l.forEach(S=>h.add(S))});const r=[];return n.forEach((c,s)=>r.push([s,[...c.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=w;class v{constructor(t,n,r,c){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(S=>s.add(S))),this.affectedKeys=[...s.values()];const l=new b;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!T.equals(c,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,g.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(t=t[c],!t)return!1;r=r[c]}return!0}}e.ConfigurationChangeEvent=v;class o extends v{constructor(t,n,r,c){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=o}),define(Q[164],Z([0,1,35,39,2,24,163,3,6,12]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends O.Disposable{constructor(y,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,b)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,b){const a=typeof y=="string"?y:void 0,C=(0,R.isConfigurationOverrides)(y)?y:(0,R.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(a,C,void 0)}updateValue(y,b,a,C){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const b=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(a,b,1)}onDidDefaultConfigurationChange(y){const b=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,y);this.trigger(a,b,6)}trigger(y,b,a){const C=new T.ConfigurationChangeEvent(y,{data:b},this.configuration);C.source=a,C.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(Q[165],Z([0,1,24,15,101]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(L,f){this.configurationService=L,this.logService=f}request(L,f){return this.logService.trace("RequestService#request",L.url),L.proxyAuthorization||(L.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,O.request)(L,f)}async resolveProxy(L){}};R=ue([Y(0,m.IConfigurationService),Y(1,A.ILogService)],R),e.RequestService=R}),define(Q[40],Z([0,1,118,4,39,35,22]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function L(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=L;function f(d){return d.res.statusCode===204}async function g(d){if(!L(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,T.streamToBuffer)(d.stream)).toString()}e.asText=g;async function D(d){if(!L(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const b=(await(0,T.streamToBuffer)(d.stream)).toString();try{return JSON.parse(b)}catch(a){throw a.message+=`:
`+b,a}}e.asJson=D,R.Registry.as(O.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,m.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null)],default:"override",description:(0,m.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(8,null)}}})}),define(Q[166],Z([0,1,40,30,9,16]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(f,g){this.requestService=f,this.fileService=g}async download(f,g,D=A.CancellationToken.None){if(f.scheme===R.Schemas.file||f.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(f,g);return}const d={type:"GET",url:f.toString()},y=await this.requestService.request(d,D);if(y.res.statusCode===200)await this.fileService.writeFile(g,y.stream);else{const b=await(0,m.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${b}`)}}};T=ue([Y(0,m.IRequestService),Y(1,O.IFileService)],T),e.DownloadService=T}),define(Q[167],Z([0,1,28,9,18,62,40,30,15,12,129,2]),function(G,e,m,A,O,R,T,L,f,g,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends d.Disposable{constructor(a,C,E,p){super();this.fileService=a,this.productService=C,this.requestService=E,this.logService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(a){return this.getValidConfigBasedTips(a)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(a){const C=[];for(const[E,p]of this.allConfigBasedTips)try{const w=await this.fileService.readFile((0,g.joinPath)(a,E)),v=new Map;(0,R.forEach)(p.recommendations,({key:i,value:t})=>{if((0,O.isNonEmptyArray)(t.remotes))for(const n of t.remotes)v.set(n,{extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,D.getDomainsOfRemotes)(w.value.toString(),[...v.keys()]);for(const i of o){const t=v.get(i);t&&C.push(t)}}catch(w){}return C}async fetchWorkspacesTips(){var a,C;if(!((a=this.productService.extensionsGallery)===null||a===void 0?void 0:a.recommendationsUrl))return[];try{const E=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},L.CancellationToken.None);if(E.res.statusCode!==200)return[];const p=await(0,T.asJson)(E);return p?p.workspaceRecommendations||[]:[]}catch(E){return this.logService.error(E),[]}}};y=ue([Y(0,A.IFileService),Y(1,m.IProductService),Y(2,T.IRequestService),Y(3,f.ILogService)],y),e.ExtensionTipsService=y}),define(Q[44],Z([0,1,31,22]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function O(R,T,L){let f=L&&L.get("storage.serviceMachineId",0)||null;if(f)return f;try{const D=(await T.readFile(R.serviceMachineIdResource)).value.toString();f=(0,m.isUUID)(D)?D:null}catch(g){f=null}if(!f){f=(0,m.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,A.VSBuffer.fromString(f))}catch(g){}}return L&&L.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=O}),define(Q[19],Z([0,1,4,3,2,17,67,6]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var g;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var D;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(D=e.StorageScope||(e.StorageScope={}));var d;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class y extends O.Disposable{constructor(E={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new O.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,O.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,p){p===f?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:p,target:this.getKeyTargets(E)[p]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,p,w){var v;return(v=this.getStorage(p))===null||v===void 0?void 0:v.get(E,w)}getBoolean(E,p,w){var v;return(v=this.getStorage(p))===null||v===void 0?void 0:v.getBoolean(E,w)}getNumber(E,p,w){var v;return(v=this.getStorage(p))===null||v===void 0?void 0:v.getNumber(E,w)}store(E,p,w,v){if((0,R.isUndefinedOrNull)(p)){this.remove(E,w);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(E,w,v),(o=this.getStorage(w))===null||o===void 0||o.set(E,p)})}remove(E,p){this.withPausedEmitters(()=>{var w;this.updateKeyTarget(E,p,void 0),(w=this.getStorage(p))===null||w===void 0||w.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,p){const w=[],v=this.getKeyTargets(E);for(const o of Object.keys(v))v[o]===p&&w.push(o);return w}updateKeyTarget(E,p,w){var v,o;const i=this.getKeyTargets(p);typeof w=="number"?i[E]!==w&&(i[E]=w,(v=this.getStorage(p))===null||v===void 0||v.set(f,JSON.stringify(i))):typeof i[E]=="number"&&(delete i[E],(o=this.getStorage(p))===null||o===void 0||o.set(f,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const p=this.get(f,E);if(p)try{return JSON.parse(p)}catch(w){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(){var E,p,w,v;this._onWillSaveState.fire({reason:g.NONE}),await L.Promises.settled([(p=(E=this.getStorage(0))===null||E===void 0?void 0:E.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(v=(w=this.getStorage(1))===null||w===void 0?void 0:w.whenFlushed())!==null&&v!==void 0?v:Promise.resolve()])}async logStorage(){var E,p,w,v,o,i;const t=(p=(E=this.getStorage(0))===null||E===void 0?void 0:E.items)!==null&&p!==void 0?p:new Map,n=(v=(w=this.getStorage(1))===null||w===void 0?void 0:w.items)!==null&&v!==void 0?v:new Map;return a(t,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends y{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=b;async function a(C,E,p,w){const v=s=>{try{return JSON.parse(s)}catch(l){return s}},o=new Map,i=new Map;C.forEach((s,l)=>{o.set(l,s),i.set(l,v(s))});const t=new Map,n=new Map;E.forEach((s,l)=>{t.set(l,s),n.set(l,v(s))}),console.group(`Storage: Global (path: ${p})`);let r=[];o.forEach((s,l)=>{r.push({key:l,value:s})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${w})`);let c=[];t.forEach((s,l)=>{c.push({key:l,value:s})}),console.table(c),console.groupEnd(),console.log(n)}e.logStorage=a}),define(Q[168],Z([0,1,3,2,29,34,19,17]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let f=class extends A.Disposable{constructor(d){super();this._onDidChangeEnablement=new m.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new g(d)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(d,y){return this._removeFromDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:y}),!0):!1}async disableExtension(d,y){return this._addToDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(d){let y=this.getDisabledExtensions();return y.every(b=>!(0,R.areSameExtensions)(b,d))?(y.push(d),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(d){let y=this.getDisabledExtensions();for(let b=0;b<y.length;b++){const a=y[b];if((0,R.areSameExtensions)(a,d))return y.splice(b,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(d){this._setExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH,d)}_getExtensions(d){return this.storageManger.get(d,0)}_setExtensions(d,y){this.storageManger.set(d,y,0)}};f=ue([Y(0,T.IStorageService)],f),e.GlobalExtensionEnablementService=f;class g extends A.Disposable{constructor(d){super();this.storageService=d,this.storage=Object.create(null),this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this._register(d.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(d,y){let b;return y===0?((0,L.isUndefinedOrNull)(this.storage[d])&&(this.storage[d]=this._get(d,y)),b=this.storage[d]):b=this._get(d,y),JSON.parse(b)}set(d,y,b){let a=JSON.stringify(y.map(({id:E,uuid:p})=>({id:E,uuid:p})));this._get(d,b)!==a&&(b===0&&(y.length?this.storage[d]=a:delete this.storage[d]),this._set(d,y.length?a:void 0,b))}onDidStorageChange(d){if(d.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[d.key])&&this._get(d.key,d.scope)!==this.storage[d.key]){const b=this.get(d.key,d.scope);delete this.storage[d.key];const a=this.get(d.key,d.scope),C=b.filter(p=>!a.some(w=>(0,R.areSameExtensions)(p,w))),E=a.filter(p=>!b.some(w=>(0,R.areSameExtensions)(w,p)));(C.length||E.length)&&this._onDidChange.fire([...C,...E])}}_get(d,y){return this.storageService.get(d,y,"[]")}_set(d,y,b){y?this.storageService.store(d,y,b,1):this.storageService.remove(d,b)}}e.StorageManager=g}),define(Q[169],Z([0,1,3,2]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class O extends A.Disposable{constructor(g,D){super();this.channel=g,this.workspace=D}async getItems(){const g={workspace:this.workspace},D=await this.channel.call("getItems",g);return new Map(D)}updateItems(g){const D={workspace:this.workspace};return g.insert&&(D.insert=Array.from(g.insert.entries())),g.delete&&(D.delete=Array.from(g.delete.values())),this.channel.call("updateItems",D)}}class R extends O{constructor(g){super(g,void 0);this._onDidChangeItemsExternal=this._register(new m.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(g=>this.onDidChangeGlobalStorage(g)))}onDidChangeGlobalStorage(g){(Array.isArray(g.changed)||Array.isArray(g.deleted))&&this._onDidChangeItemsExternal.fire({changed:g.changed?new Map(g.changed):void 0,deleted:g.deleted?new Set(g.deleted):void 0})}async close(){this.dispose()}}class T extends O{constructor(g,D){super(g,D);this.onDidChangeItemsExternal=m.Event.None}async close(){const g={workspace:this.workspace};return this.channel.call("close",g)}}class L extends A.Disposable{constructor(g,D){super();this.channel=g,this.workspace=D,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=L}),define(Q[170],Z([0,1,2,19,67,6,155,169,12]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class g extends A.AbstractStorageService{constructor(d,y,b){super();this.mainProcessService=y,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new m.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(d)}createGlobalStorage(){const d=new L.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new O.Storage(d.globalStorage);return this._register(y.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),y}createWorkspaceStorage(d){const y=new L.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),d);if(y.workspaceStorage){const b=new O.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(a=>this.emitDidChangeValue(1,a)),this.workspaceStorageId=d==null?void 0:d.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var d,y;(0,T.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),(y=(d=this.workspaceStorage)===null||d===void 0?void 0:d.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,T.mark)("code/didInitStorage")}}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,f.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var d,y;this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),(y=(d=this.workspaceStorage)===null||d===void 0?void 0:d.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(d){var y;const b=this.workspaceStorage,a=(y=b==null?void 0:b.items)!==null&&y!==void 0?y:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(d),await this.workspaceStorage.init();for(const[C,E]of a)this.workspaceStorage.set(C,E)}}e.NativeStorageService=g}),define(Q[171],Z([0,1,7,36,31,5]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function T(f,g,D,d,y,b,a,C,E){const p=Object.create(null);p["common.machineId"]=b,p.sessionID=(0,O.generateUuid)()+Date.now(),p.commitHash=d,p.version=y,p["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,m.PlatformToString)(m.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=D,p["common.product"]=E||"desktop";const w=L(a||[]);w&&(p["common.msftInternal"]=w);let v=0;const o=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),m.isLinuxSnap&&(p["common.snap"]="true");try{const i=await f.readFile(R.URI.file(C));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=T;function L(f){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const D=g.toLowerCase();return f.some(d=>D===d)}}),define(Q[25],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[172],Z([0,1,38,93,69,27,8,32,96,28,7,5,25,52,16,9,23]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,n){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,s=new Map,l=2e4;function h(u,P,_,q){const W=P.substring(u.length+1);return new Promise(async N=>{var $,V,B;let M;try{M=await(0,E.readdir)(P,{withFileTypes:!0})}catch(U){N();return}if(q.count>=l){q.count+=M.length,q.maxReached=!0,N();return}let F=M.length;if(F===0){N();return}let k=M;q.count+M.length>l&&(q.maxReached=!0,F=l-q.count,k=M.slice(0,F)),q.count+=M.length;for(const U of k)if(U.isDirectory()){if(_.includes(U.name)||await h(u,(0,T.join)(P,U.name),_,q),--F==0){N();return}}else{const j=U.name.lastIndexOf(".");if(j>=0){const z=U.name.substring(j+1);z&&c.set(z,(($=c.get(z))!==null&&$!==void 0?$:0)+1)}for(const z of r)((V=z.relativePathPattern)===null||V===void 0?void 0:V.test(W))!==!1&&z.filePattern.test(U.name)&&s.set(z.tag,((B=s.get(z.tag))!==null&&B!==void 0?B:0)+1);if(--F==0){N();return}}})}const S={count:0,maxReached:!1};await h(t,t,n,S);const I=await o(t);return{configFiles:w(s),fileTypes:w(c),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:I}}e.collectWorkspaceStats=p;function w(t){return[...b.Iterable.map(t.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function v(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},n=m.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=v;function o(t){let n=new Map,r=(0,T.join)(t,".vscode","launch.json");return new Promise((c,s)=>{(0,R.exists)(r,l=>{if(l)(0,R.readFile)(r,(h,S)=>{if(h)return c([]);const I=[],u=(0,L.parse)(S.toString(),I);if(I.length)return console.log(`Unable to parse ${r}`),c([]);if((0,L.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const _=P.type;_&&(n.has(_)?n.set(_,n.get(_)+1):n.set(_,1))}return c(w(n))});else return c([])})})}e.collectLaunchConfigs=o;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const c=m.cpus();return c&&c.length>0&&r.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),r.push(`Memory (System):  ${(m.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||r.push(`Load (avg):       ${m.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,f.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async c=>{let[s,l]=c,h=this.formatProcessList(n,s);return r.forEach(S=>{if((0,O.isRemoteDiagnosticError)(S))h+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(h+=`

Remote: ${S.hostName}`,S.processes&&(h+=`
${this.formatProcessList(n,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const I of Object.keys(S.workspaceMetadata)){const u=S.workspaceMetadata[I];let P=`${u.fileCount} files`;u.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${I}): ${P}`,l+=this.formatWorkspaceStats(u)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:c,vmHint:s,os:l,cpus:h}=v(),S={os:l,memory:c,cpus:h,vmHint:s,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return D.isWindows||(S.load=`${m.loadavg().map(I=>Math.round(I)).join(", ")}`),D.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(n,r){const c=[];return(0,f.listProcesses)(n.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(n)),c.push(""),c.push(this.formatProcessList(n,s)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(n))),r.forEach(l=>{if((0,O.isRemoteDiagnosticError)(l))c.push(`
${l.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${l.hostName}`),c.push(this.formatMachineInfo(l.machineInfo)),l.processes&&c.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[h];let I=`${S.fileCount} files`;S.maxFilesReached&&(I=`more than ${I}`),c.push(`Folder (${h}): ${I}`),c.push(this.formatWorkspaceStats(S))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(n){const r=[],c=60;let s=0;const l=(u,P)=>{const _=` ${u}(${P})`;s+_.length>c?(r.push(h),h="|                 ",s=h.length):s+=_.length,h+=_};let h="|      File types:";const S=10;let I=n.fileTypes.length>S?S:n.fileTypes.length;for(let u=0;u<I;u++){const P=n.fileTypes[u];l(P.name,P.count)}if(r.push(h),n.configFiles.length>=0&&(h="|      Conf files:",s=0,n.configFiles.forEach(u=>{l(u.name,u.count)}),r.push(h)),n.launchConfigFiles.length>0){let u="|      Launch Configs:";n.launchConfigFiles.forEach(P=>{u+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),r.push(u)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(c=>c.length));return Object.keys(n).map(c=>`${c}:  ${" ".repeat(r-c.length)}  ${n[c]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],c=[];return n.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const h=d.URI.revive(l);if(h.scheme===a.Schemas.file){const S=h.fsPath;c.push(p(S,["node_modules",".git"]).then(I=>{let u=`${I.fileCount} files`;I.maxFilesReached&&(u=`more than ${u}`),r.push(`|    Folder (${(0,T.basename)(S)}): ${u}`),r.push(this.formatWorkspaceStats(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${S} (${I.toString()})`)}))}else r.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(n,r){const c=new Map;n.windows.forEach(l=>c.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,c,s,r,0),s.join(`
`)}formatProcessItem(n,r,c,s,l){const h=l===0;let S;h?S=s.pid===n?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${r.get(s.pid)})`));const I=process.platform==="win32"?s.mem:m.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/C.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(u=>this.formatProcessItem(n,r,c,u,l+1))}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const c=d.URI.revive(r);if(c.scheme===a.Schemas.file){const s=c.fsPath;try{const l=await p(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})})}catch(l){}}}}};i=ue([Y(0,y.ITelemetryService),Y(1,g.IProductService)],i),e.DiagnosticsService=i}),define(Q[173],Z([0,1,11,29,34,26,25,40,68,10,30,15,9,5,28,19,44,4,12]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var v;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(v||(v={}));function o(...k){return String(k.reduce((U,j)=>U|j,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class s{constructor(U=c){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,j=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:U,pageSize:j}))}withFilter(U,...j){const z=[...this.state.criteria,...j.length?j.map(H=>({filterType:U,value:H})):[{filterType:U}]];return new s(Object.assign(Object.assign({},this.state),{criteria:z}))}withSortBy(U){return new s(Object.assign(Object.assign({},this.state),{sortBy:U}))}withSortOrder(U){return new s(Object.assign(Object.assign({},this.state),{sortOrder:U}))}withFlags(...U){return new s(Object.assign(Object.assign({},this.state),{flags:U.reduce((j,z)=>j|z,0)}))}withAssetTypes(...U){return new s(Object.assign(Object.assign({},this.state),{assetTypes:U}))}get raw(){const{criteria:U,pageNumber:j,pageSize:z,sortBy:H,sortOrder:K,flags:te,assetTypes:X}=this.state;return{filters:[{criteria:U,pageNumber:j,pageSize:z,sortBy:H,sortOrder:K}],assetTypes:X,flags:te}}get searchText(){const U=this.state.criteria.filter(j=>j.filterType===i.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(k,U){const j=(k||[]).filter(z=>z.statisticName===U)[0];return j?j.value:0}function h(k){const U="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(z=>z.assetType.indexOf(U)===0).reduce((z,H)=>{const K=P(k,H.assetType);return K&&z.push([H.assetType.substring(U.length),K]),z},[])}function S(k){if(k.properties){const U=k.properties.filter(H=>H.key===t.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),z=U.filter(H=>j.test(H.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return P(k,t.Repository)}function I(k){return{uri:`${k.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${k.fallbackAssetUri}/${t.VSIX}`}}function u(k){const U=P(k,t.Icon);if(U)return U;const j=A.DefaultIconPath;return{uri:j,fallbackUri:j}}function P(k,U){return k.files.filter(z=>z.assetType===U)[0]?{uri:`${k.assetUri}/${U}`,fallbackUri:`${k.fallbackAssetUri}/${U}`}:null}function _(k,U){const j=k.properties?k.properties.filter(H=>H.key===U):[],z=j.length>0&&j[0].value;return z?z.split(",").map(H=>(0,O.adoptToGalleryExtensionId)(H)):[]}function q(k){const U=k.properties?k.properties.filter(j=>j.key===n.Engine):[];return U.length>0&&U[0].value||""}function W(k){const U=k.properties?k.properties.filter(z=>z.key===n.LocalizedLanguages):[],j=U.length>0&&U[0].value||"";return j?j.split(","):[]}function N(k){return k.indexOf("preview")!==-1}function $(k){const U=k.properties?k.properties.find(j=>j.key===n.WebExtension):void 0;return!!U&&U.value==="true"}function V(k){return k.files.some(U=>U.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,w.joinPath)(b.URI.parse(k.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function B(k,U,j,z,H){const K={manifest:P(U,t.Manifest),readme:P(U,t.Details),changelog:P(U,t.Changelog),license:P(U,t.License),repository:S(U),download:I(U),icon:u(U),coreTranslations:h(U)};return{identifier:{id:(0,O.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:U.version,date:U.lastUpdated,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:l(k.statistics,"install"),rating:l(k.statistics,"averagerating"),ratingCount:l(k.statistics,"ratingcount"),assetUri:b.URI.parse(U.assetUri),webResource:V(U),assetTypes:U.files.map(({assetType:te})=>te),assets:K,properties:{dependencies:_(U,n.Dependency),extensionPack:_(U,n.ExtensionPack),engine:q(U),localizedLanguages:W(U),webExtension:$(U)},telemetryData:{index:(z.pageNumber-1)*z.pageSize+j,searchText:z.searchText,querySource:H},preview:N(k.flags)}}let M=class{constructor(U,j,z,H,K,te,X){this.requestService=U,this.logService=j,this.environmentService=z,this.telemetryService=H,this.fileService=K,this.productService=te;const ie=te.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=F(te.version,this.environmentService,this.fileService,X)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,j){const z=[];let{total:H,firstPage:K,getPage:te}=await this.query({names:U,pageSize:U.length},j);z.push(...K);for(let X=1;z.length<H&&(K=await te(X,j),K.length);X++)z.push(...K);return z}async getCompatibleExtension(U,j){const z=await this.getCompatibleExtensionByEngine(U,j);return(z==null?void 0:z.properties.webExtension)?z.webResource?z:null:z}async getCompatibleExtensionByEngine(U,j){const z=(0,A.isIExtensionIdentifier)(U)?null:U;if(z&&z.properties.engine&&(0,f.isEngineValid)(z.properties.engine,this.productService.version))return z;const{id:H,uuid:K}=z?z.identifier:U;let te=new s().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?te=te.withFilter(i.ExtensionId,K):te=te.withFilter(i.ExtensionName,H);const{galleryExtensions:X}=await this.queryGallery(te,D.CancellationToken.None),[ie]=X;if(!ie||!ie.versions.length)return null;if(j){const ce=ie.versions.filter(he=>he.version===j)[0];if(ce){const he=B(ie,ce,0,te);if(he.properties.engine&&(0,f.isEngineValid)(he.properties.engine,this.productService.version))return he}return null}const se=await this.getLastValidExtensionVersion(ie,ie.versions);return se?B(ie,se,0,te):null}async query(U,j){const z=D.CancellationToken.isCancellationToken(U)?{}:U,H=D.CancellationToken.isCancellationToken(U)?U:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=z.text||"";const te=(0,R.getOrDefault)(z,me=>me.pageSize,50);let X=new s().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,te).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Category,Ie||we),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Tag,Ie||we),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),X=X.withFilter(i.SearchText,K)),X=X.withSortBy(0)):z.ids?X=X.withFilter(i.ExtensionId,...z.ids):z.names?X=X.withFilter(i.ExtensionName,...z.names):X=X.withSortBy(4),typeof z.sortBy=="number"&&(X=X.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(X=X.withSortOrder(z.sortOrder));const{galleryExtensions:ie,total:se}=await this.queryGallery(X,H),ce=ie.map((me,we)=>B(me,me.versions[0],we,X,z.source)),he=async(me,we)=>{if(we.isCancellationRequested)throw(0,m.canceled)();const Ie=X.withPage(me+1),{galleryExtensions:ke}=await this.queryGallery(Ie,we);return ke.map((Ue,Fe)=>B(Ue,Ue.versions[0],Fe,Ie,z.source))};return{firstPage:ce,total:se,pageSize:X.pageSize,getPage:he}}async queryGallery(U,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,v.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(v.Unpublished));const z=await this.commonHeadersPromise,H=JSON.stringify(U.raw),K=Object.assign(Object.assign({},z),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)}),te=new Date().getTime();let X,ie,se=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:K},j),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:se};const ce=await(0,L.asJson)(X);if(ce){const he=ce.results[0],me=he.extensions,we=he.resultMetadata&&he.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return se=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:se}}return{galleryExtensions:[],total:se}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},U.telemetryData),{requestBodySize:String(H.length),duration:new Date().getTime()-te,success:!!X&&(0,L.isSuccess)(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ie?(0,m.isPromiseCanceledError)(ie)?"canceled":(0,m.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(U,j,z,H){if(!!this.isEnabled()){const K=await this.commonHeadersPromise,te=Object.assign(Object.assign({},K),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${U}/extensions/${j}/${z}/stats?statType=${H}`),headers:te},D.CancellationToken.None)}catch(X){}}}async download(U,j,z){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const H=(0,O.getGalleryExtensionTelemetryData)(U),K=new Date().getTime(),te=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},H),{duration:ce})),X=z===1?"install":z===2?"update":"",ie=X?{uri:`${U.assets.download.uri}&${X}=true`,fallbackUri:`${U.assets.download.fallbackUri}?${X}=true`}:U.assets.download,se=await this.getAsset(ie);await this.fileService.writeFile(j,se.stream),te(new Date().getTime()-K)}async getReadme(U,j){if(U.assets.readme){const z=await this.getAsset(U.assets.readme,{},j);return await(0,L.asText)(z)||""}return""}async getManifest(U,j){if(U.assets.manifest){const z=await this.getAsset(U.assets.manifest,{},j),H=await(0,L.asText)(z);return H?JSON.parse(H):null}return null}async getCoreTranslation(U,j){const z=U.assets.coreTranslations.filter(H=>H[0]===j.toUpperCase())[0];if(z){const H=await this.getAsset(z[1]),K=await(0,L.asText)(H);return K?JSON.parse(K):null}return null}async getChangelog(U,j){if(U.assets.changelog){const z=await this.getAsset(U.assets.changelog,{},j);return await(0,L.asText)(z)||""}return""}async getAllVersions(U,j){let z=new s().withFlags(v.IncludeVersions,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");U.identifier.uuid?z=z.withFilter(i.ExtensionId,U.identifier.uuid):z=z.withFilter(i.ExtensionName,U.identifier.id);const H=[],{galleryExtensions:K}=await this.queryGallery(z,D.CancellationToken.None);return K.length&&(j?await Promise.all(K[0].versions.map(async te=>{let X;try{X=await this.getEngine(te)}catch(ie){}X&&(0,f.isEngineValid)(X,this.productService.version)&&H.push({version:te.version,date:te.lastUpdated})})):H.push(...K[0].versions.map(te=>({version:te.version,date:te.lastUpdated})))),H}async getAsset(U,j={},z=D.CancellationToken.None){const H=await this.commonHeadersPromise,K={type:"GET"},te=Object.assign(Object.assign({},H),j.headers||{});j=Object.assign(Object.assign(Object.assign({},j),K),{headers:te});const X=U.uri,ie=U.fallbackUri,se=Object.assign(Object.assign({},j),{url:X});try{const ce=await this.requestService.request(se,z);if(ce.res.statusCode===200)return ce;const he=await(0,L.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${he}`)}catch(ce){if((0,m.isPromiseCanceledError)(ce))throw ce;const he=(0,m.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:he});const me=Object.assign(Object.assign({},j),{url:ie});return this.requestService.request(me,z)}}async getLastValidExtensionVersion(U,j){const z=this.getLastValidExtensionVersionFromProperties(U,j);return z||this.getLastValidExtensionVersionRecursively(U,j)}getLastValidExtensionVersionFromProperties(U,j){for(const z of j){const H=q(z);if(!H)return null;if((0,f.isEngineValid)(H,this.productService.version))return z}return null}async getEngine(U){const j=q(U);if(j)return j;const z=P(U,t.Manifest);if(!z)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},K=await this.getAsset(z,{headers:H}),te=await(0,L.asJson)(K);if(te)return te.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(U,j){if(!j.length)return null;const z=j[0],H=await this.getEngine(z);return(0,f.isEngineValid)(H,this.productService.version)?(z.properties=z.properties||[],z.properties.push({key:n.Engine,value:H}),z):this.getLastValidExtensionVersionRecursively(U,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,L.asJson)(U),z=new Map;if(j)for(const H of j.malicious){const K=z.get(H)||{id:{id:H},malicious:!0,slow:!1};K.malicious=!0,z.set(H,K)}return[...z.values()]}};M=ue([Y(0,L.IRequestService),Y(1,d.ILogService),Y(2,g.IEnvironmentService),Y(3,T.ITelemetryService),Y(4,y.IFileService),Y(5,a.IProductService),Y(6,(0,p.optional)(C.IStorageService))],M),e.ExtensionGalleryService=M;async function F(k,U,j,z){const H={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},K=await(0,E.getServiceMachineId)(U,j,z);return H["X-Market-User-Id"]=K,H}e.resolveMarketplaceHeaders=F}),define(Q[174],Z([0,1,5,8,28,10,36,9,7,18,29,62,40,15,167,6,25,71,109,19,3,56]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let r=class extends a.ExtensionTipsService{constructor(s,l,h,S,I,u,P,_,q,W){super(P,_,q,W);this.environmentService=s,this.telemetryService=l,this.extensionManagementService=h,this.storageService=S,this.nativeHostService=I,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,d.forEach)(_.exeBasedExtensionTips,({key:N,value:$})=>{const V=[],B=[],M=[];(0,d.forEach)($.recommendations,({key:F,value:k})=>{k.important?$.important?V.push({extensionId:F,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):B.push({extensionId:F,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):M.push({extensionId:F,extensionName:k.name,isExtensionPack:!!k.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),B.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:B}),M.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:M})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(s,l){const h=new Map;s.forEach(_=>h.set(_.extensionId.toLowerCase(),_));const{installed:S,uninstalled:I}=this.groupByInstalled([...h.keys()],l);for(const _ of S){const q=h.get(_);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,A.basename)(q.windowsPath)})}for(const _ of I){const q=h.get(_);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,A.basename)(q.windowsPath)})}const u=this.getPromptedExecutableTips(),P=new Map;for(const _ of I){const q=h.get(_);if(q&&(!u[q.exeName]||!u[q.exeName].includes(q.extensionId))){let W=P.get(q.exeName);W||(W=[],P.set(q.exeName,W)),W.push(q)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[s,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const S=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(S(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const I=this._register((0,C.disposableTimeout)(()=>{I.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const s=this.getLastPromptedMediumExeTime(),l=Date.now()-s,h=7*24*60*60*1e3;if(l<h){const u=this._register((0,C.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[S,I]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(I).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(S),this.addToRecommendedExecutables(I[0].exeName,I);const P=this._register((0,C.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(S),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,C.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(s){const l=s.map(({extensionId:S})=>S.toLowerCase()),h=(0,w.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(n,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(n,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(s,l){const h=this.getPromptedExecutableTips();h[s]=l.map(({extensionId:S})=>S.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(s,l){const h=[],S=[],I=l.reduce((u,P)=>(u.add(P.identifier.id.toLowerCase()),u),new Set);return s.forEach(u=>{I.has(u.toLowerCase())?h.push(u):S.push(u)}),{installed:h,uninstalled:S}}async getValidExecutableBasedExtensionTips(s){const l=[],h=new Map;for(const S of s.keys()){const I=s.get(S);if(!(!I||!(0,g.isNonEmptyArray)(I.recommendations))){const u=[];f.isWindows?I.windowsPath&&u.push(I.windowsPath.replace("%USERPROFILE%",T.env.USERPROFILE).replace("%ProgramFiles(x86)%",T.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",T.env.ProgramFiles).replace("%APPDATA%",T.env.APPDATA).replace("%WINDIR%",T.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",S)),u.push((0,A.join)("/usr/bin",S)),u.push((0,A.join)(this.environmentService.userHome.fsPath,S)));for(const P of u){let _=h.get(P);if(_===void 0&&(_=await this.fileService.exists(m.URI.file(P)),h.set(P,_)),_)for(const{extensionId:q,extensionName:W,isExtensionPack:N}of I.recommendations)l.push({extensionId:q,extensionName:W,isExtensionPack:N,exeName:S,exeFriendlyName:I.exeFriendlyName,windowsPath:I.windowsPath})}}}return l}};r=ue([Y(0,R.INativeEnvironmentService),Y(1,E.ITelemetryService),Y(2,D.IExtensionManagementService),Y(3,v.IStorageService),Y(4,i.INativeHostService),Y(5,p.IExtensionRecommendationNotificationService),Y(6,L.IFileService),Y(7,O.IProductService),Y(8,y.IRequestService),Y(9,b.ILogService)],r),e.ExtensionTipsService=r}),define(Q[79],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(R){this.appender=R}listen(R,T){throw new Error(`Event not found: ${T}`)}call(R,T,{eventName:L,data:f}){return this.appender.log(L,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class A{constructor(R){this.channel=R}log(R,T){return this.channel.call("log",{eventName:R,data:T}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(Q[80],Z([0,1,57,119,21,4,24,39,2,26,35]),function(G,e,m,A,O,R,T,L,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(a,C){this._configurationService=C,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(E),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(E=>{const p=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(a,C){this._experimentProperties[a]=C}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const C=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(y);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let C=a.sessionID,E=a["common.instanceId"],p=a["common.machineId"],w=a["common.firstSessionDate"],v=a["common.msftInternal"];return{sessionId:C,instanceId:E,machineId:p,firstSessionDate:w,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(a,C,E){return this.isOptedIn?this._commonProperties.then(p=>{C=(0,g.mixin)(C,p),C=(0,g.mixin)(C,this._experimentProperties),C=(0,g.cloneAndChange)(C,w=>{if(typeof w=="string")return this._cleanupInfo(w,E)}),this._appender.log(a,C)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(a,C,E){return this.publicLog(a,C,E)}publicLogError(a,C){return this.sendErrorTelemetry?this.publicLog(a,C,!0):Promise.resolve(void 0)}publicLogError2(a,C){return this.publicLogError(a,C)}_cleanupInfo(a,C){let E=a;if(C){const p=[];for(let i of this._cleanupPatterns)for(;;){const t=i.exec(a);if(!t)break;p.push([t.index,i.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(E="";;){const i=v.exec(a);if(!i)break;!w.test(i[0])&&p.every(([t,n])=>i.index<t||i.index>=n)&&(E+=a.substring(o,i.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}o<a.length&&(E+=a.substr(o))}for(let p of this._cleanupPatterns)E=E.replace(p,"");return E}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ue([Y(1,(0,R.optional)(T.IConfigurationService))],d),e.TelemetryService=d;const y="telemetry";D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(2,null,m.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[58],Z([0,1,24,26,17,6]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,C){return Promise.resolve(void 0)}publicLog2(a,C){return this.publicLog(a,C)}publicLogError(a,C){return Promise.resolve(void 0)}publicLogError2(a,C){return this.publicLogError(a,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(C,E,p){}async publicLogError(C,E,p){}}e.NullEndpointTelemetryService=T;function L(...a){return{log:(C,E)=>a.forEach(p=>p.log(C,E)),flush:()=>R.Promises.settled(a.map(C=>C.flush()))}}e.combinedAppender=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(a,C){return C.onDidChangeConfiguration(E=>{E.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(E.source),configurationKeys:y(E.sourceConfig)})})}e.configurationTelemetry=f;function g(a){const C=Object.create(null),E=Object.create(null),p=Object.create(null);d(a,p);for(let w in p){w=w.length>150?w.substr(w.length-149):w;const v=p[w];typeof v=="number"?E[w]=v:typeof v=="boolean"?E[w]=v?1:0:typeof v=="string"?C[w]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(C[w]=v)}return{properties:C,measurements:E}}e.validateTelemetryData=g;function D(a){if(!a)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{a.indexOf(`${p}+`)===0&&(C=p)}),C}e.cleanRemoteAuthority=D;function d(a,C,E=0,p){if(!!a)for(let w of Object.getOwnPropertyNames(a)){const v=a[w],o=p?p+w:w;Array.isArray(v)?C[o]=(0,A.safeStringify)(v):v instanceof Date?C[o]=v.toISOString():(0,O.isObject)(v)?E<2?d(v,C,E+1,o+"."):C[o]=(0,A.safeStringify)(v):C[o]=v}}function y(a){if(!a)return[];const C=[];return b(C,"",a),C}function b(a,C,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(p=>b(a,C?`${C}.${p}`:p,E[p])):a.push(C)}}),define(Q[175],Z([0,1,2,10,15,58]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends m.Disposable{constructor(f,g){super();this.logger=this._register(f.createLogger(g.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(f,g){this.logger.trace(`telemetry/${f}`,(0,R.validateTelemetryData)(g))}};T=ue([Y(0,O.ILoggerService),Y(1,A.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(Q[176],Z([0,1,11,26,58]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(L){const f=await new Promise((D,d)=>{G(["applicationinsights"],D,d)});let g;return f.defaultClient?(g=new f.TelemetryClient(L),g.channel.setUseDiskRetryCaching(!0)):(f.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=f.defaultClient),L.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class T{constructor(f,g,D){this._eventPrefix=f,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(g=>{f(g)},g=>{(0,m.onUnexpectedError)(g),console.error(g)})}}log(f,g){!this._aiClient||(g=(0,A.mixin)(g,this._defaultData),g=(0,O.validateTelemetryData)(g),this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+f,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(Q[177],Z([0,1,49,79,16,80,24,25]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(D,d){this.configurationService=D,this.telemetryService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(D){if(!this.customTelemetryServices.has(D.id)){const{machineId:d,sessionId:y}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=d,b["common.vscodesessionid"]=y;const a=[D.id,JSON.stringify(b),D.aiKey],E=new m.Client(O.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=new A.TelemetryAppenderClient(E);this.customTelemetryServices.set(D.id,new R.TelemetryService({appender:p,sendErrorTelemetry:D.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(D.id)}async publicLog(D,d,y){await(await this.getCustomTelemetryService(D)).publicLog(d,y)}async publicLogError(D,d,y){await(await this.getCustomTelemetryService(D)).publicLogError(d,y)}};f=ue([Y(0,T.IConfigurationService),Y(1,L.ITelemetryService)],f),e.CustomEndpointTelemetryService=f}),define(Q[81],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var O;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(O=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,m.createDecorator)("localTerminalService"),e.IPtyService=(0,m.createDecorator)("ptyService");var R;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(T=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var L;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(L=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Q[178],Z([0,1,4]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,m.createDecorator)("localPtyService")}),define(Q[179],Z([0,1,2,15,81,49,16,33,3,76]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var D;(function(b){b[b.MaxRestarts=5]="MaxRestarts"})(D||(D={}));let d=0,y=class extends m.Disposable{constructor(a){super();this._logService=a,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new f.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new f.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new f.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new f.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new f.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new f.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new f.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new f.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new f.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new f.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new f.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new f.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new f.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,m.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new R.Client(T.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),L.ProxyChannel.toService(a.getChannel(O.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._register(a.onDidProcessExit(w=>{this._onPtyHostExit.fire(w.code),this._isDisposed||(this._restartCount<=D.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${w.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${w.code}, giving up`))}));const E=a.getChannel(O.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{g.LogLevelChannelClient.setLevel(E,this._logService.getLevel())}));const p=L.ProxyChannel.toService(a.getChannel(O.TerminalIpcChannels.PtyHost));return this._register(p.onProcessData(w=>this._onProcessData.fire(w))),this._register(p.onProcessExit(w=>this._onProcessExit.fire(w))),this._register(p.onProcessReady(w=>this._onProcessReady.fire(w))),this._register(p.onProcessTitleChanged(w=>this._onProcessTitleChanged.fire(w))),this._register(p.onProcessShellTypeChanged(w=>this._onProcessShellTypeChanged.fire(w))),this._register(p.onProcessOverrideDimensions(w=>this._onProcessOverrideDimensions.fire(w))),this._register(p.onProcessResolvedShellLaunchConfig(w=>this._onProcessResolvedShellLaunchConfig.fire(w))),this._register(p.onProcessReplay(w=>this._onProcessReplay.fire(w))),this._register(p.onProcessOrphanQuestion(w=>this._onProcessOrphanQuestion.fire(w))),[a,p]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,C,E,p,w,v,o,i,t,n){const r=setTimeout(()=>this._handleUnresponsiveCreateProcess(),O.HeartbeatConstants.CreateProcessTimeout),c=await this._proxy.createProcess(a,C,E,p,w,v,o,i,t,n);return clearTimeout(r),d=Math.max(d,c),c}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(a){return this._proxy.listProcesses(a)}start(a){return this._proxy.start(a)}shutdown(a,C){return this._proxy.shutdown(a,C)}input(a,C){return this._proxy.input(a,C)}resize(a,C,E){return this._proxy.resize(a,C,E)}acknowledgeDataEvent(a,C){return this._proxy.acknowledgeDataEvent(a,C)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier+O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${O.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};y=ue([Y(0,A.ILogService)],y),e.PtyHostService=y}),define(Q[51],Z([0,1,41]),function(G,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function A(T,L,f,g){const D=(0,m.setProperty)(T,L,f,g)[0];return D&&(T=T.substring(0,D.offset)+D.content+T.substring(D.offset+D.length)),T}e.edit=A;function O(T,L,f){let g=f;for(;g>=0;){if(T.charAt(g)===L.charAt(L.length-1)&&L.length===1)return g+1;if(g--,L.length===2&&g>=0&&T.charAt(g)===L.charAt(0))return g+2}return 0}e.getLineStartOffset=O;function R(T,L,f){let g=f;for(;g>=0;)if(T.charAt(g)===L.charAt(L.length-1)&&L.length===1||(g++,L.length===2&&g>=0&&T.charAt(g)===L.charAt(1)))return g;return T.length-1}e.getLineEndOffset=R}),define(Q[180],Z([0,1,26,55]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(d,y,b,a,C){var E,p;const w=[],v=[],o=[];if(!y){const q=d.filter(({identifier:W})=>C.every(N=>N.toLowerCase()!==W.id.toLowerCase()));return{added:w,removed:v,updated:o,remote:q.length>0?q:null}}d=d.map(g),y=y.map(g),b=b?b.map(g):null;const i=new Map,t=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};d.forEach(({identifier:q})=>t(q)),y.forEach(({identifier:q})=>t(q)),b&&b.forEach(({identifier:q})=>t(q));const n=q=>{const W=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${q.identifier.id.toLowerCase()}`},r=(q,W)=>(q.set(n(W),W),q),c=d.reduce(r,new Map),s=y.reduce(r,new Map),l=y.reduce((q,W)=>{const N=n(W);W=(0,m.deepClone)(W);const $=c.get(N);return $&&($.installed&&(W.installed=!0),W.version||(W.version=$.version)),r(q,W)},new Map),h=b?b.reduce(r,new Map):null,S=a.reduce(r,new Map),I=C.reduce((q,W)=>{const N=i.get(W.toLowerCase());return q.add(N?`uuid:${N}`:`id:${W.toLowerCase()}`)},new Set),u=R(c,s,I);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const q=R(h,c,I),W=R(h,s,I),N=($,V)=>{const B=c.get($);if(B){const M=s.get($);return Object.assign(Object.assign({},V?M:B),{version:(M.version&&A.gt(M.version,B.version),B.version),state:T(B,M,h==null?void 0:h.get($))})}};for(const $ of W.removed.values()){const V=c.get($);V&&v.push(V.identifier)}for(const $ of W.added.values())if(q.added.has($)){if(u.updated.has($)){const V=N($,!0);V&&(o.push(D(V,$)),l.set($,V))}}else{const V=s.get($);V.installed&&w.push(D(V,$))}for(const $ of W.updated.values()){const V=N($,!0);V&&(o.push(D(V,$)),l.set($,V))}for(const $ of q.added.values())W.added.has($)||l.set($,c.get($));for(const $ of q.updated.values())if(!W.removed.has($)&&!W.updated.has($)){const V=N($,!1);V&&(((E=l.get($))===null||E===void 0?void 0:E.installed)&&(V.installed=!0),l.set($,V))}for(const $ of q.removed.values())!S.has($)&&!W.updated.has($)&&((p=h==null?void 0:h.get($))===null||p===void 0?void 0:p.installed)&&l.delete($)}const P=[],_=R(s,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((q,W)=>P.push(D(q,W))),{added:w,removed:v,updated:o,remote:P.length?P:null}}e.merge=O;function R(d,y,b,{checkInstalledProperty:a,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const E=d?[...d.keys()].filter(i=>!b.has(i)):[],p=[...y.keys()].filter(i=>!b.has(i)),w=p.filter(i=>E.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),v=E.filter(i=>p.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),o=new Set;for(const i of E)if(!v.has(i)){const t=d.get(i),n=y.get(i);(!n||t.disabled!==n.disabled||!f(t.state,n.state)||C&&t.version!==n.version||a&&t.installed!==n.installed)&&o.add(i)}return{added:w,removed:v,updated:o}}function T(d,y,b){const a=d.state,C=y.state,E=b==null?void 0:b.state;if(!y.version||a&&A.gt(d.version,y.version))return a;if(C&&A.gt(y.version,d.version)||!a)return C;if(!C)return a;const p=(0,m.deepClone)(a),w=E?L(E,C):{added:Object.keys(C).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set},v=E?L(E,a):{added:Object.keys(a).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set};for(const o of[...w.added.values(),...w.updated.values()])p[o]=C[o];for(const o of w.removed.values())v.updated.has(o)||delete p[o];return p}function L(d,y){const b=Object.keys(d),a=Object.keys(y),C=a.filter(w=>b.indexOf(w)===-1).reduce((w,v)=>(w.add(v),w),new Set),E=b.filter(w=>a.indexOf(w)===-1).reduce((w,v)=>(w.add(v),w),new Set),p=new Set;for(const w of b)if(!E.has(w)){const v=d[w],o=y[w];(0,m.equals)(v,o)||p.add(w)}return{added:C,removed:E,updated:p}}function f(d={},y={}){const{added:b,removed:a,updated:C}=L(d,y);return b.size===0&&a.size===0&&C.size===0}function g(d){return Object.assign(Object.assign({},d),{disabled:!!d.disabled,installed:!!d.installed})}function D(d,y){const b={identifier:{id:d.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return d.version&&(b.version=d.version),d.disabled&&(b.disabled=!0),d.installed&&(b.installed=!0),d.state&&(b.state=d.state),b}}),define(Q[82],Z([0,1,18,3,2,34,4,28,19]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,T.createDecorator)("IExtensionsStorageSyncService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let D=class Ye extends O.Disposable{constructor(y,b){super();this.storageService=y,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new A.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(a=>this.onDidChangeStorageValue(a)))}static toKey(y){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const b=g.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const y=this.storageService.keys(0,1);for(const b of y){const a=Ye.fromKey(b);a&&this.extensionsWithKeysForSync.add(a.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Ye.fromKey(y.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,b){this.storageService.store(Ye.toKey(y),JSON.stringify(b),0,1)}getKeysForSync(y){var b;const a=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[y.id.toLowerCase()],C=this.storageService.get(Ye.toKey(y),0),E=C?JSON.parse(C):void 0;return E&&a?(0,m.distinct)([...E,...a]):E||a}};D=ue([Y(0,f.IStorageService),Y(1,L.IProductService)],D),e.ExtensionsStorageSyncService=D}),define(Q[83],Z([0,1,18,24,4]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,O.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,f){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return g=g.filter(D=>D!==L&&D!==`-${L}`),f&&g.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}updateSynchronizedExtensions(L,f){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return g=g.filter(D=>D!==L&&D!==`-${L}`),f&&g.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}getIgnoredExtensions(L){const f=L.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),g=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),D=[],d=[];if(Array.isArray(g))for(const y of g)y.startsWith("-")?d.push(y.substring(1)):D.push(y);return(0,m.distinct)([...f,...D].filter(y=>d.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(f=>f.toLowerCase())}};R=ue([Y(0,A.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(Q[181],Z([0,1,26,32,18,140,51]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function L(o){return(0,A.parse)(o)||[]}e.parseKeybindings=L;async function f(o,i,t,n,r){const c=L(o),s=L(i),l=t?L(t):null,h=[...c,...s,...l||[]].map(B=>B.key),S=await r.resolveUserBindings(h);let I=D(c,s,l,S);if(!I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!I.hasLocalForwarded&&I.hasRemoteForwarded)return{mergeContent:i,hasChanges:!0,hasConflicts:!1};if(I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const u=y(c),P=y(s),_=l?y(l):null,q=a(u,P,S),W=_?a(_,u,S):{added:[...u.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},N=_?a(_,P,S):{added:[...P.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},$=g(q,W,N);let V=o;for(const B of $.removed.values())$.conflicts.has(B)||(V=w(V,B,n));for(const B of $.added.values())if(!$.conflicts.has(B)){const M=P.get(B);if(M.some(F=>F.command!==`-${B}`&&I.conflicts.has(S[F.key]))){$.conflicts.add(B);continue}V=p(V,M,n)}for(const B of $.updated.values())if(!$.conflicts.has(B)){const M=P.get(B);if(M.some(F=>F.command!==`-${B}`&&I.conflicts.has(S[F.key]))){$.conflicts.add(B);continue}V=v(V,B,M,n)}return{mergeContent:V,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=f;function g(o,i,t){const n=new Set,r=new Set,c=new Set,s=new Set;for(const l of i.removed.values())t.updated.has(l)&&s.add(l);for(const l of t.removed.values())s.has(l)||(i.updated.has(l)?s.add(l):r.add(l));for(const l of i.added.values())s.has(l)||t.added.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.added.values())s.has(l)||(i.added.has(l)?o.updated.has(l)&&s.add(l):n.add(l));for(const l of i.updated.values())s.has(l)||t.updated.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.updated.values())s.has(l)||(i.updated.has(l)?o.updated.has(l)&&s.add(l):c.add(l));return{added:n,removed:r,updated:c,conflicts:s}}function D(o,i,t,n){const r=new Set,c=d(o,n),s=d(i,n),l=t?d(t,n):null,h=b(c,s);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const S=l?b(l,c):{added:[...c.keys()].reduce((W,N)=>(W.add(N),W),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const I=l?b(l,s):{added:[...s.keys()].reduce((W,N)=>(W.add(N),W),new Set),removed:new Set,updated:new Set};if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:u,removed:P,updated:_,conflicts:q}=g(h,S,I);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:P,updated:_,conflicts:q}}function d(o,i){const t=new Map;for(const n of o){const r=i[n.key];let c=t.get(r);c||(c=[],t.set(r,c)),c.push(n)}return t}function y(o){const i=new Map;for(const t of o){const n=t.command[0]==="-"?t.command.substring(1):t.command;let r=i.get(n);r||(r=[],i.set(n,r)),r.push(t)}return i}function b(o,i){const t=[...o.keys()],n=[...i.keys()],r=n.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=t.filter(l=>n.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),s=new Set;for(const l of t)if(!c.has(l)){const h=o.get(l).map(I=>Object.assign(Object.assign({},I),{key:l})),S=i.get(l).map(I=>Object.assign(Object.assign({},I),{key:l}));(0,O.equals)(h,S,(I,u)=>E(I,u))||s.add(l)}return{added:r,removed:c,updated:s}}function a(o,i,t){const n=[...o.keys()],r=[...i.keys()],c=r.filter(h=>n.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),s=n.filter(h=>r.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),l=new Set;for(const h of n)if(!s.has(h)){const S=o.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),I=i.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));C(S,I)||l.add(h)}return{added:c,removed:s,updated:l}}function C(o,i){return!(!(0,O.equals)(o.filter(({command:t})=>t[0]!=="-"),i.filter(({command:t})=>t[0]!=="-"),(t,n)=>E(t,n))||!(0,O.equals)(o.filter(({command:t})=>t[0]==="-"),i.filter(({command:t})=>t[0]==="-"),(t,n)=>E(t,n)))}function E(o,i){if(o.command!==i.command||o.key!==i.key)return!1;const t=R.ContextKeyExpr.deserialize(o.when),n=R.ContextKeyExpr.deserialize(i.when);return!(t&&!n||!t&&n||t&&n&&!t.equals(n)||!m.equals(o.args,i.args))}function p(o,i,t){for(const n of i)o=T.edit(o,[-1],n,t);return o}function w(o,i,t){const n=L(o);for(let r=n.length-1;r>=0;r--)(n[r].command===i||n[r].command===`-${i}`)&&(o=T.edit(o,[r],void 0,t));return o}function v(o,i,t,n){const r=L(o),c=r.findIndex(s=>s.command===i||s.command===`-${i}`);for(let s=r.length-1;s>=0;s--)(r[s].command===i||r[s].command===`-${i}`)&&(o=T.edit(o,[s],void 0,n));for(let s=t.length-1;s>=0;s--)o=T.edit(o,[c],t[s],n);return o}}),define(Q[182],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function m(R,T,L){const f={},g={},D=new Set;if(!T)return{local:{added:f,updated:g,removed:[...D.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const d=A(R,T);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:f,updated:g,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=A(L,R),b=A(L,T),a={},C={},E=new Set,p=new Set;for(const w of y.removed.values())b.updated.has(w)?f[w]=T[w]:E.add(w);for(const w of b.removed.values())p.has(w)||(y.updated.has(w)?p.add(w):D.add(w));for(const w of y.updated.values())p.has(w)||(b.updated.has(w)?d.updated.has(w)&&p.add(w):C[w]=R[w]);for(const w of b.updated.values())p.has(w)||(y.updated.has(w)?d.updated.has(w)&&p.add(w):R[w]!==void 0&&(g[w]=T[w]));for(const w of y.added.values())p.has(w)||(b.added.has(w)?d.updated.has(w)&&p.add(w):a[w]=R[w]);for(const w of b.added.values())p.has(w)||(y.added.has(w)?d.updated.has(w)&&p.add(w):f[w]=T[w]);return{local:{added:f,removed:[...D.values()],updated:g},remote:{added:a,removed:[...E.values()],updated:C},conflicts:[...p.values()]}}e.merge=m;function A(R,T){const L=R?Object.keys(R):[],f=T?Object.keys(T):[],g=f.filter(y=>L.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),D=L.filter(y=>f.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),d=new Set;for(const y of L)if(!D.has(y)){const b=R[y],a=T[y];b!==a&&d.add(y)}return{added:g,removed:D,updated:d}}function O(R,T){const{added:L,removed:f,updated:g}=A(R,T);return L.size===0&&f.size===0&&g.size===0}e.areSame=O}),define(Q[20],Z([0,1,4,29,35,39,124,78,12,18,17]),function(G,e,m,A,O,R,T,L,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function d(){const s=O.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=d;function y(){const s=O.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(I=>!!s[I].ignoreSync),h=Object.keys(s).filter(I=>s[I].scope===2||s[I].scope===6),S=d();return(0,g.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...h,...S])}e.getDefaultIgnoredSettings=y;function b(){const s="vscode://schemas/ignoredSettings",l=O.Registry.as(R.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=O.Registry.as(L.Extensions.JSONContribution),S=()=>{const I=d(),u=y().filter(W=>W!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(R.allSettings.properties).filter(W=>u.indexOf(W)===-1),_=u.filter(W=>I.indexOf(W)===-1),q={items:{type:"string",enum:[...P,..._.map(W=>`-${W}`)]}};h.registerSchema(s,q)};return l.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=b;function a(s){return s&&(0,D.isObject)(s)&&(0,D.isString)(s.id)&&(0,D.isArray)(s.scopes)}e.isAuthenticationProvider=a;var C;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=E;var p;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.NoRef="NoRef",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(p=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(l,h,S,I){super(l);this.code=h,this.resource=S,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class v extends w{constructor(l,h,S,I){super(l,S,void 0,I);this.url=h,this.operationId=I}}e.UserDataSyncStoreError=v;class o extends w{constructor(l,h){super(l,h)}}e.UserDataAutoSyncError=o,function(s){function l(h){if(h instanceof s)return h;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(S&&S[1]){const I=S[2]==="unknown"?void 0:S[2],u=S[3]==="unknown"?void 0:S[3];return new s(h.message,S[1],I,u)}return new s(h.message,p.Unknown)}s.toUserDataSyncError=l}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var t;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var n;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(s){return`sync.enable.${s}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,l){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,f.isEqualOrParent)(s,(0,f.joinPath)(l.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Q[45],Z([0,1,2,9,22,5,20,10,12,6,3,25,32,120,24,17,21,18,44,19,30]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=i;function t(l,h,S){return S.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}let n=class extends m.Disposable{constructor(h,S,I,u,P,_,q,W,N,$){super();this.resource=h,this.fileService=S,this.environmentService=I,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=q,this.telemetryService=W,this.logService=N,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new g.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(I.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(I.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,T.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,I,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(I,S,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const S=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(S)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:I})=>I!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const S=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),S==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,S={}){await this._sync(h,!0,S)}async preview(h,S={}){return this._sync(h,!1,S)}async apply(h,S={}){try{this.syncHeaders=Object.assign({},S);const I=await this.doApply(h);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,S,I){try{if(this.syncHeaders=Object.assign({},I),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(h,P);return u=await this.performSync(_,P,S),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(h){const S=await this.resolveContent(h);if(!S)return!1;const I=this.parseSyncData(S);if(!I)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:P.ref,syncData:I},u,o.CancellationToken.None),q=[];for(const W of _){const N=await this.getAcceptResult(W,W.remoteResource,void 0,o.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(W,W.previewResource,W.remoteContent,o.CancellationToken.None);q.push([W,Object.assign(Object.assign({},N),{remoteChange:$!==0?$:2})])}await this.applyResult(P,u,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,S){if(S){const I=h&&h.latest?h.latest[this.resource]:void 0;if(S.ref===I||I===void 0&&S.syncData===null)return S}return this.getRemoteUserData(S)}async performSync(h,S,I){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new T.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,h.syncData.version),T.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,S,I)}catch(u){if(u instanceof T.UserDataSyncError)switch(u.code){case T.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,S,I);case T.UserDataSyncErrorCode.Conflict:case T.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),S=await this.getLastSyncUserData(),this.performSync(h,S,I)}throw u}}async doSync(h,S,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,g.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(h,S,I,P)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":I?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(h){return await this.updateSyncResourcePreview(h,async S=>{const I=await this.getMergeResult(S,o.CancellationToken.None);await this.fileService.writeFile(S.previewResource,O.VSBuffer.fromString((I==null?void 0:I.content)||""));const u=I&&!I.hasConflicts?await this.getAcceptResult(S,S.previewResource,void 0,o.CancellationToken.None):void 0;return S.acceptResult=u,S.mergeState=I.hasConflicts?"conflict":u?"accepted":"preview",S.localChange=u?u.localChange:I.localChange,S.remoteChange=u?u.remoteChange:I.remoteChange,S}),this.syncPreviewPromise}async accept(h,S){return await this.updateSyncResourcePreview(h,async I=>{const u=await this.getAcceptResult(I,h,S,o.CancellationToken.None);return I.acceptResult=u,I.mergeState="accepted",I.localChange=u.localChange,I.remoteChange=u.remoteChange,I}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async S=>{const I=await this.getMergeResult(S,o.CancellationToken.None);return await this.fileService.writeFile(S.previewResource,O.VSBuffer.fromString(I.content||"")),S.acceptResult=void 0,S.mergeState="preview",S.localChange=I.localChange,S.remoteChange=I.remoteChange,S}),this.syncPreviewPromise}async updateSyncResourcePreview(h,S){if(!!this.syncPreviewPromise){let I=await this.syncPreviewPromise;const u=I.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:q})=>this.extUri.isEqual(P,h)||this.extUri.isEqual(_,h)||this.extUri.isEqual(q,h));u!==-1&&(this.syncPreviewPromise=(0,g.createCancelablePromise)(async P=>{const _=[...I.resourcePreviews];return _[u]=await S(_[u]),Object.assign(Object.assign({},I),{resourcePreviews:_})}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const S=await this.syncPreviewPromise;return S.resourcePreviews.some(({mergeState:I})=>I==="conflict")?"hasConflicts":S.resourcePreviews.some(({mergeState:I})=>I!=="accepted")?"syncing":(await this.applyResult(S.remoteUserData,S.lastSyncUserData,S.resourcePreviews.map(I=>[I,I.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const S=h.filter(({mergeState:I})=>I==="conflict");(0,p.equals)(this._conflicts,S,(I,u)=>this.extUri.isEqual(I.previewResource,u.previewResource))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:S,ref:I})=>({created:S,uri:this.toRemoteBackupResource(I)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:S,ref:I})=>({created:S,uri:this.toLocalBackupResource(I)}))}toRemoteBackupResource(h){return R.URI.from({scheme:T.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return R.URI.from({scheme:T.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:I}=await this.getUserData(S);if(I){const u=this.parseSyncData(I);return u==null?void 0:u.machineId}}}async resolveContent(h){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:I}=await this.getUserData(S);return I}return this.extUri.isEqual(h,this.toLocalBackupResource(S))?this.userDataSyncBackupStoreService.resolveContent(this.resource,S):null}async resolvePreviewContent(h){const S=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(S)for(const I of S.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,h))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,h))return I.remoteContent;if(this.extUri.isEqual(I.localResource,h))return I.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,S,I,u){var P;const _=await this.currentMachineIdPromise,q=!!((P=h.syncData)===null||P===void 0?void 0:P.machineId)&&h.syncData.machineId===_,W=S===null&&q&&!this.hasSyncResourceStateVersionChanged?h:S,N=await this.generateSyncPreview(h,W,u),$=[];for(const V of N){const B=V.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===0&&V.remoteChange===0)$.push(Object.assign(Object.assign({},V),{acceptedResource:B,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const M=I?await this.getMergeResult(V,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(V.previewResource,O.VSBuffer.fromString((M==null?void 0:M.content)||""));const F=M&&!M.hasConflicts?await this.getAcceptResult(V,V.previewResource,void 0,u):void 0;$.push(Object.assign(Object.assign({},V),{acceptResult:F,mergeState:(M==null?void 0:M.hasConflicts)?"conflict":F?"accepted":"preview",localChange:F?F.localChange:M?M.localChange:V.localChange,remoteChange:F?F.remoteChange:M?M.remoteChange:V.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:S,resourcePreviews:$,isLastSyncFromCurrentMachine:q}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),S=JSON.parse(h.value.toString()),I=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=S.version&&I&&S.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${S.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;const u=S;if(u.content===null)return{ref:S.ref,syncData:null};const P=JSON.parse(u.content);if(i(P))return Object.assign(Object.assign({},S),{syncData:P,content:void 0})}catch(h){h instanceof A.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,S={}){if(S.ref||S.content||S.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),u=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:I},S);await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(u)))}async getRemoteUserData(h){const{ref:S,content:I}=await this.getUserData(h);let u=null;return I!==null&&(u=this.parseSyncData(I)),{ref:S,syncData:u}}parseSyncData(h){try{const S=JSON.parse(h);if(i(S))return S}catch(S){this.logService.error(S)}throw new T.UserDataSyncError((0,b.localize)(1,null),T.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if((0,C.isString)(h)){const S=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:S}}else{const S=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,S,this.syncHeaders)}}async updateRemoteUserData(h,S){const I=await this.currentMachineIdPromise,u={version:this.version,machineId:I,content:h};return S=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),S,this.syncHeaders),{ref:S,syncData:u}}async backupLocal(h){const S={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(S))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};n=ue([Y(1,A.IFileService),Y(2,L.IEnvironmentService),Y(3,v.IStorageService),Y(4,T.IUserDataSyncStoreService),Y(5,T.IUserDataSyncBackupStoreService),Y(6,T.IUserDataSyncResourceEnablementService),Y(7,d.ITelemetryService),Y(8,T.IUserDataSyncLogService),Y(9,a.IConfigurationService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(h,S,I,u,P,_,q,W,N,$,V){super(S,I,u,P,_,q,W,N,$,V);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,S,I){try{S?await this.fileService.writeFile(this.file,O.VSBuffer.fromString(h),I?void 0:S):await this.fileService.createFile(this.file,O.VSBuffer.fromString(h),{overwrite:I})}catch(u){throw u instanceof A.FileOperationError&&u.fileOperationResult===1||u instanceof A.FileOperationError&&u.fileOperationResult===3?new T.UserDataSyncError(u.message,T.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};r=ue([Y(2,A.IFileService),Y(3,L.IEnvironmentService),Y(4,v.IStorageService),Y(5,T.IUserDataSyncStoreService),Y(6,T.IUserDataSyncBackupStoreService),Y(7,T.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,T.IUserDataSyncLogService),Y(10,a.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let c=class extends r{constructor(h,S,I,u,P,_,q,W,N,$,V,B){super(h,S,I,u,P,_,q,W,N,$,B);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(h){const S=[];return(0,y.parse)(h,S,{allowEmptyContent:!0,allowTrailingComma:!0}),S.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=ue([Y(2,A.IFileService),Y(3,L.IEnvironmentService),Y(4,v.IStorageService),Y(5,T.IUserDataSyncStoreService),Y(6,T.IUserDataSyncBackupStoreService),Y(7,T.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,T.IUserDataSyncLogService),Y(10,T.IUserDataSyncUtilService),Y(11,a.IConfigurationService)],c),e.AbstractJsonFileSynchroniser=c;let s=class{constructor(h,S,I,u){this.resource=h,this.environmentService=S,this.logService=I,this.fileService=u,this.extUri=this.fileService.hasCapability(S.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,S,f.extUri)}async initialize({ref:h,content:S}){if(!S){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(S);if(!!I){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:I})}catch(P){this.logService.error(P)}}}parseSyncData(h){try{const S=JSON.parse(h);if(i(S))return S}catch(S){this.logService.error(S)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,S={}){const I=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},S);await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(I)))}};s=ue([Y(1,L.IEnvironmentService),Y(2,T.IUserDataSyncLogService),Y(3,A.IFileService)],s),e.AbstractInitializer=s}),define(Q[183],Z([0,1,20,3,10,29,34,9,24,180,45,25,5,46,41,21,19,30,83,11,82,6]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,h){const S=JSON.parse(l.content);if(l.version===1||l.version===2){const I=(await h.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of S)l.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),l.version===2&&I.every(P=>!(0,T.areSameExtensions)(P.identifier,u.identifier))&&(u.installed=!0)}return S}function n(l,h,S){const I=S.get((0,T.getExtensionId)(l,h),0)||"{}";return JSON.parse(I)}function r(l,h,S,I){I.store((0,T.getExtensionId)(l,h),JSON.stringify(S),0,1)}let c=class rt extends D.AbstractSynchroniser{constructor(h,S,I,u,P,_,q,W,N,$,V,B,M,F){super("extensions",S,h,I,u,P,B,M,N,V);this.storageService=I,this.extensionManagementService=_,this.extensionEnablementService=q,this.ignoredExtensionsManagementService=W,this.extensionGalleryService=$,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtension,k=>!!k.gallery),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,k=>!k.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,S){const I=h.syncData?await t(h.syncData,this.extensionManagementService):null,u=(S==null?void 0:S.skippedExtensions)||[],P=(S==null?void 0:S.syncData)?await t(S.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),q=this.getLocalExtensions(_),W=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:N,removed:$,updated:V,remote:B}=(0,g.merge)(q,I,P,u,W),M={added:N,removed:$,updated:V,remote:B,content:this.getPreviewContent(q,N,V,$),localChange:N.length>0||$.length>0||V.length>0?2:0,remoteChange:B!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format(q),localExtensions:q,remoteResource:this.remoteResource,remoteContent:I?this.format(I):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,S,I,u){const P=[...S,...I],_=new Set,q=W=>{_.add(W.id.toLowerCase()),W.uuid&&_.add(W.uuid)};P.forEach(({identifier:W})=>q(W)),u.forEach(q);for(const W of h)_.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&_.has(W.identifier.uuid)||P.push(W);return this.format(P)}async getMergeResult(h,S){return Object.assign(Object.assign({},h.previewResult),{hasConflicts:!1})}async getAcceptResult(h,S,I,u){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(S,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(h){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),u=(0,g.merge)(h.localExtensions,null,null,h.skippedExtensions,I),{added:P,removed:_,updated:q,remote:W}=u;return{content:h.localContent,added:P,removed:_,updated:q,remote:W,localChange:P.length>0||_.length>0||q.length>0?2:0,remoteChange:W!==null?2:0}}async acceptRemote(h){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),u=h.remoteContent?JSON.parse(h.remoteContent):null;if(u!==null){const P=(0,g.merge)(h.localExtensions,u,h.localExtensions,[],I),{added:_,removed:q,updated:W,remote:N}=P;return{content:h.remoteContent,added:_,removed:q,updated:W,remote:N,localChange:_.length>0||q.length>0||W.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:h.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(h,S,I,u){let{skippedExtensions:P,localExtensions:_}=I[0][0],{added:q,removed:W,updated:N,remote:$,localChange:V,remoteChange:B}=I[0][1];if(V===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),V!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(q,W,N,P)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify($);h=await this.updateRemoteUserData(M,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(S==null?void 0:S.ref)!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:rt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,rt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),P=this.getLocalExtensions(I).filter(_=>!u.some(q=>(0,T.areSameExtensions)({id:q},_.identifier)));return this.format(P)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let S=await super.resolveContent(h);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(h)),S){const I=this.parseSyncData(S);if(I)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(I))}}return null}format(h){h.sort((u,P)=>!u.identifier.uuid&&P.identifier.uuid?-1:u.identifier.uuid&&!P.identifier.uuid?1:(0,C.compare)(u.identifier.id,P.identifier.id));const S=JSON.stringify(h),I=(0,b.format)(S,void 0,{});return(0,a.applyEdits)(S,I)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(I=>I.installed||I.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,S,I,u){const P=[],_=[],q=await this.extensionManagementService.getInstalled();if(S.length){const N=q.filter(({identifier:$,isBuiltin:V})=>!V&&S.some(B=>(0,T.areSameExtensions)($,B)));await i.Promises.settled(N.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),P.push($.identifier)}))}(h.length||I.length)&&await i.Promises.settled([...h,...I].map(async N=>{const $=q.find(B=>(0,T.areSameExtensions)(B.identifier,N.identifier));if($&&$.isBuiltin){N.state&&$.manifest.version===N.version&&this.updateExtensionState(N.state,$.manifest.publisher,$.manifest.name,$.manifest.version),N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id)),P.push(N.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(N.identifier);if(N.state&&($?$.manifest.version===N.version:!!V)){const B=$?$.manifest.publisher:V.publisher,M=$?$.manifest.name:V.name;this.updateExtensionState(N.state,B,M,$==null?void 0:$.manifest.version)}if(V)try{N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,V.version)),$||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,V.version),P.push(V.identifier))}catch(B){_.push(N),this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else _.push(N)}));const W=[];for(const N of u)P.some($=>(0,T.areSameExtensions)($,N.identifier))||W.push(N);for(const N of _)W.some($=>(0,T.areSameExtensions)($.identifier,N.identifier))||W.push(N);return W}updateExtensionState(h,S,I,u){const P=n(S,I,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,T.getGalleryExtensionId)(S,I),version:u}):void 0;_?_.forEach(q=>{P[q]=h[q]}):Object.keys(h).forEach(q=>P[q]=h[q]),r(S,I,P,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const S=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:I,isBuiltin:u,manifest:P})=>{const _={identifier:I,version:P.version};S.some(q=>(0,T.areSameExtensions)(q,I))&&(_.disabled=!0),u||(_.installed=!0);try{const q=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:P.version});if(q){const W=n(P.publisher,P.name,this.storageService);_.state=Object.keys(W).reduce((N,$)=>(q.includes($)&&(N[$]=W[$]),N),{})}}catch(q){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,v.getErrorMessage)(q))}return _})}};c.EXTENSIONS_DATA_URI=y.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=ue([Y(0,O.IEnvironmentService),Y(1,L.IFileService),Y(2,E.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,w.IIgnoredExtensionsManagementService),Y(8,m.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,f.IConfigurationService),Y(11,m.IUserDataSyncResourceEnablementService),Y(12,d.ITelemetryService),Y(13,o.IExtensionsStorageSyncService)],c),e.ExtensionsSynchroniser=c;let s=class extends D.AbstractInitializer{constructor(h,S,I,u,P,_,q,W){super("extensions",q,W,_);this.extensionManagementService=h,this.galleryService=S,this.extensionEnablementService=I,this.storageService=u,this.ignoredExtensionsManagementService=P}async doInitialize(h){const S=h.syncData?await t(h.syncData,this.extensionManagementService):null;if(!S){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(S)}async initializeRemoteExtensions(h){const S=[],I=await this.extensionManagementService.getInstalled(),u=new Map,P=[],_={names:[],uuids:[]},q=[];for(const W of h)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(W.identifier.id)){const N=I.find($=>(0,T.areSameExtensions)($.identifier,W.identifier));N?(P.push({syncExtension:W,installedExtension:N}),W.disabled&&q.push(W.identifier)):W.installed&&(u.set(W.identifier.id.toLowerCase(),W),W.identifier.uuid?_.uuids.push(W.identifier.uuid):_.names.push(W.identifier.id),W.disabled&&q.push(W.identifier))}for(const{syncExtension:W,installedExtension:N}of P)if(W.state){const $=n(N.manifest.publisher,N.manifest.name,this.storageService);Object.keys(W.state).forEach(V=>$[V]=W.state[V]),r(N.manifest.publisher,N.manifest.name,$,this.storageService)}if(q.length)for(const W of q)this.logService.trace("Disabling extension...",W.id),await this.extensionEnablementService.disableExtension(W),this.logService.info("Disabling extension",W.id);if(_.names.length||_.uuids.length){const W=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},p.CancellationToken.None)).firstPage;for(const N of W)try{const $=u.get(N.identifier.id.toLowerCase());$.state&&r(N.publisher,N.name,$.state,this.storageService),this.logService.trace("Installing extension...",N.identifier.id);const V=await this.extensionManagementService.installFromGallery(N,{isMachineScoped:!1});q.some(B=>(0,T.areSameExtensions)(B,N.identifier))||S.push(V),this.logService.info("Installed extension.",N.identifier.id)}catch($){this.logService.error($)}}return S}};s=ue([Y(0,R.IExtensionManagementService),Y(1,R.IExtensionGalleryService),Y(2,R.IGlobalExtensionEnablementService),Y(3,E.IStorageService),Y(4,w.IIgnoredExtensionsManagementService),Y(5,L.IFileService),Y(6,O.IEnvironmentService),Y(7,m.IUserDataSyncLogService)],s),e.ExtensionsInitializer=s}),define(Q[184],Z([0,1,26,20]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(L,f,g,D,d){if(!f)return{remote:Object.keys(L).length>0?L:null,local:{added:{},removed:[],updated:{}}};const y=R(L,f);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=g?R(g,f):{added:Object.keys(f).reduce((w,v)=>(w.add(v),w),new Set),removed:new Set,updated:new Set},a=g?R(g,L):{added:Object.keys(L).reduce((w,v)=>(w.add(v),w),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},E=m.deepClone(f),p=!g;for(const w of a.added.values())w!==A.SYNC_SERVICE_URL_TYPE&&p&&b.added.has(w)||(E[w]=L[w]);for(const w of a.updated.values())E[w]=L[w];for(const w of a.removed.values())D.unregistered.includes(w)||delete E[w];for(const w of b.added.values()){const v=f[w];if(D.machine.includes(w)){d.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(!(g&&a.added.has(w))){const o=L[w];o&&o.value===v.value||w===A.SYNC_SERVICE_URL_TYPE&&p&&a.added.has(w)||(o?C.updated[w]=v:C.added[w]=v)}}for(const w of b.updated.values()){const v=f[w];if(D.machine.includes(w)){d.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(!(a.updated.has(w)||a.removed.has(w))){const o=L[w];o&&o.value===v.value||(C.updated[w]=v)}}for(const w of b.removed.values()){if(D.machine.includes(w)){d.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}a.updated.has(w)||a.removed.has(w)||C.removed.push(w)}return{local:C,remote:T(E,f)?null:E}}e.merge=O;function R(L,f){const g=Object.keys(L),D=Object.keys(f),d=D.filter(a=>g.indexOf(a)===-1).reduce((a,C)=>(a.add(C),a),new Set),y=g.filter(a=>D.indexOf(a)===-1).reduce((a,C)=>(a.add(C),a),new Set),b=new Set;for(const a of g)if(!y.has(a)){const C=L[a],E=f[a];m.equals(C,E)||b.add(a)}return{added:d,removed:y,updated:b}}function T(L,f){const{added:g,removed:D,updated:d}=R(L,f);return g.size===0&&D.size===0&&d.size===0}}),define(Q[185],Z([0,1,20,22,3,10,9,51,184,32,45,25,24,5,46,41,19,7,44,31,15]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",t=["locale"];function n(h){const S=h.storage?Object.keys(h.storage).sort():[],I={};S.forEach(_=>I[_]=h.storage[_]),h.storage=I;const u=JSON.stringify(h),P=(0,a.format)(u,void 0,{});return(0,C.applyEdits)(u,P)}const r=1;let c=class st extends D.AbstractSynchroniser{constructor(S,I,u,P,_,q,W,N,$){super("globalState",S,_,$,I,u,q,W,P,N);this.environmentService=_,this.storageService=$,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(O.Event.any(O.Event.filter(S.onDidFilesChange,V=>V.contains(this.environmentService.argvResource)),O.Event.filter($.onDidChangeValue,V=>V.scope===0&&V.target!==void 0?V.target===0:$.keys(0,0).includes(V.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(S,I,u){const P=S.syncData?JSON.parse(S.syncData.content):null,_=I&&I.syncData?JSON.parse(I.syncData.content):null,q=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=this.getStorageKeys(_),{local:N,remote:$}=(0,f.merge)(q.storage,P?P.storage:null,_?_.storage:null,W,this.logService),V={content:null,local:N,remote:$,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:n(q),localUserData:q,remoteResource:this.remoteResource,remoteContent:P?n(P):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async getMergeResult(S,I){return Object.assign(Object.assign({},S.previewResult),{hasConflicts:!1})}async getAcceptResult(S,I,u,P){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(I,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(S){return{content:S.localContent,local:{added:{},removed:[],updated:{}},remote:S.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(S){if(S.remoteContent!==null){const I=JSON.parse(S.remoteContent),{local:u,remote:P}=(0,f.merge)(S.localUserData.storage,I.storage,null,S.storageKeys,this.logService);return{content:S.remoteContent,local:u,remote:P,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:S.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(S,I,u,P){let{localUserData:_}=u[0][0],{local:q,remote:W,localChange:N,remoteChange:$}=u[0][1];if(N===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),N!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(q),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const V=JSON.stringify({storage:W});S=await this.updateRemoteUserData(V,P?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(I==null?void 0:I.ref)!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,st.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return n(u)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S))return this.resolvePreviewContent(S);let I=await super.resolveContent(S);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(S)),I){const u=this.parseSyncData(I);if(u)switch(this.extUri.basename(S)){case"globalState.json":return n(JSON.parse(u.content))}}return null}async hasLocalData(){var S;try{const{storage:I}=await this.getLocalGlobalState();if(Object.keys(I).length>1||((S=I[`${i}.locale`])===null||S===void 0?void 0:S.value)!=="en")return!0}catch(I){}return!1}async getLocalGlobalState(){const S={},I=await this.getLocalArgvContent(),u=(0,g.parse)(I);for(const P of t)u[P]!==void 0&&(S[`${i}${P}`]={version:1,value:u[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(S[P]={version:1,value:_})}return{storage:S}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(S){}return"{}"}async writeLocalGlobalState({added:S,removed:I,updated:u}){const P={},_={},q=(N,$)=>{for(const V of N){if(V.startsWith(i)){P[V.substring(i.length)]=$?$[V].value:void 0;continue}if($){const B=$[V];B.value!==String(this.storageService.get(V,0))&&(_[V]=B.value)}else this.storageService.get(V,0)!==void 0&&(_[V]=void 0)}};if(q(Object.keys(S),S),q(Object.keys(u),u),q(I),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const N of Object.keys(_))this.storageService.store(N,_[N],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(S){const I=await this.getLocalArgvContent();let u=I;for(const P of Object.keys(S))u=(0,L.edit)(u,[P],S[P],{});I!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,A.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(S){const I=this.storageService.keys(0,0),u=this.storageService.keys(0,1),P=[...I,...u],_=(S==null?void 0:S.storage)?Object.keys(S.storage).filter(q=>!q.startsWith(i)&&!P.includes(q)&&this.storageService.get(q,0)!==void 0):[];if(!p.isWeb){const q=[...m.ALL_SYNC_RESOURCES.map(W=>(0,m.getEnablementKey)(W)),m.SYNC_SERVICE_URL_TYPE];_.push(...q),u.push(...q)}return{user:I,machine:u,unregistered:_}}};c.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=ue([Y(0,T.IFileService),Y(1,m.IUserDataSyncStoreService),Y(2,m.IUserDataSyncBackupStoreService),Y(3,m.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,m.IUserDataSyncResourceEnablementService),Y(6,d.ITelemetryService),Y(7,y.IConfigurationService),Y(8,E.IStorageService)],c),e.GlobalStateSynchroniser=c;let s=class extends D.AbstractInitializer{constructor(S,I,u,P){super("globalState",u,P,I);this.storageService=S}async doInitialize(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},P={};for(const _ of Object.keys(I.storage))_.startsWith(i)?u[_.substring(i.length)]=I.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=I.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(q){}for(const q of Object.keys(u))_=(0,L.edit)(_,[q],u[q],{});await this.fileService.writeFile(this.environmentService.argvResource,A.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};s=ue([Y(0,E.IStorageService),Y(1,T.IFileService),Y(2,R.IEnvironmentService),Y(3,m.IUserDataSyncLogService)],s),e.GlobalStateInitializer=s;let l=class{constructor(S,I,u,P,_){this.userDataSyncStoreClient=S,this.storageService=I,this.environmentService=u,this.fileService=P,this.logService=_}getSyncStoreType(S){var I;const u=this.parseGlobalState(S);return(I=u==null?void 0:u.storage[m.SYNC_SERVICE_URL_TYPE])===null||I===void 0?void 0:I.value}async sync(S){const I=(0,m.createSyncHeaders)((0,v.generateUuid)());try{return await this.doSync(S,I)}catch(u){if(u instanceof m.UserDataSyncError)switch(u.code){case m.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(S,I)}throw u}}async doSync(S,I){const u=await this.userDataSyncStoreClient.read("globalState",null,I),P=this.parseGlobalState(u)||{storage:{}};P.storage[m.SYNC_SERVICE_URL_TYPE]={value:S,version:r};const _=await(0,w.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),q={version:r,machineId:_,content:n(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(q),u.ref,I)}parseGlobalState({content:S}){if(!S)return null;const I=JSON.parse(S);if((0,D.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};l=ue([Y(1,E.IStorageService),Y(2,R.IEnvironmentService),Y(3,T.IFileService),Y(4,o.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Q[186],Z([0,1,9,20,181,32,121,10,24,7,17,18,45,25,19,22,3]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(o,i){const t=JSON.parse(o);if(!i)return(0,D.isUndefined)(t.all)?null:t.all;switch(g.OS){case 2:return(0,D.isUndefined)(t.mac)?null:t.mac;case 3:return(0,D.isUndefined)(t.linux)?null:t.linux;case 1:return(0,D.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=p;let w=class extends y.AbstractJsonFileSynchroniser{constructor(i,t,n,r,c,s,l,h,S,I){super(l.keybindingsResource,"keybindings",s,l,h,i,t,c,I,n,S,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(E.Event.filter(r.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,t,n){const r=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null,c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,s=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,S=!1,I=!1,u=!1;if(r){let _=s?s.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new A.UserDataSyncError((0,T.localize)(0,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!c||c!==_||c!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,O.merge)(_,r,c,l,this.userDataSyncUtilService);q.hasChanges&&(h=q.mergeContent,u=q.hasConflicts,S=u||q.mergeContent!==_,I=u||q.mergeContent!==r)}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=s.value.toString(),I=!0);const P={content:h,localChange:S?s?2:1:0,remoteChange:I?2:0,hasConflicts:u};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(i,t){return i.previewResult}async getAcceptResult(i,t,n,r){if(this.extUri.isEqual(t,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(i,t,n,r){var c;const{fileContent:s}=n[0][0];let{content:l,localChange:h,remoteChange:S}=n[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new A.UserDataSyncError((0,T.localize)(1,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(l||"[]",s,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const I=this.toSyncContent(l||"[]",(c=i.syncData)===null||c===void 0?void 0:c.content);i=await this.updateRemoteUserData(I,r?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(I){}(t==null?void 0:t.ref)!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const t=(0,R.parse)(i.value.toString());if((0,d.isNonEmptyArray)(t))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:t}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let t=await super.resolveContent(i);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(i)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(i)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(n.content)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(i.syncData.content)}getKeybindingsContentFromSyncContent(i){try{return p(i,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(i,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=i,g.OS){case 2:n.mac=i;break;case 3:n.linux=i;break;case 1:n.windows=i;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){let i=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return i!==void 0||(i=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,i!==void 0)?i:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=ue([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncBackupStoreService),Y(2,A.IUserDataSyncLogService),Y(3,f.IConfigurationService),Y(4,A.IUserDataSyncResourceEnablementService),Y(5,m.IFileService),Y(6,L.IEnvironmentService),Y(7,a.IStorageService),Y(8,A.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],w),e.KeybindingsSynchroniser=w;let v=class extends y.AbstractInitializer{constructor(i,t,n){super("keybindings",t,n,i)}async doInitialize(i){const t=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,R.parse)(i.value.toString());return!(0,d.isNonEmptyArray)(t)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return p(i,!0)}catch(t){return this.logService.error(t),null}}};v=ue([Y(0,m.IFileService),Y(1,L.IEnvironmentService),Y(2,A.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(Q[187],Z([0,1,26,32,41,46,51,20,18]),function(G,e,m,A,O,R,T,L,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function g(l,h,S){let I=[];S?I=d(S):I=D(h);const u=[],P=[...(0,L.getDisallowedIgnoredSettings)()];if(Array.isArray(I))for(const _ of I)_.startsWith("-")?P.push(_.substring(1)):u.push(_);return(0,f.distinct)([...l,...u].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=g;function D(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function d(l){const h=(0,A.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function y(l,h,S,I){if(S.length){const u=s(h),P=(0,A.parse)(h),_=(0,A.parse)(l),q=[];for(const W of S){const N=P[W],$=_[W];N===void 0?l=T.edit(l,[W],void 0,I):$!==void 0?l=T.edit(l,[W],N,I):q.push(i(W,u))}q.sort((W,N)=>W.startOffset-N.startOffset),q.forEach(W=>l=p(W.setting.key,h,l,I))}return l}e.updateIgnoredSettings=y;function b(l,h,S,I,u,P){const _=y(l,h,I,P),q=S!==_,W=S!==h;if(!q&&!W)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!W)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(W&&!q)return{conflictsSettings:[],localContent:y(h,l,I,P),remoteContent:null,hasConflicts:!1};if(S===null&&C(l)){const se=a(l,h,I)?null:y(h,l,I,P);return{conflictsSettings:[],localContent:se,remoteContent:null,hasConflicts:!1}}let N=l,$=h;const V=(0,A.parse)(l),B=(0,A.parse)(h),M=S?(0,A.parse)(S):null,F=I.reduce((se,ce)=>(se.add(ce),se),new Set),k=E(V,B,F),U=E(M,V,F),j=E(M,B,F),z=new Map,H=new Set,K=se=>{H.add(se);const ce=u.filter(({key:he})=>he===se)[0];ce?(N=T.edit(N,[se],ce.value,P),$=T.edit($,[se],ce.value,P)):z.set(se,{key:se,localValue:V[se],remoteValue:B[se]})};for(const se of U.removed.values())j.updated.has(se)?K(se):$=T.edit($,[se],void 0,P);for(const se of j.removed.values())H.has(se)||(U.updated.has(se)?K(se):N=T.edit(N,[se],void 0,P));for(const se of U.updated.values())H.has(se)||(j.updated.has(se)?k.updated.has(se)&&K(se):$=T.edit($,[se],V[se],P));for(const se of j.updated.values())H.has(se)||(U.updated.has(se)?k.updated.has(se)&&K(se):N=T.edit(N,[se],B[se],P));for(const se of U.added.values())H.has(se)||(j.added.has(se)?k.updated.has(se)&&K(se):$=p(se,N,$,P));for(const se of j.added.values())H.has(se)||(U.added.has(se)?k.updated.has(se)&&K(se):N=p(se,$,N,P));const te=z.size>0||!a(N,$,I),X=te||!a(N,l,[]),ie=te||!a($,h,[]);return{localContent:X?N:null,remoteContent:ie?$:null,conflictsSettings:[...z.values()],hasConflicts:te}}e.merge=b;function a(l,h,S){if(l===h)return!0;const I=(0,A.parse)(l),u=(0,A.parse)(h),P=S.reduce((W,N)=>(W.add(N),W),new Set),_=s(l).filter(W=>!(W.setting&&P.has(W.setting.key))),q=s(h).filter(W=>!(W.setting&&P.has(W.setting.key)));if(_.length!==q.length)return!1;for(let W=0;W<_.length;W++){const N=_[W],$=q[W];if(N.setting&&$.setting){if(N.setting.key!==$.setting.key||!m.equals(I[N.setting.key],u[N.setting.key]))return!1}else if(!N.setting&&!$.setting){if(N.value!==$.value)return!1}else return!1}return!0}e.areSame=a;function C(l){return l?s(l).length===0:!0}e.isEmpty=C;function E(l,h,S){const I=l?Object.keys(l).filter(W=>!S.has(W)):[],u=Object.keys(h).filter(W=>!S.has(W)),P=u.filter(W=>I.indexOf(W)===-1).reduce((W,N)=>(W.add(N),W),new Set),_=I.filter(W=>u.indexOf(W)===-1).reduce((W,N)=>(W.add(N),W),new Set),q=new Set;if(l){for(const W of I)if(!_.has(W)){const N=l[W],$=h[W];m.equals(N,$)||q.add(W)}}return{added:P,removed:_,updated:q}}function p(l,h,S,I){const u=(0,A.parse)(h),P=s(h),_=s(S),q=w(l,P,_);return v(S,l,u[l],q,_,I)}e.addSetting=p;function w(l,h,S){const I=h.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),u=h[I-1];if(u){if(u.setting){const _=i(u.setting.key,S);if(_)return{index:S.indexOf(_),insertAfter:!0}}else{const _=t(I,h);if(_){const q=i(_.setting.key,S);if(q){const W=n(S.indexOf(q),S),N=r(h,_,h[I]);if(W){const $=r(S,q,W),V=c(N,$);return V?{index:S.indexOf(V),insertAfter:!0}:{index:S.indexOf(W),insertAfter:!1}}else{const $=r(S,q,S[S.length-1]),V=c(N,$);return V?{index:S.indexOf(V),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const P=h[I+1];if(P)if(P.setting){const _=i(P.setting.key,S);if(_)return{index:S.indexOf(_),insertAfter:!1}}else{const _=n(I,h);if(_){const q=i(_.setting.key,S);if(q){const W=t(S.indexOf(q),S),N=r(h,h[I],_);if(W){const $=r(S,W,q),V=c(N.reverse(),$.reverse());return V?{index:S.indexOf(V),insertAfter:!1}:{index:S.indexOf(W),insertAfter:!0}}else{const $=r(S,S[0],q),V=c(N.reverse(),$.reverse());return V?{index:S.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function v(l,h,S,I,u,P){let _;return I.index===-1?_=(0,O.setProperty)(l,[h],S,P):_=o(l,h,S,I,u,P).map(q=>(0,O.withFormatting)(l,q,P)[0]),(0,O.applyEdits)(l,_)}function o(l,h,S,I,u,P){var _;const q=`${JSON.stringify(h)}: ${JSON.stringify(S)}`,W=(0,R.getEOL)(P,l),N=u[I.index];if(I.insertAfter){const $=[];if(N.setting)$.push({offset:N.endOffset,length:0,content:","+q});else{const V=n(I.index,u),B=t(I.index,u),M=(_=B==null?void 0:B.setting)===null||_===void 0?void 0:_.commaOffset;B&&M===void 0&&$.push({offset:B.endOffset,length:0,content:","});const F=M!==void 0&&M>N.endOffset;$.push({offset:F?M+1:N.endOffset,length:0,content:V?W+q+",":W+q})}return $}else{if(N.setting)return[{offset:N.startOffset,length:0,content:q+","}];const $=(u[I.index-1]&&!u[I.index-1].setting?W:"")+q+(n(I.index,u)?",":"")+W;return[{offset:N.startOffset,length:0,content:$}]}}function i(l,h){return h.filter(S=>{var I;return((I=S.setting)===null||I===void 0?void 0:I.key)===l})[0]}function t(l,h){for(let S=l-1;S>=0;S--)if(h[S].setting)return h[S]}function n(l,h){for(let S=l+1;S<h.length;S++)if(h[S].setting)return h[S]}function r(l,h,S){const I=l.indexOf(h),u=l.indexOf(S);return l.filter((P,_)=>I<_&&_<u)}function c(l,h){if(l.length&&h.length){let S=0;for(;S<h.length&&S<l.length;S++)if(l[S].value!==h[S].value)return h[S-1];return h[S-1]}}function s(l){const h=[];let S=-1,I,u;const P={onObjectBegin:_=>{S++},onObjectProperty:(_,q,W)=>{S===0&&(I=q,u=_)},onObjectEnd:(_,q)=>{S--,S===0&&h.push({startOffset:I,endOffset:_+q,value:l.substring(I,_+q),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,q)=>{S++},onArrayEnd:(_,q)=>{S--,S===0&&h.push({startOffset:I,endOffset:_+q,value:l.substring(I,_+q),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,q,W)=>{S===0&&h.push({startOffset:I,endOffset:q+W,value:l.substring(I,q+W),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,q,W)=>{if(S===0&&_===","){let N=h.length-1;for(;N>=0&&!h[N].setting;N--);const $=h[N];$&&h.splice(N,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:q}})}},onComment:(_,q)=>{S===0&&h.push({startOffset:_,endOffset:_+q,value:l.substring(_,_+q)})}};return(0,A.visit)(l,P),h}}),define(Q[188],Z([0,1,9,20,22,122,3,10,24,187,51,45,25,29,19,41]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function E(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const t=JSON.parse(i);return E(t)?t:{settings:i}}e.parseSettingsSyncContent=p;let w=class extends d.AbstractJsonFileSynchroniser{constructor(t,n,r,c,s,l,h,S,I,u,P){super(n.settingsResource,"settings",t,n,r,c,s,I,u,l,h,S);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,n,r){const c=await this.getLocalFileContent(),s=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),h=n?this.getSettingsSyncContent(n):null,S=await this.getIgnoredSettings();let I=null,u=!1,P=!1,_=!1;if(l){let W=c?c.value.toString().trim():"{}";W=W||"{}",this.validateContent(W),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const N=(0,g.merge)(W,l.settings,h?h.settings:null,S,[],s);I=N.localContent||N.remoteContent,u=N.localContent!==null,P=N.remoteContent!==null,_=N.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),I=c.value.toString(),P=!0);const q={content:I,localChange:u?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(t,n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,g.updateIgnoredSettings)(t.previewResult.content,"{}",c,r):null})}async getAcceptResult(t,n,r,c){const s=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:t.fileContent?(0,g.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:t.remoteContent!==null?(0,g.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,g.updateIgnoredSettings)(r,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(t,n,r,c){const{fileContent:s}=r[0][0];let{content:l,localChange:h,remoteChange:S}=r[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(l,s,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const I=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,g.updateIgnoredSettings)(l,u?u.settings:"{}",P,I),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),c?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(I){}(n==null?void 0:n.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const n=await this.getFormattingOptions(),r=(0,D.edit)(t.value.toString(),[A.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,g.isEmpty)(r)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:n}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let n=await super.resolveContent(t);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(t)),n){const r=this.parseSyncData(n);if(r){const c=this.parseSettingsSyncContent(r.content);if(c)switch(this.extUri.basename(t)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(t){let n=await super.resolvePreviewContent(t);if(n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();n=(0,g.updateIgnoredSettings)(n,"{}",c,r)}return n}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtension,c=>!!c.gallery),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,g.getIgnoredSettings)(n,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new A.UserDataSyncError((0,R.localize)(0,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const n=JSON.parse(t.value.toString());if(!o(n))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(n.content);if(!r||!r.settings)return;let c=r.settings;const s=await this.getFormattingOptions();for(const l in n)if(["version","content","machineId"].indexOf(l)===-1&&n[l]!==void 0){const h=(0,C.setProperty)(c,[l],n[l],s);h.length&&(c=(0,C.applyEdits)(c,h))}await this.fileService.writeFile(this.file,O.VSBuffer.fromString(c))}catch(t){}}};w=ue([Y(0,m.IFileService),Y(1,L.IEnvironmentService),Y(2,a.IStorageService),Y(3,A.IUserDataSyncStoreService),Y(4,A.IUserDataSyncBackupStoreService),Y(5,A.IUserDataSyncLogService),Y(6,A.IUserDataSyncUtilService),Y(7,f.IConfigurationService),Y(8,A.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,b.IExtensionManagementService)],w),e.SettingsSynchroniser=w;let v=class extends d.AbstractInitializer{constructor(t,n,r){super("settings",n,r,t)}async doInitialize(t){const n=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,O.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,g.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}};v=ue([Y(0,m.IFileService),Y(1,L.IEnvironmentService),Y(2,A.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function o(i){return!!(i&&i.version!==void 0&&typeof i.version=="number"&&i.content!==void 0&&typeof i.content=="string"&&i.machineId!==void 0&&typeof i.machineId=="string")}}),define(Q[189],Z([0,1,20,10,9,24,45,25,22,182,19,26,3]),function(G,e,m,A,O,R,T,L,f,g,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends T.AbstractSynchroniser{constructor(E,p,w,v,o,i,t,n,r){super("snippets",p,E,w,v,o,n,r,i,t);this.version=1,this.snippetsFolder=E.snippetsHome,this._register(this.fileService.watch(E.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(E,p,w){const v=await this.getSnippetsFileContents(),o=this.toSnippetsContents(v),i=E.syncData?this.parseSnippets(E.syncData):null,t=p&&p.syncData?this.parseSnippets(p.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,g.merge)(o,i,t);return this.getResourcePreviews(n,v,i||{})}async getMergeResult(E,p){return E.previewResult}async getAcceptResult(E,p,w,v){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:E.fileContent?E.fileContent.value.toString():null,localChange:0,remoteChange:E.fileContent?E.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:E.remoteContent,localChange:E.remoteContent!==null?E.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return w===void 0?{content:E.previewResult.content,localChange:E.previewResult.localChange,remoteChange:E.previewResult.remoteChange}:{content:w,localChange:w===null?E.fileContent!==null?3:0:2,remoteChange:w===null?E.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(E,p,w,v){const o=w.map(([i,t])=>Object.assign(Object.assign({},i),{acceptResult:t}));o.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,v)),o.some(({remoteChange:i})=>i!==0)&&(E=await this.updateRemoteSnippets(o,E,v)),(p==null?void 0:p.ref)!==E.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(E),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of o)try{await this.fileService.del(i)}catch(t){}}getResourcePreviews(E,p,w){const v=new Map;for(const o of Object.keys(E.local.added)){const i={content:E.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};v.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E.local.updated)){const i={content:E.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of E.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E.remote.added)){const i={content:E.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E.remote.updated)){const i={content:E.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of E.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of E.conflicts){const i={content:p[o]?p[o].value.toString():null,hasConflicts:!0,localChange:p[o]?2:1,remoteChange:w[o]?2:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o]||null,localContent:p[o]?p[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(p))if(!v.has(o)){const i={content:p[o]?p[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o]||null,localContent:p[o]?p[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:E}){let p=await super.resolveContent(E);if(p){const w=this.parseSyncData(p);if(w){const v=this.parseSnippets(w),o=[];for(const i of Object.keys(v)){const t=this.extUri.joinPath(E,i),n=this.extUri.joinPath(this.snippetsFolder,i),r=await this.fileService.exists(n);o.push({resource:t,comparableResource:r?n:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(E){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(E);let p=await super.resolveContent(E);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(E)),p){const w=this.parseSyncData(p);if(w)return this.parseSnippets(w)[this.extUri.basename(E)]||null}return null}async hasLocalData(){try{const E=await this.getSnippetsFileContents();if(Object.keys(E).length)return!0}catch(E){}return!1}async updateLocalBackup(E){const p={};for(const w of E)w.fileContent&&(p[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(E,p){for(const{fileContent:w,acceptResult:v,localResource:o,remoteResource:i,localChange:t}of E)if(t!==0){const n=i?this.extUri.basename(i):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,f.VSBuffer.fromString(v.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,f.VSBuffer.fromString(v.content),p?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(E,p,w){const v=p.syncData?this.parseSnippets(p.syncData):{},o=(0,d.deepClone)(v);for(const{acceptResult:i,localResource:t,remoteResource:n,remoteChange:r}of E)if(r!==0){const c=t?this.extUri.basename(t):this.extUri.basename(n);r===3?delete o[c]:o[c]=i.content}return(0,g.areSame)(v,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(o),w?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(E){return JSON.parse(E.content)}toSnippetsContents(E){const p={};for(const w of Object.keys(E))p[w]=E[w].value.toString();return p}async getSnippetsFileContents(){const E={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof O.FileOperationError&&w.fileOperationResult===1)return E;throw w}for(const w of p.children||[]){const v=w.resource,o=this.extUri.extname(v);if(o===".json"||o===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);E[i]=t}}return E}};b=ue([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,D.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncBackupStoreService),Y(5,m.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,m.IUserDataSyncResourceEnablementService),Y(8,L.ITelemetryService)],b),e.SnippetsSynchroniser=b;let a=class extends T.AbstractInitializer{constructor(E,p,w){super("snippets",p,w,E)}async doInitialize(E){const p=E.syncData?JSON.parse(E.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(p)){const o=p[v];if(o){const i=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(i,f.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(E)}async isEmpty(){var E;try{return!((E=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||E===void 0?void 0:E.length)}catch(p){return p.fileOperationResult===1}}};a=ue([Y(0,O.IFileService),Y(1,A.IEnvironmentService),Y(2,m.IUserDataSyncLogService)],a),e.SnippetsInitializer=a}),define(Q[59],Z([0,1,4,3,2,20]),function(G,e,m,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,m.createDecorator)("IUserDataSyncAccountService");let T=class extends O.Disposable{constructor(f){super();this.userDataSyncStoreService=f,this._onDidChangeAccount=this._register(new A.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(f.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(f.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(f){(f&&this._account?f.token!==this._account.token||f.authenticationProviderId!==this._account.authenticationProviderId:f!==this._account)&&(this._account=f,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(f))}};T=ue([Y(0,R.IUserDataSyncStoreService)],T),e.UserDataSyncAccountService=T}),define(Q[190],Z([0,1,2,20,12,24,9,10,53,22,6]),function(G,e,m,A,O,R,T,L,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let d=class extends m.Disposable{constructor(b,a,C,E){super();this.environmentService=b,this.fileService=a,this.configurationService=C,this.logService=E,A.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(b){const a=(0,O.joinPath)(this.environmentService.userDataSyncHome,b),C=await this.fileService.resolve(a);return C.children?C.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(b,a){if(!a){const C=await this.getAllRefs(b);C.length&&(a=C[C.length-1].ref)}if(a){const C=(0,O.joinPath)(this.environmentService.userDataSyncHome,b,a);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(b,a){const C=(0,O.joinPath)(this.environmentService.userDataSyncHome,b),E=(0,O.joinPath)(C,`${(0,f.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(E,g.VSBuffer.fromString(a))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(b)}catch(p){}}async cleanUpBackup(b){const a=(0,O.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(a))return}catch(E){return}const C=await this.fileService.resolve(a);if(C.children){const E=C.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=E.filter(o=>Date.now()-this.getCreationTime(o)>p);const v=E.length-w.length;v<10&&(w=w.slice(10-v)),await D.Promises.settled(w.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};d=ue([Y(0,L.IEnvironmentService),Y(1,T.IFileService),Y(2,R.IConfigurationService),Y(3,A.IUserDataSyncLogService)],d),e.UserDataSyncBackupStoreService=d}),define(Q[191],Z([0,1,5,2]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class O{constructor(y){this.service=y}listen(y,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(y,b,a){switch(b){case"triggerSync":return this.service.triggerSync(a[0],a[1],a[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(a[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=O;class R{constructor(y){this.service=y}listen(y,b){throw new Error(`Event not found: ${b}`)}call(y,b,a){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(a[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(m.URI.revive(a[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class T{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=T;class L{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(y,b,a){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(a[0],a[1]);case"setEnablement":return this.service.setEnablement(a[0],a[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=L;class f{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(y,b,a){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(a)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=f;class g{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(y,b,a){switch(b){case"switch":return this.service.switch(a[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=g;class D extends A.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:m.URI.revive(y.url),type:y.type,defaultUrl:m.URI.revive(y.defaultUrl),insidersUrl:m.URI.revive(y.insidersUrl),stableUrl:m.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(Q[192],Z([0,1,15,10]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends m.AbstractLogger{constructor(T,L){super();this.logger=this._register(T.createLogger(L.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...L){this.logger.trace(T,...L)}debug(T,...L){this.logger.debug(T,...L)}info(T,...L){this.logger.info(T,...L)}warn(T,...L){this.logger.warn(T,...L)}error(T,...L){this.logger.error(T,...L)}critical(T,...L){this.logger.critical(T,...L)}flush(){this.logger.flush()}};O=ue([Y(0,m.ILoggerService),Y(1,A.IEnvironmentService)],O),e.UserDataSyncLogService=O}),define(Q[60],Z([0,1,4,2,44,10,9,19,20,125,28,7,21,3]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const a="sync.currentMachineName";let C=class xe extends A.Disposable{constructor(p,w,v,o,i,t){super();this.storageService=v,this.userDataSyncStoreService=o,this.logService=i,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,O.getServiceMachineId)(p,w,v)}async getMachines(p){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(p)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===w}))}async addCurrentMachine(p){const w=await this.currentMachineIdPromise,v=await this.readMachinesData(p);v.machines.some(({id:o})=>o===w)||(v.machines.push({id:w,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(p){const w=await this.currentMachineIdPromise,v=await this.readMachinesData(p),o=v.machines.filter(({id:i})=>i!==w);o.length!==v.machines.length&&(v.machines=o,await this.writeMachinesData(v))}async renameMachine(p,w,v){const o=await this.currentMachineIdPromise,i=await this.readMachinesData(v),t=i.machines.find(({id:n})=>n===p);t&&(t.name=w,await this.writeMachinesData(i),i.machines.some(({id:n})=>n===o)&&this.storageService.store(a,w,0,1))}async setEnablement(p,w){const v=await this.readMachinesData(),o=v.machines.find(({id:i})=>i===p);o&&(o.disabled=w?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(p){const w=this.storageService.get(a,0);if(w)return w;const v=`${this.productService.nameLong} (${(0,d.PlatformToString)(d.isWeb?0:d.platform)})`,o=new RegExp(`${(0,y.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let i=0;for(const t of p){const n=o.exec(t.name),r=n?parseInt(n[1]):0;i=r>i?r:i}return`${v} #${i+1}`}async readMachinesData(p){this.userData=await this.readUserData(p);const w=this.parse(this.userData);if(w.version!==xe.VERSION)throw new Error((0,g.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(p){var w;const v=JSON.stringify(p),o=await this.userDataSyncStoreService.write(xe.RESOURCE,v,((w=this.userData)===null||w===void 0?void 0:w.ref)||null);this.userData={ref:o,content:v},this._onDidChange.fire()}async readUserData(p){if(this.userData){const w=p&&p.latest?p.latest[xe.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(xe.RESOURCE,this.userData)}parse(p){if(p.content!==null)try{return JSON.parse(p.content)}catch(w){this.logService.error(w)}return{version:xe.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=ue([Y(0,R.IEnvironmentService),Y(1,T.IFileService),Y(2,L.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncLogService),Y(5,D.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Q[84],Z([0,1,6,3,2,20,59,25,11,19,10,60,123,53,5,12,7,28]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const w="sync.enable",v="sync.disableMachineEventually",o="sync.sessionId",i="sync.storeUrl",t="sync.productQuality";let n=class extends O.Disposable{constructor(l,h,S){super();this.storageService=l,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(I=>this.onDidStorageChange(I)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(w,l,0,1)}onDidStorageChange(l){if(l.scope===0&&w===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=ue([Y(0,g.IStorageService),Y(1,D.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends O.Disposable{constructor(l,h,S,I,u,P,_,q,W,N,$){var V;super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=I,this.userDataSyncService=u,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=q,this.userDataSyncMachinesService=W,this.storageService=N,this.autoSync=this._register(new O.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=$,this.syncTriggerDelayer=this._register(new m.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=h.userDataSyncStore)===null||V===void 0?void 0:V.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{var B,M;(0,C.isEqual)(this.syncUrl,(B=h.userDataSyncStore)===null||B===void 0?void 0:B.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(M=h.userDataSyncStore)===null||M===void 0?void 0:M.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(u.onDidChangeLocal,(B,M)=>B?[...B,M]:[M],1e3)(B=>this.triggerSync(B,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,B])=>B)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(i,0);return l?a.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(i,l.toString(),0,1):this.storageService.remove(i,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:h}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,h,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(I){if(h)this.logService.error(I),this.updateEnablement(!1);else throw I}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(w,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const h=R.UserDataSyncError.toUserDataSyncError(l);h instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code===R.UserDataSyncErrorCode.LocalTooManyRequests||h.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code===R.UserDataSyncErrorCode.UpgradeRequired||h.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code===R.UserDataSyncErrorCode.ServiceChanged||h.code===R.UserDataSyncErrorCode.DefaultServiceChanged?E.isWeb&&h.code===R.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(v,!0,0,1),await(0,m.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(v,0,!1)}stopDisableMachineEventually(){this.storageService.remove(v,0)}async triggerSync(l,h,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=ue([Y(0,p.IProductService),Y(1,R.IUserDataSyncStoreManagementService),Y(2,R.IUserDataSyncStoreService),Y(3,R.IUserDataSyncResourceEnablementService),Y(4,R.IUserDataSyncService),Y(5,R.IUserDataSyncLogService),Y(6,T.IUserDataSyncAccountService),Y(7,L.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,g.IStorageService),Y(10,R.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class c extends O.Disposable{constructor(l,h,S,I,u,P,_,q){super();this.lastSyncUrl=l,this.interval=h,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=I,this.userDataSyncService=u,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=q,this.intervalHandler=this._register(new O.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,O.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,m.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(l,h){const S=(0,m.createCancelablePromise)(async I=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,f.isPromiseCanceledError)(u))return}return this.doSync(l,h,I)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!l&&(!(0,C.isEqual)(h.defaultUrl,l.defaultUrl)||!(0,C.isEqual)(h.insidersUrl,l.insidersUrl)||!(0,C.isEqual)(h.stableUrl,l.stableUrl))}async doSync(l,h,S){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let I;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(h),S.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,y.localize)(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,y.localize)(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,y.localize)(2,null),R.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(o,0);if(P&&u&&P!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,y.localize)(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,y.localize)(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,y.localize)(5,null),R.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(S.isCancellationRequested)return;const q=_.find(W=>W.isCurrent);if(q==null?void 0:q.disabled)throw new R.UserDataAutoSyncError((0,y.localize)(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==P&&this.storageService.store(o,u.session,0,1),S.isCancellationRequested)return;q||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),I=u}this._onDidFinishSync.fire(I)}register(l){return super._register(l)}}c.INTERVAL_SYNCING="Interval"}),define(Q[193],Z([0,1,20,2,3,19,25,7]),function(G,e,m,A,O,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let f=class extends A.Disposable{constructor(D,d){super();this.storageService=D,this.telemetryService=d,this._onDidChangeResourceEnablement=new O.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(D.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(D){return this.storageService.getBoolean((0,m.getEnablementKey)(D),0,!0)}setResourceEnablement(D,d){if(this.isResourceEnabled(D)!==d){const y=(0,m.getEnablementKey)(D);this.telemetryService.publicLog2(y,{enabled:d}),this.storeResourceEnablement(y,d)}}getResourceSyncStateVersion(D){}storeResourceEnablement(D,d){this.storageService.store(D,d,0,L.isWeb?0:1)}onDidStorageChange(D){if(D.scope===0){const d=m.ALL_SYNC_RESOURCES.filter(y=>(0,m.getEnablementKey)(y)===D.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}}};f=ue([Y(0,R.IStorageService),Y(1,T.ITelemetryService)],f),e.UserDataSyncResourceEnablementService=f}),define(Q[194],Z([0,1,20,2,4,3,183,186,185,43,25,18,19,188,12,189,31,6,11]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let o=class extends A.Disposable{constructor(r,c,s,l,h,S){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=c,this.instantiationService=s,this.logService=l,this.telemetryService=h,this.storageService=S,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(L.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(f.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(T.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(I=>R.Event.map(I.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(I=>R.Event.map(I.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(I=>R.Event.map(I.onDidChangeLocal,()=>I.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r){await this.checkEnablement();const c=(0,E.generateUuid)();let s;try{const I=(0,m.createSyncHeaders)(c);r&&(I["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(I)}catch(I){const u=m.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(u,c),u}let l=!1;const h=this;let S;return{manifest:s,run(){if(l)throw new Error("Can run a task only once");return S=(0,p.createCancelablePromise)(I=>h.sync(s,c,I)),S.finally(()=>S=void 0)},async stop(){if(S&&S.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,E.generateUuid)(),c=(0,m.createSyncHeaders)(r);let s;try{s=await this.userDataSyncStoreService.manifest(c)}catch(l){const h=m.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,r),h}return new i(r,s,c,this.synchronisers,this.logService)}async sync(r,c,s){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!s.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,m.createSyncHeaders)(c);for(const S of this.synchronisers){if(s.isCancellationRequested)return;try{await S.sync(r,h)}catch(I){if(I instanceof m.UserDataSyncError)switch(I.code){case m.UserDataSyncErrorCode.TooLarge:throw new m.UserDataSyncError(I.message,I.code,S.resource);case m.UserDataSyncErrorCode.TooManyRequests:case m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case m.UserDataSyncErrorCode.LocalTooManyRequests:case m.UserDataSyncErrorCode.Gone:case m.UserDataSyncErrorCode.UpgradeRequired:case m.UserDataSyncErrorCode.IncompatibleRemoteContent:case m.UserDataSyncErrorCode.IncompatibleLocalContent:throw I}const u=m.UserDataSyncError.toUserDataSyncError(I);this.reportUserDataSyncError(u,c),this.logService.error(I),this.logService.error(`${S.resource}: ${(0,g.toErrorMessage)(I)}`),this._syncErrors.push([S.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const S=m.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(S,c),S}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(c){this.logService.error(c)}}async replace(r){await this.checkEnablement();for(const c of this.synchronisers)if(await c.replace(r))return}async accept(r,c,s,l){await this.checkEnablement();const h=this.getSynchroniser(r);await h.accept(c,s),l&&await h.apply(!1,(0,m.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(r){for(const c of this.synchronisers){const s=await c.resolveContent(r);if(s)return s}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,c){return this.getSynchroniser(r).getAssociatedResources(c)}getMachineId(r,c){return this.getSynchroniser(r).getMachineId(c)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const c of r)if(await c.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(c){this.logService.error(`${r.resource}: ${(0,g.toErrorMessage)(c)}`),this.logService.error(c)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const c=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,d.equals)(this._conflicts,r,([c,s],[l,h])=>c===c&&(0,d.equals)(s,h,(S,I)=>(0,a.isEqual)(S.previewResource,I.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,c){this.telemetryService.publicLog2("sync/error",{code:r.code,url:r instanceof m.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(t)])}getSynchroniser(r){return this.synchronisers.find(c=>c.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=ue([Y(0,m.IUserDataSyncStoreService),Y(1,m.IUserDataSyncStoreManagementService),Y(2,O.IInstantiationService),Y(3,m.IUserDataSyncLogService),Y(4,D.ITelemetryService),Y(5,y.IStorageService)],o),e.UserDataSyncService=o;class i extends A.Disposable{constructor(r,c,s,l,h){super();this.id=r,this.manifest=c,this.syncHeaders=s,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,p.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,c){try{return await this.performAction(r,s=>s.accept(r,c))}catch(s){throw this.logService.error(s),s}}async merge(r){try{return r?await this.performAction(r,c=>c.merge(r)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(r){try{return await this.performAction(r,c=>c.discard(r))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,c]of this.previews)for(const s of c.resourcePreviews)s.mergeState==="conflict"&&r.push(s.previewResource);for(const c of r)await this.discard(c);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(S=>S.resource===c);for(const S of s.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&await l.merge(S.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&r.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.remoteResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.localResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(c){(0,w.isPromiseCanceledError)(c)||this.logService.error(c)}this.reset()}async performAction(r,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const s=this.previews.findIndex(([,q])=>q.resourcePreviews.some(({localResource:W,previewResource:N,remoteResource:$})=>(0,a.isEqual)(r,W)||(0,a.isEqual)(r,N)||(0,a.isEqual)(r,$)));if(s===-1)return this.previews;const[l,h]=this.previews[s],S=h.resourcePreviews.find(({localResource:q,remoteResource:W,previewResource:N})=>(0,a.isEqual)(q,r)||(0,a.isEqual)(W,r)||(0,a.isEqual)(N,r));if(!S)return this.previews;let I=this.synchronizingResources.find(q=>q[0]===l);I||(I=[l,[]],this.synchronizingResources.push(I)),I[1].some(q=>(0,a.isEqual)(q,S.localResource))||(I[1].push(S.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find(q=>q.resource===this.previews[s][0]),P=await c(u);P?this.previews.splice(s,1,this.toSyncResourcePreview(u.resource,P)):this.previews.splice(s,1);const _=this.synchronizingResources.findIndex(q=>q[0]===l);return this.synchronizingResources[_][1].splice(I[1].findIndex(q=>(0,a.isEqual)(q,S.localResource)),1),I[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(S=>S.resource===c);let h=s;for(const S of s.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&(h=await l.merge(S.previewResource));h&&r.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const c=[];for(const s of this.synchronisers){if(r.isCancellationRequested)return[];const l=await s.preview(this.manifest,this.syncHeaders);l&&c.push(this.toSyncResourcePreview(s.resource,l))}return c}toSyncResourcePreview(r,c){return[r,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(Q[195],Z([0,1,3,20,5,2,17]),function(G,e,m,A,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class L{constructor(d,y){this.service=d,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new m.Emitter}listen(d,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(d,y,b){try{return await this._call(d,y,b)}catch(a){throw this.logService.error(a),a}}async _call(d,y,b){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(O.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],O.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(O.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:O.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:O.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const a=y.substring("manualSync/".length),C=b[0],E=this.getManualSyncTask(C);switch(b=b.slice(1),a){case"preview":return E.preview();case"accept":return E.accept(O.URI.revive(b[0]),b[1]);case"merge":return E.merge(O.URI.revive(b[0]));case"discard":return E.discard(O.URI.revive(b[0]));case"discardConflicts":return E.discardConflicts();case"apply":return E.apply();case"pull":return E.pull();case"push":return E.push();case"stop":return E.stop();case"_getStatus":return E.status;case"dispose":return this.disposeManualSyncTask(E)}}throw new Error("Invalid call")}getManualSyncTask(d){const y=this.manualSyncTasks.get(this.createKey(d));if(!y)throw new Error(`Manual sync taks not found: ${d}`);return y.manualSyncTask}async createManualSyncTask(){const d=new R.DisposableStore,y=d.add(await this.service.createManualSyncTask());return d.add(y.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:b}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:d}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(d){var y;d.dispose();const b=this.createKey(d.id);(y=this.manualSyncTasks.get(b))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=L;class f extends R.Disposable{constructor(d){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new m.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new m.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new m.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new m.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,b,a){return d.call(y,b,a).then(null,C=>{throw A.UserDataSyncError.toUserDataSyncError(C)})},listen(y,b){return d.listen(y,b)}},this.channel.call("_getInitialData").then(([y,b,a])=>{this.updateStatus(y),this.updateConflicts(b),a&&this.updateLastSyncTime(a),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([b,a])=>[b,A.UserDataSyncError.toUserDataSyncError(a)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:d,manifest:y,status:b}=await this.channel.call("createManualSyncTask"),a=this,C=new g(d,y,b,{async call(E,p,w){return a.channel.call(`manualSync/${E}`,[d,...(0,T.isArray)(p)?p:[p]],w)},listen(E,p){return m.Event.map(m.Event.filter(a.channel.listen(`manualSync/${E}`,p),w=>!C.isDiposed()&&w.manualSyncTaskId===d),w=>w.data)}});return C}replace(d){return this.channel.call("replace",[d])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,y,b,a){return this.channel.call("accept",[d,y,b,a])}resolveContent(d){return this.channel.call("resolveContent",[d])}async getLocalSyncResourceHandles(d){return(await this.channel.call("getLocalSyncResourceHandles",[d])).map(({created:b,uri:a})=>({created:b,uri:O.URI.revive(a)}))}async getRemoteSyncResourceHandles(d){return(await this.channel.call("getRemoteSyncResourceHandles",[d])).map(({created:b,uri:a})=>({created:b,uri:O.URI.revive(a)}))}async getAssociatedResources(d,y){return(await this.channel.call("getAssociatedResources",[d,y])).map(({resource:a,comparableResource:C})=>({resource:O.URI.revive(a),comparableResource:O.URI.revive(C)}))}async getMachineId(d,y){return this.channel.call("getMachineId",[d,y])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(([y,b])=>[y,b.map(a=>Object.assign(Object.assign({},a),{localResource:O.URI.revive(a.localResource),remoteResource:O.URI.revive(a.remoteResource),previewResource:O.URI.revive(a.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}}e.UserDataSyncChannelClient=f;class g extends R.Disposable{constructor(d,y,b,a){super();this.id=d,this.manifest=y,this._disposed=!1,this._status=b;const C=this;this.channel={async call(E,p,w){try{const v=await a.call(E,p,w);return C.isDiposed()||(C._status=await a.call("_getStatus")),v}catch(v){throw A.UserDataSyncError.toUserDataSyncError(v)}},listen(E,p){return a.listen(E,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const d=await this.channel.call("preview");return this.deserializePreviews(d)}async accept(d,y){const b=await this.channel.call("accept",[d,y]);return this.deserializePreviews(b)}async merge(d){const y=await this.channel.call("merge",[d]);return this.deserializePreviews(y)}async discard(d){const y=await this.channel.call("discard",[d]);return this.deserializePreviews(y)}async discardConflicts(){const d=await this.channel.call("discardConflicts");return this.deserializePreviews(d)}async apply(){const d=await this.channel.call("apply");return this.deserializePreviews(d)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(d){return d.map(([y,b])=>[y,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(a=>Object.assign(Object.assign({},a),{localResource:O.URI.revive(a.localResource),remoteResource:O.URI.revive(a.remoteResource),previewResource:O.URI.revive(a.previewResource),acceptedResource:O.URI.revive(a.acceptedResource)}))}])}}}),define(Q[196],Z([0,1,2,20,40,12,30,24,28,44,10,9,19,31,7,3,6,17,5,11]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",i="sync.donot-make-requests-until",t="sync.user-session-id",n="sync.machine-session-id",r=100,c=1e3*60*5;let s=class extends m.Disposable{constructor(P,_,q){super();this.productService=P,this.configurationService=_,this.storageService=q,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(q.onDidChangeValue,W=>{var N;return W.key===A.SYNC_SERVICE_URL_TYPE&&W.scope===0&&this.userDataSyncStoreType!==((N=this.userDataSyncStore)===null||N===void 0?void 0:N.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(A.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(A.SYNC_SERVICE_URL_TYPE,P,0,a.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[A.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(A.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=a.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const q=Object.assign(Object.assign({},P||{}),_||{});if(q&&(0,p.isString)(q.url)&&(0,p.isObject)(q.authenticationProviders)&&Object.keys(q.authenticationProviders).every(W=>(0,p.isArray)(q.authenticationProviders[W].scopes))){const W=q,N=!!W.canSwitch&&!(_==null?void 0:_.url),$=W.url===W.insidersUrl?"insiders":"stable",V=(N?this.userDataSyncStoreType:void 0)||$,B=(_==null?void 0:_.url)||(V==="insiders"?W.insidersUrl:V==="stable"?W.stableUrl:W.url);return{url:w.URI.parse(B),type:V,defaultType:$,defaultUrl:w.URI.parse(W.url),stableUrl:w.URI.parse(W.stableUrl),insidersUrl:w.URI.parse(W.insidersUrl),canSwitch:N,authenticationProviders:Object.keys(W.authenticationProviders).reduce((M,F)=>(M.push({id:F,scopes:W.authenticationProviders[F].scopes}),M),[])}}}};s=ue([Y(0,f.IProductService),Y(1,L.IConfigurationService),Y(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let l=class extends s{constructor(P,_,q){super(P,_,q);const W=this.storageService.get(o,0);W&&(this.previousConfigurationSyncStore=JSON.parse(W));const N=this.productService[A.CONFIGURATION_SYNC_STORE_KEY];N?this.storageService.store(o,JSON.stringify(N),0,1):this.storageService.remove(o,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=ue([Y(0,f.IProductService),Y(1,L.IConfigurationService),Y(2,y.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let h=class extends m.Disposable{constructor(P,_,q,W,N,$,V){super();this.requestService=q,this.logService=W,this.storageService=V,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,g.getServiceMachineId)(N,$,V).then(B=>{const M={"X-Client-Name":`${_.applicationName}${a.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":B};return _.commit&&(M["X-Client-Commit"]=_.commit),M}),this.session=new I(r,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,m.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,R.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(i,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,E.createCancelablePromise)(q=>(0,E.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P),q={},W=await this.request(_.toString(),{type:"GET",headers:q},[],T.CancellationToken.None);return(await(0,O.asJson)(W)||[]).map(({url:$,created:V})=>({ref:(0,R.relativePath)(_,_.with({path:$})),created:V*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),W={};W["Cache-Control"]="no-cache";const N=await this.request(q,{type:"GET",headers:W},[],T.CancellationToken.None);return await(0,O.asText)(N)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),q={};await this.request(_,{type:"DELETE",headers:q},[],T.CancellationToken.None)}async read(P,_,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();q=Object.assign({},q),q["Cache-Control"]="no-cache",_&&(q["If-None-Match"]=_.ref);const N=await this.request(W,{type:"GET",headers:q},[304],T.CancellationToken.None);if(N.res.statusCode===304)return _;const $=N.res.headers.etag;if(!$)throw new A.UserDataSyncStoreError("Server did not return the ref",W,A.UserDataSyncErrorCode.NoRef,N.res.headers[A.HEADER_OPERATION_ID]);const V=await(0,O.asText)(N);return{ref:$,content:V}}async write(P,_,q,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();W=Object.assign({},W),W["Content-Type"]="text/plain",q&&(W["If-Match"]=q);const $=await this.request(N,{type:"POST",data:_,headers:W},[],T.CancellationToken.None),V=$.res.headers.etag;if(!V)throw new A.UserDataSyncStoreError("Server did not return the ref",N,A.UserDataSyncErrorCode.NoRef,$.res.headers[A.HEADER_OPERATION_ID]);return V}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const q=await this.request(_,{type:"GET",headers:P},[],T.CancellationToken.None),W=await(0,O.asJson)(q),N=this.storageService.get(t,0);return N&&W&&N!==W.session&&this.clearSession(),W===null&&N&&this.clearSession(),W&&this.storageService.store(t,W.session,0,1),W}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(n,0)}async request(P,_,q,W){if(!this.authToken)throw new A.UserDataSyncStoreError("No Auth Token Available",P,A.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const N=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),N),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let $;try{$=await this.session.request(P,_,W)}catch(F){if(!(F instanceof A.UserDataSyncStoreError)){const k=(0,v.isPromiseCanceledError)(F)?A.UserDataSyncErrorCode.RequestCanceled:(0,v.getErrorMessage)(F).startsWith("XHR timeout")?A.UserDataSyncErrorCode.RequestTimeout:A.UserDataSyncErrorCode.RequestFailed;F=new A.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,k,void 0)}throw this.logService.info("Request failed",P),F}const V=$.res.headers[A.HEADER_OPERATION_ID],B={url:P,status:$.res.statusCode,"execution-id":_.headers[A.HEADER_EXECUTION_ID],"operation-id":V},M=(0,O.isSuccess)($)||$.res.statusCode&&q.indexOf($.res.statusCode)!==-1;if(M?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new A.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,A.UserDataSyncErrorCode.Unauthorized,V);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,A.UserDataSyncErrorCode.Conflict,V);if($.res.statusCode===410)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,A.UserDataSyncErrorCode.Gone,V);if($.res.statusCode===412)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,A.UserDataSyncErrorCode.PreconditionFailed,V);if($.res.statusCode===413)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,A.UserDataSyncErrorCode.TooLarge,V);if($.res.statusCode===426)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,A.UserDataSyncErrorCode.UpgradeRequired,V);if($.res.statusCode===429){const F=$.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V)):new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequests,V)}if(!M)throw new A.UserDataSyncStoreError("Server returned "+$.res.statusCode,P,A.UserDataSyncErrorCode.Unknown,V);return $}addSessionHeaders(P){let _=this.storageService.get(n,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(n,_,0,1)),P["X-Machine-Session-Id"]=_;const q=this.storageService.get(t,0);q!==void 0&&(P["X-User-Session-Id"]=q)}};h=ue([Y(1,f.IProductService),Y(2,O.IRequestService),Y(3,A.IUserDataSyncLogService),Y(4,D.IEnvironmentService),Y(5,d.IFileService),Y(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let S=class extends h{constructor(P,_,q,W,N,$,V){var B;super((B=P.userDataSyncStore)===null||B===void 0?void 0:B.url,_,q,W,N,$,V);this._register(P.onDidChangeUserDataSyncStore(()=>{var M;return this.updateUserDataSyncStoreUrl((M=P.userDataSyncStore)===null||M===void 0?void 0:M.url)}))}};S=ue([Y(0,A.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,O.IRequestService),Y(3,A.IUserDataSyncLogService),Y(4,D.IEnvironmentService),Y(5,d.IFileService),Y(6,y.IStorageService)],S),e.UserDataSyncStoreService=S;class I{constructor(P,_,q,W){this.limit=P,this.interval=_,this.requestService=q,this.logService=W,this.requests=[],this.startTime=void 0}request(P,_,q){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new A.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,A.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,q)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(Q[197],Z([0,1,20,3,56,84,59,25,19,60,28]),function(G,e,m,A,O,R,T,L,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let d=class extends R.UserDataAutoSyncService{constructor(b,a,C,E,p,w,v,o,i,t,n,r){super(b,a,C,E,p,v,o,i,t,n,r);this._register(A.Event.debounce(A.Event.any(A.Event.map(w.onDidFocusWindow,()=>"windowFocus"),A.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(c,s)=>c?[...c,s]:[s],1e3)(c=>this.triggerSync(c,!0,!1)))}};d=ue([Y(0,D.IProductService),Y(1,m.IUserDataSyncStoreManagementService),Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncResourceEnablementService),Y(4,m.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,m.IUserDataSyncLogService),Y(7,T.IUserDataSyncAccountService),Y(8,L.ITelemetryService),Y(9,g.IUserDataSyncMachinesService),Y(10,f.IStorageService),Y(11,m.IUserDataAutoSyncEnablementService)],d),e.UserDataAutoSyncService=d}),define(Q[198],Z([0,1,3,2,6]),function(G,e,m,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends A.Disposable{constructor({onDidOpenWindow:L,onDidFocusWindow:f,getActiveWindowId:g}){super();this.disposables=this._register(new A.DisposableStore),m.Event.latch(m.Event.any(L,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,O.createCancelablePromise)(()=>g()),(async()=>{try{const d=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:d}catch(d){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Q[61],Z([0,1,106,8,27,6,23,204,205,17]),function(G,e,m,A,O,R,T,L,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(t,n){let r=n.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=n}}e.ExtractError=D;function d(i){const t=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,r)=>n+r,t&61440)}function y(i){if(i instanceof D)return i;let t;return/end of central directory record signature not found/.test(i.message)&&(t="CorruptZip"),new D(t,i)}function b(i,t,n,r,c,s){const l=A.dirname(t),h=A.join(r,l);if(!h.startsWith(r))return Promise.reject(new Error(m.localize(0,null,t)));const S=A.join(r,t);let I;return s.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(O.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((u,P)=>{if(!s.isCancellationRequested)try{I=(0,O.createWriteStream)(S,{mode:n}),I.once("close",()=>u()),I.once("error",P),i.once("error",P),i.pipe(I)}catch(_){P(_)}}))}function a(i,t,n,r){let c=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{c.cancel(),i.close()}),new Promise((l,h)=>{const S=new R.Sequencer,I=u=>{u.isCancellationRequested||(s++,i.readEntry())};i.once("error",h),i.once("close",()=>c.then(()=>{r.isCancellationRequested||i.entryCount===s?l():h(new D("Incomplete",new Error(m.localize(1,null,s,i.entryCount))))},h)),i.readEntry(),i.on("entry",u=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(u.fileName)){I(r);return}const P=u.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(P)){const W=A.join(t,P);c=(0,R.createCancelablePromise)(N=>O.promises.mkdir(W,{recursive:!0}).then(()=>I(N)).then(void 0,h));return}const _=E(i,u),q=d(u);c=(0,R.createCancelablePromise)(W=>S.queue(()=>_.then(N=>b(N,P,q,t,n,W).then(()=>I(W)))).then(null,h))}})})}function C(i,t=!1){return new Promise((n,r)=>{(0,L.open)(i,t?{lazyEntries:!0}:void 0,(c,s)=>{c?r(y(c)):n((0,g.assertIsDefined)(s))})})}function E(i,t){return new Promise((n,r)=>{i.openReadStream(t,(c,s)=>{c?r(y(c)):n((0,g.assertIsDefined)(s))})})}function p(i,t){return new Promise((n,r)=>{const c=new f.ZipFile;t.forEach(l=>{l.contents?c.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&c.addFile(l.localPath,l.path)}),c.end();const s=(0,O.createWriteStream)(i);c.outputStream.pipe(s),c.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(i))})}e.zip=p;function w(i,t,n={},r){const c=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=C(i,!0);return n.overwrite&&(s=s.then(l=>(0,T.rimraf)(t).then(()=>l))),s.then(l=>a(l,t,{sourcePathRegex:c},r))}e.extract=w;function v(i,t){return C(i).then(n=>new Promise((r,c)=>{n.on("entry",s=>{s.fileName===t&&E(n,s).then(l=>r(l),l=>c(l))}),n.once("close",()=>c(new Error(m.localize(2,null,t))))}))}function o(i,t){return v(i,t).then(n=>new Promise((r,c)=>{const s=[];n.once("error",c),n.on("data",l=>s.push(l)),n.on("end",()=>r(Buffer.concat(s)))}))}e.buffer=o}),define(Q[199],Z([0,1,61,111]),function(G,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function O(R){return(0,m.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(L){throw new Error((0,A.localize)(0,null))}})}e.getManifest=O}),define(Q[200],Z([0,1,27,55,2,23,8,15,29,34,6,5,10,131,112,28,61,7,18,16,9,12,31,11]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",c="scanningUser",s="extracting",l="deleting",h="renaming";let S=class extends O.Disposable{constructor(u,P,_,q,W){super();this.beforeRemovingExtension=u,this.fileService=P,this.logService=_,this.environmentService=q,this.productService=W,this._devSystemExtensionsPath=null,this.systemExtensionsPath=q.builtinExtensionsPath,this.extensionsPath=q.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(u){const P=[];(u===null||u===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,r)))),(u===null||u===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,c))));try{const _=await Promise.all(P);return(0,w.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(u){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(q=>!P[new g.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]),u&&(_=(0,g.groupByExtension)(_,W=>W.identifier).map(W=>W.sort((N,$)=>A.rcompare(N.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(u,P,_){const q=u.key(),W=T.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),N=T.join(this.extensionsPath,q);try{await R.rimraf(N)}catch(V){try{await R.rimraf(N)}catch(B){}throw new f.ExtensionManagementError((0,a.localize)(0,null,N,u.id),l)}await this.extractAtLocation(u,P,W,_);try{await this.rename(u,W,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(V){try{await R.rimraf(W)}catch(B){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",u.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(V)}. Deleted from extracted location`,W),V}let $=null;try{$=await this.scanExtension(d.URI.file(T.join(this.extensionsPath,q)),1)}catch(V){}if($)return $;throw new Error((0,a.localize)(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(u,P){this.setMetadata(u,P),P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0;const _=T.join(u.location.fsPath,"package.json"),q=await m.promises.readFile(_,"utf8"),{manifest:W}=await this.parseManifest(q);return W.__metadata=P,await R.writeFile(_,JSON.stringify(W,null,"	")),u}getUninstalledExtensions(){return this.withUninstalledExtensions(u=>u)}async withUninstalledExtensions(u){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await m.promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let _={};if(P)try{_=JSON.parse(P)}catch(W){}const q=u(_);return Object.keys(_).length?await R.writeFile(this.uninstalledPath,JSON.stringify(_)):await R.rimraf(this.uninstalledPath),q})}async removeExtension(u,P){this.logService.trace(`Deleting ${P} extension from disk`,u.identifier.id,u.location.fsPath),await R.rimraf(u.location.fsPath),this.logService.info("Deleted from disk",u.identifier.id,u.location.fsPath)}async removeUninstalledExtension(u){await this.removeExtension(u,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new g.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()])}async extractAtLocation(u,P,_,q){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await R.rimraf(_)}catch(W){throw new f.ExtensionManagementError(this.joinErrors(W).message,l)}try{await(0,E.extract)(P,_,{sourcePath:"extension",overwrite:!0},q),this.logService.info(`Extracted extension to ${_}:`,u.id)}catch(W){try{await R.rimraf(_)}catch(N){}throw new f.ExtensionManagementError(W.message,W instanceof E.ExtractError&&W.type?W.type:s)}}async rename(u,P,_,q){try{await m.promises.rename(P,_)}catch(W){if(p.isWindows&&W&&W.code==="EPERM"&&Date.now()<q)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,u.id),this.rename(u,P,_,q);throw new f.ExtensionManagementError(W.message||(0,a.localize)(2,null,P,_),W.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const u=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return u;const P=this.scanDevSystemExtensions(),[_,q]=await Promise.all([u,P]);return[..._,...q]}async scanExtensionsInDir(u,P){const _=new D.Limiter(10),q=await this.fileService.resolve(d.URI.file(u));return q.children?(await Promise.all(q.children.filter(N=>N.isDirectory).map(N=>_.queue(()=>this.scanExtension(N.resource,P))))).filter(N=>N&&N.identifier):[]}async scanExtension(u,P){var _,q;if(P===1&&(0,i.basename)(u).indexOf(".")===0)return null;try{const W=await this.fileService.resolve(u);if(W.children){const{manifest:N,metadata:$}=await this.readManifest(u.fsPath),V=(_=W.children.find(({name:k})=>/^readme(\.txt|\.md|)$/i.test(k)))===null||_===void 0?void 0:_.resource,B=(q=W.children.find(({name:k})=>/^changelog(\.txt|\.md|)$/i.test(k)))===null||q===void 0?void 0:q.resource,M={id:(0,g.getGalleryExtensionId)(N.publisher,N.name)},F={type:P,identifier:M,manifest:N,location:u,readmeUrl:V,changelogUrl:B,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return $&&this.setMetadata(F,$),F}}catch(W){P!==0&&this.logService.trace(W)}return null}async scanDefaultSystemExtensions(){const u=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",u.length),u}async scanDevSystemExtensions(){const u=this.getDevSystemExtensionsList();if(u.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>u.some(q=>(0,g.areSameExtensions)(_.identifier,{id:q})))}else return[]}setMetadata(u,P){u.publisherDisplayName=P.publisherDisplayName||null,u.publisherId=P.publisherId||null,u.identifier.uuid=P.id,u.isMachineScoped=!!P.isMachineScoped,u.isBuiltin=u.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const u=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const N of P)u[new g.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).key()]||_.add(N.identifier.id.toLowerCase());const q=(0,g.groupByExtension)(P,N=>N.identifier);await D.Promises.settled(q.map(async N=>{const $=N.sort((V,B)=>A.rcompare(V.manifest.version,B.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const W=P.filter(N=>u[new g.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).key()]);await D.Promises.settled(W.map(N=>this.removeUninstalledExtension(N)))}async removeOutdatedExtensions(){const u=await this.scanAllUserExtensions(),P=[],_=(0,g.groupByExtension)(u,q=>q.identifier);P.push(...(0,w.flatten)(_.map(q=>q.sort((W,N)=>A.rcompare(W.manifest.version,N.manifest.version)).slice(1)))),await D.Promises.settled(P.map(q=>this.removeExtension(q,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(u=>u.name)}joinErrors(u){const P=Array.isArray(u)?u:[u];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,q)=>new Error(`${_.message}${_.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(v.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(u){const P=[m.promises.readFile(T.join(u,"package.json"),"utf8").then(N=>this.parseManifest(N)),m.promises.readFile(T.join(u,"package.nls.json"),"utf8").then(void 0,N=>N.code!=="ENOENT"?Promise.reject(N):"{}").then(N=>JSON.parse(N))],[{manifest:_,metadata:q},W]=await Promise.all(P);return{manifest:(0,b.localizeManifest)(_,W),metadata:q}}parseManifest(u){return new Promise((P,_)=>{try{const q=JSON.parse(u),W=q.__metadata||null;P({manifest:q,metadata:W})}catch(q){_(new Error((0,a.localize)(3,null)))}})}};S=ue([Y(1,o.IFileService),Y(2,L.ILogService),Y(3,y.INativeEnvironmentService),Y(4,C.IProductService)],S),e.ExtensionsScanner=S}),define(Q[201],Z([0,1,27,110,8,23,2,18,61,29,34,10,6,3,55,5,57,7,15,144,43,25,68,12,31,70,4,16,30,199,152,200,153]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i,t,n,r,c,s,l,h,S,I,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",q="downloading",W="validating",N="local",$="unknown";let V=class extends T.Disposable{constructor(M,F,k,U,j,z){super();this.environmentService=M,this.galleryService=F,this.logService=k,this.downloadService=U,this.telemetryService=j,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const H=this._register(z.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(z.createInstance(u.ExtensionsScanner,K=>H.postUninstall(K))),this.manifestCache=this._register(new v.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(z.createInstance(I.ExtensionsDownloader)),this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(K=>K.cancel()),this.uninstallingExtensions.forEach(K=>K.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),k=await(0,f.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,F);return C.URI.file(k)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const F=await this.downloadVsix(M),k=O.resolve(F.fsPath);return(0,S.getManifest)(k)}async collectFiles(M){const F=async U=>{let j=await R.readdir(U);j=j.map(K=>O.join(U,K));const z=await Promise.all(j.map(K=>m.promises.stat(K)));let H=Promise.resolve([]);return z.forEach((K,te)=>{const X=j[te];K.isFile()&&(H=H.then(ie=>[...ie,X])),K.isDirectory()&&(H=H.then(ie=>F(X).then(se=>[...ie,...se])))}),H};return(await F(M.location.fsPath)).map(U=>({path:`extension/${O.relative(M.location.fsPath,U)}`,localPath:U}))}async install(M,F={}){return this.logService.trace("ExtensionManagementService#install",M.toString()),(0,y.createCancelablePromise)(async k=>{const U=await this.downloadVsix(M),j=O.resolve(U.fsPath),z=await(0,S.getManifest)(j),H={id:(0,D.getGalleryExtensionId)(z.publisher,z.name)};let K=1;if(z.engines&&z.engines.vscode&&!(0,t.isEngineValid)(z.engines.vscode,E.default.version))throw new Error(A.localize(0,null,H.id,E.default.version));const te=new D.ExtensionIdentifierWithVersion(H,z.version),ie=(await this.getInstalled(1)).find(ce=>(0,D.areSameExtensions)(H,ce.identifier));if(ie)if(F.isMachineScoped=F.isMachineScoped||ie.isMachineScoped,F.isBuiltin=F.isBuiltin||ie.isBuiltin,K=2,te.equals(new D.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch(ce){throw new Error(A.localize(1,null,z.displayName||z.name))}else a.gt(ie.manifest.version,z.version)&&await this.uninstallExtension(ie);else{const ce=await this.unsetUninstalledAndGetLocal(te);if(ce)try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(he){throw new Error(A.localize(2,null,z.displayName||z.name))}}this.logService.info("Installing the extension:",H.id),this._onInstallExtension.fire({identifier:H,zipPath:j});let se;try{se=await this.getGalleryMetadata((0,D.getGalleryExtensionId)(z.publisher,z.name))}catch(ce){}try{const ce=await this.installFromZipPath(te,j,Object.assign(Object.assign({},se||{}),F),F,K,k);return this.logService.info("Successfully installed the extension:",H.id),ce}catch(ce){throw this.logService.error("Failed to install the extension:",H.id,ce.message),ce}})}async downloadVsix(M){if(M.scheme===l.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const F=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(M,F),F}async installFromZipPath(M,F,k,U,j,z){try{const H=await this.installExtension({zipPath:F,identifierWithVersion:M,metadata:k},z);try{await this.installDependenciesAndPackExtensions(H,void 0,U)}catch(K){(0,L.isNonEmptyArray)(H.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",H.identifier.id,K.message),(0,L.isNonEmptyArray)(H.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",H.identifier.id,K.message)}return this._onDidInstallExtension.fire({identifier:M,zipPath:F,local:H,operation:j}),H}catch(H){throw this._onDidInstallExtension.fire({identifier:M,zipPath:F,operation:j,error:H}),H}}async canInstall(M){return!0}async installFromGallery(M,F={}){if(!this.galleryService.isEnabled())throw new Error(A.localize(3,null));try{M=await this.checkAndGetCompatibleVersion(M)}catch(j){const z=j&&j.code?j.code:$;throw this.logService.error("Failed to install extension:",M.identifier.id,j?j.message:z),this.reportTelemetry(this.getTelemetryEvent(1),(0,D.getGalleryExtensionTelemetryData)(M),void 0,j),j instanceof Error&&(j.name=z),j}const k=new D.ExtensionIdentifierWithVersion(M.identifier,M.version).key();let U=this.installingExtensions.get(k);return U||(U=(0,y.createCancelablePromise)(j=>this.doInstallFromGallery(M,F,j)),this.installingExtensions.set(k,U),U.finally(()=>this.installingExtensions.delete(k))),U}async doInstallFromGallery(M,F,k){const U=new Date().getTime();let j=1;this.logService.info("Installing extension:",M.identifier.id),this._onInstallExtension.fire({identifier:M.identifier,gallery:M});try{const H=(await this.getInstalled(1)).find(X=>(0,D.areSameExtensions)(X.identifier,M.identifier));H&&(j=2);const K=await this.downloadInstallableExtension(M,j);K.metadata.isMachineScoped=F.isMachineScoped||(H==null?void 0:H.isMachineScoped),K.metadata.isBuiltin=F.isBuiltin||(H==null?void 0:H.isBuiltin);const te=await this.installExtension(K,k);try{await this.extensionsDownloader.delete(C.URI.file(K.zipPath))}catch(X){}if(!F.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(te,H,F)}catch(X){try{await this.uninstall(te)}catch(ie){}throw X}return H&&a.neq(H.manifest.version,M.version)&&await this.setUninstalled(H),this.logService.info("Extensions installed successfully:",M.identifier.id),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,local:te,operation:j}),this.reportTelemetry(this.getTelemetryEvent(j),(0,D.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,void 0),te}catch(z){const H=z&&z.code?z.code:$;throw this.logService.error("Failed to install extension:",M.identifier.id,z?z.message:H),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,operation:j,error:H}),this.reportTelemetry(this.getTelemetryEvent(j),(0,D.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,z),z instanceof Error&&(z.name=H),z}}async checkAndGetCompatibleVersion(M){if(await this.isMalicious(M))throw new g.ExtensionManagementError(A.localize(4,null),g.INSTALL_ERROR_MALICIOUS);const F=await this.galleryService.getCompatibleExtension(M);if(!F)throw new g.ExtensionManagementError(A.localize(5,null,M.identifier.id,E.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return F}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(6,null));const F=await this.findGalleryExtension(M);if(!F)throw new Error(A.localize(7,null));await this.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(A.localize(8,null,(0,o.toErrorMessage)(k)))}await this.installFromGallery(F)}getTelemetryEvent(M){return M===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(M){const F=await this.getExtensionsReport();return(0,D.getMaliciousExtensionsSet)(F).has(M.identifier.id)}async downloadInstallableExtension(M,F){const k={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",M.identifier.id);const j=await this.extensionsDownloader.downloadExtension(M,F);this.logService.info("Downloaded extension:",M.identifier.id,U),U=j.fsPath}catch(j){throw new g.ExtensionManagementError(this.joinErrors(j).message,q)}try{const j=await(0,S.getManifest)(U);return{zipPath:U,identifierWithVersion:new D.ExtensionIdentifierWithVersion(M.identifier,j.version),metadata:k}}catch(j){throw new g.ExtensionManagementError(this.joinErrors(j).message,W)}}async installExtension(M,F){try{const k=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(k)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(k,M.metadata):k}catch(k){throw p.isMacintosh?new g.ExtensionManagementError(A.localize(9,null),_):new g.ExtensionManagementError(A.localize(10,null),_)}return this.extractAndInstall(M,F)}async unsetUninstalledAndGetLocal(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.unsetUninstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.getInstalled(1)).find(U=>new D.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(M))||null):null}async extractAndInstall({zipPath:M,identifierWithVersion:F,metadata:k},U){let j=await this.extensionsScanner.extractUserExtension(F,M,U);return this.logService.info("Installation completed.",F.id),k&&(j=await this.extensionsScanner.saveMetadataForLocalExtension(j,k)),j}async installDependenciesAndPackExtensions(M,F,k){if(!!this.galleryService.isEnabled()){const U=M.manifest.extensionDependencies||[];if(M.manifest.extensionPack)for(const j of M.manifest.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(z=>(0,D.areSameExtensions)({id:z},{id:j}))||U.every(z=>!(0,D.areSameExtensions)({id:z},{id:j}))&&U.push(j);if(U.length){const j=await this.getInstalled(),z=U.filter(H=>j.every(({identifier:K})=>!(0,D.areSameExtensions)(K,{id:H})));if(z.length){const K=(await this.galleryService.query({names:z,pageSize:U.length},h.CancellationToken.None)).firstPage;try{await y.Promises.settled(K.map(te=>this.installFromGallery(te,k)))}catch(te){try{await this.rollback(K)}catch(X){}throw te}}}}}async rollback(M){const k=(await this.getInstalled(1)).filter(U=>M.some(j=>new D.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(new D.ExtensionIdentifierWithVersion(j.identifier,j.version))));await y.Promises.settled(k.map(U=>this.uninstall(U)))}async uninstall(M,F={}){this.logService.trace("ExtensionManagementService#uninstall",M.identifier.id);const k=await this.getInstalled(1),U=k.find(j=>(0,D.areSameExtensions)(j.identifier,M.identifier));if(!U)throw new Error(A.localize(11,null,M.manifest.displayName||M.manifest.name));try{await this.checkForDependenciesAndUninstall(U,k,F)}catch(j){throw this.joinErrors(j)}}async updateMetadata(M,F){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),F)),this.manifestCache.invalidate(),M}async updateExtensionScope(M,F){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),{isMachineScoped:F})),this.manifestCache.invalidate(),M}async getGalleryMetadata(M){const F=await this.findGalleryExtensionByName(M);return F?{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}:void 0}async findGalleryExtension(M){if(M.identifier.uuid){const F=await this.findGalleryExtensionById(M.identifier.uuid);return F||this.findGalleryExtensionByName(M.identifier.id)}return this.findGalleryExtensionByName(M.identifier.id)}async findGalleryExtensionById(M){return(await this.galleryService.query({ids:[M],pageSize:1},h.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(M){return(await this.galleryService.query({names:[M],pageSize:1},h.CancellationToken.None)).firstPage[0]}joinErrors(M){const F=Array.isArray(M)?M:[M];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((k,U)=>new Error(`${k.message}${k.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}async checkForDependenciesAndUninstall(M,F,k){try{await this.preUninstallExtension(M);const U=k.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(M,F);await this.uninstallExtensions(M,U,F,k)}catch(U){throw await this.postUninstallExtension(M,new g.ExtensionManagementError(U instanceof Error?U.message:U,N)),U}await this.postUninstallExtension(M)}async uninstallExtensions(M,F,k,U){const j=[M,...F];if(!U.donotCheckDependents)for(const z of j)this.checkForDependents(z,j,k,M);await y.Promises.settled([this.uninstallExtension(M),...F.map(z=>this.doUninstall(z))])}checkForDependents(M,F,k,U){const j=this.getDependents(M,k);if(j.length){const z=j.filter(H=>F.indexOf(H)===-1);if(z.length)throw new Error(this.getDependentsErrorMessage(M,z,U))}}getDependentsErrorMessage(M,F,k){return k===M?F.length===1?A.localize(12,null,k.manifest.displayName||k.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?A.localize(13,null,k.manifest.displayName||k.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):A.localize(14,null,k.manifest.displayName||k.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):F.length===1?A.localize(15,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?A.localize(16,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):A.localize(17,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name)}getAllPackExtensionsToUninstall(M,F,k=[]){if(k.indexOf(M)!==-1)return[];k.push(M);const U=M.manifest.extensionPack?M.manifest.extensionPack:[];if(U.length){const j=F.filter(H=>!H.isBuiltin&&U.some(K=>(0,D.areSameExtensions)({id:K},H.identifier))),z=[];for(const H of j)z.push(...this.getAllPackExtensionsToUninstall(H,F,k));return[...j,...z]}return[]}getDependents(M,F){return F.filter(k=>k.manifest.extensionDependencies&&k.manifest.extensionDependencies.some(U=>(0,D.areSameExtensions)({id:U},M.identifier)))}async doUninstall(M){try{await this.preUninstallExtension(M),await this.uninstallExtension(M)}catch(F){throw await this.postUninstallExtension(M,new g.ExtensionManagementError(F instanceof Error?F.message:F,N)),F}await this.postUninstallExtension(M)}async preUninstallExtension(M){if(!await R.exists(M.location.fsPath))throw new Error(A.localize(18,null));this.logService.info("Uninstalling extension:",M.identifier.id),this._onUninstallExtension.fire(M.identifier)}async uninstallExtension(M){let F=this.uninstallingExtensions.get(M.identifier.id);return F||(F=(0,y.createCancelablePromise)(async()=>{const k=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...k.filter(U=>(0,D.areSameExtensions)(U.identifier,M.identifier)))}),this.uninstallingExtensions.set(M.identifier.id,F),F.finally(()=>this.uninstallingExtensions.delete(M.identifier.id))),F}async postUninstallExtension(M,F){if(F)this.logService.error("Failed to uninstall extension:",M.identifier.id,F.message);else if(this.logService.info("Successfully uninstalled extension:",M.identifier.id),M.identifier.uuid)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"uninstall")}catch(U){}this.reportTelemetry("extensionGallery:uninstall",(0,D.getLocalExtensionTelemetryData)(M),void 0,F);const k=F?F instanceof g.ExtensionManagementError?F.code:$:void 0;this._onDidUninstallExtension.fire({identifier:M.identifier,error:k})}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(M){return(await this.filterUninstalled(M)).length===1}filterUninstalled(...M){return this.extensionsScanner.withUninstalledExtensions(F=>{const k=[];for(const U of M)F[U.key()]&&k.push(U.key());return k})}setUninstalled(...M){const F=M.map(k=>new D.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));return this.extensionsScanner.withUninstalledExtensions(k=>(F.forEach(U=>k[U.key()]=!0),k))}unsetUninstalled(M){return this.extensionsScanner.withUninstalledExtensions(F=>delete F[M.key()])}getExtensionsReport(){const M=new Date().getTime();return(!this.reportedExtensions||M-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=M),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const M=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${M.length} reported extensions from service`),M}catch(M){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(M,F,k,U){const j=U?U instanceof g.ExtensionManagementError?U.code:$:void 0;this.telemetryService.publicLogError(M,Object.assign(Object.assign({},F),{success:!U,duration:k,errorcode:j}))}};V=ue([Y(0,d.INativeEnvironmentService),Y(1,g.IExtensionGalleryService),Y(2,w.ILogService),Y(3,(0,s.optional)(c.IDownloadService)),Y(4,i.ITelemetryService),Y(5,s.IInstantiationService)],V),e.ExtensionManagementService=V}),define(Q[206],Z([0,1,27,38,207,100,57,99,33,75,50,148,10,128,130,29,201,173,24,164,40,165,25,58,171,79,80,176,15,76,157,54,2,166,70,162,161,142,141,150,149,77,172,69,154,9,156,16,28,20,194,196,191,56,160,192,197,170,19,168,193,59,190,174,60,71,132,198,175,84,83,82,4,151,143,11,43,8,81,179,178,195,139,145,177]),function(G,e,m,A,O,R,T,L,f,g,D,d,y,b,a,C,E,p,w,v,o,i,t,n,r,c,s,l,h,S,I,u,P,_,q,W,N,$,V,B,M,F,k,U,j,z,H,K,te,X,ie,se,ce,he,me,we,Ie,ke,Ue,Fe,_e,Me,De,Ae,$e,He,Ne,ze,J,ne,re,ge,x,ee,oe,ae,le,de,ve,ye,Ee,be,Le,Se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ce extends P.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new L.Server),(0,O.gracefulify)(m),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,X.registerConfiguration)(),fe.invokeFunction(Pe=>{const Oe=Pe.get(h.ILogService);Oe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Pe),this.registerErrorHandler(Oe)}),this._register((0,P.combinedDisposable)(fe.createInstance(W.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),fe.createInstance(N.LanguagePackCachedDataCleaner),fe.createInstance($.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(V.LogsDataCleaner),fe.createInstance(ee.LocalizationsUpdater),fe.createInstance(oe.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new g.ServiceCollection,Pe=Object.assign({_serviceBrand:void 0},T.default);fe.set(te.IProductService,Pe);const Oe=new b.NativeEnvironmentService(this.configuration.args,Pe);fe.set(y.INativeEnvironmentService,Oe);const Je=new f.StaticRouter(je=>je==="main"),Ze=new S.LogLevelChannelClient(this.server.getChannel("logLevel",Je)),et=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogger(this.configuration.logLevel)),this._register(new F.SpdLogLogger("sharedprocess",(0,de.join)(Oe.logsPath,"sharedprocess.log"),!0,this.configuration.logLevel))])),qe=this._register(new S.FollowerLogService(Ze,et));fe.set(h.ILogService,qe);const Ge=new M.MessagePortMainProcessService(this.server,Je);fe.set(B.IMainProcessService,Ge);const Be=this._register(new j.FileService(qe));fe.set(z.IFileService,Be);const tt=this._register(new H.DiskFileSystemProvider(qe));Be.registerProvider(K.Schemas.file,tt);const We=this._register(new v.ConfigurationService(Oe.settingsResource,Be));fe.set(w.IConfigurationService,We),await We.initialize();const Ke=new ke.NativeStorageService(void 0,Ge,Oe);fe.set(Ue.IStorageService,Ke),await Ke.initialize(),this._register((0,P.toDisposable)(()=>Ke.flush())),fe.set(o.IRequestService,new D.SyncDescriptor(i.RequestService)),fe.set(Le.IChecksumService,new D.SyncDescriptor(Se.ChecksumService));const Xe=f.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(he.INativeHostService,Xe),fe.set(q.IDownloadService,new D.SyncDescriptor(_.DownloadService));const it=this._register(new ze.ActiveWindowManager(Xe)),nt=new f.StaticRouter(je=>it.getActiveClientId().then(gt=>je===gt));fe.set(He.IExtensionRecommendationNotificationService,new Ne.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",nt)));const ot=this._register(new me.LoggerService(qe,Be));fe.set(h.ILoggerService,ot);const{appRoot:ct,extensionsPath:lt,extensionDevelopmentLocationURI:ut,isBuilt:ht,installSourcePath:dt}=Oe;let Qe,Ve;if(!ut&&!Oe.disableTelemetry&&Pe.enableTelemetry){if(Ve=new J.TelemetryLogAppender(ot,Oe),Pe.aiConfig&&Pe.aiConfig.asimovKey&&ht){const je=new l.AppInsightsAppender("monacoworkbench",null,Pe.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>je.flush())),Ve=(0,n.combinedAppender)(je,Ve)}Qe=new s.TelemetryService({appender:Ve,commonProperties:(0,r.resolveCommonProperties)(Be,(0,A.release)(),process.arch,Pe.commit,Pe.version,this.configuration.machineId,Pe.msftInternalDomains,dt),sendErrorTelemetry:!0,piiPaths:[ct,lt]},We)}else Qe=n.NullTelemetryService,Ve=n.NullAppender;this.server.registerChannel("telemetryAppender",new c.TelemetryAppenderChannel(Ve)),fe.set(t.ITelemetryService,Qe);const ft=new pe.CustomEndpointTelemetryService(We,Qe);return fe.set(t.ICustomEndpointTelemetryService,ft),fe.set(C.IExtensionManagementService,new D.SyncDescriptor(E.ExtensionManagementService)),fe.set(C.IExtensionGalleryService,new D.SyncDescriptor(p.ExtensionGalleryService)),fe.set(C.IExtensionTipsService,new D.SyncDescriptor(Ae.ExtensionTipsService)),fe.set(u.ILocalizationsService,new D.SyncDescriptor(I.LocalizationsService)),fe.set(U.IDiagnosticsService,new D.SyncDescriptor(k.DiagnosticsService)),fe.set(Me.IUserDataSyncAccountService,new D.SyncDescriptor(Me.UserDataSyncAccountService)),fe.set(X.IUserDataSyncLogService,new D.SyncDescriptor(we.UserDataSyncLogService)),fe.set(X.IUserDataSyncUtilService,new ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),fe.set(C.IGlobalExtensionEnablementService,new D.SyncDescriptor(Fe.GlobalExtensionEnablementService)),fe.set(re.IIgnoredExtensionsManagementService,new D.SyncDescriptor(re.IgnoredExtensionsManagementService)),fe.set(ge.IExtensionsStorageSyncService,new D.SyncDescriptor(ge.ExtensionsStorageSyncService)),fe.set(X.IUserDataSyncStoreManagementService,new D.SyncDescriptor(se.UserDataSyncStoreManagementService)),fe.set(X.IUserDataSyncStoreService,new D.SyncDescriptor(se.UserDataSyncStoreService)),fe.set($e.IUserDataSyncMachinesService,new D.SyncDescriptor($e.UserDataSyncMachinesService)),fe.set(X.IUserDataSyncBackupStoreService,new D.SyncDescriptor(De.UserDataSyncBackupStoreService)),fe.set(X.IUserDataAutoSyncEnablementService,new D.SyncDescriptor(ne.UserDataAutoSyncEnablementService)),fe.set(X.IUserDataSyncResourceEnablementService,new D.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),fe.set(X.IUserDataSyncService,new D.SyncDescriptor(ie.UserDataSyncService)),fe.set(Ee.ILocalPtyService,this._register(new ye.PtyHostService(qe))),new d.InstantiationService(fe)}initChannels(fe){const Pe=new a.ExtensionManagementChannel(fe.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Pe);const Oe=f.ProxyChannel.fromService(fe.get(u.ILocalizationsService));this.server.registerChannel("localizations",Oe);const Je=f.ProxyChannel.fromService(fe.get(U.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const Ze=new a.ExtensionTipsChannel(fe.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const et=f.ProxyChannel.fromService(fe.get(Le.IChecksumService));this.server.registerChannel("checksum",et);const qe=new ce.UserDataSyncMachinesServiceChannel(fe.get($e.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",qe);const Ge=f.ProxyChannel.fromService(fe.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Be=new ce.UserDataSyncAccountServiceChannel(fe.get(Me.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const tt=new ce.UserDataSyncStoreManagementServiceChannel(fe.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",tt);const We=new be.UserDataSyncChannel(fe.get(X.IUserDataSyncService),fe.get(h.ILogService));this.server.registerChannel("userDataSync",We);const Ke=this._register(fe.get(x.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),Xe=new ce.UserDataAutoSyncChannel(Ke);this.server.registerChannel("userDataAutoSync",Xe);const it=fe.get(Ee.ILocalPtyService),nt=f.ProxyChannel.fromService(it);this.server.registerChannel(ve.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Pe=>{(0,ae.onUnexpectedError)(Pe.reason),Pe.preventDefault()}),(0,ae.setUnexpectedErrorHandler)(Pe=>{const Oe=(0,le.toErrorMessage)(Pe,!0);!Oe||fe.error(`[uncaught exception in sharedProcess]: ${Oe}`)})}}async function Re(Te){const fe=new Ce(Te);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Re})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4b1e9ac57ab3cc942ab9bff09967bf3238a7910/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
