/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/base/common/path","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/base/common/arrays","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/process","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Y){for(var e=[],_=0,y=Y.length;_<y;_++)e[_]=ge[Y[_]];return e};define(ge[52],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(y,R){if(!y)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=_}),define(ge[53],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function y(T){const k=[];for(let b in T)_.call(T,b)&&k.push(T[b]);return k}e.values=y;function R(T,k){for(let b in T)if(_.call(T,b)&&k({key:b,value:T[b]},function(){delete T[b]})===!1)return}e.forEach=R;function P(T,k){const b=Object.create(null);for(const h of T){const c=k(h);let m=b[c];m||(m=b[c]=[]),m.push(h)}return b}e.groupBy=P;function D(T){const k=Object.create(null);return T&&T.forEach((b,h)=>{k[h]=b}),k}e.fromMap=D;function A(T,k){const b=[],h=[];for(let c of T)k.has(c)||b.push(c);for(let c of k)T.has(c)||h.push(c);return{removed:b,added:h}}e.diffSets=A;function C(T,k){const b=[],h=[];for(let[c,m]of T)k.has(c)||b.push(m);for(let[c,m]of k)T.has(c)||h.push(m);return{removed:b,added:h}}e.diffMaps=C;class n{constructor(){this.map=new Map}add(k,b){let h=this.map.get(k);h||(h=new Set,this.map.set(k,h)),h.add(b)}delete(k,b){const h=this.map.get(k);!h||(h.delete(b),h.size===0&&this.map.delete(k))}forEach(k,b){const h=this.map.get(k);!h||h.forEach(b)}}e.SetMap=n}),define(ge[54],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(C){return(n,T,k)=>{let b=null,h=null;if(typeof k.value=="function"?(b="value",h=k.value):typeof k.get=="function"&&(b="get",h=k.get),!h)throw new Error("not supported");k[b]=C(h,T)}}e.createDecorator=_;let y=0;function R(){const C=`$memoize${y++}`;let n;const T=function(b,h,c){let m=null,E=null;if(typeof c.value=="function"?(m="value",E=c.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(m="get",E=c.get),!E)throw new Error("not supported");const g=`${C}:${h}`;c[m]=function(...w){return n=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,w)}),this[g]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(C)===0&&delete n[k]})},T}e.createMemoizer=R;function P(C,n,T){return R()(C,n,T)}e.memoize=P;function D(C,n,T){return _((k,b)=>{const h=`$debounce$${b}`,c=`$debounce$result$${b}`;return function(...m){this[c]||(this[c]=T?T():void 0),clearTimeout(this[h]),n&&(this[c]=n(this[c],...m),m=[this[c]]),this[h]=setTimeout(()=>{k.apply(this,m),this[c]=T?T():void 0},C)}})}e.debounce=D;function A(C,n,T){return _((k,b)=>{const h=`$throttle$timer$${b}`,c=`$throttle$result$${b}`,m=`$throttle$lastRun$${b}`,E=`$throttle$pending$${b}`;return function(...g){if(this[c]||(this[c]=T?T():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),n&&(this[c]=n(this[c],...g)),!this[E]){const w=this[m]+C;w<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[c]]),this[c]=T?T():void 0):(this[E]=!0,this[h]=setTimeout(()=>{this[E]=!1,this[m]=Date.now(),k.apply(this,[this[c]]),this[c]=T?T():void 0},w-Date.now()))}}})}e.throttle=A}),define(ge[16],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function y(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=y;function R(a){C(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function P(a){C(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=P;function D(a){if(a instanceof Error){let{name:t,message:i}=a;const o=a.stacktrace||a.stack;return{$isError:!0,name:t,message:i,stack:o}}return a}e.transformErrorForSerialization=D;const A="Canceled";function C(a){return a instanceof Error&&a.name===A&&a.message===A}e.isPromiseCanceledError=C;class n extends Error{constructor(){super(A);this.name=this.message}}e.CancellationError=n;function T(){const a=new Error(A);return a.name=a.message,a}e.canceled=T;function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=k;function b(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=b;function h(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function m(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=m;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function d(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function u(a,t=Object.create(null)){const i=new Error(a);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=u}),define(ge[12],pe([0,1,16]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function y(M,U=0){return M[M.length-(1+U)]}e.tail=y;function R(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=R;function P(M,U,F=(N,O)=>N===O){if(M===U)return!0;if(!M||!U||M.length!==U.length)return!1;for(let N=0,O=M.length;N<O;N++)if(!F(M[N],U[N]))return!1;return!0}e.equals=P;function D(M,U,F){let N=0,O=M.length-1;for(;N<=O;){const V=(N+O)/2|0,q=F(M[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=D;function A(M,U){let F=0,N=M.length;if(N===0)return 0;for(;F<N;){const O=Math.floor((F+N)/2);U(M[O])?N=O:F=O+1}return F}e.findFirstInSorted=A;function C(M,U,F){if(M=M|0,M>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let Q of U){const fe=F(Q,N);fe<0?O.push(Q):fe>0?V.push(Q):q.push(Q)}return M<O.length?C(M,O,F):M<O.length+q.length?q[0]:C(M-(O.length+q.length),V,F)}e.quickSelect=C;function n(M,U){const F=[];let N;for(const O of M.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],F.push(N)):N.push(O);return F}e.groupBy=n;function T(M,U,F){const N=[];function O(Q,fe,_e){if(!(fe===0&&_e.length===0)){const Le=N[N.length-1];Le&&Le.start+Le.deleteCount===Q?(Le.deleteCount+=fe,Le.toInsert.push(..._e)):N.push({start:Q,deleteCount:fe,toInsert:_e})}}let V=0,q=0;for(;;){if(V===M.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,M.length-V,[]);break}const Q=M[V],fe=U[q],_e=F(Q,fe);_e===0?(V+=1,q+=1):_e<0?(O(V,1,[]),V+=1):_e>0&&(O(V,0,[fe]),q+=1)}return N}e.sortedDiff=T;function k(M,U,F){const N=T(M,U,F),O=[],V=[];for(const q of N)O.push(...M.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=k;function b(M,U,F){if(F===0)return[];const N=M.slice(0,F).sort(U);return c(M,U,N,F,M.length),N}e.top=b;function h(M,U,F,N,O){return F===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const Q=M.length,fe=M.slice(0,F).sort(U);for(let _e=F,Le=Math.min(F+N,Q);_e<Q;_e=Le,Le=Math.min(Le+N,Q)){if(_e>F&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,_.canceled)();c(M,U,fe,_e,Le)}return fe})().then(V,q)})}e.topAsync=h;function c(M,U,F,N,O){for(const V=F.length;N<O;N++){const q=M[N];if(U(q,F[V-1])<0){F.pop();const Q=A(F,fe=>U(q,fe)<0);F.splice(Q,0,q)}}}function m(M){return M.filter(U=>!!U)}e.coalesce=m;function E(M){let U=0;for(let F=0;F<M.length;F++)M[F]&&(M[U]=M[F],U+=1);M.length=U}e.coalesceInPlace=E;function g(M,U,F){M.splice(F,0,M.splice(U,1)[0])}e.move=g;function w(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=w;function d(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=d;function u(M,U){if(!U)return M.filter((N,O)=>M.indexOf(N)===O);const F=Object.create(null);return M.filter(N=>{const O=U(N);return F[O]?!1:(F[O]=!0,!0)})}e.distinct=u;function a(M){const U=new Set;return M.filter(F=>U.has(F)?!1:(U.add(F),!0))}e.distinctES6=a;function t(M){const U=Object.create(null);return F=>{const N=M(F);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function i(M,U){for(let F=M.length-1;F>=0;F--){const N=M[F];if(U(N))return F}return-1}e.lastIndex=i;function o(M,U){return M.length>0?M[0]:U}e.firstOrDefault=o;function s(M,U,F=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(M.length,U.length);O<V&&F(M[O],U[O]);O++)N++;return N}e.commonPrefixLength=s;function r(M){return[].concat(...M)}e.flatten=r;function l(M,U){let F=typeof U=="number"?M:0;typeof U=="number"?F=M:(F=0,U=M);const N=[];if(F<=U)for(let O=F;O<U;O++)N.push(O);else for(let O=F;O>U;O--)N.push(O);return N}e.range=l;function p(M,U,F){return M.reduce((N,O)=>(N[U(O)]=F?F(O):O,N),Object.create(null))}e.index=p;function S(M,U){return M.push(U),()=>f(M,U)}e.insert=S;function f(M,U){const F=M.indexOf(U);if(F>-1)return M.splice(F,1),U}e.remove=f;function v(M,U,F){const N=M.slice(0,U),O=M.slice(U);return N.concat(F,O)}e.arrayInsert=v;function I(M,U){let F;if(typeof U=="number"){let N=U;F=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else F=Math.random;for(let N=M.length-1;N>0;N-=1){const O=Math.floor(F()*(N+1)),V=M[N];M[N]=M[O],M[O]=V}}e.shuffle=I;function L(M,U){const F=M.indexOf(U);F>-1&&(M.splice(F,1),M.unshift(U))}e.pushToStart=L;function x(M,U){const F=M.indexOf(U);F>-1&&(M.splice(F,1),M.push(U))}e.pushToEnd=x;function Z(M,U){return Array.isArray(M)?M.map(U):U(M)}e.mapArrayOrNot=Z;function z(M){return Array.isArray(M)?M:[M]}e.asArray=z;function B(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=B;function $(M,U){for(const F of M){const N=U(F);if(N!==void 0)return N}}e.mapFind=$}),define(ge[69],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(y){const R=this;let P=!1,D;return function(){return P||(P=!0,D=y.apply(R,arguments)),D}}e.once=_}),define(ge[70],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[71],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(y){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}y.is=R;const P=Object.freeze([]);function D(){return P}y.empty=D;function*A(a){yield a}y.single=A;function C(a){return a||P}y.from=C;function n(a){return!a||a[Symbol.iterator]().next().done===!0}y.isEmpty=n;function T(a){return a[Symbol.iterator]().next().value}y.first=T;function k(a,t){for(const i of a)if(t(i))return!0;return!1}y.some=k;function b(a,t){for(const i of a)if(t(i))return i}y.find=b;function*h(a,t){for(const i of a)t(i)&&(yield i)}y.filter=h;function*c(a,t){for(const i of a)yield t(i)}y.map=c;function*m(...a){for(const t of a)for(const i of t)yield i}y.concat=m;function*E(a){for(const t of a)for(const i of t)yield i}y.concatNested=E;function g(a,t,i){let o=i;for(const s of a)o=t(o,s);return o}y.reduce=g;function*w(a,t,i=a.length){for(t<0&&(t+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);t<i;t++)yield a[t]}y.slice=w;function d(a,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,a];const o=a[Symbol.iterator]();for(let s=0;s<t;s++){const r=o.next();if(r.done)return[i,y.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return o}}]}y.consume=d;function u(a,t,i=(o,s)=>o===s){const o=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const r=o.next(),l=s.next();if(r.done!==l.done)return!1;if(r.done)return!0;if(!i(r.value,l.value))return!1}}y.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function D(t,i=!1){let o=0,s=t.length,r="",l=0,p=16,S=0;function f(B){let $=0,M=0;for(;$<B;){const U=t.charCodeAt(o);if(U>=48&&U<=57)M=M*16+U-48;else if(U>=65&&U<=70)M=M*16+U-65+10;else if(U>=97&&U<=102)M=M*16+U-97+10;else break;o++,$++}return $<B&&(M=-1),M}function v(B){o=B,r="",l=0,p=16,S=0}function I(){const B=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return S=3,t.substring(B,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;$=o}else S=3;return t.substring(B,$)}function L(){let B="",$=o;for(;;){if(o>=s){B+=t.substring($,o),S=2;break}const M=t.charCodeAt(o);if(M===34){B+=t.substring($,o),o++;break}if(M===92){if(B+=t.substring($,o),o++,o>=s){S=2;break}switch(t.charCodeAt(o++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const F=f(4);F>=0?B+=String.fromCharCode(F):S=4;break;default:S=5}$=o;continue}if(M>=0&&M<=31)if(C(M)){B+=t.substring($,o),S=2;break}else S=6;o++}return B}function x(){if(r="",S=0,l=o,o>=s)return l=s,p=17;let B=t.charCodeAt(o);if(A(B)){do o++,r+=String.fromCharCode(B),B=t.charCodeAt(o);while(A(B));return p=15}if(C(B))return o++,r+=String.fromCharCode(B),B===13&&t.charCodeAt(o)===10&&(o++,r+=`
`),p=14;switch(B){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,r=L(),p=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<s&&!C(t.charCodeAt(o));)o++;return r=t.substring($,o),p=12}if(t.charCodeAt(o+1)===42){o+=2;const M=s-1;let U=!1;for(;o<M;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,S=1),r=t.substring($,o),p=13}return r+=String.fromCharCode(B),o++,p=16;case 45:if(r+=String.fromCharCode(B),o++,o===s||!n(t.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=I(),p=11;default:for(;o<s&&Z(B);)o++,B=t.charCodeAt(o);if(l!==o){switch(r=t.substring(l,o),r){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return r+=String.fromCharCode(B),o++,p=16}}function Z(B){if(A(B)||C(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>o,scan:i?z:x,getToken:()=>p,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>o-l,getTokenError:()=>S}}e.createScanner=D;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const o=[],s=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function S(f,v,I,L){l.value=f,l.offset=v,l.length=I,l.type=L,l.colonOffset=void 0,r=l}try{d(t,{onObjectBegin:(f,v)=>{if(i<=f)throw s;r=void 0,p=i>f,o.push("")},onObjectProperty:(f,v,I)=>{if(i<v||(S(f,v,I,"property"),o[o.length-1]=f,i<=v+I))throw s},onObjectEnd:(f,v)=>{if(i<=f)throw s;r=void 0,o.pop()},onArrayBegin:(f,v)=>{if(i<=f)throw s;r=void 0,o.push(0)},onArrayEnd:(f,v)=>{if(i<=f)throw s;r=void 0,o.pop()},onLiteralValue:(f,v,I)=>{if(i<v||(S(f,v,I,a(f)),i<=v+I))throw s},onSeparator:(f,v,I)=>{if(i<=v)throw s;if(f===":"&&r&&r.type==="property")r.colonOffset=v,p=!1,r=void 0;else if(f===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(p=!0,o[o.length-1]=""),r=void 0}}})}catch(f){if(f!==s)throw f}return{path:o,previousNode:r,isAtPropertyKey:p,matches:f=>{let v=0;for(let I=0;v<f.length&&I<o.length;I++)if(f[v]===o[I]||f[v]==="*")v++;else if(f[v]!=="**")return!1;return v===f.length}}}e.getLocation=k;function b(t,i=[],o=P.DEFAULT){let s=null,r=[];const l=[];function p(f){Array.isArray(r)?r.push(f):s!==null&&(r[s]=f)}return d(t,{onObjectBegin:()=>{const f={};p(f),l.push(r),r=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const f=[];p(f),l.push(r),r=f,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:p,onError:(f,v,I)=>{i.push({error:f,offset:v,length:I})}},o),r[0]}e.parse=b;function h(t,i=[],o=P.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){s.type==="property"&&(s.length=f-s.offset,s=s.parent)}function l(f){return s.children.push(f),f}d(t,{onObjectBegin:f=>{s=l({type:"object",offset:f,length:-1,parent:s,children:[]})},onObjectProperty:(f,v,I)=>{s=l({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:f,offset:v,length:I,parent:s})},onObjectEnd:(f,v)=>{s.length=f+v-s.offset,s=s.parent,r(f+v)},onArrayBegin:(f,v)=>{s=l({type:"array",offset:f,length:-1,parent:s,children:[]})},onArrayEnd:(f,v)=>{s.length=f+v-s.offset,s=s.parent,r(f+v)},onLiteralValue:(f,v,I)=>{l({type:a(f),offset:v,length:I,parent:s,value:f}),r(v+I)},onSeparator:(f,v,I)=>{s.type==="property"&&(f===":"?s.colonOffset=v:f===","&&r(v))},onError:(f,v,I)=>{i.push({error:f,offset:v,length:I})}},o);const S=s.children[0];return S&&delete S.parent,S}e.parseTree=h;function c(t,i){if(!!t){let o=t;for(let s of i)if(typeof s=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let r=!1;for(const l of o.children)if(Array.isArray(l.children)&&l.children[0].value===s){o=l.children[1],r=!0;break}if(!r)return}else{const r=s;if(o.type!=="array"||r<0||!Array.isArray(o.children)||r>=o.children.length)return;o=o.children[r]}return o}}e.findNodeAtLocation=c;function m(t){if(!t.parent||!t.parent.children)return[];const i=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=m;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const i=Object.create(null);for(let o of t.children){const s=o.children[1];s&&(i[o.children[0].value]=E(s))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function g(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=g;function w(t,i,o=!1){if(g(t,i,o)){const s=t.children;if(Array.isArray(s))for(let r=0;r<s.length&&s[r].offset<=i;r++){const l=w(s[r],i,o);if(l)return l}return t}}e.findNodeAtOffset=w;function d(t,i,o=P.DEFAULT){const s=D(t,!1);function r(fe){return fe?()=>fe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(fe){return fe?_e=>fe(_e,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=r(i.onObjectBegin),S=l(i.onObjectProperty),f=r(i.onObjectEnd),v=r(i.onArrayBegin),I=r(i.onArrayEnd),L=l(i.onLiteralValue),x=l(i.onSeparator),Z=r(i.onComment),z=l(i.onError),B=o&&o.disallowComments,$=o&&o.allowTrailingComma;function M(){for(;;){const fe=s.scan();switch(s.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:B||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(fe){case 12:case 13:B?U(10):Z();break;case 16:U(1);break;case 15:case 14:break;default:return fe}}}function U(fe,_e=[],Le=[]){if(z(fe),_e.length+Le.length>0){let Ie=s.getToken();for(;Ie!==17;){if(_e.indexOf(Ie)!==-1){M();break}else if(Le.indexOf(Ie)!==-1)break;Ie=M()}}}function F(fe){const _e=s.getTokenValue();return fe?L(_e):S(_e),M(),!0}function N(){switch(s.getToken()){case 11:let fe=0;try{fe=JSON.parse(s.getTokenValue()),typeof fe!="number"&&(U(2),fe=0)}catch(_e){U(2)}L(fe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return M(),!0}function O(){return s.getToken()!==10?(U(3,[],[2,5]),!1):(F(!1),s.getToken()===6?(x(":"),M(),Q()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){p(),M();let fe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(fe||U(4,[],[]),x(","),M(),s.getToken()===2&&$)break}else fe&&U(6,[],[]);O()||U(4,[],[2,5]),fe=!0}return f(),s.getToken()!==2?U(7,[2],[]):M(),!0}function q(){v(),M();let fe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(fe||U(4,[],[]),x(","),M(),s.getToken()===4&&$)break}else fe&&U(6,[],[]);Q()||U(4,[],[4,5]),fe=!0}return I(),s.getToken()!==4?U(8,[4],[]):M(),!0}function Q(){switch(s.getToken()){case 3:return q();case 1:return V();case 10:return F(!0);default:return N()}}return M(),s.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):Q()?(s.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=d;function u(t,i){let o=D(t),s=[],r,l=0,p;do switch(p=o.getPosition(),r=o.scan(),r){case 12:case 13:case 17:l!==p&&s.push(t.substring(l,p)),i!==void 0&&s.push(o.getTokenValue().replace(/[^\r\n]/g,i)),l=o.getPosition();break}while(r!==17);return s.join("")}e.stripComments=u;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ge[130],pe([0,1,55]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function y(C,n,T){let k,b,h,c,m;if(n){for(c=n.offset,m=c+n.length,h=c;h>0&&!A(C,h-1);)h--;let l=m;for(;l<C.length&&!A(C,l);)l++;b=C.substring(h,l),k=P(b,T)}else b=C,k=0,h=0,c=0,m=C.length;const E=D(T,C);let g=!1,w=0,d;T.insertSpaces?d=R(" ",T.tabSize||4):d="	";const u=(0,_.createScanner)(b,!1);let a=!1;function t(){return E+R(d,k+w)}function i(){let l=u.scan();for(g=!1;l===15||l===14;)g=g||l===14,l=u.scan();return a=l===16||u.getTokenError()!==0,l}const o=[];function s(l,p,S){!a&&p<m&&S>c&&C.substring(p,S)!==l&&o.push({offset:p,length:S-p,content:l})}let r=i();if(r!==17){const l=u.getTokenOffset()+h,p=R(d,k);s(p,h,l)}for(;r!==17;){let l=u.getTokenOffset()+u.getTokenLength()+h,p=i(),S="";for(;!g&&(p===12||p===13);){const v=u.getTokenOffset()+h;s(" ",l,v),l=u.getTokenOffset()+u.getTokenLength()+h,S=p===12?t():"",p=i()}if(p===2)r!==1&&(w--,S=t());else if(p===4)r!==3&&(w--,S=t());else{switch(r){case 3:case 1:w++,S=t();break;case 5:case 12:S=t();break;case 13:g?S=t():S=" ";break;case 6:S=" ";break;case 10:if(p===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?S=" ":p!==5&&p!==17&&(a=!0);break;case 16:a=!0;break}g&&(p===12||p===13)&&(S=t())}const f=u.getTokenOffset()+h;s(S,l,f),r=p}return o}e.format=y;function R(C,n){let T="";for(let k=0;k<n;k++)T+=C;return T}function P(C,n){let T=0,k=0;const b=n.tabSize||4;for(;T<C.length;){const h=C.charAt(T);if(h===" ")k++;else if(h==="	")k+=b;else break;T++}return Math.floor(k/b)}function D(C,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=D;function A(C,n){return`\r
`.indexOf(C.charAt(n))!==-1}e.isEOL=A}),define(ge[131],pe([0,1,55,130]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(n,T,k){return P(n,T,void 0,k)}e.removeProperty=R;function P(n,T,k,b,h){const c=T.slice(),m=[],E=(0,_.parseTree)(n,m);let g,w;for(;c.length>0&&(w=c.pop(),g=(0,_.findNodeAtLocation)(E,c),g===void 0&&k!==void 0);)typeof w=="string"?k={[w]:k}:k=[k];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const d=(0,_.findNodeAtLocation)(g,[w]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const u=g.children.indexOf(d.parent);let a,t=d.parent.offset+d.parent.length;if(u>0){const i=g.children[u-1];a=i.offset+i.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(n,{offset:a,length:t-a,content:""},b)}else return D(n,{offset:d.offset,length:d.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const u=`${JSON.stringify(w)}: ${JSON.stringify(k)}`,a=h?h(g.children.map(i=>i.children[0].value)):g.children.length;let t;if(a>0){const i=g.children[a-1];t={offset:i.offset+i.length,length:0,content:","+u}}else g.children.length===0?t={offset:g.offset+1,length:0,content:u}:t={offset:g.offset+1,length:0,content:u+","};return D(n,t,b)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let u;if(g.children.length===0||w===0)u={offset:g.offset+1,length:0,content:g.children.length===0?d:d+","};else{const a=w===-1||w>g.children.length?g.children.length:w,t=g.children[a-1];u={offset:t.offset+t.length,length:0,content:","+d}}return D(n,u,b)}else{const d=w,u=g.children[d];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===d){const t=g.children[d-1],i=t.offset+t.length,o=g.offset+g.length;a={offset:i,length:o-2-i,content:""}}else a={offset:u.offset,length:g.children[d+1].offset-u.offset,content:""};return D(n,a,b)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(n,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(k)},b)}}e.setProperty=P;function D(n,T,k){let b=A(n,T),h=T.offset,c=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;h>0&&!(0,y.isEOL)(b,h-1);)h--;for(;c<b.length&&!(0,y.isEOL)(b,c);)c++}const m=(0,y.format)(b,{offset:h,length:c-h},k);for(let g=m.length-1;g>=0;g--){const w=m[g];b=A(b,w),h=Math.min(h,w.offset),c=Math.max(c,w.offset+w.length),c+=w.content.length-w.length}const E=n.length-(b.length-c)-h;return[{offset:h,length:E,content:b.substring(h,c)}]}e.withFormatting=D;function A(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=A;function C(n,T){let k=T.slice(0).sort((h,c)=>{const m=h.offset-c.offset;return m===0?h.length-c.length:m}),b=n.length;for(let h=k.length-1;h>=0;h--){let c=k[h];if(c.offset+c.length<=b)n=A(n,c);else throw new Error("Overlapping edit");b=c.offset}return n}e.applyEdits=C}),define(ge[132],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new _(()=>R(this.getValue()))}}e.Lazy=_}),define(ge[6],pe([0,1,69,71]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let P=null;function D(d){P=d}if(e.setDisposableTracker=D,R){const d="__is_disposable_tracked__";P=new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[d]||console.log(a)},3e3)}markTracked(u){if(u&&u!==m.None)try{u[d]=!0}catch(a){}}}}function A(d){!P||P.markTracked(d)}function C(d){return P&&P.trackDisposable(d),d}e.trackDisposable=C;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function T(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=T;function k(d){if(y.Iterable.is(d)){let u=[];for(const a of d)if(a){A(a);try{a.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(d)?[]:d}else if(d)return A(d),d.dispose(),d}e.dispose=k;function b(...d){return d.forEach(A),h(()=>k(d))}e.combinedDisposable=b;function h(d){const u=C({dispose:()=>{A(u),d()}});return u}e.toDisposable=h;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(A(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return A(u),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new c,C(this)}dispose(){A(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var a;this._isDisposed||u===this._value||((a=this._value)===null||a===void 0||a.dispose(),u&&A(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,A(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=E;class g{constructor(){this.references=new Map}acquire(u,...a){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,t));const{object:i}=t,o=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=g;class w{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=w}),define(ge[56],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(P){this.element=P,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class y{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,D){const A=new _(P);if(this._first===_.Undefined)this._first=A,this._last=A;else if(D){const n=this._last;this._last=A,A.prev=n,n.next=A}else{const n=this._first;this._first=A,A.next=n,n.prev=A}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(A))}}shift(){if(this._first!==_.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==_.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==_.Undefined&&P.next!==_.Undefined){const D=P.prev;D.next=P.next,P.next.prev=D}else P.prev===_.Undefined&&P.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):P.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):P.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==_.Undefined;)yield P.element,P=P.next}}e.LinkedList=y}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(K,oe){for(var ue=0;ue<oe.length;ue++){var J=oe[ue];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(K,J.key,J)}}function e(K,oe,ue){return oe&&Y(K.prototype,oe),ue&&Y(K,ue),K}function _(K,oe){if(!!K){if(typeof K=="string")return y(K,oe);var ue=Object.prototype.toString.call(K).slice(8,-1);if(ue==="Object"&&K.constructor&&(ue=K.constructor.name),ue==="Map"||ue==="Set")return Array.from(K);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return y(K,oe)}}function y(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var ue=0,J=new Array(oe);ue<oe;ue++)J[ue]=K[ue];return J}function R(K,oe){var ue;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(ue=_(K))||oe&&K&&typeof K.length=="number"){ue&&(K=ue);var J=0;return function(){return J>=K.length?{done:!0}:{done:!1,value:K[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ue=K[Symbol.iterator](),ue.next.bind(ue)}function P(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var D=P(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ue(J){K.exports.defaults=J}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:ue}}),A=/[&<>"']/,C=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(oe){return k[oe]};function h(K,oe){if(oe){if(A.test(K))return K.replace(C,b)}else if(n.test(K))return K.replace(T,b);return K}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(K){return K.replace(c,function(oe,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var E=/(^|[^\[])\^/g;function g(K,oe){K=K.source||K,oe=oe||"";var ue={replace:function(ne,le){return le=le.source||le,le=le.replace(E,"$1"),K=K.replace(ne,le),ue},getRegex:function(){return new RegExp(K,oe)}};return ue}var w=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(K,oe,ue){if(K){var J;try{J=decodeURIComponent(m(ue)).replace(w,"").toLowerCase()}catch(ne){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}oe&&!d.test(ue)&&(ue=s(oe,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch(ne){return null}return ue}var a={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(K,oe){a[" "+K]||(t.test(K)?a[" "+K]=K+"/":a[" "+K]=S(K,"/",!0)),K=a[" "+K];var ue=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?ue?oe:K.replace(i,"$1")+oe:oe.charAt(0)==="/"?ue?oe:K.replace(o,"$1")+oe:K+oe}var r={exec:function(){}};function l(K){for(var oe=1,ue,J;oe<arguments.length;oe++){ue=arguments[oe];for(J in ue)Object.prototype.hasOwnProperty.call(ue,J)&&(K[J]=ue[J])}return K}function p(K,oe){var ue=K.replace(/\|/g,function(le,me,Ee){for(var He=!1,$e=me;--$e>=0&&Ee[$e]==="\\";)He=!He;return He?"|":" |"}),J=ue.split(/ \|/),ne=0;if(J.length>oe)J.splice(oe);else for(;J.length<oe;)J.push("");for(;ne<J.length;ne++)J[ne]=J[ne].trim().replace(/\\\|/g,"|");return J}function S(K,oe,ue){var J=K.length;if(J===0)return"";for(var ne=0;ne<J;){var le=K.charAt(J-ne-1);if(le===oe&&!ue)ne++;else if(le!==oe&&ue)ne++;else break}return K.substr(0,J-ne)}function f(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var ue=K.length,J=0,ne=0;ne<ue;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===oe[0])J++;else if(K[ne]===oe[1]&&(J--,J<0))return ne;return-1}function v(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(K,oe){if(oe<1)return"";for(var ue="";oe>1;)oe&1&&(ue+=K),oe>>=1,K+=K;return ue+K}var L={escape:h,unescape:m,edit:g,cleanUrl:u,resolveUrl:s,noopTest:r,merge:l,splitCells:p,rtrim:S,findClosingBracket:f,checkSanitizeDeprecation:v,repeatString:I},x=D.defaults,Z=L.rtrim,z=L.splitCells,B=L.escape,$=L.findClosingBracket;function M(K,oe,ue){var J=oe.href,ne=oe.title?B(oe.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:ue,href:J,title:ne,text:le}:{type:"image",raw:ue,href:J,title:ne,text:B(le)}}function U(K,oe){var ue=K.match(/^(\s+)(?:```)/);if(ue===null)return oe;var J=ue[1];return oe.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var me=le[0];return me.length>=J.length?ne.slice(J.length):ne}).join(`
`)}var F=function(){function K(ue){this.options=ue||x}var oe=K.prototype;return oe.space=function(J){var ne=this.rules.block.newline.exec(J);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(J){var ne=this.rules.block.code.exec(J);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:Z(le,`
`)}}},oe.fences=function(J){var ne=this.rules.block.fences.exec(J);if(ne){var le=ne[0],me=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:me}}},oe.heading=function(J){var ne=this.rules.block.heading.exec(J);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var me=Z(le,"#");(this.options.pedantic||!me||/ $/.test(me))&&(le=me.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},oe.nptable=function(J){var ne=this.rules.block.nptable.exec(J);if(ne){var le={type:"table",header:z(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var me=le.align.length,Ee;for(Ee=0;Ee<me;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(me=le.cells.length,Ee=0;Ee<me;Ee++)le.cells[Ee]=z(le.cells[Ee],le.header.length);return le}}},oe.hr=function(J){var ne=this.rules.block.hr.exec(J);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(J){var ne=this.rules.block.blockquote.exec(J);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},oe.list=function(J){var ne=this.rules.block.list.exec(J);if(ne){var le=ne[0],me=ne[2],Ee=me.length>1,He={type:"list",raw:le,ordered:Ee,start:Ee?+me.slice(0,-1):"",loose:!1,items:[]},$e=ne[0].match(this.rules.block.item),qe=!1,Qe,Ze,ut,st,be,he,ce,ee,Ae=$e.length;ut=this.rules.block.listItemStart.exec($e[0]);for(var Re=0;Re<Ae;Re++){if(Qe=$e[Re],le=Qe,Re!==Ae-1){if(st=this.rules.block.listItemStart.exec($e[Re+1]),this.options.pedantic?st[1].length>ut[1].length:st[1].length>ut[0].length||st[1].length>3){$e.splice(Re,2,$e[Re]+`
`+$e[Re+1]),Re--,Ae--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==me[me.length-1]:Ee===(st[2].length===1))&&(be=$e.slice(Re+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-be.length),Re=Ae-1);ut=st}Ze=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(Ze-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),he=qe||/\n\n(?!\s*$)/.test(Qe),Re!==Ae-1&&(qe=Qe.charAt(Qe.length-1)===`
`,he||(he=qe)),he&&(He.loose=!0),this.options.gfm&&(ce=/^\[[ xX]\] /.test(Qe),ee=void 0,ce&&(ee=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:ce,checked:ee,loose:he,text:Qe})}return He}},oe.html=function(J){var ne=this.rules.block.html.exec(J);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):B(ne[0]):ne[0]}},oe.def=function(J){var ne=this.rules.block.def.exec(J);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(J){var ne=this.rules.block.table.exec(J);if(ne){var le={type:"table",header:z(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var me=le.align.length,Ee;for(Ee=0;Ee<me;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(me=le.cells.length,Ee=0;Ee<me;Ee++)le.cells[Ee]=z(le.cells[Ee].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(J){var ne=this.rules.block.lheading.exec(J);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(J){var ne=this.rules.block.paragraph.exec(J);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(J){var ne=this.rules.block.text.exec(J);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(J){var ne=this.rules.inline.escape.exec(J);if(ne)return{type:"escape",raw:ne[0],text:B(ne[1])}},oe.tag=function(J,ne,le){var me=this.rules.inline.tag.exec(J);if(me)return!ne&&/^<a /i.test(me[0])?ne=!0:ne&&/^<\/a>/i.test(me[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]}},oe.link=function(J){var ne=this.rules.inline.link.exec(J);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var me=Z(le.slice(0,-1),"\\");if((le.length-me.length)%2==0)return}else{var Ee=$(ne[2],"()");if(Ee>-1){var He=ne[0].indexOf("!")===0?5:4,$e=He+ne[1].length+Ee;ne[2]=ne[2].substring(0,Ee),ne[0]=ne[0].substring(0,$e).trim(),ne[3]=""}}var qe=ne[2],Qe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Ze&&(qe=Ze[1],Qe=Ze[3])}else Qe=ne[3]?ne[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),M(ne,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(J,ne){var le;if((le=this.rules.inline.reflink.exec(J))||(le=this.rules.inline.nolink.exec(J))){var me=(le[2]||le[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var Ee=le[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return M(le,me,le[0])}},oe.emStrong=function(J,ne,le){le===void 0&&(le="");var me=this.rules.inline.emStrong.lDelim.exec(J);if(!!me&&!(me[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=me[1]||me[2]||"";if(!Ee||Ee&&(le===""||this.rules.inline.punctuation.exec(le))){var He=me[0].length-1,$e,qe,Qe=He,Ze=0,ut=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*J.length+He);(me=ut.exec(ne))!=null;)if($e=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!$e){if(qe=$e.length,me[3]||me[4]){Qe+=qe;continue}else if((me[5]||me[6])&&He%3&&!((He+qe)%3)){Ze+=qe;continue}if(Qe-=qe,!(Qe>0)){if(Qe+Ze-qe<=0&&!ne.slice(ut.lastIndex).match(ut)&&(qe=Math.min(qe,qe+Qe+Ze)),Math.min(He,qe)%2)return{type:"em",raw:J.slice(0,He+me.index+qe+1),text:J.slice(1,He+me.index+qe)};if(Math.min(He,qe)%2==0)return{type:"strong",raw:J.slice(0,He+me.index+qe+1),text:J.slice(2,He+me.index+qe-1)}}}}}},oe.codespan=function(J){var ne=this.rules.inline.code.exec(J);if(ne){var le=ne[2].replace(/\n/g," "),me=/[^ ]/.test(le),Ee=/^ /.test(le)&&/ $/.test(le);return me&&Ee&&(le=le.substring(1,le.length-1)),le=B(le,!0),{type:"codespan",raw:ne[0],text:le}}},oe.br=function(J){var ne=this.rules.inline.br.exec(J);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(J){var ne=this.rules.inline.del.exec(J);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(J,ne){var le=this.rules.inline.autolink.exec(J);if(le){var me,Ee;return le[2]==="@"?(me=B(this.options.mangle?ne(le[1]):le[1]),Ee="mailto:"+me):(me=B(le[1]),Ee=me),{type:"link",raw:le[0],text:me,href:Ee,tokens:[{type:"text",raw:me,text:me}]}}},oe.url=function(J,ne){var le;if(le=this.rules.inline.url.exec(J)){var me,Ee;if(le[2]==="@")me=B(this.options.mangle?ne(le[0]):le[0]),Ee="mailto:"+me;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);me=B(le[0]),le[1]==="www."?Ee="http://"+me:Ee=me}return{type:"link",raw:le[0],text:me,href:Ee,tokens:[{type:"text",raw:me,text:me}]}}},oe.inlineText=function(J,ne,le){var me=this.rules.inline.text.exec(J);if(me){var Ee;return ne?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]:Ee=B(this.options.smartypants?le(me[0]):me[0]),{type:"text",raw:me[0],text:Ee}}},K}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=V({},Q),Q.pedantic=V({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=V({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=V({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:q,inline:Q},_e=D.defaults,Le=fe.block,Ie=fe.inline,Fe=L.repeatString;function j(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(K){var oe="",ue,J,ne=K.length;for(ue=0;ue<ne;ue++)J=K.charCodeAt(ue),Math.random()>.5&&(J="x"+J.toString(16)),oe+="&#"+J+";";return oe}var te=function(){function K(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||_e,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Le.normal,inline:Ie.normal};this.options.pedantic?(J.block=Le.pedantic,J.inline=Ie.pedantic):this.options.gfm&&(J.block=Le.gfm,this.options.breaks?J.inline=Ie.breaks:J.inline=Ie.gfm),this.tokenizer.rules=J}K.lex=function(J,ne){var le=new K(ne);return le.lex(J)},K.lexInline=function(J,ne){var le=new K(ne);return le.inlineTokens(J)};var oe=K.prototype;return oe.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(J,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var me,Ee,He,$e;J;){if(me=this.tokenizer.space(J)){J=J.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(J)){J=J.substring(me.raw.length),$e=ne[ne.length-1],$e&&$e.type==="paragraph"?($e.raw+=`
`+me.raw,$e.text+=`
`+me.text):ne.push(me);continue}if(me=this.tokenizer.fences(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.nptable(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(J)){J=J.substring(me.raw.length),me.tokens=this.blockTokens(me.text,[],le),ne.push(me);continue}if(me=this.tokenizer.list(J)){for(J=J.substring(me.raw.length),He=me.items.length,Ee=0;Ee<He;Ee++)me.items[Ee].tokens=this.blockTokens(me.items[Ee].text,[],!1);ne.push(me);continue}if(me=this.tokenizer.html(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.def(J))){J=J.substring(me.raw.length),this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.paragraph(J))){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.text(J)){J=J.substring(me.raw.length),$e=ne[ne.length-1],$e&&$e.type==="text"?($e.raw+=`
`+me.raw,$e.text+=`
`+me.text):ne.push(me);continue}if(J){var qe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},oe.inline=function(J){var ne,le,me,Ee,He,$e,qe=J.length;for(ne=0;ne<qe;ne++)switch($e=J[ne],$e.type){case"paragraph":case"text":case"heading":{$e.tokens=[],this.inlineTokens($e.text,$e.tokens);break}case"table":{for($e.tokens={header:[],cells:[]},Ee=$e.header.length,le=0;le<Ee;le++)$e.tokens.header[le]=[],this.inlineTokens($e.header[le],$e.tokens.header[le]);for(Ee=$e.cells.length,le=0;le<Ee;le++)for(He=$e.cells[le],$e.tokens.cells[le]=[],me=0;me<He.length;me++)$e.tokens.cells[le][me]=[],this.inlineTokens(He[me],$e.tokens.cells[le][me]);break}case"blockquote":{this.inline($e.tokens);break}case"list":{for(Ee=$e.items.length,le=0;le<Ee;le++)this.inline($e.items[le].tokens);break}}return J},oe.inlineTokens=function(J,ne,le,me){ne===void 0&&(ne=[]),le===void 0&&(le=!1),me===void 0&&(me=!1);var Ee,He,$e=J,qe,Qe,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ut.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,qe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Qe||(Ze=""),Qe=!1,Ee=this.tokenizer.escape(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.tag(J,le,me)){J=J.substring(Ee.raw.length),le=Ee.inLink,me=Ee.inRawBlock;var st=ne[ne.length-1];st&&Ee.type==="text"&&st.type==="text"?(st.raw+=Ee.raw,st.text+=Ee.text):ne.push(Ee);continue}if(Ee=this.tokenizer.link(J)){J=J.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,me)),ne.push(Ee);continue}if(Ee=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(Ee.raw.length);var be=ne[ne.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,me),ne.push(Ee)):be&&Ee.type==="text"&&be.type==="text"?(be.raw+=Ee.raw,be.text+=Ee.text):ne.push(Ee);continue}if(Ee=this.tokenizer.emStrong(J,$e,Ze)){J=J.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,me),ne.push(Ee);continue}if(Ee=this.tokenizer.codespan(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.br(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.del(J)){J=J.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,me),ne.push(Ee);continue}if(Ee=this.tokenizer.autolink(J,X)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(!le&&(Ee=this.tokenizer.url(J,X))){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.inlineText(J,me,j)){J=J.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(Ze=Ee.raw.slice(-1)),Qe=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=Ee.raw,He.text+=Ee.text):ne.push(Ee);continue}if(J){var he="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Le,inline:Ie}}}]),K}(),ae=D.defaults,ve=L.cleanUrl,De=L.escape,Oe=function(){function K(ue){this.options=ue||ae}var oe=K.prototype;return oe.code=function(J,ne,le){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(J,me);Ee!=null&&Ee!==J&&(le=!0,J=Ee)}return J=J.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+De(me,!0)+'">'+(le?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(le?J:De(J,!0))+`</code></pre>
`},oe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},oe.html=function(J){return J},oe.heading=function(J,ne,le,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(le)+'">'+J+"</h"+ne+`>
`:"<h"+ne+">"+J+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(J,ne,le){var me=ne?"ol":"ul",Ee=ne&&le!==1?' start="'+le+'"':"";return"<"+me+Ee+`>
`+J+"</"+me+`>
`},oe.listitem=function(J){return"<li>"+J+`</li>
`},oe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(J){return"<p>"+J+`</p>
`},oe.table=function(J,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ne+`</table>
`},oe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},oe.tablecell=function(J,ne){var le=ne.header?"th":"td",me=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return me+J+"</"+le+`>
`},oe.strong=function(J){return"<strong>"+J+"</strong>"},oe.em=function(J){return"<em>"+J+"</em>"},oe.codespan=function(J){return"<code>"+J+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(J){return"<del>"+J+"</del>"},oe.link=function(J,ne,le){if(J=ve(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var me='<a href="'+De(J)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+le+"</a>",me},oe.image=function(J,ne,le){if(J=ve(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var me='<img src="'+J+'" alt="'+le+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},oe.text=function(J){return J},K}(),we=function(){function K(){}var oe=K.prototype;return oe.strong=function(J){return J},oe.em=function(J){return J},oe.codespan=function(J){return J},oe.del=function(J){return J},oe.html=function(J){return J},oe.text=function(J){return J},oe.link=function(J,ne,le){return""+le},oe.image=function(J,ne,le){return""+le},oe.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(J,ne){var le=J,me=0;if(this.seen.hasOwnProperty(le)){me=this.seen[J];do me++,le=J+"-"+me;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[J]=me,this.seen[le]=0),le},oe.slug=function(J,ne){ne===void 0&&(ne={});var le=this.serialize(J);return this.getNextSafeSlug(le,ne.dryrun)},K}(),Te=D.defaults,xe=L.unescape,ye=function(){function K(ue){this.options=ue||Te,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}K.parse=function(J,ne){var le=new K(ne);return le.parse(J)},K.parseInline=function(J,ne){var le=new K(ne);return le.parseInline(J)};var oe=K.prototype;return oe.parse=function(J,ne){ne===void 0&&(ne=!0);var le="",me,Ee,He,$e,qe,Qe,Ze,ut,st,be,he,ce,ee,Ae,Re,et,Ge,rt,lt=J.length;for(me=0;me<lt;me++)switch(be=J[me],be.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(be.tokens),be.depth,xe(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ut="",Ze="",$e=be.header.length,Ee=0;Ee<$e;Ee++)Ze+=this.renderer.tablecell(this.parseInline(be.tokens.header[Ee]),{header:!0,align:be.align[Ee]});for(ut+=this.renderer.tablerow(Ze),st="",$e=be.cells.length,Ee=0;Ee<$e;Ee++){for(Qe=be.tokens.cells[Ee],Ze="",qe=Qe.length,He=0;He<qe;He++)Ze+=this.renderer.tablecell(this.parseInline(Qe[He]),{header:!1,align:be.align[He]});st+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,st);continue}case"blockquote":{st=this.parse(be.tokens),le+=this.renderer.blockquote(st);continue}case"list":{for(he=be.ordered,ce=be.start,ee=be.loose,$e=be.items.length,st="",Ee=0;Ee<$e;Ee++)Re=be.items[Ee],et=Re.checked,Ge=Re.task,Ae="",Re.task&&(rt=this.renderer.checkbox(et),ee?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=rt+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=rt+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:rt}):Ae+=rt),Ae+=this.parse(Re.tokens,ee),st+=this.renderer.listitem(Ae,Ge,et);le+=this.renderer.list(st,he,ce);continue}case"html":{le+=this.renderer.html(be.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(st=be.tokens?this.parseInline(be.tokens):be.text;me+1<lt&&J[me+1].type==="text";)be=J[++me],st+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);le+=ne?this.renderer.paragraph(st):st;continue}default:{var Xe='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}return le},oe.parseInline=function(J,ne){ne=ne||this.renderer;var le="",me,Ee,He=J.length;for(me=0;me<He;me++)switch(Ee=J[me],Ee.type){case"escape":{le+=ne.text(Ee.text);break}case"html":{le+=ne.html(Ee.text);break}case"link":{le+=ne.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,ne));break}case"image":{le+=ne.image(Ee.href,Ee.title,Ee.text);break}case"strong":{le+=ne.strong(this.parseInline(Ee.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(Ee.tokens,ne));break}case"codespan":{le+=ne.codespan(Ee.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(Ee.tokens,ne));break}case"text":{le+=ne.text(Ee.text);break}default:{var $e='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}return le},K}(),Ke=L.merge,G=L.checkSanitizeDeprecation,ie=L.escape,Se=D.getDefaults,Ne=D.changeDefaults,ze=D.defaults;function We(K,oe,ue){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(ue=oe,oe=null),oe=Ke({},We.defaults,oe||{}),G(oe),ue){var J=oe.highlight,ne;try{ne=te.lex(K,oe)}catch(He){return ue(He)}var le=function($e){var qe;if(!$e)try{qe=ye.parse(ne,oe)}catch(Qe){$e=Qe}return oe.highlight=J,$e?ue($e):ue(null,qe)};if(!J||J.length<3||(delete oe.highlight,!ne.length))return le();var me=0;We.walkTokens(ne,function(He){He.type==="code"&&(me++,setTimeout(function(){J(He.text,He.lang,function($e,qe){if($e)return le($e);qe!=null&&qe!==He.text&&(He.text=qe,He.escaped=!0),me--,me===0&&le()})},0))}),me===0&&le();return}try{var Ee=te.lex(K,oe);return oe.walkTokens&&We.walkTokens(Ee,oe.walkTokens),ye.parse(Ee,oe)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+ie(He.message+"",!0)+"</pre>";throw He}}We.options=We.setOptions=function(K){return Ke(We.defaults,K),Ne(We.defaults),We},We.getDefaults=Se,We.defaults=ze,We.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var J=We.defaults.renderer||new Oe,ne=function(Ee){var He=J[Ee];J[Ee]=function(){for(var $e=arguments.length,qe=new Array($e),Qe=0;Qe<$e;Qe++)qe[Qe]=arguments[Qe];var Ze=K.renderer[Ee].apply(J,qe);return Ze===!1&&(Ze=He.apply(J,qe)),Ze}};for(var le in K.renderer)ne(le);oe.renderer=J}(),K.tokenizer&&function(){var J=We.defaults.tokenizer||new F,ne=function(Ee){var He=J[Ee];J[Ee]=function(){for(var $e=arguments.length,qe=new Array($e),Qe=0;Qe<$e;Qe++)qe[Qe]=arguments[Qe];var Ze=K.tokenizer[Ee].apply(J,qe);return Ze===!1&&(Ze=He.apply(J,qe)),Ze}};for(var le in K.tokenizer)ne(le);oe.tokenizer=J}(),K.walkTokens){var ue=We.defaults.walkTokens;oe.walkTokens=function(J){K.walkTokens(J),ue&&ue(J)}}We.setOptions(oe)},We.walkTokens=function(K,oe){for(var ue=R(K),J;!(J=ue()).done;){var ne=J.value;switch(oe(ne),ne.type){case"table":{for(var le=R(ne.tokens.header),me;!(me=le()).done;){var Ee=me.value;We.walkTokens(Ee,oe)}for(var He=R(ne.tokens.cells),$e;!($e=He()).done;)for(var qe=$e.value,Qe=R(qe),Ze;!(Ze=Qe()).done;){var ut=Ze.value;We.walkTokens(ut,oe)}break}case"list":{We.walkTokens(ne.items,oe);break}default:ne.tokens&&We.walkTokens(ne.tokens,oe)}}},We.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},We.defaults,oe||{}),G(oe);try{var ue=te.lexInline(K,oe);return oe.walkTokens&&We.walkTokens(ue,oe.walkTokens),ye.parseInline(ue,oe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},We.Parser=ye,We.parser=ye.parse,We.Renderer=Oe,We.TextRenderer=we,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=F,We.Slugger=ke,We.parse=We;var Ye=We;return Ye}),define(ge[72],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(D,A,C){return Math.min(Math.max(D,A),C)}e.clamp=_;function y(D,A){return(A+D%A)%A}e.rot=y;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class P{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function Y(R){const P=[];typeof R=="number"&&P.push("code/timeOrigin",R);function D(C){P.push(C,Date.now())}function A(){const C=[];for(let n=0;n<P.length;n+=2)C.push({name:P[n],startTime:P[n+1]});return C}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(R+D.startTime)});return P}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function _(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=_(y))})(),define(ge[9],pe([0,1]),function(Y,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const y="en";let R=!1,P=!1,D=!1,A=!1,C=!1,n=!1,T=!1,k,b=y,h,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof process!="undefined"?m=process:typeof e.globals.vscode!="undefined"&&(m=e.globals.vscode.process);const E=typeof((_=m==null?void 0:m.versions)===null||_===void 0?void 0:_.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=E&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=m==null?void 0:m.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)c=navigator.userAgent,R=c.indexOf("Windows")>=0,P=c.indexOf("Macintosh")>=0,T=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=c.indexOf("Linux")>=0,n=!0,k=navigator.language,b=k;else if(typeof m=="object"){R=m.platform==="win32",P=m.platform==="darwin",D=m.platform==="linux",A=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,k=y,b=y;const s=m.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),l=r.availableLanguages["*"];k=r.locale,b=l||y,h=r._translationsConfigFile}catch(r){}C=!0}else console.error("Unable to resolve platform.");var g;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let d=0;P?d=1:R?d=3:D&&(d=2),e.isWindows=R,e.isMacintosh=P,e.isLinux=D,e.isLinuxSnap=A,e.isNative=C,e.isWeb=n,e.isIOS=T,e.platform=d,e.userAgent=c,e.language=b;var u;(function(s){function r(){return e.language}s.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function p(){return e.language==="en"}s.isDefault=p})(u=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let f=0,v=l.length;f<v;f++){const I=l[f];if(I.id===S.data.vscodeSetImmediateId){l.splice(f,1),I.callback();return}}});let p=0;return S=>{const f=++p;l.push({id:f,callback:S}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const r=Promise.resolve();return l=>r.then(l)}();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||T?2:R?1:3;let t=!0,i=!1;function o(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[30],pe([0,1,9]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let y;if(typeof process!="undefined")y={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}};else if(typeof _.globals.vscode!="undefined"){const R=_.globals.vscode.process;y={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(P){return(0,_.setImmediate)(P)}}}else y={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(R){return(0,_.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=y.cwd,e.env=y.env,e.platform=y.platform,e.nextTick=y.nextTick}),define(ge[7],pe([0,1,30]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const y=65,R=97,P=90,D=122,A=46,C=47,n=92,T=58,k=63;class b extends Error{constructor(u,a,t){let i;typeof a=="string"&&a.indexOf("not ")===0?(i="must not be",a=a.replace(/^not /,"")):i="must be";const o=u.indexOf(".")!==-1?"property":"argument";let s=`The "${u}" ${o} ${i} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(d,u){if(typeof d!="string")throw new b(u,"string",d)}function c(d){return d===C||d===n}function m(d){return d===C}function E(d){return d>=y&&d<=P||d>=R&&d<=D}function g(d,u,a,t){let i="",o=0,s=-1,r=0,l=0;for(let p=0;p<=d.length;++p){if(p<d.length)l=d.charCodeAt(p);else{if(t(l))break;l=C}if(t(l)){if(!(s===p-1||r===1))if(r===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==A||i.charCodeAt(i.length-2)!==A){if(i.length>2){const S=i.lastIndexOf(a);S===-1?(i="",o=0):(i=i.slice(0,S),o=i.length-1-i.lastIndexOf(a)),s=p,r=0;continue}else if(i.length!==0){i="",o=0,s=p,r=0;continue}}u&&(i+=i.length>0?`${a}..`:"..",o=2)}else i.length>0?i+=`${a}${d.slice(s+1,p)}`:i=d.slice(s+1,p),o=p-s-1;s=p,r=0}else l===A&&r!==-1?++r:r=-1}return i}function w(d,u){if(u===null||typeof u!="object")throw new b("pathObject","Object",u);const a=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return a?a===u.root?`${a}${t}`:`${a}${d}${t}`:t}e.win32={resolve(...d){let u="",a="",t=!1;for(let i=d.length-1;i>=-1;i--){let o;if(i>=0){if(o=d[i],h(o,"path"),o.length===0)continue}else u.length===0?o=_.cwd():(o=_.env[`=${u}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${u}\\`));const s=o.length;let r=0,l="",p=!1;const S=o.charCodeAt(0);if(s===1)c(S)&&(r=1,p=!0);else if(c(S))if(p=!0,c(o.charCodeAt(1))){let f=2,v=f;for(;f<s&&!c(o.charCodeAt(f));)f++;if(f<s&&f!==v){const I=o.slice(v,f);for(v=f;f<s&&c(o.charCodeAt(f));)f++;if(f<s&&f!==v){for(v=f;f<s&&!c(o.charCodeAt(f));)f++;(f===s||f!==v)&&(l=`\\\\${I}\\${o.slice(v,f)}`,r=f)}}}else r=1;else E(S)&&o.charCodeAt(1)===T&&(l=o.slice(0,2),r=2,s>2&&c(o.charCodeAt(2))&&(p=!0,r=3));if(l.length>0)if(u.length>0){if(l.toLowerCase()!==u.toLowerCase())continue}else u=l;if(t){if(u.length>0)break}else if(a=`${o.slice(r)}\\${a}`,t=p,p&&u.length>0)break}return a=g(a,!t,"\\",c),t?`${u}\\${a}`:`${u}${a}`||"."},normalize(d){h(d,"path");const u=d.length;if(u===0)return".";let a=0,t,i=!1;const o=d.charCodeAt(0);if(u===1)return m(o)?"\\":d;if(c(o))if(i=!0,c(d.charCodeAt(1))){let r=2,l=r;for(;r<u&&!c(d.charCodeAt(r));)r++;if(r<u&&r!==l){const p=d.slice(l,r);for(l=r;r<u&&c(d.charCodeAt(r));)r++;if(r<u&&r!==l){for(l=r;r<u&&!c(d.charCodeAt(r));)r++;if(r===u)return`\\\\${p}\\${d.slice(l)}\\`;r!==l&&(t=`\\\\${p}\\${d.slice(l,r)}`,a=r)}}}else a=1;else E(o)&&d.charCodeAt(1)===T&&(t=d.slice(0,2),a=2,u>2&&c(d.charCodeAt(2))&&(i=!0,a=3));let s=a<u?g(d.slice(a),!i,"\\",c):"";return s.length===0&&!i&&(s="."),s.length>0&&c(d.charCodeAt(u-1))&&(s+="\\"),t===void 0?i?`\\${s}`:s:i?`${t}\\${s}`:`${t}${s}`},isAbsolute(d){h(d,"path");const u=d.length;if(u===0)return!1;const a=d.charCodeAt(0);return c(a)||u>2&&E(a)&&d.charCodeAt(1)===T&&c(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,a;for(let o=0;o<d.length;++o){const s=d[o];h(s,"path"),s.length>0&&(u===void 0?u=a=s:u+=`\\${s}`)}if(u===void 0)return".";let t=!0,i=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++i;const o=a.length;o>1&&c(a.charCodeAt(1))&&(++i,o>2&&(c(a.charCodeAt(2))?++i:t=!1))}if(t){for(;i<u.length&&c(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(d,u){if(h(d,"from"),h(u,"to"),d===u)return"";const a=e.win32.resolve(d),t=e.win32.resolve(u);if(a===t||(d=a.toLowerCase(),u=t.toLowerCase(),d===u))return"";let i=0;for(;i<d.length&&d.charCodeAt(i)===n;)i++;let o=d.length;for(;o-1>i&&d.charCodeAt(o-1)===n;)o--;const s=o-i;let r=0;for(;r<u.length&&u.charCodeAt(r)===n;)r++;let l=u.length;for(;l-1>r&&u.charCodeAt(l-1)===n;)l--;const p=l-r,S=s<p?s:p;let f=-1,v=0;for(;v<S;v++){const L=d.charCodeAt(i+v);if(L!==u.charCodeAt(r+v))break;L===n&&(f=v)}if(v!==S){if(f===-1)return t}else{if(p>S){if(u.charCodeAt(r+v)===n)return t.slice(r+v+1);if(v===2)return t.slice(r+v)}s>S&&(d.charCodeAt(i+v)===n?f=v:v===2&&(f=3)),f===-1&&(f=0)}let I="";for(v=i+f+1;v<=o;++v)(v===o||d.charCodeAt(v)===n)&&(I+=I.length===0?"..":"\\..");return r+=f,I.length>0?`${I}${t.slice(r,l)}`:(t.charCodeAt(r)===n&&++r,t.slice(r,l))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const a=u.charCodeAt(2);if(a!==k&&a!==A)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(E(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return d},dirname(d){h(d,"path");const u=d.length;if(u===0)return".";let a=-1,t=0;const i=d.charCodeAt(0);if(u===1)return c(i)?d:".";if(c(i)){if(a=t=1,c(d.charCodeAt(1))){let r=2,l=r;for(;r<u&&!c(d.charCodeAt(r));)r++;if(r<u&&r!==l){for(l=r;r<u&&c(d.charCodeAt(r));)r++;if(r<u&&r!==l){for(l=r;r<u&&!c(d.charCodeAt(r));)r++;if(r===u)return d;r!==l&&(a=t=r+1)}}}}else E(i)&&d.charCodeAt(1)===T&&(a=u>2&&c(d.charCodeAt(2))?3:2,t=a);let o=-1,s=!0;for(let r=u-1;r>=t;--r)if(c(d.charCodeAt(r))){if(!s){o=r;break}}else s=!1;if(o===-1){if(a===-1)return".";o=a}return d.slice(0,o)},basename(d,u){u!==void 0&&h(u,"ext"),h(d,"path");let a=0,t=-1,i=!0,o;if(d.length>=2&&E(d.charCodeAt(0))&&d.charCodeAt(1)===T&&(a=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let s=u.length-1,r=-1;for(o=d.length-1;o>=a;--o){const l=d.charCodeAt(o);if(c(l)){if(!i){a=o+1;break}}else r===-1&&(i=!1,r=o+1),s>=0&&(l===u.charCodeAt(s)?--s==-1&&(t=o):(s=-1,t=r))}return a===t?t=r:t===-1&&(t=d.length),d.slice(a,t)}for(o=d.length-1;o>=a;--o)if(c(d.charCodeAt(o))){if(!i){a=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":d.slice(a,t)},extname(d){h(d,"path");let u=0,a=-1,t=0,i=-1,o=!0,s=0;d.length>=2&&d.charCodeAt(1)===T&&E(d.charCodeAt(0))&&(u=t=2);for(let r=d.length-1;r>=u;--r){const l=d.charCodeAt(r);if(c(l)){if(!o){t=r+1;break}continue}i===-1&&(o=!1,i=r+1),l===A?a===-1?a=r:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||i===-1||s===0||s===1&&a===i-1&&a===t+1?"":d.slice(a,i)},format:w.bind(null,"\\"),parse(d){h(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const a=d.length;let t=0,i=d.charCodeAt(0);if(a===1)return c(i)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(c(i)){if(t=1,c(d.charCodeAt(1))){let f=2,v=f;for(;f<a&&!c(d.charCodeAt(f));)f++;if(f<a&&f!==v){for(v=f;f<a&&c(d.charCodeAt(f));)f++;if(f<a&&f!==v){for(v=f;f<a&&!c(d.charCodeAt(f));)f++;f===a?t=f:f!==v&&(t=f+1)}}}}else if(E(i)&&d.charCodeAt(1)===T){if(a<=2)return u.root=u.dir=d,u;if(t=2,c(d.charCodeAt(2))){if(a===3)return u.root=u.dir=d,u;t=3}}t>0&&(u.root=d.slice(0,t));let o=-1,s=t,r=-1,l=!0,p=d.length-1,S=0;for(;p>=t;--p){if(i=d.charCodeAt(p),c(i)){if(!l){s=p+1;break}continue}r===-1&&(l=!1,r=p+1),i===A?o===-1?o=p:S!==1&&(S=1):o!==-1&&(S=-1)}return r!==-1&&(o===-1||S===0||S===1&&o===r-1&&o===s+1?u.base=u.name=d.slice(s,r):(u.name=d.slice(s,o),u.base=d.slice(s,r),u.ext=d.slice(o,r))),s>0&&s!==t?u.dir=d.slice(0,s-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",a=!1;for(let t=d.length-1;t>=-1&&!a;t--){const i=t>=0?d[t]:_.cwd();h(i,"path"),i.length!==0&&(u=`${i}/${u}`,a=i.charCodeAt(0)===C)}return u=g(u,!a,"/",m),a?`/${u}`:u.length>0?u:"."},normalize(d){if(h(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===C,a=d.charCodeAt(d.length-1)===C;return d=g(d,!u,"/",m),d.length===0?u?"/":a?"./":".":(a&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return h(d,"path"),d.length>0&&d.charCodeAt(0)===C},join(...d){if(d.length===0)return".";let u;for(let a=0;a<d.length;++a){const t=d[a];h(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(h(d,"from"),h(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const a=1,t=d.length,i=t-a,o=1,s=u.length-o,r=i<s?i:s;let l=-1,p=0;for(;p<r;p++){const f=d.charCodeAt(a+p);if(f!==u.charCodeAt(o+p))break;f===C&&(l=p)}if(p===r)if(s>r){if(u.charCodeAt(o+p)===C)return u.slice(o+p+1);if(p===0)return u.slice(o+p)}else i>r&&(d.charCodeAt(a+p)===C?l=p:p===0&&(l=0));let S="";for(p=a+l+1;p<=t;++p)(p===t||d.charCodeAt(p)===C)&&(S+=S.length===0?"..":"/..");return`${S}${u.slice(o+l)}`},toNamespacedPath(d){return d},dirname(d){if(h(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===C;let a=-1,t=!0;for(let i=d.length-1;i>=1;--i)if(d.charCodeAt(i)===C){if(!t){a=i;break}}else t=!1;return a===-1?u?"/":".":u&&a===1?"//":d.slice(0,a)},basename(d,u){u!==void 0&&h(u,"ext"),h(d,"path");let a=0,t=-1,i=!0,o;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let s=u.length-1,r=-1;for(o=d.length-1;o>=0;--o){const l=d.charCodeAt(o);if(l===C){if(!i){a=o+1;break}}else r===-1&&(i=!1,r=o+1),s>=0&&(l===u.charCodeAt(s)?--s==-1&&(t=o):(s=-1,t=r))}return a===t?t=r:t===-1&&(t=d.length),d.slice(a,t)}for(o=d.length-1;o>=0;--o)if(d.charCodeAt(o)===C){if(!i){a=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":d.slice(a,t)},extname(d){h(d,"path");let u=-1,a=0,t=-1,i=!0,o=0;for(let s=d.length-1;s>=0;--s){const r=d.charCodeAt(s);if(r===C){if(!i){a=s+1;break}continue}t===-1&&(i=!1,t=s+1),r===A?u===-1?u=s:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===a+1?"":d.slice(u,t)},format:w.bind(null,"/"),parse(d){h(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const a=d.charCodeAt(0)===C;let t;a?(u.root="/",t=1):t=0;let i=-1,o=0,s=-1,r=!0,l=d.length-1,p=0;for(;l>=t;--l){const S=d.charCodeAt(l);if(S===C){if(!r){o=l+1;break}continue}s===-1&&(r=!1,s=l+1),S===A?i===-1?i=l:p!==1&&(p=1):i!==-1&&(p=-1)}if(s!==-1){const S=o===0&&a?1:o;i===-1||p===0||p===1&&i===s-1&&i===o+1?u.base=u.name=d.slice(S,s):(u.name=d.slice(S,i),u.base=d.slice(S,s),u.ext=d.slice(i,s))}return o>0?u.dir=d.slice(0,o-1):a&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[133],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var y;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(y=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...D){const A=D.reduce((T,k)=>(T[k]=!0,T),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(T=>!A[T]).forEach(T=>{for(let k=0;k<C.length;k++)if(T.search(C[k])!==-1){delete P[T];break}})}e.sanitizeProcessEnvironment=R}),define(ge[46],pe([0,1,9]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const y=_.globals.performance&&typeof _.globals.performance.now=="function";class R{constructor(D){this._highResolution=y&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new R(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ge[3],pe([0,1,16,69,6,56,46]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var A;(function(g){g.None=()=>R.Disposable.None;function w(z){return(B,$=null,M)=>{let U=!1,F;return F=z(N=>{if(!U)return F?F.dispose():U=!0,B.call($,N)},null,M),U&&F.dispose(),F}}g.once=w;function d(z,B){return s(($,M=null,U)=>z(F=>$.call(M,B(F)),null,U))}g.map=d;function u(z,B){return s(($,M=null,U)=>z(F=>{B(F),$.call(M,F)},null,U))}g.forEach=u;function a(z,B){return s(($,M=null,U)=>z(F=>B(F)&&$.call(M,F),null,U))}g.filter=a;function t(z){return z}g.signal=t;function i(...z){return(B,$=null,M)=>(0,R.combinedDisposable)(...z.map(U=>U(F=>B.call($,F),null,M)))}g.any=i;function o(z,B,$){let M=$;return d(z,U=>(M=B(M,U),M))}g.reduce=o;function s(z){let B;const $=new b({onFirstListenerAdd(){B=z($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}g.snapshot=s;function r(z,B,$=100,M=!1,U){let F,N,O,V=0;const q=new b({leakWarningThreshold:U,onFirstListenerAdd(){F=z(Q=>{V++,N=B(N,Q),M&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const fe=N;N=void 0,O=void 0,(!M||V>1)&&q.fire(fe),V=0},$)})},onLastListenerRemove(){F.dispose()}});return q.event}g.debounce=r;function l(z){const B=new Date().getTime();return d(w(z),$=>new Date().getTime()-B)}g.stopwatch=l;function p(z){let B=!0,$;return a(z,M=>{const U=B||M!==$;return B=!1,$=M,U})}g.latch=p;function S(z,B=!1,$=[]){let M=$.slice(),U=z(O=>{M?M.push(O):N.fire(O)});const F=()=>{M&&M.forEach(O=>N.fire(O)),M=null},N=new b({onFirstListenerAdd(){U||(U=z(O=>N.fire(O)))},onFirstListenerDidAdd(){M&&(B?setTimeout(F):F())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}g.buffer=S;class f{constructor(B){this.event=B}map(B){return new f(d(this.event,B))}forEach(B){return new f(u(this.event,B))}filter(B){return new f(a(this.event,B))}reduce(B,$){return new f(o(this.event,B,$))}latch(){return new f(p(this.event))}debounce(B,$=100,M=!1,U){return new f(r(this.event,B,$,M,U))}on(B,$,M){return this.event(B,$,M)}once(B,$,M){return w(this.event)(B,$,M)}}function v(z){return new f(z)}g.chain=v;function I(z,B,$=M=>M){const M=(...O)=>N.fire($(...O)),U=()=>z.on(B,M),F=()=>z.removeListener(B,M),N=new b({onFirstListenerAdd:U,onLastListenerRemove:F});return N.event}g.fromNodeEventEmitter=I;function L(z,B,$=M=>M){const M=(...O)=>N.fire($(...O)),U=()=>z.addEventListener(B,M),F=()=>z.removeEventListener(B,M),N=new b({onFirstListenerAdd:U,onLastListenerRemove:F});return N.event}g.fromDOMEventEmitter=L;function x(z){const B=new b;let $=!1;return z.then(void 0,()=>null).then(()=>{$?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),$=!0,B.event}g.fromPromise=x;function Z(z){return new Promise(B=>w(z)(B))}g.toPromise=Z})(A=e.Event||(e.Event={}));class C{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${C._idPool++}`}start(w){this._stopWatch=new D.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let n=-1;function T(g){const w=n;return n=g,{dispose(){n=w}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(w,d=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let d=n;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||w<d)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(u)||0;if(this._stacks.set(u,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,i=0;for(const[o,s]of this._stacks)(!t||i<s)&&(t=o,i=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class b{constructor(w){var d;this._disposed=!1,this._options=w,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(w,d,u)=>{var a;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(d?[w,d]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,d);const o=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let s;return s={dispose:()=>{o&&o(),s.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof R.DisposableStore?u.add(s):Array.isArray(u)&&u.push(s),s}),this._event}fire(w){var d,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,w]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(i){(0,_.onUnexpectedError)(i)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var w,d,u;(w=this._listeners)===null||w===void 0||w.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class h extends b{constructor(w){super(w);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=h;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const d={event:w,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const u=()=>{this.hasListeners&&this.unhook(d);const a=this.events.indexOf(d);this.events.splice(a,1)};return(0,R.toDisposable)((0,y.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(d=>this.emitter.fire(d))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class m{constructor(){this.buffers=[]}wrapEvent(w){return(d,u,a)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>d.call(u,t)):d.call(u,t)},void 0,a)}bufferEvents(w){const d=[];this.buffers.push(d);const u=w();return this.buffers.pop(),d.forEach(a=>a()),u}}e.EventBufferer=m;class E{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=R.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const y=Object.freeze(function(A,C){const n=setTimeout(A.bind(C),0);return{dispose(){clearTimeout(n)}}});var R;(function(A){function C(n){return n===A.None||n===A.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}A.isCancellationToken=C,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(R=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?y:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=R.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=D}),define(ge[47],pe([0,1,3]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class y{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new y;e.iconRegistry=R;function P(n,T){return new D(n,T)}e.registerCodicon=P;class D{constructor(T,k,b){this.id=T,this.definition=k,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function A(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=A;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(c){if(c instanceof D)return["codicon","codicon-"+c.id];const m=T.exec(c.id);if(!m)return k(D.error);let[,E,g]=m;const w=["codicon","codicon-"+E];return g&&w.push("codicon-modifier-"+g.substr(1)),w}n.asClassNameArray=k;function b(c){return k(c).join(" ")}n.asClassName=b;function h(c){return"."+k(c).join(".")}n.asCSSSelector=h})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,16,6]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(E){const g=E;return g&&[g.on,g.pause,g.resume,g.destroy].every(w=>typeof w=="function")}e.isReadableStream=R;function P(E){const g=E;return g&&R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=P;function D(E,g){return new A(E,g)}e.newWriteableStream=D;class A{constructor(g,w){this.reducer=g,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(w=>w(g))}emitError(g){this.listeners.error.length===0?(0,_.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(w=>w(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,w){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(g,w){if(!this.state.destroyed){let d;switch(g){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const u=d.indexOf(w);u>=0&&d.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(E,g){const w=[];let d;for(;(d=E.read())!==null;)w.push(d);return g(w)}e.consumeReadable=C;function n(E,g,w){const d=[];let u;for(;(u=E.read())!==null&&d.length<w;)d.push(u);return u===null&&d.length>0?g(d):{read:()=>{if(d.length>0)return d.shift();if(typeof u!="undefined"){const a=u;return u=void 0,a}return E.read()}}}e.peekReadable=n;function T(E,g){return new Promise((w,d)=>{const u=[];k(E,{onData:a=>{g&&u.push(a)},onError:a=>{g?d(a):w(void 0)},onEnd:()=>{w(g?g(u):void 0)}})})}e.consumeStream=T;function k(E,g){E.on("error",w=>g.onError(w)),E.on("end",()=>g.onEnd()),E.on("data",w=>g.onData(w))}e.listenStream=k;function b(E,g){return new Promise((w,d)=>{const u=new y.DisposableStore,a=[],t=s=>{if(a.push(s),a.length>g)return u.dispose(),E.pause(),w({stream:E,buffer:a,ended:!1})},i=s=>d(s),o=()=>w({stream:E,buffer:a,ended:!0});u.add((0,y.toDisposable)(()=>E.removeListener("error",i))),E.on("error",i),u.add((0,y.toDisposable)(()=>E.removeListener("end",o))),E.on("end",o),u.add((0,y.toDisposable)(()=>E.removeListener("data",t))),E.on("data",t)})}e.peekStream=b;function h(E,g){const w=D(g);return w.end(E),w}e.toStream=h;function c(E){let g=!1;return{read:()=>g?null:(g=!0,E)}}e.toReadable=c;function m(E,g,w){const d=D(w);return k(E,{onData:u=>d.write(g.data(u)),onError:u=>d.error(g.error?g.error(u):u),onEnd:()=>d.end()}),d}e.transform=m}),define(ge[10],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const y=/{(\d+)}/g;function R(K,...oe){return oe.length===0?K:K.replace(y,function(ue,J){const ne=parseInt(J,10);return isNaN(ne)||ne<0||ne>=oe.length?ue:oe[ne]})}e.format=R;function P(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function A(K,oe){let ue=0;const J=oe.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===J&&ue++;return ue}e.count=A;function C(K,oe,ue="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${ue}`}e.truncate=C;function n(K,oe=" "){const ue=T(K,oe);return k(ue,oe)}e.trim=n;function T(K,oe){if(!K||!oe)return K;const ue=oe.length;if(ue===0||K.length===0)return K;let J=0;for(;K.indexOf(oe,J)===J;)J=J+ue;return K.substring(J)}e.ltrim=T;function k(K,oe){if(!K||!oe)return K;const ue=oe.length,J=K.length;if(ue===0||J===0)return K;let ne=J,le=-1;for(;le=K.lastIndexOf(oe,ne-1),!(le===-1||le+ue!==ne);){if(le===0)return"";ne=le}return K.substring(0,ne)}e.rtrim=k;function b(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function h(K){return K.replace(/\*/g,"")}e.stripWildcards=h;function c(K,oe,ue={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=D(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let J="";return ue.global&&(J+="g"),ue.matchCase||(J+="i"),ue.multiline&&(J+="m"),ue.unicode&&(J+="u"),new RegExp(K,J)}e.createRegExp=c;function m(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function g(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=g;function w(K){return K.split(/\r\n|\r|\n/)}e.splitLines=w;function d(K){for(let oe=0,ue=K.length;oe<ue;oe++){const J=K.charCodeAt(oe);if(J!==32&&J!==9)return oe}return-1}e.firstNonWhitespaceIndex=d;function u(K,oe=0,ue=K.length){for(let J=oe;J<ue;J++){const ne=K.charCodeAt(J);if(ne!==32&&ne!==9)return K.substring(oe,J)}return K.substring(oe,ue)}e.getLeadingWhitespace=u;function a(K,oe=K.length-1){for(let ue=oe;ue>=0;ue--){const J=K.charCodeAt(ue);if(J!==32&&J!==9)return ue}return-1}e.lastNonWhitespaceIndex=a;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function i(K,oe,ue=0,J=K.length,ne=0,le=oe.length){for(;ue<J&&ne<le;ue++,ne++){let He=K.charCodeAt(ue),$e=oe.charCodeAt(ne);if(He<$e)return-1;if(He>$e)return 1}const me=J-ue,Ee=le-ne;return me<Ee?-1:me>Ee?1:0}e.compareSubstring=i;function o(K,oe){return s(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=o;function s(K,oe,ue=0,J=K.length,ne=0,le=oe.length){for(;ue<J&&ne<le;ue++,ne++){let He=K.charCodeAt(ue),$e=oe.charCodeAt(ne);if(He!==$e){const qe=He-$e;if(!(qe===32&&l($e))&&!(qe===-32&&l(He)))return r(He)&&r($e)?qe:i(K.toLowerCase(),oe.toLowerCase(),ue,J,ne,le)}}const me=J-ue,Ee=le-ne;return me<Ee?-1:me>Ee?1:0}e.compareSubstringIgnoreCase=s;function r(K){return K>=97&&K<=122}e.isLowerAsciiLetter=r;function l(K){return K>=65&&K<=90}e.isUpperAsciiLetter=l;function p(K){return r(K)||l(K)}function S(K,oe){return K.length===oe.length&&f(K,oe)}e.equalsIgnoreCase=S;function f(K,oe,ue=K.length){for(let J=0;J<ue;J++){const ne=K.charCodeAt(J),le=oe.charCodeAt(J);if(ne!==le){if(p(ne)&&p(le)){const me=Math.abs(ne-le);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function v(K,oe){const ue=oe.length;return oe.length>K.length?!1:f(K,oe,ue)}e.startsWithIgnoreCase=v;function I(K,oe){let ue,J=Math.min(K.length,oe.length);for(ue=0;ue<J;ue++)if(K.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return J}e.commonPrefixLength=I;function L(K,oe){let ue,J=Math.min(K.length,oe.length);const ne=K.length-1,le=oe.length-1;for(ue=0;ue<J;ue++)if(K.charCodeAt(ne-ue)!==oe.charCodeAt(le-ue))return ue;return J}e.commonSuffixLength=L;function x(K){return 55296<=K&&K<=56319}e.isHighSurrogate=x;function Z(K){return 56320<=K&&K<=57343}e.isLowSurrogate=Z;function z(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=z;function B(K,oe,ue){const J=K.charCodeAt(ue);if(x(J)&&ue+1<oe){const ne=K.charCodeAt(ue+1);if(Z(ne))return z(J,ne)}return J}e.getNextCodePoint=B;function $(K,oe){const ue=K.charCodeAt(oe-1);if(Z(ue)&&oe>1){const J=K.charCodeAt(oe-2);if(x(J))return z(J,ue)}return ue}function M(K,oe){const ue=We.getInstance(),J=oe,ne=K.length,le=B(K,ne,oe);oe+=le>=65536?2:1;let me=ue.getGraphemeBreakType(le);for(;oe<ne;){const Ee=B(K,ne,oe),He=ue.getGraphemeBreakType(Ee);if(Ne(me,He))break;oe+=Ee>=65536?2:1,me=He}return oe-J}e.nextCharLength=M;function U(K,oe){const ue=We.getInstance(),J=oe,ne=$(K,oe);oe-=ne>=65536?2:1;let le=ue.getGraphemeBreakType(ne);for(;oe>0;){const me=$(K,oe),Ee=ue.getGraphemeBreakType(me);if(Ne(Ee,le))break;oe-=me>=65536?2:1,le=Ee}return J-oe}e.prevCharLength=U;function F(K,oe){const ue=We.getInstance(),J=K.length,ne=oe,le=B(K,J,oe),me=ue.getGraphemeBreakType(le);oe+=le>=65536?2:1;let Ee=me;for(;oe<J;){const $e=B(K,J,oe),qe=ue.getGraphemeBreakType($e);if(Ne(Ee,qe))break;oe+=$e>=65536?2:1,Ee=qe}const He=oe;for(oe=ne,Ee=me;oe>0;){const $e=$(K,oe),qe=ue.getGraphemeBreakType($e);if(Ne(qe,Ee))break;oe-=$e>=65536?2:1,Ee=qe}return[oe,He]}function N(K,oe){return oe>0&&Z(K.charCodeAt(oe))?F(K,oe-1):F(K,oe)}e.getCharContainingOffset=N;function O(K){const oe=K.length;let ue=0,J=0;for(;J<oe;){const me=B(K,oe,J);J+=me>=65536?2:1,me<128?ue+=1:me<2048?ue+=2:me<65536?ue+=3:ue+=4}const ne=new Uint8Array(ue);J=0;let le=0;for(;J<oe;){const me=B(K,oe,J);J+=me>=65536?2:1,me<128?ne[le++]=me:me<2048?(ne[le++]=192|(me&1984)>>>6,ne[le++]=128|(me&63)>>>0):me<65536?(ne[le++]=224|(me&61440)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0):(ne[le++]=240|(me&1835008)>>>18,ne[le++]=128|(me&258048)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0)}return ne}e.encodeUTF8=O;function V(K){const oe=K.byteLength,ue=[];let J=0;for(;J<oe;){const ne=K[J];let le;if(ne>=240&&J+3<oe?le=(K[J++]&7)<<18>>>0|(K[J++]&63)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=224&&J+2<oe?le=(K[J++]&15)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=192&&J+1<oe?le=(K[J++]&31)<<6>>>0|(K[J++]&63)<<0>>>0:le=K[J++],le>=0&&le<=55295||le>=57344&&le<=65535)ue.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const me=le-65536,Ee=55296+((me&1047552)>>>10),He=56320+((me&1023)>>>0);ue.push(String.fromCharCode(Ee)),ue.push(String.fromCharCode(He))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function _e(K){return fe.test(K)}e.containsEmoji=_e;const Le=/^[\t\n\r\x20-\x7E]*$/;function Ie(K){return Le.test(K)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Fe;function j(K){for(let oe=0,ue=K.length;oe<ue;oe++)if(X(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=j;function X(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=X;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function ae(K,oe){if(K.length<oe)return K;const ue=/\b/g;let J=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<oe);)J=ue.lastIndex,ue.lastIndex+=1;return K.substring(J).replace(/^\s/,"")}e.lcut=ae;const ve=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(ve,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Te;function xe(K,oe){if(!K||!oe||K.length<oe.length)return!1;const ue=oe.length,J=K.toLowerCase();let ne=0,le=-1;for(;ne<ue;){const me=J.indexOf(oe[ne],le+1);if(me<0)return!1;le=me,ne++}return!0}e.fuzzyContains=xe;function ye(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=ye;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function G(K,oe=1){if(oe===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=G;function ie(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=ie;function Se(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Se;function Ne(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Ye()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,J=ue.length/3;let ne=1;for(;ne<=J;)if(oe<ue[3*ne])ne=2*ne;else if(oe>ue[3*ne+1])ne=2*ne+1;else return ue[3*ne+2];return 0}}We._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[25],pe([0,1,10,91]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let A,C;class n{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return R?new n(Buffer.allocUnsafe(r)):new n(new Uint8Array(r))}static wrap(r){return R&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new n(r)}static fromString(r,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&R?new n(Buffer.from(r)):P?(A||(A=new TextEncoder),new n(A.encode(r))):new n(_.encodeUTF8(r))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let f=0,v=r.length;f<v;f++)l+=r[f].byteLength}const p=n.alloc(l);let S=0;for(let f=0,v=r.length;f<v;f++){const I=r[f];p.set(I,S),S+=I.byteLength}return p}toString(){return R?this.buffer.toString():D?(C||(C=new TextDecoder),C.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(r,l){return new n(this.buffer.subarray(r,l))}set(r,l){r instanceof n?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return b(this.buffer,r)}writeUInt32BE(r,l){h(this.buffer,r,l)}readUInt32LE(r){return c(this.buffer,r)}writeUInt32LE(r,l){m(this.buffer,r,l)}readUInt8(r){return E(this.buffer,r)}writeUInt8(r,l){g(this.buffer,r,l)}}e.VSBuffer=n;function T(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=T;function k(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255}e.writeUInt16LE=k;function b(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=b;function h(s,r,l){s[l+3]=r,r=r>>>8,s[l+2]=r,r=r>>>8,s[l+1]=r,r=r>>>8,s[l]=r}e.writeUInt32BE=h;function c(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=c;function m(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255,r=r>>>8,s[l+2]=r&255,r=r>>>8,s[l+3]=r&255}e.writeUInt32LE=m;function E(s,r){return s[r]}e.readUInt8=E;function g(s,r,l){s[l]=r}e.writeUInt8=g;function w(s){return y.consumeReadable(s,r=>n.concat(r))}e.readableToBuffer=w;function d(s){return y.toReadable(s)}e.bufferToReadable=d;function u(s){return y.consumeStream(s,r=>n.concat(r))}e.streamToBuffer=u;async function a(s){return s.ended?n.concat(s.buffer):n.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=a;function t(s){return y.toStream(s,r=>n.concat(r))}e.bufferToStream=t;function i(s){return y.transform(s,{data:r=>typeof r=="string"?n.fromString(r):n.wrap(r)},r=>n.concat(r))}e.streamToBufferReadableStream=i;function o(s){return y.newWriteableStream(r=>n.concat(r),s)}e.newWriteableBufferStream=o}),define(ge[73],pe([0,1,10]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function y(g){return R(g,0)}e.hash=y;function R(g,w){switch(typeof g){case"object":return g===null?P(349,w):Array.isArray(g)?C(g,w):n(g,w);case"string":return A(g,w);case"boolean":return D(g,w);case"number":return P(g,w);case"undefined":return P(937,w);default:return P(617,w)}}e.doHash=R;function P(g,w){return(w<<5)-w+g|0}function D(g,w){return P(g?433:863,w)}function A(g,w){w=P(149417,w);for(let d=0,u=g.length;d<u;d++)w=P(g.charCodeAt(d),w);return w}e.stringHash=A;function C(g,w){return w=P(104579,w),g.reduce((d,u)=>R(u,d),w)}function n(g,w){return w=P(181387,w),Object.keys(g).sort().reduce((d,u)=>(d=A(u,d),R(g[u],d)),w)}class T{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=R(w,this._value),this._value}}e.Hasher=T;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(g,w,d=32){const u=d-w,a=~((1<<u)-1);return(g<<w|(a&g)>>>u)>>>0}function h(g,w=0,d=g.byteLength,u=0){for(let a=0;a<d;a++)g[w+a]=u}function c(g,w,d="0"){for(;g.length<w;)g=d+g;return g}function m(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(d=>d.toString(16).padStart(2,"0")).join(""):c((g>>>0).toString(16),w/4)}e.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const d=w.length;if(d!==0){const u=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=w.charCodeAt(0),o=0);;){let s=i;if(_.isHighSurrogate(i))if(o+1<d){const r=w.charCodeAt(o+1);_.isLowSurrogate(r)?(o++,s=_.computeCodePoint(i,r)):s=65533}else{t=i;break}else _.isLowSurrogate(i)&&(s=65533);if(a=this._push(u,a,s),o++,o<d)i=w.charCodeAt(o);else break}this._buffLen=a,this._leftoverHighSurrogate=t}}_push(w,d,u){return u<128?w[d++]=u:u<2048?(w[d++]=192|(u&1984)>>>6,w[d++]=128|(u&63)>>>0):u<65536?(w[d++]=224|(u&61440)>>>12,w[d++]=128|(u&4032)>>>6,w[d++]=128|(u&63)>>>0):(w[d++]=240|(u&1835008)>>>18,w[d++]=128|(u&258048)>>>12,w[d++]=128|(u&4032)>>>6,w[d++]=128|(u&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=E._bigBlock32,d=this._buffDV;for(let p=0;p<64;p+=4)w.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)w.setUint32(p,b(w.getUint32(p-12,!1)^w.getUint32(p-32,!1)^w.getUint32(p-56,!1)^w.getUint32(p-64,!1),1),!1);let u=this._h0,a=this._h1,t=this._h2,i=this._h3,o=this._h4,s,r,l;for(let p=0;p<80;p++)p<20?(s=a&t|~a&i,r=1518500249):p<40?(s=a^t^i,r=1859775393):p<60?(s=a&t|a&i|t&i,r=2400959708):(s=a^t^i,r=3395469782),l=b(u,5)+s+o+r+w.getUint32(p*4,!1)&4294967295,o=i,i=t,t=b(a,30),a=u,u=l;this._h0=this._h0+u&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,10]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(y||(y={})),function(R){const P="error",D="warning",A="warn",C="info";function n(T){return T?_.equalsIgnoreCase(P,T)?R.Error:_.equalsIgnoreCase(D,T)||_.equalsIgnoreCase(A,T)?R.Warning:_.equalsIgnoreCase(C,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=n}(y||(y={})),e.default=y}),define(ge[15],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(r){return Array.isArray(r)}e.isArray=_;function y(r){return typeof r=="string"}e.isString=y;function R(r){return Array.isArray(r)&&r.every(l=>y(l))}e.isStringArray=R;function P(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=P;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function A(r){return r===!0||r===!1}e.isBoolean=A;function C(r){return typeof r=="undefined"}e.isUndefined=C;function n(r){return!T(r)}e.isDefined=n;function T(r){return C(r)||r===null}e.isUndefinedOrNull=T;function k(r,l){if(!r)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=k;function b(r){if(T(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=b;function h(...r){const l=[];for(let p=0;p<r.length;p++){const S=r[p];if(T(S))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);l.push(S)}return l}e.assertAllDefined=h;const c=Object.prototype.hasOwnProperty;function m(r){if(!P(r))return!1;for(let l in r)if(c.call(r,l))return!1;return!0}e.isEmptyObject=m;function E(r){return typeof r=="function"}e.isFunction=E;function g(...r){return r.length>0&&r.every(E)}e.areFunctions=g;function w(r,l){const p=Math.min(r.length,l.length);for(let S=0;S<p;S++)d(r[S],l[S])}e.validateConstraints=w;function d(r,l){if(y(l)){if(typeof r!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(E(l)){try{if(r instanceof l)return}catch(p){}if(!T(r)&&r.constructor===l||l.length===1&&l.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function u(r){let l=[],p=Object.getPrototypeOf(r);for(;Object.prototype!==p;)l=l.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return l}e.getAllPropertyNames=u;function a(r){const l=[];for(const p of u(r))typeof r[p]=="function"&&l.push(p);return l}e.getAllMethodNames=a;function t(r,l){const p=f=>function(){const v=Array.prototype.slice.call(arguments,0);return l(f,v)};let S={};for(const f of r)S[f]=p(f);return S}e.createProxyObject=t;function i(r){return r===null?void 0:r}e.withNullAsUndefined=i;function o(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=o;function s(r){return class{constructor(){return new Proxy({},{get(l,p){if(l[p])return l[p];throw new Error(`Not Implemented: ${r}->${String(p)}`)}})}}}e.NotImplementedProxy=s}),define(ge[31],pe([0,1,9,10,7,15]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function A(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=A;function C(i,o=R.posix.sep){if(!i)return"";const s=i.length,r=i.charCodeAt(0);if(D(r)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let p=3;const S=p;for(;p<s&&!D(i.charCodeAt(p));p++);if(S!==p&&!D(i.charCodeAt(p+1))){for(p+=1;p<s;p++)if(D(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,o)}}return o}else if(E(r)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<s;l++)if(D(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=C;function n(i){if(!_.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let s=2;const r=s;for(;s<i.length&&(o=i.charCodeAt(s),o!==92);s++);return!(r===s||(o=i.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=_.isWindows){const s=o?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(s.lastIndex=0,s.test(i))||o&&b.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function c(i,o,s){const r=i===o;return!s||r?r:!i||!o?!1:(0,y.equalsIgnoreCase)(i,o)}e.isEqual=c;function m(i,o,s,r=R.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(s){if(!(0,y.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let p=o.length;return o.charAt(o.length-1)===r&&p--,i.charAt(p)===r}return o.charAt(o.length-1)!==r&&(o+=r),i.indexOf(o)===0}e.isEqualOrParent=m;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function g(i,o){return _.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(o,i)),i=(0,R.normalize)(i),_.isWindows?(i=(0,y.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,y.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=g;function w(i){const o=(0,R.normalize)(i);return _.isWindows?i.length>3?!1:d(o)&&(i.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=w;function d(i){return _.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function u(i){return d(i)?i[0]:void 0}e.getDriveLetter=u;function a(i,o,s){return o.length>i.length?-1:i===o?0:(s&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=a;function t(i){const o=i.split(":");let s,r,l;if(o.forEach(p=>{const S=Number(p);(0,P.isNumber)(S)?r===void 0?r=S:l===void 0&&(l=S):s=s?[s,p].join(":"):p}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:r!==void 0?r:void 0,column:l!==void 0?l:r!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[22],pe([0,1,15]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function y(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const m=Array.isArray(c)?[]:{};return Object.keys(c).forEach(E=>{c[E]&&typeof c[E]=="object"?m[E]=y(c[E]):m[E]=c[E]}),m}e.deepClone=y;function R(c){if(!c||typeof c!="object")return c;const m=[c];for(;m.length>0;){const E=m.shift();Object.freeze(E);for(const g in E)if(P.call(E,g)){const w=E[g];typeof w=="object"&&!Object.isFrozen(w)&&m.push(w)}}return c}e.deepFreeze=R;const P=Object.prototype.hasOwnProperty;function D(c,m){return A(c,m,new Set)}e.cloneAndChange=D;function A(c,m,E){if((0,_.isUndefinedOrNull)(c))return c;const g=m(c);if(typeof g!="undefined")return g;if((0,_.isArray)(c)){const w=[];for(const d of c)w.push(A(d,m,E));return w}if((0,_.isObject)(c)){if(E.has(c))throw new Error("Cannot clone recursive data-structure");E.add(c);const w={};for(let d in c)P.call(c,d)&&(w[d]=A(c[d],m,E));return E.delete(c),w}return c}function C(c,m,E=!0){return(0,_.isObject)(c)?((0,_.isObject)(m)&&Object.keys(m).forEach(g=>{g in c?E&&((0,_.isObject)(c[g])&&(0,_.isObject)(m[g])?C(c[g],m[g],E):c[g]=m[g]):c[g]=m[g]}),c):m}e.mixin=C;function n(c,m){if(c===m)return!0;if(c==null||m===null||m===void 0||typeof c!=typeof m||typeof c!="object"||Array.isArray(c)!==Array.isArray(m))return!1;let E,g;if(Array.isArray(c)){if(c.length!==m.length)return!1;for(E=0;E<c.length;E++)if(!n(c[E],m[E]))return!1}else{const w=[];for(g in c)w.push(g);w.sort();const d=[];for(g in m)d.push(g);if(d.sort(),!n(w,d))return!1;for(E=0;E<w.length;E++)if(!n(c[w[E]],m[w[E]]))return!1}return!0}e.equals=n;function T(c){const m=new Set;return JSON.stringify(c,(E,g)=>{if((0,_.isObject)(g)||Array.isArray(g)){if(m.has(g))return"[Circular]";m.add(g)}return g})}e.safeStringify=T;function k(c,m,E){const g=m(c);return typeof g=="undefined"?E:g}e.getOrDefault=k;function b(c,m){const E=Object.create(null);return!c||!m||Object.keys(m).forEach(w=>{const d=c[w],u=m[w];n(d,u)||(E[w]=u)}),E}e.distinct=b;function h(c,m){const E=m.toLowerCase(),g=Object.keys(c).find(w=>w.toLowerCase()===E);return g?c[g]:c[m]}e.getCaseInsensitive=h}),define(ge[92],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function y(P){return P<0?0:P>255?255:P|0}e.toUint8=y;function R(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=R}),define(ge[2],pe([0,1,9,7]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,P=/^\//,D=/^\/\//;function A(o,s){if(!o.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!R.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(o,s){return!o&&!s?"file":o}function n(o,s){switch(o){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const T="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(s,r,l,p,S,f=!1){typeof s=="object"?(this.scheme=s.scheme||T,this.authority=s.authority||T,this.path=s.path||T,this.query=s.query||T,this.fragment=s.fragment||T):(this.scheme=C(s,f),this.authority=r||T,this.path=n(this.scheme,l||T),this.query=p||T,this.fragment=S||T,A(this,f))}static isUri(s){return s instanceof h?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:r,authority:l,path:p,query:S,fragment:f}=s;return r===void 0?r=this.scheme:r===null&&(r=T),l===void 0?l=this.authority:l===null&&(l=T),p===void 0?p=this.path:p===null&&(p=T),S===void 0?S=this.query:S===null&&(S=T),f===void 0?f=this.fragment:f===null&&(f=T),r===this.scheme&&l===this.authority&&p===this.path&&S===this.query&&f===this.fragment?this:new m(r,l,p,S,f)}static parse(s,r=!1){const l=b.exec(s);return l?new m(l[2]||T,i(l[4]||T),i(l[5]||T),i(l[7]||T),i(l[9]||T),r):new m(T,T,T,T,T)}static file(s){let r=T;if(_.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const l=s.indexOf(k,2);l===-1?(r=s.substring(2),s=k):(r=s.substring(2,l),s=s.substring(l)||k)}return new m("file",r,s,T,T)}static from(s){return new m(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...r){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return _.isWindows&&s.scheme==="file"?l=h.file(y.win32.join(d(s,!0),...r)).path:l=y.posix.join(s.path,...r),s.with({path:l})}toString(s=!1){return u(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof h)return s;{const r=new m(s);return r._formatted=s.external,r._fsPath=s._sep===c?s.fsPath:null,r}}else return s}}e.URI=h;const c=_.isWindows?1:void 0;class m extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(o,s){let r,l=-1;for(let p=0;p<o.length;p++){const S=o.charCodeAt(p);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||s&&S===47)l!==-1&&(r+=encodeURIComponent(o.substring(l,p)),l=-1),r!==void 0&&(r+=o.charAt(p));else{r===void 0&&(r=o.substr(0,p));const f=E[S];f!==void 0?(l!==-1&&(r+=encodeURIComponent(o.substring(l,p)),l=-1),r+=f):l===-1&&(l=p)}}return l!==-1&&(r+=encodeURIComponent(o.substring(l))),r!==void 0?r:o}function w(o){let s;for(let r=0;r<o.length;r++){const l=o.charCodeAt(r);l===35||l===63?(s===void 0&&(s=o.substr(0,r)),s+=E[l]):s!==void 0&&(s+=o[r])}return s!==void 0?s:o}function d(o,s){let r;return o.authority&&o.path.length>1&&o.scheme==="file"?r=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?s?r=o.path.substr(1):r=o.path[1].toLowerCase()+o.path.substr(2):r=o.path,_.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=d;function u(o,s){const r=s?w:g;let l="",{scheme:p,authority:S,path:f,query:v,fragment:I}=o;if(p&&(l+=p,l+=":"),(S||p==="file")&&(l+=k,l+=k),S){let L=S.indexOf("@");if(L!==-1){const x=S.substr(0,L);S=S.substr(L+1),L=x.indexOf(":"),L===-1?l+=r(x,!1):(l+=r(x.substr(0,L),!1),l+=":",l+=r(x.substr(L+1),!1)),l+="@"}S=S.toLowerCase(),L=S.indexOf(":"),L===-1?l+=r(S,!1):(l+=r(S.substr(0,L),!1),l+=S.substr(L))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const L=f.charCodeAt(1);L>=65&&L<=90&&(f=`/${String.fromCharCode(L+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const L=f.charCodeAt(0);L>=65&&L<=90&&(f=`${String.fromCharCode(L+32)}:${f.substr(2)}`)}l+=r(f,!0)}return v&&(l+="?",l+=r(v,!1)),I&&(l+="#",l+=s?I:g(I,!1)),l}function a(o){try{return decodeURIComponent(o)}catch(s){return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,s=>a(s)):o}}),define(ge[23],pe([0,1,2,10]),function(Y,e,_,y){"use strict";var R,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(u,a,t){let i=u.get(a);return i===void 0&&(i=t,u.set(a,i)),i}e.getOrSet=D;function A(u){const a=[];return u.forEach((t,i)=>{a.push(`${i} => ${t}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.mapToString=A;function C(u){const a=[];return u.forEach(t=>{a.push(t)}),`Set(${u.size}) {${a.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const t=a.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,y.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(a=!0,t=!0){this._splitOnBackslash=a,this._caseSensitive=t}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,y.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var b;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(b||(b={}));class h{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,y.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(a){this._iter=a}static forUris(a=()=>!1){return new m(new h(a))}static forPaths(){return new m(new k)}static forStrings(){return new m(new n)}static forConfigKeys(){return new m(new T)}clear(){this._root=void 0}set(a,t){const i=this._iter.reset(a);let o;for(this._root||(this._root=new c,this._root.segment=i.value()),o=this._root;;){const r=i.cmp(o.segment);if(r>0)o.left||(o.left=new c,o.left.segment=i.value()),o=o.left;else if(r<0)o.right||(o.right=new c,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new c,o.mid.segment=i.value()),o=o.mid;else break}const s=o.value;return o.value=t,o.key=a,s}get(a){var t;return(t=this._getNode(a))===null||t===void 0?void 0:t.value}_getNode(a){const t=this._iter.reset(a);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(a){const t=this._getNode(a);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,t){const i=this._iter.reset(a),o=[];let s=this._root;for(;s;){const r=i.cmp(s.segment);if(r>0)o.push([1,s]),s=s.left;else if(r<0)o.push([-1,s]),s=s.right;else if(i.hasNext())i.next(),o.push([0,s]),s=s.mid;else{for(t?(s.left=void 0,s.mid=void 0,s.right=void 0):s.value=void 0;o.length>0&&s.isEmpty();){let[l,p]=o.pop();switch(l){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}s=p}break}}}findSubstr(a){const t=this._iter.reset(a);let i=this._root,o;for(;i;){const s=t.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(t.hasNext())t.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(a){const t=this._iter.reset(a);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(a){for(const[t,i]of this)a(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=m;class E{constructor(a,t){this[R]="ResourceMap",a instanceof E?(this.map=new Map(a.map),this.toKey=t!=null?t:E.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:E.defaultToKey)}set(a,t){return this.map.set(this.toKey(a),t),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t!="undefined"&&(a=a.bind(t));for(let[i,o]of this.map)a(o,_.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield _.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[_.URI.parse(a[0]),a[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[_.URI.parse(a[0]),a[1]]}}e.ResourceMap=E,E.defaultToKey=u=>u.toString();var g;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class w{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,t=0){const i=this._map.get(a);if(!!i)return t!==0&&this.touch(i,t),i.value}set(a,t,i=0){let o=this._map.get(a);if(o)o.value=t,i!==0&&this.touch(o,i);else{switch(o={key:a,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(a,o),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(!!t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,t){const i=this._state;let o=this._head;for(;o;){if(t?a.bind(t)(o.value,o.key,this):a(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const a=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:i.key,done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}values(){const a=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:i.value,done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}entries(){const a=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const s={value:[i.key,i.value],done:!1};return i=i.next,s}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>a;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,i=a.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(a===this._head)return;const i=a.next,o=a.previous;a===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===2){if(a===this._tail)return;const i=a.next,o=a.previous;a===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,i)=>{a.push([i,t])}),a}fromJSON(a){this.clear();for(const[t,i]of a)this.set(t,i)}}e.LinkedMap=w;class d extends w{constructor(a,t=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=2){return super.get(a,t)}peek(a){return super.get(a,0)}set(a,t){return super.set(a,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(ge[93],pe([0,1,23,10]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...we){return function(ke,Te){for(let xe=0,ye=we.length;xe<ye;xe++){const Ke=we[xe](ke,Te);if(Ke)return Ke}return null}}e.or=R,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(we,ke,Te){if(!Te||Te.length<ke.length)return null;let xe;return we?xe=y.startsWithIgnoreCase(Te,ke):xe=Te.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(we,ke){const Te=ke.toLowerCase().indexOf(we.toLowerCase());return Te===-1?null:[{start:Te,end:Te+we.length}]}e.matchesContiguousSubString=D;function A(we,ke){return C(we.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=A;function C(we,ke,Te,xe){if(Te===we.length)return[];if(xe===ke.length)return null;if(we[Te]===ke[xe]){let ye=null;return(ye=C(we,ke,Te+1,xe+1))?g({start:xe,end:xe+1},ye):null}return C(we,ke,Te,xe+1)}function n(we){return 97<=we&&we<=122}function T(we){return 65<=we&&we<=90}e.isUpper=T;function k(we){return 48<=we&&we<=57}function b(we){return we===32||we===9||we===10||we===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>h.add(we.charCodeAt(0)));function c(we){return b(we)||h.has(we)}function m(we,ke){return we===ke||c(we)&&c(ke)}function E(we){return n(we)||T(we)||k(we)}function g(we,ke){return ke.length===0?ke=[we]:we.end===ke[0].start?ke[0].start=we.start:ke.unshift(we),ke}function w(we,ke){for(let Te=ke;Te<we.length;Te++){const xe=we.charCodeAt(Te);if(T(xe)||k(xe)||Te>0&&!E(we.charCodeAt(Te-1)))return Te}return we.length}function d(we,ke,Te,xe){if(Te===we.length)return[];if(xe===ke.length)return null;if(we[Te]!==ke[xe].toLowerCase())return null;{let ye=null,Ke=xe+1;for(ye=d(we,ke,Te+1,xe+1);!ye&&(Ke=w(ke,Ke))<ke.length;)ye=d(we,ke,Te+1,Ke),Ke++;return ye===null?null:g({start:xe,end:xe+1},ye)}}function u(we){let ke=0,Te=0,xe=0,ye=0,Ke=0;for(let ze=0;ze<we.length;ze++)Ke=we.charCodeAt(ze),T(Ke)&&ke++,n(Ke)&&Te++,E(Ke)&&xe++,k(Ke)&&ye++;const G=ke/we.length,ie=Te/we.length,Se=xe/we.length,Ne=ye/we.length;return{upperPercent:G,lowerPercent:ie,alphaPercent:Se,numericPercent:Ne}}function a(we){const{upperPercent:ke,lowerPercent:Te}=we;return Te===0&&ke>.6}function t(we){const{upperPercent:ke,lowerPercent:Te,alphaPercent:xe,numericPercent:ye}=we;return Te>.2&&ke<.8&&xe>.6&&ye<.2}function i(we){let ke=0,Te=0,xe=0,ye=0;for(let Ke=0;Ke<we.length;Ke++)xe=we.charCodeAt(Ke),T(xe)&&ke++,n(xe)&&Te++,b(xe)&&ye++;return(ke===0||Te===0)&&ye===0?we.length<=30:ke<=5}function o(we,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(we)||ke.length>60)return null;const Te=u(ke);if(!t(Te)){if(!a(Te))return null;ke=ke.toLowerCase()}let xe=null,ye=0;for(we=we.toLowerCase();ye<ke.length&&(xe=d(we,ke,0,ye))===null;)ye=w(ke,ye+1);return xe}e.matchesCamelCase=o;function s(we,ke,Te=!1){if(!ke||ke.length===0)return null;let xe=null,ye=0;for(we=we.toLowerCase(),ke=ke.toLowerCase();ye<ke.length&&(xe=r(we,ke,0,ye,Te))===null;)ye=l(ke,ye+1);return xe}e.matchesWords=s;function r(we,ke,Te,xe,ye){if(Te===we.length)return[];if(xe===ke.length)return null;if(m(we.charCodeAt(Te),ke.charCodeAt(xe))){let Ke=null,G=xe+1;if(Ke=r(we,ke,Te+1,xe+1,ye),!ye)for(;!Ke&&(G=l(ke,G))<ke.length;)Ke=r(we,ke,Te+1,G,ye),G++;return Ke===null?null:g({start:xe,end:xe+1},Ke)}else return null}function l(we,ke){for(let Te=ke;Te<we.length;Te++)if(c(we.charCodeAt(Te))||Te>0&&c(we.charCodeAt(Te-1)))return Te;return we.length}const p=R(e.matchesPrefix,o,D),S=R(e.matchesPrefix,o,A),f=new _.LRUCache(1e4);function v(we,ke,Te=!1){if(typeof we!="string"||typeof ke!="string")return null;let xe=f.get(we);xe||(xe=new RegExp(y.convertSimple2RegExpPattern(we),"i"),f.set(we,xe));const ye=xe.exec(ke);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:Te?S(we,ke):p(we,ke)}e.matchesFuzzy=v;function I(we,ke){const Te=j(we,we.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?x(Te):null}e.matchesFuzzy2=I;function L(we,ke,Te,xe,ye,Ke){const G=Math.min(13,we.length);for(;Te<G;Te++){const ie=j(we,ke,Te,xe,ye,Ke,!1);if(ie)return ie}return[0,Ke]}e.anyScore=L;function x(we){if(typeof we=="undefined")return[];const ke=[],Te=we[1];for(let xe=we.length-1;xe>1;xe--){const ye=we[xe]+Te,Ke=ke[ke.length-1];Ke&&Ke.end===ye?Ke.end=ye+1:ke.push({start:ye,end:ye+1})}return ke}e.createMatches=x;const Z=128;function z(){const we=[],ke=[];for(let Te=0;Te<=Z;Te++)ke[Te]=0;for(let Te=0;Te<=Z;Te++)we.push(ke.slice(0));return we}function B(we){const ke=[];for(let Te=0;Te<=we;Te++)ke[Te]=0;return ke}const $=B(2*Z),M=B(2*Z),U=z(),F=z(),N=z(),O=!1;function V(we,ke,Te,xe,ye){function Ke(ie,Se,Ne=" "){for(;ie.length<Se;)ie=Ne+ie;return ie}let G=` |   |${xe.split("").map(ie=>Ke(ie,3)).join("|")}
`;for(let ie=0;ie<=Te;ie++)ie===0?G+=" |":G+=`${ke[ie-1]}|`,G+=we[ie].slice(0,ye+1).map(Se=>Ke(Se.toString(),3)).join("|")+`
`;return G}function q(we,ke,Te,xe){we=we.substr(ke),Te=Te.substr(xe),console.log(V(F,we,we.length,Te,Te.length)),console.log(V(N,we,we.length,Te,Te.length)),console.log(V(U,we,we.length,Te,Te.length))}function Q(we,ke){if(ke<0||ke>=we.length)return!1;const Te=we.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(Te)}}function fe(we,ke){if(ke<0||ke>=we.length)return!1;switch(we.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function _e(we,ke,Te){return ke[we]!==Te[we]}function Le(we,ke,Te,xe,ye,Ke,G=!1){for(;ke<Te&&ye<Ke;)we[ke]===xe[ye]&&(G&&($[ke]=ye),ke+=1),ye+=1;return ke===Te}e.isPatternInWord=Le;var Ie;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Fe;(function(we){we.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}we.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function j(we,ke,Te,xe,ye,Ke,G){const ie=we.length>Z?Z:we.length,Se=xe.length>Z?Z:xe.length;if(!(Te>=ie||Ke>=Se||ie-Te>Se-Ke)&&!!Le(ke,Te,ie,ye,Ke,Se,!0)){X(ie,Se,Te,Ke,ke,ye);let Ne=1,ze=1,We=Te,Ye=Ke;const K=[!1];for(Ne=1,We=Te;We<ie;Ne++,We++){const le=$[We],me=M[We],Ee=We+1<ie?M[We+1]:Se;for(ze=le-Ke+1,Ye=le;Ye<Ee;ze++,Ye++){let He=Number.MIN_SAFE_INTEGER,$e=!1;Ye<=me&&(He=te(we,ke,We,Te,xe,ye,Ye,Se,Ke,U[Ne-1][ze-1]===0,K));let qe=0;He!==Number.MAX_SAFE_INTEGER&&($e=!0,qe=He+F[Ne-1][ze-1]);const Qe=Ye>le,Ze=Qe?F[Ne][ze-1]+(U[Ne][ze-1]>0?-5:0):0,ut=Ye>le+1&&U[Ne][ze-1]>0,st=ut?F[Ne][ze-2]+(U[Ne][ze-2]>0?-5:0):0;if(ut&&(!Qe||st>=Ze)&&(!$e||st>=qe))F[Ne][ze]=st,N[Ne][ze]=3,U[Ne][ze]=0;else if(Qe&&(!$e||Ze>=qe))F[Ne][ze]=Ze,N[Ne][ze]=2,U[Ne][ze]=0;else if($e)F[Ne][ze]=qe,N[Ne][ze]=1,U[Ne][ze]=U[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(we,Te,xe,Ke),!(!K[0]&&!G)){Ne--,ze--;const oe=[F[Ne][ze],Ke];let ue=0,J=0;for(;Ne>=1;){let le=ze;do{const me=N[Ne][le];if(me===3)le=le-2;else if(me===2)le=le-1;else break}while(le>=1);ue>1&&ke[Te+Ne-1]===ye[Ke+ze-1]&&!_e(le+Ke-1,xe,ye)&&ue+1>U[Ne][le]&&(le=ze),le===ze?ue++:ue=1,J||(J=le),Ne--,ze=le-1,oe.push(ze)}Se===ie&&(oe[0]+=2);const ne=J-ie;return oe[0]-=ne,oe}}}e.fuzzyScore=j;function X(we,ke,Te,xe,ye,Ke){let G=we-1,ie=ke-1;for(;G>=Te&&ie>=xe;)ye[G]===Ke[ie]&&(M[G]=ie,G--),ie--}function te(we,ke,Te,xe,ye,Ke,G,ie,Se,Ne,ze){if(ke[Te]!==Ke[G])return Number.MIN_SAFE_INTEGER;let We=1,Ye=!1;return G===Te-xe?We=we[Te]===ye[G]?7:5:_e(G,ye,Ke)&&(G===0||!_e(G-1,ye,Ke))?(We=we[Te]===ye[G]?7:5,Ye=!0):Q(Ke,G)&&(G===0||!Q(Ke,G-1))?We=5:(Q(Ke,G-1)||fe(Ke,G-1))&&(We=5,Ye=!0),We>1&&Te===xe&&(ze[0]=!0),Ye||(Ye=_e(G,ye,Ke)||Q(Ke,G-1)||fe(Ke,G-1)),Te===xe?G>Se&&(We-=Ye?3:5):Ne?We+=Ye?2:0:We+=Ye?0:1,G+1===ie&&(We-=Ye?3:5),We}function ae(we,ke,Te,xe,ye,Ke,G){return De(we,ke,Te,xe,ye,Ke,!0,G)}e.fuzzyScoreGracefulAggressive=ae;function ve(we,ke,Te,xe,ye,Ke,G){return De(we,ke,Te,xe,ye,Ke,!1,G)}e.fuzzyScoreGraceful=ve;function De(we,ke,Te,xe,ye,Ke,G,ie){let Se=j(we,ke,Te,xe,ye,Ke,ie);if(Se&&!G)return Se;if(we.length>=3){const Ne=Math.min(7,we.length-1);for(let ze=Te+1;ze<Ne;ze++){const We=Oe(we,ze);if(We){const Ye=j(We,We.toLowerCase(),Te,xe,ye,Ke,ie);Ye&&(Ye[0]-=3,(!Se||Ye[0]>Se[0])&&(Se=Ye))}}}return Se}function Oe(we,ke){if(!(ke+1>=we.length)){const Te=we[ke],xe=we[ke+1];if(Te!==xe)return we.slice(0,ke)+xe+Te+we.slice(ke+2)}}}),define(ge[134],pe([0,1,47,93,10]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${P.source}`,"g");function A(m){return m.replace(D,(E,g)=>g?E:`\\${E}`)}e.escapeIcons=A;const C=new RegExp(`\\\\${P.source}`,"g");function n(m){return m.replace(C,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function k(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(T,(E,g,w,d)=>w?E:g||d||"")}e.stripIcons=k;function b(m){const E=m.indexOf(e.iconStartMarker);return E===-1?{text:m}:h(m,E)}e.parseLabelWithIcons=b;function h(m,E){const g=[];let w="";function d(l){if(l){w+=l;for(const p of l)g.push(t)}}let u=-1,a="",t=0,i,o,s=E;const r=m.length;for(d(m.substr(0,E));s<r;)i=m[s],o=m[s+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=s,d(a),a=e.iconStartMarker,s++):i===")"&&u!==-1?(t+=s-u+1,u=-1,a=""):u!==-1?/^[a-z0-9\-]$/i.test(i)?a+=i:(d(a),u=-1,a=""):d(i),s++;return d(a),{text:w,iconOffsets:g}}function c(m,E,g=!1){const{text:w,iconOffsets:d}=E;if(!d||d.length===0)return(0,y.matchesFuzzy)(m,w,g);const u=(0,R.ltrim)(w," "),a=w.length-u.length,t=(0,y.matchesFuzzy)(m,u,g);if(t)for(const i of t){const o=d[i.start+a]+a;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=c}),define(ge[94],pe([0,1,12,134,16]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(m="",E=!1){var g,w;if(this.value=m,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(g=E.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(w=E.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(m,E=0){return this.value+=k(this.supportThemeIcons?(0,y.escapeIcons)(m):m).replace(/([ \t]+)/g,(g,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,E){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=D;function A(c){return C(c)?!c.value:Array.isArray(c)?c.every(A):!0}e.isEmptyMarkdownString=A;function C(c){return c instanceof D?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function n(c,m){return!c&&!m?!0:!c||!m?!1:Array.isArray(c)&&Array.isArray(m)?(0,_.equals)(c,m,T):C(c)&&C(m)?T(c,m):!1}e.markedStringsEquals=n;function T(c,m){return c===m?!0:!c||!m?!1:c.value===m.value&&c.isTrusted===m.isTrusted&&c.supportThemeIcons===m.supportThemeIcons}function k(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function b(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function h(c){const m=[],E=c.split("|").map(w=>w.trim());c=E[0];const g=E[1];if(g){const w=/height=(\d+)/.exec(g),d=/width=(\d+)/.exec(g),u=w?w[1]:"",a=d?d[1]:"",t=isFinite(parseInt(a)),i=isFinite(parseInt(u));t&&m.push(`width="${a}"`),i&&m.push(`height="${u}"`)}return{href:c,dimensions:m}}e.parseHrefAndDimensions=h}),define(ge[58],pe([0,1,25,10,2]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,A)}e.stringify=P;function D(n){let T=JSON.parse(n);return T=C(T),T}e.parse=D;function A(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,y.regExpFlags)(T)}:T}function C(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=C(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=C(n[k],T+1))}return n}e.revive=C}),define(ge[11],pe([0,1,2,9]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.vscodeWebviewResource="vscode-webview-resource",A.extension="extension",A.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,n,T){this._hosts[C]=n,this._ports[C]=T}setConnectionToken(C,n){this._connectionTokens[C]=n}rewrite(C){if(this._delegate)return this._delegate(C);const n=C.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],b=this._connectionTokens[n];let h=`path=${encodeURIComponent(C.path)}`;return typeof b=="string"&&(h+=`&tkn=${encodeURIComponent(b)}`),_.URI.from({scheme:y.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new P;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(C,n,T){const k=this.toUri(C,n);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):y.isNative&&(T||y.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(C,n){const T=this.toUri(C,n);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(C,n){return _.URI.isUri(C)?C:_.URI.parse(n.toUrl(C))}}e.FileAccess=new D}),define(ge[74],pe([0,1,23]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const y=new _.LRUCache(1e4);function R(n){return C(n,"NFC",y)}e.normalizeNFC=R;const P=new _.LRUCache(1e4);function D(n){return C(n,"NFD",P)}e.normalizeNFD=D;const A=/[^\u0000-\u0080]/;function C(n,T,k){if(!e.canNormalize||!n)return n;const b=k.get(n);if(b)return b;let h;return A.test(n)?h=n.normalize(T):h=n,k.set(n,h),h}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(T){return D(T).replace(n,"")}}else return function(n){return n}}()}),define(ge[24],pe([0,1,31,7,2,10,11,9]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(h){return(0,R.uriToFsPath)(h,!0)}e.originalFSPath=C;class n{constructor(c){this._ignorePathCasing=c}compare(c,m,E=!1){return c===m?0:(0,P.compare)(this.getComparisonKey(c,E),this.getComparisonKey(m,E))}isEqual(c,m,E=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,E)===this.getComparisonKey(m,E)}getComparisonKey(c,m=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,m,E=!1){if(c.scheme===m.scheme){if(c.scheme===D.Schemas.file)return _.isEqualOrParent(C(c),C(m),this._ignorePathCasing(c))&&c.query===m.query&&(E||c.fragment===m.fragment);if((0,e.isEqualAuthority)(c.authority,m.authority))return _.isEqualOrParent(c.path,m.path,this._ignorePathCasing(c),"/")&&c.query===m.query&&(E||c.fragment===m.fragment)}return!1}joinPath(c,...m){return R.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return y.posix.basename(c.path)}extname(c){return y.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===D.Schemas.file?m=R.URI.file(y.dirname(C(c))).path:(m=y.posix.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===D.Schemas.file?m=R.URI.file(y.normalize(C(c))).path:m=y.posix.normalize(c.path),c.with({path:m})}relativePath(c,m){if(!(c.scheme!==m.scheme||!(0,e.isEqualAuthority)(c.authority,m.authority))){if(c.scheme===D.Schemas.file){const w=y.relative(C(c),C(m));return A.isWindows?_.toSlashes(w):w}let E=c.path||"/",g=m.path||"/";if(this._ignorePathCasing(c)){let w=0;for(const d=Math.min(E.length,g.length);w<d&&!(E.charCodeAt(w)!==g.charCodeAt(w)&&E.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);E=g.substr(0,w)+E.substr(w)}return y.posix.relative(E,g)}}resolvePath(c,m){if(c.scheme===D.Schemas.file){const E=R.URI.file(y.resolve(C(c),m));return c.with({authority:E.authority,path:E.path})}return m.indexOf("/")===-1&&(m=_.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),c.with({path:y.posix.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||(0,P.equalsIgnoreCase)(c,m)}hasTrailingPathSeparator(c,m=y.sep){if(c.scheme===D.Schemas.file){const E=C(c);return E.length>_.getRoot(E).length&&E[E.length-1]===m}else{const E=c.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=y.sep){return(0,e.hasTrailingPathSeparator)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=y.sep){let E=!1;if(c.scheme===D.Schemas.file){const g=C(c);E=g!==void 0&&g.length===_.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=c.path;E=g.length===1&&g.charCodeAt(g.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(c,m)?c.with({path:c.path+"/"}):c}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(h=>h.scheme===D.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new n(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(h,c){const m=[];for(let E=0;E<h.length;E++){const g=c(h[E]);h.some((w,d)=>d===E?!1:(0,e.isEqualOrParent)(g,c(w)))||m.push(h[E])}return m}e.distinctParents=T;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(m){const E=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,a]=d.split(":");u&&a&&E.set(u,a)});const w=m.path.substring(0,m.path.indexOf(";"));return w&&E.set(h.META_DATA_MIME,w),E}h.parseMetaData=c})(k=e.DataUri||(e.DataUri={}));function b(h,c,m){if(c){let E=h.path;return E&&E[0]!==y.posix.sep&&(E=y.posix.sep+E),h.with({scheme:m,authority:c,path:E})}return h.with({scheme:m})}e.toLocalResource=b}),define(ge[17],pe([0,1,21,16,3,6,56,24]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(F){return!!F&&typeof F.then=="function"}e.isThenable=C;function n(F){const N=new _.CancellationTokenSource,O=F(N.token),V=new Promise((q,Q)=>{N.token.onCancellationRequested(()=>{Q((0,y.canceled)())}),Promise.resolve(O).then(fe=>{N.dispose(),q(fe)},fe=>{N.dispose(),Q(fe)})});return new class{cancel(){N.cancel()}then(q,Q){return V.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=n;function T(F,N,O){return Promise.race([F,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=T;async function k(F){let N=-1;const O=F.map((q,Q)=>q.then(fe=>(N=Q,fe))),V=await Promise.race(O);return F.forEach((q,Q)=>{Q!==N&&q.cancel()}),V}e.raceCancellablePromises=k;function b(F,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([F.finally(()=>clearTimeout(q)),new Promise(Q=>V=Q)])}e.raceTimeout=b;function h(F){return new Promise((N,O)=>{const V=F();C(V)?V.then(N,O):N(V)})}e.asPromise=h;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=c;class m{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=m;class E{constructor(){this.promiseMap=new Map}queue(N,O){var V;const Q=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===Q&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Q),Q}}e.SequencerByKey=E;class g{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,y.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class w{constructor(N){this.delayer=new g(N),this.throttler=new c}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class d{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class u extends d{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function a(F,N){return N?new Promise((O,V)=>{const q=setTimeout(O,F);N.onCancellationRequested(()=>{clearTimeout(q),V((0,y.canceled)())})}):n(O=>a(F,O))}e.timeout=a;function t(F,N=0){const O=setTimeout(F,N);return(0,P.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(F){return F.then(void 0,N=>{})}e.ignoreErrors=i;function o(F){const N=[];let O=0;const V=F.length;function q(){return O<V?F[O++]():null}function Q(fe){fe!=null&&N.push(fe);const _e=q();return _e?_e.then(Q):Promise.resolve(N)}return Promise.resolve(null).then(Q)}e.sequence=o;function s(F,N=V=>!!V,O=null){let V=0;const q=F.length,Q=()=>{if(V>=q)return Promise.resolve(O);const fe=F[V++];return Promise.resolve(fe()).then(Le=>N(Le)?Promise.resolve(Le):Q())};return Q()}e.first=s;function r(F,N=V=>!!V,O=null){if(F.length===0)return Promise.resolve(O);let V=F.length;const q=()=>{var Q,fe;V=-1;for(const _e of F)(fe=(Q=_e).cancel)===null||fe===void 0||fe.call(Q)};return new Promise((Q,fe)=>{for(const _e of F)_e.then(Le=>{--V>=0&&N(Le)?(q(),Q(Le)):V===0&&Q(O)}).catch(Le=>{--V>=0&&(q(),fe(Le))})})}e.firstParallel=r;class l{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class p extends l{constructor(){super(1)}}e.Queue=p;class S{constructor(){this.queues=new Map}queueFor(N,O=A.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new p,R.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=S;class f{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=f;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=v;class I{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class L extends I{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(F));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(F,N)=>{const O=requestIdleCallback(F,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class x{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function Z(F,N,O){let V;for(let q=0;q<O;q++)try{return await F()}catch(Q){V=Q,await a(N)}throw V}e.retry=Z;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((Q,fe)=>{O=Q,V=fe});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=z;class B{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,y.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class M extends R.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),fe=[],_e=Object.assign(Object.assign({},Q),{waitUntil:Le=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");V&&(Le=V(Le,typeof q=="function"?q:q[0])),fe.push(Le)}});try{typeof q=="function"?q.call(void 0,_e):q[0].call(q[1],_e)}catch(Le){(0,y.onUnexpectedError)(Le);continue}Object.freeze(fe),await U.settled(fe).catch(Le=>(0,y.onUnexpectedError)(Le))}}}}e.AsyncEmitter=M;var U;(function(F){async function N(Q){return typeof Promise.allSettled=="function"?O(Q):V(Q)}F.allSettled=N;async function O(Q){return Promise.allSettled(Q)}async function V(Q){return Promise.all(Q.map(fe=>fe.then(_e=>({status:"fulfilled",value:_e}),_e=>({status:"rejected",reason:_e}))))}async function q(Q){let fe;const _e=await Promise.all(Q.map(Le=>Le.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe!="undefined")throw fe;return _e}F.settled=q})(U=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,7,17]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new y.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),P=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,a,t=!1){const i=u||"",o=a||"",s=R.value.collator.compare(i,o);return R.value.collatorIsNumeric&&s===0&&i!==o?i<o?-1:1:s}e.compareFileNames=A;function C(u,a){const t=P.value.collator;return u=u||"",a=a||"",m(t,u,a)}e.compareFileNamesDefault=C;function n(u,a,t=!1){t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase());const[i,o]=h(u),[s,r]=h(a);return i!==s?i<s?-1:1:o===r?0:o<r?-1:1}e.noIntlCompareFileNames=n;function T(u,a){const[t,i]=h(u),[o,s]=h(a);let r=R.value.collator.compare(i,s);if(r===0){if(R.value.collatorIsNumeric&&i!==s)return i<s?-1:1;if(r=R.value.collator.compare(t,o),R.value.collatorIsNumeric&&r===0&&t!==o)return t<o?-1:1}return r}e.compareFileExtensions=T;function k(u,a){u=u||"",a=a||"";const t=c(u),i=c(a),o=P.value.collator,s=D.value.collator;let r;return r=m(s,t,i),r!==0?r:m(o,u,a)}e.compareFileExtensionsDefault=k;const b=/^(.*?)(\.([^.]*))?$/;function h(u,a=!1){const t=u?b.exec(u):[];let i=[t&&t[1]||"",t&&t[3]||""];return a&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function c(u){const a=u?b.exec(u):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function m(u,a,t){let i=u.compare(a,t);return i!==0?i:a.length!==t.length?a.length<t.length?-1:1:0}function E(u,a,t=!1){return t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase()),u===a?0:u<a?-1:1}function g(u,a,t=!1){const i=u.split(_.sep),o=a.split(_.sep),s=i.length-1,r=o.length-1;let l,p;for(let S=0;;S++){if(l=s===S,p=r===S,l&&p)return A(i[S],o[S],t);if(l)return-1;if(p)return 1;const f=E(i[S],o[S],t);if(f!==0)return f}}e.comparePaths=g;function w(u,a,t){const i=u.toLowerCase(),o=a.toLowerCase(),s=d(u,a,t);if(s)return s;const r=i.endsWith(t),l=o.endsWith(t);if(r!==l)return r?-1:1;const p=A(i,o);return p!==0?p:i.localeCompare(o)}e.compareAnything=w;function d(u,a,t){const i=u.toLowerCase(),o=a.toLowerCase(),s=i.startsWith(t),r=o.startsWith(t);if(s!==r)return s?-1:1;if(s&&r){if(i.length<o.length)return-1;if(i.length>o.length)return 1}return 0}e.compareByPrefix=d}),define(ge[96],pe([0,1,95,93,7,9,10]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const A=0,C=[A,[]];function n(B,$,M,U){if(!B||!$)return C;const F=B.length,N=$.length;if(F<N)return C;const O=B.toLowerCase();return!U&&!O.includes(M)?C:T($,M,N,B,O,F)}e.scoreFuzzy=n;function T(B,$,M,U,F,N){const O=[],V=[];for(let _e=0;_e<M;_e++){const Le=_e*N,Ie=Le-N,Fe=_e>0,j=B[_e],X=$[_e];for(let te=0;te<N;te++){const ae=te>0,ve=Le+te,De=ve-1,Oe=Ie+te-1,we=ae?O[De]:0,ke=Fe&&ae?O[Oe]:0,Te=Fe&&ae?V[Oe]:0;let xe;!ke&&Fe?xe=0:xe=k(j,X,U,F,te,Te),xe&&ke+xe>=we?(V[ve]=Te+1,O[ve]=ke+xe):(V[ve]=A,O[ve]=we)}}const q=[];let Q=M-1,fe=N-1;for(;Q>=0&&fe>=0;){const _e=Q*N+fe;V[_e]===A||(q.push(fe),Q--),fe--}return[O[M*N-1],q.reverse()]}function k(B,$,M,U,F,N){let O=0;if(!b($,U[F]))return O;if(O+=1,N>0&&(O+=N*5),B===M[F]&&(O+=1),F===0)O+=8;else{const V=h(M.charCodeAt(F-1));V?O+=V:(0,y.isUpper)(M.charCodeAt(F))&&(O+=2)}return O}function b(B,$){return B===$?!0:B==="/"||B==="\\"?$==="/"||$==="\\":!1}function h(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(B,$,M=0,U=0){const F=$;return F.values&&F.values.length>1?E(B,F.values,M,U):g(B,$,M,U)}e.scoreFuzzy2=m;function E(B,$,M,U){let F=0;const N=[];for(const O of $){const[V,q]=g(B,O,M,U);if(typeof V!="number")return c;F+=V,N.push(...q)}return[F,l(N)]}function g(B,$,M,U){const F=(0,y.fuzzyScore)($.original,$.originalLowercase,M,B,B.toLowerCase(),U,!0);return F?[F[0],(0,y.createMatches)(F)]:c}const w=Object.freeze({score:0}),d=1<<18,u=1<<17,a=1<<16;function t(B,$,M,U,F){if(!B||!$.normalized)return w;const N=U.getItemLabel(B);if(!N)return w;const O=U.getItemDescription(B);let V;O?V=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${M}`:V=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${M}`;const q=F[V];if(q)return q;const Q=i(N,O,U.getItemPath(B),$,M);return F[V]=Q,Q}e.scoreItemFuzzy=t;function i(B,$,M,U,F){const N=!M||!U.containsPathSeparator;return M&&(P.isLinux?U.pathNormalized===M:(0,D.equalsIgnoreCase)(U.pathNormalized,M))?{score:d,labelMatch:[{start:0,end:B.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:U.values&&U.values.length>1?o(B,$,M,U.values,N,F):s(B,$,M,U,N,F)}function o(B,$,M,U,F,N){let O=0;const V=[],q=[];for(const Q of U){const{score:fe,labelMatch:_e,descriptionMatch:Le}=s(B,$,M,Q,F,N);if(fe===A)return w;O+=fe,_e&&V.push(..._e),Le&&q.push(...Le)}return{score:O,labelMatch:l(V),descriptionMatch:l(q)}}function s(B,$,M,U,F,N){if(F||!$){const[O,V]=n(B,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,y.matchesPrefix)(U.normalized,B);let Q;return q?(Q=u,Q+=Math.round(U.normalized.length/B.length*100)):Q=a,{score:Q+O,labelMatch:q||r(V)}}}if($){let O=$;M&&(O=`${$}${R.sep}`);const V=O.length,q=`${O}${B}`,[Q,fe]=n(q,U.normalized,U.normalizedLowercase,N);if(Q){const _e=r(fe),Le=[],Ie=[];return _e.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Le.push({start:0,end:Fe.end-V}),Ie.push({start:Fe.start,end:V})):Fe.start>=V?Le.push({start:Fe.start-V,end:Fe.end-V}):Ie.push(Fe)}),{score:Q,labelMatch:Le,descriptionMatch:Ie}}}return w}function r(B){const $=[];if(!B)return $;let M;for(const U of B)M&&M.end===U?M.end+=1:(M={start:U,end:U+1},$.push(M));return $}function l(B){const $=B.sort((F,N)=>F.start-N.start),M=[];let U;for(const F of $)!U||!p(U,F)?(U=F,M.push(F)):(U.start=Math.min(U.start,F.start),U.end=Math.max(U.end,F.end));return M}function p(B,$){return!(B.end<$.start||$.end<B.start)}function S(B,$,M,U,F,N){const O=t(B,M,U,F,N),V=t($,M,U,F,N),q=O.score,Q=V.score;if((q===d||Q===d)&&q!==Q)return q===d?-1:1;if(q>a||Q>a){if(q!==Q)return q>Q?-1:1;if(q<u&&Q<u){const X=v(O.labelMatch,V.labelMatch);if(X!==0)return X}const Fe=F.getItemLabel(B)||"",j=F.getItemLabel($)||"";if(Fe.length!==j.length)return Fe.length-j.length}if(q!==Q)return q>Q?-1:1;const fe=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,_e=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(fe&&!_e)return-1;if(_e&&!fe)return 1;const Le=f(B,O,F),Ie=f($,V,F);return Le&&Ie&&Le!==Ie?Ie>Le?-1:1:I(B,$,M,F)}e.compareItemsByFuzzyScore=S;function f(B,$,M){let U=-1,F=-1;if($.descriptionMatch&&$.descriptionMatch.length?U=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(U=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(F=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=M.getItemDescription(B);N&&(F+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(F=$.descriptionMatch[$.descriptionMatch.length-1].end);return F-U}function v(B,$){if(!B&&!$||(!B||!B.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!B||!B.length)return 1;const M=B[0].start,F=B[B.length-1].end-M,N=$[0].start,V=$[$.length-1].end-N;return F===V?0:V<F?1:-1}function I(B,$,M,U){const F=U.getItemLabel(B)||"",N=U.getItemLabel($)||"",O=U.getItemDescription(B),V=U.getItemDescription($),q=F.length+(O?O.length:0),Q=N.length+(V?V.length:0);if(q!==Q)return q-Q;const fe=U.getItemPath(B),_e=U.getItemPath($);return fe&&_e&&fe.length!==_e.length?fe.length-_e.length:F!==N?(0,_.compareAnything)(F,N,M.normalized):O&&V&&O!==V?(0,_.compareAnything)(O,V,M.normalized):fe&&_e&&fe!==_e?(0,_.compareAnything)(fe,_e,M.normalized):0}const L=" ";function x(B){typeof B!="string"&&(B="");const $=B.toLowerCase(),{pathNormalized:M,normalized:U,normalizedLowercase:F}=Z(B),N=M.indexOf(R.sep)>=0;let O;const V=B.split(L);if(V.length>1)for(const q of V){const{pathNormalized:Q,normalized:fe,normalizedLowercase:_e}=Z(q);fe&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:fe,normalizedLowercase:_e}))}return{original:B,originalLowercase:$,pathNormalized:M,normalized:U,normalizedLowercase:F,values:O,containsPathSeparator:N}}e.prepareQuery=x;function Z(B){let $;P.isWindows?$=B.replace(/\//g,R.sep):$=B.replace(/\\/g,R.sep);const M=(0,D.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:M,normalizedLowercase:M.toLowerCase()}}function z(B){return Array.isArray(B)?x(B.map($=>$.original).join(L)):x(B.original)}e.pieceToQuery=z}),define(ge[34],pe([0,1,10,31,7,23,17]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const C="**",n="/",T="[/\\\\]",k="[^/\\\\]",b=/\//g;function h(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function c(O,V){if(!O)return[];const q=[];let Q=!1,fe=!1,_e="";for(const Le of O){switch(Le){case V:if(!Q&&!fe){q.push(_e),_e="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}_e+=Le}return _e&&q.push(_e),q}e.splitGlobAware=c;function m(O){if(!O)return"";let V="";const q=c(O,n);if(q.every(Q=>Q===C))V=".*";else{let Q=!1;q.forEach((fe,_e)=>{if(fe===C){Q||(V+=h(2),Q=!0);return}let Le=!1,Ie="",Fe=!1,j="";for(const X of fe){if(X!=="}"&&Le){Ie+=X;continue}if(Fe&&(X!=="]"||!j)){let te;X==="-"?te=X:(X==="^"||X==="!")&&!j?te="^":X===n?te="":te=_.escapeRegExpCharacters(X),j+=te;continue}switch(X){case"{":Le=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${c(Ie,",").map(ve=>m(ve)).join("|")})`,Le=!1,Ie="";break;case"]":V+="["+j+"]",Fe=!1,j="";break;case"?":V+=k;continue;case"*":V+=h(1);continue;default:V+=_.escapeRegExpCharacters(X)}}_e<q.length-1&&(q[_e+1]!==C||_e+2<q.length)&&(V+=T),Q=!1})}return V}const E=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},o=function(){return null};function s(O,V){if(!O)return o;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!V.trimForExclusions}`;let fe=t.get(Q);if(fe)return r(fe,O);let _e;if(E.test(q)){const Le=q.substr(4);fe=function(Ie,Fe){return typeof Ie=="string"&&Ie.endsWith(Le)?q:null}}else(_e=g.exec(l(q,V)))?fe=p(_e[1],q):(V.trimForExclusions?d:w).test(q)?fe=S(q,V):(_e=u.exec(l(q,V)))?fe=f(_e[1].substr(1),q,!0):(_e=a.exec(l(q,V)))?fe=f(_e[1],q,!1):fe=v(q);return t.set(Q,fe),r(fe,O)}function r(O,V){return typeof V=="string"?O:function(q,Q){return y.isEqualOrParent(q,V.base)?O(R.relative(V.base,q),Q):null}}function l(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,V){const q=`/${O}`,Q=`\\${O}`,fe=function(Le,Ie){return typeof Le!="string"?null:Ie?Ie===O?V:null:Le===O||Le.endsWith(q)||Le.endsWith(Q)?V:null},_e=[O];return fe.basenames=_e,fe.patterns=[V],fe.allBasenames=_e,fe}function S(O,V){const q=N(O.slice(1,-1).split(",").map(Ie=>s(Ie,V)).filter(Ie=>Ie!==o),O),Q=q.length;if(!Q)return o;if(Q===1)return q[0];const fe=function(Ie,Fe){for(let j=0,X=q.length;j<X;j++)if(q[j](Ie,Fe))return O;return null},_e=q.find(Ie=>!!Ie.allBasenames);_e&&(fe.allBasenames=_e.allBasenames);const Le=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Le.length&&(fe.allPaths=Le),fe}function f(O,V,q){const Q=R.sep===R.posix.sep,fe=Q?O:O.replace(b,R.sep),_e=R.sep+fe,Le=R.posix.sep+O,Ie=q?function(Fe,j){return typeof Fe=="string"&&(Fe===fe||Fe.endsWith(_e)||!Q&&(Fe===O||Fe.endsWith(Le)))?V:null}:function(Fe,j){return typeof Fe=="string"&&(Fe===fe||!Q&&Fe===O)?V:null};return Ie.allPaths=[(q?"*/":"./")+O],Ie}function v(O){try{const V=new RegExp(`^${m(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return o}}function I(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=I;function L(O,V={}){if(!O)return i;if(typeof O=="string"||B(O)){const q=s(O,V);if(q===o)return i;const Q=function(fe,_e){return!!q(fe,_e)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return U(O,V)}e.parse=L;function x(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(Q=>Q?z(Q):{})),V.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=x;function Z(O){if(!!O){let V;return q=>{if(!V){const Q=O();V=Q?z(Q):{}}return!!V[q]}}}e.hasSiblingFn=Z;function z(O){const V={};for(const q of O)V[q]=!0;return V}function B(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=B;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function M(O){return O.allPaths||[]}e.getPathTerms=M;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Ie=>F(Ie,O[Ie],V)).filter(Ie=>Ie!==o)),Q=q.length;if(!Q)return o;if(!q.some(Ie=>!!Ie.requiresSiblings)){if(Q===1)return q[0];const Ie=function(X,te){for(let ae=0,ve=q.length;ae<ve;ae++){const De=q[ae](X,te);if(De)return De}return null},Fe=q.find(X=>!!X.allBasenames);Fe&&(Ie.allBasenames=Fe.allBasenames);const j=q.reduce((X,te)=>te.allPaths?X.concat(te.allPaths):X,[]);return j.length&&(Ie.allPaths=j),Ie}const fe=function(Ie,Fe,j){let X;for(let te=0,ae=q.length;te<ae;te++){const ve=q[te];ve.requiresSiblings&&j&&(Fe||(Fe=R.basename(Ie)),X||(X=Fe.substr(0,Fe.length-R.extname(Ie).length)));const De=ve(Ie,Fe,X,j);if(De)return De}return null},_e=q.find(Ie=>!!Ie.allBasenames);_e&&(fe.allBasenames=_e.allBasenames);const Le=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Le.length&&(fe.allPaths=Le),fe}function F(O,V,q){if(V===!1)return o;const Q=s(O,q);if(Q===o)return o;if(typeof V=="boolean")return Q;if(V){const fe=V.when;if(typeof fe=="string"){const _e=(Le,Ie,Fe,j)=>{if(!j||!Q(Le,Ie))return null;const X=fe.replace("$(basename)",Fe),te=j(X);return(0,D.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return _e.requiresSiblings=!0,_e}}return Q}function N(O,V){const q=O.filter(Ie=>!!Ie.basenames);if(q.length<2)return O;const Q=q.reduce((Ie,Fe)=>{const j=Fe.basenames;return j?Ie.concat(j):Ie},[]);let fe;if(V){fe=[];for(let Ie=0,Fe=Q.length;Ie<Fe;Ie++)fe.push(V)}else fe=q.reduce((Ie,Fe)=>{const j=Fe.patterns;return j?Ie.concat(j):Ie},[]);const _e=function(Ie,Fe){if(typeof Ie!="string")return null;if(!Fe){let X;for(X=Ie.length;X>0;X--){const te=Ie.charCodeAt(X-1);if(te===47||te===92)break}Fe=Ie.substr(X)}const j=Q.indexOf(Fe);return j!==-1?fe[j]:null};_e.basenames=Q,_e.patterns=fe,_e.allBasenames=Q;const Le=O.filter(Ie=>!Ie.basenames);return Le.push(_e),Le}}),define(ge[75],pe([0,1,2,7,10,11,9,24,31]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(s,r,l){if(typeof s=="string"&&(s=_.URI.file(s)),l){const S=l.getWorkspaceFolder(s);if(S){const f=l.getWorkspace().folders.length>1;let v;if((0,A.isEqual)(S.uri,s)?v="":v=(0,A.relativePath)(S.uri,s),f){const I=S.name?S.name:(0,A.basename)(S.uri);v=v?I+" \u2022 "+v:I}return v}}if(s.scheme!==P.Schemas.file&&s.scheme!==P.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(s.fsPath))return(0,y.normalize)(k(s.fsPath));let p=(0,y.normalize)(s.fsPath);return!D.isWindows&&(r==null?void 0:r.userHome)&&(p=h(p,r.userHome.fsPath)),p}e.getPathLabel=n;function T(s){if(!!s){typeof s=="string"&&(s=_.URI.file(s));const r=(0,A.basename)(s)||(s.scheme===P.Schemas.file?s.fsPath:s.path);return D.isWindows&&(0,C.isRootOrDriveLetter)(r)?k(r):r}}e.getBaseLabel=T;function k(s){return(0,C.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=k;let b=Object.create(null);function h(s,r){if(D.isWindows||!s||!r)return s;let l=b.original===r?b.normalized:void 0;return l||(l=`${(0,R.rtrim)(r,y.posix.sep)}${y.posix.sep}`,b={original:r,normalized:l}),(D.isLinux?s.startsWith(l):(0,R.startsWithIgnoreCase)(s,l))&&(s=`~/${s.substr(l.length)}`),s}e.tildify=h;function c(s,r){return s.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=c;const m="\u2026",E="\\\\",g="~";function w(s,r=y.sep){const l=new Array(s.length);let p=!1;for(let S=0;S<s.length;S++){let f=s[S];if(f===""){l[S]=`.${r}`;continue}if(!f){l[S]=f;continue}p=!0;let v="";f.indexOf(E)===0?(v=f.substr(0,f.indexOf(E)+E.length),f=f.substr(f.indexOf(E)+E.length)):f.indexOf(r)===0?(v=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(g)===0&&(v=f.substr(0,f.indexOf(g)+g.length),f=f.substr(f.indexOf(g)+g.length));const I=f.split(r);for(let L=1;p&&L<=I.length;L++)for(let x=I.length-L;p&&x>=0;x--){p=!1;let Z=I.slice(x,x+L).join(r);for(let z=0;!p&&z<s.length;z++)if(z!==S&&s[z]&&s[z].indexOf(Z)>-1){const B=x+L===I.length,$=x>0&&s[z].indexOf(r)>-1?r+Z:Z,M=s[z].endsWith($);p=!B||M}if(!p){let z="";(I[0].endsWith(":")||v!=="")&&(x===1&&(x=0,L++,Z=I[0]+r+Z),x>0&&(z=I[0]+r),z=v+z),x>0&&(z=z+m+r),z=z+Z,x+L<I.length&&(z=z+r+m),l[S]=z}}p&&(l[S]=f)}return l}e.shorten=w;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(s,r=Object.create(null)){const l=[];let p=!1,S="";for(const f of s)if(f==="$"||p&&f==="{")S&&l.push({value:S,type:d.TEXT}),S="",p=!0;else if(f==="}"&&p){const v=r[S];if(typeof v=="string")v.length&&l.push({value:v,type:d.VARIABLE});else if(v){const I=l[l.length-1];(!I||I.type!==d.SEPARATOR)&&l.push({value:v.label,type:d.SEPARATOR})}S="",p=!1}else S+=f;return S&&!p&&l.push({value:S,type:d.TEXT}),l.filter((f,v)=>{if(f.type===d.SEPARATOR){const I=l[v-1],L=l[v+1];return[I,L].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=u;function a(s,r){return D.isMacintosh||r?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(s,r){return D.isMacintosh||r?s.replace(/\(&&\w\)|&&/g,""):D.isWindows?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(s){const r=s.indexOf("/")!==-1?y.posix:y.win32,l=r.basename(s),p=r.dirname(s);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}e.splitName=o}),define(ge[97],pe([0,1,2]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const b=this._uriTransformer.transformIncoming(k);return b===k?k:y(_.URI.from(b))}transformOutgoing(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:y(_.URI.from(b))}transformOutgoingURI(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:_.URI.from(b)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,k,b){if(!T||b>200)return null;if(typeof T=="object"){if(T instanceof _.URI)return k.transformOutgoing(T);for(let h in T)if(Object.hasOwnProperty.call(T,h)){const c=P(T[h],k,b+1);c!==null&&(T[h]=c)}}return null}function D(T,k){const b=P(T,k,0);return b===null?T:b}e.transformOutgoingURIs=D;function A(T,k,b,h){if(!T||h>200)return null;if(typeof T=="object"){if(T.$mid===1)return b?_.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let c in T)if(Object.hasOwnProperty.call(T,c)){const m=A(T[c],k,b,h+1);m!==null&&(T[c]=m)}}return null}function C(T,k){const b=A(T,k,!1,0);return b===null?T:b}e.transformIncomingURIs=C;function n(T,k){const b=A(T,k,!0,0);return b===null?T:b}e.transformAndReviveIncomingURIs=n}),define(ge[28],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(C){return _.test(C)}e.isUUID=y;const R=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(C){for(let n=0;n<C.length;n++)C[n]=Math.floor(Math.random()*256);return C};function A(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let C=0,n="";return n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n+="-",n+=P[R[C++]],n+=P[R[C++]],n+="-",n+=P[R[C++]],n+=P[R[C++]],n+="-",n+=P[R[C++]],n+=P[R[C++]],n+="-",n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n+=P[R[C++]],n}e.generateUuid=A}),define(ge[135],pe([0,1,98]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class y{constructor(P="utf8"){this.stringDecoder=new _.StringDecoder(P),this.remaining=null}write(P){const D=[],A=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(A.length<1)return D;let C=0,n,T=C;for(;T<A.length;)if(n=A.charCodeAt(T),n===13||n===10){if(D.push(A.substring(C,T)),T++,T<A.length){const k=n;n=A.charCodeAt(T),(k===13&&n===10||k===10&&n===13)&&T++}C=T}else T++;return this.remaining=C<A.length?A.substr(C):null,D}end(){return this.remaining}}e.LineDecoder=y}),define(ge[26],pe([0,1,37,48,7,17,9,31,28,74,24,2]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function h($,M=b.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return M===b.UNLINK?m($):c($)}e.rimraf=h;async function c($){try{const M=(0,R.join)((0,y.tmpdir)(),(0,C.generateUuid)());try{await _.promises.rename($,M)}catch(U){return m($)}m(M).catch(U=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function m($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function g($,M){return u(await(M?w($):_.promises.readdir($)))}e.readdir=g;async function w($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const M=[],U=await g($);for(const F of U){let N=!1,O=!1,V=!1;try{const q=await _.promises.lstat((0,R.join)($,F));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}M.push({name:F,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return M}function d($){return u(_.readdirSync($))}e.readdirSync=d;function u($){return $.map(M=>typeof M=="string"?D.isMacintosh?(0,n.normalizeNFC)(M):M:(M.name=D.isMacintosh?(0,n.normalizeNFC)(M.name):M.name,M))}async function a($){const M=await g($),U=[];for(const F of M)await i.existsDirectory((0,R.join)($,F))&&U.push(F);return U}e.readDirsInDir=a;function t($,M=1e3){return new Promise(U=>{let F=!1;const N=setInterval(()=>{F||(F=!0,_.access($,O=>{F=!1,O&&(clearInterval(N),U(void 0))}))},M)})}e.whenDeleted=t;var i;(function($){async function M(N){let O;try{if(O=await _.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await _.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=M;async function U(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=U;async function F(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=F})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function s($,M,U){return o.queueFor(k.URI.file($),T.extUriBiasedIgnorePathCase).queue(()=>{const F=S(U);return new Promise((N,O)=>l($,M,F,V=>V?O(V):N()))})}e.writeFile=s;let r=!0;function l($,M,U,F){if(!r)return _.writeFile($,M,{mode:U.mode,flag:U.flag},F);_.open($,U.flag,U.mode,(N,O)=>{if(N)return F(N);_.writeFile(O,M,V=>{if(V)return _.close(O,()=>F(V));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),r=!1),_.close(O,Q=>F(Q))))})})}function p($,M,U){const F=S(U);if(!r)return _.writeFileSync($,M,{mode:F.mode,flag:F.flag});const N=_.openSync($,F.flag,F.mode);try{_.writeFileSync(N,M);try{_.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),r=!1}}finally{_.closeSync(N)}}e.writeFileSync=p;function S($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,M){if($!==M){async function U(F){try{const N=await _.promises.lstat(F);if(N.isDirectory()||N.isSymbolicLink())return;const O=await _.promises.open(F,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await _.promises.rename($,M),await U(M)}catch(F){if($.toLowerCase()!==M.toLowerCase()&&F.code==="EXDEV"||$.endsWith("."))await v($,M,{preserveSymlinks:!1}),await h($,b.MOVE),await U(M);else throw F}}}e.move=f;async function v($,M,U){return L($,M,{root:{source:$,target:M},options:U,handledSourcePaths:new Set})}e.copy=v;const I=511;async function L($,M,U){if(!U.handledSourcePaths.has($)){U.handledSourcePaths.add($);const{stat:F,symbolicLink:N}=await i.stat($);if(N){if(U.options.preserveSymlinks)try{return await z($,M,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return F.isDirectory()?x($,M,F.mode&I,U):Z($,M,F.mode&I)}}async function x($,M,U,F){await _.promises.mkdir(M,{recursive:!0,mode:U});const N=await g($);for(const O of N)await L((0,R.join)($,O),(0,R.join)(M,O),F)}async function Z($,M,U){await _.promises.copyFile($,M),await _.promises.chmod(M,U)}async function z($,M,U){let F=await _.promises.readlink($);(0,A.isEqualOrParent)(F,U.root.source,!D.isLinux)&&(F=(0,R.join)(U.root.target,F.substr(U.root.source.length+1))),await _.promises.symlink(F,M)}async function B($){try{return await _.promises.access($),!0}catch(M){return!1}}e.exists=B}),define(ge[99],pe([0,1,37,280,10,7,26]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(k){const b=(0,P.dirname)(k);if(k===b)return k;const h=((0,P.basename)(k)||k).toLowerCase();try{const m=(0,D.readdirSync)(b).filter(E=>E.toLowerCase()===h);if(m.length===1){const E=A(b);if(E)return(0,P.join)(E,m[0])}else if(m.length>1){const E=m.indexOf(h);if(E>=0){const g=A(b);if(g)return(0,P.join)(g,m[E])}}}catch(c){}return null}e.realcaseSync=A;async function C(k){try{return await(0,y.promisify)(_.realpath)(k)}catch(b){const h=T(k);return await _.promises.access(h,_.constants.R_OK),h}}e.realpath=C;function n(k){try{return _.realpathSync(k)}catch(b){const h=T(k);return _.accessSync(h,_.constants.R_OK),h}}e.realpathSync=n;function T(k){return(0,R.rtrim)((0,P.normalize)(k),P.sep)}});var vt=this&&this.__await||function(Y){return this instanceof vt?(this.v=Y,this):new vt(Y)},In=this&&this.__asyncGenerator||function(Y,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var y=_.apply(Y,e||[]),R,P=[];return R={},D("next"),D("throw"),D("return"),R[Symbol.asyncIterator]=function(){return this},R;function D(b){y[b]&&(R[b]=function(h){return new Promise(function(c,m){P.push([b,h,c,m])>1||A(b,h)})})}function A(b,h){try{C(y[b](h))}catch(c){k(P[0][3],c)}}function C(b){b.value instanceof vt?Promise.resolve(b.value.v).then(n,T):k(P[0][2],b)}function n(b){A("next",b)}function T(b){A("throw",b)}function k(b,h){b(h),P.shift(),P.length&&A(P[0][0],P[0][1])}},en=this&&this.__asyncValues||function(Y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Y[Symbol.asyncIterator],_;return e?e.call(Y):(Y=typeof __values=="function"?__values(Y):Y[Symbol.iterator](),_={},y("next"),y("throw"),y("return"),_[Symbol.asyncIterator]=function(){return this},_);function y(P){_[P]=Y[P]&&function(D){return new Promise(function(A,C){D=Y[P](D),R(A,C,D.done,D.value)})}}function R(P,D,A,C){Promise.resolve(C).then(function(n){P({value:n,done:A})},D)}};define(ge[100],pe([0,1,26,48,7]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var C;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(C||(C={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class k{constructor(a,t,i){this.exePath=a,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:u=!1}={}){return u?n===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:u=!1,findPreview:a=!1}={}){const t=b({useAlternateBitness:u});if(!t)return null;const i=R.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const p of await _.readdir(i)){let S=-1;if(a){const v=p.indexOf("-");if(v<0)continue;const I=p.substring(0,v);if(!P.test(I)||p.substring(v+1)!=="preview")continue;S=parseInt(I,10)}else{if(!P.test(p))continue;S=parseInt(p,10)}if(!(S<=o)){const f=R.join(i,p,"pwsh.exe");!await _.SymlinkSupport.existsFile(f)||(s=f,o=S)}}if(!s)return null;const r=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new k(s,`PowerShell${l}${r}`,!0)}async function c({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=u?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await _.readdir(a))if(t.test(o)){const s=R.join(a,o,"pwsh.exe");return new k(s,i)}return null}function m(){const u=R.join(y.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function E(){const u=R.join(process.env.windir,n===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}function g(){return In(this,arguments,function*(){let a=yield vt(h());a&&(yield yield vt(a)),a=yield vt(h({useAlternateBitness:!0})),a&&(yield yield vt(a)),a=yield vt(c()),a&&(yield yield vt(a)),a=m(),a&&(yield yield vt(a)),a=yield vt(h({findPreview:!0})),a&&(yield yield vt(a)),a=yield vt(c({findPreview:!0})),a&&(yield yield vt(a)),a=yield vt(h({useAlternateBitness:!0,findPreview:!0})),a&&(yield yield vt(a)),a=E(),a&&(yield yield vt(a))})}function w(){return In(this,arguments,function*(){var a,t;try{for(var i=en(g()),o;o=yield vt(i.next()),!o.done;){const s=o.value;(yield vt(s.exists()))&&(yield yield vt(s))}}catch(s){a={error:s}}finally{try{o&&!o.done&&(t=i.return)&&(yield vt(t.call(i)))}finally{if(a)throw a.error}}})}e.enumeratePowerShellInstallations=w;async function d(){var u,a;try{for(var t=en(w()),i;i=await t.next(),!i.done;)return i.value}catch(o){u={error:o}}finally{try{i&&!i.done&&(a=t.return)&&await a.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(ge[101],pe([0,1,3,6,17,21,16,25,12,15,58,10]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function h(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function m(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class g{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class w{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function u(F){const N=A.VSBuffer.alloc(4);return N.writeUInt32BE(F,0),N}function a(F){return F.read(4).readUInt32BE(0)}function t(F){const N=A.VSBuffer.alloc(1);return N.writeUInt8(F,0),N}const i={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},o=typeof Buffer!="undefined";function s(F,N){if(typeof N=="undefined")F.write(i.Undefined);else if(typeof N=="string"){const O=A.VSBuffer.fromString(N);F.write(i.String),F.write(u(O.byteLength)),F.write(O)}else if(o&&Buffer.isBuffer(N)){const O=A.VSBuffer.wrap(N);F.write(i.Buffer),F.write(u(O.byteLength)),F.write(O)}else if(N instanceof A.VSBuffer)F.write(i.VSBuffer),F.write(u(N.byteLength)),F.write(N);else if(Array.isArray(N)){F.write(i.Array),F.write(u(N.length));for(const O of N)s(F,O)}else{const O=A.VSBuffer.fromString(JSON.stringify(N));F.write(i.Object),F.write(u(O.byteLength)),F.write(O)}}function r(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(a(F)).toString();case d.Buffer:return F.read(a(F)).buffer;case d.VSBuffer:return F.read(a(F));case d.Array:{const O=a(F),V=[];for(let q=0;q<O;q++)V.push(r(F));return V}case d.Object:return JSON.parse(F.read(a(F)).toString())}}class l{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,m(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,m(N.type),N.data);return}}}send(N,O=void 0){const V=new w;return s(V,N),s(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new g(N),V=r(O),q=r(O),Q=V[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${h(Q)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:Q,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${h(Q)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:Q,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new P.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(_e){q=Promise.reject(_e)}const Q=N.id;q.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(N.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(N.id)});const fe=(0,y.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,Q=O.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:V,data:fe,type:204}));this.activeRequests.set(N.id,Q)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var p;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,Q){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(N,V,q,Q)},listen(V,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=P.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Le;return new Promise((Fe,j)=>{if(q.isCancellationRequested)return j(D.canceled());const X=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Fe(Oe.data);break;case 202:this.handlers.delete(Q);const we=new Error(Oe.data.message);we.stack=Oe.data.stack,we.name=Oe.data.name,j(we);break;case 203:this.handlers.delete(Q),j(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(_e)};let te=null;this.state===E.Idle?X():(te=(0,R.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,X()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:Q,type:101}),j(D.canceled())},ve=q.onCancellationRequested(ae);Le=(0,y.combinedDisposable)((0,y.toDisposable)(ae),ve),this.activeRequests.add(Le)}).finally(()=>{this.activeRequests.delete(Le)})}requestEvent(N,O,V){const q=this.lastRequestId++,fe={id:q,type:102,channelName:N,name:O,arg:V};let _e=null;const Le=new _.Emitter({onFirstListenerAdd:()=>{_e=(0,R.createCancelablePromise)(Fe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Le),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Le),this.sendRequest({id:q,type:103}))}}),Ie=Fe=>Le.fire(Fe.data);return this.handlers.set(q,Ie),Le.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,h(N.type));return}}}send(N,O=void 0){const V=new w;return s(V,N),s(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new g(N),V=r(O),q=r(O),Q=V[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,m(Q)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,m(Q),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===E.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=S;class f{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{_.Event.once(O.onMessage)(Q=>{const fe=new g(Q),_e=r(fe),Le=new l(O,_e),Ie=new S(O);this.channels.forEach((j,X)=>Le.registerChannel(X,j));const Fe={channelServer:Le,channelClient:Ie,ctx:_e};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Le.dispose(),Ie.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,Q,fe){let _e;if((0,n.isFunction)(O)){let Ie=(0,C.getRandomElement)(V.connections.filter(O));_e=Ie?Promise.resolve(Ie):_.Event.toPromise(_.Event.filter(V.onDidAddConnection,O))}else _e=O.routeCall(V,q,Q);const Le=_e.then(Ie=>Ie.channelClient.getChannel(N));return I(Le).call(q,Q,fe)},listen(q,Q){if((0,n.isFunction)(O))return V.getMulticastEvent(N,O,q,Q);const fe=O.routeEvent(V,q,Q).then(_e=>_e.channelClient.getChannel(N));return I(fe).listen(q,Q)}}}getMulticastEvent(N,O,V,q){const Q=this;let fe=new y.DisposableStore;const _e=new _.Emitter({onFirstListenerAdd:()=>{fe=new y.DisposableStore;const Le=new _.EventMultiplexer,Ie=new Map,Fe=X=>{const ae=X.channelClient.getChannel(N).listen(V,q),ve=Le.add(ae);Ie.set(X,ve)},j=X=>{const te=Ie.get(X);!te||(te.dispose(),Ie.delete(X))};Q.connections.filter(O).forEach(Fe),_.Event.filter(Q.onDidAddConnection,O)(Fe,void 0,fe),Q.onDidRemoveConnection(j,void 0,fe),Le.event(_e.fire,_e,fe),fe.add(Le)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class v{constructor(N,O,V=null){const q=new w;s(q,O),N.send(q.buffer),this.channelClient=new S(N,V),this.channelServer=new l(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=v;function I(F){return{call(N,O,V){return F.then(q=>q.call(N,O,V))},listen(N,O){const V=new _.Relay;return F.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=I;function L(F){let N=!1;return{call(O,V,q){return N?F.call(O,V,q):(0,R.timeout)(0).then(()=>N=!0).then(()=>F.call(O,V,q))},listen(O,V){if(N)return F.listen(O,V);const q=new _.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>q.input=F.listen(O,V)),q.event}}}e.getNextTickChannel=L;class x{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=x;var Z;(function(F){function N(q,Q){const fe=q,_e=Q&&Q.disableMarshalling,Le=new Map;for(const Ie in fe)V(Ie)&&Le.set(Ie,_.Event.buffer(fe[Ie],!0));return new class{listen(Ie,Fe){const j=Le.get(Fe);if(j)return j;throw new Error(`Event not found: ${Fe}`)}call(Ie,Fe,j){const X=fe[Fe];if(typeof X=="function"){if(!_e&&Array.isArray(j))for(let te=0;te<j.length;te++)j[te]=(0,T.revive)(j[te]);return X.apply(fe,j)}throw new Error(`Method not found: ${Fe}`)}}}F.fromService=N;function O(q,Q){const fe=Q&&Q.disableMarshalling;return new Proxy({},{get(_e,Le){var Ie;if(typeof Le=="string")return((Ie=Q==null?void 0:Q.properties)===null||Ie===void 0?void 0:Ie.has(Le))?Q.properties.get(Le):V(Le)?q.listen(Le):async function(...Fe){let j;Q&&!(0,n.isUndefinedOrNull)(Q.context)?j=[Q.context,...Fe]:j=Fe;const X=await q.call(Le,j);return fe?X:(0,T.revive)(X)};throw new Error(`Property not found: ${String(Le)}`)}})}F.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&k.isUpperAsciiLetter(q.charCodeAt(2))}})(Z=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let N=F.toString();if(N!=="[object Object]")return N}return F}function $(F){return Array.isArray(F)?F.map(B):B(F)}function M(F,N,O,V,q,Q,fe){fe=$(fe);const _e=z[q],Le=_e[V%_e.length];let Ie=[`%c[${F}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Le}`];/\($/.test(Q)?(Ie=Ie.concat(fe),Ie.push(")")):Ie.push(fe),console.log.apply(console,Ie)}e.logWithColors=M;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,Q){this._totalOutgoing+=N,M(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,Q)}logIncoming(N,O,V,q,Q){this._totalIncoming+=N,M(this._incomingPrefix,this._totalIncoming,N,O,V,q,Q)}}e.IPCLogger=U}),define(ge[102],pe([0,1,3,101,6,25,9,30]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let C=null;function n(){return C||(C=P.VSBuffer.alloc(0)),C}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const S=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),S}if(this._chunks[0].byteLength>o){const S=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),S}let r=P.VSBuffer.alloc(o),l=0,p=0;for(;o>0;){const S=this._chunks[p];if(S.byteLength>o){const f=S.slice(0,o);r.set(f,l),l+=o,s&&(this._chunks[p]=S.slice(o),this._totalLength-=o),o-=o}else r.set(S,l),l+=S.byteLength,s?(this._chunks.shift(),this._totalLength-=S.byteLength):p++,o-=S.byteLength}return r}}e.ChunkStream=T;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var b;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,s,r,l){this.type=o,this.id=s,this.ack=r,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends R.Disposable{constructor(o){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const r=this._state.messageType,l=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(r,l,p,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=P.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._writeSoon(s,o.data)}}_bufferAdd(o,s){const r=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,r}_bufferTake(){const o=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends R.Disposable{constructor(o){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=E;class g extends y.IPCClient{constructor(o,s,r=null){super(o,s,r);this.protocol=o}static fromSocket(o,s){return new g(new E(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class w{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=w;class d{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,r=this._first;for(;r;)o[s++]=r.data,r=r.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new d(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let r=0;for(let l=0;l<a._HISTORY_LENGTH;l++)o-this.lastRuns[l]<=s&&r++;return 1-r/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class t{constructor(o,s=null){this._loadEstimator=a.getInstance(),this._onControlMessage=new w,this.onControlMessage=this._onControlMessage.event,this._onMessage=new w,this.onMessage=this._onMessage.event,this._onDidDispose=new w,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new w,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new w,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const s=new h(4,0,0,n());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let s=0,r=o.length;s<r;s++)this._socketWriter.write(o[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const s=this._outgoingUnackMsg.toArray();for(let r=0,l=s.length;r<l;r++)this._socketWriter.write(s[r]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const r=new h(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(r),this._isReconnecting||(this._socketWriter.write(r),this._recvAckCheck())}sendControl(o){const s=new h(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[103],pe([0,1,92]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class y{constructor(A){let C=(0,_.toUint8)(A);this._defaultValue=C,this._asciiMap=y._createAsciiMap(C),this._map=new Map}static _createAsciiMap(A){let C=new Uint8Array(256);for(let n=0;n<256;n++)C[n]=A;return C}set(A,C){let n=(0,_.toUint8)(C);A>=0&&A<256?this._asciiMap[A]=n:this._map.set(A,n)}get(A){return A>=0&&A<256?this._asciiMap[A]:this._map.get(A)||this._defaultValue}}e.CharacterClassifier=y;var R;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(R||(R={}));class P{constructor(){this._actual=new y(0)}add(A){this._actual.set(A,1)}has(A){return this._actual.get(A)===1}}e.CharacterSet=P}),define(ge[136],pe([0,1,103]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var y;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(y=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends _.CharacterClassifier{constructor(A){super(0);for(let C=0,n=A.length;C<n;C++)this.set(A.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function P(D){let A={};return C=>(A.hasOwnProperty(C)||(A[C]=D(C)),A[C])}e.getMapForWordSeparators=P(D=>new R(D))}),define(ge[49],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(R,P){this.lineNumber=R,this.column=P}with(R=this.lineNumber,P=this.column){return R===this.lineNumber&&P===this.column?this:new _(R,P)}delta(R=0,P=0){return this.with(this.lineNumber+R,this.column+P)}equals(R){return _.equals(this,R)}static equals(R,P){return!R&&!P?!0:!!R&&!!P&&R.lineNumber===P.lineNumber&&R.column===P.column}isBefore(R){return _.isBefore(this,R)}static isBefore(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<P.column}isBeforeOrEqual(R){return _.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<=P.column}static compare(R,P){let D=R.lineNumber|0,A=P.lineNumber|0;if(D===A){let C=R.column|0,n=P.column|0;return C-n}return D-A}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new _(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=_}),define(ge[43],pe([0,1,49]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class y{constructor(P,D,A,C){P>A||P===A&&D>C?(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=P,this.endColumn=D):(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=A,this.endColumn=C)}isEmpty(){return y.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return y.containsPosition(this,P)}static containsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<P.startColumn||D.lineNumber===P.endLineNumber&&D.column>P.endColumn)}containsRange(P){return y.containsRange(this,P)}static containsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>P.endColumn)}strictContainsRange(P){return y.strictContainsRange(this,P)}static strictContainsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<=P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>=P.endColumn)}plusRange(P){return y.plusRange(this,P)}static plusRange(P,D){let A,C,n,T;return D.startLineNumber<P.startLineNumber?(A=D.startLineNumber,C=D.startColumn):D.startLineNumber===P.startLineNumber?(A=D.startLineNumber,C=Math.min(D.startColumn,P.startColumn)):(A=P.startLineNumber,C=P.startColumn),D.endLineNumber>P.endLineNumber?(n=D.endLineNumber,T=D.endColumn):D.endLineNumber===P.endLineNumber?(n=D.endLineNumber,T=Math.max(D.endColumn,P.endColumn)):(n=P.endLineNumber,T=P.endColumn),new y(A,C,n,T)}intersectRanges(P){return y.intersectRanges(this,P)}static intersectRanges(P,D){let A=P.startLineNumber,C=P.startColumn,n=P.endLineNumber,T=P.endColumn,k=D.startLineNumber,b=D.startColumn,h=D.endLineNumber,c=D.endColumn;return A<k?(A=k,C=b):A===k&&(C=Math.max(C,b)),n>h?(n=h,T=c):n===h&&(T=Math.min(T,c)),A>n||A===n&&C>T?null:new y(A,C,n,T)}equalsRange(P){return y.equalsRange(this,P)}static equalsRange(P,D){return!!P&&!!D&&P.startLineNumber===D.startLineNumber&&P.startColumn===D.startColumn&&P.endLineNumber===D.endLineNumber&&P.endColumn===D.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(P){return new _.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(P){return new _.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,D){return new y(this.startLineNumber,this.startColumn,P,D)}setStartPosition(P,D){return new y(P,D,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(P){return new y(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,D=P){return new y(P.lineNumber,P.column,D.lineNumber,D.column)}static lift(P){return P?new y(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<P.startColumn)}static areIntersecting(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<=D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,D){if(P&&D){const n=P.startLineNumber|0,T=D.startLineNumber|0;if(n===T){const k=P.startColumn|0,b=D.startColumn|0;if(k===b){const h=P.endLineNumber|0,c=D.endLineNumber|0;if(h===c){const m=P.endColumn|0,E=D.endColumn|0;return m-E}return h-c}return k-b}return n-T}return(P?1:0)-(D?1:0)}static compareRangesUsingEnds(P,D){return P.endLineNumber===D.endLineNumber?P.endColumn===D.endColumn?P.startLineNumber===D.startLineNumber?P.startColumn-D.startColumn:P.startLineNumber-D.startLineNumber:P.endColumn-D.endColumn:P.endLineNumber-D.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=y}),define(ge[137],pe([0,1,49,43]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class P extends y.Range{constructor(A,C,n,T){super(A,C,n,T);this.selectionStartLineNumber=A,this.selectionStartColumn=C,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return P.selectionsEqual(this,A)}static selectionsEqual(A,C){return A.selectionStartLineNumber===C.selectionStartLineNumber&&A.selectionStartColumn===C.selectionStartColumn&&A.positionLineNumber===C.positionLineNumber&&A.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,C){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,A,C):new P(A,C,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(A,C){return this.getDirection()===0?new P(A,C,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,A,C)}static fromPositions(A,C=A){return new P(A.lineNumber,A.column,C.lineNumber,C.column)}static liftSelection(A){return new P(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,C){if(A&&!C||!A&&C)return!1;if(!A&&!C)return!0;if(A.length!==C.length)return!1;for(let n=0,T=A.length;n<T;n++)if(!this.selectionsEqual(A[n],C[n]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,C,n,T,k){return k===0?new P(A,C,n,T):new P(n,T,A,C)}}e.Selection=P}),define(ge[104],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(c){this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace)}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class C{constructor(c,m){this.range=c,this.matches=m}}e.FindMatch=C;var n;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(c,m,E,g,w,d){this.identifier=c,this.range=m,this.text=E,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=w,this._isTracked=d}}e.ValidAnnotatedEditOperation=k;class b{constructor(c,m,E){this.reverseEdits=c,this.changes=m,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=b}),define(ge[138],pe([0,1,10,136,49,43,104]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class C{constructor(d,u,a,t){this.searchString=d,this.isRegex=u,this.matchCase=a,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=n(this.searchString):d=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let a=!this.isRegex&&!d;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new T(u,this.wordSeparators?(0,y.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=C;function n(w){if(!w||w.length===0)return!1;for(let d=0,u=w.length;d<u;d++)if(w.charCodeAt(d)===92){if(d++,d>=u)break;const t=w.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(d,u,a){this.regex=d,this.wordSeparators=u,this.simpleSearch=a}}e.SearchData=T;function k(w,d,u){if(!u)return new D.FindMatch(w,null);let a=[];for(let t=0,i=d.length;t<i;t++)a[t]=d[t];return new D.FindMatch(w,a)}e.createFindMatch=k;class b{constructor(d){let u=[],a=0;for(let t=0,i=d.length;t<i;t++)d.charCodeAt(t)===10&&(u[a++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(d){const u=this._lineFeedsOffsets;let a=0,t=u.length-1;if(t===-1||d<=u[0])return 0;for(;a<t;){const i=a+((t-a)/2>>0);u[i]>=d?t=i-1:u[i+1]>=d?(a=i,t=i):a=i+1}return a+1}}class h{static findMatches(d,u,a,t,i){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(d,a,new g(o.wordSeparators,o.regex),t,i):this._doFindMatchesLineByLine(d,a,o,t,i):[]}static _getMultilineMatchRange(d,u,a,t,i,o){let s,r=0;t?(r=t.findLineFeedCountBeforeOffset(i),s=u+i+r):s=u+i;let l;if(t){let v=t.findLineFeedCountBeforeOffset(i+o.length)-r;l=s+o.length+v}else l=s+o.length;const p=d.getPositionAt(s),S=d.getPositionAt(l);return new P.Range(p.lineNumber,p.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(d,u,a,t,i){const o=d.getOffsetAt(u.getStartPosition()),s=d.getValueInRange(u,1),r=d.getEOL()===`\r
`?new b(s):null,l=[];let p=0,S;for(a.reset(0);S=a.next(s);)if(l[p++]=k(this._getMultilineMatchRange(d,o,s,r,S.index,S[0]),S,t),p>=i)return l;return l}static _doFindMatchesLineByLine(d,u,a,t,i){const o=[];let s=0;if(u.startLineNumber===u.endLineNumber){const l=d.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return s=this._findMatchesInLine(a,l,u.startLineNumber,u.startColumn-1,s,o,t,i),o}const r=d.getLineContent(u.startLineNumber).substring(u.startColumn-1);s=this._findMatchesInLine(a,r,u.startLineNumber,u.startColumn-1,s,o,t,i);for(let l=u.startLineNumber+1;l<u.endLineNumber&&s<i;l++)s=this._findMatchesInLine(a,d.getLineContent(l),l,0,s,o,t,i);if(s<i){const l=d.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);s=this._findMatchesInLine(a,l,u.endLineNumber,0,s,o,t,i)}return o}static _findMatchesInLine(d,u,a,t,i,o,s,r){const l=d.wordSeparators;if(!s&&d.simpleSearch){const f=d.simpleSearch,v=f.length,I=u.length;let L=-v;for(;(L=u.indexOf(f,L+v))!==-1;)if((!l||E(l,u,I,L,v))&&(o[i++]=new D.FindMatch(new P.Range(a,L+1+t,a,L+1+v+t),null),i>=r))return i;return i}const p=new g(d.wordSeparators,d.regex);let S;p.reset(0);do if(S=p.next(u),S&&(o[i++]=k(new P.Range(a,S.index+1+t,a,S.index+1+S[0].length+t),S,s),i>=r))return i;while(S);return i}static findNextMatch(d,u,a,t){const i=u.parseSearchRequest();if(!i)return null;const o=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(d,a,o,t):this._doFindNextMatchLineByLine(d,a,o,t)}static _doFindNextMatchMultiline(d,u,a,t){const i=new R.Position(u.lineNumber,1),o=d.getOffsetAt(i),s=d.getLineCount(),r=d.getValueInRange(new P.Range(i.lineNumber,i.column,s,d.getLineMaxColumn(s)),1),l=d.getEOL()===`\r
`?new b(r):null;a.reset(u.column-1);let p=a.next(r);return p?k(this._getMultilineMatchRange(d,o,r,l,p.index,p[0]),p,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(d,new R.Position(1,1),a,t):null}static _doFindNextMatchLineByLine(d,u,a,t){const i=d.getLineCount(),o=u.lineNumber,s=d.getLineContent(o),r=this._findFirstMatchInLine(a,s,o,u.column,t);if(r)return r;for(let l=1;l<=i;l++){const p=(o+l-1)%i,S=d.getLineContent(p+1),f=this._findFirstMatchInLine(a,S,p+1,1,t);if(f)return f}return null}static _findFirstMatchInLine(d,u,a,t,i){d.reset(t-1);const o=d.next(u);return o?k(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,i):null}static findPreviousMatch(d,u,a,t){const i=u.parseSearchRequest();if(!i)return null;const o=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(d,a,o,t):this._doFindPreviousMatchLineByLine(d,a,o,t)}static _doFindPreviousMatchMultiline(d,u,a,t){const i=this._doFindMatchesMultiline(d,new P.Range(1,1,u.lineNumber,u.column),a,t,10*A);if(i.length>0)return i[i.length-1];const o=d.getLineCount();return u.lineNumber!==o||u.column!==d.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(d,new R.Position(o,d.getLineMaxColumn(o)),a,t):null}static _doFindPreviousMatchLineByLine(d,u,a,t){const i=d.getLineCount(),o=u.lineNumber,s=d.getLineContent(o).substring(0,u.column-1),r=this._findLastMatchInLine(a,s,o,t);if(r)return r;for(let l=1;l<=i;l++){const p=(i+o-l-1)%i,S=d.getLineContent(p+1),f=this._findLastMatchInLine(a,S,p+1,t);if(f)return f}return null}static _findLastMatchInLine(d,u,a,t){let i=null,o;for(d.reset(0);o=d.next(u);)i=k(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,t);return i}}e.TextModelSearch=h;function c(w,d,u,a,t){if(a===0)return!0;const i=d.charCodeAt(a-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=d.charCodeAt(a);if(w.get(o)!==0)return!0}return!1}function m(w,d,u,a,t){if(a+t===u)return!0;const i=d.charCodeAt(a+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=d.charCodeAt(a+t-1);if(w.get(o)!==0)return!0}return!1}function E(w,d,u,a,t){return c(w,d,u,a,t)&&m(w,d,u,a,t)}e.isValidMatch=E;class g{constructor(d,u){this._wordSeparators=d,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const u=d.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(a=this._searchRegex.exec(d),!a))return null;const t=a.index,i=a[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){_.getNextCodePoint(d,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||E(this._wordSeparators,d,u,t,i))return a}while(a);return null}}e.Searcher=g}),define(ge[105],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(A=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)A.indexOf(n)>=0||(C+="\\"+n);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=_();function y(A){let C=e.DEFAULT_WORD_REGEXP;if(A&&A instanceof RegExp)if(A.global)C=A;else{let n="g";A.ignoreCase&&(n+="i"),A.multiline&&(n+="m"),A.unicode&&(n+="u"),C=new RegExp(A.source,n)}return C.lastIndex=0,C}e.ensureValidWordDefinition=y;const R={maxLen:1e3,windowSize:15,timeBudget:150};function P(A,C,n,T,k=R){if(n.length>k.maxLen){let E=A-k.maxLen/2;return E<0?E=0:T+=E,n=n.substring(E,A+k.maxLen/2),P(A,C,n,T,k)}const b=Date.now(),h=A-1-T;let c=-1,m=null;for(let E=1;!(Date.now()-b>=k.timeBudget);E++){const g=h-k.windowSize*E;C.lastIndex=Math.max(0,g);const w=D(C,n,h,c);if(!w&&m||(m=w,g<=0))break;c=g}if(m){let E={word:m[0],startColumn:T+1+m.index,endColumn:T+1+m.index+m[0].length};return C.lastIndex=0,E}return null}e.getWordAtText=P;function D(A,C,n,T){let k;for(;k=A.exec(C);){const b=k.index||0;if(b<=n&&A.lastIndex>=n)return k;if(T>0&&b>T)return null}return null}}),define(ge[139],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class y{constructor(A){if(this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let C=0,n=A.notIn.length;C<n;C++)switch(A.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=y;class R{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of A)P(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),P(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),P(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),P(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&P(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=R;function P(D,A,C){D.has(A)?D.get(A).push(C):D.set(A,[C])}}),define(ge[76],pe([0,1,34,7]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(P,D,A,C){if(Array.isArray(P)){let n=0;for(const T of P){const k=R(T,D,A,C);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof P=="string")return C?P==="*"?5:P===A?10:0:0;if(P){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:b}=P;if(!C&&!b)return 0;let h=0;if(k)if(k===D.scheme)h=10;else if(k==="*")h=5;else return 0;if(n)if(n===A)h=10;else if(n==="*")h=Math.max(h,5);else return 0;if(T){let c;if(typeof T=="string"?c=T:c=Object.assign(Object.assign({},T),{base:(0,y.normalize)(T.base)}),c===D.fsPath||(0,_.match)(c,D.fsPath))h=10;else return 0}return h}else return 0}}e.score=R}),define(ge[140],pe([0,1,103]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var y;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(y=e.State||(e.State={}));class R{constructor(c,m,E){const g=new Uint8Array(c*m);for(let w=0,d=c*m;w<d;w++)g[w]=E;this._data=g,this.rows=c,this.cols=m}get(c,m){return this._data[c*this.cols+m]}set(c,m,E){this._data[c*this.cols+m]=E}}e.Uint8Matrix=R;class P{constructor(c){let m=0,E=0;for(let w=0,d=c.length;w<d;w++){let[u,a,t]=c[w];a>m&&(m=a),u>E&&(E=u),t>E&&(E=t)}m++,E++;let g=new R(E,m,0);for(let w=0,d=c.length;w<d;w++){let[u,a,t]=c[w];g.set(u,a,t)}this._states=g,this._maxCharCode=m}nextState(c,m){return m<0||m>=this._maxCharCode?0:this._states.get(c,m)}}e.StateMachine=P;let D=null;function A(){return D===null&&(D=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var C;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let n=null;function T(){if(n===null){n=new _.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<h.length;m++)n.set(h.charCodeAt(m),1);const c=".,;";for(let m=0;m<c.length;m++)n.set(c.charCodeAt(m),2)}return n}class k{static _createLink(c,m,E,g,w){let d=w-1;do{const u=m.charCodeAt(d);if(c.get(u)!==2)break;d--}while(d>g);if(g>0){const u=m.charCodeAt(g-1),a=m.charCodeAt(d);(u===40&&a===41||u===91&&a===93||u===123&&a===125)&&d--}return{range:{startLineNumber:E,startColumn:g+1,endLineNumber:E,endColumn:d+2},url:m.substring(g,d+1)}}static computeLinks(c,m=A()){const E=T();let g=[];for(let w=1,d=c.getLineCount();w<=d;w++){const u=c.getLineContent(w),a=u.length;let t=0,i=0,o=0,s=1,r=!1,l=!1,p=!1,S=!1;for(;t<a;){let f=!1;const v=u.charCodeAt(t);if(s===13){let I;switch(v){case 40:r=!0,I=0;break;case 41:I=r?0:1;break;case 91:p=!0,l=!0,I=0;break;case 93:p=!1,I=l?0:1;break;case 123:S=!0,I=0;break;case 125:I=S?0:1;break;case 39:I=o===34||o===96?0:1;break;case 34:I=o===39||o===96?0:1;break;case 96:I=o===39||o===34?0:1;break;case 42:I=o===42?1:0;break;case 124:I=o===124?1:0;break;case 32:I=p?0:1;break;default:I=E.get(v)}I===1&&(g.push(k._createLink(E,u,w,i,t)),f=!0)}else if(s===12){let I;v===91?(l=!0,I=0):I=E.get(v),I===1?f=!0:s=13}else s=m.nextState(s,v),s===0&&(f=!0);f&&(s=1,r=!1,l=!1,S=!1,i=t+1,o=v),t++}s===13&&g.push(k._createLink(E,u,w,i,a))}return g}}e.LinkComputer=k;function b(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:k.computeLinks(h)}e.computeLinks=b}),define(ge[141],pe([0,1,3,6]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,A){return this._map.set(D,A),this.fire([D]),(0,y.toDisposable)(()=>{this._map.get(D)===A&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,A){let C=null,n=!1;return this._promises.set(D,A.then(T=>{this._promises.delete(D),!(n||!T)&&(C=this.register(D,T))})),(0,y.toDisposable)(()=>{n=!0,C&&C.dispose()})}getPromise(D){const A=this.get(D);if(A)return Promise.resolve(A);const C=this._promises.get(D);return C?C.then(n=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(ge[106],pe([0,1,25,9]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function P(k){for(let b=0,h=k.length;b<h;b+=4){const c=k[b+0],m=k[b+1],E=k[b+2],g=k[b+3];k[b+0]=g,k[b+1]=E,k[b+2]=m,k[b+3]=c}}function D(k){const b=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return y.isLittleEndian()||P(b),_.VSBuffer.wrap(b)}function A(k){const b=k.buffer;if(y.isLittleEndian()||P(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const h=new Uint8Array(b.byteLength);return h.set(b),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function C(k){const b=new Uint32Array(n(k));let h=0;if(b[h++]=k.id,k.type==="full")b[h++]=1,b[h++]=k.data.length,b.set(k.data,h),h+=k.data.length;else{b[h++]=2,b[h++]=k.deltas.length;for(const c of k.deltas)b[h++]=c.start,b[h++]=c.deleteCount,c.data?(b[h++]=c.data.length,b.set(c.data,h),h+=c.data.length):b[h++]=0}return D(b)}e.encodeSemanticTokensDto=C;function n(k){let b=0;if(b+=1+1,k.type==="full")b+=1+k.data.length;else{b+=1,b+=(1+1+1)*k.deltas.length;for(const h of k.deltas)h.data&&(b+=h.data.length)}return b}function T(k){const b=A(k);let h=0;const c=b[h++];if(b[h++]===1){const w=b[h++],d=b.subarray(h,h+w);return h+=w,{id:c,type:"full",data:d}}const E=b[h++];let g=[];for(let w=0;w<E;w++){const d=b[h++],u=b[h++],a=b[h++];let t;a>0&&(t=b.subarray(h,h+a),h+=a),g[w]={start:d,deleteCount:u,data:t}}return{id:c,type:"delta",deltas:g}}e.decodeSemanticTokensDto=T}),define(ge[107],pe([0,1,92]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class y{constructor(D,A){this.index=D,this.remainder=A}}e.PrefixSumIndexOfResult=y;class R{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,A){D=(0,_.toUint32)(D);const C=this.values,n=this.prefixSum,T=A.length;return T===0?!1:(this.values=new Uint32Array(C.length+T),this.values.set(C.subarray(0,D),0),this.values.set(C.subarray(D),D+T),this.values.set(A,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,A){return D=(0,_.toUint32)(D),A=(0,_.toUint32)(A),this.values[D]===A?!1:(this.values[D]=A,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,A){D=(0,_.toUint32)(D),A=(0,_.toUint32)(A);const C=this.values,n=this.prefixSum;if(D>=C.length)return!1;let T=C.length-D;return A>=T&&(A=T),A===0?!1:(this.values=new Uint32Array(C.length-A),this.values.set(C.subarray(0,D),0),this.values.set(C.subarray(D+A),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,_.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),D>=this.values.length&&(D=this.values.length-1);for(let C=A;C<=D;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let A=0,C=this.values.length-1,n=0,T=0,k=0;for(;A<=C;)if(n=A+(C-A)/2|0,T=this.prefixSum[n],k=T-this.values[n],D<k)C=n-1;else if(D>=T)A=n+1;else break;return new y(n,D-k)}}e.PrefixSumComputer=R}),define(ge[142],pe([0,1,10,49,107]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(A,C,n,T){this._uri=A,this._lines=C,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(A){A.eol&&A.eol!==this._eol&&(this._eol=A.eol,this._lineStarts=null);const C=A.changes;for(const n of C)this._acceptDeleteRange(n.range),this._acceptInsertText(new y.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=A.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const A=this._eol.length,C=this._lines.length,n=new Uint32Array(C);for(let T=0;T<C;T++)n[T]=this._lines[T].length+A;this._lineStarts=new R.PrefixSumComputer(n)}}_setLineText(A,C){this._lines[A]=C,this._lineStarts&&this._lineStarts.changeValue(A,this._lines[A].length+this._eol.length)}_acceptDeleteRange(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.startLineNumber-1].substring(A.endColumn-1));return}this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.endLineNumber-1].substring(A.endColumn-1)),this._lines.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}_acceptInsertText(A,C){if(C.length!==0){let n=(0,_.splitLines)(C);if(n.length===1){this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]+this._lines[A.lineNumber-1].substring(A.column-1));return}n[n.length-1]+=this._lines[A.lineNumber-1].substring(A.column-1),this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(A.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(A.lineNumber,T)}}}e.MirrorTextModel=P}),define(ge[143],pe([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ge[144],pe([0,1,143]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,R=y*60,P=R*24,D=P*7,A=P*30,C=P*365;function n(k,b){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,_.localize)(0,null,n(new Date().getTime()+h*1e3,!1));if(h<30)return(0,_.localize)(1,null);let c;return h<y?(c=h,b?c===1?(0,_.localize)(2,null,c):(0,_.localize)(3,null,c):c===1?(0,_.localize)(4,null,c):(0,_.localize)(5,null,c)):h<R?(c=Math.floor(h/y),b?c===1?(0,_.localize)(6,null,c):(0,_.localize)(7,null,c):c===1?(0,_.localize)(8,null,c):(0,_.localize)(9,null,c)):h<P?(c=Math.floor(h/R),b?c===1?(0,_.localize)(10,null,c):(0,_.localize)(11,null,c):c===1?(0,_.localize)(12,null,c):(0,_.localize)(13,null,c)):h<D?(c=Math.floor(h/P),b?c===1?(0,_.localize)(14,null,c):(0,_.localize)(15,null,c):c===1?(0,_.localize)(16,null,c):(0,_.localize)(17,null,c)):h<A?(c=Math.floor(h/D),b?c===1?(0,_.localize)(18,null,c):(0,_.localize)(19,null,c):c===1?(0,_.localize)(20,null,c):(0,_.localize)(21,null,c)):h<C?(c=Math.floor(h/A),b?c===1?(0,_.localize)(22,null,c):(0,_.localize)(23,null,c):c===1?(0,_.localize)(24,null,c):(0,_.localize)(25,null,c)):(c=Math.floor(h/C),b?c===1?(0,_.localize)(26,null,c):(0,_.localize)(27,null,c):c===1?(0,_.localize)(28,null,c):(0,_.localize)(29,null,c))}e.fromNow=n;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ge[145],pe([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ge[59],pe([0,1,145,15,12]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,T){return T&&(n.stack||n.stacktrace)?_.localize(0,null,A(n),D(n.stack)||D(n.stacktrace)):A(n)}function D(n){return Array.isArray(n)?n.join(`
`):n}function A(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function C(n=null,T=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const k=R.coalesce(n),b=C(k[0],T);return k.length>1?_.localize(4,null,b,k.length):b}if(y.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return P(k.error,T);if(k.exception)return P(k.exception,T)}return n.stack?P(n,T):n.message?n.message:_.localize(5,null)}e.toErrorMessage=C}),define(ge[146],pe([18,19]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ge[77],pe([0,1,7,37,26,38,146,30,15,22,31,9,135,11]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function c(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(a,t){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const o=P.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],i);return new Promise(s=>{o.once("error",r=>{s({success:!1,error:r})}),o.once("exit",(r,l)=>{s(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?c(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(o=>{P.execFile(i,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,r,l)=>{o(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function E(a=A.env){return a.comspec||"cmd.exe"}e.getWindowsShell=E;class g{constructor(t,i,o,s){if(i!==void 0&&o!==void 0&&s!==void 0)this.cmd=t,this.args=i,this.shell=o,this.options=s;else{const r=t;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(A.env).forEach(l=>{r[l]=A.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(_.sep);return i!==-1&&(t=t.substring(i+1)),g.WellKnowCommands[t]?t:"other"}start(t){return k.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(A.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(i=>{let o,s;const r=new Promise((l,p)=>{o=l,s=p});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=P.exec(l,this.options,(p,S,f)=>{this.childProcess=null;const v=p;v&&v.killed?s({killed:this.terminateRequested,stdout:S.toString(),stderr:f.toString()}):this.handleExec(o,t,p,S,f)})}else{let l=null;const p=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,o,t,s);const f={terminated:this.terminateRequested};C.isNumber(S)&&(f.cmdCode=S),o(f)};if(this.shell&&k.isWindows){const S=n.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let f=!1,v=!1;const I=[];let L=this.ensureQuotes(this.cmd);I.push(L.value),f=L.quoted,this.args&&this.args.forEach(Z=>{L=this.ensureQuotes(Z),I.push(L.value),v=v&&L.quoted});const x=["/s","/c"];f?v?x.push('"'+I.join(" ")+'"'):I.length>1?x.push('"'+I[0]+'" '+I.slice(1).join(" ")):x.push('"'+I[0]+'"'):x.push(I.join(" ")),l=P.spawn(E(),x,S)}else this.cmd&&(l=P.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(C.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,s({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",p),this.handleSpawn(l,o,t,s,!0)))}return r})}handleClose(t,i,o,s){}ensureQuotes(t){return g.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!k.isWindows)return t(!1);const i=P.spawn(E(),["/s","/c"]);i.on("error",o=>t(!0)),i.on("exit",o=>t(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class w extends g{constructor(t,i,o,s){super(t,i,o,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,o,s,r){[s,r].forEach((l,p)=>{const S=new b.LineDecoder;S.write(l).forEach(I=>{i({line:I,source:p===0?0:1})});const v=S.end();v&&i({line:v,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,i,o,s,r){const l=new b.LineDecoder,p=new b.LineDecoder;t.stdout.on("data",S=>{l.write(S).forEach(v=>o({line:v,source:0}))}),t.stderr.on("data",S=>{p.write(S).forEach(v=>o({line:v,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=p}handleClose(t,i,o,s){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&o({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&o({line:l,source:1})}}e.LineProcess=w;function d(a){let t=[],i=!1;const o=function(s){if(i){t.push(s);return}(!a.send(s,l=>{if(l&&console.error(l),i=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(S=>o(S))}})||k.isWindows)&&(i=!0)};return{send:o}}e.createQueuedSender=d;var u;(function(a){async function t(i,o,s){if(_.isAbsolute(i))return i;if(o===void 0&&(o=A.cwd()),_.dirname(i)!=="."||(s===void 0&&C.isString(A.env.PATH)&&(s=A.env.PATH.split(_.delimiter)),s===void 0||s.length===0))return _.join(o,i);async function l(p){return await R.exists(p)?!(await y.promises.stat(p)).isDirectory():!1}for(let p of s){let S;if(_.isAbsolute(p)?S=_.join(p,i):S=_.join(o,p,i),await l(S))return S;let f=S+".com";if(await l(f)||(f=S+".exe",await l(f)))return f}return _.join(o,i)}a.findExecutable=t})(u=e.win32||(e.win32={}))}),define(ge[147],pe([0,1,48,9,100,77]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(h,c){return h===3?y.isWindows?k():P.getWindowsShell(c):n(h,c)}e.getSystemShell=D;function A(h,c){return h===3?y.isWindows?b(c):P.getWindowsShell(c):n(h,c)}e.getSystemShellSync=A;let C=null;function n(h,c){if(y.isLinux&&h===1||y.isMacintosh&&h===2)return"/bin/bash";if(!C){let m;if(y.isWindows)m="/bin/bash";else{if(m=c.SHELL,!m)try{m=_.userInfo().shell}catch(E){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}C=m}return C}let T=null;async function k(){return T||(T=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),T}function b(h){if(T)return T;const c=y.isWindows&&parseFloat(_.release())>=10,m=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${h.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?E:P.getWindowsShell(h)}}),define(ge[148],pe([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ge[149],pe([0,1,148,9,105]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=D;class A{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Se){this._values[ie]=Se}}e.ValidatedEditorOptions=A;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class n{constructor(ie,Se,Ne,ze){this.id=ie,this.name=Se,this.defaultValue=Ne,this.schema=ze}compute(ie,Se,Ne){return Ne}}class T{constructor(ie,Se=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Se}validate(ie){return this.defaultValue}}class k{constructor(ie,Se,Ne,ze){this.id=ie,this.name=Se,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Se,Ne){return Ne}}function b(G,ie){return typeof G=="undefined"?ie:G==="false"?!1:Boolean(G)}e.boolean=b;class h extends k{constructor(ie,Se,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,Se,Ne,ze)}validate(ie){return b(ie,this.defaultValue)}}class c extends k{constructor(ie,Se,Ne,ze,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ne,Ye.minimum=ze,Ye.maximum=We),super(ie,Se,Ne,Ye),this.minimum=ze,this.maximum=We}static clampedInt(ie,Se,Ne,ze){if(typeof ie=="undefined")return Se;let We=parseInt(ie,10);return isNaN(We)?Se:(We=Math.max(Ne,We),We=Math.min(ze,We),We|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class m extends k{constructor(ie,Se,Ne,ze,We){typeof We!="undefined"&&(We.type="number",We.default=Ne),super(ie,Se,Ne,We),this.validationFn=ze}static clamp(ie,Se,Ne){return ie<Se?Se:ie>Ne?Ne:ie}static float(ie,Se){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Se;const Ne=parseFloat(ie);return isNaN(Ne)?Se:Ne}validate(ie){return this.validationFn(m.float(ie,this.defaultValue))}}class E extends k{static string(ie,Se){return typeof ie!="string"?Se:ie}constructor(ie,Se,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,Se,Ne,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function g(G,ie,Se){return typeof G!="string"||Se.indexOf(G)===-1?ie:G}e.stringSet=g;class w extends k{constructor(ie,Se,Ne,ze,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=ze,We.default=Ne),super(ie,Se,Ne,We),this._allowedValues=ze}validate(ie){return g(ie,this.defaultValue,this._allowedValues)}}class d extends n{constructor(ie,Se,Ne,ze,We,Ye,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=We,K.default=ze),super(ie,Se,Ne,K),this._allowedValues=We,this._convert=Ye}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Se,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends n{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertSpace:b(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function r(G){switch(G){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=r;function l(G){switch(G){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class p extends T{constructor(){super(121,[60,29])}compute(ie,Se,Ne){const ze=["monaco-editor"];return Se.get(29)&&ze.push(Se.get(29)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),Se.get(60)==="default"?ze.push("mouse-default"):Se.get(60)==="copy"&&ze.push("mouse-copy"),Se.get(95)&&ze.push("showUnused"),Se.get(119)&&ze.push("showDeprecated"),ze.join(" ")}}class S extends h{constructor(){super(28,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ie,Se,Ne){return Ne&&ie.emptySelectionClipboard}}class f extends n{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:_.localize(13,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:_.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{cursorMoveOnType:b(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":g(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Se.loop,this.defaultValue.loop)}}}class v extends n{constructor(){super(39,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?v.OFF:ie==="true"?v.ON:ie:Boolean(ie)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class I extends T{constructor(){super(38)}compute(ie,Se,Ne){return ie.fontInfo}}class L extends k{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ie){let Se=m.float(ie,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Se,6,100)}compute(ie,Se,Ne){return ie.fontInfo.fontSize}}class x extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class Z extends n{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(45,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},Se),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},Se),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},Se),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},Se),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},Se),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(ie){var Se,Ne,ze,We,Ye;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:g(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Se=K.multipleDefinitions)!==null&&Se!==void 0?Se:g(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:g(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:g(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=K.multipleImplementations)!==null&&We!==void 0?We:g(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=K.multipleReferences)!==null&&Ye!==void 0?Ye:g(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends n{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(48,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:_.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:b(Se.enabled,this.defaultValue.enabled),delay:c.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:b(Se.sticky,this.defaultValue.sticky)}}}var B;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class $ extends T{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(ie,Se,Ne){return $.computeLayout(Se,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Se=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Se-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:We}}static _computeMinimapLayout(ie,Se){const Ne=ie.outerWidth,ze=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=Se.stableMinimapLayoutInput,K=Ye&&ie.outerHeight===Ye.outerHeight&&ie.lineHeight===Ye.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ye.pixelRatio&&ie.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&ie.minimap.enabled===Ye.minimap.enabled&&ie.minimap.side===Ye.minimap.side&&ie.minimap.size===Ye.minimap.size&&ie.minimap.showSlider===Ye.minimap.showSlider&&ie.minimap.renderCharacters===Ye.minimap.renderCharacters&&ie.minimap.maxColumn===Ye.minimap.maxColumn&&ie.minimap.scale===Ye.minimap.scale&&ie.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&ie.isViewportWrapping===Ye.isViewportWrapping,oe=ie.lineHeight,ue=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let le=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const me=ie.minimap.maxColumn,Ee=ie.minimap.size,He=ie.minimap.side,$e=ie.verticalScrollbarWidth,qe=ie.viewLineCount,Qe=ie.remainingWidth,Ze=ie.isViewportWrapping,ut=ne?2:3;let st=Math.floor(We*ze);const be=st/We;let he=!1,ce=!1,ee=ut*le,Ae=le/We,Re=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:at,desiredRatio:Ct,minimapLineCount:gt}=$.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:J,height:ze,lineHeight:oe,pixelRatio:We});if(qe/gt>1)he=!0,ce=!0,le=1,ee=1,Ae=le/We;else{let Et=!1,St=le+1;if(Ee==="fit"){const mt=Math.ceil((qe+at)*ee);Ze&&K&&Qe<=Se.stableFitRemainingWidth?(Et=!0,St=Se.stableFitMaxMinimapScale):(Et=mt>st,Ze&&Et?(Se.stableMinimapLayoutInput=ie,Se.stableFitRemainingWidth=Qe):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0))}if(Ee==="fill"||Et){he=!0;const mt=le;ee=Math.min(oe*We,Math.max(1,Math.floor(1/Ct))),le=Math.min(St,Math.max(1,Math.floor(ee/ut))),le>mt&&(Re=Math.min(2,le/mt)),Ae=le/We/Re,st=Math.ceil(Math.max(dt,qe+at)*ee),Ze&&Et&&(Se.stableFitMaxMinimapScale=le)}}}const et=Math.floor(me*Ae),Ge=Math.min(et,Math.max(0,Math.floor((Qe-$e-2)*Ae/(ue+Ae)))+e.MINIMAP_GUTTER_WIDTH);let rt=Math.floor(We*Ge);const lt=rt/We;rt=Math.floor(rt*Re);const Xe=ne?1:2,it=He==="left"?0:Ne-Ge-$e;return{renderMinimap:Xe,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:he,minimapIsSampling:ce,minimapScale:le,minimapLineHeight:ee,minimapCanvasInnerWidth:rt,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:be}}static computeLayout(ie,Se){const Ne=Se.outerWidth|0,ze=Se.outerHeight|0,We=Se.lineHeight|0,Ye=Se.lineNumbersDigitCount|0,K=Se.typicalHalfwidthCharacterWidth,oe=Se.maxDigitWidth,ue=Se.pixelRatio,J=Se.viewLineCount,ne=ie.get(116),le=ne==="inherit"?ie.get(115):ne,me=le==="inherit"?ie.get(111):le,Ee=ie.get(114),He=ie.get(2),$e=Se.isDominatedByLongLines,qe=ie.get(44),Qe=ie.get(54).renderType!==0,Ze=ie.get(55),ut=ie.get(89),st=ie.get(59),be=ie.get(87),he=be.verticalScrollbarSize,ce=be.verticalHasArrows,ee=be.arrowSize,Ae=be.horizontalScrollbarSize,Re=ie.get(52),et=ie.get(33);let Ge;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const ht=parseFloat(Re.substr(0,Re.length-2));Ge=c.clampedInt(ht*K,0,0,1e3)}else Ge=c.clampedInt(Re,0,0,1e3);et&&(Ge+=16);let rt=0;if(Qe){const ht=Math.max(Ye,Ze);rt=Math.round(ht*oe)}let lt=0;qe&&(lt=We);let Xe=0,it=Xe+lt,dt=it+rt,at=dt+Ge;const Ct=Ne-lt-rt-Ge;let gt=!1,kt=!1,Et=-1;He!==2&&(le==="inherit"&&$e?(gt=!0,kt=!0):me==="on"||me==="bounded"?kt=!0:me==="wordWrapColumn"&&(Et=Ee));const St=$._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:We,typicalHalfwidthCharacterWidth:K,pixelRatio:ue,scrollBeyondLastLine:ut,minimap:st,verticalScrollbarWidth:he,viewLineCount:J,remainingWidth:Ct,isViewportWrapping:kt},Se.memory||new C);St.renderMinimap!==0&&St.minimapLeft===0&&(Xe+=St.minimapWidth,it+=St.minimapWidth,dt+=St.minimapWidth,at+=St.minimapWidth);const mt=Ct-St.minimapWidth,Lt=Math.max(1,Math.floor((mt-he-2)/K)),Ft=ce?ee:0;return kt&&(Et=Math.max(1,Lt),me==="bounded"&&(Et=Math.min(Et,Ee))),{width:Ne,height:ze,glyphMarginLeft:Xe,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:rt,decorationsLeft:dt,decorationsWidth:Ge,contentLeft:at,contentWidth:mt,minimap:St,viewportColumn:Lt,isWordWrapMinified:gt,isViewportWrapping:kt,wrappingColumn:Et,verticalScrollbarWidth:he,horizontalScrollbarHeight:Ae,overviewRuler:{top:Ft,width:he,height:ze-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=$;class M extends n{constructor(){const ie={enabled:!0};super(51,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:_.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:b(ie.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:_.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:b(Se.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class F extends c{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ie,Se,Ne){return ie.fontInfo.lineHeight}}class N extends n{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ie.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:_.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:b(Se.enabled,this.defaultValue.enabled),size:g(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Se.side,this.defaultValue.side,["right","left"]),showSlider:g(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Se.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Se.scale,1,1,3),maxColumn:c.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(G){return G==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{top:c.clampedInt(Se.top,0,0,1e3),bottom:c.clampedInt(Se.bottom,0,0,1e3)}}}class q extends n{constructor(){const ie={enabled:!0,cycle:!1};super(70,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:_.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:b(Se.enabled,this.defaultValue.enabled),cycle:b(Se.cycle,this.defaultValue.cycle)}}}class Q extends T{constructor(){super(122)}compute(ie,Se,Ne){return ie.pixelRatio}}class fe extends n{constructor(){const ie={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:_.localize(59,null)},other:{type:"boolean",default:ie.other,description:_.localize(60,null)}}}],default:ie,description:_.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Se=ie,Ne={other:b(Se.other,this.defaultValue.other),comments:b(Se.comments,this.defaultValue.comments),strings:b(Se.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var _e;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ie){let Se=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Se=4,Ne=ie):ie==="interval"?Se=3:ie==="relative"?Se=2:ie==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ne}}}function Ie(G){const ie=G.get(82);return ie==="editable"?G.get(75):ie!=="on"}e.filterValidationDecorations=Ie;class Fe extends n{constructor(){const ie=[],Se={type:"number",description:_.localize(67,null)};super(86,"rulers",ie,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ie,description:_.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Se=[];for(let Ne of ie)if(typeof Ne=="number")Se.push({column:c.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;Se.push({column:c.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Se.sort((Ne,ze)=>Ne.column-ze.column),Se}return this.defaultValue}}function j(G,ie){if(typeof G!="string")return ie;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie,Ne=c.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=c.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Se.vertical,this.defaultValue.vertical),horizontal:j(Se.horizontal,this.defaultValue.horizontal),useShadows:b(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:c.clampedInt(Se.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:c.clampedInt(Se.verticalSliderSize,ze,0,1e3),scrollByPage:b(Se.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ie.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertMode:g(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Se.showIcons,this.defaultValue.showIcons),showStatusBar:b(Se.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Se.showMethods,this.defaultValue.showMethods),showFunctions:b(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Se.showConstructors,this.defaultValue.showConstructors),showFields:b(Se.showFields,this.defaultValue.showFields),showVariables:b(Se.showVariables,this.defaultValue.showVariables),showClasses:b(Se.showClasses,this.defaultValue.showClasses),showStructs:b(Se.showStructs,this.defaultValue.showStructs),showInterfaces:b(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Se.showModules,this.defaultValue.showModules),showProperties:b(Se.showProperties,this.defaultValue.showProperties),showEvents:b(Se.showEvents,this.defaultValue.showEvents),showOperators:b(Se.showOperators,this.defaultValue.showOperators),showUnits:b(Se.showUnits,this.defaultValue.showUnits),showValues:b(Se.showValues,this.defaultValue.showValues),showConstants:b(Se.showConstants,this.defaultValue.showConstants),showEnums:b(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Se.showKeywords,this.defaultValue.showKeywords),showWords:b(Se.showWords,this.defaultValue.showWords),showColors:b(Se.showColors,this.defaultValue.showColors),showFiles:b(Se.showFiles,this.defaultValue.showFiles),showReferences:b(Se.showReferences,this.defaultValue.showReferences),showFolders:b(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Se.showSnippets,this.defaultValue.showSnippets),showUsers:b(Se.showUsers,this.defaultValue.showUsers),showIssues:b(Se.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends T{constructor(){super(123,[75])}compute(ie,Se,Ne){return Se.get(75)?!0:ie.tabFocusMode}}var De;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends T{constructor(){super(125,[124])}compute(ie,Se,Ne){const ze=Se.get(124);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Te:y.isLinux?xe:ke,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ye(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingOvertype=6]="autoClosingOvertype",G[G.autoClosingQuotes=7]="autoClosingQuotes",G[G.autoIndent=8]="autoIndent",G[G.automaticLayout=9]="automaticLayout",G[G.autoSurround=10]="autoSurround",G[G.codeLens=11]="codeLens",G[G.codeLensFontFamily=12]="codeLensFontFamily",G[G.codeLensFontSize=13]="codeLensFontSize",G[G.colorDecorators=14]="colorDecorators",G[G.columnSelection=15]="columnSelection",G[G.comments=16]="comments",G[G.contextmenu=17]="contextmenu",G[G.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",G[G.cursorBlinking=19]="cursorBlinking",G[G.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",G[G.cursorStyle=21]="cursorStyle",G[G.cursorSurroundingLines=22]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",G[G.cursorWidth=24]="cursorWidth",G[G.disableLayerHinting=25]="disableLayerHinting",G[G.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",G[G.dragAndDrop=27]="dragAndDrop",G[G.emptySelectionClipboard=28]="emptySelectionClipboard",G[G.extraEditorClassName=29]="extraEditorClassName",G[G.fastScrollSensitivity=30]="fastScrollSensitivity",G[G.find=31]="find",G[G.fixedOverflowWidgets=32]="fixedOverflowWidgets",G[G.folding=33]="folding",G[G.foldingStrategy=34]="foldingStrategy",G[G.foldingHighlight=35]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=37]="fontFamily",G[G.fontInfo=38]="fontInfo",G[G.fontLigatures=39]="fontLigatures",G[G.fontSize=40]="fontSize",G[G.fontWeight=41]="fontWeight",G[G.formatOnPaste=42]="formatOnPaste",G[G.formatOnType=43]="formatOnType",G[G.glyphMargin=44]="glyphMargin",G[G.gotoLocation=45]="gotoLocation",G[G.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",G[G.hover=48]="hover",G[G.inDiffEditor=49]="inDiffEditor",G[G.letterSpacing=50]="letterSpacing",G[G.lightbulb=51]="lightbulb",G[G.lineDecorationsWidth=52]="lineDecorationsWidth",G[G.lineHeight=53]="lineHeight",G[G.lineNumbers=54]="lineNumbers",G[G.lineNumbersMinChars=55]="lineNumbersMinChars",G[G.linkedEditing=56]="linkedEditing",G[G.links=57]="links",G[G.matchBrackets=58]="matchBrackets",G[G.minimap=59]="minimap",G[G.mouseStyle=60]="mouseStyle",G[G.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=62]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",G[G.multiCursorModifier=64]="multiCursorModifier",G[G.multiCursorPaste=65]="multiCursorPaste",G[G.occurrencesHighlight=66]="occurrencesHighlight",G[G.overviewRulerBorder=67]="overviewRulerBorder",G[G.overviewRulerLanes=68]="overviewRulerLanes",G[G.padding=69]="padding",G[G.parameterHints=70]="parameterHints",G[G.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",G[G.quickSuggestions=73]="quickSuggestions",G[G.quickSuggestionsDelay=74]="quickSuggestionsDelay",G[G.readOnly=75]="readOnly",G[G.renameOnType=76]="renameOnType",G[G.renderControlCharacters=77]="renderControlCharacters",G[G.renderIndentGuides=78]="renderIndentGuides",G[G.renderFinalNewline=79]="renderFinalNewline",G[G.renderLineHighlight=80]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=82]="renderValidationDecorations",G[G.renderWhitespace=83]="renderWhitespace",G[G.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",G[G.roundedSelection=85]="roundedSelection",G[G.rulers=86]="rulers",G[G.scrollbar=87]="scrollbar",G[G.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=89]="scrollBeyondLastLine",G[G.scrollPredominantAxis=90]="scrollPredominantAxis",G[G.selectionClipboard=91]="selectionClipboard",G[G.selectionHighlight=92]="selectionHighlight",G[G.selectOnLineNumbers=93]="selectOnLineNumbers",G[G.showFoldingControls=94]="showFoldingControls",G[G.showUnused=95]="showUnused",G[G.snippetSuggestions=96]="snippetSuggestions",G[G.smartSelect=97]="smartSelect",G[G.smoothScrolling=98]="smoothScrolling",G[G.stickyTabStops=99]="stickyTabStops",G[G.stopRenderingLineAfter=100]="stopRenderingLineAfter",G[G.suggest=101]="suggest",G[G.suggestFontSize=102]="suggestFontSize",G[G.suggestLineHeight=103]="suggestLineHeight",G[G.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",G[G.suggestSelection=105]="suggestSelection",G[G.tabCompletion=106]="tabCompletion",G[G.tabIndex=107]="tabIndex",G[G.unusualLineTerminators=108]="unusualLineTerminators",G[G.useTabStops=109]="useTabStops",G[G.wordSeparators=110]="wordSeparators",G[G.wordWrap=111]="wordWrap",G[G.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=114]="wordWrapColumn",G[G.wordWrapOverride1=115]="wordWrapOverride1",G[G.wordWrapOverride2=116]="wordWrapOverride2",G[G.wrappingIndent=117]="wrappingIndent",G[G.wrappingStrategy=118]="wrappingStrategy",G[G.showDeprecated=119]="showDeprecated",G[G.inlineHints=120]="inlineHints",G[G.editorClassName=121]="editorClassName",G[G.pixelRatio=122]="pixelRatio",G[G.tabFocusMode=123]="tabFocusMode",G[G.layoutInfo=124]="layoutInfo",G[G.wrappingInfo=125]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:ye(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:ye(new a),accessibilityPageSize:ye(new c(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null),deprecationMessage:_.localize(115,null)})),ariaLabel:ye(new E(4,"ariaLabel",_.localize(116,null))),autoClosingBrackets:ye(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(117,null),_.localize(118,null),""],description:_.localize(119,null)})),autoClosingOvertype:ye(new w(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(120,null),""],description:_.localize(121,null)})),autoClosingQuotes:ye(new w(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(122,null),_.localize(123,null),""],description:_.localize(124,null)})),autoIndent:ye(new d(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(125,null),_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null)],description:_.localize(130,null)})),automaticLayout:ye(new h(9,"automaticLayout",!1)),autoSurround:ye(new w(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(131,null),_.localize(132,null),_.localize(133,null),""],description:_.localize(134,null)})),stickyTabStops:ye(new h(99,"stickyTabStops",!1,{description:_.localize(135,null)})),codeLens:ye(new h(11,"codeLens",!0,{description:_.localize(136,null)})),codeLensFontFamily:ye(new E(12,"codeLensFontFamily","",{description:_.localize(137,null)})),codeLensFontSize:ye(new c(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(138,null)})),colorDecorators:ye(new h(14,"colorDecorators",!0,{description:_.localize(139,null)})),columnSelection:ye(new h(15,"columnSelection",!1,{description:_.localize(140,null)})),comments:ye(new t),contextmenu:ye(new h(17,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new h(18,"copyWithSyntaxHighlighting",!0,{description:_.localize(141,null)})),cursorBlinking:ye(new d(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(142,null)})),cursorSmoothCaretAnimation:ye(new h(20,"cursorSmoothCaretAnimation",!1,{description:_.localize(143,null)})),cursorStyle:ye(new d(21,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:_.localize(144,null)})),cursorSurroundingLines:ye(new c(22,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(145,null)})),cursorSurroundingLinesStyle:ye(new w(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(146,null),_.localize(147,null)],description:_.localize(148,null)})),cursorWidth:ye(new c(24,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(149,null)})),disableLayerHinting:ye(new h(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new h(26,"disableMonospaceOptimizations",!1)),dragAndDrop:ye(new h(27,"dragAndDrop",!0,{description:_.localize(150,null)})),emptySelectionClipboard:ye(new S),extraEditorClassName:ye(new E(29,"extraEditorClassName","")),fastScrollSensitivity:ye(new m(30,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:_.localize(151,null)})),find:ye(new f),fixedOverflowWidgets:ye(new h(32,"fixedOverflowWidgets",!1)),folding:ye(new h(33,"folding",!0,{description:_.localize(152,null)})),foldingStrategy:ye(new w(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(153,null),_.localize(154,null)],description:_.localize(155,null)})),foldingHighlight:ye(new h(35,"foldingHighlight",!0,{description:_.localize(156,null)})),unfoldOnClickAfterEndOfLine:ye(new h(36,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(157,null)})),fontFamily:ye(new E(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(158,null)})),fontInfo:ye(new I),fontLigatures2:ye(new v),fontSize:ye(new L),fontWeight:ye(new x),formatOnPaste:ye(new h(42,"formatOnPaste",!1,{description:_.localize(159,null)})),formatOnType:ye(new h(43,"formatOnType",!1,{description:_.localize(160,null)})),glyphMargin:ye(new h(44,"glyphMargin",!0,{description:_.localize(161,null)})),gotoLocation:ye(new Z),hideCursorInOverviewRuler:ye(new h(46,"hideCursorInOverviewRuler",!1,{description:_.localize(162,null)})),highlightActiveIndentGuide:ye(new h(47,"highlightActiveIndentGuide",!0,{description:_.localize(163,null)})),hover:ye(new z),inDiffEditor:ye(new h(49,"inDiffEditor",!1)),letterSpacing:ye(new m(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>m.clamp(G,-5,20),{description:_.localize(164,null)})),lightbulb:ye(new M),lineDecorationsWidth:ye(new k(52,"lineDecorationsWidth",10)),lineHeight:ye(new F),lineNumbers:ye(new Le),lineNumbersMinChars:ye(new c(55,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new h(56,"linkedEditing",!1,{description:_.localize(165,null)})),links:ye(new h(57,"links",!0,{description:_.localize(166,null)})),matchBrackets:ye(new w(58,"matchBrackets","always",["always","near","never"],{description:_.localize(167,null)})),minimap:ye(new N),mouseStyle:ye(new w(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new m(61,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:_.localize(168,null)})),mouseWheelZoom:ye(new h(62,"mouseWheelZoom",!1,{markdownDescription:_.localize(169,null)})),multiCursorMergeOverlapping:ye(new h(63,"multiCursorMergeOverlapping",!0,{description:_.localize(170,null)})),multiCursorModifier:ye(new d(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(171,null),_.localize(172,null)],markdownDescription:_.localize(173,null)})),multiCursorPaste:ye(new w(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(174,null),_.localize(175,null)],markdownDescription:_.localize(176,null)})),occurrencesHighlight:ye(new h(66,"occurrencesHighlight",!0,{description:_.localize(177,null)})),overviewRulerBorder:ye(new h(67,"overviewRulerBorder",!0,{description:_.localize(178,null)})),overviewRulerLanes:ye(new c(68,"overviewRulerLanes",3,0,3)),padding:ye(new V),parameterHints:ye(new q),peekWidgetDefaultFocus:ye(new w(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(179,null),_.localize(180,null)],description:_.localize(181,null)})),definitionLinkOpensInPeek:ye(new h(72,"definitionLinkOpensInPeek",!1,{description:_.localize(182,null)})),quickSuggestions:ye(new fe),quickSuggestionsDelay:ye(new c(74,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(183,null)})),readOnly:ye(new h(75,"readOnly",!1)),renameOnType:ye(new h(76,"renameOnType",!1,{description:_.localize(184,null),markdownDeprecationMessage:_.localize(185,null)})),renderControlCharacters:ye(new h(77,"renderControlCharacters",!1,{description:_.localize(186,null)})),renderIndentGuides:ye(new h(78,"renderIndentGuides",!0,{description:_.localize(187,null)})),renderFinalNewline:ye(new h(79,"renderFinalNewline",!0,{description:_.localize(188,null)})),renderLineHighlight:ye(new w(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(189,null)],description:_.localize(190,null)})),renderLineHighlightOnlyWhenFocus:ye(new h(81,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(191,null)})),renderValidationDecorations:ye(new w(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new w(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(192,null),_.localize(193,null),_.localize(194,null),""],description:_.localize(195,null)})),revealHorizontalRightPadding:ye(new c(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new h(85,"roundedSelection",!0,{description:_.localize(196,null)})),rulers:ye(new Fe),scrollbar:ye(new X),scrollBeyondLastColumn:ye(new c(88,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(197,null)})),scrollBeyondLastLine:ye(new h(89,"scrollBeyondLastLine",!0,{description:_.localize(198,null)})),scrollPredominantAxis:ye(new h(90,"scrollPredominantAxis",!0,{description:_.localize(199,null)})),selectionClipboard:ye(new h(91,"selectionClipboard",!0,{description:_.localize(200,null),included:y.isLinux})),selectionHighlight:ye(new h(92,"selectionHighlight",!0,{description:_.localize(201,null)})),selectOnLineNumbers:ye(new h(93,"selectOnLineNumbers",!0)),showFoldingControls:ye(new w(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(202,null),_.localize(203,null)],description:_.localize(204,null)})),showUnused:ye(new h(95,"showUnused",!0,{description:_.localize(205,null)})),showDeprecated:ye(new h(119,"showDeprecated",!0,{description:_.localize(206,null)})),inlineHints:ye(new U),snippetSuggestions:ye(new w(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(207,null),_.localize(208,null),_.localize(209,null),_.localize(210,null)],description:_.localize(211,null)})),smartSelect:ye(new ae),smoothScrolling:ye(new h(98,"smoothScrolling",!1,{description:_.localize(212,null)})),stopRenderingLineAfter:ye(new c(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new te),suggestFontSize:ye(new c(102,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(213,null)})),suggestLineHeight:ye(new c(103,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestOnTriggerCharacters:ye(new h(104,"suggestOnTriggerCharacters",!0,{description:_.localize(215,null)})),suggestSelection:ye(new w(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(216,null),_.localize(217,null),_.localize(218,null)],description:_.localize(219,null)})),tabCompletion:ye(new w(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(220,null),_.localize(221,null),_.localize(222,null)],description:_.localize(223,null)})),tabIndex:ye(new c(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new w(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(224,null),_.localize(225,null),_.localize(226,null)],description:_.localize(227,null)})),useTabStops:ye(new h(109,"useTabStops",!0,{description:_.localize(228,null)})),wordSeparators:ye(new E(110,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:_.localize(229,null)})),wordWrap:ye(new w(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(230,null),_.localize(231,null),_.localize(232,null),_.localize(233,null)],description:_.localize(234,null)})),wordWrapBreakAfterCharacters:ye(new E(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new E(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new c(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(235,null)})),wordWrapOverride1:ye(new w(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new w(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new d(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(236,null),_.localize(237,null),_.localize(238,null),_.localize(239,null)],description:_.localize(240,null)})),wrappingStrategy:ye(new w(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(241,null),_.localize(242,null)],description:_.localize(243,null)})),editorClassName:ye(new p),pixelRatio:ye(new Q),tabFocusMode:ye(new ve),layoutInfo:ye(new $),wrappingInfo:ye(new we)}}),define(ge[150],pe([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[151],pe([18,19]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[152],pe([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ge[153],pe([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ge[154],pe([18,19]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[155],pe([18,19]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[156],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[157],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[158],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[159],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([18,19]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([18,19]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(ge[167],pe([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[168],pe([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[169],pe([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[170],pe([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[171],pe([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[172],pe([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[173],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var y;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(y=e.EditorOverride||(e.EditorOverride={}));var R;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[108],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(P,D=[],A=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=_;const y=(R,...P)=>new _(R,P);e.createSyncDescriptor=y}),define(ge[78],pe([0,1,108]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const y=[];function R(D,A,C){A instanceof _.SyncDescriptor||(A=new _.SyncDescriptor(A,[],C)),y.push([D,A])}e.registerSingleton=R;function P(){return y}e.getSingletonServiceDescriptors=P}),define(ge[174],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=_;class y{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let D of this._nodes.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const A=this.lookupOrInsertNode(P),C=this.lookupOrInsertNode(D);A.outgoing.set(this._hashFn(D),C),C.incoming.set(this._hashFn(P),A)}removeNode(P){const D=this._hashFn(P);this._nodes.delete(D);for(let A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(P){const D=this._hashFn(P);let A=this._nodes.get(D);return A||(A=new _(P),this._nodes.set(D,A)),A}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[D,A]of this._nodes)P.push(`${D}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=y}),define(ge[4],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function C(n){return n[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=C})(_=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function y(A,C,n,T){C[_.DI_TARGET]===C?C[_.DI_DEPENDENCIES].push({id:A,index:n,optional:T}):(C[_.DI_DEPENDENCIES]=[{id:A,index:n,optional:T}],C[_.DI_TARGET]=C)}function R(A){if(_.serviceIds.has(A))return _.serviceIds.get(A);const C=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(C,n,k,!1)};return C.toString=()=>A,_.serviceIds.set(A,C),C}e.createDecorator=R;function P(A){return A}e.refineServiceDecorator=P;function D(A){return function(C,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");y(A,C,T,!0)}}e.optional=D}),define(ge[175],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function y(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=y}),define(ge[176],pe([0,1,3,73,6,23,72,76,175]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(h,c){let m={selector:h,provider:c,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(m){let E=this._entries.indexOf(m);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const c=[];for(let m of this._entries)m._score>0&&c.push(m.provider);return c}ordered(h){const c=[];return this._orderedForEach(h,m=>c.push(m.provider)),c}orderedGroups(h){const c=[];let m,E;return this._orderedForEach(h,g=>{m&&E===g._score?m.push(g.provider):(E=g._score,m=[g.provider],c.push(m))}),c}_orderedForEach(h,c){if(!!h){this._updateScores(h);for(const m of this._entries)m._score>0&&c(m)}}_updateScores(h){let c={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let m of this._entries)if(m._score=(0,A.score)(m.selector,h.uri,h.getLanguageIdentifier().language,(0,C.shouldSynchronizeModel)(h)),n(m.selector)&&m._score>0){for(let E of this._entries)E._score=0;m._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(h,c){return h._score<c._score?1:h._score>c._score?-1:h._time<c._time?1:h._time>c._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(h,c,m=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=c,this.max=m,this._cache=new P.LRUCache(50,.7)}_key(h){return h.id+(0,y.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const c=this._key(h),m=this._cache.get(c);return this._clamp(m==null?void 0:m.value)}update(h,c){const m=this._key(h);let E=this._cache.get(m);return E||(E=new D.MovingAverage,this._cache.set(m,E)),E.update(c),this.get(h)}}e.LanguageFeatureRequestDelays=k}),define(ge[79],pe([0,1,2,43,176,141,47]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var A;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));class C{constructor(v,I){this.language=v,this.id=I}}e.LanguageIdentifier=C;var n;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let I=this.getForeground(v),L="mtk"+I,x=this.getFontStyle(v);return x&1&&(L+=" mtki"),x&2&&(L+=" mtkb"),x&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(v,I){const L=this.getForeground(v),x=this.getFontStyle(v);let Z=`color: ${I[L]};`;return x&1&&(Z+="font-style: italic;"),x&2&&(Z+="font-weight: bold;"),x&4&&(Z+="text-decoration: underline;"),Z}}e.TokenMetadata=h;var c;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(v){const I=f[v];let L=I&&D.iconRegistry.get(I);return L||(console.info("No codicon found for CompletionItemKind "+v),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(v,I){let L=f[v];return typeof L=="undefined"&&!I&&(L=9),L}}();var m;(function(f){f[f.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(f){return f&&_.URI.isUri(f.uri)&&y.Range.isIRange(f.range)&&(y.Range.isIRange(f.originSelectionRange)||y.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=a;var t;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(f){f[f.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(f){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function L(z){return v.get(z)}f.fromString=L;function x(z){return I.get(z)}f.toString=x;function Z(z,B){const $=I.get(z);let M=$&&D.iconRegistry.get("symbol-"+$);return M||(console.info("No codicon found for SymbolKind "+z),M=D.Codicon.symbolProperty),`${B?"inline":"block"} ${M.classNames}`}f.toCssClassName=Z})(o=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(v){this.value=v}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var r;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var p;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var S;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[177],pe([0,1,6,15,4,3,56,71]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(C,n){if(!C)throw new Error("invalid command");if(typeof C=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:C,handler:n})}if(C.description){const c=[];for(let E of C.description.args)c.push(E.constraint);const m=C.handler;C.handler=function(E,...g){return(0,y.validateConstraints)(g,c),m(E,...g)}}const{id:T}=C;let k=this._commands.get(T);k||(k=new D.LinkedList,this._commands.set(T,k));let b=k.unshift(C),h=(0,_.toDisposable)(()=>{b();const c=this._commands.get(T);(c==null?void 0:c.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),h}registerCommandAlias(C,n){return e.CommandsRegistry.registerCommand(C,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(C){const n=this._commands.get(C);if(!(!n||n.isEmpty()))return A.Iterable.first(n)}getCommands(){const C=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&C.set(n,T)}return C}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],pe([0,1,10,4,9]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=R.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",R.isMacintosh),D.set("isLinux",R.isLinux),D.set("isWindows",R.isWindows),D.set("isWeb",R.isWeb),D.set("isMacNative",R.isMacintosh&&!R.isWeb),D.set("isEdge",P.indexOf("Edg/")>=0),D.set("isFirefox",P.indexOf("Firefox")>=0),D.set("isChrome",P.indexOf("Chrome")>=0),D.set("isSafari",P.indexOf("Safari")>=0),D.set("isIPad",P.indexOf("iPad")>=0);const A=Object.prototype.hasOwnProperty;var C;(function(f){f[f.False=0]="False",f[f.True=1]="True",f[f.Defined=2]="Defined",f[f.Not=3]="Not",f[f.Equals=4]="Equals",f[f.NotEquals=5]="NotEquals",f[f.And=6]="And",f[f.Regex=7]="Regex",f[f.NotRegex=8]="NotRegex",f[f.Or=9]="Or",f[f.In=10]="In",f[f.NotIn=11]="NotIn",f[f.Greater=12]="Greater",f[f.GreaterEquals=13]="GreaterEquals",f[f.Smaller=14]="Smaller",f[f.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return b.INSTANCE}static has(v){return h.create(v)}static equals(v,I){return c.create(v,I)}static notEquals(v,I){return g.create(v,I)}static regex(v,I){return i.create(v,I)}static in(v,I){return m.create(v,I)}static not(v){return w.create(v)}static and(...v){return s.create(v)}static or(...v){return r.create(v)}static greater(v,I){return d.create(v,I)}static less(v,I){return a.create(v,I)}static deserialize(v,I=!1){if(!!v)return this._deserializeOrExpression(v,I)}static _deserializeOrExpression(v,I){let L=v.split("||");return r.create(L.map(x=>this._deserializeAndExpression(x,I)))}static _deserializeAndExpression(v,I){let L=v.split("&&");return s.create(L.map(x=>this._deserializeOne(x,I)))}static _deserializeOne(v,I){if(v=v.trim(),v.indexOf("!=")>=0){let L=v.split("!=");return g.create(L[0].trim(),this._deserializeValue(L[1],I))}if(v.indexOf("==")>=0){let L=v.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],I))}if(v.indexOf("=~")>=0){let L=v.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],I))}if(v.indexOf(" in ")>=0){let L=v.split(" in ");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const L=v.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const L=v.split(">");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const L=v.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const L=v.split("<");return a.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(v)?w.create(v.substr(1).trim()):h.create(v)}static _deserializeValue(v,I){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let L=/^'([^']*)'$/.exec(v);return L?L[1].trim():v}static _deserializeRegexValue(v,I){if((0,_.isFalsyOrWhitespace)(v)){if(I)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=v.indexOf("/"),x=v.lastIndexOf("/");if(L===x||L<0){if(I)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let Z=v.slice(L+1,x),z=v[x+1]==="i"?"i":"";try{return new RegExp(Z,z)}catch(B){if(I)throw new Error(`bad regexp-value '${v}', parse error: ${B}`);return console.warn(`bad regexp-value '${v}', parse error: ${B}`),null}}}e.ContextKeyExpr=n;function T(f,v){return f.cmp(v)}class k{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class b{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class h{constructor(v){this.key=v,this.type=2}static create(v){const I=D.get(v);return typeof I=="boolean"?I?b.INSTANCE:k.INSTANCE:new h(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=h;class c{constructor(v,I){this.key=v,this.value=I,this.type=4}static create(v,I){if(typeof I=="boolean")return I?h.create(v):w.create(v);const L=D.get(v);return typeof L=="boolean"?I===(L?"true":"false")?b.INSTANCE:k.INSTANCE:new c(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class m{constructor(v,I){this.key=v,this.valueKey=I,this.type=10}static create(v,I){return new m(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const I=v.getValue(this.valueKey),L=v.getValue(this.key);return Array.isArray(I)?I.indexOf(L)>=0:typeof L=="string"&&typeof I=="object"&&I!==null?A.call(I,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=m;class E{constructor(v){this._actual=v,this.type=11}static create(v){return new E(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new E(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class g{constructor(v,I){this.key=v,this.value=I,this.type=5}static create(v,I){if(typeof I=="boolean")return I?w.create(v):h.create(v);const L=D.get(v);return typeof L=="boolean"?I===(L?"true":"false")?k.INSTANCE:b.INSTANCE:new g(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class w{constructor(v){this.key=v,this.type=3}static create(v){const I=D.get(v);return typeof I=="boolean"?I?k.INSTANCE:b.INSTANCE:new w(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=w;class d{constructor(v,I){this.key=v,this.value=I,this.type=12}static create(v,I){return new d(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class u{constructor(v,I){this.key=v,this.value=I,this.type=13}static create(v,I){return new u(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(v,I){this.key=v,this.value=I,this.type=14}static create(v,I){return new a(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(v,I){this.key=v,this.value=I,this.type=15}static create(v,I){return new t(v,I)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(v,I){this.key=v,this.regexp=I,this.type=7}static create(v,I){return new i(v,I)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const I=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return I<L?-1:I>L?1:0}equals(v){if(v.type===this.type){const I=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return this.key===v.key&&I===L}return!1}evaluate(v){let I=v.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(v){this._actual=v,this.type=8}static create(v){return new o(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new o(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class s{constructor(v){this.expr=v,this.type=6}static create(v){return s._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const x=T(this.expr[I],v.expr[I]);if(x!==0)return x}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(v.expr[I]))return!1;return!0}return!1}evaluate(v){for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].evaluate(v))return!1;return!0}static _normalizeArr(v){const I=[];let L=!1;for(const x of v)if(!!x){if(x.type===1){L=!0;continue}if(x.type===0)return k.INSTANCE;if(x.type===6){I.push(...x.expr);continue}I.push(x)}if(I.length===0&&L)return b.INSTANCE;if(I.length!==0){if(I.length===1)return I[0];for(I.sort(T);I.length>1;){const x=I[I.length-1];if(x.type!==9)break;I.pop();const Z=I.pop(),z=r.create(x.expr.map(B=>s.create([B,Z])));z&&(I.push(z),I.sort(T))}return I.length===1?I[0]:new s(I)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let I of this.expr)v.push(...I.keys());return v}map(v){return new s(this.expr.map(I=>I.map(v)))}negate(){let v=[];for(let I of this.expr)v.push(I.negate());return r.create(v)}}e.ContextKeyAndExpr=s;class r{constructor(v){this.expr=v,this.type=9}static create(v){const I=r._normalizeArr(v);if(I.length!==0)return I.length===1?I[0]:new r(I)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const x=T(this.expr[I],v.expr[I]);if(x!==0)return x}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(v.expr[I]))return!1;return!0}return!1}evaluate(v){for(let I=0,L=this.expr.length;I<L;I++)if(this.expr[I].evaluate(v))return!0;return!1}static _normalizeArr(v){let I=[],L=!1;if(v){for(let x=0,Z=v.length;x<Z;x++){const z=v[x];if(!!z){if(z.type===0){L=!0;continue}if(z.type===1)return[b.INSTANCE];if(z.type===9){I=I.concat(z.expr);continue}I.push(z)}}if(I.length===0&&L)return[k.INSTANCE];I.sort(T)}return I}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let I of this.expr)v.push(...I.keys());return v}map(v){return new r(this.expr.map(I=>I.map(v)))}negate(){let v=[];for(let L of this.expr)v.push(L.negate());const I=L=>L.type===9?L.expr:[L];for(;v.length>1;){const L=v.shift(),x=v.shift(),Z=[];for(const z of I(L))for(const B of I(x))Z.push(n.and(z,B));v.unshift(n.or(...Z))}return v[0]}}e.ContextKeyOrExpr=r;class l extends h{constructor(v,I,L){super(v);this.key=v,this._defaultValue=I,typeof L=="object"?l._info.push(Object.assign(Object.assign({},L),{key:v})):L!==!0&&l._info.push({key:v,description:L,type:I!=null?typeof I:void 0})}static all(){return l._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(v){return n.equals(this.key,v)}notEqualsTo(v){return n.notEquals(this.key,v)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(f,v){return f<v?-1:f>v?1:0}function S(f,v,I,L){return f<I?-1:f>I?1:v<L?-1:v>L?1:0}}),define(ge[178],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[179],pe([0,1,151,4,11]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=P;var D;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var A;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var C;(function(k){k.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var n;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(b,h){super(b);this.code=h}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,10,4]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class D{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let b=typeof T=="string"?T:T.value,h=typeof k=="string"?k:k.value;return _.equalsIgnoreCase(b,h)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=D;function A(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[180],pe([0,1,10,29]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:(0,_.compareIgnoreCase)(h.id,c.id)===0}e.areSameExtensions=R;class P{constructor(c,m){this.version=m,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof P?R(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=P;function D(h,c){return`${h}.${c}`}e.getExtensionId=D;function A(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function C(h,c){return A(D(h,c))}e.getGalleryExtensionId=C;function n(h,c){const m=[],E=g=>{for(const w of m)if(w.some(d=>R(c(d),c(g))))return w;return null};for(const g of h){const w=E(g);w?w.push(g):m.push([g])}return m}e.groupByExtension=n;function T(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function b(h){const c=new Set;for(const m of h)m.malicious&&c.add(m.id.id);return c}e.getMaliciousExtensionsSet=b}),define(ge[44],pe([0,1,152,7,2,4,10,15,23]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(z){return z.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=b;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function c(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function m(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=m;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(B,$){super(B);this.code=$}}e.FileSystemProviderError=g;function w(z,B){const $=new g(z.toString(),B);return u($,B),$}e.createFileSystemProviderError=w;function d(z){return z||w((0,_.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=d;function u(z,B){return z.name=B?`${B} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=u;function a(z){if(!z)return E.Unknown;if(z instanceof g)return z.code;const B=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!B)return E.Unknown;switch(B[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=a;function t(z){if(z instanceof p)return z.fileOperationResult;switch(a(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(B,$,M){this.resource=B,this.operation=$,this.target=M}isOperation(B){return this.operation===B}}e.FileOperationEvent=o;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class r{constructor(B,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const M of B)switch(M.type){case 1:this.added||(this.added=C.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=C.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=C.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(B,...$){return this.doContains(B,{includeChildren:!1},...$)}affects(B,...$){return this.doContains(B,{includeChildren:!0},...$)}doContains(B,$,...M){var U,F,N,O,V,q;if(!B)return!1;const Q=M.length>0;return!!((!Q||M.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(B))||$.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!Q||M.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(B))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(B)))||(!Q||M.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(B))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const $=[],M=B===1?this.added:B===0?this.updated:this.deleted;if(M)for(const[,U]of M)$.push(U);return $}filter(B){return new r(this.changes.filter($=>B($)),this.ignorePathCasing)}}e.FileChangesEvent=r;function l(z,B,$){return!z||!B||z===B||B.length>z.length?!1:(B.charAt(B.length-1)!==y.sep&&(B+=y.sep),$?(0,D.startsWithIgnoreCase)(z,B):z.indexOf(B)===0)}e.isParent=l;class p extends Error{constructor(B,$,M){super(B);this.fileOperationResult=$,this.options=M}static isFileOperationError(B){return B instanceof Error&&!(0,A.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=p;var S;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var f;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(f=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=v;async function I(z,B){if(!B.canHandleResource(R.URI.from({scheme:z.scheme})))return new Promise($=>{const M=B.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===z.scheme&&U.added&&(M.dispose(),$())})})}e.whenProviderRegistered=I,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(B){return(0,A.isNumber)(B)||(B=0),B<L.KB?(0,_.localize)(1,null,B.toFixed(0)):B<L.MB?(0,_.localize)(2,null,(B/L.KB).toFixed(2)):B<L.GB?(0,_.localize)(3,null,(B/L.MB).toFixed(2)):B<L.TB?(0,_.localize)(4,null,(B/L.GB).toFixed(2)):(0,_.localize)(5,null,(B/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var x;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function Z(z){return{maxFileSize:z===0?300*L.MB:16*L.GB,maxHeapSize:z===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=Z}),define(ge[81],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...R){this._entries=new Map;for(let[P,D]of R)this.set(P,D)}set(R,P){const D=this._entries.get(R);return this._entries.set(R,P),D}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=_}),define(ge[181],pe([0,1,16,174,108,4,81,17]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class n extends Error{constructor(c){super("cyclic dependency between services");this.message=c.toString()}}class T{constructor(c=new D.ServiceCollection,m=!1,E){this._activeInstantiations=new Set,this._services=c,this._strict=m,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(c){return new T(c,this._strict,this)}invokeFunction(c,...m){let E=b.traceInvocation(c),g=!1;try{return c({get:(d,u)=>{if(g)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(d,E);if(!a&&u!==P.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return a}},...m)}finally{g=!0,E.stop()}}createInstance(c,...m){let E,g;return c instanceof R.SyncDescriptor?(E=b.traceCreation(c.ctor),g=this._createInstance(c.ctor,c.staticArguments.concat(m),E)):(E=b.traceCreation(c),g=this._createInstance(c,m,E)),E.stop(),g}_createInstance(c,m=[],E){let g=P._util.getServiceDependencies(c).sort((u,a)=>u.index-a.index),w=[];for(const u of g){let a=this._getOrCreateServiceInstance(u.id,E);if(!a&&this._strict&&!u.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${u.id}.`);w.push(a)}let d=g.length>0?g[0].index:m.length;if(m.length!==d){console.warn(`[createInstance] First service dependency of ${c.name} at position ${d+1} conflicts with ${m.length} static arguments`);let u=d-m.length;u>0?m=m.concat(new Array(u)):m=m.slice(0,d)}return new c(...[...m,...w])}_setServiceInstance(c,m){if(this._services.get(c)instanceof R.SyncDescriptor)this._services.set(c,m);else if(this._parent)this._parent._setServiceInstance(c,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let m=this._services.get(c);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):m}_getOrCreateServiceInstance(c,m){let E=this._getServiceInstanceOrDescriptor(c);return E instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,E,m.branch(c,!0)):(m.branch(c,!1),E)}_safeCreateAndCacheServiceInstance(c,m,E){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,m,E)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,m,E){const g=new y.Graph(u=>u.id.toString());let w=0;const d=[{id:c,desc:m,_trace:E}];for(;d.length;){const u=d.pop();if(g.lookupOrInsertNode(u),w++>1e3)throw new n(g);for(let a of P._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const i={id:a.id,desc:t,_trace:u._trace.branch(a.id,!0)};g.insertEdge(u,i),d.push(i)}}}for(;;){const u=g.roots();if(u.length===0){if(!g.isEmpty())throw new n(g);break}for(const{data:a}of u){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,i)}g.removeNode(a)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,m,E=[],g,w){if(this._services.get(c)instanceof R.SyncDescriptor)return this._createServiceInstance(m,E,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,m,E,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(c,m=[],E,g){if(E){const w=new A.IdleValue(()=>this._createInstance(c,m,g));return new Proxy(Object.create(null),{get(d,u){if(u in d)return d[u];let a=w.value,t=a[u];return typeof t!="function"||(t=t.bind(a),d[u]=t),t},set(d,u,a){return w.value[u]=a,!0}})}else return this._createInstance(c,m,g)}}e.InstantiationService=T;var k;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(k||(k={}));class b{constructor(c,m){this.type=c,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return C?new b(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(c){return C?new b(0,c.name):b._None}branch(c,m){let E=new b(2,c.toString());return this._dep.push([c,m,E]),E}stop(){let c=Date.now()-this._start;b._totals+=c;let m=!1;function E(w,d){let u=[],a=new Array(w+1).join("	");for(const[t,i,o]of d._dep)if(i&&o){m=!0,u.push(`${a}CREATES -> ${t}`);let s=E(w+1,o);s&&u.push(s)}else u.push(`${a}uses -> ${t}`);return u.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(c>2||m)&&console.log(g.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(ge[13],pe([0,1,4,6,9,3,59]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var C;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;class n extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,this.format([a,...t]))}debug(a,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,this.format([a,...t]))}info(a,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,this.format([a,...t]))}warn(a,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,this.format([a,...t]))}error(a,...t){if(this.checkLogLevel(C.Error))if(a instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=a.stack,this.log(C.Error,this.format(i))}else this.log(C.Error,this.format([a,...t]))}critical(a,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,this.format([a,...t]))}flush(){}format(a){let t="";for(let i=0;i<a.length;i++){let o=a[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(s){}t+=(i>0?" ":"")+o}return t}}e.AbstractMessageLogger=T;class k extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!R.isWindows}trace(a,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,a,...t):console.log(`[main ${A()}]`,a,...t))}debug(a,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,a,...t):console.log(`[main ${A()}]`,a,...t))}info(a,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,a,...t):console.log(`[main ${A()}]`,a,...t))}warn(a,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,a,...t):console.warn(`[main ${A()}]`,a,...t))}error(a,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,a,...t):console.error(`[main ${A()}]`,a,...t))}critical(a,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,a,...t):console.error(`[main ${A()}]`,a,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class b extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",a,...t)}debug(a,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...t)}info(a,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",a,...t)}warn(a,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",a,...t)}error(a,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",a,...t)}critical(a,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class h extends n{constructor(a,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(t)}trace(a,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(a),...t])}debug(a,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(a),...t])}info(a,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(a),...t])}warn(a,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(a),...t])}error(a,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(a),...t])}critical(a,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(a),...t])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends n{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const t of this.logServices)t.setLevel(a);super.setLevel(a)}trace(a,...t){for(const i of this.logServices)i.trace(a,...t)}debug(a,...t){for(const i of this.logServices)i.debug(a,...t)}info(a,...t){for(const i of this.logServices)i.info(a,...t)}warn(a,...t){for(const i of this.logServices)i.warn(a,...t)}error(a,...t){for(const i of this.logServices)i.error(a,...t)}critical(a,...t){for(const i of this.logServices)i.critical(a,...t)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=c;class m extends y.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...t){this.logger.trace(a,...t)}debug(a,...t){this.logger.debug(a,...t)}info(a,...t){this.logger.info(a,...t)}warn(a,...t){this.logger.warn(a,...t)}error(a,...t){this.logger.error(a,...t)}critical(a,...t){this.logger.critical(a,...t)}flush(){this.logger.flush()}}e.LogService=m;class E{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...t){}debug(a,...t){}info(a,...t){}warn(a,...t){}error(a,...t){}critical(a,...t){}dispose(){}flush(){}}e.NullLogService=E;function g(u){if(u.verbose)return C.Trace;if(typeof u.logLevel=="string"){const a=w(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function w(u){switch(u){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=w;function d(u){switch(u){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=d}),define(ge[109],pe([0,1,13,44]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(C,n,T,k){try{const b=await new Promise((h,c)=>{Y(["spdlog"],h,c)});return b.setAsyncMode(8192,500),b.createRotatingLoggerAsync(C,n,T,k)}catch(b){console.error(b)}return null}function P(C,n,T,k){return Y.__$__nodeRequire("spdlog").createRotatingLogger(C,n,T,k)}e.createRotatingLogger=P;function D(C,n,T){switch(n){case _.LogLevel.Trace:C.trace(T);break;case _.LogLevel.Debug:C.debug(T);break;case _.LogLevel.Info:C.info(T);break;case _.LogLevel.Warning:C.warn(T);break;case _.LogLevel.Error:C.error(T);break;case _.LogLevel.Critical:C.critical(T);break;default:throw new Error("Invalid log level")}}class A extends _.AbstractMessageLogger{constructor(n,T,k,b){super();this.name=n,this.filepath=T,this.rotating=k,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const n=this.rotating?6:1,T=30/n*y.ByteSize.MB;return R(this.name,this.filepath,T,n).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:b,message:h}of this.buffer)D(this._logger,b,h);this.buffer=[]}})}log(n,T){this._logger?D(this._logger,n,T):this.getLevel()<=n&&this.buffer.push({level:n,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=A}),define(ge[110],pe([0,1,4,153,57]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var D;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function n(c,m){return m-c}C.compare=n;const T=Object.create(null);T[C.Error]=(0,y.localize)(0,null),T[C.Warning]=(0,y.localize)(1,null),T[C.Info]=(0,y.localize)(2,null);function k(c){return T[c]||""}C.toString=k;function b(c){switch(c){case R.default.Error:return C.Error;case R.default.Warning:return C.Warning;case R.default.Info:return C.Info;case R.default.Ignore:return C.Hint}}C.fromSeverity=b;function h(c){switch(c){case C.Error:return R.default.Error;case C.Warning:return R.default.Warning;case C.Info:return R.default.Info;case C.Hint:return R.default.Ignore}}C.toSeverity=h}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(C){const n="";function T(b){return k(b,!0)}C.makeKey=T;function k(b,h){let c=[n];return b.source?c.push(b.source.replace("\xA6","\\\xA6")):c.push(n),b.code?typeof b.code=="string"?c.push(b.code.replace("\xA6","\\\xA6")):c.push(b.code.value.replace("\xA6","\\\xA6")):c.push(n),b.severity!==void 0&&b.severity!==null?c.push(D.toString(b.severity)):c.push(n),b.message&&h?c.push(b.message.replace("\xA6","\\\xA6")):c.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?c.push(b.startLineNumber.toString()):c.push(n),b.startColumn!==void 0&&b.startColumn!==null?c.push(b.startColumn.toString()):c.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?c.push(b.endLineNumber.toString()):c.push(n),b.endColumn!==void 0&&b.endColumn!==null?c.push(b.endColumn.toString()):c.push(n),c.push(n),c.join("\xA6")}C.makeKeyOptionalMessage=k})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[182],pe([0,1,57,4,3]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,y.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new C,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=A;class C{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=C}),define(ge[183],pe([0,1,11,9,30,24]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(y.isWeb||typeof Y=="undefined"||typeof Y.__$__nodeRequire!="function")D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.55.0-dev",nameShort:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const A=(0,P.dirname)(_.FileAccess.asFileUri("",Y));D=Y.__$__nodeRequire((0,P.joinPath)(A,"product.json").fsPath);const C=Y.__$__nodeRequire((0,P.joinPath)(A,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:C.version})}e.default=D});var je=this&&this.__decorate||function(Y,e,_,y){var R=arguments.length,P=R<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,_):y,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Y,e,_,y);else for(var A=Y.length-1;A>=0;A--)(D=Y[A])&&(P=(R<3?D(P):R>3?D(e,_,P):D(e,_))||P);return R>3&&P&&Object.defineProperty(e,_,P),P},Ue=this&&this.__param||function(Y,e){return function(_,y){e(_,y,Y)}};define(ge[111],pe([0,1,4,21,6,17]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var D;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let C=class extends R.Disposable{constructor(k,b){super();this.deferred=new P.DeferredPromise,b.withProgress(k,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,R.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};C=je([Ue(1,e.IProgressService)],C),e.UnmanagedProgress=C;class n extends R.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(k){this.stop();const b=++this.currentOperationId,h=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:h.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,15,52]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(D,A){y.ok(_.isString(D)),y.ok(_.isObject(A)),y.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new R}),define(ge[112],pe([0,1,40,3]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,n){this.schemasById[R(C)]=n,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new P;_.Registry.add(e.Extensions.JSONContribution,D)}),define(ge[82],pe([0,1,150,3,40,15,112]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=R.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,w=!0){this.registerConfigurations([g],w)}registerConfigurations(g,w=!0){const d=[];g.forEach(u=>{d.push(...this.validateAndRegisterProperties(u,w)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(g){const w=[],d=u=>{if(u.properties)for(const a in u.properties)w.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,u.properties[a]);u.allOf&&u.allOf.forEach(a=>d(a))};for(const u of g){d(u);const a=this.configurationContributors.indexOf(u);a!==-1&&this.configurationContributors.splice(a,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(g){const w=[],d=[];for(const u of g)for(const a in u)if(w.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),u[a]);const t={type:"object",default:this.defaultValues[a],description:_.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};d.push(k(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=u[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(g){const w=[];for(const d of g)for(const u in d)if(w.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const w of g)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,w=!0,d=3){d=P.isUndefinedOrNull(g.scope)?d:g.scope;let u=[],a=g.properties;if(a)for(let i in a){if(w&&c(i)){delete a[i];continue}const o=a[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:o.scope=P.isUndefinedOrNull(o.scope)?d:o.scope,a[i].hasOwnProperty("included")&&!a[i].included){this.excludedConfigurationProperties[i]=a[i],delete a[i];continue}else this.configurationProperties[i]=a[i];!a[i].deprecationMessage&&a[i].markdownDeprecationMessage&&(a[i].deprecationMessage=a[i].markdownDeprecationMessage),u.push(i)}let t=g.allOf;if(t)for(let i of t)u.push(...this.validateAndRegisterProperties(i,w,d));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const w=d=>{let u=d.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let a=d.allOf;a&&a.forEach(w)};w(g)}updateSchema(g,w){switch(e.allSettings.properties[g]=w,w.scope){case 1:e.applicationSettings.properties[g]=w;break;case 2:e.machineSettings.properties[g]=w;break;case 6:e.machineOverridableSettings.properties[g]=w;break;case 3:e.windowSettings.properties[g]=w;break;case 4:e.resourceSettings.properties[g]=w;break;case 5:e.resourceSettings.properties[g]=w,this.resourceLanguageSettingsSchema.properties[g]=w;break}}removeFromSchema(g,w){switch(delete e.allSettings.properties[g],w.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const w=`[${g}]`,d={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,d),e.allSettings.properties[w]=d,e.applicationSettings.properties[w]=d,e.machineSettings.properties[w]=d,e.machineOverridableSettings.properties[w]=d,e.windowSettings.properties[w]=d,e.resourceSettings.properties[w]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,w){let d=this.defaultValues[g];P.isUndefined(d)&&(d=w.default),P.isUndefined(d)&&(d=b(w.type)),w.default=d}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=k;function b(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const h=new n;R.Registry.add(e.Extensions.Configuration,h);function c(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?_.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?_.localize(6,null,E):null:_.localize(4,null)}e.validateProperty=c;function m(){const E=[],g=h.getConfigurationProperties();for(const w of Object.keys(g))E.push([w,g[w].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=m}),define(ge[83],pe([0,1,22,15,2,40,4,82]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=C;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,o){const s=o?i?o.keys.filter(I=>i.keys.indexOf(I)===-1):[...o.keys]:[],r=i?o?i.keys.filter(I=>o.keys.indexOf(I)===-1):[...i.keys]:[],l=[];if(o&&i){for(const I of i.keys)if(o.keys.indexOf(I)!==-1){const L=g(i.contents,I),x=g(o.contents,I);_.equals(L,x)||l.push(I)}}const p=[],S=I=>{const L={};for(const x of I)for(const Z of x.identifiers)L[a(Z)]=x;return L},f=o?S(o.overrides):{},v=i?S(i.overrides):{};if(Object.keys(f).length)for(const I of s){const L=f[I];L&&p.push([(0,A.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(v).length)for(const I of r){const L=v[I];L&&p.push([(0,A.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(f).length&&Object.keys(v).length)for(const I of l){const L=v[I],x=f[I];if(L&&x){const Z=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([(0,A.overrideIdentifierFromKey)(I),[...Z.added,...Z.removed,...Z.updated]])}}return{added:s,removed:r,updated:l,overrides:p}}e.compare=k;function b(i,o){const s=[];for(const r of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(r)){const l={};for(const p in i[r])l[p]=i[r][p];s.push({identifiers:[(0,A.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(l),contents:h(l,o)})}return s}e.toOverrides=b;function h(i,o){const s=Object.create(null);for(let r in i)c(s,r,i[r],o);return s}e.toValuesTree=h;function c(i,o,s,r){const l=o.split("."),p=l.pop();let S=i;for(let f=0;f<l.length;f++){let v=l[f],I=S[v];switch(typeof I){case"undefined":I=S[v]=Object.create(null);break;case"object":break;default:r(`Ignoring ${o} as ${l.slice(0,f+1).join(".")} is ${JSON.stringify(I)}`);return}S=I}if(typeof S=="object"&&S!==null)try{S[p]=s}catch(f){r(`Ignoring ${o} as ${l.join(".")} is ${JSON.stringify(S)}`)}else r(`Ignoring ${o} as ${l.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=c;function m(i,o){const s=o.split(".");E(i,s)}e.removeFromValueTree=m;function E(i,o){const s=o.shift();if(o.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const r=i[s];typeof r=="object"&&!Array.isArray(r)&&(E(r,o),Object.keys(r).length===0&&delete i[s])}}function g(i,o,s){function r(S,f){let v=S;for(const I of f){if(typeof v!="object"||v===null)return;v=v[I]}return v}const l=o.split("."),p=r(i,l);return typeof p=="undefined"?s:p}e.getConfigurationValue=g;function w(i,o,s){Object.keys(o).forEach(r=>{r!=="__proto__"&&(r in i?y.isObject(i[r])&&y.isObject(o[r])?w(i[r],o[r],s):s&&(i[r]=o[r]):i[r]=o[r])})}e.merge=w;function d(){const i=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=d;function u(){const i=Object.create(null),o=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let s in o){let r=o[s].default;c(i,s,r,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=u;function a(i){return`[${i}]`}e.keyFromOverrideIdentifier=a;function t(i,o,s){const r=i.inspect(o),l=i.inspect(s);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:r.defaultValue}e.getMigratedSettingValue=t}),define(ge[184],pe([0,1,55,23,12,15,22,2,82,83,40,6,3]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const s of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let r=this.contents[s],l=i[s];l&&(typeof r=="object"&&typeof l=="object"?(r=D.deepClone(r),this.mergeContents(r,l)):r=l),o[s]=r}return new h(o,this.keys,this.overrides)}merge(...t){const i=D.deepClone(this.contents),o=D.deepClone(this.overrides),s=[...this.keys];for(const r of t){this.mergeContents(i,r.contents);for(const l of r.overrides){const[p]=o.filter(S=>R.equals(S.identifiers,l.identifiers));p?this.mergeContents(p.contents,l.contents):o.push(D.deepClone(l))}for(const l of r.keys)s.indexOf(l)===-1&&s.push(l)}return new h(i,s,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&P.isObject(t[o])&&P.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=D.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),o=[];for(const s of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(s)&&o.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,n.toValuesTree)(t[s],r=>console.error(`Conflict in default settings file: ${r}`))});super(t,i,o)}}e.DefaultConfigurationModel=c;class m{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new h(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},o=null,s=[],r=[],l=[];function p(f){Array.isArray(s)?s.push(f):o&&(s[o]=f)}let S={onObjectBegin:()=>{let f={};p(f),r.push(s),s=f,o=null},onObjectProperty:f=>{o=f},onObjectEnd:()=>{s=r.pop()},onArrayBegin:()=>{let f=[];p(f),r.push(s),s=f,o=null},onArrayEnd:()=>{s=r.pop()},onLiteralValue:p,onError:(f,v,I)=>{l.push({error:f,offset:v,length:I})}};if(t)try{_.visit(t,S),i=s[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return i}doParseRaw(t){if(this._scopes){const r=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,r,!0,this._scopes)}const i=(0,n.toValuesTree)(t,r=>console.error(`Conflict in settings file ${this._name}: ${r}`)),o=Object.keys(t),s=(0,n.toOverrides)(t,r=>console.error(`Conflict in settings file ${this._name}: ${r}`));return{contents:i,keys:o,overrides:s}}filterByScope(t,i,o,s){const r={};for(let l in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(l)&&o)r[l]=this.filterByScope(t[l],i,!1,s);else{const p=this.getScope(l,i);(p===void 0||s.indexOf(p)!==-1)&&(r[l]=t[l])}return r}getScope(t,i){const o=i[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=m;class E extends k.Disposable{constructor(t,i,o,s){super();this.userSettingsResource=t,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(b.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new h}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=E;class g{constructor(t,i,o=new h,s=new h,r=new y.ResourceMap,l=new h,p=new y.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=r,this._memoryConfiguration=l,this._memoryConfigurationByResource=p,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new h,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(t):s.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const s=this.getConsolidateConfigurationModel(i,o),r=this.getFolderConfigurationModelForResource(i.resource,o),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),I=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=r?i.overrideIdentifier?r.freeze().override(i.overrideIdentifier).getValue(t):r.freeze().getValue(t):void 0,x=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),Z=s.getValue(t),z=R.distinct(R.flatten(s.overrides.map(B=>B.identifiers))).filter(B=>s.getOverrideValue(t,B)!==void 0);return{defaultValue:p,userValue:S,userLocalValue:f,userRemoteValue:v,workspaceValue:I,workspaceFolderValue:L,memoryValue:x,value:Z,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:r==null?void 0:r.freeze().getValue(t),override:i.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(s=>C.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const r=(0,C.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(r),p=t.getKeysForOverrideIdentifier(r),S=[...p.filter(f=>l.indexOf(f)===-1),...l.filter(f=>p.indexOf(f)===-1),...l.filter(f=>!D.equals(this._defaultConfiguration.override(r).getValue(f),t.override(r).getValue(f)))];return[r,S]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:s,overrides:r}=(0,n.compare)(this.localUserConfiguration,t),l=[...i,...o,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:s,overrides:r}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...i,...o,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:s,overrides:r}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...i,...o,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:r}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:s,updated:r,removed:l,overrides:p}=(0,n.compare)(o,i);let S=[...s,...r,...l];return(S.length||!o)&&this.updateFolderConfiguration(t,i),{keys:S,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:s,removed:r,overrides:l}=(0,n.compare)(i,void 0);return{keys:[...o,...s,...r],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const s=i.getFolder(t);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const r=this._memoryConfigurationByResource.get(t);r&&(o=o.merge(r))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(i=o.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:s,keys:r}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:s,keys:r}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),r=t.folders.reduce((l,p)=>(l.set(A.URI.revive(p[0]),this.parseConfigurationModel(p[1])),l),new y.ResourceMap);return new g(i,o,new h,s,r,new h,new y.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,i=new Map;for(const s of a)s.keys.forEach(r=>t.add(r)),s.overrides.forEach(([r,l])=>{const p=(0,y.getOrSet)(i,r,new Set);l.forEach(S=>p.add(S))});const o=[];return i.forEach((s,r)=>o.push([r,[...s.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=w;class d{constructor(t,i,o,s){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const r=new Set;t.keys.forEach(p=>r.add(p)),t.overrides.forEach(([,p])=>p.forEach(S=>r.add(S))),this.affectedKeys=[...r.values()];const l=new h;this.affectedKeys.forEach(p=>l.setValue(p,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,r=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!D.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=(0,n.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(t=t[s],!t)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=d;class u extends d{constructor(t,i,o,s){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=u}),define(ge[113],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var y;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(D,A=y.Unknown,C){super(D);this._message=D,this._code=A,this._detail=C,this.isHandled=A===y.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(D){return D instanceof R&&D._code===y.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof R&&D._code===y.NoResolverFound}static isHandled(D){return D instanceof R&&D.isHandled}}e.RemoteAuthorityResolverError=R}),define(ge[114],pe([0,1,11]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function y(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=y;function R(P){if(!!P){const D=P.indexOf("+");return D<0?P:P.substr(0,D)}}e.getRemoteName=R}),define(ge[185],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((R,P)=>Y(["vsda"],R,P))}async sign(R){try{const P=await this.vsda(),D=new P.signer;if(D)return D.sign(R)}catch(P){}return R}}e.SignService=_}),define(ge[186],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,P,D=5){let A;return A=P(C=>{const n=typeof C=="string"?C:C.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(n);return}const k=setTimeout(()=>this._flushBuffer(R),D);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(R),A.dispose()}},this._terminalBufferMap.set(R,T)}),A}stopBuffering(R){const P=this._terminalBufferMap.get(R);P&&P.dispose()}_flushBuffer(R){const P=this._terminalBufferMap.get(R);P&&(this._terminalBufferMap.delete(R),this._callback(R,P.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[187],pe([0,1,48,7,30,26,15,22,9]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let b=0;return k&&k.length===4&&(b=parseInt(k[3])),b}e.getWindowsBuildNumber=n;async function T(k,b,h,c=R.env){if(y.isAbsolute(k))return await(0,P.exists)(k)?k:void 0;if(b===void 0&&(b=R.cwd()),y.dirname(k)!=="."){const w=y.join(b,k);return await(0,P.exists)(w)?w:void 0}const E=(0,A.getCaseInsensitive)(c,"PATH");if(h===void 0&&(0,D.isString)(E)&&(h=E.split(y.delimiter)),h===void 0||h.length===0){const w=y.join(b,k);return await(0,P.exists)(w)?w:void 0}for(let w of h){let d;if(y.isAbsolute(w)?d=y.join(w,k):d=y.join(b,w,k),await(0,P.exists)(d))return d;if(C.isWindows){let u=d+".com";if(await(0,P.exists)(u)||(u=d+".exe",await(0,P.exists)(u)))return u}}const g=y.join(b,k);return await(0,P.exists)(g)?g:void 0}e.findExecutable=T}),define(ge[188],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(y){y.DARK="dark",y.LIGHT="light",y.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[189],pe([0,1,4,6,40,3,188,47]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(E){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}E.isThemeColor=g})(C=e.ThemeColor||(e.ThemeColor={}));function n(E){return{id:E}}e.themeColorFromId=n;var T;(function(E){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}E.isThemeIcon=g;const w=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const i=w.exec(t);if(!!i){let[,o]=i;return{id:o}}}E.fromString=d;function u(t,i){let o=t.id;const s=o.lastIndexOf("~");return s!==-1&&(o=o.substring(0,s)),i&&(o=`${o}~${i}`),{id:o}}E.modify=u;function a(t,i){var o,s;return t.id===i.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((s=i.color)===null||s===void 0?void 0:s.id)}E.isEqual=a,E.asClassNameArray=A.CSSIcon.asClassNameArray,E.asClassName=A.CSSIcon.asClassName,E.asCSSSelector=A.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function k(E){switch(E){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,y.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new b;R.Registry.add(e.Extensions.ThemingContribution,h);function c(E){return h.onColorThemeChange(E)}e.registerThemingParticipant=c;class m extends y.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let d=this.theme.getColor(g);return d&&w&&(d=w(d,this.theme)),d?d.toString():null}}e.Themable=m}),define(ge[190],pe([0,1,40,189,3,154,112,17,47]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${C.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,w,d,u){const a=this.iconsById[g];if(a){if(d&&!a.description){a.description=d,this.iconSchema.properties[g].markdownDescription=`${d} $(${g})`;const o=this.iconReferenceSchema.enum.indexOf(g);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=d),this._onDidChange.fire()}return a}let t={id:g,description:d,defaults:w,deprecationMessage:u};this.iconsById[g]=t;let i={$ref:"#/definitions/icons"};return u&&(i.deprecationMessage=u),d&&(i.markdownDescription=`${d}: $(${g})`),this.iconSchema.properties[g]=i,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const w=this.iconReferenceSchema.enum.indexOf(g);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,w){const d=this.iconFontsById[g];if(d)return d;let u={id:g,definition:w};return this.iconFontsById[g]=u,this._onDidChange.fire(),u}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(a,t)=>a.id.localeCompare(t.id),w=a=>{for(;y.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of u.filter(t=>!!t.description).sort(g))d.push(`|<i class="${w(a)}"></i>|${a.id}|${y.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const a of u.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(g))d.push(`|<i class="${w(a)}"></i>|${a.id}|`);return d.join(`
`)}}const T=new n;_.Registry.add(e.Extensions.IconContribution,T);function k(E,g,w,d){return T.registerIcon(E,g,w,d)}e.registerIcon=k;function b(){return T}e.getIconRegistry=b;function h(){for(const E of C.iconRegistry.all)T.registerIcon(E.id,E.definition,E.description);C.iconRegistry.onDidRegister(E=>T.registerIcon(E.id,E.definition,E.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let c=_.Registry.as(D.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,T.getIconSchema());const m=new A.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=k("widget-close",C.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",C.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",C.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=y.ThemeIcon.modify(C.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,24,4,23]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var D;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function A(b){const h=b;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=A;function C(b){const h=b;return!!(h&&typeof h=="object"&&_.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=C;class n{constructor(h,c,m,E){this._id=h,this._configuration=m,this._ignorePathCasing=E,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,y.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(b){return new T({uri:b,index:0,name:(0,y.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=k}),define(ge[115],pe([0,1,4,155,60,2,9,7,24,131,55,11,75,31,114]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,A.extname)($):(0,C.extname)($))===m}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function g($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function w($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=w;function d($){return $.hasOwnProperty("fileUri")}e.isRecentFile=d;function u($){const M=$;return typeof(M==null?void 0:M.id)=="string"&&P.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=u;function a($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=a;function t($){const M=$;return typeof(M==null?void 0:M.id)=="string"&&P.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function i($){const M=$;if(M==null?void 0:M.uri)return{id:M.id,uri:P.URI.revive(M.uri)};const U=$;if(U==null?void 0:U.configPath)return{id:U.id,configPath:P.URI.revive(U.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function o($,M){return C.extUriBiasedIgnorePathCase.isEqualOrParent($,M.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function s($){return r($)||l($)}e.isStoredWorkspaceFolder=s;function r($){const M=$;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=r;function l($){const M=$;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=l;function p($,M,U,F,N=!D.isWindows,O){if($.scheme!==F.scheme)return{name:U,uri:$.toString(!0)};let V=M?void 0:O.relativePath(F,$);if(V!==void 0)V.length===0?V=".":D.isWindows&&$.scheme===k.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if($.scheme===k.Schemas.file)V=$.fsPath,D.isWindows&&(V=(0,b.normalizeDriveLetter)(V),N&&(V=(0,h.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,F.authority))return{name:U,uri:$.toString(!0)};V=$.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=p;function S($,M,U){let F=[],N=new Set;const O=U.dirname(M);for(let V of $){let q=null;if(r(V))V.path&&(q=U.resolvePath(O,V.path));else if(l(V))try{q=P.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=U.getComparisonKey(q);if(!N.has(Q)){N.add(Q);const fe=V.name||U.basenameOrAuthority(q);F.push(new R.WorkspaceFolder({uri:q,name:fe,index:F.length},V))}}}return F}e.toWorkspaceFolders=S;function f($,M,U,F,N){let O=v(M,$);const V=N.dirname(M),q=N.dirname(F),Q=[],fe=I(O.folders);for(const Fe of O.folders){const j=r(Fe)?N.resolvePath(V,Fe.path):P.URI.parse(Fe.uri);let X;U?X=!1:X=!r(Fe)||(0,A.isAbsolute)(Fe.path),Q.push(p(j,X,Fe.name,q,fe,N))}const _e={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Le=n.setProperty($,["folders"],Q,_e);let Ie=n.applyEdits($,Le);return O.remoteAuthority===(0,c.getRemoteAuthority)(F)&&(Ie=n.applyEdits(Ie,n.removeProperty(Ie,["remoteAuthority"],_e))),Ie}e.rewriteWorkspaceFileForNewLocation=f;function v($,M){let U=T.parse(M);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(F=>s(F));else throw new Error(`${$} looks like an invalid workspace file.`);return U}function I($){return D.isWindows?$.some(M=>r(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function x($){return typeof $.folderUri=="string"}function Z($){return typeof $.fileUri=="string"}function z($,M){const U={workspaces:[],files:[]};if($){const F=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(Q){M.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))F(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):x(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:P.URI.parse(O.folderUri)}):Z(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:P.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&F(O.workspaces3,(V,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:Q,workspace:{id:V.id,configPath:P.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:Q,folderUri:P.URI.parse(V)})}),Array.isArray(O.files2)&&F(O.files2,(V,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:Q,fileUri:P.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=z;function B($){const M={entries:[]};for(const U of $.workspaces)w(U)?M.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):M.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of $.files)M.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return M}e.toStoreData=B}),define(ge[116],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const P=this._idPool++;return this._data.set(P,R),this.logDebugInfo(),P}get(R,P){return this._data.has(R)?this._data.get(R)[P]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[191],pe([0,1,2,3]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(A=>({name:A.name,group:A.group,resource:_.URI.revive(A.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(ge[61],pe([0,1,11,4]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,A){A===null?this._providerInfo.delete(D):this._providerInfo.set(D,A)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[192],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(P,D,A){this._id=P,this._shared=D,this._storage=A,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)})}get whenReady(){return this._init}get(P,D){let A=this._value[P];return typeof A=="undefined"&&(A=D),A}update(P,D){return this._value[P]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class y extends _{constructor(P,D){super(P.identifier.value,!0,D);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(ge[14],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class y{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=y});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[193],pe([0,1,29,3]),function(Y,e,_,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(A,C){R.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(A.identifier),tt(this,R,C),Be(this,R).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(A){return Be(this,R).get(this._id,A)}store(A,C){return Be(this,R).store(this._id,A,C)}delete(A){return Be(this,R).delete(this._id,A)}}e.ExtensionSecrets=P,R=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[50],pe([0,1,4,3,14]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(A){function C(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}A.fromApiTunnel=C;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}A.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let D=class{constructor(C){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,n){return{dispose:()=>{}}}async $providePortAttributes(C,n,T,k,b){return[]}async $forwardPort(C,n){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Ue(0,R.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[8],pe([0,1,12,16,94,23,15,2,28,44,113]),function(Y,e,_,y,R,P,D,A,C,n,T){"use strict";var k,b,h,c,m,E,g,w,d,u,a,t,i,o,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(H){function W(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(W,H),Object.setPrototypeOf(W.prototype,H.prototype),W}let p=h=class{constructor(W){k.set(this,void 0),tt(this,k,W)}static from(...W){let se=W;return new h(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof Be(this,k)=="function"&&(Be(this,k).call(this),tt(this,k,void 0))}};k=new WeakMap,p=h=je([l],p),e.Disposable=p;let S=c=class{constructor(W,se){if(W<0)throw(0,y.illegalArgument)("line must be non-negative");if(se<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const Ve=W[Ce];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const Ve=W[Ce];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(W){if(!W)return!1;if(W instanceof c)return!0;let{line:se,character:Ce}=W;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,y.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=0:typeof W=="number"?Ce=W:(Ce=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),Ce===0&&se===0?this:new c(this.line+Ce,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,y.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=this.line:typeof W=="number"?Ce=W:(Ce=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),Ce===this.line&&se===this.character?this:new c(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};S=c=je([l],S),e.Position=S;let f=m=class{constructor(W,se,Ce,Ve){let Je,nt;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"?(Je=new S(W,se),nt=new S(Ce,Ve)):W instanceof S&&se instanceof S&&(Je=W,nt=se),!Je||!nt)throw new Error("Invalid arguments");Je.isBefore(nt)?(this._start=Je,this._end=nt):(this._start=nt,this._end=Je)}static isRange(W){return W instanceof m?!0:W?S.isPosition(W.start)&&S.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof m?this.contains(W._start)&&this.contains(W._end):W instanceof S?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=S.Max(W.start,this._start),Ce=S.Min(W.end,this._end);if(!se.isAfter(Ce))return new m(se,Ce)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=S.Min(W.start,this._start),Ce=S.Max(W.end,this.end);return new m(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,y.illegalArgument)();let Ce;return W?S.isPosition(W)?Ce=W:(Ce=W.start||this.start,se=W.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new m(Ce,se)}toJSON(){return[this.start,this.end]}};f=m=je([l],f),e.Range=f;let v=E=class extends f{constructor(W,se,Ce,Ve){let Je,nt;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"?(Je=new S(W,se),nt=new S(Ce,Ve)):W instanceof S&&se instanceof S&&(Je=W,nt=se),!Je||!nt)throw new Error("Invalid arguments");super(Je,nt);this._anchor=Je,this._active=nt}static isSelection(W){return W instanceof E?!0:W?f.isRange(W)&&S.isPosition(W.anchor)&&S.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};v=E=je([l],v),e.Selection=v;class I{constructor(W,se,Ce){if(typeof W!="string"||W.length===0)throw(0,y.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,y.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,y.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=I;class L extends Error{constructor(W,se=T.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(W);this._message=W,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static NotAvailable(W,se){return new L(W,T.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new L(W,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=L;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var Z;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=g=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof g?!0:W?f.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new g(W,se)}static insert(W,se){return g.replace(new f(W,W),se)}static delete(W){return g.replace(W,"")}static setEndOfLine(W){const se=new g(new f(new S(0,0),new S(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!f.isRange(W))throw(0,y.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,y.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,y.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=g=je([l],z),e.TextEdit=z;var B;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(B=e.FileEditType||(e.FileEditType={}));let $=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,Ce,Ve){this._edits.push({_type:1,from:W,to:se,options:Ce,metadata:Ve})}createFile(W,se,Ce){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:Ce})}deleteFile(W,se,Ce){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(W,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,Ce,Ve,Je){(se!==Ce||Ve.length>0)&&this._edits.push({_type:5,uri:W,index:se,count:Ce-se,cells:Ve,metadata:Je})}replaceNotebookCellOutput(W,se,Ce,Ve){this._editNotebookCellOutput(W,se,!1,Ce,Ve)}appendNotebookCellOutput(W,se,Ce,Ve){this._editNotebookCellOutput(W,se,!0,Ce,Ve)}replaceNotebookCellOutputItems(W,se,Ce,Ve,Je){this._editNotebookCellOutputItems(W,se,Ce,!1,Ve,Je)}appendNotebookCellOutputItems(W,se,Ce,Ve,Je){this._editNotebookCellOutputItems(W,se,Ce,!0,Ve,Je)}_editNotebookCellOutputItems(W,se,Ce,Ve,Je,nt){this._edits.push({_type:6,metadata:nt,uri:W,index:se,outputId:Ce,append:Ve,newOutputItems:Je})}_editNotebookCellOutput(W,se,Ce,Ve,Je){this._edits.push({_type:4,metadata:Je,uri:W,index:se,append:Ce,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(W,se,Ce,Ve){this._edits.push({_type:3,metadata:Ve,uri:W,edit:{editType:3,index:se,metadata:Ce}})}replace(W,se,Ce,Ve){this._edits.push({_type:2,uri:W,edit:new z(se,Ce),metadata:Ve})}insert(W,se,Ce,Ve){this.replace(W,new f(se,se),Ce,Ve)}delete(W,se,Ce){this.replace(W,se,"",Ce)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:W,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ve=this._edits[Ce];Ve._type===2&&Ve.uri.toString()===W.toString()&&(this._edits[Ce]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===W.toString()&&se.push(Ce.edit);return se}entries(){const W=new P.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=W.get(se.uri);Ce||(Ce=[se.uri,[]],W.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};$=je([l],$),e.WorkspaceEdit=$;let M=w=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof w?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=w._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const Ce=new w;Ce._tabstop=this._tabstop,W(Ce),this._tabstop=Ce._tabstop,W=Ce.value}else W=w._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const Ce=W.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const Ce=new w;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=w=je([l],M),e.SnippetString=M;var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var F;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let N=d=class{constructor(W,se){if(this.uri=W,se)if(se instanceof f)this.range=se;else if(se instanceof S)this.range=new f(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof d?!0:W?f.isRange(W.range)&&A.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};N=d=je([l],N),e.Location=N;let O=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&f.isRange(W.location.range)&&A.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};O=je([l],O),e.DiagnosticRelatedInformation=O;let V=class{constructor(W,se,Ce=F.Error){if(!f.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=Ce}toJSON(){return{severity:F[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,_.equals)(W.tags,se.tags)&&(0,_.equals)(W.relatedInformation,se.relatedInformation,O.isEqual)}};V=je([l],V),e.Diagnostic=V;let q=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,R.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=se}};q=je([l],q),e.Hover=q;var Q;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Q=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let fe=class{constructor(W,se=Q.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:Q[this.kind]}}};fe=je([l],fe),e.DocumentHighlight=fe;var _e;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(_e=e.SymbolKind||(e.SymbolKind={}));var Le;(function(H){H[H.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let Ie=u=class{constructor(W,se,Ce,Ve,Je){this.name=W,this.kind=se,this.containerName=Je,typeof Ce=="string"&&(this.containerName=Ce),Ve instanceof N?this.location=Ve:Ce instanceof f&&(this.location=new N(Ve,Ce)),u.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:_e[this.kind],location:this.location,containerName:this.containerName}}};Ie=u=je([l],Ie),e.SymbolInformation=Ie;let Fe=a=class{constructor(W,se,Ce,Ve,Je){this.name=W,this.detail=se,this.kind=Ce,this.range=Ve,this.selectionRange=Je,this.children=[],a.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(a.validate)}};Fe=a=je([l],Fe),e.DocumentSymbol=Fe;var j;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let X=class{constructor(W,se){this.title=W,this.kind=se}};X=je([l],X),e.CodeAction=X;let te=t=class{constructor(W){this.value=W}append(W){return new t(this.value?this.value+t.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+t.sep)}};te.sep=".",te=t=je([l],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let ae=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([l],ae),e.SelectionRange=ae;class ve{constructor(W,se,Ce,Ve,Je,nt){this.kind=W,this.name=se,this.detail=Ce,this.uri=Ve,this.range=Je,this.selectionRange=nt}}e.CallHierarchyItem=ve;class De{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=De;class Oe{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=Oe;let we=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};we=je([l],we),e.CodeLens=we;let ke=i=class{constructor(W,se=!1){b.set(this,void 0),tt(this,b,new R.MarkdownString(W,{supportThemeIcons:se}))}static isMarkdownString(W){return W instanceof i?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Be(this,b).value}set value(W){Be(this,b).value=W}get isTrusted(){return Be(this,b).isTrusted}set isTrusted(W){Be(this,b).isTrusted=W}get supportThemeIcons(){return Be(this,b).supportThemeIcons}appendText(W){return Be(this,b).appendText(W),this}appendMarkdown(W){return Be(this,b).appendMarkdown(W),this}appendCodeblock(W,se){return Be(this,b).appendCodeblock(se!=null?se:"",W),this}};b=new WeakMap,ke=i=je([l],ke),e.MarkdownString=ke;let Te=class{constructor(W,se){this.label=W,this.documentation=se}};Te=je([l],Te),e.ParameterInformation=Te;let xe=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};xe=je([l],xe),e.SignatureInformation=xe;let ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ye=je([l],ye),e.SignatureHelp=ye;var Ke;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var G;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(G=e.InlineHintKind||(e.InlineHintKind={}));let ie=class{constructor(W,se,Ce){this.text=W,this.range=se,this.kind=Ce}};ie=je([l],ie),e.InlineHint=ie;var Se;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(H){H[H.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let We=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};We=je([l],We),e.CompletionItem=We;let Ye=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};Ye=je([l],Ye),e.CompletionList=Ye;var K;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(K=e.ViewColumn||(e.ViewColumn={}));var oe;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(J=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ne;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var me;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function W(se){switch(se){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(W,se){if(se&&!A.URI.isUri(se))throw(0,y.illegalArgument)("target");if(!f.isRange(W)||W.isEmpty)throw(0,y.illegalArgument)("range");this.range=W,this.target=se}};Ee=je([l],Ee),e.DocumentLink=Ee;let He=class{constructor(W,se,Ce,Ve){this.red=W,this.green=se,this.blue=Ce,this.alpha=Ve}};He=je([l],He),e.Color=He;let $e=class{constructor(W,se){if(se&&!(se instanceof He))throw(0,y.illegalArgument)("color");if(!f.isRange(W)||W.isEmpty)throw(0,y.illegalArgument)("range");this.range=W,this.color=se}};$e=je([l],$e),e.ColorInformation=$e;let qe=class{constructor(W){if(!W||typeof W!="string")throw(0,y.illegalArgument)("label");this.label=W}};qe=je([l],qe),e.ColorPresentation=qe;var Qe;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ut;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(ut=e.TaskRevealKind||(e.TaskRevealKind={}));var st;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(st=e.TaskPanelKind||(e.TaskPanelKind={}));let be=o=class{constructor(W,se){if(typeof W!="string"||typeof se!="string")throw(0,y.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};be.Clean=new o("clean","Clean"),be.Build=new o("build","Build"),be.Rebuild=new o("rebuild","Rebuild"),be.Test=new o("test","Test"),be=o=je([l],be),e.TaskGroup=be;function he(H){let W="";for(let se=0;se<H.length;se++)W+=H[se].replace(/,/g,",,")+",";return W}let ce=class{constructor(W,se,Ce){if(typeof W!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,y.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return he(W)}};ce=je([l],ce),e.ProcessExecution=ce;let ee=class{constructor(W,se,Ce){if(this._args=[],Array.isArray(se)){if(!W)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,y.illegalArgument)("command");this._command=W,this._args=se,this._options=Ce}else{if(typeof W!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,y.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return he(W)}};ee=je([l],ee),e.ShellExecution=ee;var Ae;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Ae=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class et{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=et;let Ge=s=class{constructor(W,se,Ce,Ve,Je,nt){this.__deprecated=!1,this._definition=this.definition=W;let ot;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=Ve,ot=Je,this.__deprecated=!0):se===Re.Global||se===Re.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=Ve,this.execution=Je,ot=nt):(this.target=se,this._name=this.name=Ce,this._source=this.source=Ve,this.execution=Je,ot=nt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:s.ProcessType,id:this._execution.computeId()}:this._execution instanceof ee?this._definition={type:s.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:s.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:s.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(s.EmptyType===se||s.ProcessType===se||s.ShellType===se||s.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=s=je([l],Ge),e.Task=Ge;var rt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(W,se=Xe.None){this.collapsibleState=se,A.URI.isUri(W)?this.resourceUri=W:this.label=W}};lt=je([l],lt),e.TreeItem=lt;var Xe;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Xe=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let it=class{constructor(W,se){this.id=W,this.color=se}};it=je([l],it),e.ThemeIcon=it,it.File=new it("file"),it.Folder=new it("folder");let dt=class{constructor(W){this.id=W}};dt=je([l],dt),e.ThemeColor=dt;var at;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(at=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(W,se){if(typeof W!="string"&&(!W||!A.URI.isUri(W)&&!A.URI.isUri(W.uri)))throw(0,y.illegalArgument)("base");if(typeof se!="string")throw(0,y.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=A.URI.file(W),this.base=W):A.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};Ct=je([l],Ct),e.RelativePattern=Ct;let gt=class{constructor(W,se,Ce,Ve){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};gt=je([l],gt),e.Breakpoint=gt;let kt=class extends gt{constructor(W,se,Ce,Ve,Je){super(se,Ce,Ve,Je);if(W===null)throw(0,y.illegalArgument)("location");this.location=W}};kt=je([l],kt),e.SourceBreakpoint=kt;let Et=class extends gt{constructor(W,se,Ce,Ve,Je){super(se,Ce,Ve,Je);this.functionName=W}};Et=je([l],Et),e.FunctionBreakpoint=Et;let St=class extends gt{constructor(W,se,Ce,Ve,Je,nt,ot){super(Ve,Je,nt,ot);if(!se)throw(0,y.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=Ce}};St=je([l],St),e.DataBreakpoint=St;let mt=class{constructor(W,se,Ce){this.command=W,this.args=se||[],this.options=Ce}};mt=je([l],mt),e.DebugAdapterExecutable=mt;let Lt=class{constructor(W,se){this.port=W,this.host=se}};Lt=je([l],Lt),e.DebugAdapterServer=Lt;let Ft=class{constructor(W){this.path=W}};Ft=je([l],Ft),e.DebugAdapterNamedPipeServer=Ft;let ht=class{constructor(W){this.implementation=W}};ht=je([l],ht),e.DebugAdapterInlineImplementation=ht;let yt=class{constructor(W,se){this.range=W,this.expression=se}};yt=je([l],yt),e.EvaluatableExpression=yt;let $t=class{constructor(W,se){this.range=W,this.text=se}};$t=je([l],$t),e.InlineValueText=$t;let Ht=class{constructor(W,se,Ce=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=Ce}};Ht=je([l],Ht),e.InlineValueVariableLookup=Ht;let Mt=class{constructor(W,se){this.range=W,this.expression=se}};Mt=je([l],Mt),e.InlineValueEvaluatableExpression=Mt;let ct=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};ct=je([l],ct),e.InlineValueContext=ct;var hn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(hn=e.FileChangeType||(e.FileChangeType={}));let Pt=r=class extends Error{constructor(W,se=n.FileSystemProviderErrorCode.Unknown,Ce){var Ve;super(A.URI.isUri(W)?W.toString(!0):W);this.code=(Ve=Ce==null?void 0:Ce.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,r.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(W){return new r(W,n.FileSystemProviderErrorCode.FileExists,r.FileExists)}static FileNotFound(W){return new r(W,n.FileSystemProviderErrorCode.FileNotFound,r.FileNotFound)}static FileNotADirectory(W){return new r(W,n.FileSystemProviderErrorCode.FileNotADirectory,r.FileNotADirectory)}static FileIsADirectory(W){return new r(W,n.FileSystemProviderErrorCode.FileIsADirectory,r.FileIsADirectory)}static NoPermissions(W){return new r(W,n.FileSystemProviderErrorCode.NoPermissions,r.NoPermissions)}static Unavailable(W){return new r(W,n.FileSystemProviderErrorCode.Unavailable,r.Unavailable)}};Pt=r=je([l],Pt),e.FileSystemError=Pt;let Tt=class{constructor(W,se,Ce){this.start=W,this.end=se,this.kind=Ce}};Tt=je([l],Tt),e.FoldingRange=Tt;var tn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var nn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(nn=e.CommentMode||(e.CommentMode={}));class mn{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function rn(H){return typeof H=="undefined"||(0,D.isStringArray)(H)}class At{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,Ce=W.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,Ce=W.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,Ce,Ve,Je){if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(W,se,Ce,Ve,Je);if(f.isRange(W)&&typeof se=="string"&&rn(Ce))return this._push(W,se,Ce);throw(0,y.illegalArgument)()}_push(W,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=W.start.line,Je=W.start.character,nt=W.end.character-W.start.character,ot=this._tokenTypeStrToInt.get(se);let pt=0;if(Ce)for(const wt of Ce){if(!this._tokenModifierStrToInt.has(wt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this._tokenModifierStrToInt.get(wt);pt|=1<<_t>>>0}this._pushEncoded(Ve,Je,nt,ot,pt)}_pushEncoded(W,se,Ce,Ve,Je){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const pt=this._data.length/5|0;let wt=0,_t=0;for(let bt=0;bt<pt;bt++){let Dt=this._data[5*bt],Yt=this._data[5*bt+1];Dt===0?(Dt=wt,Yt+=_t):Dt+=wt,this._data[5*bt]=Dt,this._data[5*bt+1]=Yt,wt=Dt,_t=Yt}}let nt=W,ot=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Je,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const Ce=W.length/5|0;for(let ot=0;ot<Ce;ot++)se[ot]=ot;se.sort((ot,pt)=>{const wt=W[5*ot],_t=W[5*pt];if(wt===_t){const bt=W[5*ot+1],Dt=W[5*pt+1];return bt-Dt}return wt-_t});const Ve=new Uint32Array(W.length);let Je=0,nt=0;for(let ot=0;ot<Ce;ot++){const pt=5*se[ot],wt=W[pt+0],_t=W[pt+1],bt=W[pt+2],Dt=W[pt+3],Yt=W[pt+4],Pn=wt-Je,Fn=Pn===0?_t-nt:_t,Zt=5*ot;Ve[Zt+0]=Pn,Ve[Zt+1]=Fn,Ve[Zt+2]=bt,Ve[Zt+3]=Dt,Ve[Zt+4]=Yt,Je=wt,nt=_t}return Ve}build(W){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),W):new zt(At._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=At;class zt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=zt;class Vt{constructor(W,se,Ce){this.start=W,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=Vt;class jt{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=jt;var gn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(gn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var pn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(pn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let It=class{constructor(){}};It.Back={iconPath:new it("arrow-left")},It=je([l],It),e.QuickInputButtons=It;var vn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vn=e.ExtensionKind||(e.ExtensionKind={}));class wn{constructor(W,se,Ce){this.badge=W,this.tooltip=se,this.color=Ce}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=wn;let qt=class{constructor(W){this.kind=W}};qt=je([l],qt),e.ColorTheme=qt;var _n;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(_n=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(W,se){if(W<0)throw(0,y.illegalArgument)("start must be positive");if(se<W)throw(0,y.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=Kt;class Bt{constructor(W,se,Ce,Ve,Je,nt,ot,pt,wt,_t,bt){this.editable=W,this.breakpointMargin=se,this.hasExecutionOrder=Ce,this.executionOrder=Ve,this.runState=Je,this.runStartTime=nt,this.statusMessage=ot,this.lastRunDuration=pt,this.inputCollapsed=wt,this.outputCollapsed=_t,this.custom=bt}with(W){let{editable:se,breakpointMargin:Ce,hasExecutionOrder:Ve,executionOrder:Je,runState:nt,runStartTime:ot,statusMessage:pt,lastRunDuration:wt,inputCollapsed:_t,outputCollapsed:bt,custom:Dt}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),Ce===void 0?Ce=this.breakpointMargin:Ce===null&&(Ce=void 0),Ve===void 0?Ve=this.hasExecutionOrder:Ve===null&&(Ve=void 0),Je===void 0?Je=this.executionOrder:Je===null&&(Je=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.runStartTime:ot===null&&(ot=void 0),pt===void 0?pt=this.statusMessage:pt===null&&(pt=void 0),wt===void 0?wt=this.lastRunDuration:wt===null&&(wt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),Dt===void 0?Dt=this.custom:Dt===null&&(Dt=void 0),se===this.editable&&Ce===this.breakpointMargin&&Ve===this.hasExecutionOrder&&Je===this.executionOrder&&nt===this.runState&&ot===this.runStartTime&&pt===this.statusMessage&&wt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&Dt===this.custom?this:new Bt(se,Ce,Ve,Je,nt,ot,pt,wt,_t,bt,Dt)}}e.NotebookCellMetadata=Bt;class Ot{constructor(W=!0,se=!0,Ce=!0,Ve={},Je=sn.Idle,nt=!0){this.editable=W,this.cellEditable=se,this.cellHasExecutionOrder=Ce,this.custom=Ve,this.runState=Je,this.trusted=nt}with(W){let{editable:se,cellEditable:Ce,cellHasExecutionOrder:Ve,custom:Je,runState:nt,trusted:ot}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),Ce===void 0?Ce=this.cellEditable:Ce===null&&(Ce=void 0),Ve===void 0?Ve=this.cellHasExecutionOrder:Ve===null&&(Ve=void 0),Je===void 0?Je=this.custom:Je===null&&(Je=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),se===this.editable&&Ce===this.cellEditable&&Ve===this.cellHasExecutionOrder&&Je===this.custom&&nt===this.runState&&ot===this.trusted?this:new Ot(se,Ce,Ve,Je,nt,ot)}}e.NotebookDocumentMetadata=Ot;class Gt{constructor(W,se,Ce,Ve,Je){this.kind=W,this.source=se,this.language=Ce,this.outputs=Ve!=null?Ve:[],this.metadata=Je}}e.NotebookCellData=Gt;class Me{constructor(W,se){this.cells=W,this.metadata=se!=null?se:new Ot}}e.NotebookData=Me;class Nt{constructor(W,se,Ce){this.mime=W,this.value=se,this.metadata=Ce}static isNotebookCellOutputItem(W){return W instanceof Nt}}e.NotebookCellOutputItem=Nt;class Qt{constructor(W,se,Ce){this.outputs=W,typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,C.generateUuid)(),this.metadata=se!=null?se:Ce)}}e.NotebookCellOutput=Qt;var ft;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var bn;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle",H[H.Success=3]="Success",H[H.Error=4]="Error"})(bn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var sn;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(sn=e.NotebookRunState||(e.NotebookRunState={}));var on;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(on=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var an;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(an=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Xt=class{constructor(W,se){this.label=W,this.timestamp=se}};Xt=je([l],Xt),e.TimelineItem=Xt;var En;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var yn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(yn=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=ln;var Dn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Dn=e.TestResult||(e.TestResult={}));var cn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(cn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class Cn{constructor(W,se){this.label=se,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:W,enumerable:!0,writable:!1})}}e.TestItem=Cn;class kn{constructor(W){this.state=W,this.messages=[]}}e.TestState=kn;class Jt{constructor(W){this.message=W,this.severity=cn.Error}static diff(W,se,Ce){const Ve=new Jt(W);return Ve.expectedOutput=se,Ve.actualOutput=Ce,Ve}}e.TestMessage=Jt;var re;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(re=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var de;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unknown=2]="Unknown"})(de=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Pe;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(Pe=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,52,11,10,142,105,8,12]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(c,m){m?n.set(c,m):n.delete(c)}e.setWordDefinitionFor=T;function k(c){return n.get(c)}e.getWordDefinitionFor=k;class b extends P.MirrorTextModel{constructor(m,E,g,w,d,u,a,t){super(E,g,w,d);this._proxy=m,this._languageId=u,this._isDirty=a,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,C.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===y.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(E){return E?m._getTextInRange(E):m.getText()},get eol(){return m._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(E){return m._lineAt(E)},offsetAt(E){return m._offsetAt(E)},positionAt(E){return m._positionAt(E)},validateRange(E){return m._validateRange(E)},validatePosition(E){return m._validatePosition(E)},getWordRangeAtPosition(E,g){return m._getWordRangeAtPosition(E,g)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,_.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,_.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const E=this._validateRange(m);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const g=this._eol,w=E.start.line,d=E.end.line,u=[];u.push(this._lines[w].substring(E.start.character));for(let a=w+1;a<d;a++)u.push(this._lines[a]);return u.push(this._lines[d].substring(0,E.end.character)),u.join(g)}_lineAt(m){let E;if(m instanceof A.Position?E=m.line:typeof m=="number"&&(E=m),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new h(E,this._lines[E],E===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(m),g=this._lines[E.index].length;return new A.Position(E.index,Math.min(E.remainder,g))}_validateRange(m){if(!(m instanceof A.Range))throw new Error("Invalid argument");const E=this._validatePosition(m.start),g=this._validatePosition(m.end);return E===m.start&&g===m.end?m:new A.Range(E.line,E.character,g.line,g.character)}_validatePosition(m){if(!(m instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:E,character:g}=m,w=!1;if(E<0)E=0,g=0,w=!0;else if(E>=this._lines.length)E=this._lines.length-1,g=this._lines[E].length,w=!0;else{const d=this._lines[E].length;g<0?(g=0,w=!0):g>d&&(g=d,w=!0)}return w?new A.Position(E,g):m}_getWordRangeAtPosition(m,E){const g=this._validatePosition(m);if(!E)E=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(g.character+1,(0,D.ensureValidWordDefinition)(E),this._lines[g.line],0);if(w)return new A.Range(g.line,w.startColumn-1,g.line,w.endColumn-1)}}e.ExtHostDocumentData=b;class h{constructor(m,E,g){this._line=m,this._text=E,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(ge[194],pe([0,1,8,3,107,6,76,23,2,28]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(b,h,c,m){this._notebook=c,this._selector=m,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(g=>{const w=this._cellUris.get(g.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(g=>E(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const b=[],h=[];for(const c of this._notebook.cells)c.kind===_.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),b.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(b){var h,c;if(!b){let d="";for(const u of this._cells)d+=u.document.getText()+`
`;return d=d.slice(0,-1),d}if(b.isEmpty)return"";const m=this.locationAt(b.start),E=this.locationAt(b.end),g=this._cells[(h=this._cellUris.get(m.uri))!==null&&h!==void 0?h:-1],w=this._cells[(c=this._cellUris.get(E.uri))!==null&&c!==void 0?c:-1];if(!g||!w)return"";if(g===w)return g.document.getText(new _.Range(m.range.start,E.range.end));{const d=g.document.getText(new _.Range(m.range.start,new _.Position(g.document.lineCount,0))),u=w.document.getText(new _.Range(new _.Position(0,0),E.range.end));return d+`
`+u}}offsetAt(b){const h=this._cellLines.getIndexOf(b.line),c=this._cellLengths.getAccumulatedValue(h.index-1),m=this._cells[h.index].document.offsetAt(b.with(h.remainder));return c+m}positionAt(b){if(typeof b=="number"){const c=this._cellLengths.getIndexOf(b),m=this._cellLines.getAccumulatedValue(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(m)}const h=this._cellUris.get(b.uri);if(h!==void 0){const c=this._cellLines.getAccumulatedValue(h-1);return new _.Position(c+b.range.start.line,b.range.start.character)}return new _.Position(0,0)}locationAt(b){_.Range.isRange(b)||(b=new _.Range(b,b));const h=this._cellLines.getIndexOf(b.start.line);let c=h;b.isEmpty||(c=this._cellLines.getIndexOf(b.end.line));const m=new _.Position(h.remainder,b.start.character),E=new _.Position(c.remainder,b.end.character),g=new _.Range(m,E),w=this._cells[h.index];return new _.Location(w.document.uri,w.document.validateRange(g))}contains(b){return this._cellUris.has(b)}validateRange(b){const h=this.validatePosition(b.start),c=this.validatePosition(b.end);return b.with(h,c)}validatePosition(b){const h=this._cellLines.getIndexOf(b.line),c=new _.Position(h.remainder,b.character),m=this._cells[h.index].document.validatePosition(c),E=this._cellLines.getAccumulatedValue(h.index-1);return new _.Position(E+m.line,m.character)}}e.ExtHostNotebookConcatDocument=T}),define(ge[195],pe([0,1,8,14,3]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(A){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let C=A==="light"?_.ColorThemeKind.Light:A==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([Ue(0,y.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(ge[62],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class y{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=y}),define(ge[84],pe([0,1,2]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function y(P,D,A){const C=P.webviewResourceRoot.replace("{{resource}}",A.scheme+R(A)).replace("{{uuid}}",D);return _.URI.parse(C)}e.asWebviewUri=y;function R(P){return P.toString().replace(/^\S+?:/,"")}}),define(ge[196],pe([0,1,3,6,84,28]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(C,n,T){this._proxy=C,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const b of this._insets.values())k.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,n,T,k,b){let h;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===C){h=u;break}if(!h)throw new Error("not a visible editor");const c=this,m=this._handlePool++,E=new _.Emitter,g=new _.Emitter,w=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,R.asWebviewUri)(c._initData,this._uuid,u)}get cspSource(){return c._initData.webviewCspSource}set options(u){this._options=u,c._proxy.$setOptions(m,u)}get options(){return this._options}set html(u){this._html=u,c._proxy.$setHtml(m,u)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(u){return c._proxy.$postMessage(m,u)}},d=new class{constructor(){this.editor=C,this.line=n,this.height=T,this.webview=w,this.onDidDispose=g.event}dispose(){c._insets.has(m)&&(c._insets.delete(m),c._proxy.$disposeEditorInset(m),g.fire(),g.dispose(),E.dispose())}};return this._proxy.$createEditorInset(m,h.id,h.value.document.uri,n+1,T,k||{},b.identifier,b.extensionLocation),this._insets.set(m,{editor:C,inset:d,onDidReceiveMessage:E}),d}$onDidDispose(C){const n=this._insets.get(C);n&&n.inset.dispose()}$onDidReceiveMessage(C,n){const T=this._insets.get(C);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=D}),define(ge[197],pe([0,1,3,80,166,4,6,23,40,12,53,22,47,190]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",b.Codicon.window,(0,R.localize)(0,null));var c;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var m;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(r){switch(r){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function g(r){return`viewContainer.${r}.enabled`}e.getEnabledViewContainerContextKey=g;class w extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(l,p,S){var f;const v=this.get(l.id);if(v)return v;const I=l;return I.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(f=I.openCommandActionDescriptor)!==null&&f!==void 0?f:{id:I.id},(0,A.getOrSet)(this.viewContainers,p,[]).push(I),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:p}),I}deregisterViewContainer(l){for(const p of this.viewContainers.keys()){const S=this.viewContainers.get(p),f=S==null?void 0:S.indexOf(l);if(f!==-1){S==null||S.splice(f,1),S.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:p});return}}}get(l){return this.all.filter(p=>p.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(S=>(S==null?void 0:S.id)===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===l)}}C.Registry.add(c.ViewContainersRegistry,new w);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function u(r,l){var p,S,f,v;const I=(p=r.group)!==null&&p!==void 0?p:d.More,L=(S=l.group)!==null&&S!==void 0?S:d.More;return I!==L?I.localeCompare(L):((f=r.order)!==null&&f!==void 0?f:5)-((v=l.order)!==null&&v!==void 0?v:5)}class a extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(l,p){this.registerViews2([{views:l,viewContainer:p}])}registerViews2(l){l.forEach(({views:p,viewContainer:S})=>this.addViews(p,S)),this._onViewsRegistered.fire(l)}deregisterViews(l,p){const S=this.removeViews(l,p);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:p})}moveViews(l,p){for(const S of this._views.keys())if(S!==p){const f=this.removeViews(l,S);f.length&&(this.addViews(f,p),this._onDidChangeContainer.fire({views:f,from:S,to:p}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const p of this._viewContainers){const S=(this._views.get(p)||[]).filter(f=>f.id===l)[0];if(S)return S}return null}getViewContainer(l){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(f=>f.id===l)[0])return p;return null}registerViewWelcomeContent(l,p){return this._viewWelcomeContents.add(l,p),this._onDidChangeViewWelcomeContent.fire(l),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(l,p),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,p){const S=new Map;for(const[f,v]of p)this._viewWelcomeContents.add(l,v),S.set(f,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(l,v),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),S}getViewWelcomeContent(l){const p=[];return this._viewWelcomeContents.forEach(l,S=>p.push(S)),p.sort(u)}addViews(l,p){let S=this._views.get(p);S||(S=[],this._views.set(p,S),this._viewContainers.push(p));for(const f of l){if(this.getView(f.id)!==null)throw new Error((0,R.localize)(1,null,f.id));S.push(f)}}removeViews(l,p){const S=this._views.get(p);if(!S)return[];const f=[],v=[];for(const I of S)l.includes(I)?f.push(I):v.push(I);return f.length&&(v.length?this._views.set(p,v):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),f}}C.Registry.add(c.ViewsRegistry,new a),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new y.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(r){return`view.${r}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(l,p){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,l),this._hasResolve=!!p,this.resolve=async S=>{var f,v;if(p&&!this.resolved){const I=await p(S);I&&(this.tooltip=(f=this.tooltip)!==null&&f!==void 0?f:I.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:I.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(ge[198],pe([0,1,2,177,115,13,178,197]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function C(m){return(E,...g)=>m(E.get(y.ICommandService),...g)}class n{static execute(E,g){const w={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return E.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",y.CommandsRegistry.registerCommand({id:n.ID,handler:C(n.execute),description:{description:"Opens an new window",args:[]}}),y.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(m,E){return m.get(R.IWorkspacesService).removeRecentlyOpened([E])});class T{static execute(E,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?_.URI.parse(g):_.URI.file(g):g=_.URI.revive(g),E.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",y.CommandsRegistry.registerCommand(T.ID,C(T.execute));class k{static execute(E,g){const w=typeof g=="string"?{extensionId:g}:g;return E.executeCommand("workbench.action.openIssueReporter",w)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",y.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(m,E){const g=m.get(R.IWorkspacesService);let w;const d=E.uri,u=E.label,a=E.remoteAuthority;return E.type==="workspace"?w={workspace:await g.getWorkspaceIdentifier(d),label:u,remoteAuthority:a}:E.type==="folder"?w={folderUri:d,label:u,remoteAuthority:a}:w={fileUri:d,label:u,remoteAuthority:a},g.addRecentlyOpened([w])}),y.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(m){return m.get(R.IWorkspacesService).getRecentlyOpened()}),y.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(m,E){const g=m.get(P.ILogService),w=m.get(D.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&g.setLevel(E)}),y.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(m){return m.get(P.ILogService).getLevel()}),y.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(m,E){const g=m.get(A.IViewDescriptorService),w=g.getViewContainerById(E.destinationId);if(!!w){for(const d of E.viewIds){const u=g.getViewDescriptorById(d);(u==null?void 0:u.canMoveView)&&g.moveViewsToContainer([u],w,A.ViewVisibilityState.Default)}await m.get(A.IViewsService).openViewContainer(w.id,!0)}});class b{static execute(E,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",y.CommandsRegistry.registerCommand({id:b.ID,handler:C(b.execute),description:{description:"Move Views",args:[]}});class h{static execute(E,g){return E.executeCommand("_workbench.open",g)}}h.ID="vscode.open",y.CommandsRegistry.registerCommand(h.ID,C(h.execute));class c{static execute(E,g,w,d,u){return E.executeCommand("_workbench.diff",[g,w,d])}}c.ID="vscode.diff",y.CommandsRegistry.registerCommand(c.ID,C(c.execute))}),define(ge[119],pe([0,1,3,17,167]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,C,n,T){const k={command:A};if(C&&Object.keys(C).length>0&&(k.arguments=C),this.internalSend("request",k),typeof T=="number"){const b=setTimeout(()=>{clearTimeout(b);const h=this.pendingRequests.get(k.seq);if(h){this.pendingRequests.delete(k.seq);const c={type:"response",seq:0,request_seq:k.seq,success:!1,command:A,message:(0,R.localize)(0,null,T,A)};h(c)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,C){return A.type!=="event"||C.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,y.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const C=A,n=this.pendingRequests.get(C.request_seq);n&&(this.pendingRequests.delete(C.request_seq),n(C));break}}}internalSend(A,C){C.type=A,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((C,n)=>A.set(n,C)),await(0,y.timeout)(500),A.forEach((C,n)=>{C({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(ge[199],pe([0,1,10,2,7,22,11]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function C(i,o,s){return i.replace(A,function(r,l){return o&&l.length>0&&l[0]!=="_"?r:s&&s.hasOwnProperty(l)?s[l]:r})}e.formatPII=C;function n(i){const o={};for(const s of Object.keys(i))s.startsWith("!")||(o[s]=i[s]);return o}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(o,"extensionhost")||(0,_.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function b(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=b;function h(i,o,s){let r,l=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=p.exec(i);){let f=S.index+1,v=f+S[0].length;if(f<=o&&v>=s){r=S[0],l=f;break}}if(r){let f=/\w+/g,v=null;for(;(v=f.exec(r))&&!(v.index+1+l+v[0].length>=s););v&&(r=r.substring(0,f.lastIndex))}return r?{start:l,end:l+r.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(i){return!!(i&&i.match(c))}e.isUri=m;function E(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(m(i.path))return y.URI.parse(i.path);if((0,R.isAbsolute)(i.path))return y.URI.file(i.path)}return i.path}function g(i){if(typeof i.path=="object"){const o=y.URI.revive(i.path);if(o)return o.scheme===D.Schemas.file?o.fsPath:o.toString()}return i.path}function w(i,o){const s=o?E:g,r=(0,P.deepClone)(i);return u(r,(l,p)=>{l&&p&&(p.path=s(p))}),r}e.convertToDAPaths=w;function d(i,o){const s=o?E:g,r=(0,P.deepClone)(i);return u(r,(l,p)=>{!l&&p&&(p.path=s(p))}),r}e.convertToVSCPaths=d;function u(i,o){switch(i.type){case"event":const s=i;switch(s.event){case"output":o(!1,s.body.source);break;case"loadedSource":o(!1,s.body.source);break;case"breakpoint":o(!1,s.body.breakpoint.source);break;default:break}break;case"request":const r=i;switch(r.command){case"setBreakpoints":o(!0,r.arguments.source);break;case"breakpointLocations":o(!0,r.arguments.source);break;case"source":o(!0,r.arguments.source);break;case"gotoTargets":o(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(p=>o(!1,p));break;default:break}break;case"response":const l=i;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(p=>o(!1,p.source));break;case"loadedSources":l.body.sources.forEach(p=>o(!1,p));break;case"scopes":l.body.scopes.forEach(p=>o(!1,p.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(p=>o(!1,p.source));break;case"setBreakpoints":l.body.breakpoints.forEach(p=>o(!1,p.source));break;default:break}break}}function a(i){return i.filter(o=>{var s;return!((s=o.presentation)===null||s===void 0?void 0:s.hidden)}).sort((o,s)=>o.presentation?s.presentation?o.presentation.group?s.presentation.group?o.presentation.group!==s.presentation.group?o.presentation.group.localeCompare(s.presentation.group):t(o.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(o.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=a;function t(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}}),define(ge[200],pe([0,1,26,38,168,120,7,10,22,9,179,119]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class b extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",u=>this.handleData(u))}sendMessage(w){if(this.outputStream){const d=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${b.TWO_CRLF}${d}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+d))}continue}}else{const d=this.rawData.indexOf(b.TWO_CRLF);if(d!==-1){const a=this.rawData.toString("utf8",0,d).split(b.HEADER_LINESEPARATOR);for(const t of a){const i=t.split(b.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(d+b.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=b,b.TWO_CRLF=`\r
\r
`,b.HEADER_LINESEPARATOR=/\r?\n/,b.HEADER_FIELDSEPARATOR=/: */;class h extends b{startSession(){return new Promise((w,d)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",a=>{u?this._onError.fire(a):d(a)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class c extends h{constructor(w){super();this.adapterServer=w}createConnection(w){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=c;class m extends h{constructor(w){super();this.adapterServer=w}createConnection(w){return P.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=m;class E extends b{constructor(w,d,u){super();this.adapterExecutable=w,this.debugType=d,this.outputService=u}async startSession(){const w=this.adapterExecutable.command,d=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(w)if(D.isAbsolute(w)){if(!await(0,_.exists)(w))throw new Error(R.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let a=process.env;if(u.env&&Object.keys(u.env).length>0&&(a=C.mixin(C.deepClone(process.env),u.env)),w==="node")if(Array.isArray(d)&&d.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:a,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(o.cwd=u.cwd);const s=y.fork(d[0],d.slice(1),o);if(!s.pid)throw new Error(R.localize(2,null,d[0]));this.serverProcess=s}else throw new Error(R.localize(3,null));else{const i={env:a};u.cwd&&(i.cwd=u.cwd),this.serverProcess=y.spawn(w,d,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,o)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const s=t.getChannel(T.ExtensionsChannelId);s&&s.append(i(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(a){this._onError.fire(a)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((w,d)=>{const u=y.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(a,t,i){if(a)return d(a)});u.on("exit",w),u.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,d){if(!!w){const u=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?u.runtime=D.join(d,w.runtime):u.runtime=w.runtime),w.runtimeArgs&&(u.runtimeArgs=w.runtimeArgs),w.program&&(D.isAbsolute(w.program)?u.program=w.program:u.program=D.join(d,w.program)),w.args&&(u.args=w.args);const a=w;return a.win&&(u.win=E.extract(a.win,d)),a.winx86&&(u.winx86=E.extract(a.winx86,d)),a.windows&&(u.windows=E.extract(a.windows,d)),a.osx&&(u.osx=E.extract(a.osx,d)),a.linux&&(u.linux=E.extract(a.linux,d)),u}}static platformAdapterExecutable(w,d){let u=Object.create(null);d=d.toLowerCase();for(const r of w)if(r.contributes){const l=r.contributes.debuggers;l&&l.length>0&&l.filter(p=>typeof p.type=="string"&&A.equalsIgnoreCase(p.type,d)).forEach(p=>{const S=E.extract(p,r.extensionLocation.fsPath);u=C.mixin(u,S,r.isBuiltin)})}let a;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=u.winx86||u.win||u.windows:n.isWindows?a=u.win||u.windows:n.isMacintosh?a=u.osx:n.isLinux&&(a=u.linux),a=a||u;let t=a.program||u.program;const i=a.args||u.args;let o=a.runtime||u.runtime;const s=a.runtimeArgs||u.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=E}),define(ge[201],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[202],pe([0,1,38,7,77,169,26,9,83,4,201,11]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=P.localize(0,null);let h=class Ut{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,R.getWindowsShell(),d)}}runInTerminal(d,u,a,t,i){const o=i.windowsExec||Ut.getDefaultTerminalWindows();return new Promise((s,r)=>{const l=`"${u} - ${b}"`,p=`""${a.join('" "')}" & pause"`,S=["/c","start",l,"/wait",o,"/c",p],f=Object.assign({},process.env,t);Object.keys(f).filter(L=>f[L]===null).forEach(L=>delete f[L]);const v={cwd:u,env:f,windowsVerbatimArguments:!0};_.spawn(Ut.CMD,S,v).on("error",L=>{r(E(L))}),s(void 0)})}spawnTerminal(d,u,a,t){const o=u.terminal.external.windowsExec||Ut.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const s=y.basename(o).toLowerCase();if(s==="cmder"||s==="cmder.exe")return d.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return o.indexOf(" ")>=0&&r.push('""'),r.push(o),(s==="wt"||s==="wt.exe")&&r.push("-d ."),new Promise((l,p)=>{const S=t?{cwd:t}:void 0,f=d.spawn(a,r,S);f.on("error",p),f.on("exit",()=>l())})}static getDefaultTerminalWindows(){if(!Ut._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ut._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return Ut._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=je([Ue(0,(0,n.optional)(C.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let c=class An{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,d)}}runInTerminal(d,u,a,t,i){const o=i.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{if(o===T.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const l=o===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Y).fsPath,"-t",d||b,"-w",u];for(let I of a)S.push("-a"),S.push(I);if(t)for(let I in t){const L=t[I];L===null?(S.push("-u"),S.push(I)):(S.push("-e"),S.push(`${I}=${L}`))}let f="";const v=_.spawn(An.OSASCRIPT,S);v.on("error",I=>{r(E(I))}),v.stderr.on("data",I=>{f+=I.toString()}),v.on("exit",I=>{if(I===0)s(void 0);else if(f){const L=f.split(`
`,1);r(new Error(L[0]))}else r(new Error(P.localize(1,null,l,I)))})}else r(new Error(P.localize(2,null,o)))})}spawnTerminal(d,u,a){const i=u.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((o,s)=>{const r=["-a",i];a&&r.push(a);const l=d.spawn("/usr/bin/open",r);l.on("error",s),l.on("exit",()=>o())})}};c.OSASCRIPT="/usr/bin/osascript",c=je([Ue(0,(0,n.optional)(C.IConfigurationService))],c),e.MacExternalTerminalService=c;let m=class xt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,d)}}runInTerminal(d,u,a,t,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):xt.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{let l=[];o.then(p=>{p.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const S=`${g(a)}; echo; read -p "${xt.WAIT_MESSAGE}" -n1;`;l.push(`''${S}''`);const f=Object.assign({},process.env,t);Object.keys(f).filter(x=>f[x]===null).forEach(x=>delete f[x]);const v={cwd:u,env:f};let I="";const L=_.spawn(p,l,v);L.on("error",x=>{r(E(x))}),L.stderr.on("data",x=>{I+=x.toString()}),L.on("exit",x=>{if(x===0)s(void 0);else if(I){const Z=I.split(`
`,1);r(new Error(Z[0]))}else r(new Error(P.localize(4,null,p,x)))})})})}spawnTerminal(d,u,a){const t=u.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):xt.getDefaultTerminalLinuxReady();return new Promise((o,s)=>{i.then(r=>{const l=a?{cwd:a}:void 0,p=d.spawn(r,[],l);p.on("error",s),p.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return xt._DEFAULT_TERMINAL_LINUX_READY||(xt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{A.isLinux?await D.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),xt._DEFAULT_TERMINAL_LINUX_READY}};m.WAIT_MESSAGE=P.localize(3,null),m=je([Ue(0,(0,n.optional)(C.IConfigurationService))],m),e.LinuxExternalTerminalService=m;function E(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(P.localize(5,null,w.path)):w}function g(w){let d="";for(let u of w)u.indexOf(" ")>=0?d+='"'+u+'"':d+=u,d+=" ";return d}}),define(ge[203],pe([0,1,38,9,202,31]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function A(b,h){if(!D)if(y.isWindows)D=new R.WindowsExternalTerminalService(void 0);else if(y.isMacintosh)D=new R.MacExternalTerminalService(void 0);else if(y.isLinux)D=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const c=h.getConfiguration("terminal");return D.runInTerminal(b.title,b.cwd,b.args,b.env||{},c.external||{})}e.runInExternalTerminal=A;function C(b,h){return new Promise((c,m)=>{let E="";const g=_.spawn(b,h);g.pid&&g.stdout.on("data",w=>{E+=w.toString()}),g.on("error",w=>{m(w)}),g.on("close",w=>{c(E)})})}function n(b){return b?y.isWindows?C("wmic",["process","get","ParentProcessId"]).then(h=>h.split(`\r
`).some(m=>parseInt(m)===b),h=>!0):C("/usr/bin/pgrep",["-lP",String(b)]).then(h=>{const c=h.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var T;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(T||(T={}));function k(b,h,c,m){b=b.trim().toLowerCase();let E;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?E=1:b.indexOf("cmd.exe")>=0?E=0:b.indexOf("bash")>=0?E=2:y.isWindows?E=0:E=2;let g,w=" ";switch(E){case 1:if(g=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),c){const u=(0,P.getDriveLetter)(c);u&&(w+=`${u}:; `),w+=`cd ${g(c)}; `}if(m)for(let u in m){const a=m[u];a===null?w+=`Remove-Item env:${u}; `:w+=`\${env:${u}}='${a}'; `}if(h.length>0){const u=g(h.shift());w+=u[0]==="'"?`& ${u} `:`${u} `;for(let a of h)w+=`${g(a)} `}break;case 0:if(g=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),c){const u=(0,P.getDriveLetter)(c);u&&(w+=`${u}: && `),w+=`cd ${g(c)} && `}if(m){w+='cmd /C "';for(let u in m){let a=m[u];a===null?w+=`set "${u}=" && `:(a=a.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),w+=`set "${u}=${a}" && `)}}for(let u of h)w+=`${g(u)} `;m&&(w+='"');break;case 2:g=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const d=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(c&&(w+=`cd ${g(c)} ; `),m){w+="/usr/bin/env";for(let u in m){const a=m[u];a===null?w+=` -u ${d(u)}`:w+=` ${d(`${u}=${a}`)}`}w+=" "}for(let u of h)w+=`${g(u)} `;break}return w}e.prepareCommand=k}),define(ge[85],pe([0,1,34,11,7,9,80]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(I){I[I.Markdown=1]="Markdown",I[I.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},runState:C.Idle,trusted:!0};var n;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle",I[I.Success=3]="Success",I[I.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var T;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.CellClearOutput=3]="CellClearOutput",I[I.CellsClearOutput=4]="CellsClearOutput",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.OutputsSplice=6]="OutputsSplice",I[I.Move=7]="Move",I[I.Unknown=8]="Unknown",I[I.CellContent=9]="CellContent",I[I.OutputItems=10]="OutputItems"})(b=e.CellEditType||(e.CellEditType={}));function h(I){const L=c.parse(I);return L?L.notebook.toString():I.toString()}e.getCellUndoRedoComparisonKey=h;var c;(function(I){I.scheme=y.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function x($,M){return $.with({scheme:I.scheme,fragment:`ch${M.toString().padStart(7,"0")}${$.scheme!==y.Schemas.file?$.scheme:""}`})}I.generate=x;function Z($){if($.scheme===I.scheme){const M=L.exec($.fragment);if(!!M)return{handle:Number(M[1]),notebook:$.with({scheme:$.fragment.substr(M[0].length)||y.Schemas.file,fragment:null})}}}I.parse=Z;function z($,M){return $.with({scheme:y.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${$.scheme!==y.Schemas.file?$.scheme:""}`})}I.generateCellMetadataUri=z;function B($){if($.scheme===y.Schemas.vscodeNotebookCellMetadata){const M=L.exec($.fragment);if(!!M)return{handle:Number(M[1]),notebook:$.with({scheme:$.fragment.substr(M[0].length)||y.Schemas.file,fragment:null})}}}I.parseCellMetadataUri=B})(c=e.CellUri||(e.CellUri={}));const m=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(I){var L,x;return(x=(L=m.get(I))===null||L===void 0?void 0:L.alwaysSecure)!==null&&x!==void 0?x:!1}e.mimeTypeIsAlwaysSecure=E;function g(I){var L,x;return(x=(L=m.get(I))===null||L===void 0?void 0:L.supportedByCore)!==null&&x!==void 0?x:!1}e.mimeTypeSupportedByCore=g;function w(I){var L,x;return(x=(L=m.get(I))===null||L===void 0?void 0:L.mergeable)!==null&&x!==void 0?x:!1}e.mimeTypeIsMergeable=w;function d(I,L){return P.isWindows&&(I=I.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),_.match(I,L)}function u(I,L,x){let Z=0;for(let z=0;z<L.length;z++){if(d(L[z],I))return Z;Z++}for(let z=0;z<x.length;z++){if(d(x[z],I))return Z;Z++}return Z}function a(I,L,x){return I.sort((Z,z)=>u(Z,L,x)-u(z,L,x))}e.sortMimeTypes=a;function t(I,L,x,Z=(z,B)=>z===B){const z=[];function B(U,F,N){if(!(F===0&&N.length===0)){const O=z[z.length-1];O&&O.start+O.deleteCount===U?(O.deleteCount+=F,O.toInsert.push(...N)):z.push({start:U,deleteCount:F,toInsert:N})}}let $=0,M=0;for(;;){if($===I.length){B($,0,L.slice(M));break}if(M===L.length){B($,I.length-$,[]);break}const U=I[$],F=L[M];if(Z(U,F)){$+=1,M+=1;continue}x(F)?(B($,1,[]),$+=1):(B($,0,[F]),M+=1)}return z}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new D.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(I){I.default="default",I.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(I){const L=I;return!!((typeof L.include=="string"||_.isRelativePattern(L.include))&&(typeof L.exclude=="string"||_.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=o;function s(I,L,x){if(Array.isArray(I.viewType)&&I.viewType.indexOf(L)>=0||I.viewType===L)return!0;if(I.filenamePattern){let Z=o(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,z=o(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(_.match(Z,(0,R.basename)(x.fsPath).toLowerCase()))return!(z&&_.match(z,(0,R.basename)(x.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class r{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let x=0;x<this.textModel.cells.length;x++)L[x]=this.textModel.cells[x].getHashValue();return L}}e.CellSequence=r,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var l;(function(I){I[I.LEFT=0]="LEFT",I[I.RIGHT=1]="RIGHT"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function p(I){I.sort((x,Z)=>x-Z);const L=I.shift();return L===void 0?[]:I.reduce(function(x,Z){return Z<=x[0][1]?x[0][1]=Z+1:x.unshift([Z,Z+1]),x},[[L,L+1]]).reverse().map(x=>({start:x[0],end:x[1]}))}e.cellIndexesToRanges=p;function S(I){return I.reduce((x,Z)=>{for(let z=Z.start;z<Z.end;z++)x.push(z);return x},[])}e.cellRangesToIndexes=S;function f(I){const L=I.sort((Z,z)=>Z.start-z.start),x=L[0];return x?L.reduce((Z,z)=>{const B=Z[Z.length-1];return B.end>=z.start?B.end=Math.max(B.end,z.end):Z.push(z),Z},[x]):[]}e.reduceRanges=f;function v(I,L){return L.start>=I.start&&L.end<=I.end}e.cellRangeContains=v}),define(ge[204],pe([0,1,171,4,80]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,y.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[205],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=_;function y(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=y}),define(ge[206],pe([0,1,7,9,133]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(a,t){if(!!t)if(y.isWindows)for(const i in t){let o=i;for(const r in a)if(i.toLowerCase()===r.toLowerCase()){o=r;break}const s=t[i];D(a,o,s)}else Object.keys(t).forEach(i=>{const o=t[i];D(a,i,o)})}e.mergeEnvironments=P;function D(a,t,i){typeof i=="string"?a[t]=i:delete a[t]}function A(a,t,i,o){a.TERM_PROGRAM="vscode",t&&(a.TERM_PROGRAM_VERSION=t),T(a,o)&&(a.LANG=k(i)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=A;function C(a,t){if(!!t)for(const i of Object.keys(t)){const o=t[i];o&&(a[i]=o)}}function n(a,t){return Object.keys(t).forEach(i=>{const o=t[i];if(typeof o=="string")try{t[i]=a(o)}catch(s){t[i]=o}}),t}function T(a,t){if(t==="on")return!0;if(t==="auto"){const i=a.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function k(a){const t=a?a.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=k;function b(a,t,i,o,s,r){if(a.cwd){const p=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,S=h(p,i);return c(S||p)}let l;return!a.ignoreConfigurationCwd&&s&&(i&&(s=h(s,i,r)),s&&(_.isAbsolute(s)?l=s:o&&(l=_.join(o.fsPath,s)))),l||(l=o?o.fsPath:t||""),c(l)}e.getCwd=b;function h(a,t,i){if(t)try{return t(a)}catch(o){i==null||i.error("Could not resolve terminal cwd",o);return}return a}function c(a){return y.platform===3&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function m(a){let t=a;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=m;function E(a,t){if(!!t)return i=>t.resolve(a,i)}e.createVariableResolver=E;function g(a,t,i,o,s,r,l,p,S=y.platform){let f=null;p&&(f=d(a,t,"automationShell",S)),f||(f=d(a,t,"shell",S));let v=f||i;if(S===3&&!o&&s){const I=_.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();v&&v.toLowerCase().indexOf(I)===0&&(v=_.join(s,"System32",v.substr(I.length+1)))}if(v&&S===3&&(v=v.replace(/\//g,"\\")),r)try{v=r(v)}catch(I){l.error("Could not resolve shell",I)}return v}e.getDefaultShell=g;function w(a,t,i,o,s,r=y.platform){if(i&&d(a,t,"automationShell",r))return[];const l=r===3?"windows":r===1?"osx":"linux",p=a(`terminal.integrated.shellArgs.${l}`);let S=(t?p.value:p.userValue)||p.defaultValue;if(!S)return[];if(typeof S=="string"&&r===3)return o?o(S):S;if(o){const f=[];for(const v of S)try{f.push(o(v))}catch(I){s.error(`Could not resolve terminal.integrated.shellArgs.${l}`,I),f.push(v)}S=f}return S}e.getDefaultShellArgs=w;function d(a,t,i,o=y.platform){const r=a(`terminal.integrated.${i}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?r.value:r.userValue)||r.defaultValue}function u(a,t,i,o,s,r,l){let p={};if(a.strictEnv)C(p,a.env);else{C(p,l);const S=Object.assign({},o?t.value:t.userValue);i&&(S&&n(i,S),a.env&&n(i,a.env)),(0,R.sanitizeProcessEnvironment)(p,"VSCODE_IPC_HOOK_CLI"),P(p,S),P(p,a.env),A(p,s,y.locale,r)}return p}e.createTerminalEnvironment=u});var en=this&&this.__asyncValues||function(Y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Y[Symbol.asyncIterator],_;return e?e.call(Y):(Y=typeof __values=="function"?__values(Y):Y[Symbol.iterator](),_={},y("next"),y("throw"),y("return"),_[Symbol.asyncIterator]=function(){return this},_);function y(P){_[P]=Y[P]&&function(D){return new Promise(function(A,C){D=Y[P](D),R(A,C,D.done,D.value)})}}function R(P,D,A,C){Promise.resolve(C).then(function(n){P({value:n,done:A})},D)}};define(ge[207],pe([0,1,37,9,12,7,100,187,38]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;function n(m,E,g,w,d,u){var a,t,i;return y.isWindows?T(m,E,g==null?void 0:g.quickLaunchWslProfiles,(a=g==null?void 0:g.profiles)===null||a===void 0?void 0:a.windows,w,d,u):h(m,y.isMacintosh?(t=g==null?void 0:g.profiles)===null||t===void 0?void 0:t.osx:(i=g==null?void 0:g.profiles)===null||i===void 0?void 0:i.linux)}e.detectAvailableProfiles=n;async function T(m,E,g,w,d,u,a){const t=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),i=`${process.env.windir}\\${t?"Sysnative":"System32"}`;let o=!1;(0,A.getWindowsBuildNumber)()>=16299&&(o=!0);let s=[{profileName:"Command Prompt",paths:[`${i}\\cmd.exe`]},{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]},{profileName:"Cygwin",paths:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["-l"]},...await b(`${i}\\${o?"wsl.exe":"bash.exe"}`,g,E),...await k()];const r=[];s.forEach(f=>r.push(c(f.profileName,f.paths,a,f.args)));const l=await Promise.all(r);let p=(0,R.coalesce)(l);if(!m)return p;let S=[];if(p&&w){for(const[f,v]of Object.entries(w))if(v!==null)if(v.pathOrPaths){let I;const L=v;if(Array.isArray(L.pathOrPaths)){let x=[];for(const Z of L.pathOrPaths){const z=d==null?void 0:d.resolve(u,Z);z?x.push(z):a?x.push(Z):E==null||E.trace(`Could not resolve path ${Z} in workspace folder ${u}`)}I=p==null?void 0:p.find(Z=>x.includes(Z.path)),I||E==null||E.trace(`Could not detect path ${JSON.stringify(x)}`)}else{let x=d==null?void 0:d.resolve(u,L.pathOrPaths);x?I=p==null?void 0:p.find(Z=>Z.path===x):a?x=L.pathOrPaths:E==null||E.trace(`Could not resolve path ${L.pathOrPaths} in workspace folder ${u}`),I||E==null||E.trace(`Could not detect path ${x}`)}I&&(L.args?S==null||S.push({profileName:f,path:I.path,args:L.args}):S==null||S.push({profileName:f,path:I.path}))}else if(v.source){let I=v.source;const L=p==null?void 0:p.find(x=>x.profileName===I.toString());L?S==null||S.push({profileName:f,path:L.path,args:L.args}):E==null||E.trace(`No source with key ${I}`)}else E==null||E.trace("Entry in terminal.profiles.windows is not of type ITerminalExecutable or Source",f,v)}else E==null||E.trace(`No detected profiles ${JSON.stringify(p)} or ${JSON.stringify(w)}`);return S.find(f=>f.path.endsWith("pwsh.exe"))&&(S=S.filter(f=>f.profileName!=="Windows PowerShell")),g&&S.push(...p.filter(f=>f.path.endsWith("wsl.exe"))),S}async function k(){var m,E;let g=[];try{for(var w=en((0,D.enumeratePowerShellInstallations)()),d;d=await w.next(),!d.done;){const u=d.value;g.push({profileName:u.displayName,paths:[u.exePath]})}}catch(u){m={error:u}}finally{try{d&&!d.done&&(E=w.return)&&await E.call(w)}finally{if(m)throw m.error}}return g}async function b(m,E,g){let w=[];if(E){const d=await new Promise((u,a)=>{C.exec("wsl.exe -l",(t,i)=>{if(t)return a("Problem occurred when getting wsl distros");u(i)})});if(d){let u=new RegExp(/[\r?\n]/),a=d.split(u).filter(t=>t.trim().length>0&&t!=="");a.shift();for(let t of a)if(t=t.replace(/\u0000/g,"").replace(/ \(Default\)$/,""),t!==""&&t!=="docker-desktop-data"){const i={profileName:`${t} (WSL)`,paths:[m],args:["-d",`${t}`]};w.push(i)}return w}}return[]}async function h(m,E){const w=(await _.promises.readFile("/etc/shells","utf8")).split(`
`).filter(t=>t.trim().indexOf("#")!==0&&t.trim().length>0);let d=[],u=[];for(const t of w)d.push({profileName:(0,P.basename)(t),path:t}),u.find(i=>i.profileName===(0,P.basename)(t))||u.push({profileName:(0,P.basename)(t),path:t});if(!m)return d;const a=[];for(const[t,i]of Object.entries(E))if(i.pathOrPaths){const s=i.pathOrPaths;if(Array.isArray(s))for(const r of s){const l=d.find(p=>p.path.endsWith(r));if(l){a.push({profileName:t,path:l.path});break}}else{const r=d.find(l=>l.path.endsWith(s));r&&a.push({profileName:t,path:r.path})}}return a}async function c(m,E,g,w){if(E.length===0)return Promise.resolve(void 0);const d=E.shift();if(d==="")return c(m,E,g,w);if(g){if(g.stat(d))return w?{profileName:m,path:d,args:w}:{profileName:m,path:d}}else try{const u=await _.promises.stat((0,P.normalize)(d));if(u.isFile()||u.isSymbolicLink())return w?{profileName:m,path:d,args:w}:{profileName:m,path:d}}catch(u){try{const a=await _.promises.lstat((0,P.normalize)(d));if(a.isFile()||a.isSymbolicLink())return w?{profileName:m,path:d,args:w}:{profileName:m,path:d}}catch(a){}}return c(m,E,g,w)}}),define(ge[208],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var _;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",D[D.DeltaRootsComplete=4]="DeltaRootsComplete"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));const y=(D,A)=>`${D}:${A.toString()}`;e.getTestSubscriptionKey=y;class R{add(A){}update(A){}remove(A,C){}complete(){}}e.IncrementalChangeCollector=R;class P{constructor(){this.items=new Map,this.roots=new Set}apply(A){const C=this.createChangeCollector();for(const n of A)switch(n[0]){case 0:{const T=n[1];if(T.parent){if(this.items.has(T.parent)){const k=this.items.get(T.parent);k.children.add(T.item.extId);const b=this.createItem(T,k);this.items.set(T.item.extId,b),C.add(b)}}else{this.roots.add(T.item.extId);const k=this.createItem(T);this.items.set(T.item.extId,k),C.add(k)}break}case 1:{const T=n[1],k=this.items.get(T.item.extId);k&&(Object.assign(k.item,T.item),C.update(k));break}case 2:{const T=this.items.get(n[1]);if(!T)break;T.parent?this.items.get(T.parent).children.delete(T.item.extId):this.roots.delete(T.item.extId);const k=[[n[1]]];for(;k.length;)for(const b of k.pop()){const h=this.items.get(b);h&&(k.push(h.children),this.items.delete(b),C.remove(h,h!==T))}break}case 3:this.updateBusyProviders(n[1]);break;case 4:this.updatePendingRoots(n[1]);break}C.complete()}updateBusyProviders(A){}updatePendingRoots(A){}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=P}),define(ge[209],pe([0,1,7,30,15,22,9,75,172]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,b,h){if(this._contributedVariables=new Map,this._context=k,this._labelService=b,h)if(D.isWindows){const c=Object.create(null);this._envVariables=c,Object.keys(h).forEach(m=>{c[m.toLowerCase()]=h[m]})}else this._envVariables=h}resolve(k,b){return this.recursiveResolve(k?k.uri:void 0,b)}resolveAnyBase(k,b,h,c){const m=P.deepClone(b);return D.isWindows&&m.windows?Object.keys(m.windows).forEach(E=>m[E]=m.windows[E]):D.isMacintosh&&m.osx?Object.keys(m.osx).forEach(E=>m[E]=m.osx[E]):D.isLinux&&m.linux&&Object.keys(m.linux).forEach(E=>m[E]=m.linux[E]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(k?k.uri:void 0,m,h,c)}resolveAny(k,b,h){return this.resolveAnyBase(k,b,h)}resolveAnyMap(k,b,h){const c=new Map;return{newConfig:this.resolveAnyBase(k,b,h,c),resolvedVariables:c}}resolveWithInteractionReplace(k,b,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,b)}recursiveResolve(k,b,h,c){if(R.isString(b))return this.resolveString(k,b,h,c);if(R.isArray(b))return b.map(m=>this.recursiveResolve(k,m,h,c));if(R.isObject(b)){let m=Object.create(null);return Object.keys(b).forEach(E=>{const g=this.resolveString(k,E,h,c);m[g]=this.recursiveResolve(k,b[E],h,c)}),m}return b}resolveString(k,b,h,c){return b.replace(n.VARIABLE_REGEXP,(E,g)=>{if(g.includes(n.VARIABLE_LHS))return E;let w=this.evaluateSingleVariable(E,g,k,h);return c&&c.set(g,w),w})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,b,h,c){let m;const E=b.split(":");E.length>1&&(b=E[0],m=E[1]);const g=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,C.localize)(0,null,k))},w=()=>{const u=g();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,C.localize)(1,null,k,_.basename(u)))},d=()=>{if(m){const u=this._context.getFolderUri(m);if(u)return u;throw new Error((0,C.localize)(2,null,k,m))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,k)):new Error((0,C.localize)(4,null,k))};switch(b){case"env":if(m){if(this._envVariables){const u=this._envVariables[D.isWindows?m.toLowerCase():m];if(R.isString(u))return u}return""}throw new Error((0,C.localize)(5,null,k));case"config":if(m){const u=this._context.getConfigurationValue(h,m);if(R.isUndefinedOrNull(u))throw new Error((0,C.localize)(6,null,k,m));if(R.isObject(u))throw new Error((0,C.localize)(7,null,k,m));return u}throw new Error((0,C.localize)(8,null,k));case"command":return this.resolveFromMap(k,m,c,"command");case"input":return this.resolveFromMap(k,m,c,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return h||m?(0,A.normalizeDriveLetter)(this.fsPath(d())):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(d()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,C.localize)(9,null,k));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,C.localize)(10,null,k));case"file":return g();case"fileWorkspaceFolder":return w();case"relativeFile":return h||m?_.relative(this.fsPath(d()),g()):g();case"relativeFileDirname":const t=_.dirname(g());if(h||m){const r=_.relative(this.fsPath(d()),t);return r.length===0?".":r}return t;case"fileDirname":return _.dirname(g());case"fileExtname":return _.extname(g());case"fileBasename":return _.basename(g());case"fileBasenameNoExtension":const i=_.basename(g());return i.slice(0,i.length-_.extname(i).length);case"fileDirnameBasename":return _.basename(_.dirname(g()));case"execPath":const o=this._context.getExecPath();return o||k;case"execInstallFolder":const s=this._context.getAppRoot();return s||k;case"pathSeparator":return _.sep;default:try{const r=m?`${b}:${m}`:b;return this.resolveFromMap(k,r,c,void 0)}catch(r){return k}}}}resolveFromMap(k,b,h,c){if(b&&h){const m=c===void 0?h[b]:h[c+":"+b];if(typeof m=="string")return m;throw new Error((0,C.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[210],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var y;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var D;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var A;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(A=e.MergeGroupMode||(e.MergeGroupMode={}));var C;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ge[211],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,79,8,173,2,43,94,110,211,15,281,58,22,12,85]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(be){function he(ee){const{selectionStartLineNumber:Ae,selectionStartColumn:Re,positionLineNumber:et,positionColumn:Ge}=ee,rt=new y.Position(Ae-1,Re-1),lt=new y.Position(et-1,Ge-1);return new y.Selection(rt,lt)}be.to=he;function ce(ee){const{anchor:Ae,active:Re}=ee;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}be.from=ce})(E=e.Selection||(e.Selection={}));var g;(function(be){function he(ee){if(!!ee){const{start:Ae,end:Re}=ee;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}}be.from=he;function ce(ee){if(!!ee){const{startLineNumber:Ae,startColumn:Re,endLineNumber:et,endColumn:Ge}=ee;return new y.Range(Ae-1,Re-1,et-1,Ge-1)}}be.to=ce})(g=e.Range||(e.Range={}));var w;(function(be){function he(ce){switch(ce){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}be.to=he})(w=e.TokenType||(e.TokenType={}));var d;(function(be){function he(ee){return new y.Position(ee.lineNumber-1,ee.column-1)}be.to=he;function ce(ee){return{lineNumber:ee.line+1,column:ee.character+1}}be.from=ce})(d=e.Position||(e.Position={}));var u;(function(be){function he(ee){switch(ee){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}be.from=he;function ce(ee){switch(ee){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}be.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(be){function he(ee){let Ae;return ee.code&&((0,T.isString)(ee.code)||(0,T.isNumber)(ee.code)?Ae=String(ee.code):Ae={value:String(ee.code.value),target:ee.code.target}),Object.assign(Object.assign({},g.from(ee.range)),{message:ee.message,source:ee.source,code:Ae,severity:i.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(t.from),tags:Array.isArray(ee.tags)?(0,c.coalesce)(ee.tags.map(u.from)):void 0})}be.from=he;function ce(ee){var Ae;const Re=new y.Diagnostic(g.to(ee),ee.message,i.to(ee.severity));return Re.source=ee.source,Re.code=(0,T.isString)(ee.code)?ee.code:(Ae=ee.code)===null||Ae===void 0?void 0:Ae.value,Re.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(t.to),Re.tags=ee.tags&&(0,c.coalesce)(ee.tags.map(u.to)),Re}be.to=ce})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(ee){return Object.assign(Object.assign({},g.from(ee.location.range)),{message:ee.message,resource:ee.location.uri})}be.from=he;function ce(ee){return new y.DiagnosticRelatedInformation(new y.Location(ee.resource,g.to(ee)),ee.message)}be.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(be){function he(ee){switch(ee){case y.DiagnosticSeverity.Error:return C.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return C.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return C.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return C.MarkerSeverity.Hint}return C.MarkerSeverity.Error}be.from=he;function ce(ee){switch(ee){case C.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case C.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case C.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case C.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}be.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(be){function he(ee){return typeof ee=="number"&&ee>=y.ViewColumn.One?ee-1:ee===y.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}be.from=he;function ce(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ce})(o=e.ViewColumn||(e.ViewColumn={}));function s(be){return typeof be.range!="undefined"}function r(be){return be.length===0?!0:!!s(be[0])}e.isDecorationOptionsArr=r;var l;(function(be){function he(Ge){return Ge.map(be.from)}be.fromMany=he;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ee(Ge){let rt;if(ce(Ge)){const{language:dt,value:at}=Ge;rt={value:"```"+dt+`
`+at+"\n```\n"}}else y.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const lt=Object.create(null);rt.uris=lt;const Xe=dt=>{try{let at=P.URI.parse(dt,!0);at=at.with({query:Ae(at.query,lt)}),lt[dt]=at}catch(at){}return""},it=new k.Renderer;return it.link=Xe,it.image=dt=>Xe(A.parseHrefAndDimensions(dt).href),k(rt.value,{renderer:it}),rt}be.from=ee;function Ae(Ge,rt){if(!Ge)return Ge;let lt;try{lt=(0,b.parse)(Ge)}catch(it){}if(!lt)return Ge;let Xe=!1;return lt=(0,h.cloneAndChange)(lt,it=>{if(P.URI.isUri(it)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=it,Xe=!0,dt}else return}),Xe?JSON.stringify(lt):Ge}function Re(Ge){const rt=new y.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}be.to=Re;function et(Ge){if(!!Ge)return typeof Ge=="string"?Ge:be.from(Ge)}be.fromStrict=et})(l=e.MarkdownString||(e.MarkdownString={}));function p(be){return r(be)?be.map(he=>({range:g.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?l.fromMany(he.hoverMessage):he.hoverMessage?l.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:g.from(he)}))}e.fromRangeOrRangeWithMessage=p;function S(be){return typeof be=="undefined"?be:typeof be=="string"?P.URI.file(be):be}e.pathOrURIToURI=S;var f;(function(be){function he(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?S(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}be.from=he})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(be){function he(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}be.from=he})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var I;(function(be){function he(ce){if(typeof ce=="undefined")return ce;switch(ce){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(I=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(be){function he(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?I.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?v.from(ce.light):void 0,dark:ce.dark?v.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}be.from=he})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(be){function he(ee){return{text:ee.newText,eol:ee.newEol&&ie.from(ee.newEol),range:g.from(ee.range)}}be.from=he;function ce(ee){const Ae=new y.TextEdit(g.to(ee.range),ee.text);return Ae.newEol=typeof ee.eol=="undefined"?void 0:ie.to(ee.eol),Ae}be.to=ce})(x=e.TextEdit||(e.TextEdit={}));var Z;(function(be){function he(ee,Ae,Re){var et,Ge,rt;const lt={edits:[]};if(ee instanceof y.WorkspaceEdit)for(let Xe of ee._allEntries())if(Xe._type===1)lt.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const it=Ae==null?void 0:Ae.getDocument(Xe.uri);lt.edits.push({_type:2,resource:Xe.uri,edit:x.from(Xe.edit),modelVersionId:it==null?void 0:it.version,metadata:Xe.metadata})}else Xe._type===3?lt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(et=Re==null?void 0:Re.lookupNotebookDocument(Xe.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Xe._type===4?(Xe.newOutputs&&lt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(Ee.from)}}),Xe.newMetadata&&lt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:3,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?lt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ge=Re==null?void 0:Re.lookupNotebookDocument(Xe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(le.from)}}):Xe._type===6&&lt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:10,index:Xe.index,outputId:Xe.outputId,items:((rt=Xe.newOutputItems)===null||rt===void 0?void 0:rt.map(me.from))||[],append:Xe.append}});return lt}be.from=he;function ce(ee){const Ae=new y.WorkspaceEdit;for(const Re of ee.edits)Re.edit?Ae.replace(P.URI.revive(Re.resource),g.to(Re.edit.range),Re.edit.text):Ae.renameFile(P.URI.revive(Re.oldUri),P.URI.revive(Re.newUri),Re.options);return Ae}be.to=ce})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(be){const he=Object.create(null);he[y.SymbolKind.File]=0,he[y.SymbolKind.Module]=1,he[y.SymbolKind.Namespace]=2,he[y.SymbolKind.Package]=3,he[y.SymbolKind.Class]=4,he[y.SymbolKind.Method]=5,he[y.SymbolKind.Property]=6,he[y.SymbolKind.Field]=7,he[y.SymbolKind.Constructor]=8,he[y.SymbolKind.Enum]=9,he[y.SymbolKind.Interface]=10,he[y.SymbolKind.Function]=11,he[y.SymbolKind.Variable]=12,he[y.SymbolKind.Constant]=13,he[y.SymbolKind.String]=14,he[y.SymbolKind.Number]=15,he[y.SymbolKind.Boolean]=16,he[y.SymbolKind.Array]=17,he[y.SymbolKind.Object]=18,he[y.SymbolKind.Key]=19,he[y.SymbolKind.Null]=20,he[y.SymbolKind.EnumMember]=21,he[y.SymbolKind.Struct]=22,he[y.SymbolKind.Event]=23,he[y.SymbolKind.Operator]=24,he[y.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof he[Ae]=="number"?he[Ae]:6}be.from=ce;function ee(Ae){for(const Re in he)if(he[Re]===Ae)return Number(Re);return y.SymbolKind.Property}be.to=ee})(z=e.SymbolKind||(e.SymbolKind={}));var B;(function(be){function he(ee){switch(ee){case y.SymbolTag.Deprecated:return 1}}be.from=he;function ce(ee){switch(ee){case 1:return y.SymbolTag.Deprecated}}be.to=ce})(B=e.SymbolTag||(e.SymbolTag={}));var $;(function(be){function he(ee){return{name:ee.name,kind:z.from(ee.kind),tags:ee.tags&&ee.tags.map(B.from),containerName:ee.containerName,location:O.from(ee.location)}}be.from=he;function ce(ee){const Ae=new y.SymbolInformation(ee.name,z.to(ee.kind),ee.containerName,O.to(ee.location));return Ae.tags=ee.tags&&ee.tags.map(B.to),Ae}be.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(be){function he(ee){var Ae,Re;const et={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:g.from(ee.range),selectionRange:g.from(ee.selectionRange),kind:z.from(ee.kind),tags:(Re=(Ae=ee.tags)===null||Ae===void 0?void 0:Ae.map(B.from))!==null&&Re!==void 0?Re:[]};return ee.children&&(et.children=ee.children.map(he)),et}be.from=he;function ce(ee){const Ae=new y.DocumentSymbol(ee.name,ee.detail,z.to(ee.kind),g.to(ee.range),g.to(ee.selectionRange));return(0,c.isNonEmptyArray)(ee.tags)&&(Ae.tags=ee.tags.map(B.to)),ee.children&&(Ae.children=ee.children.map(ce)),Ae}be.to=ce})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(be){function he(ce){const ee=new y.CallHierarchyItem(z.to(ce.kind),ce.name,ce.detail||"",P.URI.revive(ce.uri),g.to(ce.range),g.to(ce.selectionRange));return ee._sessionId=ce._sessionId,ee._itemId=ce._itemId,ee}be.to=he})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(be){function he(ce){return new y.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(ee=>g.to(ee)))}be.to=he})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(be){function he(ce){return new y.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(ee=>g.to(ee)))}be.to=he})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(be){function he(ee){return{range:ee.range&&g.from(ee.range),uri:ee.uri}}be.from=he;function ce(ee){return new y.Location(P.URI.revive(ee.uri),g.to(ee.range))}be.to=ce})(O=e.location||(e.location={}));var V;(function(be){function he(ee){const Ae=ee,Re=ee;return{originSelectionRange:Ae.originSelectionRange?g.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Re.uri,range:g.from(Ae.targetRange?Ae.targetRange:Re.range),targetSelectionRange:Ae.targetSelectionRange?g.from(Ae.targetSelectionRange):void 0}}be.from=he;function ce(ee){return{targetUri:P.URI.revive(ee.uri),targetRange:g.to(ee.range),targetSelectionRange:ee.targetSelectionRange?g.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?g.to(ee.originSelectionRange):void 0}}be.to=ce})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(ee){return{range:g.from(ee.range),contents:l.fromMany(ee.contents)}}be.from=he;function ce(ee){return new y.Hover(ee.contents.map(l.to),g.to(ee.range))}be.to=ce})(q=e.Hover||(e.Hover={}));var Q;(function(be){function he(ee){return{range:g.from(ee.range),expression:ee.expression}}be.from=he;function ce(ee){return new y.EvaluatableExpression(g.to(ee.range),ee.expression)}be.to=ce})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(be){function he(ee){if(ee instanceof y.InlineValueText)return{type:"text",range:g.from(ee.range),text:ee.text};if(ee instanceof y.InlineValueVariableLookup)return{type:"variable",range:g.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ce(ee){switch(ee.type){case"text":return{range:g.to(ee.range),text:ee.text};case"variable":return{range:g.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:g.to(ee.range),expression:ee.expression}}}be.to=ce})(fe=e.InlineValue||(e.InlineValue={}));var _e;(function(be){function he(ee){return{frameId:ee.frameId,stoppedLocation:g.from(ee.stoppedLocation)}}be.from=he;function ce(ee){return new y.InlineValueContext(ee.frameId,g.to(ee.stoppedLocation))}be.to=ce})(_e=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(be){function he(ee){return{range:g.from(ee.range),kind:ee.kind}}be.from=he;function ce(ee){return new y.DocumentHighlight(g.to(ee.range),ee.kind)}be.to=ce})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(be){function he(ce){switch(ce){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}be.to=he})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(be){function he(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}be.to=he})(Fe=e.CompletionContext||(e.CompletionContext={}));var j;(function(be){function he(ee){switch(ee){case y.CompletionItemTag.Deprecated:return 1}}be.from=he;function ce(ee){switch(ee){case 1:return y.CompletionItemTag.Deprecated}}be.to=ce})(j=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(be){const he=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function ce(Re){var et;return(et=he.get(Re))!==null&&et!==void 0?et:9}be.from=ce;const ee=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function Ae(Re){var et;return(et=ee.get(Re))!==null&&et!==void 0?et:y.CompletionItemKind.Property}be.to=Ae})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(be){function he(ce,ee){var Ae;const Re=new y.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Re.label2=ce.label),Re.insertText=ce.insertText,Re.kind=X.to(ce.kind),Re.tags=(Ae=ce.tags)===null||Ae===void 0?void 0:Ae.map(j.to),Re.detail=ce.detail,Re.documentation=A.isMarkdownString(ce.documentation)?l.to(ce.documentation):ce.documentation,Re.sortText=ce.sortText,Re.filterText=ce.filterText,Re.preselect=ce.preselect,Re.commitCharacters=ce.commitCharacters,D.Range.isIRange(ce.range)?Re.range=g.to(ce.range):typeof ce.range=="object"&&(Re.range={inserting:g.to(ce.range.insert),replacing:g.to(ce.range.replace)}),Re.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Re.insertText=new y.SnippetString(ce.insertText):(Re.insertText=ce.insertText,Re.textEdit=Re.range instanceof y.Range?new y.TextEdit(Re.range,Re.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Re.additionalTextEdits=ce.additionalTextEdits.map(et=>x.to(et))),Re.command=ee&&ce.command?ee.fromInternal(ce.command):void 0,Re}be.to=he})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(be){function he(ee){return{label:ee.label,documentation:ee.documentation?l.fromStrict(ee.documentation):void 0}}be.from=he;function ce(ee){return{label:ee.label,documentation:A.isMarkdownString(ee.documentation)?l.to(ee.documentation):ee.documentation}}be.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var ve;(function(be){function he(ee){return{label:ee.label,documentation:ee.documentation?l.fromStrict(ee.documentation):void 0,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.from):[],activeParameter:ee.activeParameter}}be.from=he;function ce(ee){return{label:ee.label,documentation:A.isMarkdownString(ee.documentation)?l.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.to):[],activeParameter:ee.activeParameter}}be.to=ce})(ve=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(be){function he(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ve.from):[]}}be.from=he;function ce(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ve.to):[]}}be.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(be){function he(ee){var Ae;return{text:ee.text,range:g.from(ee.range),kind:we.from((Ae=ee.kind)!==null&&Ae!==void 0?Ae:y.InlineHintKind.Other),description:ee.description&&l.fromStrict(ee.description),whitespaceBefore:ee.whitespaceBefore,whitespaceAfter:ee.whitespaceAfter}}be.from=he;function ce(ee){const Ae=new y.InlineHint(ee.text,g.to(ee.range),we.to(ee.kind));return Ae.whitespaceAfter=ee.whitespaceAfter,Ae.whitespaceBefore=ee.whitespaceBefore,Ae.description=A.isMarkdownString(ee.description)?l.to(ee.description):ee.description,Ae}be.to=ce})(Oe=e.InlineHint||(e.InlineHint={}));var we;(function(be){function he(ee){return ee}be.from=he;function ce(ee){return ee}be.to=ce})(we=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(be){function he(ee){return{range:g.from(ee.range),url:ee.target,tooltip:ee.tooltip}}be.from=he;function ce(ee){let Ae;if(ee.url)try{Ae=typeof ee.url=="string"?P.URI.parse(ee.url,!0):P.URI.revive(ee.url)}catch(Re){}return new y.DocumentLink(g.to(ee.range),Ae)}be.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Te;(function(be){function he(ee){const Ae=new y.ColorPresentation(ee.label);return ee.textEdit&&(Ae.textEdit=x.to(ee.textEdit)),ee.additionalTextEdits&&(Ae.additionalTextEdits=ee.additionalTextEdits.map(Re=>x.to(Re))),Ae}be.to=he;function ce(ee){return{label:ee.label,textEdit:ee.textEdit?x.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Ae=>x.from(Ae)):void 0}}be.from=ce})(Te=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(be){function he(ee){return new y.Color(ee[0],ee[1],ee[2],ee[3])}be.to=he;function ce(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}be.from=ce})(xe=e.Color||(e.Color={}));var ye;(function(be){function he(ee){return{range:g.from(ee.range)}}be.from=he;function ce(ee){return new y.SelectionRange(g.to(ee.range))}be.to=ce})(ye=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(be){function he(ce){switch(ce){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}be.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(be){function he(ee){switch(ee){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ce(ee){switch(ee){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}be.to=ce})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(be){function he(ee){if(ee===y.EndOfLine.CRLF)return 1;if(ee===y.EndOfLine.LF)return 0}be.from=he;function ce(ee){if(ee===1)return y.EndOfLine.CRLF;if(ee===0)return y.EndOfLine.LF}be.to=ce})(ie=e.EndOfLine||(e.EndOfLine={}));var Se;(function(be){function he(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(Se=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(be){function he(ce){const ee={start:ce.start+1,end:ce.end+1};return ce.kind&&(ee.kind=ze.from(ce.kind)),ee}be.from=he})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(be){function he(ce){if(ce)switch(ce){case y.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}be.from=he})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(be){function he(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?g.from(ce.selection):void 0,override:typeof ce.override=="boolean"?R.EditorOverride.DISABLED:void 0}}be.from=he})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(be){function he(ee){return ee instanceof y.RelativePattern||typeof ee=="string"?ee:ce(ee)?new y.RelativePattern(ee.base,ee.pattern):ee}be.from=he;function ce(ee){const Ae=ee;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var K;(function(be){function he(ce){if(ce){if(Array.isArray(ce))return ce.map(he);if(typeof ce=="string")return ce;{const ee=ce;return{language:ee.language,scheme:ee.scheme,pattern:typeof ee.pattern=="undefined"?void 0:Ye.from(ee.pattern),exclusive:ee.exclusive}}}else return}be.from=he})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(be){function he(ee){return{start:ee.start,end:ee.end}}be.from=he;function ce(ee){return new y.NotebookCellRange(ee.start,ee.end)}be.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var ue;(function(be){function he(ce){return new y.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.executionOrder,ce.runState,ce.runStartTime,ce.statusMessage,ce.lastRunDuration,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}be.to=he})(ue=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(be){function he(ee){return ee}be.from=he;function ce(ee){return new y.NotebookDocumentMetadata(ee.editable,ee.cellEditable,ee.cellHasExecutionOrder,ee.custom,ee.runState,ee.trusted)}be.to=ce})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(be){function he(ee){switch(ee){case y.NotebookCellKind.Markdown:return m.CellKind.Markdown;case y.NotebookCellKind.Code:default:return m.CellKind.Code}}be.from=he;function ce(ee){switch(ee){case m.CellKind.Markdown:return y.NotebookCellKind.Markdown;case m.CellKind.Code:default:return y.NotebookCellKind.Code}}be.to=ce})(ne=e.NotebookCellKind||(e.NotebookCellKind={}));var le;(function(be){function he(ce){return{cellKind:ne.from(ce.kind),language:ce.language,source:ce.source,metadata:ce.metadata,outputs:ce.outputs?ce.outputs.map(Ee.from):[]}}be.from=he})(le=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(be){function he(ee){return{mime:ee.mime,value:ee.value,metadata:ee.metadata}}be.from=he;function ce(ee){return new y.NotebookCellOutputItem(ee.mime,ee.value,ee.metadata)}be.to=ce})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ee;(function(be){function he(ee){return{outputId:ee.id,outputs:ee.outputs.map(me.from),metadata:ee.metadata}}be.from=he;function ce(ee){const Ae=ee.outputs.map(me.to);return new y.NotebookCellOutput(Ae,ee.outputId,ee.metadata)}be.to=ce})(Ee=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(be){function he(Re){if(Re!=null){if(Re instanceof y.RelativePattern||typeof Re=="string")return Re;if(Ae(Re))return new y.RelativePattern(Re.base,Re.pattern);if(ee(Re))return{include:Ye.from(Re.include)||void 0,exclude:Ye.from(Re.exclude)||void 0}}}be.from=he;function ce(Re){return typeof Re=="string"?Re:Ae(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}be.to=ce;function ee(Re){const et=Re,Ge=Ye.from(et.include);if(!(Ge&&Ge instanceof y.RelativePattern||typeof Ge=="string"))return!1;const rt=Ye.from(et.exclude);return!!(rt&&rt instanceof y.RelativePattern||typeof rt=="string")}function Ae(Re){const et=Re;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var $e;(function(be){function he(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?f.from(ce.top):void 0}}be.from=he})($e=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var qe;(function(be){function he(ee){return{state:ee.state,duration:ee.duration,messages:ee.messages.map(Qe.from)}}be.from=he;function ce(ee){const Ae=new y.TestState(ee.state);return Ae.duration=ee.duration,Ae.messages=ee.messages.map(Qe.to),Ae}be.to=ce})(qe=e.TestState||(e.TestState={}));var Qe;(function(be){function he(ee){return{message:l.fromStrict(ee.message)||"",severity:ee.severity,expectedOutput:ee.expectedOutput,actualOutput:ee.actualOutput,location:ee.location?O.from(ee.location):void 0}}be.from=he;function ce(ee){const Ae=new y.TestMessage(typeof ee.message=="string"?ee.message:l.to(ee.message));return Ae.severity=ee.severity,Ae.actualOutput=ee.actualOutput,Ae.expectedOutput=ee.expectedOutput,Ae}be.to=ce})(Qe=e.TestMessage||(e.TestMessage={}));var Ze;(function(be){function he(Ae){var Re,et;return{extId:Ae.id,label:Ae.label,location:Ae.location?O.from(Ae.location):void 0,debuggable:(Re=Ae.debuggable)!==null&&Re!==void 0?Re:!1,description:Ae.description,runnable:(et=Ae.runnable)!==null&&et!==void 0?et:!0}}be.from=he;function ce(Ae){return{id:Ae.extId,label:Ae.label,location:Ae.location&&O.to({range:Ae.location.range,uri:P.URI.revive(Ae.location.uri)}),debuggable:Ae.debuggable,description:Ae.description,runnable:Ae.runnable}}be.toPlainShallow=ce;function ee(Ae){const Re=new y.TestItem(Ae.extId,Ae.label);return Ae.location&&(Re.location=O.to({range:Ae.location.range,uri:P.URI.revive(Ae.location.uri)})),Re.debuggable=Ae.debuggable,Re.description=Ae.description,Re.runnable=Ae.runnable,Re}be.toShallow=ee})(Ze=e.TestItem||(e.TestItem={}));var ut;(function(be){function he(Ae,Re){var et,Ge,rt;const lt={completedAt:Re.completedAt,id:Ae,items:[]},Xe=[[null,Re.results]];for(;Xe.length;){const[it,dt]=Xe.pop();for(const at of dt){const Ct={children:(Ge=(et=at.children)===null||et===void 0?void 0:et.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:at.result.state,item:Ze.from(at),state:qe.from(at.result),retired:void 0,parent:(rt=it==null?void 0:it.item.extId)!==null&&rt!==void 0?rt:null,providerId:"",direct:!it};lt.items.push(Ct),at.children&&Xe.push([Ct,at.children])}}return lt}be.from=he;const ce=(Ae,Re)=>Object.assign(Object.assign({},Ze.toPlainShallow(Ae.item)),{result:qe.to(Ae.state),children:Ae.children.map(et=>Re.get(et)).filter(T.isDefined).map(et=>ce(et,Re))});function ee(Ae){const Re=[],et=new Map;for(const Ge of Ae.items)et.set(Ge.item.extId,Ge),Ge.direct&&Re.push(Ge);return{completedAt:Ae.completedAt,results:Re.map(Ge=>ce(Ge,et))}}be.to=ee})(ut=e.TestResults||(e.TestResults={}));var st;(function(be){function he(ce){switch(ce){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}be.to=he})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[212],pe([0,1,2,16,8,20,56]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(n,T,k,b={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=b,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,b)=>{const c={dispose:this._callbacks.push([T,k,n])};return Array.isArray(b)&&b.push(c),c}}async $participateInSave(n,T){const k=_.URI.revive(n);let b=!1;const h=setTimeout(()=>b=!0,this._thresholds.timeout),c=[];try{for(let m of[...this._callbacks]){if(b)break;const E=this._documents.getDocument(k),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:E,reason:P.TextDocumentSaveReason.to(T)});c.push(g)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([n,T,k],b){const h=this._badListeners.get(n);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,b).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const m=this._badListeners.get(n);this._badListeners.set(n,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,b){const h=[],c=Date.now(),{document:m,reason:E}=b,{version:g}=m,w=Object.freeze({document:m,reason:E,waitUntil(d){if(Object.isFrozen(h))throw(0,y.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(d))}});try{T.apply(k,[w])}catch(d){return Promise.reject(d)}return Object.freeze(h),new Promise((d,u)=>{const a=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(a),d(t)}).catch(t=>{clearTimeout(a),u(t)})}).then(d=>{const u={edits:[]};for(const a of d)if(Array.isArray(a)&&a.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:i,range:o}of a)u.edits.push({_type:2,resource:m.uri,edit:{range:o&&P.Range.from(o),text:t,eol:i&&P.EndOfLine.from(i)}});if(u.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ge[213],pe([0,1,3,17,34,2,20,8]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(k,b,h,c,m){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,h&&(this._config+=1),c&&(this._config+=2),m&&(this._config+=4);const E=(0,R.parse)(b),g=k(w=>{if(!h)for(let d of w.created){const u=P.URI.revive(d);E(u.fsPath)&&this._onDidCreate.fire(u)}if(!c)for(let d of w.changed){const u=P.URI.revive(d);E(u.fsPath)&&this._onDidChange.fire(u)}if(!m)for(let d of w.deleted){const u=P.URI.revive(d);E(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,b,h){this._logService=b,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new y.AsyncEmitter,this._onWillCreateFile=new y.AsyncEmitter,this._onWillDeleteFile=new y.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,b,h,c){return new C(this._onFileSystemEvent.event,k,b,h,c)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,b){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(h=>P.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(h=>P.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,b){return(h,c,m)=>{const E=function(w){h.call(c,w)};return E.extension=k,b.event(E,void 0,m)}}async $onWillRunFileOperation(k,b,h,c){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))},h,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(m=>P.URI.revive(m.target))},h,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(m=>P.URI.revive(m.target))},h,c)}}async _fireWillEvent(k,b,h,c){const m=new Set,E=[];if(await k.fireAsync(b,c,async(w,d)=>{var u;const a=Date.now(),t=await Promise.resolve(w);t instanceof A.WorkspaceEdit&&(E.push(t),m.add((u=d.extension.displayName)!==null&&u!==void 0?u:d.extension.identifier.value)),Date.now()-a>h&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!c.isCancellationRequested&&E.length!==0){const g={edits:[]};for(let w of E){let{edits:d}=D.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(d)}return{edit:g,extensionNames:Array.from(m)}}}}e.ExtHostFileSystemEventService=n}),define(ge[214],pe([0,1,3,6,11,22,2,20,85]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class n{constructor(h,c,m,E){this.start=h,this.deletedCount=c,this.deletedItems=m,this.items=E}static asApiEvents(h){return h.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(m=>m.cell)}))}}class T{constructor(h,c,m){var E;this._notebook=h,this._extHostDocument=c,this._cellData=m,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=m.handle,this.uri=D.URI.revive(m.uri),this.cellKind=m.cellKind,this._outputs=m.outputs.map(A.NotebookCellOutput.to),this._metadata=A.NotebookCellMetadata.to((E=m.metadata)!==null&&E!==void 0?E:{})}static asModelAddData(h,c){return{EOL:c.eol,lines:c.source,modeId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:h}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const h=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return h._notebook.getCellIndex(h)},notebook:h._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata}})}return this._cell}setOutputs(h){this._outputs=h.map(A.NotebookCellOutput.to)}setOutputItems(h,c,m){const E=m.map(A.NotebookCellOutputItem.to),g=this._outputs.find(w=>w.id===h);g&&(c||(g.outputs.length=0),g.outputs.push(...E))}setMetadata(h){this._metadata=A.NotebookCellMetadata.to(h)}}e.ExtHostCell=T;class k extends y.Disposable{constructor(h,c,m,E,g,w,d){super();this._proxy=h,this._textDocumentsAndEditors=c,this._textDocuments=m,this._emitter=E,this._viewType=g,this._metadata=w,this.uri=d,this.handle=k._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,y.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const h=this;this._notebook=Object.freeze({get uri(){return h.uri},get version(){return h._versionId},get fileName(){return h.uri.fsPath},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===R.Schemas.untitled},get cells(){return h._cells.map(c=>c.cell)},get metadata(){return h._metadata},set metadata(c){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return h._save()}})}return this._notebook}updateBackup(h){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,c){this._versionId=h.versionId,this._isDirty=c;for(const m of h.rawEvents)m.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(m.changes,!0),m.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1):m.kind===C.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx):m.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(m.index,m.outputs):m.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems):m.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(m.index,m.language):m.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(m.index,m.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(h,c){if(!this._disposed){const m=[],E=[],g=[];h.reverse().forEach(w=>{var d;const a=w[2].map(o=>{const s=new T(this,this._textDocumentsAndEditors,o);if(c||E.push(T.asModelAddData(this.notebookDocument,o)),!this._cellDisposableMapping.has(s.handle)){const r=new y.DisposableStore;r.add(s),this._cellDisposableMapping.set(s.handle,r)}return s});for(let o=w[0];o<w[0]+w[1];o++)(d=this._cellDisposableMapping.get(this._cells[o].handle))===null||d===void 0||d.dispose(),this._cellDisposableMapping.delete(this._cells[o].handle);const t=new n(w[0],w[1],[],a),i=this._cells.splice(w[0],w[1],...a);for(let o of i)g.push(o.uri),t.deletedItems.push(o.cell);m.push(t)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:g}),c||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(m)}))}}_moveCell(h,c){const m=this._cells.splice(h,1);this._cells.splice(c,0,...m);const E=[new n(h,1,m.map(g=>g.cell),[]),new n(c,0,[],m)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(E)}))}_setCellOutputs(h,c){const m=this._cells[h];m.setOutputs(c),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[m.cell]}))}_setCellOutputItems(h,c,m,E){const g=this._cells[h];g.setOutputItems(c,m,E),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[g.cell]}))}_changeCellLanguage(h,c){const m=this._cells[h];m.cell.document.languageId!==c&&this._textDocuments.$acceptModelModeChanged(m.uri,c)}_changeCellMetadata(h,c){const m=this._cells[h];m.setMetadata(c||{}),this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:m.cell}))}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(c=>c.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(ge[215],pe([0,1,3,8,20]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:n})}replaceCellOutput(C,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:C,outputs:n.map(T=>R.NotebookCellOutput.from(T))})}replaceCells(C,n,T){this._throwIfFinalized(),!(C===n&&T.length===0)&&this._collectedEdits.push({editType:1,index:C,count:n-C,cells:T.map(R.NotebookCellData.from)})}}class D{constructor(C,n,T,k,b,h,c){this.id=C,this._viewType=n,this._proxy=T,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=h,this._visibleRanges=b,this._viewColumn=c}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.notebookDocument},get selection(){var n;const T=C._selections[0];return T&&((n=C.notebookData.getCellFromIndex(T.start))===null||n===void 0?void 0:n.cell)},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(n,T){C._proxy.$tryRevealRange(C.id,R.NotebookCellRange.from(n),T!=null?T:y.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},get onDidDispose(){return C.onDidDispose},edit(n){const T=new P(this.document.version);return n(T),C._applyEdit(T.finalize())},get kernel(){return C._kernel},setDecorations(n,T){return C.setDecorations(n,T)}}}return this._editor}_acceptKernel(C){this._kernel=C}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const n=[];let T=-1;for(let k=0;k<C.cellEdits.length;k++){if(T<0){n.push(C.cellEdits[k]),T++;continue}const h=n[T];if(h.editType===1&&C.cellEdits[k].editType===1){const c=C.cellEdits[k];if(c.editType!==5&&h.index===c.index){h.cells.push(...C.cellEdits[k].cells),h.count+=C.cellEdits[k].count;continue}}n.push(C.cellEdits[k]),T++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,C.documentVersionId,n)}setDecorations(C,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return n.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(n),C.key)}}e.ExtHostNotebookEditor=D}),define(ge[216],pe([0,1,20,111,160,21,54]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,b,h){const c=this._handles++,{title:m,location:E,cancellable:g}=b,w=(0,R.localize)(0,null,k.displayName||k.name);return this._proxy.$startProgress(c,{location:_.ProgressLocation.from(E),title:m,source:w,cancellable:g},k),this._withProgress(c,h,!!g)}_withProgress(k,b,h){let c;h&&(c=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,c));const m=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),c&&c.dispose()};let E;try{E=b(new n(this._proxy,k),h&&c?c.token:P.CancellationToken.None)}catch(g){throw m(k),g}return E.then(g=>m(k),g=>m(k)),E}$acceptProgressCanceled(k){const b=this._mapHandleToCancellationSource.get(k);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=A;function C(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends y.Progress{constructor(k,b){super(h=>this.throttledReport(h));this._proxy=k,this._handle=b}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,D.throttle)(100,(T,k)=>C(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ge[121],pe([0,1,52,16,70,20,8]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(b,h){const c=A._Keys.nextId();b.$registerTextEditorDecorationType(c,P.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:c,dispose(){b.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=A,A._Keys=new R.IdGenerator("TextEditorDecorationType");class C{constructor(b,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,h){this._throwIfFinalized();let c=null;if(b instanceof D.Position)c=new D.Range(b,b);else if(b instanceof D.Range)c=b;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(b,h){this._throwIfFinalized(),this._pushEdit(new D.Range(b,b),h,!0)}delete(b){this._throwIfFinalized();let h=null;if(b instanceof D.Range)h=b;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(b,h,c){const m=this._document.validateRange(b);this._collectedEdits.push({range:m,text:h,forceMoveMarkers:c})}setEndOfLine(b){if(this._throwIfFinalized(),b!==D.EndOfLine.LF&&b!==D.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=C;class n{constructor(b,h,c,m){this._proxy=b,this._id=h,this._accept(c),this._logService=m;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(g){E._setTabSize(g)},get insertSpaces(){return E._insertSpaces},set insertSpaces(g){E._setInsertSpaces(g)},get cursorStyle(){return E._cursorStyle},set cursorStyle(g){E._setCursorStyle(g)},get lineNumbers(){return E._lineNumbers},set lineNumbers(g){E._setLineNumbers(g)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const h=Math.floor(b);return h>0?h:null}if(typeof b=="string"){const h=parseInt(b,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(b){const h=this._validateTabSize(b);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const h=this._validateInsertSpaces(b);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const h={};let c=!1;if(typeof b.tabSize!="undefined"){const m=this._validateTabSize(b.tabSize);m==="auto"?(c=!0,h.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,c=!0,h.tabSize=m)}if(typeof b.insertSpaces!="undefined"){const m=this._validateInsertSpaces(b.insertSpaces);m==="auto"?(c=!0,h.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,c=!0,h.insertSpaces=m)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,c=!0,h.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,c=!0,h.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(b){b.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=n;class T{constructor(b,h,c,m,E,g,w,d){this.id=b,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new n(this._proxy,this.id,g,c),this._visibleRanges=w,this._viewColumn=d;const u=this;this.value=Object.freeze({get document(){return m.getValue()},set document(a){throw(0,y.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(a){if(!(a instanceof D.Selection))throw(0,y.illegalArgument)("selection");u._selections=[a],u._trySetSelection()},get selections(){return u._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof D.Selection)))throw(0,y.illegalArgument)("selections");u._selections=a,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(a){throw(0,y.readonly)("visibleRanges")},get options(){return u._options.value},set options(a){u._disposed||u._options.assign(a)},get viewColumn(){return u._viewColumn},set viewColumn(a){throw(0,y.readonly)("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new C(m.getValue(),t);return a(i),u._applyEdit(i)},insertSnippet(a,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(s=>P.Range.from(s));else if(t instanceof D.Position){const{lineNumber:s,column:r}=P.Position.from(t);o=[{startLineNumber:s,startColumn:r,endLineNumber:s,endColumn:r}]}else if(t instanceof D.Range)o=[P.Range.from(t)];else{o=[];for(const s of t)if(s instanceof D.Range)o.push(P.Range.from(s));else{const{lineNumber:r,column:l}=P.Position.from(s);o.push({startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l})}}return h.$tryInsertSnippet(b,a.value,o,i)},setDecorations(a,t){const i=t.length===0;i&&!u._hasDecorationsForKey.has(a.key)||(i?u._hasDecorationsForKey.delete(a.key):u._hasDecorationsForKey.add(a.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return h.$trySetDecorations(b,a.key,P.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let s=0,r=t.length;s<r;s++){const l=t[s];o[4*s]=l.start.line+1,o[4*s+1]=l.start.character+1,o[4*s+2]=l.end.line+1,o[4*s+3]=l.end.character+1}return h.$trySetDecorationsFast(b,a.key,o)}}))},revealRange(a,t){u._runOnProxy(()=>h.$tryRevealRange(b,P.Range.from(a),t||D.TextEditorRevealType.Default))},show(a){h.$tryShowEditor(b,P.ViewColumn.from(a))},hide(){h.$tryHideEditor(b)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,_.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,_.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,_.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,_.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const h=b.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(E=>E.range);c.sort((E,g)=>E.end.line===g.end.line?E.end.character===g.end.character?E.start.line===g.start.line?E.start.character-g.start.character:E.start.line-g.start.line:E.end.character-g.end.character:E.end.line-g.end.line);for(let E=0,g=c.length-1;E<g;E++){const w=c[E].end;if(c[E+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=h.edits.map(E=>({range:P.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,m,{setEndOfLine:typeof h.setEndOfLine=="number"?P.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=T}),define(ge[217],pe([0,1,163,24,2,3,6,17,8,15,12,20,21]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(E,g){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let w;return Array.isArray(E.highlights)&&(w=E.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),w=w.length?w:void 0),{label:E.label,highlights:w}}}class c{constructor(g,w,d){this._proxy=g,this.commands=w,this.logService=d,this.treeViews=new Map;function u(a){return a&&a.$treeViewId&&a.$treeItemHandle}w.registerArgumentProcessor({processArgument:a=>u(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(t=>u(t)?this.convertArgument(t):t):a})}registerTreeDataProvider(g,w,d){const u=this.createTreeView(g,{treeDataProvider:w},d);return{dispose:()=>u.dispose()}}createTreeView(g,w,d){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany}),a=this.createExtHostTreeView(g,w,d);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(t){a.message=t},get title(){return a.title},set title(t){a.title=t},get description(){return a.description},set description(t){a.description=t},reveal:(t,i)=>a.reveal(t,i),dispose:async()=>{await u,this.treeViews.delete(g),a.dispose()}}}$getChildren(g,w){const d=this.treeViews.get(g);return d?d.getChildren(w):Promise.reject(new Error((0,_.localize)(0,null,g)))}async $hasResolve(g){const w=this.treeViews.get(g);if(!w)throw new Error((0,_.localize)(1,null,g));return w.hasResolve}$resolve(g,w,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(2,null,g));return u.resolveTreeItem(w,d)}$setExpanded(g,w,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(3,null,g));u.setExpanded(w,d)}$setSelection(g,w){const d=this.treeViews.get(g);if(!d)throw new Error((0,_.localize)(4,null,g));d.setSelection(w)}$setVisible(g,w){const d=this.treeViews.get(g);if(!d)throw new Error((0,_.localize)(5,null,g));d.setVisible(w)}createExtHostTreeView(g,w,d){const u=new m(g,w,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(g,u),u}convertArgument(g){const w=this.treeViews.get(g.$treeViewId);return w?w.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=c;class m extends D.Disposable{constructor(g,w,d,u,a,t){super();if(this.viewId=g,this.proxy=d,this.commands=u,this.logService=a,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const r of t.contributes.views[s])r.id===g&&(this._title=r.name);this.dataProvider=w.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let i,o;this._register(P.Event.debounce(this._onDidChangeData.event,(s,r)=>(s||(s={message:!1,elements:[]}),r.element!==!1&&(i||(i=new Promise(l=>o=l),this.refreshPromise=this.refreshPromise.then(()=>i)),s.elements.push(r.element)),r.message&&(s.message=!0),s),200,!0)(({message:s,elements:r})=>{r.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=o;return i=null,this.refresh(r).then(()=>l())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,n.isUndefinedOrNull)(g))}getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(g);return(d?Promise.resolve(d):this.fetchChildrenNodes(w)).then(u=>u.map(a=>a.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const d=(0,n.isUndefinedOrNull)(w.select)?!0:w.select,u=(0,n.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,n.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(o=>o.item)},{select:d,focus:u,expand:a})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:u,expand:a})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,w){const d=this.getExtensionElement(g);d&&(w?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(g){(0,T.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,w){var d;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(g);if(u){const a=this.nodes.get(u);if(a){const t=(d=await this.dataProvider.resolveTreeItem(a.extensionItem,u,w))!==null&&d!==void 0?d:a.extensionItem;return a.item.tooltip=this.getTooltip(t.tooltip),a.item.command=this.getCommand(a.disposableStore,t.command),a.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(w=>w?this.resolveUnknownParentChain(w).then(d=>this.resolveTreeNode(w,d[d.length-1]).then(u=>(d.push(u),d))):Promise.resolve([]))}resolveParent(g){const w=this.nodes.get(g);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,w){const d=this.nodes.get(g);return d?Promise.resolve(d):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>this.createHandle(g,u,w,!0)).then(u=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(u);if(a){const t=this.nodes.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(g){if(g){let w;if(typeof g=="string"){const d=this.getExtensionElement(g);w=d?this.nodes.get(d):void 0}else w=g;return w&&w.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const w=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=g?this.nodes.get(g):void 0,u=await this.dataProvider.getChildren(g);if(w.token.isCancellationRequested)return[];const a=await Promise.all((0,T.coalesce)(u||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,d):null}));return w.token.isCancellationRequested?[]:(0,T.coalesce)(a)}finally{w.dispose()}}refresh(g){if(g.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(g);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const w=new Set;for(const u of g){const a=this.nodes.get(u);if(a&&!w.has(a.item.handle)){let t=a;for(;t&&t.parent&&!w.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(a.item.handle)}}const d=[];return w.forEach(u=>{const a=this.elements.get(u);if(a){const t=this.nodes.get(a);t&&(!t.parent||!w.has(t.parent.item.handle))&&d.push(u)}}),d}refreshHandles(g){const w={};return Promise.all(g.map(d=>this.refreshNode(d).then(u=>{u&&(w[d]=u.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(g){const w=this.getExtensionElement(g);if(w){const d=this.nodes.get(w);if(d)return this.clearChildren(w),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>{if(u){const a=this.createTreeNode(w,u,d.parent);return this.updateNodeCache(w,a,d,d.parent),d.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,w,d){const u=this.createTreeNode(g,w,d);if(w.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,w.id));return this.addNodeToCache(g,u),this.addNodeToParentCache(u,d),u}getTooltip(g){return C.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}getCommand(g,w){return w?this.commands.toInternal(w,g):void 0}createTreeNode(g,w,d){const u=new D.DisposableStore,a=this.createHandle(g,w,d),t=this.getLightIconPath(w);return{item:{handle:a,parentHandle:d?d.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(u,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,n.isUndefinedOrNull)(w.collapsibleState)?C.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:d,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(g){return g.iconPath instanceof C.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:w,label:d,resourceUri:u},a,t){if(w)return`${m.ID_HANDLE_PREFIX}/${w}`;const i=h(d,this.extension),o=a?a.item.handle:m.LABEL_HANDLE_PREFIX;let s=i?i.label:u?(0,y.basename)(u):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const r=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,l=this.getChildrenNodes(a)||[];let p,S=0;do{if(p=`${o}/${S}:${s}`,t||!this.elements.has(p)||r===p)break;S++}while(S<=l.length);return p}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof C.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof C.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return R.URI.isUri(g)?g:R.URI.file(g)}addNodeToCache(g,w){this.elements.set(w.item.handle,g),this.nodes.set(g,w)}updateNodeCache(g,w,d,u){this.elements.delete(w.item.handle),this.nodes.delete(g),w.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(g,w);const a=this.getChildrenNodes(u)||[],t=a.filter(i=>i.item.handle===d.item.handle)[0];t&&a.splice(a.indexOf(t),1,w)}addNodeToParentCache(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const w=this.nodes.get(g);if(w){if(w.children)for(const d of w.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}w.children=void 0}}else this.clearAll()}clear(g){const w=this.nodes.get(g);if(w){if(w.children)for(const d of w.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}this.nodes.delete(g),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ge[218],pe([0,1,12,17,54,20]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class D{constructor(){this.testIdsToInternal=new Set}getTestById(c){return(0,_.mapFind)(this.testIdsToInternal,m=>{const E=m.get(c);return E&&[m,E]})}createForHierarchy(c=()=>{}){return new n(this.createIdMap(),c)}createIdMap(){const c=new C;return this.testIdsToInternal.add(c),{object:c,dispose:()=>this.testIdsToInternal.delete(c)}}}e.OwnedTestCollection=D;var A;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));class C{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(c){if(this.map.has(c.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${c.item.extId}`);this.map.set(c.item.extId,c),c.parent||this._roots.add(c)}has(c){return this.map.has(c)}delete(c){const m=this.map.get(c);return m?(this.map.delete(c),this._roots.delete(m),!0):!1}get(c){return this.map.get(c)}comparePositions(c,m){const E=typeof c=="string"?this.map.get(c):c,g=typeof m=="string"?this.map.get(m):m;if(!E||!g)return 0;if(E===g)return 3;for(let w=this.map.get(g.parent);w;w=this.map.get(w.parent))if(w===E)return 1;for(let w=this.map.get(E.parent);w;w=this.map.get(w.parent))if(w===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class n{constructor(c,m){this.testIdToInternal=c,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new y.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(c,m){this.addItem(c,m,null),this.debounceSendDiff.schedule()}getTestByReference(c){return this.testItemToInternal.get(c)}onItemChange(c,m){const E=this.testItemToInternal.get(c);if(!E){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(c,m,E.parent),this.debounceSendDiff.schedule()}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){this.diff.push(c),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(c,m,E){let g=this.testItemToInternal.get(c);if(g)g.previousEquals(c)||(g.item=P.TestItem.from(c),g.previousEquals=b(c),this.diff.push([1,{parent:E,providerId:m,item:g.item}]));else{if(this.testIdToInternal.object.has(c.id))throw new Error(`Attempted to insert a duplicate test item ID ${c.id}`);g={actual:c,parent:E,item:P.TestItem.from(c),providerId:m,previousChildren:new Set,previousEquals:b(c)},this.testIdToInternal.object.add(g),this.testItemToInternal.set(c,g),this.diff.push([0,{parent:E,providerId:m,item:g.item}])}if(c.children){const w=g.previousChildren,d=new Set;for(const u of c.children){const a=this.testIdToInternal.object.get(u.id);a&&a.actual!==u&&this.removeItembyId(u.id);const t=this.addItem(u,m,g.item.extId);w.delete(t.item.extId),d.add(t.item.extId)}for(const u of w)this.removeItembyId(u);g.previousChildren=d}return g}removeItembyId(c){this.diff.push([2,c]);const m=[this.testIdToInternal.object.get(c)];for(;m.length;){const E=m.pop();if(!!E){this.testIdToInternal.object.delete(E.item.extId),this.testItemToInternal.delete(E.actual);for(const g of E.previousChildren)m.push(this.testIdToInternal.object.get(g))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const c=this.collectDiff();c.length&&this.publishDiff(c)}}je([(0,R.throttle)(200)],n.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=n;const k=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),b=h=>{const c=[];for(const m of k)c.push(h[m]);return m=>{for(let E=0;E<k.length;E++)if(c[E]!==m[k[E]])return!1;return!0}}}),define(ge[219],pe([0,1,29,3,7]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=P;class D{constructor(T){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${_.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(b=>k.add(_.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>k.has(_.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const b=D._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(b.map(h=>h.identifier)),k.length>0){const h=new Set;k.forEach(c=>h.add(_.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(_.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(b)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,g){this.addNode(E),this.addNode(g),this._arcs.has(E)?this._arcs.get(E).push(g):this._arcs.set(E,[g])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,g){const w=k.getArcs(E);for(let d=0;d<w.length;d++)if(!g.has(w[d]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let E of T){const g=_.ExtensionIdentifier.toKey(E.identifier);if(b.set(g,E),E.extensionDependencies)for(let w of E.extensionDependencies){const d=_.ExtensionIdentifier.toKey(w);k.addArc(g,d)}}let h=new Set;k.getNodes().filter(E=>k.getArcs(E).length===0).forEach(E=>h.add(E));let c=k.getNodes().filter(E=>!h.has(E)),m;do{m=!1;for(let E=0;E<c.length;E++){const g=c[E];k.hasOnlyGoodArcs(g,h)&&(c.splice(E,1),E--,h.add(g),m=!0)}}while(m);return c.map(E=>b.get(E))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(_.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=D;var A;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(A||(A={}));function C(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==b)return k-b;const h=R.posix.basename(n.extensionLocation.path),c=R.posix.basename(T.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(ge[220],pe([0,1,25]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var y;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(A){const C=_.VSBuffer.alloc(1);switch(A){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=P;function D(A,C){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=D}),define(ge[41],pe([0,1,3,2,4,29,180]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class A{constructor(u){this.dependency=u}}e.MissingDependencyError=A;var C;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(C=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(u,a,t,i){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class T{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function b(d){d.enableProposedApi||h(d)}e.checkProposedApiEnabled=b;function h(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=h;function c(d){var u;((u=d.workspaceTrust)===null||u===void 0?void 0:u.required)||m(d)}e.checkRequiresWorkspaceTrust=c;function m(d){throw new Error(`[${d.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=m;function E(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=E;function g(d){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=g;class w{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,a){}_activateById(u,a){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,a,t,i,o){}_onExtensionRuntimeError(u,a){}_onExtensionHostExit(u){}}e.NullExtensionService=w}),define(ge[221],pe([0,1,158,29,41,13]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(m,E,g,w){this.startup=m,this.codeLoadingTime=E,this.activateCallTime=g,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,E){return m===-1||E===-1?-1:E-m}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class n{constructor(m,E,g,w,d,u){this.activationFailed=m,this.activationFailedError=E,this.activationTimes=g,this.module=w,this.exports=d,this.subscriptions=u}}e.ActivatedExtension=n;class T extends n{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class b extends n{constructor(m){super(!0,m,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let h=class{constructor(m,E,g,w,d){this._logService=d,this._registry=m,this._resolvedExtensionsSet=new Set,E.forEach(u=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,g.forEach(u=>this._hostExtensionsMap.set(y.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(m){const E=y.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(E)}getActivatedExtension(m){const E=y.ExtensionIdentifier.toKey(m),g=this._activatedExtensions.get(E);if(!g)throw new Error("Extension `"+m.value+"` is not known or not activated");return g}activateByEvent(m,E){if(this._alreadyActivatedEvents[m])return D;const g=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(g.map(w=>({id:w.identifier,reason:{startup:E,extensionId:w.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,E){const g=this._registry.getExtensionDescription(m);if(!g)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:g.identifier,reason:E}])}_handleActivateRequest(m,E,g){if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(m.id))){E[y.ExtensionIdentifier.toKey(m.id)]=m;return}const w=this._registry.getExtensionDescription(m.id);if(!w){this._host.onExtensionActivationError(m.id,new R.MissingDependencyError(m.id.value));const a=new Error(`Unknown dependency '${m.id.value}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(m.id),new b(a));return}const d=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let a=0,t=d.length;a<t;a++){const i=d[a];if(!this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(i))){const o=this._activatedExtensions.get(y.ExtensionIdentifier.toKey(i));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(w.identifier,_.localize(0,null,w.displayName||w.identifier.value,i));const l=new Error(`Dependency ${i} failed to activate`);l.detail=o.activationFailedError,this._activatedExtensions.set(y.ExtensionIdentifier.toKey(w.identifier),new b(l));return}if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(i))){u=!1,E[y.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(y.ExtensionIdentifier.toKey(i)),reason:m.reason};continue}const s=this._registry.getExtensionDescription(i);if(s){u=!1,E[y.ExtensionIdentifier.toKey(i)]={id:s.identifier,reason:m.reason};continue}this._host.onExtensionActivationError(w.identifier,new R.MissingDependencyError(i));const r=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(w.identifier),new b(r));return}}}u?E[y.ExtensionIdentifier.toKey(w.identifier)]=m:g.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(d=>!this._activatedExtensions.has(y.ExtensionIdentifier.toKey(d.id))),m.length===0))return Promise.resolve(void 0);const E=Object.create(null),g=[];for(let d=0,u=m.length;d<u;d++)this._handleActivateRequest(m[d],E,g);for(let d=0,u=g.length;d<u;d++){const a=y.ExtensionIdentifier.toKey(g[d].id);E[a]&&delete E[a]}const w=Object.keys(E).map(d=>E[d]);return g.length===0?Promise.all(w.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(w).then(d=>this._activateExtensions(g))}_activateExtension(m,E){const g=y.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const w=this._activatingExtensions.get(g);if(w)return w;const d=this._host.actualActivateExtension(m,E).then(void 0,u=>(this._host.onExtensionActivationError(m,_.localize(1,null,m.value,u.message)),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(u),new b(u))).then(u=>{this._activatedExtensions.set(g,u),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,d),d}};h=je([Ue(4,P.ILogService)],h),e.ExtensionsActivator=h}),define(ge[222],pe([0,1,13,41,27,11,109]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends _.LogService{constructor(n){if(n.logFile.scheme!==P.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(y.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};A=je([Ue(0,R.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ge[223],pe([0,1,16]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,D)=>{this._actualOk=P,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,_.onUnexpectedError)(P))}then(P,D){return this._ensureActual().then(P,D)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=y}),define(ge[122],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(C,n){this.isMain=C,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const y=[];function R(A){const C=new _(!0,A);return y[C.nid]=C,C}e.createMainContextProxyIdentifier=R;function P(A){const C=new _(!1,A);return y[C.nid]=C,C}e.createExtHostContextProxyIdentifier=P;function D(A){return y[A].sid}e.getStringIdentifierForProxy=D}),define(ge[5],pe([0,1,2,122,58]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var D;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var n;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(d){d.name="$ident";function u(t,i){return Object.defineProperty(t,d.name,{value:i,enumerable:!0}),t}d.mixin=u;function a(t){return t[d.name]}d.of=a})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(u){return u._id=h._n++,u}}e.IdObject=h,h._n=0;var c;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(d){if(d&&d.edits)for(const u of d.edits)typeof u.resource=="object"?u.resource=_.URI.revive(u.resource):(u.newUri=_.URI.revive(u.newUri),u.oldUri=_.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,R.revive)(u.metadata));return d}e.reviveWorkspaceEditDto=g;var w;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,y.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(A){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,C){return this._proxy.$getPassword(A,C)}store(A,C,n){return this._proxy.$setPassword(A,C,n)}delete(A,C){return this._proxy.$deletePassword(A,C)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,13,5,14]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(C,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(R.MainContext.MainThreadTelemetry)}report(C,n,T){const k=this.getUsageKey(C,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:C}))}getUsageKey(C,n){return`${C}-${n.identifier.value}`}};D=je([Ue(0,P.IExtHostRpcService),Ue(1,y.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,C,n){}})}),define(ge[224],pe([0,1,3,5,8,29]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(C,n,T,k={}){const b=P.ExtensionIdentifier.toKey(C.identifier),h=this._inFlightRequests.get(b)||[],c=T.sort().join(" ");let m=h.find(E=>E.scopes===c);if(m)return m.result;{const E=this._getSession(C,b,n,T,k);m={scopes:c,result:E},h.push(m),this._inFlightRequests.set(b,h);try{await E}finally{const g=h.findIndex(w=>w.scopes===c);g>-1&&(h.splice(g),this._inFlightRequests.set(b,h))}return E}}async _getSession(C,n,T,k,b={}){await this._proxy.$ensureProvider(T);const h=C.displayName||C.name;return this._proxy.$getSession(T,k,n,h,b)}async removeSession(C,n){const T=this._authenticationProviders.get(C);return T?T.provider.removeSession(n):this._proxy.$removeSession(C,n)}registerAuthenticationProvider(C,n,T,k){var b;if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===C)||this._providers.push({id:C,label:n});const h=T.onDidChangeSessions(c=>{var m,E,g;this._proxy.$sendDidChangeSessions(C,{added:(m=c.added)!==null&&m!==void 0?m:[],changed:(E=c.changed)!==null&&E!==void 0?E:[],removed:(g=c.removed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(C,n,(b=k==null?void 0:k.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new R.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(C);const c=this._providers.findIndex(m=>m.id===C);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,n){const T=this._authenticationProviders.get(C);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,n){const T=this._authenticationProviders.get(C);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,n){const T=this._authenticationProviders.get(C);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,n){return this._onDidChangeSessions.fire({provider:{id:C,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(C,n){return C.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(b=>b.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:C,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ge[225],pe([0,1,5,14,20]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(A,C){this._extHostDocumentsAndEditors=C,this._proxy=A.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const C=R.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};P=je([Ue(0,y.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(ge[226],pe([0,1,5]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(P){const D=P.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=y}),define(ge[51],pe([0,1,15,8,20,22,5,12,13,58,43,49,2,6,4,14]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=i,this.converter=new g(this,o=>{const s=this._apiCommands.get(o);return(s==null?void 0:s.result)===d.Void?s:void 0},i),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,P.cloneAndChange)(o,function(s){if(T.Range.isIRange(s))return R.Range.to(s);if(k.Position.isIPosition(s))return R.Position.to(s);if(T.Range.isIRange(s.range)&&b.URI.isUri(s.uri))return R.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const s=t.args.map((l,p)=>{if(!l.validate(o[p]))throw new Error(`Invalid argument '${l.name}' when running '${t.id}', received: ${o[p]}`);return l.convert(o[p])}),r=await this.executeCommand(t.internalId,...s);return t.result.convert(r,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new y.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,s,r){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:s,description:r}),t&&this._proxy.$registerCommand(i),new y.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const s=(0,P.cloneAndChange)(i,function(r){if(r instanceof y.Position)return R.Position.from(r);if(r instanceof y.Range)return R.Range.from(r);if(r instanceof y.Location)return R.location.from(r);if(!Array.isArray(r))return r});try{const r=await this._proxy.$executeCommand(t,s,o);return(0,n.revive)(r)}catch(r){if(r instanceof Error&&r.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw r}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:s,thisArg:r,description:l}=o;if(l)for(let p=0;p<l.args.length;p++)try{(0,_.validateConstraint)(i[p],l.args[p].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${l.args[p].name}' - ${l.args[p].description}`)}try{return await s.apply(r,i)}catch(p){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...i);S&&(t=S.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((s,r)=>r.processArgument(s),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:s}=o;s&&(t[i]=s)}return Promise.resolve(t)}};E=je([Ue(0,m.IExtHostRpcService),Ue(1,C.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class g{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const s=this._lookupApiCommand(t.command);if(s)o.id=s.internalId,o.arguments=s.args.map((r,l)=>r.convert(t.arguments&&t.arguments[l]));else if((0,A.isNonEmptyArray)(t.arguments)){const r=++this._cachIdPool;this._cache.set(r,t),i.add((0,h.toDisposable)(()=>{this._cache.delete(r),this._logService.trace("CommandsConverter#DISPOSE",r)})),o.$ident=r,o.id=this.delegatingCommandId,o.arguments=[r],this._logService.trace("CommandsConverter#CREATE",t.command,r)}return o}}fromInternal(t){const i=D.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class w{constructor(t,i,o,s){this.name=t,this.description=i,this.validate=o,this.convert=s}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",a=>b.URI.isUri(a),a=>a),w.Position=new w("position","A position in a text document",a=>y.Position.isPosition(a),R.Position.from),w.Range=new w("range","A range in a text document",a=>y.Range.isRange(a),R.Range.from),w.Selection=new w("selection","A selection in a text document",a=>y.Selection.isSelection(a),R.Selection.from),w.Number=new w("number","",a=>typeof a=="number",a=>a),w.String=new w("string","",a=>typeof a=="string",a=>a),w.CallHierarchyItem=new w("item","A call hierarchy item",a=>a instanceof y.CallHierarchyItem,R.CallHierarchyItem.to);class d{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=d,d.Void=new d("no result",a=>a);class u{constructor(t,i,o,s,r){this.id=t,this.internalId=i,this.description=o,this.args=s,this.result=r}}e.ApiCommand=u}),define(ge[227],pe([0,1,6,20,8,79,51,198,12,106]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(y.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(c,m)=>{if(!(0,C.isFalsyOrEmpty)(c)){class E extends R.SymbolInformation{static to(w){const d=new E(w.name,y.SymbolKind.to(w.kind),w.containerName||"",new R.Location(m[0],y.Range.to(w.range)));return d.detail=w.detail,d.range=d.location.range,d.selectionRange=y.Range.to(w.selectionRange),d.children=w.children?w.children.map(E.to):[],d}}return c.map(E.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(y.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(y.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.Position.isPosition(m)),c=>c.map(y.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(m=>{let E;for(const g of m.reverse())E=new R.SelectionRange(y.Range.to(g),E);return E}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const m=[];if(Array.isArray(c))for(let E of c)m.push(...E[1].map(y.WorkspaceSymbol.to));return m})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!!c){const m=(0,n.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!!c){const m=(0,n.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,m,E)=>{if(!c)return new R.CompletionList([]);const g=c.suggestions.map(w=>y.CompletionItem.to(w,E));return new R.CompletionList(g,c.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,m,E)=>b(g=>new R.CodeLens(y.Range.to(g.range),g.command&&E.fromInternal(g.command)))(c))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.Range.isRange(c),c=>R.Selection.isSelection(c)?y.Selection.from(c):y.Range.from(c)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,m,E)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(g.command)}else{const w=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=y.WorkspaceEdit.to(g.edit)),g.command&&(w.command=E.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(c))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.ColorInformation(y.Range.to(m.range),y.Color.to(m.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",c=>c instanceof R.Color,y.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",c=>c.map(y.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientMetadata:c.options.transientMetadata},filenamePattern:c.filenamePattern.map(m=>y.NotebookExclusiveDocumentPattern.to(m))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],D.ApiCommandResult.Void)];class k{constructor(m){this._disposables=new _.DisposableStore,this._commands=m}static register(m){return T.forEach(m.registerApiCommand,m),new k(m).registerCommands()}registerCommands(){const m=E=>(...g)=>E(this._commands,...g);this._register(A.RemoveFromRecentlyOpenedAPICommand.ID,m(A.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(A.OpenIssueReporter.ID,m(A.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(m,E,g){const w=this._commands.registerCommand(!1,m,E,this,g);this._disposables.add(w)}}e.ExtHostApiCommands=k;function b(c){return m=>{if(Array.isArray(m))return m.map(c)}}function h(c){if(!!Array.isArray(c)){const m=[];for(const E of c)P.isLocationLink(E)?m.push(y.DefinitionLink.to(E)):m.push(y.location.to(E));return m}}}),define(ge[228],pe([0,1,17,54,3,6,2,79,29,20,8,5]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(u,a,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadComments),a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const s=o.getCommentThread(i.commentThreadHandle);return s||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const s=o.getCommentThread(i.thread.commentThreadHandle);return s?{thread:s,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const s=o.getCommentThread(i.thread.commentThreadHandle);if(!s)return i;let r=i.commentUniqueId,l=s.getCommentByUniqueId(r);return l||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const s=o.getCommentThread(i.thread.commentThreadHandle);if(!s)return i;let r=i.text,l=i.commentUniqueId,p=s.getCommentByUniqueId(l);return p?(p.body=r,p):i}return i}})}createCommentController(u,a,t){const i=b.handlePool++,o=new c(u,i,this._proxy,a,t);this._commentControllers.set(o.handle,o);const s=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(u.identifier))||[];return s.push(o),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(u.identifier),s),o}$createCommentThreadTemplate(u,a,t){const i=this._commentControllers.get(u);!i||i.$createCommentThreadTemplate(a,t)}async $updateCommentThreadTemplate(u,a,t){const i=this._commentControllers.get(u);!i||i.$updateCommentThreadTemplate(a,t)}$deleteCommentThread(u,a){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(a)}$provideCommentingRanges(u,a,t){const i=this._commentControllers.get(u);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(D.URI.revive(a));return(0,_.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(o,t)).then(s=>s?s.map(r=>n.Range.from(r)):void 0)}$toggleReaction(u,a,t,i,o){const s=this._commentControllers.get(u);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const r=s.getCommentThread(a);if(r){const l=r.getCommentByUniqueId(i.uniqueIdInThread);if(s!==void 0&&l&&s.reactionHandler)return s.reactionHandler(l,g(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class h{constructor(u,a,t,i,o,s,r){this._proxy=u,this._commentController=a,this._id=t,this._uri=i,this._range=o,this._comments=s,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${a.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),r),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),a={};u("range")&&(a.range=n.Range.from(this._range)),u("label")&&(a.label=this.label),u("contextValue")&&(a.contextValue=this.contextValue),u("comments")&&(a.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(a.collapseState=w(this._collapseState)),u("canReply")&&(a.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,a)}}getCommentByUniqueId(u){for(let a of this._commentsMap){let t=a[0],i=a[1];if(u===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,je([(0,y.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class c{constructor(u,a,t,i,o){this._extension=u,this._handle=a,this._proxy=t,this._id=i,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,a,t,i){if(typeof u=="string"){const o=new h(this._proxy,this,u,a,t,i,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new h(this._proxy,this,void 0,u,a,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,a){const t=new h(this._proxy,this,void 0,D.URI.revive(u),n.Range.to(a),[],this._extension.identifier);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,a){let t=this._threads.get(u);t&&(t.range=n.Range.to(a))}$deleteCommentThread(u){let a=this._threads.get(u);a&&a.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(d,u,a,t){let i=t.get(a);i||(i=++d.commentHandle,t.set(a,i));const o=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(a.body),userName:a.author.name,userIconPath:o,label:a.label,commentReactions:a.reactions?a.reactions.map(s=>E(s)):void 0}}function E(d){return{label:d.label,iconPath:d.iconPath?n.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function g(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?D.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function w(d){if(d!==void 0)switch(d){case T.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}}),define(ge[123],pe([0,1,2,5,8,4,14,13,12,10,7]),function(Y,e,_,y,R,P,D,A,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class un{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const m=un._handlePool++;this._provider.set(m,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(m,c.value);const E=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(m,null);return}let w=(0,C.asArray)(g);if(w.length<=un._maxEventSize){this._proxy.$onDidChange(m,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,w.length);const d=w.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,C.groupBy)(d,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let a=[];e:for(let t of u){let i;for(let o of t){let s=(0,T.dirname)(o.uri.path);if(i!==s&&(i=s,a.push(o.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(m,a)});return new R.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(h,c,m){if(!this._provider.has(h))return Object.create(null);const E=Object.create(null),{provider:g,extensionId:w}=this._provider.get(h);return await Promise.all(c.map(async d=>{try{const{uri:u,id:a}=d,t=await Promise.resolve(g.provideFileDecoration(_.URI.revive(u),m));if(!t)return;try{R.FileDecoration.validate(t),E[a]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(u){this._logService.error(u)}})),E}};k._handlePool=0,k._maxEventSize=250,k=je([Ue(0,D.IExtHostRpcService),Ue(1,A.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(ge[229],pe([0,1,157,110,2,5,8,20,3,13,23]),function(Y,e,_,y,R,P,D,A,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(c,m,E,g,w){this._name=c,this._owner=m,this._maxDiagnosticsPerFile=E,this._proxy=g,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,m){if(!c){this.clear();return}this._checkDisposed();let E=[];if(R.URI.isUri(c)){if(!m){this.delete(c);return}this._data.set(c,m.slice()),E=[c]}else if(Array.isArray(c)){E=[];let w;c=[...c].sort(k._compareIndexedTuplesByUri);for(const d of c){const[u,a]=d;if((!w||u.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=u,E.push(u),this._data.set(u,[])),a){const t=this._data.get(u);t&&t.push(...a)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const g=[];for(let w of E){let d=[];const u=this._data.get(w);if(u)if(u.length>this._maxDiagnosticsPerFile){d=[];const a=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of u)if(i.severity===a[t]&&d.push(A.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;d.push({severity:y.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=u.map(a=>A.Diagnostic.from(a));g.push([w,d])}this._proxy.$changeMany(this._owner,g)}}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,m){this._checkDisposed();for(let E of this._data.keys())c.apply(m,[E,this.get(E),this])}get(c){this._checkDisposed();const m=this._data.get(c);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,m){return c[0].toString()<m[0].toString()?-1:c[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=k;let b=class Wt{constructor(c,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new C.Emitter,this.onDidChangeDiagnostics=C.Event.map(C.Event.debounce(this._onDidChangeDiagnostics.event,Wt._debouncer,50),Wt._mapper),this._proxy=c.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(c,m){return c?c.concat(m):m}static _mapper(c){const m=[],E=new Set;for(const g of c)typeof g=="string"?E.has(g)||(E.add(g),m.push(R.URI.parse(g))):E.has(g.toString())||(E.add(g.toString()),m.push(g));return Object.freeze(m),{uris:m}}createDiagnosticCollection(c,m){const{_collections:E,_proxy:g,_onDidChangeDiagnostics:w,_logService:d}=this,u=new class{$changeMany(i,o){g.$changeMany(i,o),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,o.length===0?"CLEARING":o)}$clear(i){g.$clear(i),d.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){g.dispose()}};let a;if(!m)m="_generated_diagnostic_collection_name_#"+Wt._idPool++,a=m;else if(!E.has(m))a=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do a=m+Wt._idPool++;while(E.has(a))}return new class extends k{constructor(){super(m,a,Wt._maxDiagnosticsPerFile,u,w);E.set(a,this)}dispose(){super.dispose(),E.delete(a)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const m=new Map,E=[];for(const g of this._collections.values())g.forEach((w,d)=>{let u=m.get(w.toString());typeof u=="undefined"&&(u=E.length,m.set(w.toString(),u),E.push([w,[]])),E[u][1]=E[u][1].concat(...d)});return E}}_getDiagnostics(c){let m=[];for(let E of this._collections.values())E.has(c)&&(m=m.concat(E.get(c)));return m}$acceptMarkersChange(c){if(!this._mirrorCollection){const m="_generated_mirror",E=new k(m,m,Wt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,E),this._mirrorCollection=E}for(const[m,E]of c)this._mirrorCollection.set(R.URI.revive(m),E.map(A.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([Ue(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(ge[230],pe([0,1,2,5]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(D){this._proxy=D.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(C=>_.URI.revive(C)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?_.URI.revive(A):void 0)}}e.ExtHostDialogs=R}),define(ge[231],pe([0,1,16,2,8,5,11,21,10]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,b,h){this._documentsAndEditors=b,this._logService=h,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,b){if(Object.keys(D.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const h=n._handlePool++;this._documentContentProviders.set(h,b),this._proxy.$registerTextContentProvider(h,k);let c;return typeof b.onDidChange=="function"&&(c=b.onDidChange(m=>{if(m.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(h,m).then(E=>{if(!(!E&&typeof E!="string")){const g=this._documentsAndEditors.getDocument(m);if(!!g){const w=(0,C.splitLines)(E);if(!g.equalLines(w))return this._proxy.$onVirtualDocumentChange(m,E)}}},_.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(k,b){const h=this._documentContentProviders.get(k);return h?Promise.resolve(h.provideTextDocumentContent(y.URI.revive(b),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ge[232],pe([0,1,3,6,2,5,118,20,15,22]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(b,h){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const m of c)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const m of c)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const h=this._documentsAndEditors.getDocument(b);if(h)return h}}getDocument(b){const h=this.getDocumentData(b);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return h.document}ensureDocumentData(b){const h=this._documentsAndEditors.getDocument(b);if(h)return Promise.resolve(h);let c=this._documentLoader.get(b.toString());return c||(c=this._proxy.$tryOpenDocument(b).then(m=>{this._documentLoader.delete(b.toString());const E=R.URI.revive(m);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(E))},m=>(this._documentLoader.delete(b.toString()),Promise.reject(m))),this._documentLoader.set(b.toString(),c)),c}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(h=>R.URI.revive(h))}$acceptModelModeChanged(b,h){const c=R.URI.revive(b),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(h),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(b){const h=R.URI.revive(b),c=this._documentsAndEditors.getDocument(h);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(b,h){const c=R.URI.revive(b),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(h),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(b,h,c){const m=R.URI.revive(b),E=this._documentsAndEditors.getDocument(m);if(!E)throw new Error("unknown document");E._acceptIsDirty(c),E.onEvents(h),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:E.document,contentChanges:h.changes.map(g=>({range:A.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(b,h){(0,D.setWordDefinitionFor)(b,h)}}e.ExtHostDocuments=T}),define(ge[39],pe([0,1,52,3,6,2,4,5,118,14,121,20,13,23,11,71,132]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(u,a){this._extHostRpc=u,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const a=[],t=[],i=[];if(u.removedDocuments)for(const o of u.removedDocuments){const s=P.URI.revive(o),r=this._documents.get(s);(r==null?void 0:r.unref())&&(this._documents.delete(s),a.push(r.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const s=P.URI.revive(o.uri);let r=this._documents.get(s);if(r&&s.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);r||(r=new g(new C.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),s,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(s,r),t.push(r.value)),r.ref()}if(u.removedEditors)for(const o of u.removedEditors){const s=this._editors.get(o);this._editors.delete(o),s&&i.push(s)}if(u.addedEditors)for(const o of u.addedEditors){const s=P.URI.revive(o.documentUri);_.ok(this._documents.has(s),`document '${s}' does not exist`),_.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const r=this._documents.get(s).value,l=new T.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>r.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(p=>k.Range.to(p)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,l)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,R.dispose)(a),(0,R.dispose)(i),u.removedDocuments&&this._onDidRemoveDocuments.fire(a),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var a;return(a=this._documents.get(u))===null||a===void 0?void 0:a.value}allDocuments(){return m.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const a=this._editors.get(this._activeEditorId);return u?a:a==null?void 0:a.value}}allEditors(){return[...this._editors.values()]}};w=je([Ue(0,n.IExtHostRpcService),Ue(1,b.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[233],pe([0,1,2,5,6,8,20,140,10,25]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let m,E,g=14,w=14;for(const d of h){let u=m?(0,C.commonPrefixLength)(m,d):0;for(u===0?E=1:E=w;u<d.length;u++)u+1===d.length?(g=w,w=9):w+=1,c.push([E,d.toUpperCase().charCodeAt(u),w]),c.push([E,d.toLowerCase().charCodeAt(u),w]),E=w;m=d,w=g}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new A.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],m=A.LinkComputer.computeLinks({getLineContent(E){return h.lineAt(E-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const E of m){const g=D.DocumentLink.to(E);g.target&&c.push(g)}return c}}class k{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,m,E={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(g,m);let w=2;E.isCaseSensitive&&(w+=1024),E.isReadonly&&(w+=2048),typeof m.copy=="function"&&(w+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(g,c,w).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(u)});const d=m.onDidChangeFile(u=>{const a=[];for(const t of u){let{uri:i,type:o}=t;if(i.scheme===c){let s;switch(o){case P.FileChangeType.Changed:s=0;break;case P.FileChangeType.Created:s=1;break;case P.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:i,type:s})}}this._proxy.$onFileSystemChange(g,a)});return(0,R.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(h){const{type:c,ctime:m,mtime:E,size:g}=h;return{type:c,ctime:m,mtime:E,size:g}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(_.URI.revive(c))).then(k._asIStat)}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(_.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(_.URI.revive(c))).then(m=>n.VSBuffer.wrap(m))}$writeFile(h,c,m,E){return Promise.resolve(this._getFsProvider(h).writeFile(_.URI.revive(c),m.buffer,E))}$delete(h,c,m){return Promise.resolve(this._getFsProvider(h).delete(_.URI.revive(c),m))}$rename(h,c,m,E){return Promise.resolve(this._getFsProvider(h).rename(_.URI.revive(c),_.URI.revive(m),E))}$copy(h,c,m,E){const g=this._getFsProvider(h);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(_.URI.revive(c),_.URI.revive(m),E))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(_.URI.revive(c)))}$watch(h,c,m,E){const g=this._getFsProvider(h).watch(_.URI.revive(m),E);this._watches.set(c,g)}$unwatch(h,c){const m=this._watches.get(c);m&&(m.dispose(),this._watches.delete(c))}$open(h,c,m){const E=this._getFsProvider(h);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(_.URI.revive(c),m))}$close(h,c){const m=this._getFsProvider(h);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(c))}$read(h,c,m,E){const g=this._getFsProvider(h);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const w=n.VSBuffer.alloc(E);return Promise.resolve(g.read(c,m,w.buffer,0,E)).then(d=>w.slice(0,d))}$write(h,c,m,E){const g=this._getFsProvider(h);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(c,m,E.buffer,0,E.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return c}}e.ExtHostFileSystem=k}),define(ge[87],pe([0,1,5,44,8,25,4,14,61]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Rt{constructor(k,b){const h=k.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Rt._handleError)},readDirectory(c){return h.$readdir(c).catch(Rt._handleError)},createDirectory(c){return h.$mkdir(c).catch(Rt._handleError)},async readFile(c){return h.$readFile(c).then(m=>m.buffer).catch(Rt._handleError)},writeFile(c,m){return h.$writeFile(c,P.VSBuffer.wrap(m)).catch(Rt._handleError)},delete(c,m){return h.$delete(c,Object.assign({recursive:!1,useTrash:!1},m)).catch(Rt._handleError)},rename(c,m,E){return h.$rename(c,m,Object.assign({overwrite:!1},E)).catch(Rt._handleError)},copy(c,m,E){return h.$copy(c,m,Object.assign({overwrite:!1},E)).catch(Rt._handleError)},isWritableFileSystem(c){const m=b.getCapabilities(c);if(typeof m=="number")return!(m&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case y.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case y.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case y.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case y.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};n=je([Ue(0,A.IExtHostRpcService),Ue(1,C.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[234],pe([0,1,6,5]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(D){this._handlePool=0,this._proxy=D.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=R}),define(ge[235],pe([0,1,2,22,20,8,17,5,10,43,12,15,137,6,106,70,116,46,16]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,X){this._documents=j,this._provider=X}provideDocumentSymbols(j,X){const te=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,X)).then(ae=>{if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(R.DocumentSymbol.from):d._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(j){var X;j=j.slice(0).sort((ve,De)=>{let Oe=ve.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(ve.location.range.end)),Oe});const te=[],ae=[];for(const ve of j){const De={name:ve.name||"!!MISSING: name!!",kind:R.SymbolKind.from(ve.kind),tags:((X=ve.tags)===null||X===void 0?void 0:X.map(R.SymbolTag.from))||[],detail:"",containerName:ve.containerName,range:R.Range.from(ve.location.range),selectionRange:R.Range.from(ve.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Oe=ae[ae.length-1];if(n.Range.containsRange(Oe.range,De.range)&&!n.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(j,X,te){this._documents=j,this._commands=X,this._provider=te,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,X){const te=this._documents.getDocument(j),ae=await this._provider.provideCodeLenses(te,X);if(!(!ae||X.isCancellationRequested)){const ve=this._cache.add(ae),De=new h.DisposableStore;this._disposables.set(ve,De);const Oe={cacheId:ve,lenses:[]};for(let we=0;we<ae.length;we++)Oe.lenses.push({cacheId:[ve,we],range:R.Range.from(ae[we].range),command:this._commands.toInternal(ae[we].command,De)});return Oe}}async resolveCodeLens(j,X){var te;const ae=j.cacheId&&this._cache.get(...j.cacheId);if(!!ae){let ve;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?ve=ae:ve=await this._provider.resolveCodeLens(ae,X),ve||(ve=ae),!X.isCancellationRequested){const De=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!De)return j.command=this._commands.toInternal((te=ve.command)!==null&&te!==void 0?te:u._badCmd,De),j}}}releaseCodeLenses(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(Fe){return Array.isArray(Fe)?Fe.map(R.DefinitionLink.from):Fe?[R.DefinitionLink.from(Fe)]:[]}class t{constructor(j,X){this._documents=j,this._provider=X}provideDefinition(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,ve,te)).then(a)}}class i{constructor(j,X){this._documents=j,this._provider=X}provideDeclaration(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,ve,te)).then(a)}}class o{constructor(j,X){this._documents=j,this._provider=X}provideImplementation(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,ve,te)).then(a)}}class s{constructor(j,X){this._documents=j,this._provider=X}provideTypeDefinition(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,ve,te)).then(a)}}class r{constructor(j,X){this._documents=j,this._provider=X}provideHover(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideHover(ae,ve,te)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(ve)),De.range||(De.range=new P.Range(ve,ve)),R.Hover.from(De)})}}class l{constructor(j,X){this._documents=j,this._provider=X}provideEvaluatableExpression(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,ve,te)).then(De=>{if(De)return R.EvaluatableExpression.from(De)})}}class p{constructor(j,X){this._documents=j,this._provider=X}provideInlineValues(j,X,te,ae){const ve=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideInlineValues(ve,R.Range.to(X),R.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>R.InlineValue.from(Oe))})}}class S{constructor(j,X){this._documents=j,this._provider=X}provideDocumentHighlights(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,ve,te)).then(De=>{if(Array.isArray(De))return De.map(R.DocumentHighlight.from)})}}class f{constructor(j,X){this._documents=j,this._provider=X}provideLinkedEditingRanges(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,ve,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(R.Range.from)),wordPattern:De.wordPattern}})}}class v{constructor(j,X){this._documents=j,this._provider=X}provideReferences(j,X,te,ae){const ve=this._documents.getDocument(j),De=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideReferences(ve,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.location.from)})}}class I{constructor(j,X,te,ae,ve,De,Oe){this._documents=j,this._commands=X,this._diagnostics=te,this._provider=ae,this._logService=ve,this._extension=De,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,X,te,ae){const ve=this._documents.getDocument(j),De=b.Selection.isISelection(X)?R.Selection.to(X):R.Range.to(X),Oe=[];for(const ke of this._diagnostics.getDiagnostics(j))if(De.intersection(ke.range)&&Oe.push(ke)>I._maxCodeActionsPerFile)break;const we={diagnostics:Oe,only:te.only?new P.CodeActionKind(te.only):void 0,triggerKind:R.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(ve,De,we,ae)).then(ke=>{var Te;if(!(!(0,T.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),ye=new h.DisposableStore;this._disposables.set(xe,ye);const Ke=[];for(let G=0;G<ke.length;G++){const ie=ke[G];!ie||(I._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,ye)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[xe,G],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,ye),diagnostics:ie.diagnostics&&ie.diagnostics.map(R.Diagnostic.from),edit:ie.edit&&R.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Te=ie.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:xe,actions:Ke}}})}async resolveCodeAction(j,X){var te;const[ae,ve]=j,De=this._cache.get(ae,ve);if(!(!De||I._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(te=await this._provider.resolveCodeAction(De,X))!==null&&te!==void 0?te:De;return(Oe==null?void 0:Oe.edit)?R.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}I._maxCodeActionsPerFile=1e3;class L{constructor(j,X){this._documents=j,this._provider=X}provideDocumentFormattingEdits(j,X,te){const ae=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,X,te)).then(ve=>{if(Array.isArray(ve))return ve.map(R.TextEdit.from)})}}class x{constructor(j,X){this._documents=j,this._provider=X}provideDocumentRangeFormattingEdits(j,X,te,ae){const ve=this._documents.getDocument(j),De=R.Range.to(X);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ve,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.TextEdit.from)})}}class Z{constructor(j,X){this._documents=j,this._provider=X,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,X,te,ae,ve){const De=this._documents.getDocument(j),Oe=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,te,ae,ve)).then(we=>{if(Array.isArray(we))return we.map(R.TextEdit.from)})}}class z{constructor(j,X){this._provider=j,this._logService=X,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,X){const te=A.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(j,X)).then(ae=>{if((0,T.isNonEmptyArray)(ae)){for(const ve of ae)if(!!ve){if(!ve.name){this._logService.warn("INVALID SymbolInformation, lacks name",ve);continue}const De=A.IdObject.mixin(R.WorkspaceSymbol.from(ve));this._symbolCache.set(De._id,ve),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(j,X){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const te=this._symbolCache.get(j._id);if(te){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,X));return ae&&(0,y.mixin)(j,R.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(j){const X=this._resultCache.get(j);if(X){for(let[te,ae]=X;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(j)}}}class B{constructor(j,X,te){this._documents=j,this._provider=X,this._logService=te}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,X,te,ae){const ve=this._documents.getDocument(j),De=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(ve,De,te,ae)).then(Oe=>{if(!!Oe)return R.WorkspaceEdit.from(Oe)},Oe=>{const we=B._asMessage(Oe);return we?{rejectReason:we,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(j,X,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(j),ve=R.Position.to(X);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,ve,te)).then(De=>{let Oe,we;if(P.Range.isRange(De)?(Oe=De,we=ae.getText(De)):(0,k.isObject)(De)&&(Oe=De.range,we=De.placeholder),!!Oe){if(Oe.start.line>ve.line||Oe.end.line<ve.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Oe),text:we}}},De=>{const Oe=B._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ${constructor(j,X){this.resultId=j,this.tokens=X}}class M{constructor(j,X){this._documents=j,this._provider=X,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,X,te){const ae=this._documents.getDocument(j),ve=X!==0?this._previousResults.get(X):null;return(0,D.asPromise)(()=>ve&&typeof ve.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,ve.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(ve&&this._previousResults.delete(X),De?(De=M._fixProvidedSemanticTokens(De),this._send(M._convertToEdits(ve,De),De)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return M._isSemanticTokens(j)?M._isCorrectSemanticTokens(j)?j:new P.SemanticTokens(new Uint32Array(j.data),j.resultId):M._isSemanticTokensEdits(j)?M._isCorrectSemanticTokensEdits(j)?j:new P.SemanticTokensEdits(j.edits.map(X=>new P.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const X of j.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,X){if(!M._isSemanticTokens(X)||!j||!j.tokens)return X;const te=j.tokens,ae=te.length,ve=X.data,De=ve.length;let Oe=0;const we=Math.min(ae,De);for(;Oe<we&&te[Oe]===ve[Oe];)Oe++;if(Oe===ae&&Oe===De)return new P.SemanticTokensEdits([],X.resultId);let ke=0;const Te=we-Oe;for(;ke<Te&&te[ae-ke-1]===ve[De-ke-1];)ke++;return new P.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-ke,data:ve.subarray(Oe,De-ke)}],X.resultId)}_send(j,X){if(M._isSemanticTokens(j)){const te=this._nextResultId++;return this._previousResults.set(te,new $(j.resultId,j.data)),(0,c.encodeSemanticTokensDto)({id:te,type:"full",data:j.data})}if(M._isSemanticTokensEdits(j)){const te=this._nextResultId++;return M._isSemanticTokens(X)?this._previousResults.set(te,new $(X.resultId,X.data)):this._previousResults.set(te,new $(j.resultId)),(0,c.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(j.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class U{constructor(j,X){this._documents=j,this._provider=X}provideDocumentRangeSemanticTokens(j,X,te){const ae=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,R.Range.to(X),te)).then(ve=>ve?this._send(ve):null)}_send(j){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=U;class F{constructor(j,X,te,ae,ve){this._documents=j,this._commands=X,this._provider=te,this._apiDeprecation=ae,this._extension=ve,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,X,te,ae){const ve=this._documents.getDocument(j),De=R.Position.to(X),Oe=ve.getWordRangeAtPosition(De)||new P.Range(De,De),we=Oe.with({end:De}),ke=new g.StopWatch(!0),Te=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(ve,De,ae,R.CompletionContext.to(te)));if(!!Te&&!ae.isCancellationRequested){const xe=Array.isArray(Te)?new P.CompletionList(Te):Te,ye=F.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ke=new h.DisposableStore;this._disposables.set(ye,Ke);const G=[],ie={x:ye,b:G,a:{replace:R.Range.from(Oe),insert:R.Range.from(we)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Se=0;Se<xe.items.length;Se++){const Ne=xe.items[Se],ze=this._convertCompletionItem(Ne,[ye,Se],we,Oe);G.push(ze)}return ie}}async resolveCompletionItem(j,X){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...j);if(!!te){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,X));if(!!ae)return this._convertCompletionItem(ae,j)}}}releaseCompletionItems(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,X,te,ae){var ve;const De=this._disposables.get(X[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:X,a:(ve=j.label)!==null&&ve!==void 0?ve:"",o:j.label2,b:j.kind!==void 0?R.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(R.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(j.command,De)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=j.textEdit.newText):typeof j.insertText=="string"?Oe.h=j.insertText:j.insertText instanceof P.SnippetString&&(Oe.h=j.insertText.value,Oe.i|=4);let we;return j.textEdit?we=j.textEdit.range:j.range&&(we=j.range),P.Range.isRange(we)?Oe.j=R.Range.from(we):we&&(!(te==null?void 0:te.isEqual(we.inserting))||!(ae==null?void 0:ae.isEqual(we.replacing)))&&(Oe.j={insert:R.Range.from(we.inserting),replace:R.Range.from(we.replacing)}),Oe}}class N{constructor(j,X){this._documents=j,this._provider=X,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(j,X,te,ae){const ve=this._documents.getDocument(j),De=R.Position.to(X),Oe=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(ve,De,ae,Oe)).then(we=>{if(we){const ke=this._cache.add([we]);return Object.assign(Object.assign({},R.SignatureHelp.from(we)),{id:ke})}})}reviveContext(j){let X;if(j.activeSignatureHelp){const te=R.SignatureHelp.to(j.activeSignatureHelp),ae=this._cache.get(j.activeSignatureHelp.id,0);ae?(X=ae,X.activeSignature=te.activeSignature,X.activeParameter=te.activeParameter):X=te}return Object.assign(Object.assign({},j),{activeSignatureHelp:X})}releaseSignatureHelp(j){this._cache.delete(j)}}class O{constructor(j,X){this._documents=j,this._provider=X}provideInlineHints(j,X,te){const ae=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,R.Range.to(X),te)).then(ve=>ve?{hints:ve.map(R.InlineHint.from)}:void 0)}}class V{constructor(j,X){this._documents=j,this._provider=X,this._cache=new E.Cache("DocumentLink")}provideLinks(j,X){const te=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,X)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(R.DocumentLink.from)};{const ve=this._cache.add(ae),De={links:[],id:ve};for(let Oe=0;Oe<ae.length;Oe++){const we=R.DocumentLink.from(ae[Oe]);we.cacheId=[ve,Oe],De.links.push(we)}return De}}})}resolveLink(j,X){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...j);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,X)).then(ae=>ae&&R.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class q{constructor(j,X){this._documents=j,this._provider=X}provideColors(j,X){const te=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,X)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:R.Color.from(De.color),range:R.Range.from(De.range)})):[])}provideColorPresentations(j,X,te){const ae=this._documents.getDocument(j),ve=R.Range.to(X.range),De=R.Color.to(X.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:ve},te)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(R.ColorPresentation.from)})}}class Q{constructor(j,X){this._documents=j,this._provider=X}provideFoldingRanges(j,X,te){const ae=this._documents.getDocument(j);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,X,te)).then(ve=>{if(!!Array.isArray(ve))return ve.map(R.FoldingRange.from)})}}class fe{constructor(j,X,te){this._documents=j,this._provider=X,this._logService=te}provideSelectionRanges(j,X,te){const ae=this._documents.getDocument(j),ve=X.map(R.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,ve,te)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==ve.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let we=0;we<ve.length;we++){const ke=[];Oe.push(ke);let Te=ve[we],xe=De[we];for(;;){if(!xe.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(R.SelectionRange.from(xe)),!xe.parent)break;Te=xe.range,xe=xe.parent}}return Oe})}}class _e{constructor(j,X){this._documents=j,this._provider=X,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(j,X,te){const ae=this._documents.getDocument(j),ve=R.Position.to(X),De=await this._provider.prepareCallHierarchy(ae,ve,te);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Oe,we)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(j,X,te){const ae=this._itemFromCache(j,X);if(!ae)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!ve)return ve.map(De=>({from:this._cacheAndConvertItem(j,De.from),fromRanges:De.fromRanges.map(Oe=>R.Range.from(Oe))}))}async provideCallsFrom(j,X,te){const ae=this._itemFromCache(j,X);if(!ae)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!ve)return ve.map(De=>({to:this._cacheAndConvertItem(j,De.to),fromRanges:De.fromRanges.map(Oe=>R.Range.from(Oe))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,X){var te;const ae=this._cache.get(j),ve={_sessionId:j,_itemId:ae.size.toString(36),name:X.name,detail:X.detail,kind:R.SymbolKind.from(X.kind),uri:X.uri,range:R.Range.from(X.range),selectionRange:R.Range.from(X.selectionRange),tags:(te=X.tags)===null||te===void 0?void 0:te.map(R.SymbolTag.from)};return ae.set(ve._itemId,X),ve}_itemFromCache(j,X){const te=this._cache.get(j);return te==null?void 0:te.get(X)}}class Le{constructor(j,X){this.adapter=j,this.extension=X}}class Ie{constructor(j,X,te,ae,ve,De,Oe){this._adapter=new Map,this._uriTransformer=X,this._proxy=j.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=ve,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(j){return(0,T.coalesce)((0,T.asArray)(j).map(X=>this._doTransformDocumentSelector(X)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:R.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new P.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Ie._handlePool++}_withAdapter(j,X,te,ae,ve=!1){const De=this._adapter.get(j);if(!De)return Promise.resolve(ae);if(De.adapter instanceof X){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${X.name}'`));const we=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(we).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Te=>{ve&&Te instanceof w.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Te))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,X){const te=this._nextHandle();return this._adapter.set(te,new Le(j,X)),te}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,X,te,ae){const ve=this._addNewAdapter(new d(this._documents,te),j),De=ae&&ae.label||Ie._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(ve,this._transformDocumentSelector(X),De),this._createDisposable(ve)}$provideDocumentSymbols(j,X,te){return this._withAdapter(j,d,ae=>ae.provideDocumentSymbols(_.URI.revive(X),te),void 0)}registerCodeLensProvider(j,X,te){const ae=this._nextHandle(),ve=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Le(new u(this._documents,this._commands.converter,te),j)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(X),ve);let De=this._createDisposable(ae);if(ve!==void 0){const Oe=te.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(ve));De=P.Disposable.from(De,Oe)}return De}$provideCodeLenses(j,X,te){return this._withAdapter(j,u,ae=>ae.provideCodeLenses(_.URI.revive(X),te),void 0)}$resolveCodeLens(j,X,te){return this._withAdapter(j,u,ae=>ae.resolveCodeLens(X,te),void 0)}$releaseCodeLenses(j,X){this._withAdapter(j,u,te=>Promise.resolve(te.releaseCodeLenses(X)),void 0)}registerDefinitionProvider(j,X,te){const ae=this._addNewAdapter(new t(this._documents,te),j);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideDefinition(j,X,te,ae){return this._withAdapter(j,t,ve=>ve.provideDefinition(_.URI.revive(X),te,ae),[])}registerDeclarationProvider(j,X,te){const ae=this._addNewAdapter(new i(this._documents,te),j);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideDeclaration(j,X,te,ae){return this._withAdapter(j,i,ve=>ve.provideDeclaration(_.URI.revive(X),te,ae),[])}registerImplementationProvider(j,X,te){const ae=this._addNewAdapter(new o(this._documents,te),j);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideImplementation(j,X,te,ae){return this._withAdapter(j,o,ve=>ve.provideImplementation(_.URI.revive(X),te,ae),[])}registerTypeDefinitionProvider(j,X,te){const ae=this._addNewAdapter(new s(this._documents,te),j);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideTypeDefinition(j,X,te,ae){return this._withAdapter(j,s,ve=>ve.provideTypeDefinition(_.URI.revive(X),te,ae),[])}registerHoverProvider(j,X,te,ae){const ve=this._addNewAdapter(new r(this._documents,te),j);return this._proxy.$registerHoverProvider(ve,this._transformDocumentSelector(X)),this._createDisposable(ve)}$provideHover(j,X,te,ae){return this._withAdapter(j,r,ve=>ve.provideHover(_.URI.revive(X),te,ae),void 0)}registerEvaluatableExpressionProvider(j,X,te,ae){const ve=this._addNewAdapter(new l(this._documents,te),j);return this._proxy.$registerEvaluatableExpressionProvider(ve,this._transformDocumentSelector(X)),this._createDisposable(ve)}$provideEvaluatableExpression(j,X,te,ae){return this._withAdapter(j,l,ve=>ve.provideEvaluatableExpression(_.URI.revive(X),te,ae),void 0)}registerInlineValuesProvider(j,X,te,ae){const ve=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new p(this._documents,te),j);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(X),ve);let Oe=this._createDisposable(De);if(ve!==void 0){const we=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(ve));Oe=P.Disposable.from(Oe,we)}return Oe}$provideInlineValues(j,X,te,ae,ve){return this._withAdapter(j,p,De=>De.provideInlineValues(_.URI.revive(X),te,ae,ve),void 0)}registerDocumentHighlightProvider(j,X,te){const ae=this._addNewAdapter(new S(this._documents,te),j);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideDocumentHighlights(j,X,te,ae){return this._withAdapter(j,S,ve=>ve.provideDocumentHighlights(_.URI.revive(X),te,ae),void 0)}registerLinkedEditingRangeProvider(j,X,te){const ae=this._addNewAdapter(new f(this._documents,te),j);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideLinkedEditingRanges(j,X,te,ae){return this._withAdapter(j,f,async ve=>{const De=await ve.provideLinkedEditingRanges(_.URI.revive(X),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(j,X,te){const ae=this._addNewAdapter(new v(this._documents,te),j);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideReferences(j,X,te,ae,ve){return this._withAdapter(j,v,De=>De.provideReferences(_.URI.revive(X),te,ae,ve),void 0)}registerCodeActionProvider(j,X,te,ae){var ve,De;const Oe=new h.DisposableStore,we=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,te,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(X),{providedKinds:(ve=ae==null?void 0:ae.providedCodeActionKinds)===null||ve===void 0?void 0:ve.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Ie._extLabel(j),Boolean(te.resolveCodeAction)),Oe.add(this._createDisposable(we)),Oe}$provideCodeActions(j,X,te,ae,ve){return this._withAdapter(j,I,De=>De.provideCodeActions(_.URI.revive(X),te,ae,ve),void 0)}$resolveCodeAction(j,X,te){return this._withAdapter(j,I,ae=>ae.resolveCodeAction(X,te),void 0)}$releaseCodeActions(j,X){this._withAdapter(j,I,te=>Promise.resolve(te.releaseCodeActions(X)),void 0)}registerDocumentFormattingEditProvider(j,X,te){const ae=this._addNewAdapter(new L(this._documents,te),j);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(X),j.identifier,j.displayName||j.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(j,X,te,ae){return this._withAdapter(j,L,ve=>ve.provideDocumentFormattingEdits(_.URI.revive(X),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(j,X,te){const ae=this._addNewAdapter(new x(this._documents,te),j);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(X),j.identifier,j.displayName||j.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(j,X,te,ae,ve){return this._withAdapter(j,x,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(X),te,ae,ve),void 0)}registerOnTypeFormattingEditProvider(j,X,te,ae){const ve=this._addNewAdapter(new Z(this._documents,te),j);return this._proxy.$registerOnTypeFormattingSupport(ve,this._transformDocumentSelector(X),ae,j.identifier),this._createDisposable(ve)}$provideOnTypeFormattingEdits(j,X,te,ae,ve,De){return this._withAdapter(j,Z,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(X),te,ae,ve,De),void 0)}registerWorkspaceSymbolProvider(j,X){const te=this._addNewAdapter(new z(X,this._logService),j);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(j,X,te){return this._withAdapter(j,z,ae=>ae.provideWorkspaceSymbols(X,te),{symbols:[]})}$resolveWorkspaceSymbol(j,X,te){return this._withAdapter(j,z,ae=>ae.resolveWorkspaceSymbol(X,te),void 0)}$releaseWorkspaceSymbols(j,X){this._withAdapter(j,z,te=>te.releaseWorkspaceSymbols(X),void 0)}registerRenameProvider(j,X,te){const ae=this._addNewAdapter(new B(this._documents,te,this._logService),j);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(X),B.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(j,X,te,ae,ve){return this._withAdapter(j,B,De=>De.provideRenameEdits(_.URI.revive(X),te,ae,ve),void 0)}$resolveRenameLocation(j,X,te,ae){return this._withAdapter(j,B,ve=>ve.resolveRenameLocation(_.URI.revive(X),te,ae),void 0)}registerDocumentSemanticTokensProvider(j,X,te,ae){const ve=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ve,new Le(new M(this._documents,te),j)),this._proxy.$registerDocumentSemanticTokensProvider(ve,this._transformDocumentSelector(X),ae,De);let Oe=this._createDisposable(ve);if(De){const we=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=P.Disposable.from(Oe,we)}return Oe}$provideDocumentSemanticTokens(j,X,te,ae){return this._withAdapter(j,M,ve=>ve.provideDocumentSemanticTokens(_.URI.revive(X),te,ae),null,!0)}$releaseDocumentSemanticTokens(j,X){this._withAdapter(j,M,te=>te.releaseDocumentSemanticColoring(X),void 0)}registerDocumentRangeSemanticTokensProvider(j,X,te,ae){const ve=this._addNewAdapter(new U(this._documents,te),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ve,this._transformDocumentSelector(X),ae),this._createDisposable(ve)}$provideDocumentRangeSemanticTokens(j,X,te,ae){return this._withAdapter(j,U,ve=>ve.provideDocumentRangeSemanticTokens(_.URI.revive(X),te,ae),null,!0)}registerCompletionItemProvider(j,X,te,ae){const ve=this._addNewAdapter(new F(this._documents,this._commands.converter,te,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(ve,this._transformDocumentSelector(X),ae,F.supportsResolving(te),`${j.identifier.value}(${ae.join("")})`),this._createDisposable(ve)}$provideCompletionItems(j,X,te,ae,ve){return this._withAdapter(j,F,De=>De.provideCompletionItems(_.URI.revive(X),te,ae,ve),void 0)}$resolveCompletionItem(j,X,te){return this._withAdapter(j,F,ae=>ae.resolveCompletionItem(X,te),void 0)}$releaseCompletionItems(j,X){this._withAdapter(j,F,te=>te.releaseCompletionItems(X),void 0)}registerSignatureHelpProvider(j,X,te,ae){const ve=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),j);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(X),ve),this._createDisposable(De)}$provideSignatureHelp(j,X,te,ae,ve){return this._withAdapter(j,N,De=>De.provideSignatureHelp(_.URI.revive(X),te,ae,ve),void 0)}$releaseSignatureHelp(j,X){this._withAdapter(j,N,te=>te.releaseSignatureHelp(X),void 0)}registerInlineHintsProvider(j,X,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ve=this._addNewAdapter(new O(this._documents,te),j);this._proxy.$registerInlineHintsProvider(ve,this._transformDocumentSelector(X),ae);let De=this._createDisposable(ve);if(ae!==void 0){const Oe=te.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Oe)}return De}$provideInlineHints(j,X,te,ae){return this._withAdapter(j,O,ve=>ve.provideInlineHints(_.URI.revive(X),te,ae),void 0)}registerDocumentLinkProvider(j,X,te){const ae=this._addNewAdapter(new V(this._documents,te),j);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(X),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(j,X,te){return this._withAdapter(j,V,ae=>ae.provideLinks(_.URI.revive(X),te),void 0)}$resolveDocumentLink(j,X,te){return this._withAdapter(j,V,ae=>ae.resolveLink(X,te),void 0)}$releaseDocumentLinks(j,X){this._withAdapter(j,V,te=>te.releaseLinks(X),void 0)}registerColorProvider(j,X,te){const ae=this._addNewAdapter(new q(this._documents,te),j);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideDocumentColors(j,X,te){return this._withAdapter(j,q,ae=>ae.provideColors(_.URI.revive(X),te),[])}$provideColorPresentations(j,X,te,ae){return this._withAdapter(j,q,ve=>ve.provideColorPresentations(_.URI.revive(X),te,ae),void 0)}registerFoldingRangeProvider(j,X,te){const ae=this._nextHandle(),ve=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Le(new Q(this._documents,te),j)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(X),ve);let De=this._createDisposable(ae);if(ve!==void 0){const Oe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ve));De=P.Disposable.from(De,Oe)}return De}$provideFoldingRanges(j,X,te,ae){return this._withAdapter(j,Q,ve=>ve.provideFoldingRanges(_.URI.revive(X),te,ae),void 0)}registerSelectionRangeProvider(j,X,te){const ae=this._addNewAdapter(new fe(this._documents,te,this._logService),j);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$provideSelectionRanges(j,X,te,ae){return this._withAdapter(j,fe,ve=>ve.provideSelectionRanges(_.URI.revive(X),te,ae),[])}registerCallHierarchyProvider(j,X,te){const ae=this._addNewAdapter(new _e(this._documents,te),j);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(X)),this._createDisposable(ae)}$prepareCallHierarchy(j,X,te,ae){return this._withAdapter(j,_e,ve=>Promise.resolve(ve.prepareSession(_.URI.revive(X),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(j,X,te,ae){return this._withAdapter(j,_e,ve=>ve.provideCallsTo(X,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(j,X,te,ae){return this._withAdapter(j,_e,ve=>ve.provideCallsFrom(X,te,ae),void 0)}$releaseCallHierarchy(j,X){this._withAdapter(j,_e,te=>Promise.resolve(te.releaseSession(X)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,C.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Ie._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ie._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ie._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Ie._serializeRegExp(j.beforeText),afterText:j.afterText?Ie._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Ie._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(j,X,te){let{wordPattern:ae}=te;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(X,ae):this._documents.setWordDefinitionFor(X,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ve=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ie._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ie._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ie._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ve,X,De),this._createDisposable(ve)}$setWordDefinitions(j){for(const X of j)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(ge[236],pe([0,1,5,20,8]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(A,C){this._proxy=A.getProxy(_.MainContext.MainThreadLanguages),this._documents=C}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,C){await this._proxy.$changeLanguage(A,C);const n=this._documents.getDocumentData(A);if(!n)throw new Error(`document '${A.toString}' NOT found`);return n.document}async tokenAtPosition(A,C){var n;const T=A.version,k=y.Position.from(C),b=await this._proxy.$tokensAtPosition(A.uri,k),h={type:R.StandardTokenType.Other,range:(n=A.getWordRangeAtPosition(C))!==null&&n!==void 0?n:new R.Range(C.line,C.character,C.line,C.character)};if(!b)return h;const c={range:y.Range.to(b.range),type:y.TokenType.to(b.type)};return!c.range.contains(C)||T!==A.version?h:c}}e.ExtHostLanguages=P}),define(ge[237],pe([0,1,5,13,41]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(A){return A&&A.title}let D=class{constructor(C,n){this._logService=n,this._proxy=C.getProxy(_.MainContext.MainThreadMessageService)}showMessage(C,n,T,k,b){const h={extension:C};let c;typeof k=="string"||P(k)?c=[k,...b]:(h.modal=k&&k.modal,h.useCustom=k&&k.useCustom,c=b),h.useCustom&&(0,R.checkProposedApiEnabled)(C);const m=[];for(let E=0;E<c.length;E++){const g=c[E];if(typeof g=="string")m.push({title:g,handle:E,isCloseAffordance:!1});else if(typeof g=="object"){let{title:w,isCloseAffordance:d}=g;m.push({title:w,isCloseAffordance:!!d,handle:E})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(n,T,h,m).then(E=>{if(typeof E=="number")return c[E]})}};D=je([Ue(1,y.ILogService)],D),e.ExtHostMessageService=D}),define(ge[238],pe([0,1,21,3,6,2,28,5,20,8,84,85,23,214,215,70,15,73]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class w extends R.Disposable{constructor(r,l,p,S,f){super();this._editorId=r,this.uri=l,this._proxy=p,this._webviewInitData=S,this.document=f,this._onDidReceiveDocumentMessage=new y.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:v=>this._proxy.$postMessage(this._editorId,void 0,v),asWebviewUri:v=>this._asWebviewUri(v)}}onDidReceiveMessage(r,l){var p;this._onDidReceiveDocumentMessage.fire(l),r!==void 0&&((p=this._rendererIdToEmitters.get(r))===null||p===void 0||p.fire(l))}getRendererComm(r){const l=new y.Emitter;return this._rendererIdToEmitters.set(r,l),{editorId:this._editorId,onDidReceiveMessage:l.event,postMessage:p=>this._proxy.$postMessage(this._editorId,r,p),asWebviewUri:p=>this._asWebviewUri(p)}}_asWebviewUri(r){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,r)}}class d extends R.Disposable{constructor(r,l,p,S){super();this._proxy=r,this._handle=l,this._extension=p,this._provider=S,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(f=>{const v=f==null?void 0:f.uri;this._proxy.$onNotebookKernelChange(this._handle,v)}))}async provideKernels(r,l){const p=await this._provider.provideKernels(r.notebookDocument,l)||[],S=new Map;let f=0;const v=new Set,I=this._kernelToFriendlyId.get(r.uri),L=p.map(Z=>{let z=I==null?void 0:I.get(Z);return z===void 0&&(Z.id&&v.has(Z.id)?z=`${this._extension.identifier.value}_${Z.id}_${f++}`:z=`${this._extension.identifier.value}_${Z.id||D.generateUuid()}`),S.set(Z,z),{id:Z.id,friendlyId:z,label:Z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:Z.description,detail:Z.detail,isPreferred:Z.isPreferred,preloads:Z.preloads,supportedLanguages:Z.supportedLanguages}});this._kernelToFriendlyId.set(r.uri,S);const x=new Map;return S.forEach((Z,z)=>{x.set(Z,z)}),this._friendlyIdToKernel.set(r.uri,x),L}getKernelByFriendlyId(r,l){var p;return(p=this._friendlyIdToKernel.get(r))===null||p===void 0?void 0:p.get(l)}async resolveNotebook(r,l,p,S){var f;const v=(f=this._friendlyIdToKernel.get(l.uri))===null||f===void 0?void 0:f.get(r);if(v&&this._provider.resolveKernel)return this._provider.resolveKernel(v,l.notebookDocument,p,S)}async executeNotebook(r,l,p){var S;const f=(S=this._friendlyIdToKernel.get(l.uri))===null||S===void 0?void 0:S.get(r);if(!!f)return u(p?v=>f.executeCell(l.notebookDocument,p.cell,v):v=>f.executeAllCells(l.notebookDocument,v))}async cancelNotebook(r,l,p){var S;const f=(S=this._friendlyIdToKernel.get(l.uri))===null||S===void 0?void 0:S.get(r);if(!!f)return p?f.cancelCellExecution(l.notebookDocument,p.cell):f.cancelAllCellsExecution(l.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;async function u(s){const r=new _.CancellationTokenSource;try{await s(r.token)}finally{r.dispose()}}class a{constructor(r,l){const p=a._Keys.nextId();r.$registerNotebookEditorDecorationType(p,C.NotebookDecorationRenderOptions.from(l)),this.value={key:p,dispose(){r.$removeNotebookEditorDecorationType(p)}}}}e.NotebookEditorDecorationType=a,a._Keys=new m.IdGenerator("NotebookEditorDecorationType");class t{constructor(r,l,p,S,f,v,I){this._textDocumentsAndEditors=p,this._textDocuments=S,this._webviewInitData=f,this.logService=v,this._extensionStoragePaths=I,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new y.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new y.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new y.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new y.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new y.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new y.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new y.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new y.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=r.getProxy(A.MainContext.MainThreadNotebook),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:L=>{var x;if(L&&L.$mid===12){const Z=(x=L.notebookEditor)===null||x===void 0?void 0:x.notebookUri,z=L.cell.handle,B=this._documents.get(Z),$=B==null?void 0:B.getCell(z);if($)return $.cell}return L}})}get activeNotebookEditor(){var r;return(r=this._activeNotebookEditor)===null||r===void 0?void 0:r.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(r=>r.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(r){return this._documents.get(r)}_getNotebookDocument(r){const l=this._documents.get(r);if(!l)throw new Error(`NO notebook document for '${r}'`);return l}_getProviderData(r){const l=this._notebookContentProviders.get(r);if(!l)throw new Error(`NO provider for '${r}'`);return l}registerNotebookContentProvider(r,l,p,S){var f,v,I;if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:r,provider:p});let L;p.onDidChangeNotebookContentOptions&&(L=p.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(l,p.options)}));const x=(f=S==null?void 0:S.viewOptions)===null||f===void 0?void 0:f.filenamePattern.map(Z=>C.NotebookExclusiveDocumentPattern.from(Z)).filter(Z=>Z!==void 0);return((v=S==null?void 0:S.viewOptions)===null||v===void 0?void 0:v.filenamePattern)&&!x&&console.warn(`Notebook content provider view options file name pattern is invalid ${(I=S==null?void 0:S.viewOptions)===null||I===void 0?void 0:I.filenamePattern}`),this._proxy.$registerNotebookProvider({id:r.identifier,location:r.extensionLocation,description:r.description},l,{transientOutputs:(S==null?void 0:S.transientOutputs)||!1,transientMetadata:(S==null?void 0:S.transientMetadata)||{},viewOptions:(S==null?void 0:S.viewOptions)&&x?{displayName:S.viewOptions.displayName,filenamePattern:x,exclusive:S.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{L==null||L.dispose(),this._notebookContentProviders.delete(l),this._proxy.$unregisterNotebookProvider(l)})}registerNotebookKernelProvider(r,l,p){const S=t._notebookKernelProviderHandlePool++,f=new d(this._proxy,S,r,p);return this._notebookKernelProviders.set(S,f),this._proxy.$registerNotebookKernelProvider({id:r.identifier,location:r.extensionLocation,description:r.description},S,{viewType:l.viewType,filenamePattern:l.filenamePattern?C.NotebookExclusiveDocumentPattern.from(l.filenamePattern):void 0}),new n.Disposable(()=>{f.dispose(),this._notebookKernelProviders.delete(S),this._proxy.$unregisterNotebookKernelProvider(S)})}createNotebookEditorDecorationType(r){return new a(this._proxy,r).value}async openNotebookDocument(r){const l=this._documents.get(r);if(l)return l.notebookDocument;const p=await this._proxy.$tryOpenDocument(r),S=this._documents.get(P.URI.revive(p));return(0,E.assertIsDefined)(S==null?void 0:S.notebookDocument)}_withAdapter(r,l,p){const S=this._documents.get(P.URI.revive(l));if(!S)return[];const f=this._notebookKernelProviders.get(r);return f?p(f,S):[]}async showNotebookDocument(r,l){var p;P.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let S;typeof l=="object"?S={position:C.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:l.selection&&C.NotebookCellRange.from(l.selection),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:S={preserveFocus:!1};const f=await this._proxy.$tryShowNotebookDocument(r.uri,r.viewType,S),v=f&&((p=this._editors.get(f))===null||p===void 0?void 0:p.editor);if(v)return v.editor;throw f?new Error(`Could NOT open editor for "${r.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.toString()}".`)}async $provideNotebookKernels(r,l,p){return this._withAdapter(r,l,(S,f)=>S.provideKernels(f,p))}async $resolveNotebookKernel(r,l,p,S,f){await this._withAdapter(r,p,async(v,I)=>{const L=this._webviewComm.get(l);L&&await v.resolveNotebook(S,I,L.contentProviderComm,f)})}async $resolveNotebookEditor(r,l,p){const S=this._notebookContentProviders.get(r),f=P.URI.revive(l),v=this._documents.get(f);if(!(!v||!S)){let I=this._webviewComm.get(p);I||(I=new w(p,f,this._proxy,this._webviewInitData,v),this._webviewComm.set(p,I)),!!S.provider.resolveNotebook&&await S.provider.resolveNotebook(v.notebookDocument,I.contentProviderComm)}}async $executeNotebookKernelFromProvider(r,l,p,S){await this._withAdapter(r,l,async(f,v)=>{const I=S!==void 0?v.getCell(S):void 0;return f.executeNotebook(p,v,I)})}async $cancelNotebookKernelFromProvider(r,l,p,S){await this._withAdapter(r,l,async(f,v)=>{const I=S!==void 0?v.getCell(S):void 0;return f.cancelNotebook(p,v,I)})}async $openNotebook(r,l,p,S,f){const{provider:v}=this._getProviderData(r),I=await v.openNotebook(P.URI.revive(l),{backupId:p,untitledDocumentData:f==null?void 0:f.buffer},S);return{metadata:C.NotebookDocumentMetadata.from(I.metadata),cells:I.cells.map(C.NotebookCellData.from)}}async $saveNotebook(r,l,p){const S=this._getNotebookDocument(P.URI.revive(l)),{provider:f}=this._getProviderData(r);return await f.saveNotebook(S.notebookDocument,p),!0}async $saveNotebookAs(r,l,p,S){const f=this._getNotebookDocument(P.URI.revive(l)),{provider:v}=this._getProviderData(r);return await v.saveNotebookAs(P.URI.revive(p),f.notebookDocument,S),!0}async $backupNotebook(r,l,p){var S;const f=this._getNotebookDocument(P.URI.revive(l)),v=this._getProviderData(r),I=(S=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&S!==void 0?S:this._extensionStoragePaths.globalValue(v.extension),L=String((0,g.hash)([f.uri.toString(),this._backupIdPool++])),x=P.URI.joinPath(I,L),Z=await v.provider.backupNotebook(f.notebookDocument,{destination:x},p);return f.updateBackup(Z),Z.id}$acceptNotebookActiveKernelChange(r){r.providerHandle!==void 0&&this._withAdapter(r.providerHandle,r.uri,async(l,p)=>{const S=r.kernelFriendlyId?l.getKernelByFriendlyId(P.URI.revive(r.uri),r.kernelFriendlyId):void 0;this._editors.forEach(f=>{f.editor.notebookData===p&&f.editor._acceptKernel(S)}),this._onDidChangeActiveNotebookKernel.fire({document:p.notebookDocument,kernel:S})})}$onDidReceiveMessage(r,l,p){var S;(S=this._webviewComm.get(r))===null||S===void 0||S.onDidReceiveMessage(l,p)}$acceptModelChanged(r,l,p){this._getNotebookDocument(P.URI.revive(r)).acceptModelChanged(l,p)}$acceptDirtyStateChanged(r,l){const p=this._getNotebookDocument(P.URI.revive(r));p.acceptModelChanged({rawEvents:[],versionId:p.notebookDocument.version},l)}$acceptModelSaved(r){const l=this._getNotebookDocument(P.URI.revive(r));this._onDidSaveNotebookDocument.fire(l.notebookDocument)}$acceptEditorPropertiesChanged(r,l){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",r,l);const p=this._editors.get(r);if(!p)throw new Error(`unknown text editor: ${r}`);l.visibleRanges&&p.editor._acceptVisibleRanges(l.visibleRanges.ranges.map(C.NotebookCellRange.to)),l.selections&&p.editor._acceptSelections(l.selections.selections.map(C.NotebookCellRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.editor.editor,visibleRanges:p.editor.editor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.editor.editor,selections:p.editor.editor.selections}))}$acceptDocumentPropertiesChanged(r,l){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",r.path,l);const p=this._getNotebookDocument(P.URI.revive(r));p.acceptDocumentPropertiesChanged(l),l.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:p.notebookDocument})}_createExtHostEditor(r,l,p){var S;const f=r.uri;let v=this._webviewComm.get(l);v||(v=new w(l,f,this._proxy,this._webviewInitData,r),this._webviewComm.set(l,v));const I=new c.ExtHostNotebookEditor(l,r.notebookDocument.viewType,this._proxy,r,p.visibleRanges.map(C.NotebookCellRange.to),p.selections.map(C.NotebookCellRange.to),typeof p.viewColumn=="number"?C.ViewColumn.to(p.viewColumn):void 0);(S=this._editors.get(l))===null||S===void 0||S.editor.dispose(),this._editors.set(l,{editor:I})}$acceptDocumentAndEditorsDelta(r){var l,p,S,f;let v=!1;if(r.removedDocuments)for(const L of r.removedDocuments){const x=P.URI.revive(L),Z=this._documents.get(x);Z&&(Z.dispose(),this._documents.delete(x),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:Z.notebookDocument.cells.map(z=>z.document.uri)}),this._onDidCloseNotebookDocument.fire(Z.notebookDocument));for(const z of this._editors.values())z.editor.notebookData.uri.toString()===x.toString()&&(z.editor.dispose(),this._editors.delete(z.editor.id),v=!0)}if(r.addedDocuments){const L=[];for(const x of r.addedDocuments){const Z=P.URI.revive(x.uri),z=x.viewType;if(this._documents.has(Z))throw new Error(`adding EXISTING notebook ${Z}`);const B=this,$=new h.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){B._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){B._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){B._onDidChangeCellMetadata.fire(M)}},z,x.metadata?C.NotebookDocumentMetadata.to(x.metadata):new n.NotebookDocumentMetadata,Z);$.acceptModelChanged({versionId:x.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,x.cells]]}]},!1),L.push(...x.cells.map(M=>h.ExtHostCell.asModelAddData($.notebookDocument,M))),(l=this._documents.get(Z))===null||l===void 0||l.dispose(),this._documents.set(Z,$),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this._onDidOpenNotebookDocument.fire($.notebookDocument)}}if(r.addedEditors)for(const L of r.addedEditors){if(this._editors.has(L.id))return;const x=P.URI.revive(L.documentUri),Z=this._documents.get(x);Z&&(this._createExtHostEditor(Z,L.id,L),v=!0)}const I=[];if(r.removedEditors)for(const L of r.removedEditors){const x=this._editors.get(L);x&&(v=!0,this._editors.delete(L),((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.id)===x.editor.id&&(this._activeNotebookEditor=void 0),I.push(x))}if(v&&I.forEach(L=>{L.editor.dispose()}),r.visibleEditors){this._visibleNotebookEditors=r.visibleEditors.map(x=>this._editors.get(x).editor).filter(x=>!!x);const L=new Set;this._visibleNotebookEditors.forEach(x=>L.add(x.id));for(const x of this._editors.values()){const Z=L.has(x.editor.id);x.editor._acceptVisibility(Z)}this._visibleNotebookEditors=[...this._editors.values()].map(x=>x.editor).filter(x=>x.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}r.newActiveEditor===null?this._activeNotebookEditor=void 0:r.newActiveEditor&&(this._activeNotebookEditor=(S=this._editors.get(r.newActiveEditor))===null||S===void 0?void 0:S.editor),r.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.editor)}createNotebookCellStatusBarItemInternal(r,l,p){const S=new i(this._proxy,this._commandsConverter,r,l,p),f=k.CellUri.parse(r.document.uri);if(f){const v=this._documents.get(f.notebook);if(v){const I=v.getCell(f.handle);I&&y.Event.once(I.onDidDispose)(()=>S.dispose())}}return S}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends R.Disposable{constructor(r,l,p,S,f){super();this._proxy=r,this._commands=l,this._cell=p,this._priority=f,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=S!=null?S:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(r){this._alignment=r,this.update()}get priority(){return this._priority}set priority(r){this._priority=r,this.update()}get text(){return this._text}set text(r){this._text=r,this.update()}get tooltip(){return this._tooltip}set tooltip(r){this._tooltip=r,this.update()}get command(){var r;return(r=this._command)===null||r===void 0?void 0:r.fromApi}set command(r){var l;((l=this._command)===null||l===void 0?void 0:l.fromApi)!==r&&(this._internalCommandRegistration.clear(),typeof r=="string"?this._command={fromApi:r,internal:this._commands.toInternal({title:"",command:r},this._internalCommandRegistration)}:r?this._command={fromApi:r,internal:this._commands.toInternal(r,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(r){this._accessibilityInformation=r,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var r;if(!this._isDisposed){const l={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(r=this._command)===null||r===void 0?void 0:r.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,l)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function o(s){return Object.freeze({cell:s.cell,get alignment(){return s.alignment},set alignment(r){s.alignment=r},get priority(){return s.priority},set priority(r){s.priority=r},get text(){return s.text},set text(r){s.text=r},get tooltip(){return s.tooltip},set tooltip(r){s.tooltip=r},get command(){return s.command},set command(r){s.command=r},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(r){s.accessibilityInformation=r},show(){s.show()},hide(){s.hide()},dispose(){s.dispose()}})}}),define(ge[64],pe([0,1,5,3,6,25,4,14]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class C extends R.Disposable{constructor(c,m,E,g){super();this._onDidAppend=this._register(new y.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=g,this._id=g.$register(this.name,m,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?P.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(m=>this._proxy.$clear(m,c))}show(c,m){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof c=="boolean"?c:m)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=C;class n extends C{constructor(c,m){super(c,!1,void 0,m)}append(c){super.append(c),this._id.then(m=>this._proxy.$append(m,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends C{constructor(c,m,E){super(c,!0,m,E)}append(c){throw new Error("Not supported")}}class k{constructor(c,m){this.name=c,this._channel=m}append(c){this._channel.then(m=>m.append(c))}appendLine(c){this._channel.then(m=>m.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,m){this._channel.then(E=>E.show(c,m))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=k;let b=class{constructor(c){this._proxy=c.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new n(c,this._proxy)}createOutputChannelFromLogFile(c,m){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new T(c,m,this._proxy)}};b=je([Ue(0,A.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[239],pe([0,1,17,21,3,6,5,2,8,16,12,57]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(h,c,m){const E=h.getProxy(D.MainContext.MainThreadQuickOpen);class g{constructor(s,r){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=r}showQuickPick(s,r,l,p=y.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(s),f=++this._instances,v=E.$show(f,{title:l==null?void 0:l.title,placeHolder:l==null?void 0:l.placeHolder,matchOnDescription:l==null?void 0:l.matchOnDescription,matchOnDetail:l==null?void 0:l.matchOnDetail,ignoreFocusLost:l==null?void 0:l.ignoreFocusOut,canPickMany:l==null?void 0:l.canPickMany},p),I={},L=v.then(()=>I);return Promise.race([L,S]).then(x=>{if(x!==I)return S.then(Z=>{const z=[];for(let B=0;B<Z.length;B++){const $=Z[B];let M,U,F,N,O;typeof $=="string"?M=$:(M=$.label,U=$.description,F=$.detail,N=$.picked,O=$.alwaysShow),z.push({label:M,description:U,handle:B,detail:F,picked:N,alwaysShow:O})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{l.onDidSelectItem(Z[B])}),E.$setItems(f,z),v.then(B=>{if(typeof B=="number")return Z[B];if(Array.isArray(B))return B.map($=>Z[$])})})}).then(void 0,x=>{if(!(0,n.isPromiseCanceledError)(x))return E.$setError(f,x),Promise.reject(x)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,r=y.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,E.$input(s,typeof this._validateInput=="function",r).then(void 0,l=>{if(!(0,n.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(s){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,r=y.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!l){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(S=>S.uri.toString()===l.uri.toString())}}createQuickPick(s,r){const l=new t(s,r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(s){const r=new i(s,()=>this._sessions.delete(r._id));return this._sessions.set(r._id,r),r}$onDidChangeValue(s,r){const l=this._sessions.get(s);l&&l._fireDidChangeValue(r)}$onDidAccept(s){const r=this._sessions.get(s);r&&r._fireDidAccept()}$onDidChangeActive(s,r){const l=this._sessions.get(s);l instanceof t&&l._fireDidChangeActive(r)}$onDidChangeSelection(s,r){const l=this._sessions.get(s);l instanceof t&&l._fireDidChangeSelection(r)}$onDidTriggerButton(s,r){const l=this._sessions.get(s);l&&l._fireDidTriggerButton(r)}$onDidHide(s){const r=this._sessions.get(s);r&&r._fireDidHide()}}class w{constructor(s,r){this._extensionId=s,this._onDidDispose=r,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((r,l)=>{const p=r===C.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(p,r)}),this.update({buttons:s.map((r,l)=>({iconPath:d(r.iconPath),tooltip:r.tooltip,handle:r===C.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const r=this._handlesToButtons.get(s);r&&this._onDidTriggerButtonEmitter.fire(r)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(s){if(!this._disposed){for(const r of Object.keys(s)){const l=s[r];this._pendingUpdate[r]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function d(o){if(o instanceof C.ThemeIcon)return{id:o.id};const s=a(o),r=u(o);return{dark:typeof s=="string"?A.URI.file(s):s,light:typeof r=="string"?A.URI.file(r):r}}function u(o){return typeof o=="object"&&"light"in o?o.light:o}function a(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends w{constructor(s,r,l){super(s,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((r,l)=>{this._handlesToItems.set(l,r),this._itemsToHandles.set(r,l)}),this.update({items:s.map((r,l)=>({label:r.label,description:r.description,handle:l,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(r=>this._itemsToHandles.has(r)),this.update({activeItems:this._activeItems.map(r=>this._itemsToHandles.get(r))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(r=>this._itemsToHandles.has(r)),this.update({selectedItems:this._selectedItems.map(r=>this._itemsToHandles.get(r))})}_fireDidChangeActive(s){const r=(0,T.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._activeItems=r,this._onDidChangeActiveEmitter.fire(r)}_fireDidChangeSelection(s){const r=(0,T.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._selectedItems=r,this._onDidChangeSelectionEmitter.fire(r)}}class i extends w{constructor(s,r){super(s,r);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?k.default.Error:k.default.Ignore})}}return new g(c,m)}e.createExtHostQuickOpen=b}),define(ge[240],pe([0,1,2,3,54,6,17,5,12,95,13,29,41]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(s){if(s)return typeof s.iconPath=="string"?_.URI.file(s.iconPath):s.iconPath}function c(s,r){if(!s.iconPath&&!r.iconPath)return 0;if(s.iconPath){if(!r.iconPath)return 1}else return-1;const l=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,p=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath;return(0,n.comparePaths)(l,p)}function m(s,r){let l=0;if(s.strikeThrough!==r.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==r.faded)return s.faded?1:-1;if(s.tooltip!==r.tooltip)return(s.tooltip||"").localeCompare(r.tooltip||"");if(l=c(s,r),l!==0)return l;if(s.light&&r.light)l=c(s.light,r.light);else{if(s.light)return 1;if(r.light)return-1}if(l!==0)return l;if(s.dark&&r.dark)l=c(s.dark,r.dark);else{if(s.dark)return 1;if(r.dark)return-1}return l}function E(s,r){if(s.command!==r.command)return s.command<r.command?-1:1;if(s.title!==r.title)return s.title<r.title?-1:1;if(s.tooltip!==r.tooltip){if(s.tooltip!==void 0&&r.tooltip!==void 0)return s.tooltip<r.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(s.arguments===r.arguments)return 0;if(s.arguments)if(r.arguments){if(s.arguments.length!==r.arguments.length)return s.arguments.length-r.arguments.length}else return 1;else return-1;for(let l=0;l<s.arguments.length;l++){const p=s.arguments[l],S=r.arguments[l];if(p!==S)return p<S?-1:1}return 0}function g(s,r){let l=(0,n.comparePaths)(s.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(l!==0)return l;if(s.command&&r.command)l=E(s.command,r.command);else{if(s.command)return 1;if(r.command)return-1}if(l!==0)return l;if(s.decorations&&r.decorations)l=m(s.decorations,r.decorations);else{if(s.decorations)return 1;if(r.decorations)return-1}return l}function w(s,r){for(let l=0;l<s.length;l++)if(s[l]!==r[l])return!1;return!0}function d(s,r){return s.command===r.command&&s.title===r.title&&s.tooltip===r.tooltip&&(s.arguments&&r.arguments?w(s.arguments,r.arguments):s.arguments===r.arguments)}function u(s,r){return(0,C.equals)(s,r,d)}class a{constructor(r,l,p){this._extension=r,this._proxy=l,this._sourceControlHandle=p,this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(r){this._proxy.$setInputBoxValue(this._sourceControlHandle,r),this.updateValue(r)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(r){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,r),this._placeholder=r}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(r){if((0,b.checkProposedApiEnabled)(this._extension),r&&typeof r!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=r,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!r)}get visible(){return this._visible}set visible(r){r=!!r,this._visible!==r&&(this._visible=r,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,r))}$onInputBoxValueChange(r){this.updateValue(r)}updateValue(r){this._value=r,this._onDidChange.fire(r)}}e.ExtHostSCMInputBox=a;class t{constructor(r,l,p,S,f){this._proxy=r,this._commands=l,this._sourceControlHandle=p,this._id=S,this._label=f,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(r){this._label=r,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,r)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(r){this._hideWhenEmpty=r,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(r){this._resourceStates=[...r],this._onDidUpdateResourceStates.fire()}getResourceState(r){return this._resourceStatesMap.get(r)}$executeResourceCommand(r,l){const p=this._resourceStatesCommandsMap.get(r);return p?(0,D.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var r;const l=[...this._resourceStates].sort(g),S=(0,C.sortedDiff)(this._resourceSnapshot,l,g).map(I=>{const L=I.toInsert.map(x=>{const Z=this._resourceHandlePool++;this._resourceStatesMap.set(Z,x);const z=x.resourceUri,B=h(x.decorations),$=x.decorations&&h(x.decorations.light)||B,M=x.decorations&&h(x.decorations.dark)||B,U=[];let F;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const fe=new P.DisposableStore;F=this._commands.converter.toInternal(x.command,fe),this._resourceStatesDisposablesMap.set(Z,fe)}else this._resourceStatesCommandsMap.set(Z,x.command);$&&U.push($),M&&M.toString()!==($==null?void 0:$.toString())&&U.push(M);const N=x.decorations&&x.decorations.tooltip||"",O=x.decorations&&!!x.decorations.strikeThrough,V=x.decorations&&!!x.decorations.faded,q=x.contextValue||"";return{rawResource:[Z,z,U,N,O,V,q,F],handle:Z}});return{start:I.start,deleteCount:I.deleteCount,toInsert:L}}),f=S.map(({start:I,deleteCount:L,toInsert:x})=>[I,L,x.map(Z=>Z.rawResource)]),v=S.reverse();for(const{start:I,deleteCount:L,toInsert:x}of v){const Z=x.map(B=>B.handle),z=this._handlesSnapshot.splice(I,L,...Z);for(const B of z)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(r=this._resourceStatesDisposablesMap.get(B))===null||r===void 0||r.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=l,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(r,l,p,S,f,v){this._proxy=l,this._commands=p,this._id=S,this._label=f,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(r,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,f,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(r){this._count!==r&&(this._count=r,this._proxy.$updateSourceControl(this.handle,{count:r}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(r){this._quickDiffProvider=r,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!r})}get commitTemplate(){return this._commitTemplate}set commitTemplate(r){r!==this._commitTemplate&&(this._commitTemplate=r,this._proxy.$updateSourceControl(this.handle,{commitTemplate:r}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(r){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=r;const l=this._commands.converter.toInternal(r,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:l})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(r){if(!(this._statusBarCommands&&r&&u(this._statusBarCommands,r))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=r;const l=(r||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:l})}}get selected(){return this._selected}createResourceGroup(r,l){const p=new t(this._proxy,this._commands,this.handle,r,l),S=y.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,S),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const r=[],l=[];for(const[p,S]of this.createdResourceGroups){S.dispose();const f=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});y.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),f.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),r.push([p.handle,p.id,p.label,p.features]);const v=p._takeResourceStateSnapshot();v.length>0&&l.push([p.handle,v]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,r,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const r=[];this.updatedResourceGroups.forEach(l=>{const p=l._takeResourceStateSnapshot();p.length!==0&&r.push([l.handle,p])}),r.length>0&&this._proxy.$spliceResourceStates(this.handle,r),this.updatedResourceGroups.clear()}getResourceGroup(r){return this._groups.get(r)}setSelectionState(r){this._selected=r,this._onDidChangeSelection.fire(r)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(r=>r.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,R.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,R.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Tn{constructor(r,l,p){this._commands=l,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=r.getProxy(A.MainContext.MainThreadSCM),this._telemetry=r.getProxy(A.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const f=this._sourceControls.get(S.sourceControlHandle);if(!f)return S;const v=f.getResourceGroup(S.groupHandle);return v?v.getResourceState(S.handle):S}else if(S&&S.$mid===4){const f=this._sourceControls.get(S.sourceControlHandle);return f?f.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const f=this._sourceControls.get(S.handle);return f||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(r,l,p,S){this.logService.trace("ExtHostSCM#createSourceControl",r.identifier.value,l,p,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const f=Tn._handlePool++,v=new i(r,this._proxy,this._commands,l,p,S);this._sourceControls.set(f,v);const I=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(r.identifier))||[];return I.push(v),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(r.identifier),I),v}getLastInputBox(r){this.logService.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const l=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(r.identifier)),p=l&&l[l.length-1];return p&&p.inputBox}$provideOriginalResource(r,l,p){const S=_.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",r,S.toString());const f=this._sourceControls.get(r);return!f||!f.quickDiffProvider||!f.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>f.quickDiffProvider.provideOriginalResource(S,p)).then(v=>v||null)}$onInputBoxValueChange(r,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",r);const p=this._sourceControls.get(r);return p&&p.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(r,l,p,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",r,l,p);const f=this._sourceControls.get(r);if(!f)return Promise.resolve(void 0);const v=f.getResourceGroup(l);return v?v.$executeResourceCommand(p,S):Promise.resolve(void 0)}$validateInput(r,l,p){this.logService.trace("ExtHostSCM#$validateInput",r);const S=this._sourceControls.get(r);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>S.inputBox.validateInput(l,p)).then(f=>f?Promise.resolve([f.message,f.type]):Promise.resolve(void 0))}$setSelectedSourceControl(r){var l,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&((l=this._sourceControls.get(r))===null||l===void 0||l.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=r,Promise.resolve(void 0)}};o._handlePool=0,o=je([Ue(2,T.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[241],pe([0,1,8,5,161,6]),function(Y,e,_,y,R,P){"use strict";var D,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(b,h,c,m,E=_.StatusBarAlignment.Left,g,w){D.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,D,b),tt(this,A,h),this._id=C.ID_GEN++,this._statusId=c,this._statusName=m,this._alignment=E,this._priority=g,this._accessibilityInformation=w}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!C.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:Be(this,A).toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:Be(this,A).toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,D).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,D).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,h,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,D=new WeakMap,A=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const h={message:b};return this._messages.unshift(h),this._update(),new _.Disposable(()=>{const c=this._messages.indexOf(h);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(b,h){this._proxy=b.getProxy(y.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new n(this)}createStatusBarEntry(b,h,c,m,E){return new C(this._proxy,this._commands,b,h,c,m,E)}setStatusBarMessage(b,h){const c=this._statusMessage.setMessage(b);let m;return typeof h=="number"?m=setTimeout(()=>c.dispose(),h):typeof h!="undefined"&&h.then(()=>c.dispose(),()=>c.dispose()),new _.Disposable(()=>{c.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=T}),define(ge[88],pe([0,1,5,3,4]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(A){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,C){this._proxy.$registerExtensionStorageKeysToSync(A,C)}getValue(A,C,n){return this._proxy.$getValue(A,C).then(T=>T||n)}setValue(A,C,n){return this._proxy.$setValue(A,C,n)}$acceptValue(A,C,n){this._onDidChangeStorage.fire({shared:A,key:C,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,13,87,2]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let A=class{constructor(n,T,k){var b;this._logService=T,this._extHostFileSystem=k,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=D.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=D.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return D.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return D.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};A=je([Ue(0,y.IExtHostInitDataService),Ue(1,R.ILogService),Ue(2,P.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ge[35],pe([0,1,3,5,4,2,14,6,8,162,16,205,21,28,186]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class m{constructor(t,i,o,s){this._proxy=t,this._id=i,this._creationOptions=o,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(l=>this._pidPromiseComplete=l);const r=this;this.value={get name(){return r._name||""},get processId(){return r._pidPromise},get creationOptions(){return r._creationOptions},get exitStatus(){return r._exitStatus},sendText(l,p=!0){r._checkDisposed(),r._proxy.$sendText(r._id,l,p)},show(l){r._checkDisposed(),r._proxy.$show(r._id,l)},hide(){r._checkDisposed(),r._proxy.$hide(r._id)},dispose(){r._disposed||(r._disposed=!0,r._proxy.$dispose(r._id))},get dimensions(){if(!(r._cols===void 0||r._rows===void 0))return{columns:r._cols,rows:r._rows}}}}async create(t,i,o,s,r,l,p,S,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:o,env:s,waitOnExit:r,strictEnv:l,hideFromUser:p,isFeatureTerminal:S,isExtensionOwnedTerminal:f})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let g=1,w=class extends A.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=i.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new m(this._proxy,(0,h.generateUuid)(),t,t.name),o=new E(t.pty);return i.createExtensionTerminal().then(s=>{const r=this._setupExtHostProcessListeners(s,o);this._terminalProcessDisposables[s]=r}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new E(i),r=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=r}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:i})}async $acceptTerminalDimensions(t,i,o){const s=this._getTerminalById(t);s&&s.setDimensions(i,o)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,o){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(i,o)}async $acceptTerminalTitleChange(t,i){const o=this._getTerminalById(t);o&&(o.name=i)}async $acceptTerminalClosed(t,i){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const s=this._terminals.splice(o,1)[0];s.setExitCode(i),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,i,o,s){if(i){const p=this._getTerminalObjectIndexById(this._terminals,i);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const r={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:P.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},l=new m(this._proxy,t,r,o);this._terminals.push(l),this._onDidOpenTerminal.fire(l.value),l.isOpen=!0}async $acceptTerminalProcessId(t,i){const o=this._getTerminalById(t);o&&o._setProcessId(i)}async $startExtensionTerminal(t,i){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(r=>{const l=this.onDidOpenTerminal(async p=>{p===o.value&&(l.dispose(),r())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const o=new A.DisposableStore;o.add(i.onProcessReady(r=>this._proxy.$sendProcessReady(t,r.pid,r.cwd))),o.add(i.onProcessTitleChanged(r=>this._proxy.$sendProcessTitle(t,r))),this._bufferer.startBuffering(t,i.onProcessData),o.add(i.onProcessExit(r=>this._onProcessExit(t,r))),i.onProcessOverrideDimensions&&o.add(i.onProcessOverrideDimensions(r=>this._proxy.$sendOverrideDimensions(t,r))),this._terminalProcesses.set(t,i);const s=this._extensionTerminalAwaitingStart[t];return s&&i instanceof E&&(i.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(i)}$acceptProcessResize(t,i,o){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(i,o)}catch(r){if(r.code!=="EPIPE"&&r.code!=="ERR_IPC_CHANNEL_CLOSED")throw r}}$acceptProcessShutdown(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const r=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,r);const l=[],p={terminal:o.value,line:i},S=[];for(const I of this._linkProviders)S.push(new Promise(async L=>{r.token.onCancellationRequested(()=>L({provider:I,links:[]}));const x=await I.provideTerminalLinks(p,r.token)||[];r.token.isCancellationRequested||L({provider:I,links:x})}));const f=await Promise.all(S);if(r.token.isCancellationRequested)return[];const v=new Map;for(const I of f)I&&I.links.length>0&&l.push(...I.links.map(L=>{const x={id:g++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return v.set(x.id,{provider:I.provider,link:L}),x}));return this._terminalLinkCache.set(t,v),l}$activateLink(t,i){var o;const s=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(i);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const o=this._getTerminalObjectIndexById(t,i);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,i){let o=null;return t.some((s,r)=>s._id===i?(o=r,!0):!1),o}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new d,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const o=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const o=i[0],s=new d(i[1]);this._setEnvironmentVariableCollection(o,s)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};w=je([Ue(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:C.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:C.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const o=this.map.get(t);(!o||o.value!==i.value||o.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((o,s)=>t.call(i,s,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let u=class extends w{constructor(t){super(!1,t)}createTerminal(t,i,o){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=je([Ue(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[242],pe([0,1,3,12,5,121,20,8]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(b=>b.value)}async showTextDocument(T,k,b){let h;typeof k=="number"?h={position:D.ViewColumn.from(k),preserveFocus:b}:typeof k=="object"?h={position:D.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?D.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(T.uri,h),m=c&&this._extHostDocumentsAndEditors.getEditor(c);if(m)return m.value;throw c?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new P.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const b=this._extHostDocumentsAndEditors.getEditor(T);if(!b)throw new Error("unknown text editor");if(k.options&&b._acceptOptions(k.options),k.selections){const h=k.selections.selections.map(D.Selection.to);b._acceptSelections(h)}if(k.visibleRanges){const h=y.coalesce(k.visibleRanges.map(D.Range.to));b._acceptVisibleRanges(h)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const h=A.TextEditorSelectionChangeKind.fromValue(k.selections.source),c=k.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:c,kind:h})}if(k.visibleRanges){const h=y.coalesce(k.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:h})}}$acceptEditorPositionData(T){for(const k in T){const b=this._extHostDocumentsAndEditors.getEditor(k);if(!b)throw new Error("Unknown text editor");const h=D.ViewColumn.to(T[k]);b.value.viewColumn!==h&&(b._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:h}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=C});var dn=this&&this.__rest||function(Y,e){var _={};for(var y in Y)Object.prototype.hasOwnProperty.call(Y,y)&&e.indexOf(y)<0&&(_[y]=Y[y]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,y=Object.getOwnPropertySymbols(Y);R<y.length;R++)e.indexOf(y[R])<0&&Object.prototype.propertyIsEnumerable.call(Y,y[R])&&(_[y[R]]=Y[y[R]]);return _};define(ge[243],pe([0,1,2,4,5,6,8]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class A{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:b=>{var h,c;if(b&&b.$mid===11){const m=b.uri===void 0?void 0:_.URI.revive(b.uri);return(c=(h=this._itemsBySourceAndUriMap.get(b.source))===null||h===void 0?void 0:h.get(C(m)))===null||c===void 0?void 0:c.get(b.handle)}return b}})}async $getTimeline(T,k,b,h,c){const m=this._providers.get(T);return m==null?void 0:m.provideTimeline(_.URI.revive(k),b,h,c)}registerTimelineProvider(T,k,b,h){const c=new P.DisposableStore,m=this.convertTimelineItem(k.id,h,c).bind(this);let E;k.onDidChange&&(E=k.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:k.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(w,d,u,a){var t;(a==null?void 0:a.resetCache)&&(c.clear(),(t=g.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(w,d,u);if(i!=null){const o=m(w,a);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(o)})}},dispose(){var w;for(const d of g.values())(w=d.get(k.id))===null||w===void 0||w.clear();E==null||E.dispose(),c.dispose()}}))}convertTimelineItem(T,k,b){return(h,c)=>{let m;if(c==null?void 0:c.cacheResults){let E=this._itemsBySourceAndUriMap.get(T);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(T,E));const g=C(h);m=E.get(g),m===void 0&&(m=new Map,E.set(g,m))}return E=>{var g,w;const{iconPath:d}=E,u=dn(E,["iconPath"]),a=`${T}|${(g=E.id)!==null&&g!==void 0?g:E.timestamp}`;m==null||m.set(a,E);let t,i,o;return E.iconPath&&(d instanceof D.ThemeIcon?o={id:d.id}:_.URI.isUri(d)?(t=d,i=d):{light:t,dark:i}=d),Object.assign(Object.assign({},u),{id:(w=u.id)!==null&&w!==void 0?w:void 0,handle:a,source:T,command:E.command?k.toInternal(E.command,b):void 0,icon:t,iconDark:i,themeIcon:o,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,P.toDisposable)(()=>{var b;for(const h of this._itemsBySourceAndUriMap.values())(b=h.get(T.id))===null||b===void 0||b.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=A;function C(n){return n==null?void 0:n.toString()}}),define(ge[244],pe([0,1,6,11,2,5]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(C){this._openers=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=k.schemes.find(h=>!D.supportedSchemes.has(h));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,C,k.label),(0,_.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(C,n,T){const k=this._openers.get(C);if(!k)throw new Error(`Unknown opener with id: ${C}`);const b=R.URI.revive(n);return k.canOpenExternalUri(b,T)}async $openUri(C,n,T){const k=this._openers.get(C);if(!k)throw new Error(`Unknown opener id: '${C}'`);return k.openExternalUri(R.URI.revive(n.resolvedUri),{sourceUri:R.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(ge[245],pe([0,1,5,2,6,16,29]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(D.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,R.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(y.URI.revive(T))}catch(b){(0,P.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return y.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=A,A.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[65],pe([0,1,3,2,84,5]),function(Y,e,_,y,R,P){"use strict";var D,A,C,n,T,k,b,h,c,m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(o,s,r,l,p,S,f){D.set(this,void 0),A.set(this,void 0),C.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),b.set(this,""),h.set(this,void 0),c.set(this,!1),m.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,E.set(this,new _.Emitter),this._onDidDispose=Be(this,E).event,tt(this,D,o),tt(this,A,s),tt(this,h,r),tt(this,n,l),tt(this,T,p),tt(this,k,S),tt(this,C,f)}dispose(){tt(this,c,!0),Be(this,E).fire(),Be(this,E).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return tt(this,m,!0),(0,R.asWebviewUri)(Be(this,n),Be(this,D),o)}get cspSource(){return Be(this,n).webviewCspSource.replace("{{uuid}}",Be(this,D))}get html(){return this.assertNotDisposed(),Be(this,b)}set html(o){this.assertNotDisposed(),Be(this,b)!==o&&(tt(this,b,o),!Be(this,m)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(tt(this,m,!0),Be(this,C).report("Webview vscode-resource: uris",Be(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A).$setHtml(Be(this,D),o))}get options(){return this.assertNotDisposed(),Be(this,h)}set options(o){this.assertNotDisposed(),Be(this,A).$setOptions(Be(this,D),u(Be(this,k),Be(this,T),o)),tt(this,h,o)}async postMessage(o){return Be(this,c)?!1:Be(this,A).$postMessage(Be(this,D),o)}assertNotDisposed(){if(Be(this,c))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,D=new WeakMap,A=new WeakMap,C=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,h=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap;class w{constructor(o,s,r,l,p){this.initData=s,this.workspace=r,this._logService=l,this._deprecationService=p,this._webviews=new Map,this._webviewProxy=o.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(o,s){const r=this.getWebview(o);r&&r._onMessageEmitter.fire(s)}$onMissingCsp(o,s){this._logService.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,s,r){const l=new g(o,this._webviewProxy,a(s),this.initData,this.workspace,r,this._deprecationService);return this._webviews.set(o,l),l._onDidDispose(()=>{this._webviews.delete(o)}),l}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=w;function d(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=d;function u(i,o,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||t(i,o)}}e.serializeWebviewOptions=u;function a(i){var o;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(o=i.localResourceRoots)===null||o===void 0?void 0:o.map(s=>y.URI.from(s))}}e.reviveOptions=a;function t(i,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(s=>s.uri),i.extensionLocation]}}),define(ge[246],pe([0,1,21,73,6,11,24,2,20,65,116,5,8]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,o){const s=this.key(t,i.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const r=new h(i,o);return this._documents.set(s,r),r}delete(t,i){const o=this.key(t,i.uri);this._documents.delete(o)}key(t,i){return`${t}@@@${i}`}}var m;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(m||(m={}));class E{constructor(){this._providers=new Map}addTextProvider(t,i,o){return this.add(0,t,i,o)}addCustomProvider(t,i,o){return this.add(1,t,i,o)}get(t){return this._providers.get(t)}add(t,i,o,s){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:o,provider:s}),new b.Disposable(()=>this._providers.delete(i))}}class g{constructor(t,i,o,s,r){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=s,this._extHostWebviewPanels=r,this._editorProviders=new E,this._documents=new c,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,o,s){const r=new R.DisposableStore;return w(o)?(r.add(this._editorProviders.addTextProvider(i,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,s.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(r.add(this._editorProviders.addCustomProvider(i,t,o)),this.supportEditing(o)&&r.add(o.onDidChangeCustomDocument(l=>{const p=this.getCustomDocumentEntry(i,l.document.uri);if(d(l)){const S=p.addEdit(l);this._proxy.$onDidEdit(l.document.uri,i,S,l.label)}else this._proxy.$onContentChange(l.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument)),b.Disposable.from(r,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,o,s,r){var l;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const S=A.URI.revive(t),f=await p.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:s==null?void 0:s.buffer},r);let v;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(v=(l=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,f,v),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const s=A.URI.revive(t),{document:r}=this.getCustomDocumentEntry(i,s);this._documents.delete(i,r),r.dispose()}async $resolveWebviewEditor(t,i,o,s,r,l){const p=this._editorProviders.get(o);if(!p)throw new Error(`No provider found for '${o}'`);const S=C.ViewColumn.to(r),f=this._extHostWebview.createNewWebview(i,s.webviewOptions,p.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(i,o,s.title,S,s.panelOptions,f),I=A.URI.revive(t);switch(p.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,I);return p.provider.resolveCustomEditor(L,v,l)}case 0:{const L=this._extHostDocuments.getDocument(I);return p.provider.resolveCustomTextEditor(L,v,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,o){this.getCustomDocumentEntry(i,t).disposeEdits(o)}async $onMoveCustomEditor(t,i,o){const s=this._editorProviders.get(o);if(!s)throw new Error(`No provider found for '${o}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const r=this._extHostWebviewPanels.getWebviewPanel(t);if(!r)throw new Error("No webview found");const l=A.URI.revive(i),p=this._extHostDocuments.getDocument(l);await s.provider.moveCustomTextEditor(p,r,_.CancellationToken.None)}async $undo(t,i,o,s){return this.getCustomDocumentEntry(i,t).undo(o,s)}async $redo(t,i,o,s){return this.getCustomDocumentEntry(i,t).redo(o,s)}async $revert(t,i,o){const s=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(s.document,o),s.disposeBackup()}async $onSave(t,i,o){const s=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(s.document,o),s.disposeBackup()}async $onSaveAs(t,i,o,s){const r=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(r.document,A.URI.revive(o),s)}async $backup(t,i,o){const s=this.getCustomDocumentEntry(i,t),l=await this.getCustomEditorProvider(i).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},o);return s.updateBackup(l),l.id}getCustomDocumentEntry(t,i){const o=this._documents.get(t,A.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const i=this._editorProviders.get(t),o=i==null?void 0:i.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function w(a){return typeof a.resolveCustomTextEditor=="function"}function d(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function u(a){const t=a.scheme===P.Schemas.file||a.scheme===P.Schemas.untitled?a.fsPath:a.toString();return(0,y.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[247],pe([0,1,3,6,2,28,20,65,5,8]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";var T,k,b,h,c,m,E,g,w,d,u,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends y.Disposable{constructor(l,p,S,f,v,I,L){super();T.set(this,void 0),k.set(this,void 0),b.set(this,void 0),h.set(this,void 0),c.set(this,void 0),m.set(this,void 0),E.set(this,void 0),g.set(this,void 0),w.set(this,!0),d.set(this,!0),u.set(this,!1),a.set(this,this._register(new _.Emitter)),this.onDidDispose=Be(this,a).event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Be(this,t).event,tt(this,T,l),tt(this,k,p),tt(this,b,S),tt(this,c,I),tt(this,g,v),tt(this,m,f),tt(this,h,L)}dispose(){Be(this,u)||(tt(this,u,!0),Be(this,a).fire(),Be(this,k).$disposeWebview(Be(this,T)),Be(this,h).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h)}get viewType(){return this.assertNotDisposed(),Be(this,b)}get title(){return this.assertNotDisposed(),Be(this,m)}set title(l){this.assertNotDisposed(),Be(this,m)!==l&&(tt(this,m,l),Be(this,k).$setTitle(Be(this,T),l))}get iconPath(){return this.assertNotDisposed(),Be(this,E)}set iconPath(l){this.assertNotDisposed(),Be(this,E)!==l&&(tt(this,E,l),Be(this,k).$setIconPath(Be(this,T),R.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Be(this,c)}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,g)=="number"&&Be(this,g)<0))return Be(this,g)}get active(){return this.assertNotDisposed(),Be(this,d)}get visible(){return this.assertNotDisposed(),Be(this,w)}_updateViewState(l){Be(this,u)||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,d,l.active),tt(this,w,l.visible),tt(this,g,l.viewColumn),Be(this,t).fire({webviewPanel:this}))}reveal(l,p){this.assertNotDisposed(),Be(this,k).$reveal(Be(this,T),{viewColumn:l?D.ViewColumn.from(l):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,u))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,b=new WeakMap,h=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap,g=new WeakMap,w=new WeakMap,d=new WeakMap,u=new WeakMap,a=new WeakMap,t=new WeakMap;class o{constructor(l,p,S){this.webviews=p,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(l,p,S,f,v={}){const I=typeof f=="object"?f.viewColumn:f,L={viewColumn:D.ViewColumn.from(I),preserveFocus:typeof f=="object"&&!!f.preserveFocus},x=o.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(l),x,p,{title:S,panelOptions:s(v),webviewOptions:(0,A.serializeWebviewOptions)(l,this.workspace,v)},L);const Z=this.webviews.createNewWebview(x,v,l);return this.createNewWebviewPanel(x,p,S,I,v,Z)}$onDidChangeWebviewPanelViewStates(l){const p=Object.keys(l);p.sort((S,f)=>{const v=l[S],I=l[f];return v.active?1:I.active?-1:+v.visible-+I.visible});for(const S of p){const f=this.getWebviewPanel(S);if(!!f){const v=l[S];f._updateViewState({active:v.active,visible:v.visible,viewColumn:D.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(l){const p=this.getWebviewPanel(l);p==null||p.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,p,S){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:S,extension:l}),this._proxy.$registerSerializer(p),new n.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(l,p,S,f){const v=this._serializers.get(p);if(!v)throw new Error(`No serializer found for '${p}'`);const{serializer:I,extension:L}=v,x=this.webviews.createNewWebview(l,S.webviewOptions,L),Z=this.createNewWebviewPanel(l,p,S.title,f,S.panelOptions,x);await I.deserializeWebviewPanel(Z,S.state)}createNewWebviewPanel(l,p,S,f,v,I){const L=new i(l,this._proxy,p,S,f,v,I);return this._webviewPanels.set(l,L),L}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=o;function s(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[248],pe([0,1,3,6,65,5,8]),function(Y,e,_,y,R,P,D){"use strict";var A,C,n,T,k,b,h,c,m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends y.Disposable{constructor(u,a,t,i,o,s){super();A.set(this,void 0),C.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),b.set(this,void 0),h.set(this,void 0),c.set(this,void 0),m.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Be(this,m).event,E.set(this,this._register(new _.Emitter)),this.onDidDispose=Be(this,E).event,tt(this,n,t),tt(this,h,i),tt(this,A,u),tt(this,C,a),tt(this,T,o),tt(this,b,s)}dispose(){Be(this,k)||(tt(this,k,!0),Be(this,E).fire(),Be(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h)}set title(u){this.assertNotDisposed(),Be(this,h)!==u&&(tt(this,h,u),Be(this,C).$setWebviewViewTitle(Be(this,A),u))}get description(){return this.assertNotDisposed(),Be(this,c)}set description(u){this.assertNotDisposed(),Be(this,c)!==u&&(tt(this,c,u),Be(this,C).$setWebviewViewDescription(Be(this,A),u))}get visible(){return Be(this,b)}get webview(){return Be(this,T)}get viewType(){return Be(this,n)}_setVisible(u){u===Be(this,b)||Be(this,k)||(tt(this,b,u),Be(this,m).fire())}show(u){this.assertNotDisposed(),Be(this,C).$show(Be(this,A),!!u)}assertNotDisposed(){if(Be(this,k))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,h=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap;class w{constructor(u,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,a,t,i){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(u),a,i),new D.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(u,a,t,i,o){const s=this._viewProviders.get(a);if(!s)throw new Error(`No view provider found for '${a}'`);const{provider:r,extension:l}=s,p=this._extHostWebview.createNewWebview(u,{},l),S=new g(u,this._proxy,a,t,p,!0);this._webviewViews.set(u,S),await r.resolveWebviewView(S,{state:i},o)}async $onDidChangeWebviewViewVisibility(u,a){this.getWebviewView(u)._setVisible(a)}async $disposeWebviewView(u){const a=this.getWebviewView(u);this._webviewViews.delete(u),a.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const a=this._webviewViews.get(u);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=w}),define(ge[124],pe([0,1,3,5,2,11,10,4,14]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Rn{constructor(k){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=k.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,b){let h;if(typeof k=="string"){h=k;try{k=R.URI.parse(k)}catch(c){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,D.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,h,b)}async asExternalUri(k,b){if((0,D.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const h=await this._proxy.$asExternalUri(k,b);return R.URI.from(h)}};n.InitialState={focused:!0},n=je([Ue(0,C.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ge[249],pe([0,1,7,48,28,51,6,5,2,14]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends D.Disposable{constructor(b,h){super();const c=b.getProxy(A.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async m=>{const E=C.URI.file((0,_.join)((0,y.tmpdir)(),(0,R.generateUuid)()));return await c.$download(m,E),E})}};T=je([Ue(0,n.IExtHostRpcService),Ue(1,P.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(ge[250],pe([0,1,2,7,144,26,37,64,27,14,6,13,109,44]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class c{constructor(w,d){this.file=d,this.appender=(0,b.createRotatingLogger)(w,d,30*h.ByteSize.MB,1),this.appender.clearFormatters()}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class m extends A.AbstractExtHostOutputChannel{constructor(w,d,u){super(w,!1,_.URI.file(d.file),u);this._appender=d}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,d){this._appender.flush(),super.show(w,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=m;let E=class extends A.ExtHostOutputService{constructor(w,d,u){super(w);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const d=this._channels.get(w);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(w);return d.then(u=>u._id.then(a=>this._channels.set(a,u))),new A.LazyOutputChannel(w,d)}async _doCreateOutChannel(w){try{const d=(0,y.join)(this._logsLocation.fsPath,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await P.SymlinkSupport.existsDirectory(d)||await D.promises.mkdir(d,{recursive:!0});const a=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,y.join)(d,`${a}.log`)),i=new c(a,t.fsPath);return new m(w,i,this._proxy)}catch(d){return this.logService.error(d),new A.ExtHostPushOutputChannel(w,this._proxy)}}};E=je([Ue(0,n.IExtHostRpcService),Ue(1,k.ILogService),Ue(2,C.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(ge[251],pe([0,1,5,14,6,27,2,38,24,37,26,8,9,50,3,72,13,12]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.findPorts=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(l,p,S){this.remoteAddress=l,this.localAddress=p,this._dispose=S,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function d(r){const l=r.trim().split(`
`),p=[];return l.forEach(S=>{const f=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(S);f&&f.length>=3&&p.push({pid:parseInt(f[1],10),socket:parseInt(f[2],10)})}),p}e.getSockets=d;function u(...r){const l=[].concat(...r.map(t));return[...new Map(l.filter(p=>p.st==="0A").map(p=>{const S=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:a(S[0]),port:parseInt(S[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=u;function a(r){let l="";if(r.length===8)for(let p=r.length-2;p>=0;p-=2)l+=parseInt(r.substr(p,2),16),p!==0&&(l+=".");else for(let p=r.length-4;p>=0;p-=4)l+=parseInt(r.substr(p,4),16).toString(16),p!==0&&(l+=":");return l}e.parseIpAddress=a;function t(r){const l=r.trim().split(`
`),p=l.shift().trim().split(/\s+/).filter(f=>f!=="rx_queue"&&f!=="tm->when");return l.map(f=>f.trim().split(/\s+/).reduce((v,I,L)=>(v[p[L]||L]=I,v),{}))}e.loadConnectionTable=t;function i(r){return!!r.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||r.indexOf("out/vs/server/main.js")!==-1||r.indexOf("_productName=VSCode")!==-1}async function o(r,l,p,S){const f=u(r,l),I=d(p).reduce((Z,z)=>(Z[z.socket]=z,Z),{}),L=S.reduce((Z,z)=>(Z[z.pid]=z,Z),{}),x=[];return f.filter(Z=>I[Z.socket]).forEach(({socket:Z,ip:z,port:B})=>{var $;const M=($=L[I[Z].pid])===null||$===void 0?void 0:$.cmd;M&&!i(M)&&x.push({host:z,port:B,detail:M,pid:I[Z].pid})}),x}e.findPorts=o;let s=class extends R.Disposable{constructor(l,p,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new c.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(_.MainContext.MainThreadTunnelService),b.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier} called openTunnel API for ${p.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(p,l.displayName);if(S){const f=new w(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(f),f}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,p){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:l,provider:p}),this._proxy.$registerPortsAttributesProvider(l,S),new k.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(l,p,S,f,v){const L=(await Promise.all(l.map(x=>{const Z=this._portAttributesProviders.get(x);return Z?Z.provider.providePortAttributes(p,S,f,v):[]}))).filter(x=>!!x&&x.length>0);return L.length>0?(0,g.flatten)(L).map(x=>({autoForwardAction:x.autoForwardAction,port:x.port})):[]}async $registerCandidateFinder(l){if(!(l&&this._candidateFindingEnabled)){this._candidateFindingEnabled=l;let p=new m.MovingAverage,S;for(;this._candidateFindingEnabled;){const f=new Date().getTime(),v=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${v.map(L=>L.port).join(", ")}`);const I=new Date().getTime()-f;p.update(I),(!S||JSON.stringify(S)!==JSON.stringify(v))&&(S=v,await this._proxy.$onFoundNewCandidates(S)),await new Promise(L=>setTimeout(()=>L(),this.calculateDelay(p.value)))}}}async setTunnelExtensionFunctions(l){var p;return l?(l.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,await this._proxy.$setCandidateFilter()),l.tunnelFactory&&(this._forwardPortProvider=l.tunnelFactory,await this._proxy.$setTunnelProvider((p=l.tunnelFeatures)!==null&&p!==void 0?p:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,p){if(this._extensionTunnels.has(l.host)){const S=this._extensionTunnels.get(l.host);S.has(l.port)&&(p&&S.get(l.port).disposeListener.dispose(),await S.get(l.port).tunnel.dispose(),S.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(l,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const f=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const v=this._register(f.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(f.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:f,disposeListener:v}),h.TunnelDto.fromApiTunnel(f)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const p=await Promise.all(l.map(f=>this._showCandidatePort(f.host,f.port,f.detail))),S=l.filter((f,v)=>p[v]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(f=>f.port).join(", ")} to ${S.map(f=>f.port).join(", ")}`),S}async findCandidatePorts(){let l="",p="";try{l=await n.promises.readFile("/proc/net/tcp","utf8"),p=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(I){}const S=await new Promise(I=>{(0,A.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,x,Z)=>{I(x)})}),f=await T.readdir("/proc"),v=[];for(let I of f)try{const L=Number(I),x=C.joinPath(D.URI.file("/proc"),I);if((await n.promises.stat(x.fsPath)).isDirectory()&&!isNaN(L)){const z=await n.promises.readlink(C.joinPath(x,"cwd").fsPath),B=await n.promises.readFile(C.joinPath(x,"cmdline").fsPath,"utf8");v.push({pid:L,cwd:z,cmd:B})}}catch(L){}return o(l,p,S,v)}};s=je([Ue(0,y.IExtHostRpcService),Ue(1,P.IExtHostInitDataService),Ue(2,E.ILogService)],s),e.ExtHostTunnelService=s}),define(ge[252],pe([0,1,17,21,16,3,6,97,223,122,25]),function(Y,e,_,y,R,P,D,A,C,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(s,r){try{return JSON.stringify(s,r)}catch(l){return"null"}}function h(s,r){return JSON.stringify(s,r)}function c(s){return s?(r,l)=>l&&l.$mid===1?s.transformOutgoing(l):l:null}var m;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},w=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends D.Disposable{constructor(r,l=null,p=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=r,this._logger=l,this._uriTransformer=p,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,f=n.ProxyIdentifier.count;S<f;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(r=>{this._pendingRPCReplies[r].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(r){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(r){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(r){this._responsiveState!==r&&(this._responsiveState=r,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(r){return this._uriTransformer?(0,A.transformIncomingURIs)(r,this._uriTransformer):r}getProxy(r){const{nid:l,sid:p}=r;return this._proxies[l]||(this._proxies[l]=this._createProxy(l,p)),this._proxies[l]}_createProxy(r,l){let p={get:(S,f)=>(typeof f=="string"&&!S[f]&&f.charCodeAt(0)===36&&(S[f]=(...v)=>this._remoteCall(r,f,v)),f===d?l:S[f])};return new Proxy(Object.create(null),p)}set(r,l){return this._locals[r.nid]=l,l}assertRegistered(r){for(let l=0,p=r.length;l<p;l++){const S=r[l];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(r){if(!this._isDisposed){const l=r.byteLength,p=a.read(r,0),S=p.readUInt8(),f=p.readUInt32();switch(S){case 1:case 2:{let{rpcId:v,method:I,args:L}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,f,v,I,L,S===2);break}case 3:case 4:{let{rpcId:v,method:I,args:L}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,f,v,I,L,S===4);break}case 5:{this._logger&&this._logger.logIncoming(l,f,0,"ack"),this._onDidReceiveAcknowledge(f);break}case 6:{this._receiveCancel(l,f);break}case 7:{this._receiveReply(l,f,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(p);this._uriTransformer&&(v=(0,A.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(l,f,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(p);this._receiveReply(l,f,v);break}case 10:{let v=t.deserializeReplyErrError(p);this._uriTransformer&&(v=(0,A.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(l,f,v);break}case 11:{this._receiveReplyErr(l,f,void 0);break}default:console.error("received unexpected message"),console.error(r)}}}_receiveRequest(r,l,p,S,f,v){this._logger&&this._logger.logIncoming(r,l,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(p)}.${S}(`,f);const I=String(l);let L,x;if(v){const z=new y.CancellationTokenSource;f.push(z.token),L=this._invokeHandler(p,S,f),x=()=>z.cancel()}else L=this._invokeHandler(p,S,f),x=g;this._cancelInvokedHandlers[I]=x;const Z=t.serializeAcknowledged(l);this._logger&&this._logger.logOutgoing(Z.byteLength,l,1,"ack"),this._protocol.send(Z),L.then(z=>{delete this._cancelInvokedHandlers[I];const B=t.serializeReplyOK(l,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,l,1,"reply:",z),this._protocol.send(B)},z=>{delete this._cancelInvokedHandlers[I];const B=t.serializeReplyErr(l,z);this._logger&&this._logger.logOutgoing(B.byteLength,l,1,"replyErr:",z),this._protocol.send(B)})}_receiveCancel(r,l){this._logger&&this._logger.logIncoming(r,l,1,"receiveCancel");const p=String(l);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(r,l,p){this._logger&&this._logger.logIncoming(r,l,0,"receiveReply:",p);const S=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const f=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],f.resolveOk(p)}}_receiveReplyErr(r,l,p){this._logger&&this._logger.logIncoming(r,l,0,"receiveReplyErr:",p);const S=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const f=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let v;p&&(p.$isError?(v=new Error,v.name=p.name,v.message=p.message,v.stack=p.stack):v=p),f.resolveErr(v)}}_invokeHandler(r,l,p){try{return Promise.resolve(this._doInvokeHandler(r,l,p))}catch(S){return Promise.reject(S)}}_doInvokeHandler(r,l,p){const S=this._locals[r];if(!S)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(r));let f=S[l];if(typeof f!="function")throw new Error("Unknown method "+l+" on actor "+(0,n.getStringIdentifierForProxy)(r));return f.apply(S,p)}_remoteCall(r,l,p){if(this._isDisposed)return Promise.reject(R.canceled());let S=null;if(p.length>0&&y.CancellationToken.isCancellationToken(p[p.length-1])&&(S=p.pop()),S&&S.isCancellationRequested)return Promise.reject(R.canceled());const f=t.serializeRequestArguments(p,this._uriReplacer),v=++this._lastMessageId,I=String(v),L=new C.LazyPromise;S&&S.onCancellationRequested(()=>{const Z=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(Z.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[I]=L,this._onWillSendRequest(v);const x=t.serializeRequest(v,r,l,f,!!S);return this._logger&&this._logger.logOutgoing(x.byteLength,v,0,`request: ${(0,n.getStringIdentifierForProxy)(r)}.${l}(`,p),this._protocol.send(x),L}}e.RPCProtocol=u,k=w,u.UNRESPONSIVE_TIME=3*1e3;class a{constructor(r,l){this._buff=r,this._offset=l}static alloc(r,l,p){let S=new a(T.VSBuffer.alloc(p+1+4),0);return S.writeUInt8(r),S.writeUInt32(l),S}static read(r,l){return new a(r,l)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(r){this._buff.writeUInt8(r,this._offset),this._offset+=1}readUInt8(){const r=this._buff.readUInt8(this._offset);return this._offset+=1,r}writeUInt32(r){this._buff.writeUInt32BE(r,this._offset),this._offset+=4}readUInt32(){const r=this._buff.readUInt32BE(this._offset);return this._offset+=4,r}static sizeShortString(r){return 1+r.byteLength}writeShortString(r){this._buff.writeUInt8(r.byteLength,this._offset),this._offset+=1,this._buff.set(r,this._offset),this._offset+=r.byteLength}readShortString(){const r=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,p}static sizeLongString(r){return 4+r.byteLength}writeLongString(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readLongString(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,p}writeBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}static sizeVSBuffer(r){return 4+r.byteLength}writeVSBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readVSBuffer(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+r);return this._offset+=r,l}static sizeMixedArray(r,l){let p=0;p+=1;for(let S=0,f=r.length;S<f;S++){const v=r[S],I=l[S];switch(p+=1,I){case 1:p+=this.sizeLongString(v);break;case 2:p+=this.sizeVSBuffer(v);break;case 3:break}}return p}writeMixedArray(r,l){this._buff.writeUInt8(r.length,this._offset),this._offset+=1;for(let p=0,S=r.length;p<S;p++){const f=r[p];switch(l[p]){case 1:this.writeUInt8(1),this.writeLongString(f);break;case 2:this.writeUInt8(2),this.writeVSBuffer(f);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const r=this._buff.readUInt8(this._offset);this._offset+=1;let l=new Array(r);for(let p=0;p<r;p++)switch(this.readUInt8()){case 1:l[p]=this.readLongString();break;case 2:l[p]=this.readVSBuffer();break;case 3:l[p]=void 0;break}return l}}class t{static _arrayContainsBufferOrUndefined(r){for(let l=0,p=r.length;l<p;l++)if(r[l]instanceof T.VSBuffer||typeof r[l]=="undefined")return!0;return!1}static serializeRequestArguments(r,l){if(this._arrayContainsBufferOrUndefined(r)){let p=[],S=[];for(let f=0,v=r.length;f<v;f++){const I=r[f];I instanceof T.VSBuffer?(p[f]=I,S[f]=2):typeof I=="undefined"?(p[f]=T.VSBuffer.alloc(0),S[f]=3):(p[f]=T.VSBuffer.fromString(h(I,l)),S[f]=1)}return{type:"mixed",args:p,argsType:S}}return{type:"simple",args:h(r,l)}}static serializeRequest(r,l,p,S,f){return S.type==="mixed"?this._requestMixedArgs(r,l,p,S.args,S.argsType,f):this._requestJSONArgs(r,l,p,S.args,f)}static _requestJSONArgs(r,l,p,S,f){const v=T.VSBuffer.fromString(p),I=T.VSBuffer.fromString(S);let L=0;L+=a.sizeUInt8(),L+=a.sizeShortString(v),L+=a.sizeLongString(I);let x=a.alloc(f?2:1,r,L);return x.writeUInt8(l),x.writeShortString(v),x.writeLongString(I),x.buffer}static deserializeRequestJSONArgs(r){const l=r.readUInt8(),p=r.readShortString(),S=r.readLongString();return{rpcId:l,method:p,args:JSON.parse(S)}}static _requestMixedArgs(r,l,p,S,f,v){const I=T.VSBuffer.fromString(p);let L=0;L+=a.sizeUInt8(),L+=a.sizeShortString(I),L+=a.sizeMixedArray(S,f);let x=a.alloc(v?4:3,r,L);return x.writeUInt8(l),x.writeShortString(I),x.writeMixedArray(S,f),x.buffer}static deserializeRequestMixedArgs(r){const l=r.readUInt8(),p=r.readShortString(),S=r.readMixedArray(),f=new Array(S.length);for(let v=0,I=S.length;v<I;v++){const L=S[v];typeof L=="string"?f[v]=JSON.parse(L):f[v]=L}return{rpcId:l,method:p,args:f}}static serializeAcknowledged(r){return a.alloc(5,r,0).buffer}static serializeCancel(r){return a.alloc(6,r,0).buffer}static serializeReplyOK(r,l,p){return typeof l=="undefined"?this._serializeReplyOKEmpty(r):l instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(r,l):this._serializeReplyOKJSON(r,b(l,p))}static _serializeReplyOKEmpty(r){return a.alloc(7,r,0).buffer}static _serializeReplyOKVSBuffer(r,l){let p=0;p+=a.sizeVSBuffer(l);let S=a.alloc(8,r,p);return S.writeVSBuffer(l),S.buffer}static deserializeReplyOKVSBuffer(r){return r.readVSBuffer()}static _serializeReplyOKJSON(r,l){const p=T.VSBuffer.fromString(l);let S=0;S+=a.sizeLongString(p);let f=a.alloc(9,r,S);return f.writeLongString(p),f.buffer}static deserializeReplyOKJSON(r){const l=r.readLongString();return JSON.parse(l)}static serializeReplyErr(r,l){return l?this._serializeReplyErrEror(r,l):this._serializeReplyErrEmpty(r)}static _serializeReplyErrEror(r,l){const p=T.VSBuffer.fromString(b(R.transformErrorForSerialization(l),null));let S=0;S+=a.sizeLongString(p);let f=a.alloc(10,r,S);return f.writeLongString(p),f.buffer}static deserializeReplyErrError(r){const l=r.readLongString();return JSON.parse(l)}static _serializeReplyErrEmpty(r){return a.alloc(11,r,0).buffer}}var i;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var o;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[253],pe([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[254],pe([0,1,11,7,9,2,4,253]),function(Y,e,_,y,R,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let C=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||R.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?y.win32:y.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const h=T.indexOf("/",2);h===-1?(k=T.substring(2),T="/"):(k=T.substring(2,h),T=T.substring(h)||"/")}return P.URI.from({scheme:_.Schemas.file,authority:k,path:T,query:"",fragment:""})}};C=je([Ue(1,A.IRemoteAgentService)],C),e.AbstractPathService=C}),define(ge[32],pe([0,1,12,34,22,31,10,4,7,16]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",b=(T.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var h;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function m(M){return!!M.preview}e.resultIsMatch=m;function E(M){return!!M.resource}e.isFileMatch=E;function g(M){return!!M.message}e.isProgressMessage=g;var w;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(w=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=d;class u{constructor(U,F,N){this.ranges=F;const O=Array.isArray(F)?F:[F];if(N&&N.matchLines===1&&a(O)){U=(0,D.getNLines)(U,N.matchLines);let V="",q=0,Q=0;const fe=Math.floor(N.charsPerLine/5),_e=[];for(const Le of O){const Ie=Math.max(Le.startColumn-fe,0),Fe=Le.startColumn+N.charsPerLine;if(Ie>Q+fe+b){const j=T+(Ie-Q)+k;V+=j+U.slice(Ie,Fe),q+=Ie-(Q+j.length)}else V+=U.slice(Q,Fe);_e.push(new i(0,Le.startColumn-q,Le.endColumn-q)),Q=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const V=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:U,matches:(0,_.mapArrayOrNot)(F,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function a(M){const U=M[0].startLineNumber;for(const F of M)if(F.startLineNumber!==U||F.endLineNumber!==U)return!1;return!0}class t{constructor(U,F,N,O){this.startLineNumber=U,this.startColumn=F,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(U,F,N){super(U,F,U,N)}}e.OneLineRange=i;var o;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function s(M,U=!0){const F=M&&M.files&&M.files.exclude,N=U&&M&&M.search&&M.search.exclude;if(!(!F&&!N)){if(!F||!N)return F||N;let O=Object.create(null);return O=R.mixin(O,R.deepClone(F)),O=R.mixin(O,R.deepClone(N),!0),O}}e.getExcludes=s;function r(M,U){return M.excludePattern&&y.match(M.excludePattern,U)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&y.match(M.includePattern,U)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(F=>{const N=F.folder.fsPath;if(P.isEqualOrParent(U,N)){const O=C.relative(N,U);return!F.includePattern||!!y.match(F.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var l;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(U,F){super(U);this.code=F}}e.SearchError=p;function S(M){const U=M.message;if((0,n.isPromiseCanceledError)(M))return new p(U,l.canceled);try{const F=JSON.parse(U);return new p(F.message,F.code)}catch(F){return new p(U,l.other)}}e.deserializeSearchError=S;function f(M){const U={message:M.message,code:M.code};return new Error(JSON.stringify(U))}e.serializeSearchError=f;function v(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=v;function I(M){return M.type==="success"}e.isSerializedSearchSuccess=I;function L(M){return!!M.path}e.isSerializedFileMatch=L;function x(M,U){const F=M.searchPath?M.searchPath:M.relativePath;return(0,D.fuzzyContains)(F,U)}e.isFilePatternMatch=x;class Z{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Z;function z(M,U){const F=Object.assign(Object.assign({},M||{}),U||{});return Object.keys(F).filter(N=>{const O=F[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=z;class B{constructor(U,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=y.parse(this._excludeExpression);let N=U.includePattern;F.includePattern&&(N?N=Object.assign(Object.assign({},N),F.includePattern):N=F.includePattern),N&&(this._parsedIncludeExpression=y.parse(N))}includedInQuerySync(U,F,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,F,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,F,N))}includedInQuery(U,F,N){return Promise.resolve(this._parsedExcludeExpression(U,F,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,F,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=B;function $(M){for(const U in M)if(typeof M[U]!="boolean")return!0;return!1}}),define(ge[33],pe([0,1,12,17,21,3,23,11,72,24,10,15,2,164,4,13,182,60,61,27,14,8,32,5]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d,u,a,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(I,L,x){return new n.ExtUri(Z=>p(Z,x)).isEqual(I,L)}function s(I,L,x){return o(I.uri,L.uri,x)?0:(0,T.compare)(I.uri.toString(),L.uri.toString())}function r(I,L,x){return I.index!==L.index?I.index<L.index?-1:1:o(I.uri,L.uri,x)?(0,T.compare)(I.name,L.name):(0,T.compare)(I.uri.toString(),L.uri.toString())}function l(I,L,x,Z){const z=I.slice(0).sort(($,M)=>x($,M,Z)),B=L.slice(0).sort(($,M)=>x($,M,Z));return(0,_.delta)(z,B,($,M)=>x($,M,Z))}function p(I,L){const x=L.getCapabilities(I.scheme);return!(x&&x&1024)}class S extends g.Workspace{constructor(L,x,Z,z,B,$){super(L,Z.map(M=>new g.WorkspaceFolder(M)),z,$);this._name=x,this._isUntitled=B,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris($),Z.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(L,x,Z,z){if(!L)return{workspace:null,added:[],removed:[]};const{id:B,name:$,folders:M,configuration:U,isUntitled:F}=L,N=[],O=x;x?M.forEach((fe,_e)=>{const Le=b.URI.revive(fe.uri),Ie=S._findFolder(Z||x,Le,z);Ie?(Ie.name=fe.name,Ie.index=fe.index,N.push(Ie)):N.push({uri:Le,name:fe.name,index:_e})}):N.push(...M.map(({uri:fe,name:_e,index:Le})=>({uri:b.URI.revive(fe),name:_e,index:Le}))),N.sort((fe,_e)=>fe.index<_e.index?-1:1);const V=new S(B,$,N,U?b.URI.revive(U):null,!!F,fe=>p(fe,z)),{added:q,removed:Q}=l(O?O.workspaceFolders:[],V.workspaceFolders,s,z);return{workspace:V,added:q,removed:Q}}static _findFolder(L,x,Z){for(let z=0;z<L.folders.length;z++){const B=L.workspaceFolders[z];if(o(B.uri,x,Z))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,x){return x&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let f=class{constructor(L,x,Z,z){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=a.WorkspaceTrustState.Unknown,this._logService=z,this._extHostFileSystemInfo=Z,this._requestIdProvider=new C.Counter,this._barrier=new y.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const B=x.workspace;this._confirmedWorkspace=B?new S(B.id,B.name,[],B.configuration?b.URI.revive(B.configuration):null,!!B.isUntitled,$=>p($,Z)):void 0}$initializeWorkspace(L,x){this._workspaceTrustState=x,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:A.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,x,Z,...z){const B=[];if(Array.isArray(z)&&z.forEach(N=>{b.URI.isUri(N.uri)&&!B.some(O=>o(O.uri,N.uri,this._extHostFileSystemInfo))&&B.push({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[x,Z].some(N=>typeof N!="number"||N<0)||Z===0&&B.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+Z>$.length)return!1;const M=$.slice(0);M.splice(x,Z,...B.map(N=>({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<M.length;N++){const O=M[N];if(M.some((V,q)=>q!==N&&o(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}M.forEach((N,O)=>N.index=O);const{added:U,removed:F}=l($,M,r,this._extHostFileSystemInfo);if(U.length===0&&F.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,x,Z,B).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,h.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(L,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,x)}async getWorkspaceFolder2(L,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,x)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,x){let Z,z="";if(typeof L=="string"?(Z=b.URI.file(L),z=L):typeof L!="undefined"&&(Z=L,z=L.fsPath),!Z)return z;const B=this.getWorkspaceFolder(Z,!0);if(!B)return z;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let $=(0,n.relativePath)(B.uri,Z);return x&&B.name&&($=`${B.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:x,added:Z,removed:z}=S.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Z,removed:z}))}findFiles(L,x,Z,z,B=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let $;if(x===null?$=!1:x&&(typeof x=="string"?$=x:$=x.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:U}=v(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)($),(0,k.withUndefinedAsNull)(Z),B).then(F=>Array.isArray(F)?F.map(N=>b.URI.revive(N)):[])}async findTextInFiles(L,x,Z,z,B=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),M=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:U,folder:F}=v(x.include),N=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,O={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:M,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const Q=b.URI.revive(q.resource);q.results.forEach(fe=>{(0,t.resultIsMatch)(fe)?Z({uri:Q,preview:{text:fe.preview.text,matches:(0,_.mapArrayOrNot)(fe.preview.matches,_e=>new a.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,_.mapArrayOrNot)(fe.ranges,_e=>new a.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):Z({uri:Q,text:fe.text,lineNumber:fe.lineNumber})})}},B.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(F),O,$,B);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(L){return this._proxy.$requireWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(L))}};f=je([Ue(0,u.IExtHostRpcService),Ue(1,d.IExtHostInitDataService),Ue(2,w.IExtHostFileSystemInfo),Ue(3,m.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function v(I){let L,x;return I&&(typeof I=="string"?L=I:(L=I.pattern,x=I.baseFolder||b.URI.file(I.base))),{includePattern:L,folder:x}}}),define(ge[36],pe([0,1,22,3,33,5,8,184,82,15,17,4,14,13,2]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(i,o){if(o){const s=o.split(".");let r=i;for(let l=0;r&&l<s.length;l++)r=r[s[l]];return r}}function E(i){return i instanceof c.URI}function g(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function d(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function u(i){if(E(i))return{resource:i};if(g(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(d(i))return{resource:i.uri};if(i===null)return{resource:null}}let a=class{constructor(o,s,r){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=r,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,s){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(o,s))}};a=je([Ue(0,b.IExtHostRpcService),Ue(1,R.IExtHostWorkspace),Ue(2,h.ILogService)],a),e.ExtHostConfiguration=a;class t{constructor(o,s,r,l){this._onDidChangeConfiguration=new y.Emitter,this._proxy=o,this._logService=l,this._extHostWorkspace=s,this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,s){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,r))}getConfiguration(o,s,r){const l=u(s)||{},p=this._toReadonlyValue(o?m(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,l,r==null?void 0:r.identifier);function S(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(v){return typeof m(p,v)!="undefined"},get:(v,I)=>{this._validateConfigurationAccess(o?`${o}.${v}`:v,l,r==null?void 0:r.identifier);let L=m(p,v);if(typeof L=="undefined")L=I;else{let x;const Z=(z,B)=>{let $;const M=()=>{x=x||(0,_.deepClone)(p),$=$||m(x,B)};return(0,n.isObject)(z)?new Proxy(z,{get:(U,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return M(),()=>$;if(x)return $=$||m(x,B),$[F];const N=U[F];return typeof F=="string"?Z(N,`${B}.${F}`):N},set:(U,F,N)=>(M(),$&&($[F]=N),!0),deleteProperty:(U,F)=>(M(),$&&delete $[F],!0),defineProperty:(U,F,N)=>(M(),$&&Object.defineProperty($,F,N),!0)}):z};L=Z(L,v)}return L},update:(v,I,L,x)=>{v=o?`${o}.${v}`:v;const Z=S(L);return I!==void 0?this._proxy.$updateConfigurationOption(Z,v,I,l,x):this._proxy.$removeConfigurationOption(Z,v,l,x)},inspect:v=>{var I,L,x,Z,z,B,$,M;v=o?`${o}.${v}`:v;const U=(0,_.deepClone)(this._configuration.inspect(v,l,this._extHostWorkspace.workspace));if(U)return{key:v,defaultValue:(I=U.default)===null||I===void 0?void 0:I.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(x=U.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(Z=U.workspaceFolder)===null||Z===void 0?void 0:Z.value,defaultLanguageValue:(z=U.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(B=U.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:($=U.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(M=U.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:U.overrideIdentifiers}}};return typeof p=="object"&&(0,_.mixin)(f,p,!1),Object.freeze(f)}_toReadonlyValue(o){const s=r=>(0,n.isObject)(r)?new Proxy(r,{get:(l,p)=>s(l[p]),set:(l,p,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(l,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(l,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return s(o)}_validateConfigurationAccess(o,s,r){const l=C.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),p=r?`[${r.value}] `:"";if(l===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){(s==null?void 0:s.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,s){const r=new A.ConfigurationChangeEvent(o,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,p)=>r.affectsConfiguration(l,u(p))})}_toMap(o){return o.reduce((s,r)=>(s.set(r[0],r[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[66],pe([0,1,2,17,3,5,8,33,39,36,21,35,14,27,4,11,9,13,63,204,16]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function B(M){if(M!=null)return M}z.from=B;function $(M){if(M!=null)return M}z.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(z){function B(M){if(M!=null)return M}z.from=B;function $(M){if(M!=null)return M}z.to=$})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(z){function B(M){if(M!=null)return M}z.from=B;function $(M){if(M!=null)return M}z.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(z){function B(U){if(U){const F=U;return F&&!!F.process}else return!1}z.is=B;function $(U){if(U!=null){const F={process:U.process,args:U.args};return U.options&&(F.options=o.from(U.options)),F}}z.from=$;function M(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}z.to=M})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(z){function B(M){if(M!=null)return M}z.from=B;function $(M){if(M!=null)return M}z.to=$})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(z){function B(U){if(U){const F=U;return F&&(!!F.commandLine||!!F.command)}else return!1}z.is=B;function $(U){if(U!=null){const F={};return U.commandLine!==void 0?F.commandLine=U.commandLine:(F.command=U.command,F.args=U.args),U.options&&(F.options=r.from(U.options)),F}}z.from=$;function M(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}z.to=M})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(z){function B(U){if(U){let F=U;return F&&F.customExecution==="customExecution"}else return!1}z.is=B;function $(U){return{customExecution:"customExecution"}}z.from=$;function M(U,F){return F.get(U)}z.to=M})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(z){function B($,M){let U;return $.scope!==void 0&&typeof $.scope!="number"?U=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===D.TaskScope.Workspace&&M&&M.workspaceFile?U=M.workspaceFile:U=d.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:U}}z.from=B})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(z){function B(U,F){if(U==null)return[];const N=[];for(let O of U){const V=$(O,F);V&&N.push(V)}return N}z.fromMany=B;function $(U,F){if(U!=null){let N;U.execution instanceof D.ProcessExecution?N=s.from(U.execution):U.execution instanceof D.ShellExecution?N=l.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(N=p.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=D.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:F.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}z.from=$;async function M(U,F,N){if(U!=null){let O;s.is(U.execution)?O=s.to(U.execution):l.is(U.execution)?O=l.to(U.execution):p.is(U.execution)&&(O=p.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await F.resolveWorkspaceFolder(_.URI.revive(U.source.scope)):q=D.TaskScope.Workspace),!(!V||!q)){const Q=new D.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(Q.presentationOptions=i.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}}}z.to=M})(f=e.TaskDTO||(e.TaskDTO={}));var v;(function(z){function B(M){return M}z.from=B;function $(M){if(!!M)return Object.assign(Object.create(null),M)}z.to=$})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(B,$,M){this._id=$,this._task=M,a.set(this,void 0),tt(this,a,B)}get task(){return this._task}terminate(){Be(this,a).terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}a=new WeakMap;var L;(function(z){function B($){return{id:$._id,task:void 0}}z.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(B,$,M,U,F,N,O,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=B.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=U,this._configurationService=F,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,$,M){if(!M)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:$,provider:M,extension:B}),this._proxy.$registerTaskProvider(U,$),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(B,$){this._proxy.$registerTaskSystem(B,$)}fetchTasks(B){return this._proxy.$fetchTasks(v.from(B)).then(async $=>{const M=[];for(let U of $){const F=await f.to(U,this._workspaceProvider,this._providedCustomExecutions2);F&&M.push(F)}return M})}get taskExecutions(){const B=[];return this._taskExecutions.forEach($=>B.push($)),B}terminateTask(B){if(!(B instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,$,M){const U=this._providedCustomExecutions2.get(B.id);if(U){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,U),this._terminalService.attachPtyToTerminal($,await U.callback(M))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const $=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:$,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:B.exitCode})}$provideTasks(B,$){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));const U=[],F=(0,y.asPromise)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(N=>this.provideTasksInternal($,U,M,N));return new Promise(N=>{F.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(B,$){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));if($.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${M.type}].`);const U=await f.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const F=await M.provider.resolveTask(U,T.CancellationToken.None);if(!!F){this.checkDeprecation(F,M);const N=f.from(F,M.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,F,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,$,M){const U=await this._proxy.$createTaskId(B);!M&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,$.execution)}async getTaskExecution(B,$){if(typeof B=="string"){const F=this._taskExecutionPromises.get(B);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let M=this._taskExecutionPromises.get(B.id);if(M)return M;const U=new Promise(async(F,N)=>{const O=$||await f.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);O?F(new I(this,B.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,U),U.then(F=>(this._taskExecutions.set(B.id,F),F),F=>Promise.reject(F))}checkDeprecation(B,$){B._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let M=this._notProvidedCustomExecutions.values(),U=M.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=M.next()}};x=je([Ue(0,b.IExtHostRpcService),Ue(1,h.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,g.ILogService),Ue(7,w.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let Z=class extends x{constructor(B,$,M,U,F,N,O,V){super(B,$,M,U,F,N,O,V);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(B,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const M=f.from($,B);if(M===void 0)throw new Error("Task is not valid");if(p.is(M.execution))await this.addCustomExecution(M,$,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),$);return this._proxy.$executeTask(M).catch(F=>{throw new Error(F)}),U}provideTasksInternal(B,$,M,U){const F=[];if(U)for(let N of U){this.checkDeprecation(N,M),(!N.definition||!B[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=f.from(N,M.extension);O&&p.is(O.execution)?(F.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:M.extension}}async resolveTaskInternal(B){if(p.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,$,M){}};Z=je([Ue(0,b.IExtHostRpcService),Ue(1,h.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,g.ILogService),Ue(7,w.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=(0,c.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)},dn=this&&this.__rest||function(Y,e){var _={};for(var y in Y)Object.prototype.hasOwnProperty.call(Y,y)&&e.indexOf(y)<0&&(_[y]=Y[y]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,y=Object.getOwnPropertySymbols(Y);R<y.length;R++)e.indexOf(y[R])<0&&Object.prototype.propertyIsEnumerable.call(Y,y[R])&&(_[y[R]]=Y[y[R]]);return _};define(ge[255],pe([0,1,12,17,21,3,69,6,22,15,2,28,5,39,14,20,8,33,218,208]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d){"use strict";var u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(v,I)=>`${v}:${I.toString()}`;let i=class{constructor(I,L,x){this.documents=L,this.workspace=x,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new S(this.proxy),this.textDocumentObservers=new f(this.proxy,L)}registerTestProvider(I){const L=(0,k.generateUuid)();this.providers.set(L,I),this.proxy.$registerTestProvider(L);const x=[...this.testSubscriptions.keys()];return setTimeout(()=>{var Z;for(const z of x)(Z=this.testSubscriptions.get(z))===null||Z===void 0||Z.subscribeFn(L,I)},0),new E.Disposable(()=>{this.providers.delete(L),this.proxy.$unregisterTestProvider(L)})}createTextDocumentTestObserver(I){return this.textDocumentObservers.checkout(I.uri)}createWorkspaceTestObserver(I){return this.workspaceObservers.checkout(I.uri)}async runTests(I,L=R.CancellationToken.None){const x=Z=>Z.map(this.getInternalTestForReference,this).filter(n.isDefined).map(z=>({providerId:z.providerId,testId:z.item.extId}));await this.proxy.$runTests({exclude:I.exclude?x(I.exclude).map(Z=>Z.testId):void 0,tests:x(I.tests),debug:I.debug},L)}publishExtensionProvidedResults(I,L){this.proxy.$publishExtensionProvidedResults(m.TestResults.from((0,k.generateUuid)(),I),L)}$publishTestResults(I){this.results=Object.freeze(I.map(L=>(0,C.deepFreeze)(m.TestResults.to(L))).concat(this.results).sort((L,x)=>x.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(I,L){const x=T.URI.revive(L),Z=t(I,x);if(!this.testSubscriptions.has(Z)){const z=new R.CancellationTokenSource;let B;if(I===1){let F=this.documents.getDocument(x);if(!F){const N=new A.DisposableStore;F=await new Promise(O=>{N.add((0,y.disposableTimeout)(()=>O(void 0),5e3)),N.add(this.documents.onDidAddDocuments(V=>{const q=V.find(Q=>Q.document.uri.toString()===x.toString());q&&O(q)}))}).finally(()=>N.dispose())}if(F){const N=await this.workspace.getWorkspaceFolder2(x,!1);B=O=>O.provideDocumentTestHierarchy?O.provideDocumentTestHierarchy(F.document,z.token):this.createDefaultDocumentTestHierarchy(O,F.document,N,z.token)}}else{const F=await this.workspace.getWorkspaceFolder2(x,!1);F&&(B=N=>N.provideWorkspaceTestHierarchy(F,z.token))}if(!!B){const $=async(F,N)=>{var O;try{U.pushDiff([3,1]);const V=await B(N);if(!V){U.pushDiff([3,-1]);return}U.addRoot(V.root,F),Promise.resolve(V.discoveredInitialTests).then(()=>U.pushDiff([3,-1])),V.onDidChangeTest(q=>U.onItemChange(q,F)),(O=V.onDidInvalidateTest)===null||O===void 0||O.call(V,q=>{const Q=U.getTestByReference(q);Q?this.proxy.$retireTest(Q.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(V){console.error(V)}},M=new A.DisposableStore,U=M.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(I,L,F)));M.add((0,A.toDisposable)(()=>z.dispose(!0)));for(const[F,N]of this.providers)$(F,N);U.pushDiff([4,-1]),this.testSubscriptions.set(Z,{store:M,collection:U,subscribeFn:$})}}}$unsubscribeFromTests(I,L){var x;const Z=T.URI.revive(L),z=t(I,Z);(x=this.testSubscriptions.get(z))===null||x===void 0||x.store.dispose(),this.testSubscriptions.delete(z)}$acceptDiff(I,L,x){I===1?this.textDocumentObservers.acceptDiff(T.URI.revive(L),x):this.workspaceObservers.acceptDiff(T.URI.revive(L),x)}async $runTestsForProvider(I,L){const x=this.providers.get(I.providerId);if(!!x){const Z=I.ids.map(B=>{var $;return($=this.ownedTests.getTestById(B))===null||$===void 0?void 0:$[1]}).filter(n.isDefined),z=I.excludeExtIds.map(B=>this.ownedTests.getTestById(B)).filter(n.isDefined).filter(([B,$])=>Z.some(M=>B.comparePositions(M,$)===1));if(!!Z.length)try{await x.runTests({setState:(B,$)=>{for(const[M,U]of z){const F=M.comparePositions(U,B.id);if(F===1||F===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(I.runId,B.id,m.TestState.from($))},tests:Z.map(B=>o.unwrap(B.actual)),exclude:z.map(([,B])=>o.unwrap(B.actual)),debug:I.debug},L);for(const{collection:B}of this.testSubscriptions.values())B.flushDiff();return}catch(B){throw console.error(B),B}}}$lookupTest(I){const L=this.ownedTests.getTestById(I.testId);if(!L)return Promise.resolve(void 0);const x=L[1],{actual:Z,previousChildren:z,previousEquals:B}=x,$=dn(x,["actual","previousChildren","previousEquals"]);return Promise.resolve($)}flushCollectionDiffs(){for(const{collection:I}of this.testSubscriptions.values())I.flushDiff()}getInternalTestForReference(I){var L,x;return(x=(L=this.workspaceObservers.getMirroredTestDataByReference(I))!==null&&L!==void 0?L:(0,_.mapFind)(this.testSubscriptions.values(),Z=>Z.collection.getTestByReference(I)))!==null&&x!==void 0?x:this.textDocumentObservers.getMirroredTestDataByReference(I)}async createDefaultDocumentTestHierarchy(I,L,x,Z){var z;if(!!x){const B=await I.provideWorkspaceTestHierarchy(x,Z);if(!!B){const $=new P.Emitter;(z=B.onDidInvalidateTest)===null||z===void 0||z.call(B,U=>{const F=o.getWrapperForTestItem(U,L);F.hasNodeMatchingFilter&&$.fire(F)});const M=new P.Emitter;return B.onDidChangeTest(U=>{const F=o.getWrapperForTestItem(U,L);if(F.hasNodeMatchingFilter){if(F.reset(),F.hasNodeMatchingFilter){M.fire(F);return}M.fire(F.visibleParent);return}const O=F.visibleParent;F.reset(),!!F.hasNodeMatchingFilter&&(O.reset(),M.fire(O))}),Z.onCancellationRequested(()=>{o.removeFilter(L),M.dispose()}),{root:o.getWrapperForTestItem(B.root,L),discoveredInitialTests:B.discoveredInitialTests,onDidInvalidateTest:$.event,onDidChangeTest:M.event}}}}};i=je([Ue(0,c.IExtHostRpcService),Ue(1,h.IExtHostDocumentsAndEditors),Ue(2,g.IExtHostWorkspace)],i),e.ExtHostTesting=i;class o{constructor(I,L,x){this.actual=I,this.filterDocument=L,this.parent=x,this.getWrappedChildren()}static removeFilter(I){this.wrapperMap.delete(I)}static getWrapperForTestItem(I,L,x){let Z=this.wrapperMap.get(L);if(Z==null?void 0:Z.has(I))return Z.get(I);Z||(Z=new WeakMap,this.wrapperMap.set(L,Z));const z=new o(I,L,x);return Z.set(I,z),z}static unwrap(I){return I instanceof o?I.actual:I}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(I=>I.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var I;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((I=this.actual.location)===null||I===void 0?void 0:I.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(L=>L.hasNodeMatchingFilter)),this.matchesFilter}reset(){var I;this!==this.visibleParent&&((I=this.parent)===null||I===void 0||I.reset()),this.matchesFilter=void 0}getWrappedChildren(){var I;return((I=this.actual.children)===null||I===void 0?void 0:I.map(L=>o.getWrapperForTestItem(L,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=o,o.wrapperMap=new WeakMap;class s extends d.IncrementalChangeCollector{constructor(I,L){super();this.collection=I,this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,m.TestItem.toPlainShallow(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{collection:I,added:L,updated:x,removed:Z}=this;return{get added(){return[...L].map(I.getPublicTestItem,I)},get updated(){return[...x].map(I.getPublicTestItem,I)},get removed(){return[...Z].map(I.getPublicTestItem,I)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(I){let L=[];for(const x of I){const Z=this.items.get(x);Z&&L.push(this.getPublicTestItem(Z))}return L}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,L){return Object.assign(Object.assign({},I),{revived:m.TestItem.toPlainShallow(I.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new s(this,this.changeEmitter)}getPublicTestItem(I){return I.wrapped||(I.wrapped=new l(I,this)),I.wrapped}}e.MirroredTestCollection=r;class l{constructor(I,L){u.set(this,void 0),a.set(this,void 0),tt(this,u,I),tt(this,a,L)}get id(){return Be(this,u).revived.id}get label(){return Be(this,u).revived.label}get description(){return Be(this,u).revived.description}get location(){return Be(this,u).revived.location}get runnable(){var I;return(I=Be(this,u).revived.runnable)!==null&&I!==void 0?I:!0}get debuggable(){var I;return(I=Be(this,u).revived.debuggable)!==null&&I!==void 0?I:!1}get children(){return Be(this,a).getAllAsTestItem(Be(this,u).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(L=>L.toJSON()),providerId:Be(this,u).providerId,testId:this.id}}}u=new WeakMap,a=new WeakMap;class p{constructor(){this.resources=new Map}checkout(I){var L,x;const Z=I.toString(),z=(L=this.resources.get(Z))!==null&&L!==void 0?L:this.createObserverData(I);return(x=z.pendingDeletion)===null||x===void 0||x.dispose(),z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return z.tests.rootTestItems},dispose:(0,D.once)(()=>{--z.observers||(z.pendingDeletion=this.eventuallyDispose(I))})}}getMirroredTestDataByReference(I){for(const{tests:L}of this.resources.values()){const x=L.getMirroredTestDataByReference(I);if(x)return x}}eventuallyDispose(I){return(0,y.disposableTimeout)(()=>this.unlisten(I),10*1e3)}createObserverData(I){const L=new r,x=this.listen(I,z=>L.apply(z)),Z={observers:0,tests:L,listener:x};return this.resources.set(I.toString(),Z),Z}unlisten(I){var L;const x=I.toString(),Z=this.resources.get(x);Z&&(Z.observers=-1,(L=Z.pendingDeletion)===null||L===void 0||L.dispose(),Z.listener.dispose(),this.resources.delete(x))}}class S extends p{constructor(I){super();this.proxy=I,this.diffListeners=new Map}acceptDiff(I,L){var x;(x=this.diffListeners.get(I.toString()))===null||x===void 0||x(L)}listen(I,L){this.proxy.$subscribeToDiffs(0,I);const x=I.toString();return this.diffListeners.set(x,L),new E.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,I),this.diffListeners.delete(x)})}}class f extends p{constructor(I,L){super();this.proxy=I,this.documents=L,this.diffListeners=new Map}acceptDiff(I,L){var x;(x=this.diffListeners.get(I.toString()))===null||x===void 0||x(L)}listen(I,L){if(!this.documents.getDocument(I))return new E.Disposable(()=>{});const Z=I.toString();return this.diffListeners.set(Z,L),this.proxy.$subscribeToDiffs(1,I),new E.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,I),this.diffListeners.delete(Z)})}}}),define(ge[256],pe([0,1,12,53,34,75,23,11,7,24,10,15,2,138,170,83,60,210,254,32]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(S,f,v,I){this.configurationService=S,this.workspaceContextService=f,this.editorGroupsService=v,this.pathService=I}text(S,f,v={}){S=this.getContentPattern(S,v);const I=this.configurationService.getValue(),L=f&&f.some(Z=>!this.configurationService.getValue({resource:Z}).search.useRipgrep),x=this.commonQuery(f==null?void 0:f.map(E.toWorkspaceFolder),v);return Object.assign(Object.assign({},x),{type:2,contentPattern:S,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:I.search.usePCRE2||L||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(S,f){const v=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const I=Object.assign(Object.assign({},S),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(S,f)&&(I.isCaseSensitive=!0),this.isMultiline(S)&&(I.isMultiline=!0),I}file(S,f={}){const v=this.commonQuery(S,f);return Object.assign(Object.assign({},v),{type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey})}handleIncludeExclude(S,f){return S?(S=Array.isArray(S)?S.map(s):s(S),f?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],f={}){const v=this.handleIncludeExclude(f.includePattern,f.expandPatterns),I=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=S.length>1,x=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,f,I)):S.map(B=>this.getFolderQueryForRoot(B,f,I,L))).filter(B=>!!B),Z={_reason:f._reason,folderQueries:x,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:I.pattern,includePattern:v.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(F=>F.resource)))).filter(U=>(0,d.pathIncludedInQuery)(Z,U.fsPath)),M=this.commonQueryFromFileList($);return Object.assign(Object.assign({},Z),M)}const z=f.extraFileResources&&f.extraFileResources.filter(B=>(0,d.pathIncludedInQuery)(Z,B.fsPath));return Z.extraFileResources=z&&z.length?z:void 0,Z}commonQueryFromFileList(S){const f=[],v=new D.ResourceMap,I={};let L=!1;return S.forEach(x=>{var Z,z;if(x.scheme!==A.Schemas.walkThrough)if((0,n.isAbsolutePath)(x)){const $=(z=(Z=this.workspaceContextService.getWorkspaceFolder(x))===null||Z===void 0?void 0:Z.uri)!==null&&z!==void 0?z:x.with({path:C.dirname(x.fsPath)});let M=v.get($);M||(L=!0,M={folder:$,includePattern:{}},f.push(M),v.set($,M));const U=C.relative($.fsPath,x.fsPath);(0,k.assertIsDefined)(M.includePattern)[U.replace(/\\/g,"/")]=!0}else x.fsPath&&(L=!0,I[x.fsPath]=!0)}),{folderQueries:f,includePattern:I,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(S,f){if(f.isSmartCase){if(S.isRegExp){if(T.containsUppercaseCharacter(S.pattern,!0))return!0}else if(T.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,h.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const f=M=>C.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),I=(Array.isArray(S)?S:i(S)).map(M=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(M,U.scheme===A.Schemas.file?U.fsPath:U.path):M}),L=y.groupBy(I,M=>f(M)?"searchPaths":"exprSegments"),x=(L.exprSegments||[]).map(M=>T.rtrim(M,"/")).map(M=>T.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),o(M))),Z={},z=this.expandSearchPathPatterns(L.searchPaths||[]);z&&z.length&&(Z.searchPaths=z);const B=_.flatten(x),$=t(...B);return $&&(Z.pattern=$),Z}getExcludesForFolder(S,f){return f.disregardExcludeSettings?void 0:(0,d.getExcludes)(S,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const f=_.flatten(S.map(I=>{let{pathPortion:L,globPortion:x}=a(I);x&&(x=r(x));const Z=this.expandOneSearchPath(L);return _.flatten(Z.map(z=>this.resolveOneSearchPathPattern(z,x)))})),v=new Map;return f.forEach(I=>{const L=I.searchPath.toString(),x=v.get(L);x?I.pattern&&(x.pattern=x.pattern||{},x.pattern[I.pattern]=!0):v.set(L,{searchPath:I.searchPath,pattern:I.pattern?t(I.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(S){if(C.isAbsolute(S)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==A.Schemas.file?[{searchPath:f[0].uri.with({path:S})}]:[{searchPath:b.URI.file(C.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=s(S),S.startsWith("../")||S===".."){const I=C.posix.resolve(f.path,S);return[{searchPath:f.with({path:I})}]}const v=r(S);return[{searchPath:f,pattern:v}]}else{if(S==="./"||S===".\\")return[];{const f=S.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(f){const v=f[1],I=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===v);if(I.length)return I.map(L=>{const x=f[2];return{searchPath:L.uri,pattern:x&&r(x)}});{const L=c.localize(0,null,v);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(S,f){const v=S.pattern&&f?`${S.pattern}/${f}`:S.pattern||f,I=[{searchPath:S.searchPath,pattern:v}];return v&&!v.endsWith("**")&&I.push({searchPath:S.searchPath,pattern:v+"/**"}),I}getFolderQueryForSearchPath(S,f,v){const I=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(S.searchPath),f,v,!1);return I?Object.assign(Object.assign({},I),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,f,v,I){let L;const x=b.URI.isUri(S)?S:S.uri;if(v.searchPaths){const M=v.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,x))[0];if(M&&!M.pattern)return null;M&&(L=M.pattern)}const Z=this.configurationService.getValue({resource:x}),z=this.getExcludesForFolder(Z,f),B=Object.assign(Object.assign({},z||{}),L||{}),$=b.URI.isUri(S)?(0,n.basename)(S):S.name;return{folder:x,folderName:I?$:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:Z.files&&Z.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!Z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!Z.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!Z.search.followSymlinks}}};u=je([Ue(0,m.IConfigurationService),Ue(1,E.IWorkspaceContextService),Ue(2,g.IEditorGroupsService),Ue(3,w.IPathService)],u),e.QueryBuilder=u;function a(p){const S=p.match(/[\*\{\}\(\)\[\]\?]/);if(S){const f=S.index,v=p.substr(0,f).match(/[/|\\][^/\\]*$/);if(v){let I=p.substr(0,v.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((v.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((S,f)=>(S[f]=!0,S),Object.create(null)):void 0}function i(p){return R.splitGlobAware(p,",").map(S=>S.trim()).filter(S=>!!S.length)}function o(p){return[`**/${p}/**`,`**/${p}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function r(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(p,S){p=_.distinct(p,I=>I.toString());const f=[],v=S.getWorkspace();return p&&p.forEach(I=>{let L;if(S.getWorkbenchState()===2)L=(0,n.relativePath)(v.folders[0].uri,I),L&&L!=="."&&(L="./"+L);else{const x=S.getWorkspaceFolder(I);if(x){const Z=x.name;if(v.folders.filter(B=>B.name===Z).length===1){const B=(0,n.relativePath)(x.uri,I);B===""?L=`./${x.name}`:L=`./${x.name}/${B}`}else L=I.fsPath}}L&&f.push(L)}),f}e.resolveResourcesForSearchIncludes=l}),define(ge[257],pe([0,1,24,2,21,16,4,256,32,60]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(m,E){const g=E.activationEvents;if(!g)return Promise.resolve(void 0);const w=[],d=[];for(const s of g)if(/^workspaceContains:/.test(s)){const r=s.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||m.forceUsingSearch?d.push(r):w.push(r)}if(w.length===0&&d.length===0)return Promise.resolve(void 0);let u;const a=new Promise((s,r)=>{u=s}),t=s=>u({activationEvent:s}),i=Promise.all(w.map(s=>b(m,s,t))).then(()=>{}),o=h(m,E.identifier,d,t);return Promise.all([i,o]).then(()=>{u(void 0)}),a}e.checkActivateWorkspaceContainsExtension=k;async function b(m,E,g){for(const w of m.folders)if(await m.exists(_.joinPath(y.URI.revive(w),E))){g(`workspaceContains:${E}`);return}}async function h(m,E,g,w){if(g.length===0)return Promise.resolve(void 0);const d=new R.CancellationTokenSource,u=m.checkExists(m.folders,g,d.token),a=setTimeout(async()=>{d.cancel(),w(`workspaceContainsTimeout:${g.join(",")}`)},T);let t=!1;try{t=await u}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}d.dispose(),clearTimeout(a),t&&w(`workspaceContains:${g.join(",")}`)}function c(m,E,g,w){const d=m.get(D.IInstantiationService),u=m.get(C.ISearchService),t=d.createInstance(A.QueryBuilder).file(E.map(i=>(0,n.toWorkspaceFolder)(y.URI.revive(i))),{_reason:"checkExists",includePattern:g,exists:!0});return u.fileSearch(t,w).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_){if(!e.has(Y))throw new TypeError("attempted to set private field on non-instance");return e.set(Y,_),_},Be=this&&this.__classPrivateFieldGet||function(Y,e){if(!e.has(Y))throw new TypeError("attempted to get private field on non-instance");return e.get(Y)};define(ge[42],pe([0,1,159,7,67,24,17,6,23,2,13,5,36,221,88,33,41,219,16,29,11,25,192,8,113,4,27,89,14,81,50,35,3,257,86,193]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d,u,a,t,i,o,s,r,l,p,S,f,v,I,L,x,Z){"use strict";var z,B,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let M=class Ln extends A.Disposable{constructor(O,V,q,Q,fe,_e,Le,Ie,Fe,j){super();this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Le,this._extHostWorkspace=Q,this._extHostConfiguration=fe,this._logService=_e,this._extHostTunnelService=Fe,this._extHostTerminalService=j,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new S.ServiceCollection([c.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const X=new Set;this._initData.hostExtensions.forEach(te=>X.add(d.ExtensionIdentifier.toKey(te))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(X.has(d.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new h.HostExtension;const ve=this._registry.getExtensionDescription(te);return this._activateExtension(ve,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){w.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=C.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Q=>O.set(n.URI.file(Q).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,A.dispose)(q.subscriptions)}catch(Q){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const Q=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",Q),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,Q){const fe=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},fe),Q||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Q=this._getEntryPoint(O);if(!Q)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const fe=new h.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,P.joinPath)(O.extensionLocation,Q),fe),this._loadExtensionContext(O)]).then(_e=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Ln._callActivate(this._logService,O.identifier,_e[0],_e[1],fe))).then(_e=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),_e))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),Q=new Z.ExtensionSecrets(O,this._secretState),fe=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,_e=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let Ie;return Object.freeze({globalState:V,workspaceState:q,secrets:Q,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return y.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(O).fsPath},get logPath(){return y.join(Le._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Le._initData.logsLocation,O.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(O)},get globalStorageUri(){return Le._storagePath.globalValue(O)},get extensionMode(){return fe},get extension(){return(0,E.checkProposedApiEnabled)(O),Ie===void 0&&(Ie=new F(this,O.identifier,O,_e)),Ie},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(O),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,Q,fe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,Q,fe).then(_e=>new h.ActivatedExtension(!1,null,fe.build(),q,_e,Q.subscriptions))}static _callActivateOptional(O,V,q,Q,fe){if(typeof q.activate=="function")try{fe.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const _e=typeof global=="object"?global:self,Le=q.activate.apply(_e,[Q]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Le).then(Ie=>(fe.activateResolveStop(),Ie))}catch(_e){return Promise.reject(_e)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),Q=Promise.all([O,q]).then(()=>{});return Promise.race([Q,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:O.map(_e=>_e.uri),forceUsingSearch:q,exists:_e=>this._hostUtils.exists(_e.fsPath),checkExists:(_e,Le,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(_e,Le,Ie)},fe=await(0,L.checkActivateWorkspaceContainsExtension)(Q,V);if(!!fe)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:fe.activationEvent}).then(void 0,_e=>this._logService.error(_e))}}async $extensionTestsExecute(){await this._readyToRunExtensions.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(_.localize(0,null));const q=(0,P.originalFSPath)(V),Q=await this._loadCommonJSModule(null,V,new h.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(_.localize(1,null,q));return new Promise((fe,_e)=>{const Le=(Fe,j)=>{Fe?_e(Fe):fe(typeof j=="number"&&j>0?1:0)},Ie=Q.run(q,Le);Ie&&Ie.then&&Ie.then(()=>{fe(0)}).catch(Fe=>{_e(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,A.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Q=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const fe=this._resolvers[Q];if(!fe)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${Q}`);const _e=await fe.resolve(O,{resolveAttempt:V});R.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(fe));const Le={authority:O,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},Ie={extensionHostEnv:_e.extensionHostEnv};return{type:"ok",value:{authority:Le,options:Ie,tunnelInformation:{environmentTunnels:_e.environmentTunnels}}}}catch(_e){if(R.mark(`code/extHost/didResolveAuthorityError/${Q}`),_e instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(Q=>Q.extensionLocation=n.URI.revive(Q.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async Q=>{const fe=this._registry.getExtensionDescription(Q);if(!!fe){const _e=await this._hostUtils.realpath(fe.extensionLocation.fsPath);q.delete(n.URI.file(_e).fsPath)}})),await Promise.all(O.map(async Q=>{const fe=await this._hostUtils.realpath(Q.extensionLocation.fsPath);q.set(n.URI.file(fe).fsPath,Q)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=a.VSBuffer.alloc(O),q=Math.random()%256;for(let Q=0;Q<O;Q++)V.writeUInt8(q,Q);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};M=je([Ue(0,s.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,p.IExtHostRpcService),Ue(3,m.IExtHostWorkspace),Ue(4,b.IExtHostConfiguration),Ue(5,T.ILogService),Ue(6,r.IExtHostInitDataService),Ue(7,l.IExtensionStoragePaths),Ue(8,f.IExtHostTunnelService),Ue(9,v.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class F{constructor(O,V,q,Q){z.set(this,void 0),B.set(this,void 0),$.set(this,void 0),tt(this,z,O),tt(this,B,V),tt(this,$,q.identifier),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=y.normalize((0,P.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Q}get isActive(){return Be(this,z).isActivated(Be(this,$))}get exports(){if(this.packageJSON.api!=="none")return Be(this,z).getExtensionExports(Be(this,$))}activate(){return Be(this,z).activateByIdWithErrors(Be(this,$),{startup:!1,extensionId:Be(this,B),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,z=new WeakMap,B=new WeakMap,$=new WeakMap}),define(ge[45],pe([0,1,7,2,3,17,5,8,119,33,42,39,209,36,199,14,4,15,30]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let d=class{constructor(l,p,S,f,v){this._workspaceService=p,this._extensionService=S,this._editorsService=f,this._configurationService=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=l.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(L=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,p){const S=l;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let f=`debug:${encodeURIComponent(S.path||"")}`,v="?";return p&&(f+=`${v}session=${encodeURIComponent(p.id)}`,v="&"),f+=`${v}ref=${S.sourceReference}`,y.URI.parse(f)}else{if(S.path)return y.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const p=[];for(const S of l.getAllExtensionDescriptions())if(S.contributes){const f=S.contributes.debuggers;if(f&&f.length>0)for(const v of f)(0,c.isDebuggerMainContribution)(v)&&p.push(v.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(p=>l.push(p)),l}addBreakpoints(l){this.startBreakpoints();const p=l.filter(v=>{const I=v.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,v),!0)});this.fireBreakpointChanges(p,[],[]);const S=[],f=new Map;for(const v of p)if(v instanceof A.SourceBreakpoint){let I=f.get(v.location.uri.toString());I||(I={type:"sourceMulti",uri:v.location.uri,lines:[]},f.set(v.location.uri.toString(),I),S.push(I)),I.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof A.FunctionBreakpoint&&S.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(l){this.startBreakpoints();const p=l.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],p,[]);const S=p.filter(I=>I instanceof A.SourceBreakpoint).map(I=>I.id),f=p.filter(I=>I instanceof A.FunctionBreakpoint).map(I=>I.id),v=p.filter(I=>I instanceof A.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(S,f,v)}startDebugging(l,p,S){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,p,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,p,S){if(!p)return new A.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:f,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,S,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,f),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(l,p,S){if(!S)return new A.Disposable(()=>{});if(!this.definesDebugType(l,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:f,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,f),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(l,p){if(!p)return new A.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:S,factory:p}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==p)})}async $runInTerminal(l,p){return Promise.resolve(void 0)}async $substituteVariables(l,p){if(!this._variableResolver){const[v,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,I)}let S;const f=await this.getFolder(l);return f&&(S={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(S,p)}createDebugAdapter(l,p){if(l.type==="implementation")return new o(l.implementation)}createSignService(){}async $startDASession(l,p){const S=this,f=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const I=this.convertToDto(v),L=this.createDebugAdapter(I,f);if(!L)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const x=L;return this._debugAdapters.set(l,x),this.getDebugAdapterTrackers(f).then(Z=>(Z&&this._debugAdaptersTrackers.set(l,Z),x.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const B=z,$={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(B.arguments.value);$.body={signature:M},x.sendResponse($)}else throw new Error("no signer")}catch(M){$.success=!1,$.message=M.message,x.sendResponse($)}}else Z&&Z.onDidSendMessage&&Z.onDidSendMessage(z),z=(0,c.convertToVSCPaths)(z,!0),S._debugServiceProxy.$acceptDAMessage(l,z)}),x.onError(z=>{Z&&Z.onError&&Z.onError(z),this._debugServiceProxy.$acceptDAError(l,z.name,z.message,z.stack)}),x.onExit(z=>{Z&&Z.onExit&&Z.onExit((0,g.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,g.withNullAsUndefined)(z),void 0)}),Z&&Z.onWillStartSession&&Z.onWillStartSession(),x.startSession()))})}$sendDAMessage(l,p){p=(0,c.convertToDAPaths)(p,!1);const S=this._debugAdaptersTrackers.get(l);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(p);const f=this._debugAdapters.get(l);f&&f.sendMessage(p)}$stopDASession(l){const p=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),p&&p.onWillStopSession&&p.onWillStopSession();const S=this._debugAdapters.get(l);return this._debugAdapters.delete(l),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const p=[],S=[],f=[];if(l.added)for(const v of l.added){const I=v.id;if(I&&!this._breakpoints.has(I)){let L;if(v.type==="function")L=new A.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")L=new A.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const x=y.URI.revive(v.uri);L=new A.SourceBreakpoint(new A.Location(x,new A.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}L._id=I,this._breakpoints.set(I,L),p.push(L)}}if(l.removed)for(const v of l.removed){const I=this._breakpoints.get(v);I&&(this._breakpoints.delete(v),S.push(I))}if(l.changed){for(const v of l.changed)if(v.id){const I=this._breakpoints.get(v.id);if(I){if(I instanceof A.FunctionBreakpoint&&v.type==="function"){const L=I;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.functionName=v.functionName}else if(I instanceof A.SourceBreakpoint&&v.type==="source"){const L=I;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.location=new A.Location(y.URI.revive(v.uri),new A.Position(v.line,v.character))}f.push(I)}}}this.fireBreakpointChanges(p,S,f)}$provideDebugConfigurations(l,p,S){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(l);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(p);return f.provideDebugConfigurations(v,S)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(l,p,S,f){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(p);return v.resolveDebugConfiguration(I,S,f)})}$resolveDebugConfigurationWithSubstitutedVariables(l,p,S,f){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(p);return v.resolveDebugConfigurationWithSubstitutedVariables(I,S,f)})}async $provideDebugAdapter(l,p){const S=this.getAdapterDescriptorFactoryByHandle(l);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(p);return this.getAdapterDescriptor(S,f).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(l){const p=await this.getSession(l);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(l){const p=await this.getSession(l);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,p){const S=await this.getSession(l);S&&S._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(l,p){const f={session:await this.getSession(l),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(l){if(l instanceof A.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof A.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const p=this._adapterFactories.filter(S=>S.type===l);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(l){const p=this._adapterFactories.filter(S=>S.handle===l);if(p.length>0)return p[0].factory}getConfigProviderByHandle(l){const p=this._configProviders.filter(S=>S.handle===l);if(p.length>0)return p[0].provider}definesDebugType(l,p){if(l.contributes){const S=l.contributes.debuggers;if(S&&S.length>0){for(const f of S)if(f.label&&f.type&&f.type===p)return!0}}return!1}getDebugAdapterTrackers(l){const S=l.configuration.type,f=this._trackerFactories.filter(v=>v.type===S||v.type==="*").map(v=>(0,P.asPromise)(()=>v.factory.createDebugAdapterTracker(l)).then(I=>I,I=>null));return Promise.race([Promise.all(f).then(v=>{const I=v.filter(L=>!!L);if(I.length>0)return new i(I)}),new Promise((v,I)=>{const L=setTimeout(()=>{clearTimeout(L),I(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(l,p){const S=p.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new A.DebugAdapterServer(S));if(l){const v=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>l.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,v))).then(I=>{if(I)return I})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,f))}daExecutableFromPackage(l,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,p,S){(l.length>0||p.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:p,changed:S}))}async getSession(l){if(l)if(typeof l=="string"){const p=this._debugSessions.get(l);if(p)return p}else{let p=this._debugSessions.get(l.id);if(!p){const S=await this.getFolder(l.folderUri);p=new u(this._debugServiceProxy,l.id,l.type,l.name,S,l.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(l){if(l){const p=y.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};d=je([Ue(0,m.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,h.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class u{constructor(l,p,S,f,v,I){this._debugServiceProxy=l,this._id=p,this._type=S,this._name=f,this._workspaceFolder=v,this._configuration=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,p)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=u;class a{constructor(l){this.value=Object.freeze({append(p){l.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=a;class t extends b.AbstractVariableResolverService{constructor(l,p,S,f){super({getFolderUri:v=>{const I=l.filter(L=>L.name===v);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(v,I)=>S.getConfiguration(void 0,v).get(I),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const v=p.activeEditor();if(v)return _.normalize(v.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&f){const v=p.activeEditor();if(v){const I=f.getWorkspaceFolder(v.document.uri);if(I)return _.normalize(I.uri.fsPath)}}},getSelectedText:()=>{if(p){const v=p.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(p){const v=p.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,w.env)}}e.ExtHostVariableResolverService=t;class i{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(p=>p.onError?p.onError(l):void 0)}onExit(l,p){this.trackers.forEach(S=>S.onExit?S.onExit(l,p):void 0)}}class o extends C.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends d{constructor(l,p,S,f,v){super(l,p,S,f,v)}createVariableResolver(l,p,S){return new t(l,p,S)}};s=je([Ue(0,m.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,h.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(ge[258],pe([0,1,67,2,5,36,41,29,14,27,4,42,30,13]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(d,u,a,t,i,o,s){this._apiFactory=d,this._extensionRegistry=u,this._instaService=a,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=o,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,u,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,u,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let u of d.nodeModuleName)this._factories.set(u,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(u=>d.alternativeModuleName(u))}};c=je([Ue(2,T.IInstantiationService),Ue(3,P.IExtHostConfiguration),Ue(4,k.IExtHostExtensionService),Ue(5,n.IExtHostInitDataService),Ue(6,h.ILogService)],c),e.RequireInterceptor=c;class m{constructor(d,u,a,t,i){this._apiFactory=d,this._extensionPaths=u,this._extensionRegistry=a,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,u){const a=this._extensionPaths.findSubstr(u.fsPath);if(a){let t=this._extApiImpl.get(A.ExtensionIdentifier.toKey(a.identifier));return t||(t=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(a.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,o)=>t+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(d,u){this.nodeModuleName="keytar";const{environment:a}=u,t=d.getProxy(R.MainContext.MainThreadKeytar);if(a.appRoot){let i=a.appRoot.fsPath;b.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,o)=>t.$getPassword(i,o),setPassword:(i,o,s)=>t.$setPassword(i,o,s),deletePassword:(i,o)=>t.$deletePassword(i,o),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(d,u){return this._impl}alternativeModuleName(d){const u=d.length;if(!(u<=7||!this.alternativeNames)){const a=u-7;if((d.charAt(a)==="/"||d.charAt(a)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};E=je([Ue(0,C.IExtHostRpcService),Ue(1,n.IExtHostInitDataService)],E);let g=class{constructor(d,u,a){this._extensionPaths=d,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(R.MainContext.MainThreadTelemetry);const t=a.getProxy(R.MainContext.MainThreadWindow);this._impl=(i,o)=>{const s=y.URI.parse(i);return o?this.callOriginal(i,o):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,i,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,i,{}):this.callOriginal(i,o)}}load(d,u,a){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=a(d),this._impl}callOriginal(d,u){return this.sendNoForwardTelemetry(),this._original(d,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([Ue(2,C.IExtHostRpcService)],g)}),define(ge[259],pe([0,1,165,9,8,200,33,42,39,36,35,14,45,185,203,17]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends b.ExtHostDebugServiceBase{constructor(d,u,a,t,i,o){super(d,u,a,t,i);this._terminalService=o,this._integratedTerminalInstances=new g}createDebugAdapter(d,u){switch(d.type){case"server":return new P.SocketDebugAdapter(d);case"pipeServer":return new P.NamedPipeDebugAdapter(d);case"executable":return new P.ExecutableDebugAdapter(d,u.type)}return super.createDebugAdapter(d,u)}daExecutableFromPackage(d,u){const a=P.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),d.type);if(a)return new R.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new h.SignService}async $runInTerminal(d,u){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(v=>{this._integratedTerminalInstances.onTerminalClosed(v)}));const a=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,a),i=this._terminalService.getDefaultShellArgs(!0,a),o=JSON.stringify({shell:t,shellArgs:i});let s=await this._integratedTerminalInstances.checkout(o),r,l=!1;if(s)r=d.cwd;else{const v={shellPath:t,shellArgs:i,cwd:d.cwd,name:d.title||_.localize(0,null)};l=!0,s=this._terminalService.createTerminalFromOptions(v,!0),this._integratedTerminalInstances.insert(s,o)}s.show(!0);const p=await s.processId;l?await new Promise(v=>setTimeout(v,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?s.sendText("cls"):t.indexOf("bash")>=0?s.sendText("clear"):y.isWindows?s.sendText("cls"):s.sendText("clear"));const S=(0,c.prepareCommand)(t,d.args,r,d.env);s.sendText(S);const f=this.onDidTerminateDebugSession(v=>{v.id===u&&(this._integratedTerminalInstances.free(s),f.dispose())});return p}else if(d.kind==="external")return(0,c.runInExternalTerminal)(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,u)}createVariableResolver(d,u,a){return new b.ExtHostVariableResolverService(d,u,a,this._workspaceService)}};E=je([Ue(0,k.IExtHostRpcService),Ue(1,D.IExtHostWorkspace),Ue(2,A.IExtHostExtensionService),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,T.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class g{constructor(){this._terminalInstances=new Map}async checkout(d){const a=[...this._terminalInstances.entries()].map(([t,i])=>(0,m.createCancelablePromise)(async o=>{if(i.lastUsedAt!==-1&&await(0,c.hasChildProcesses)(await t.processId))return null;const s=Date.now();return i.lastUsedAt+g.minUseDelay>s||o.isCancellationRequested||i.config!==d?null:(i.lastUsedAt=s,t)}));return await(0,m.firstParallel)(a,t=>!!t)}insert(d,u){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:u})}free(d){const u=this._terminalInstances.get(d);u&&(u.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}g.minUseDelay=1e3}),define(ge[260],pe([0,1,7,2,77,33,45,39,36,35,14,27,66,11,13,63]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends b.ExtHostTaskBase{constructor(w,d,u,a,t,i,o,s){super(w,d,u,a,t,i,o,s);this.workspaceService=u,d.remote.isRemote&&d.remote.authority&&this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(w,d){const u=d;if(!d.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const a=b.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(a);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,d);return this._proxy.$executeTask(a).catch(()=>{}),i}else{const a=b.TaskDTO.from(d,w);if(a===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(a.execution)&&await this.addCustomExecution(a,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(a),d);return this._proxy.$executeTask(a).catch(()=>{}),t}}provideTasksInternal(w,d,u,a){const t=[];if(a)for(let i of a){this.checkDeprecation(i,u),(!i.definition||!w[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const o=b.TaskDTO.from(i,u.extension);o&&(t.push(o),b.CustomExecutionDTO.is(o.execution)&&d.push(this.addCustomExecution(o,i,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(w){return w}async getVariableResolver(w){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(w,this._editorService,d,this.workspaceService)}return this._variableResolver}async $resolveVariables(w,d){const u=y.URI.revive(w),a={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(i),s={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let r of d.variables)a.variables[r]=o.resolve(s,r);if(d.process!==void 0){let r;if(d.process.path!==void 0){r=d.process.path.split(_.delimiter);for(let l=0;l<r.length;l++)r[l]=o.resolve(s,r[l])}a.process=await R.win32.findExecutable(o.resolve(s,d.process.name),d.process.cwd!==void 0?o.resolve(s,d.process.cwd):void 0,r)}return a}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(w,d,u){return R.win32.findExecutable(w,d,u)}};E=je([Ue(0,T.IExtHostRpcService),Ue(1,k.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,A.IExtHostDocumentsAndEditors),Ue(4,C.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,c.ILogService),Ue(7,m.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(ge[261],pe([0,1,9,15,28,147,13,36,45,39,14,35,33,206,207]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let m=class extends k.BaseExtHostTerminalService{constructor(g,w,d,u,a){super(!0,g);this._extHostConfiguration=w,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=u,this._logService=a,this._isWorkspaceShellAllowed=!1,(0,P.getSystemShell)(_.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(g,w,d){const u=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:g,shellPath:w,shellArgs:d},g);return this._terminals.push(u),u.create(w,d),u.value}createTerminalFromOptions(g,w){const d=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),g,g.name);return this._terminals.push(d),d.create((0,y.withNullAsUndefined)(g.shellPath),(0,y.withNullAsUndefined)(g.shellArgs),(0,y.withNullAsUndefined)(g.cwd),(0,y.withNullAsUndefined)(g.env),void 0,(0,y.withNullAsUndefined)(g.strictEnv),(0,y.withNullAsUndefined)(g.hideFromUser),(0,y.withNullAsUndefined)(w),!0),d.value}getDefaultShell(g,w){var d;const u=a=>{const t=w.getConfiguration(a.substr(0,a.lastIndexOf("."))).inspect(a.substr(a.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return h.getDefaultShell(u,this._isWorkspaceShellAllowed,(d=this._defaultShell)!==null&&d!==void 0?d:(0,P.getSystemShellSync)(_.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,h.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,g)}getDefaultShellArgs(g,w){const d=u=>{const a=w.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(a)};return h.getDefaultShellArgs(d,this._isWorkspaceShellAllowed,g,h.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(g){return{userValue:g?g.globalValue:void 0,value:g?g.workspaceValue:void 0,defaultValue:g?g.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const g=this._extHostDocumentsAndEditors.activeEditor();g&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(g.document.uri))}async _updateVariableResolver(){const g=await this._extHostConfiguration.getConfigProvider(),w=await this._extHostWorkspace.getWorkspaceFolders2();this._variableResolver=new C.ExtHostVariableResolverService(w||[],this._extHostDocumentsAndEditors,g)}async $getAvailableProfiles(g){const w=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,c.detectAvailableProfiles)(g,this._logService,w,this._variableResolver,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(g){const w=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(g,w),args:this.getDefaultShellArgs(g,w)}}$acceptWorkspacePermissionsChanged(g){this._isWorkspaceShellAllowed=g}};m=je([Ue(0,T.IExtHostRpcService),Ue(1,A.IExtHostConfiguration),Ue(2,b.IExtHostWorkspace),Ue(3,n.IExtHostDocumentsAndEditors),Ue(4,D.ILogService)],m),e.ExtHostTerminalService=m}),define(ge[262],pe([0,1,17,16,67,6,2,5,252,13,78,81,27,181,14,62,42,35]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(u,a,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new C.RPCProtocol(u,null,i);a=w._transform(a,o);const s=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());s.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},a)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(o)),s.set(m.IURITransformerService,new m.URITransformerService(i)),s.set(E.IHostUtils,t);const r=new h.InstantiationService(s,!0),l=r.invokeFunction(v=>v.get(g.IExtHostTerminalService));this._disposables.add(l),this._logService=r.invokeFunction(v=>v.get(n.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",a),this._extensionService=r.invokeFunction(v=>v.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(I,L)=>{let x="",Z,z;for(const B of L)x+=`
	at ${B.toString()}`,z=B.getFileName(),!Z&&z&&(Z=v.findSubstr(z));return p.set(I,Z),`${I.name||"Error"}: ${I.message||""}${x}`}});const S=o.getProxy(A.MainContext.MainThreadExtensionService),f=o.getProxy(A.MainContext.MainThreadErrors);y.setUnexpectedErrorHandler(v=>{const I=y.transformErrorForSerialization(v),L=p.get(v);L?S.$onExtensionRuntimeError(L.identifier,I):f.$onUnexpectedError(I)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),y.setUnexpectedErrorHandler(t=>{});const a=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),a]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,a){u.extensions.forEach(i=>i.extensionLocation=D.URI.revive(a.transformIncomingURIs(i.extensionLocation))),u.environment.appRoot=D.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(i=>D.URI.revive(a.transformIncomingURIs(i)))),u.environment.extensionTestsLocationURI=D.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=D.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=D.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=D.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.logFile=D.URI.revive(a.transformIncomingURIs(u.logFile)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=w}),define(ge[263],pe([0,1,7,21,59,34,24,46,32,30]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(h,c,m){this.config=h,this.provider=c,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&P.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&P.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const c=this.config.folderQueries||[];return new Promise((m,E)=>{const g=w=>{this.resultCount++,h(w)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const d=w.toString(),u=_.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,u)||this.matchFile(g,{base:w,basename:u})}),Promise.all(c.map(w=>this.searchInFolder(w,g))).then(w=>{m({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{E(new Error((0,R.toErrorMessage)(w)))})})}searchInFolder(h,c){const m=new y.CancellationTokenSource;return new Promise((E,g)=>{const w=this.getSearchOptionsForFolder(h),d=this.initDirectoryTree(),u=new C.QueryGlobTester(this.config,h),a=!u.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(m),t=A.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,m.token))).then(i=>{const o=t.elapsed(),s=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(r=>{const l=_.posix.relative(h.folder.path,r.path);if(a){const p=_.basename(r.path);this.matchFile(c,{base:h.folder,relativePath:l,basename:p});return}this.addDirectoryEntries(d,h.folder,l,c)}),this.activeCancellationTokens.delete(m),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,u,c),{providerTime:o,postProcessTime:s.elapsed()})}).then(i=>{m.dispose(),E(i)},i=>{m.dispose(),g(i)})})}getSearchOptionsForFolder(h){const c=(0,C.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),m=(0,C.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:m,includes:c,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},c,m,E){if(m===this.filePattern){const w=_.basename(this.filePattern);this.matchFile(E,{base:c,relativePath:this.filePattern,basename:w})}function g(w){const d=_.basename(w),u=_.dirname(w);let a=h[u];a||(a=h[u]=[],g(u)),a.push({base:c,relativePath:w,basename:d})}g(m)}matchDirectoryTree({rootEntries:h,pathToEntries:c},m,E){const g=this,w=this.filePattern;function d(u){const a=P.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,i=u.length;t<i;t++){const o=u[t],{relativePath:s,basename:r}=o;if(!!m.includedInQuerySync(s,r,w!==r?a:void 0)){const l=c[s];if(l)d(l);else{if(s===w)continue;g.matchFile(E,o)}if(g.isLimitHit)break}}}d(h)}matchFile(h,c){(!this.includePattern||c.relativePath&&this.includePattern(c.relativePath,c.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(c))}}class k{constructor(){this.sessions=new Map}fileSearch(h,c,m,E){const g=this.getSessionTokenSource(h.cacheKey),w=new T(h,c,g&&g.token);let d=0;const u=a=>{d+=a.length,m(a.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(w,k.BATCH_SIZE,u,E).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:a.stats}}))}clearCache(h){const c=this.getSessionTokenSource(h);c&&c.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new y.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:D.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,c,m,E){E.onCancellationRequested(()=>{h.cancel()});const g=d=>{d&&(w.push(d),c>0&&w.length>=c&&(m(w),w=[]))};let w=[];return h.search(g).then(d=>(w.length&&m(w),d),d=>(w.length&&m(w),Promise.reject(d)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(ge[125],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(P,D){this.line=P,this.character=D}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,D){return new _(0,0)}with(P){return new _(0,0)}}e.Position=_;class y{constructor(P,D,A,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(P,D),this.end=new _(A,C)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new y(0,0,0,0)}with(P){return new y(0,0,0,0)}}e.Range=y}),define(ge[126],pe([0,1,7,12,21,59,24,34,2,32,30,11]),function(Y,e,_,y,R,P,D,A,C,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(d,u,a){this.query=d,this.provider=u,this.fileUtils=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,u){const a=this.query.folderQueries||[],t=new R.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((i,o)=>{this.collector=new c(d);let s=!1;const r=(l,p)=>{if(!s&&!this.isLimitHit){const S=this.resultSize(l);E(l)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const f=this.resultSize(l);this.resultCount+=f,(f>0||!E(l))&&this.collector.add(l,p)}};Promise.all(a.map((l,p)=>this.searchInFolder(l,S=>r(S,p),t.token))).then(l=>{t.dispose(),this.collector.flush();const p=l.some(S=>!!S&&!!S.limitHit);i({limitHit:this.isLimitHit||p,stats:{type:"textSearchProvider"}})},l=>{t.dispose();const p=(0,P.toErrorMessage)(l);o(new Error(p))})})}resultSize(d){return E(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,u){const a=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:a.slice(0,u),preview:{matches:t.slice(0,u),text:d.preview.text},uri:d.uri}}searchInFolder(d,u,a){const t=new n.QueryGlobTester(this.query,d),i=[],o={report:r=>{if(!!this.validateProviderResult(r)){const l=d.folder.scheme===k.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(r.uri))):void 0,p=D.relativePath(d.folder,r.uri);p&&i.push(t.includedInQuery(p,_.basename(p),l).then(S=>{S&&u(r)}))}}},s=this.getSearchOptionsForFolder(d);return new Promise(r=>(0,T.nextTick)(r)).then(()=>this.provider.provideTextSearchResults(h(this.query.contentPattern),s,o,a)).then(r=>Promise.all(i).then(()=>r))}validateProviderResult(d){if(E(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const u=(0,n.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),a=(0,n.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:C.URI.from(d.folder),excludes:a,includes:u,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class c{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,u=>this.sendItems(u))}add(d,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!D.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(m(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=c;function m(w){return E(w)?{preview:{matches:(0,y.mapArrayOrNot)(w.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:w.preview.text},ranges:(0,y.mapArrayOrNot)(w.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function E(w){return!!w.preview}e.extensionResultIsMatch=E;class g{constructor(d,u){this.maxBatchSize=d,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,u){!d||this.addItemToBatch(d,u)}addItems(d,u){!d||this.addItemsToBatch(d,u)}addItemToBatch(d,u){this.batch.push(d),this.batchSize+=u,this.onUpdate()}addItemsToBatch(d,u){this.batch=this.batch.concat(d),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(ge[68],pe([0,1,6,5,4,263,14,62,13,2,126]),function(Y,e,_,y,R,P,D,A,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(m,E,g){this.extHostRpc=m,this._uriTransformer=E,this._logService=g,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,E){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const g=this._handlePool++;return this._textSearchProvider.set(g,E),this._proxy.$registerTextSearchProvider(g,this._transformScheme(m)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(m,E){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const g=this._handlePool++;return this._fileSearchProvider.set(g,E),this._proxy.$registerFileSearchProvider(g,this._transformScheme(m)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(m,E,g,w){const d=b(g),u=this._fileSearchProvider.get(m);if(u)return this._fileSearchManager.fileSearch(d,u,a=>{this._proxy.$handleFileMatch(m,E,a.map(t=>t.resource))},w);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,E,g,w){const d=this._textSearchProvider.get(m);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const u=b(g);return this.createTextSearchManager(u,d).search(t=>this._proxy.$handleTextMatch(m,E,t),w)}createTextSearchManager(m,E){return new T.TextSearchManager(m,E,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};k=je([Ue(0,D.IExtHostRpcService),Ue(1,A.IURITransformerService),Ue(2,C.ILogService)],k),e.ExtHostSearch=k;function b(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(m=>n.URI.revive(m))})}e.reviveQuery=b;function h(c){return Object.assign(Object.assign({},c),{folder:n.URI.revive(c.folder)})}}),define(ge[264],pe([0,1,156,21,16,3,57,2,149,104,139,76,44,5,227,226,51,228,36,229,230,231,212,232,39,42,233,213,235,236,237,64,216,239,240,241,88,35,242,217,20,8,245,65,124,33,41,53,196,234,114,123,66,45,68,13,62,14,27,238,195,50,63,224,243,194,89,87,248,246,247,225,61,255,244,86,191,117]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d,u,a,t,i,o,s,r,l,p,S,f,v,I,L,x,Z,z,B,$,M,U,F,N,O,V,q,Q,fe,_e,Le,Ie,Fe,j,X,te,ae,ve,De,Oe,we,ke,Te,xe,ye,Ke,G,ie,Se,Ne,ze,We,Ye,K,oe,ue,J,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function me(Ee){const He=Ee.get(Oe.IExtHostInitDataService),$e=Ee.get(K.IExtHostFileSystemInfo),qe=Ee.get(Se.IExtHostConsumerFileSystem),Qe=Ee.get(s.IExtHostExtensionService),Ze=Ee.get(q.IExtHostWorkspace),ut=Ee.get(le.IExtHostTelemetry),st=Ee.get(w.IExtHostConfiguration),be=Ee.get(ve.IURITransformerService),he=Ee.get(De.IExtHostRpcService),ce=Ee.get(z.IExtHostStorage),ee=Ee.get(ie.IExtensionStoragePaths),Ae=Ee.get(ae.ILogService),Re=Ee.get(Te.IExtHostTunnelService),et=Ee.get(xe.IExtHostApiDeprecationService),Ge=Ee.get(V.IExtHostWindow),rt=Ee.get(J.IExtHostSecretState);he.set(h.ExtHostContext.ExtHostFileSystemInfo,$e),he.set(h.ExtHostContext.ExtHostLogService,Ae),he.set(h.ExtHostContext.ExtHostWorkspace,Ze),he.set(h.ExtHostContext.ExtHostConfiguration,st),he.set(h.ExtHostContext.ExtHostExtensionService,Qe),he.set(h.ExtHostContext.ExtHostStorage,ce),he.set(h.ExtHostContext.ExtHostTunnelService,Re),he.set(h.ExtHostContext.ExtHostWindow,Ge),he.set(h.ExtHostContext.ExtHostSecretState,rt),he.set(h.ExtHostContext.ExtHostTelemetry,ut);const lt=he.set(h.ExtHostContext.ExtHostDecorations,Ee.get(Fe.IExtHostDecorations)),Xe=he.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ee.get(o.IExtHostDocumentsAndEditors)),it=he.set(h.ExtHostContext.ExtHostCommands,Ee.get(E.IExtHostCommands)),dt=he.set(h.ExtHostContext.ExtHostTerminalService,Ee.get(B.IExtHostTerminalService)),at=he.set(h.ExtHostContext.ExtHostDebugService,Ee.get(X.IExtHostDebugService)),Ct=he.set(h.ExtHostContext.ExtHostSearch,Ee.get(te.IExtHostSearch)),gt=he.set(h.ExtHostContext.ExtHostTask,Ee.get(j.IExtHostTask)),kt=he.set(h.ExtHostContext.ExtHostOutputService,Ee.get(v.IExtHostOutputService)),Et=he.set(h.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=he.set(h.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(he)),mt=he.set(h.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(he,Xe)),Lt=he.set(h.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(he,Xe,Ae)),Ft=he.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ae,mt,he.getProxy(h.MainContext.MainThreadBulkEdits))),ht=he.set(h.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(he,it,Xe,mt,He.environment,Ae,ee)),yt=he.set(h.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(he,Xe)),$t=he.set(h.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(he.getProxy(h.MainContext.MainThreadTreeViews),it,Ae)),Ht=he.set(h.ExtHostContext.ExtHostEditorInsets,new _e.ExtHostEditorInsets(he.getProxy(h.MainContext.MainThreadEditorInsets),yt,He.environment)),Mt=he.set(h.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Ae)),ct=he.set(h.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(he,be,mt,it,Mt,Ae,et)),hn=he.set(h.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(he,ct)),Pt=he.set(h.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(he,Ae,Xe)),Tt=he.set(h.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(he,Ze,it)),tn=he.set(h.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(he,it,Ae)),fn=he.set(h.ExtHostContext.ExtHostComments,new g.ExtHostComments(he,it,mt)),nn=he.set(h.ExtHostContext.ExtHostProgress,new I.ExtHostProgress(he.getProxy(h.MainContext.MainThreadProgress))),mn=he.set(h.ExtHostContext.ExtHosLabelService,new Le.ExtHostLabelService(he)),rn=he.set(h.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(he)),At=he.set(h.ExtHostContext.ExtHostAuthentication,new ye.ExtHostAuthentication(he)),zt=he.set(h.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,it)),Vt=he.set(h.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(he,He.environment,Ze,Ae,et)),jt=he.set(h.ExtHostContext.ExtHostWebviewPanels,new We.ExtHostWebviewPanels(he,Vt,Ze)),gn=he.set(h.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(he,mt,ee,Vt,jt)),pn=he.set(h.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(he,Vt)),It=he.set(h.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(he,Xe,Ze)),vn=he.set(h.ExtHostContext.ExtHostUriOpeners,new ue.ExtHostUriOpeners(he)),wn=(0,fe.values)(h.ExtHostContext);he.assertRegistered(wn);const qt=new Ye.ExtHostBulkEdits(he,Xe),_n=new m.ExtHostClipboard(he),Kt=new f.ExtHostMessageService(he,Ae),Bt=new u.ExtHostDialogs(he),Ot=new Z.ExtHostStatusBar(he,it.converter),Gt=new S.ExtHostLanguages(he,mt);return c.ExtHostApiCommands.register(it),function(Me,Nt,Qt){const ft=function(){let re=!Me.isUnderDevelopment;function de(Pe){re||(Ae.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Pe(H){if(Array.isArray(H))H.forEach(Pe);else if(typeof H=="string")de(H);else{const W=H;typeof W.scheme=="undefined"&&de(H),!Me.enableProposedApi&&typeof W.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Me)}return H}}(),bn={getSession(re,de,Pe){return At.getSession(Me,re,de,Pe)},get onDidChangeSessions(){return At.onDidChangeSessions},registerAuthenticationProvider(re,de,Pe,H){return At.registerAuthenticationProvider(re,de,Pe,H)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Me),At.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Me),At.providers},logout(re,de){return(0,Q.checkProposedApiEnabled)(Me),At.removeSession(re,de)}},sn={registerCommand(re,de,Pe){return it.registerCommand(!0,re,de,Pe)},registerTextEditorCommand(re,de,Pe){return it.registerCommand(!0,re,(...H)=>{const W=yt.getActiveTextEditor();if(!W){Ae.warn("Cannot execute "+re+" because there is no active text editor.");return}return W.edit(se=>{de.apply(Pe,[W,se,...H])}).then(se=>{se||Ae.warn("Edits from command "+re+" were not applied.")},se=>{Ae.warn("An error occurred while running command "+re,se)})})},registerDiffInformationCommand:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Me),it.registerCommand(!0,re,async(...H)=>{const W=Xe.activeEditor(!0);if(!W){Ae.warn("Cannot execute "+re+" because there is no active text editor.");return}const se=await yt.getDiffInformation(W.id);de.apply(Pe,[se,...H])})),executeCommand(re,...de){return it.executeCommand(re,...de)},getCommands(re=!1){return it.getCommands(re)}},on={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var re,de;return(de=(re=He.environment.appRoot)===null||re===void 0?void 0:re.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return dt.getDefaultShell(!1,Qt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,de){return Ge.openUri(re,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(re){return re.scheme===He.environment.appUriScheme?St.createAppUri(re):Ge.asExternalUri(re,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(on);const an=He.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Xt={registerTestProvider(re){return(0,Q.checkProposedApiEnabled)(Me),It.registerTestProvider(re)},createDocumentTestObserver(re){return(0,Q.checkProposedApiEnabled)(Me),It.createTextDocumentTestObserver(re)},createWorkspaceTestObserver(re){return(0,Q.checkProposedApiEnabled)(Me),It.createWorkspaceTestObserver(re)},runTests(re){return(0,Q.checkProposedApiEnabled)(Me),It.runTests(re)},publishTestResult(re,de=!0){return(0,Q.checkProposedApiEnabled)(Me),It.publishExtensionProvidedResults(re,de)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Me),It.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Me),It.results}},En={getExtension(re){const de=Nt.getExtensionDescription(re);if(de)return new s.Extension(Qe,Me.identifier,de,an)},get all(){return Nt.getAllExtensionDescriptions().map(re=>new s.Extension(Qe,Me.identifier,re,an))},get onDidChange(){return Nt.onDidChange}},Sn={createDiagnosticCollection(re){return Mt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:re=>Mt.getDiagnostics(re),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(re,de){return Gt.changeLanguage(re.uri,de)},match(re,de){return(0,k.score)(U.LanguageSelector.from(re),de.uri,de.languageId,!0)},registerCodeActionsProvider(re,de,Pe){return ct.registerCodeActionProvider(Me,ft(re),de,Pe)},registerCodeLensProvider(re,de){return ct.registerCodeLensProvider(Me,ft(re),de)},registerDefinitionProvider(re,de){return ct.registerDefinitionProvider(Me,ft(re),de)},registerDeclarationProvider(re,de){return ct.registerDeclarationProvider(Me,ft(re),de)},registerImplementationProvider(re,de){return ct.registerImplementationProvider(Me,ft(re),de)},registerTypeDefinitionProvider(re,de){return ct.registerTypeDefinitionProvider(Me,ft(re),de)},registerHoverProvider(re,de){return ct.registerHoverProvider(Me,ft(re),de,Me.identifier)},registerEvaluatableExpressionProvider(re,de){return ct.registerEvaluatableExpressionProvider(Me,ft(re),de,Me.identifier)},registerInlineValuesProvider(re,de){return ct.registerInlineValuesProvider(Me,ft(re),de,Me.identifier)},registerDocumentHighlightProvider(re,de){return ct.registerDocumentHighlightProvider(Me,ft(re),de)},registerLinkedEditingRangeProvider(re,de){return ct.registerLinkedEditingRangeProvider(Me,ft(re),de)},registerReferenceProvider(re,de){return ct.registerReferenceProvider(Me,ft(re),de)},registerRenameProvider(re,de){return ct.registerRenameProvider(Me,ft(re),de)},registerDocumentSymbolProvider(re,de,Pe){return ct.registerDocumentSymbolProvider(Me,ft(re),de,Pe)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,de){return ct.registerDocumentFormattingEditProvider(Me,ft(re),de)},registerDocumentRangeFormattingEditProvider(re,de){return ct.registerDocumentRangeFormattingEditProvider(Me,ft(re),de)},registerOnTypeFormattingEditProvider(re,de,Pe,...H){return ct.registerOnTypeFormattingEditProvider(Me,ft(re),de,[Pe].concat(H))},registerDocumentSemanticTokensProvider(re,de,Pe){return ct.registerDocumentSemanticTokensProvider(Me,ft(re),de,Pe)},registerDocumentRangeSemanticTokensProvider(re,de,Pe){return ct.registerDocumentRangeSemanticTokensProvider(Me,ft(re),de,Pe)},registerSignatureHelpProvider(re,de,Pe,...H){return typeof Pe=="object"?ct.registerSignatureHelpProvider(Me,ft(re),de,Pe):ct.registerSignatureHelpProvider(Me,ft(re),de,typeof Pe=="undefined"?[]:[Pe,...H])},registerCompletionItemProvider(re,de,...Pe){return ct.registerCompletionItemProvider(Me,ft(re),de,Pe)},registerDocumentLinkProvider(re,de){return ct.registerDocumentLinkProvider(Me,ft(re),de)},registerColorProvider(re,de){return ct.registerColorProvider(Me,ft(re),de)},registerFoldingRangeProvider(re,de){return ct.registerFoldingRangeProvider(Me,ft(re),de)},registerSelectionRangeProvider(re,de){return ct.registerSelectionRangeProvider(Me,re,de)},registerCallHierarchyProvider(re,de){return ct.registerCallHierarchyProvider(Me,re,de)},setLanguageConfiguration:(re,de)=>ct.setLanguageConfiguration(Me,re,de),getTokenInformationAtPosition(re,de){return(0,Q.checkProposedApiEnabled)(Me),Gt.tokenAtPosition(re,de)},registerInlineHintsProvider(re,de){return(0,Q.checkProposedApiEnabled)(Me),ct.registerInlineHintsProvider(Me,re,de)}},yn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(re,de,Pe){const H=await(A.URI.isUri(re)?Promise.resolve(ln.openTextDocument(re)):Promise.resolve(re));return yt.showTextDocument(H,de,Pe)},createTextEditorDecorationType(re){return yt.createTextEditorDecorationType(re)},onDidChangeActiveTextEditor(re,de,Pe){return yt.onDidChangeActiveTextEditor(re,de,Pe)},onDidChangeVisibleTextEditors(re,de,Pe){return yt.onDidChangeVisibleTextEditors(re,de,Pe)},onDidChangeTextEditorSelection(re,de,Pe){return yt.onDidChangeTextEditorSelection(re,de,Pe)},onDidChangeTextEditorOptions(re,de,Pe){return yt.onDidChangeTextEditorOptions(re,de,Pe)},onDidChangeTextEditorVisibleRanges(re,de,Pe){return yt.onDidChangeTextEditorVisibleRanges(re,de,Pe)},onDidChangeTextEditorViewColumn(re,de,Pe){return yt.onDidChangeTextEditorViewColumn(re,de,Pe)},onDidCloseTerminal(re,de,Pe){return dt.onDidCloseTerminal(re,de,Pe)},onDidOpenTerminal(re,de,Pe){return dt.onDidOpenTerminal(re,de,Pe)},onDidChangeActiveTerminal(re,de,Pe){return dt.onDidChangeActiveTerminal(re,de,Pe)},onDidChangeTerminalDimensions(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),dt.onDidChangeTerminalDimensions(re,de,Pe)},onDidWriteTerminalData(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),dt.onDidWriteTerminalData(re,de,Pe)},get state(){return Ge.state},onDidChangeWindowState(re,de,Pe){return Ge.onDidChangeWindowState(re,de,Pe)},showInformationMessage(re,...de){return Kt.showMessage(Me,D.default.Info,re,de[0],de.slice(1))},showWarningMessage(re,...de){return Kt.showMessage(Me,D.default.Warning,re,de[0],de.slice(1))},showErrorMessage(re,...de){return Kt.showMessage(Me,D.default.Error,re,de[0],de.slice(1))},showQuickPick(re,de,Pe){return Tt.showQuickPick(re,!!Me.enableProposedApi,de,Pe)},showWorkspaceFolderPick(re){return Tt.showWorkspaceFolderPick(re)},showInputBox(re,de){return Tt.showInput(re,de)},showOpenDialog(re){return Bt.showOpenDialog(re)},showSaveDialog(re){return Bt.showSaveDialog(re)},createStatusBarItem(re,de){let Pe,H,W,se;return re&&typeof re!="number"?(Pe=re.id,H=re.name,W=re.alignment,de=re.priority,se=re.accessibilityInformation):(Pe=Me.identifier.value,H=_.localize(0,null,Me.displayName||Me.name),W=re),Ot.createStatusBarEntry(Pe,H,W,de,se)},setStatusBarMessage(re,de){return Ot.setStatusBarMessage(re,de)},withScmProgress(re){return et.report("window.withScmProgress",Me,"Use 'withProgress' instead."),nn.withProgress(Me,{location:F.ProgressLocation.SourceControl},(de,Pe)=>re({report(H){}}))},withProgress(re,de){return nn.withProgress(Me,re,de)},createOutputChannel(re){return kt.createOutputChannel(re)},createWebviewPanel(re,de,Pe,H){return jt.createWebviewPanel(Me,re,de,Pe,H)},createWebviewTextEditorInset(re,de,Pe,H){return(0,Q.checkProposedApiEnabled)(Me),Ht.createWebviewEditorInset(re,de,Pe,H,Me)},createTerminal(re,de,Pe){return typeof re=="object"?"pty"in re?dt.createExtensionTerminal(re):dt.createTerminalFromOptions(re):dt.createTerminal(re,de,Pe)},registerTerminalLinkProvider(re){return dt.registerLinkProvider(re)},registerTreeDataProvider(re,de){return $t.registerTreeDataProvider(re,de,Me)},createTreeView(re,de){return $t.createTreeView(re,de,Me)},registerWebviewPanelSerializer:(re,de)=>jt.registerWebviewPanelSerializer(Me,re,de),registerCustomEditorProvider:(re,de,Pe={})=>gn.registerCustomEditorProvider(Me,re,de,Pe),registerFileDecorationProvider(re){return lt.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return St.registerUriHandler(Me.identifier,re)},createQuickPick(){return Tt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Tt.createInputBox(Me.identifier)},get activeColorTheme(){return rn.activeColorTheme},onDidChangeActiveColorTheme(re,de,Pe){return rn.onDidChangeActiveColorTheme(re,de,Pe)},registerWebviewViewProvider(re,de,Pe){return pn.registerWebviewViewProvider(Me,re,de,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Me),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeActiveNotebookEditor(re,de,Pe)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookEditorSelection(re,de,Pe)},onDidChangeNotebookEditorVisibleRanges(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookEditorVisibleRanges(re,de,Pe)},showNotebookDocument(re,de){return(0,Q.checkProposedApiEnabled)(Me),ht.showNotebookDocument(re,de)},registerExternalUriOpener(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),vn.registerExternalUriOpener(Me.identifier,re,de,Pe)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Me),Et.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Me),Et.onDidChangeTabs}},ln={get rootPath(){return et.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(re){throw R.readonly()},getWorkspaceFolder(re){return Ze.getWorkspaceFolder(re)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(re){throw R.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(re){throw R.readonly()},updateWorkspaceFolders:(re,de,...Pe)=>Ze.updateWorkspaceFolders(Me,re,de||0,...Pe),onDidChangeWorkspaceFolders:function(re,de,Pe){return Ze.onDidChangeWorkspace(re,de,Pe)},asRelativePath:(re,de)=>Ze.getRelativePath(re,de),findFiles:(re,de,Pe,H)=>Ze.findFiles(U.GlobPattern.from(re),U.GlobPattern.from(de),Pe,Me.identifier,H),findTextInFiles:(re,de,Pe,H)=>{let W,se;return typeof de=="object"?(W=de,se=Pe):(W={},se=de,H=Pe),Ze.findTextInFiles(re,W||{},se,Me.identifier,H)},saveAll:re=>Ze.saveAll(re),applyEdit(re){return qt.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,de,Pe,H)=>Pt.createFileSystemWatcher(U.GlobPattern.from(re),de,Pe,H),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw R.readonly()},openTextDocument(re){let de;const Pe=re;if(typeof re=="string")de=Promise.resolve(A.URI.file(re));else if(A.URI.isUri(re))de=Promise.resolve(re);else if(!Pe||typeof Pe=="object")de=mt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(H=>mt.ensureDocumentData(H).then(W=>W.document))},onDidOpenTextDocument:(re,de,Pe)=>mt.onDidAddDocument(re,de,Pe),onDidCloseTextDocument:(re,de,Pe)=>mt.onDidRemoveDocument(re,de,Pe),onDidChangeTextDocument:(re,de,Pe)=>mt.onDidChangeDocument(re,de,Pe),onDidSaveTextDocument:(re,de,Pe)=>mt.onDidSaveDocument(re,de,Pe),onWillSaveTextDocument:(re,de,Pe)=>Ft.getOnWillSaveTextDocumentEvent(Me)(re,de,Pe),onDidChangeConfiguration:(re,de,Pe)=>Qt.onDidChangeConfiguration(re,de,Pe),getConfiguration(re,de){return de=arguments.length===1?void 0:de,Qt.getConfiguration(re,de,Me)},registerTextDocumentContentProvider(re,de){return Lt.registerTextDocumentContentProvider(re,de)},registerTaskProvider:(re,de)=>(et.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Me,re,de)),registerFileSystemProvider(re,de,Pe){return hn.registerFileSystemProvider(Me.identifier,re,de,Pe)},get fs(){return qe.value},registerFileSearchProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),Ct.registerFileSearchProvider(re,de)),registerTextSearchProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),Ct.registerTextSearchProvider(re,de)),registerRemoteAuthorityResolver:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),Qe.registerRemoteAuthorityResolver(re,de)),registerResourceLabelFormatter:re=>((0,Q.checkProposedApiEnabled)(Me),mn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,de,Pe)=>Pt.onDidCreateFile(re,de,Pe),onDidDeleteFiles:(re,de,Pe)=>Pt.onDidDeleteFile(re,de,Pe),onDidRenameFiles:(re,de,Pe)=>Pt.onDidRenameFile(re,de,Pe),onWillCreateFiles:(re,de,Pe)=>Pt.getOnWillCreateFileEvent(Me)(re,de,Pe),onWillDeleteFiles:(re,de,Pe)=>Pt.getOnWillDeleteFileEvent(Me)(re,de,Pe),onWillRenameFiles:(re,de,Pe)=>Pt.getOnWillRenameFileEvent(Me)(re,de,Pe),openTunnel:re=>((0,Q.checkProposedApiEnabled)(Me),Re.openTunnel(Me,re).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Me),Re.getTunnels()},onDidChangeTunnels:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Me),Re.onDidChangeTunnels(re,de,Pe)),registerPortAttributesProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),Re.registerPortsAttributesProvider(re,de)),registerTimelineProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),zt.registerTimelineProvider(re,de,Me.identifier,it.converter)),get trustState(){return(0,Q.checkProposedApiEnabled)(Me),(0,Q.checkRequiresWorkspaceTrust)(Me),Ze.trustState},requireWorkspaceTrust:re=>((0,Q.checkProposedApiEnabled)(Me),(0,Q.checkRequiresWorkspaceTrust)(Me),Ze.requireWorkspaceTrust(re)),onDidChangeWorkspaceTrustState:(re,de,Pe)=>Ze.onDidChangeWorkspaceTrustState(re,de,Pe)},Dn={get inputBox(){return et.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),tn.getLastInputBox(Me)},createSourceControl(re,de,Pe){return tn.createSourceControl(Me,re,de,Pe)}},cn={createCommentController(re,de){return fn.createCommentController(Me,re,de)}},Cn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(re,de,Pe){return at.onDidStartDebugSession(re,de,Pe)},onDidTerminateDebugSession(re,de,Pe){return at.onDidTerminateDebugSession(re,de,Pe)},onDidChangeActiveDebugSession(re,de,Pe){return at.onDidChangeActiveDebugSession(re,de,Pe)},onDidReceiveDebugSessionCustomEvent(re,de,Pe){return at.onDidReceiveDebugSessionCustomEvent(re,de,Pe)},onDidChangeBreakpoints(re,de,Pe){return at.onDidChangeBreakpoints(re,de,Pe)},registerDebugConfigurationProvider(re,de,Pe){return at.registerDebugConfigurationProvider(re,de,Pe||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,de){return at.registerDebugAdapterDescriptorFactory(Me,re,de)},registerDebugAdapterTrackerFactory(re,de){return at.registerDebugAdapterTrackerFactory(re,de)},startDebugging(re,de,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?at.startDebugging(re,de,{parentSession:Pe}):at.startDebugging(re,de,Pe||{})},stopDebugging(re){return at.stopDebugging(re)},addBreakpoints(re){return at.addBreakpoints(re)},removeBreakpoints(re){return at.removeBreakpoints(re)},asDebugSourceUri(re,de){return at.asDebugSourceUri(re,de)}},kn={registerTaskProvider:(re,de)=>gt.registerTaskProvider(Me,re,de),fetchTasks:re=>gt.fetchTasks(re),executeTask:re=>gt.executeTask(Me,re),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(re,de,Pe)=>gt.onDidStartTask(re,de,Pe),onDidEndTask:(re,de,Pe)=>gt.onDidEndTask(re,de,Pe),onDidStartTaskProcess:(re,de,Pe)=>gt.onDidStartTaskProcess(re,de,Pe),onDidEndTaskProcess:(re,de,Pe)=>gt.onDidEndTaskProcess(re,de,Pe)},Jt={openNotebookDocument:re=>((0,Q.checkProposedApiEnabled)(Me),ht.openNotebookDocument(re)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Me),ht.notebookDocuments.map(re=>re.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Me),ht.registerNotebookContentProvider(Me,re,de,Pe)),registerNotebookKernelProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Me),ht.registerNotebookKernelProvider(Me,re,de)),createNotebookEditorDecorationType(re){return(0,Q.checkProposedApiEnabled)(Me),ht.createNotebookEditorDecorationType(re)},onDidChangeNotebookDocumentMetadata(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookDocumentMetadata(re,de,Pe)},onDidChangeNotebookCells(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookCells(re,de,Pe)},onDidChangeCellOutputs(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeCellOutputs(re,de,Pe)},onDidChangeCellMetadata(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.onDidChangeCellMetadata(re,de,Pe)},createConcatTextDocument(re,de){return(0,Q.checkProposedApiEnabled)(Me),new G.ExtHostNotebookConcatDocument(ht,mt,re,de)},createCellStatusBarItem(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Me),ht.createNotebookCellStatusBarItemInternal(re,de,Pe)}};return{version:He.version,authentication:bn,commands:sn,comments:cn,debug:Cn,env:on,extensions:En,languages:Sn,notebook:Jt,scm:Dn,tasks:kn,test:Xt,window:yn,workspace:ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:y.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:b.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:T.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:A.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlineHint:F.InlineHint,InlineHintKind:F.InlineHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookCellRange:F.NotebookCellRange,NotebookCellKind:F.NotebookCellKind,NotebookCellRunState:F.NotebookCellRunState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRunState:F.NotebookRunState,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,LinkedEditingRanges:F.LinkedEditingRanges,TestItem:F.TestItem,TestState:F.TestState,TestResult:F.TestResult,TestMessage:F.TestMessage,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=me}),define(ge[265],pe([0,1,78,64,33,123,36,51,39,35,66,45,68,89,88,50,63,124,87,61,86,117]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,_.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,_.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,_.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,_.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,_.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,_.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,_.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,_.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService),(0,_.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,_.registerSingleton)(c.IExtHostStorage,c.ExtHostStorage),(0,_.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,_.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,_.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService),(0,_.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,_.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry)}),define(ge[90],pe([0,1,12,13,32,125]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=D;function A(k,b,h,c){const m=(0,_.mapArrayOrNot)(h,C),E=new R.TextSearchMatch(b,m,c),g=E.preview.matches;return{ranges:(0,_.mapArrayOrNot)(m,n),uri:k,preview:{text:E.preview.text,matches:(0,_.mapArrayOrNot)(g,n)}}}e.createTextSearchResult=A;function C(k){return new R.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function n(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(b,h){this.prefix=b,this.logService=h}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};T=je([Ue(1,y.ILogService)],T),e.OutputChannel=T}),define(ge[266],pe([0,1,91,25]),function(Y,e,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,D=512,A=512*8,C=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let o;if(i!==e.UTF8)o=(await new Promise((r,l)=>{Y(["iconv-lite-umd"],r,l)})).getDecoder(h(i));else{const s=new TextDecoder;o={write(r){return s.decode(r,{stream:!0})},end(){return s.decode()}}}return new n(o)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function T(t,i){var o;const s=((o=i.minBytesRequiredForDetection)!==null&&o!==void 0?o:i.guessEncoding)?A:D;return new Promise((r,l)=>{const p=(0,_.newWriteableStream)(L=>L.join("")),S=[];let f=0,v;const I=async()=>{try{const L=await a({buffer:y.VSBuffer.concat(S),bytesRead:f},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),v=await n.create(L.encoding);const x=v.write(y.VSBuffer.concat(S).buffer);p.write(x),S.length=0,f=0,r({stream:p,detected:L})}catch(L){l(L)}};(0,_.listenStream)(t,{onData:async L=>{v?p.write(v.write(L.buffer)):(S.push(L),f+=L.byteLength,f>=s&&(t.pause(),await I(),setTimeout(()=>t.resume())))},onError:L=>p.error(L),onEnd:async()=>{v||await I(),p.end(v==null?void 0:v.end())}})})}e.toDecodeStream=T;async function k(t,i,o){const r=(await new Promise((S,f)=>{Y(["iconv-lite-umd"],S,f)})).getEncoder(h(i),o);let l=!1,p=!1;return{read(){if(p)return null;const S=t.read();if(typeof S!="string"){if(p=!0,!l&&(o==null?void 0:o.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return y.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return y.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return y.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const f=r.end();return f&&f.length>0?(l=!0,y.VSBuffer.wrap(f)):null}return l=!0,y.VSBuffer.wrap(r.write(S))}}}e.toEncodeReadable=k;async function b(t){return(await new Promise((o,s)=>{Y(["iconv-lite-umd"],o,s)})).encodingExists(h(t))}e.encodingExists=b;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),s=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&s===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&s===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const r=t.readUInt8(2);return o===e.UTF8_BOM[0]&&s===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const m=["ascii","utf-16","utf-32"];async function E(t){const i=await new Promise((p,S)=>{Y(["jschardet"],p,S)}),o=t.slice(0,C),s=d(o.buffer),r=i.detect(s);if(!r||!r.encoding)return null;const l=r.encoding.toLowerCase();return 0<=m.indexOf(l)?null:w(r.encoding)}const g={ibm866:"cp866",big5:"cp950"};function w(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[i]||i}function d(t){let i="";for(let o=0;o<t.length;o++)i+=String.fromCharCode(t[o]);return i}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=u;function a({buffer:t,bytesRead:i},o){let s=c(t,i),r=!1;if(s!==e.UTF16be&&s!==e.UTF16le&&t){let l=!0,p=!0,S=!1;for(let f=0;f<i&&f<P;f++){const v=f%2==1,I=t.readUInt8(f)===0;if(I&&(S=!0),l&&(v&&!I||!v&&I)&&(l=!1),p&&(v&&I||!v&&!I)&&(p=!1),I&&!l&&!p)break}S&&(l?s=e.UTF16le:p?s=e.UTF16be:r=!0)}return o&&!r&&!s&&t?E(t.slice(0,i)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:r,encoding:s}}e.detectEncodingFromBuffer=a,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[127],pe([0,1,266,26,126]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends R.TextSearchManager{constructor(A,C,n=y){super(A,C,{readdir:T=>n.readdir(T.fsPath),toCanonicalName:T=>(0,_.toCanonicalName)(T)})}}e.NativeTextSearchManager=P}),define(ge[267],pe([0,1,268,282,283,2,284]),function(Y,e,_,y,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(k,b,h,c,m,E){const g=E.environment.useHostProxy,w=typeof g=="boolean"?g:!E.remote.isRemote,d=(0,D.createProxyResolver)({resolveProxy:a=>k.resolveProxy(a),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(a,t,...i)=>{switch(a){case D.LogLevel.Trace:c.trace(t,...i);break;case D.LogLevel.Debug:c.debug(t,...i);break;case D.LogLevel.Info:c.info(t,...i);break;case D.LogLevel.Warning:c.warn(t,...i);break;case D.LogLevel.Error:c.error(t,...i);break;case D.LogLevel.Critical:c.critical(t,...i);break;case D.LogLevel.Off:break;default:o(a,t,i);break}function o(s,r,...l){c.error("Unknown log level",s),c.error(r,...l)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:a=>{m.$publicLog2("resolveProxy",a)},useHostProxy:w,env:process.env}),u=C(b,d);return T(h,u)}e.connectProxyResolver=A;function C(k,b){const h={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(m=>{h.config=k.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(m=>{c.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,D.createHttpPatch)(_,b,{config:"off"},c,!0)),on:Object.assign({},_,(0,D.createHttpPatch)(_,b,{config:"on"},c,!0)),override:Object.assign({},_,(0,D.createHttpPatch)(_,b,{config:"override"},c,!0)),onRequest:Object.assign({},_,(0,D.createHttpPatch)(_,b,h,c,!0)),default:Object.assign(_,(0,D.createHttpPatch)(_,b,h,c,!1))},https:{off:Object.assign({},y,(0,D.createHttpPatch)(y,b,{config:"off"},c,!0)),on:Object.assign({},y,(0,D.createHttpPatch)(y,b,{config:"on"},c,!0)),override:Object.assign({},y,(0,D.createHttpPatch)(y,b,{config:"override"},c,!0)),onRequest:Object.assign({},y,(0,D.createHttpPatch)(y,b,h,c,!0)),default:Object.assign(y,(0,D.createHttpPatch)(y,b,h,c,!1))},tls:Object.assign(R,(0,D.createTlsPatch)(R))}}const n=new Map;function T(k,b){return k.getExtensionPathIndex().then(h=>{const c=Y.__$__nodeRequire("module"),m=c._load;c._load=function(g,w,d){if(g==="tls")return b.tls;if(g!=="http"&&g!=="https")return m.apply(this,arguments);const u=b[g],a=h.findSubstr(P.URI.file(w.filename).fsPath);let t=n.get(a);if(t||n.set(a,t={}),!t[g]){let i=u.default;a&&a.enableProposedApi&&(i=u[a.proxySupport]||u.onRequest),t[g]=Object.assign({},i)}return t[g]}})}}),define(ge[269],pe([0,1,38,7,74,31,9,10,90,270]),function(Y,e,_,y,R,P,D,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(d,u,a,t){const i=b(d,u,a,t),o=u.folder.fsPath;return{cmd:_.spawn(T,i.args,{cwd:o}),rgDiskPath:T,siblingClauses:i.siblingClauses,rgArgs:i,cwd:o}}e.spawnRipgrepCmd=k;function b(d,u,a,t){const i=["--files","--hidden","--case-sensitive"];c([u],a,!1).forEach(s=>{const r=(0,C.anchorGlob)(s);if(i.push("-g",r),D.isMacintosh){const l=(0,R.normalizeNFD)(r);l!==r&&i.push("-g",l)}});const o=h([u],t,void 0,!1);return o.globArgs.forEach(s=>{const r=`!${(0,C.anchorGlob)(s)}`;if(i.push("-g",r),D.isMacintosh){const l=(0,R.normalizeNFD)(r);l!==r&&i.push("-g",l)}}),u.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),u.ignoreSymlinks||i.push("--follow"),d.exists&&i.push("--quiet"),i.push("--no-config"),u.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:o.siblingClauses}}function h(d,u,a,t=!0){const i=[];let o={};return d.forEach(s=>{const r=Object.assign({},s.excludePattern||{},u||{}),l=m(r,t?s.folder.fsPath:void 0,a);i.push(...l.globArgs),l.siblingClauses&&(o=Object.assign(o,l.siblingClauses))}),{globArgs:i,siblingClauses:o}}e.foldersToRgExcludeGlobs=h;function c(d,u,a=!0){const t=[];return d.forEach(i=>{const o=Object.assign({},u||{},i.includePattern||{}),s=m(o,a?i.folder.fsPath:void 0);t.push(...s.globArgs)}),t}e.foldersToIncludeGlobs=c;function m(d,u,a){const t=[],i={};return Object.keys(d).forEach(o=>{if(!(a&&a.has(o))&&!!o){const s=d[o];o=g(u?E(u,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof s=="boolean"&&s?(o.startsWith("\\\\")&&(o+="**"),t.push(w(o))):s&&s.when&&(i[o]=s)}}),{globArgs:t,siblingClauses:i}}function E(d,u){return y.isAbsolute(u)?u:y.join(d,u)}e.getAbsoluteGlob=E;function g(d){return d=A.rtrim(d,"\\"),A.rtrim(d,"/")}function w(d){return P.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=w}),define(ge[271],pe([0,1,38,37,7,98,12,59,34,74,31,9,46,10,15,26,32,269,96]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(o=>o())});class u{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&C.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,w.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&C.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(r=>{const l=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),p=r.folder.fsPath;s.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==p).forEach(S=>{(0,T.isEqualOrParent)(S,p)&&(l[R.relative(p,S)]=!0)}),this.folderExcludePatterns.set(p,new t(l,p))})}cancel(){this.isCanceled=!0}walk(s,r,l,p,S){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);r.forEach(f=>{const v=R.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,v)||this.matchFile(l,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(s,(f,v)=>{this.call(this.cmdTraversal,this,f,l,p,I=>{if(I){const L=(0,A.toErrorMessage)(I);console.error(L),this.errors.push(L),v(I,void 0)}else v(null,void 0)})},(f,v)=>{this.fileWalkSW.stop();const I=f?D.coalesce(f)[0]:null;S(I,this.isLimitHit)})}parallel(s,r,l){const p=new Array(s.length),S=new Array(s.length);let f=!1,v=0;if(s.length===0)return l(null,[]);s.forEach((I,L)=>{r(I,(x,Z)=>{if(x?(f=!0,p[L]=null,S[L]=x):(p[L]=Z,S[L]=null),++v===s.length)return l(f?S:null,p)})})}call(s,r,...l){try{s.apply(r,l)}catch(p){l[l.length-1](p)}}cmdTraversal(s,r,l,p){const S=s.folder.fsPath,f=k.isMacintosh;let v;const I=()=>v&&v.kill();d.add(I);let L=U=>{d.delete(I),L=()=>{},p(U)},x="";const Z=this.initDirectoryTree();let z;const B=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression);v=B.cmd,z=!Object.keys(B.siblingClauses).length;const $=B.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let M=`${B.rgDiskPath} ${$}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),l({message:M}),this.cmdResultCount=0,this.collectStdout(v,"utf8",l,(U,F,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(x+(f?n.normalizeNFC(F||""):F)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else x=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,z){for(const q of V)if(this.matchFile(r,{base:S,relativePath:q,searchPath:this.getSearchPath(s,q)}),this.isLimitHit){I();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(s,Z,S,V,r),N&&(this.matchDirectoryTree(Z,S,r),L())})}spawnFindCmd(s){const r=this.folderExcludePatterns.get(s.folder.fsPath),l=r.getBasenameTerms(),p=r.getPathTerms(),S=["-L","."];if(l.length||p.length){S.push("-not","(","(");for(const f of l)S.push("-name",f),S.push("-o");for(const f of p)S.push("-path",f),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),_.spawn("find",S,{cwd:s.folder.fsPath})}readStdout(s,r,l){let p="";this.collectStdout(s,r,()=>{},(S,f,v)=>{if(S){l(S);return}p+=f,v&&l(null,p)})}collectStdout(s,r,l,p){let S=(I,L,x)=>{(I||x)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),p(I,L,x)},f=!1;s.stdout?(this.forwardData(s.stdout,r,S),s.stdout.once("data",()=>f=!0)):l({message:"stdout is null"});let v;s.stderr?v=this.collectData(s.stderr):l({message:"stderr is null"}),s.on("error",I=>{S(I)}),s.on("close",I=>{let L;!f&&(L=this.decodeData(v,r))&&i(L)?S(new Error(`command failed with error code ${I}: ${this.decodeData(v,r)}`)):(this.exists&&I===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(s,r,l){const p=new P.StringDecoder(r);return s.on("data",S=>{l(null,p.write(S))}),p}collectData(s){const r=[];return s.on("data",l=>{r.push(l)}),r}decodeData(s,r){const l=new P.StringDecoder(r);return s.map(p=>l.write(p)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:r},l,p,S){p.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const f=v=>{const I=R.basename(v),L=R.dirname(v);let x=r[L];x||(x=r[L]=[],f(L)),x.push({base:l,relativePath:v,basename:I,searchPath:this.getSearchPath(s,v)})};p.forEach(f)}matchDirectoryTree({rootEntries:s,pathToEntries:r},l,p){const S=this,f=this.folderExcludePatterns.get(l),v=this.filePattern;function I(L){S.directoriesWalked++;const x=C.hasSiblingFn(()=>L.map(Z=>Z.basename));for(let Z=0,z=L.length;Z<z;Z++){const B=L[Z],{relativePath:$,basename:M}=B;if(!f.test($,M,v!==M?x:void 0)){const U=r[$];if(U)I(U);else{if(S.filesWalked++,$===v)continue;S.matchFile(p,B)}if(S.isLimitHit)break}}}I(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,r,l,p,S){const f=s.folder,v=C.hasSiblingFn(()=>l);this.parallel(l,(I,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const x=r?[r,I].join(R.sep):I;if(this.folderExcludePatterns.get(s.folder.fsPath).test(x,I,this.config.filePattern!==I?v:void 0))return L(null);const Z=[f.fsPath,x].join(R.sep);y.lstat(Z,(z,B)=>{if(z||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(Z,B,($,M)=>$||this.isCanceled||this.isLimitHit?L(null):M.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(Z,B,(U,F)=>U||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?L(null):(this.walkedPaths[F]=!0,(0,m.readdir)(Z).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(s,x,N,p,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&c.isNumber(M.size)&&M.size>this.maxFilesize||this.matchFile(p,{base:f.fsPath,relativePath:x,searchPath:this.getSearchPath(s,x)}),L(null,void 0)))})},I=>{const L=I&&D.coalesce(I);return S(L&&L.length>0?L[0]:void 0)})}matchFile(s,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,R.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(r))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,r,l){return r.isSymbolicLink()?y.stat(s,l):l(null,r)}realPathIfNeeded(s,r,l){return r.isSymbolicLink()?y.realpath(s,(p,S)=>p?l(p):l(null,S)):l(null,s)}getSearchPath(s,r){return s.folderName?R.join(s.folderName,r):r}}e.FileWalker=u;class a{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new u(s)}search(s,r,l){this.walker.walk(this.folderQueries,this.extraFiles,s,r,(p,S)=>{l(p,{limitHit:S,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(s,r){this.expression=s,this.root=r,this.init(s)}init(s){let r,l;Object.keys(s).filter(p=>s[p]).forEach(p=>{R.isAbsolute(p)?(r=r||C.getEmptyExpression(),r[p]=s[p]):(l=l||C.getEmptyExpression(),l[p]=s[p])}),this.absoluteParsedExpr=r&&C.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=l&&C.parse(l,{trimForExclusions:!0})}test(s,r,l){return this.relativeParsedExpr&&this.relativeParsedExpr(s,r,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,s),r,l)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...C.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...C.getPathTerms(this.relativeParsedExpr)),s}}function i(o){const s=o.trim().split(`
`),r=s[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return h.uppercaseFirstLetter(s[s.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=i}),define(ge[128],pe([0,1,38,285,98,12,53,34,7,10,2,32,125,286,270,90]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(f){this.outputChannel=f}provideTextSearchResults(f,v,I,L){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((x,Z)=>{L.onCancellationRequested(()=>O());const z=i(f,v),B=v.folder.fsPath,$=z.map(_e=>_e.match(/^-/)?_e:`'${_e}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${B}`);let M=_.spawn(E,z,{cwd:B});M.on("error",_e=>{console.error(_e),this.outputChannel.appendLine("Error: "+(_e&&_e.message)),Z((0,k.serializeSearchError)(new k.SearchError(_e&&_e.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const F=new u(v.maxResults,B,v.previewOptions);F.on("result",_e=>{U=!0,q="",I.report(_e)});let N=!1;const O=()=>{N=!0,M&&M.kill(),F&&F.cancel()};let V=!1;F.on("hitLimit",()=>{V=!0,O()});let q="";M.stdout.on("data",_e=>{F.handleData(_e),U||(q+=_e)});let Q=!1;M.stdout.once("data",()=>Q=!0);let fe="";M.stderr.on("data",_e=>{const Le=_e.toString();this.outputChannel.appendLine(Le),fe+=Le}),M.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)x({limitHit:V});else{F.flush(),M=null;let _e;fe&&!Q&&(_e=w(fe))?Z((0,k.serializeSearchError)(new k.SearchError(_e.message,_e.code))):x({limitHit:V})}})})}}e.RipgrepTextSearchEngine=g;function w(S){const f=S.split(`
`),v=f[0].trim();if(f.some(L=>L.startsWith("regex parse error")))return new k.SearchError(d(f),k.SearchErrorCode.regexParseError);const I=v.match(/grep config error: unknown encoding: (.*)/);if(I)return new k.SearchError(`Unknown encoding: ${I[1]}`,k.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new k.SearchError(v.charAt(0).toUpperCase()+v.substr(1),k.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new k.SearchError(v.charAt(0).toUpperCase()+v.substr(1),k.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(v,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function d(S){const f=["Regex parse error"],v=S.filter(I=>I.startsWith("PCRE2:"));if(v.length>=1){const I=v[0].replace("PCRE2:","");if(I.indexOf(":")!==-1&&I.split(":").length>=2){const L=I.split(":")[1];f.push(":"+L)}}return f.join("")}e.buildRegexParseError=d;class u extends y.EventEmitter{constructor(f,v,I){super();this.maxResults=f,this.rootFolder=v,this.previewOptions=I,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,v){return super.on(f,v),this}handleData(f){if(!this.isDone){const v=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(v)}}handleDecodedData(f){let v=f.indexOf(`
`);const I=this.remainder+f;if(v>=0)v+=this.remainder.length;else{this.remainder=I;return}let L=0;for(;v>=0;)this.handleLine(I.substring(L,v).trim()),L=v+1,v=I.indexOf(`
`,L);this.remainder=I.substring(L)}handleLine(f){if(!(this.isDone||!f)){let v;try{v=JSON.parse(f)}catch(I){throw new Error(`malformed line from rg: ${f}`)}if(v.type==="match"){const I=a(v.data.path),L=T.URI.file(C.join(this.rootFolder,I)),x=this.createTextSearchMatch(v.data,L);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const I=a(v.data.path),L=T.URI.file(C.join(this.rootFolder,I));this.createTextSearchContext(v.data,L).forEach(Z=>this.onResult(Z))}}}createTextSearchMatch(f,v){const I=f.line_number-1;let L=!1,x=a(f.lines);I===0&&(0,n.startsWithUTF8BOM)(x)&&(L=!0,x=(0,n.stripUTF8BOM)(x));const Z=Buffer.from(x);let z=0,B=0,$=I;f.submatches.length===0&&f.submatches.push(x.length?{start:0,end:1,match:{text:x[0]}}:{start:0,end:0,match:{text:""}});const M=(0,P.coalesce)(f.submatches.map((U,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=a(U.match);I===0&&F===0&&L&&(N=(0,n.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=Z.slice(z,U.start).toString().length,V=B+O,q=t(N),Q=$,fe=q.numLines+Q,_e=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return z=U.end,B=_e,$=fe,new b.Range(Q,V,fe,_e)}));return(0,m.createTextSearchResult)(v,x,M,this.previewOptions)}createTextSearchContext(f,v){const I=a(f.lines),L=f.line_number;return I.replace(/\r?\n$/,"").split(`
`).map((x,Z)=>({text:x,uri:v,lineNumber:L+Z}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=u;function a(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const f=/\n/g;let v=0,I=-1,L;for(;L=f.exec(S);)v++,I=L.index;const x=I>=0?S.length-I-1:S.length;return{numLines:v,lastLineLength:x}}function i(S,f){const v=["--hidden"];v.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:I,otherIncludes:L}=(0,D.groupBy)(f.includes,Z=>Z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const Z=new Set;L.forEach(z=>{Z.add(z)}),v.push("-g","!*"),Z.forEach(z=>{o(z).map(m.anchorGlob).forEach(B=>{v.push("-g",B)})})}I&&I.length&&I.forEach(Z=>{v.push("-g",Z)}),f.excludes.map(m.anchorGlob).forEach(Z=>v.push("-g",`!${Z}`)),f.maxFileSize&&v.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),f.followSymlinks&&v.push("--follow"),f.encoding&&f.encoding!=="utf8"&&v.push("--encoding",f.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,n.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),f.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),S.isRegExp&&(S.pattern=s(S.pattern),v.push("--auto-hybrid-regex"));let x;if(S.isWordMatch){const z=(0,n.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",z)}else if(S.isRegExp){let Z=l(S.pattern);Z=p(Z),v.push("--regexp",Z)}else x=S.pattern,v.push("--fixed-strings");return v.push("--no-config"),f.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),S.isMultiline&&v.push("--multiline"),f.beforeContext&&v.push("--before-context",f.beforeContext+""),f.afterContext&&v.push("--after-context",f.afterContext+""),v.push("--"),x&&v.push(x),v.push("."),v}function o(S){const f=(0,A.splitGlobAware)(S,"/");return f.map((v,I)=>f.slice(0,I+1).join("/"))}e.spreadGlobComponents=o;function s(S){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(f);)S=S.replace(f,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(v);)S=S.replace(v,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=s;const r=S=>S.type==="Assertion"&&S.kind==="lookbehind";function l(S){let f;try{f=new h.RegExpParser().parsePattern(S)}catch(z){return S}let v="",I=0;const L=(z,B,$)=>{v+=S.slice(I,z)+$,I=B},x=[];return new h.RegExpVisitor({onCharacterEnter(z){if(z.raw==="\\n"){const B=x[0];if(!B)L(z.start,z.end,"\\r?\\n");else if(!x.some(r))if(B.type==="CharacterClass"){const $=S.slice(B.start+1,z.start)+S.slice(z.end,B.end-1);L(B.start,B.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else B.type==="Quantifier"&&L(z.start,z.end,"(?:\\r?\\n)")}},onQuantifierEnter(z){x.unshift(z)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(z){x.unshift(z)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(z){x.unshift(z)},onCharacterClassLeave(){x.shift()},onAssertionEnter(z){r(z)&&x.push(z)},onAssertionLeave(z){x[0]===z&&x.shift()}}).visit(f),v+=S.slice(I),v}e.fixRegexNewline=l;function p(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(ge[272],pe([0,1,21,128,111,11]),function(Y,e,_,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,T,k,b){const h=new y.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===P.Schemas.userData){const c=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:P.Schemas.file})}),m=new R.Progress(E=>k.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:T.folder.scheme})})));return this.withToken(b,E=>h.provideTextSearchResults(n,c,m,E))}else return this.withToken(b,c=>h.provideTextSearchResults(n,T,k,c))}async withToken(n,T){const k=A(n);this.inProgress.add(k);const b=await T(k.token);return this.inProgress.delete(k),b}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=D;function A(C){const n=new _.CancellationTokenSource;return C.onCancellationRequested(()=>n.cancel()),n}}),define(ge[273],pe([0,1,26,128,127]),function(Y,e,_,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(C){this.query=C}search(C,n,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(h){T({message:h})}},b=new R.NativeTextSearchManager(this.query,new y.RipgrepTextSearchEngine(k),_);return new Promise((h,c)=>b.search(m=>{n(m.map(D))},C).then(m=>h({limitHit:m.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=P;function D(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((C,n)=>{if(n.ranges){const T=n;return C+(Array.isArray(T.ranges)?T.ranges.length:1)}else return C+1},0)}}}),define(ge[274],pe([0,1,37,287,12,17,16,3,96,7,46,2,44,32,271,273]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,y.gracefulify(_);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const o=d(t),s=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(r=>this.doFileSearchWithEngine(c.Engine,o,l=>s.fire(l),r)),i.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return s.event}textSearch(t){let i;const o=d(t),s=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(r=>this.ripgrepTextSearch(o,l=>s.fire(l),r)),i.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return s.event}ripgrepTextSearch(t,i,o){return t.maxFileSize=(0,b.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new m.TextSearchEngineAdapter(t).search(o,i,i)}doFileSearch(t,i,o){return this.doFileSearchWithEngine(c.Engine,t,i,o)}doFileSearchWithEngine(t,i,o,s,r=E.BATCH_SIZE){let l=0;const p=f=>{Array.isArray(f)?(l+=f.length,o(f.map(v=>this.rawMatchToSearchItem(v)))):f.relativePath?(l++,o(this.rawMatchToSearchItem(f))):o(f)};if(i.sortByScore){let f=this.trySortedSearchFromCache(i,p,s);if(!f){const v=i.maxResults?Object.assign({},i,{maxResults:null}):i,I=new t(v);f=this.doSortedSearch(I,i,o,p,s)}return new Promise((v,I)=>{f.then(([L,x])=>{const Z=x.map(z=>this.rawMatchToSearchItem(z));this.sendProgress(Z,o,r),v(L)},I)})}const S=new t(i);return this.doSearch(S,p,r,s).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:"searchProcess",fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,o,s,r){const l=new A.Emitter;let p=(0,P.createCancelablePromise)(f=>{let v=[];const I=L=>{Array.isArray(L)?v=L:(s(L),l.fire(L))};return this.doSearch(t,I,-1,f).then(L=>[L,v])}),S;if(i.cacheKey){S=this.getOrCreateCache(i.cacheKey);const f={promise:p,event:l.event,resolved:!1};S.resultsToSearchCache[i.filePattern||""]=f,p.then(()=>{f.resolved=!0},v=>{delete S.resultsToSearchCache[i.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([f,v])=>{const I=S?S.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(i,v,I,r).then(x=>{const Z=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:Z,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:x.length},limitHit:f.limitHit||typeof i.maxResults=="number"&&v.length>i.maxResults},x]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new g)}trySortedSearchFromCache(t,i,o){const s=t.cacheKey&&this.caches[t.cacheKey];if(!!s){const r=this.getResultsFromCache(s,t.filePattern||"",i,o);if(r)return r.then(([l,p,S])=>{const f=T.StopWatch.create(!1);return this.sortResults(t,p,s.scorerCache,o).then(v=>{const I=f.elapsed(),L={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:p.length,sortingTime:I};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:L},v]})})}}sortResults(t,i,o,s){const r=(0,C.prepareQuery)(t.filePattern||""),l=(S,f)=>(0,C.compareItemsByFuzzyScore)(S,f,r,!0,w,o),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(i,l,p,1e4,s)}sendProgress(t,i,o){if(o&&o>0)for(let s=0;s<t.length;s+=o)i(t.slice(s,s+o));else i(t)}getResultsFromCache(t,i,o,s){const r=T.StopWatch.create(!1),l=i.indexOf(n.sep)>=0;let p;for(const I in t.resultsToSearchCache)if(i.startsWith(I)){if(l&&I.indexOf(n.sep)<0&&I!=="")continue;const L=t.resultsToSearchCache[I];p={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!p)return null;const S=r.elapsed(),f=T.StopWatch.create(!1),v=p.event(o);return s&&s.onCancellationRequested(()=>{v.dispose()}),p.promise.then(([I,L])=>{if(s&&s.isCancellationRequested)throw(0,D.canceled)();const x=[],Z=(0,C.prepareQuery)(i).normalizedLowercase;for(const z of L)!(0,h.isFilePatternMatch)(z,Z)||x.push(z);return[I,x,{cacheWasResolved:p.resolved,cacheLookupTime:S,cacheFilterTime:f.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,o,s){return new Promise((r,l)=>{let p=[];s&&s.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(o?(p.push(S),o>0&&p.length>=o&&(i(p),p=[])):i(S))},S=>{i(S)},(S,f)=>{p.length&&i(p),S?l(S):r(f)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,o){return t.then(i,o)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=E,E.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(a){return(0,n.basename)(a.relativePath)}getItemDescription(a){return(0,n.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function d(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(u),extraFileResources:a.extraFileResources&&a.extraFileResources.map(t=>k.URI.revive(t))})}function u(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(ge[275],pe([0,1,6,2,26,13,32,274,272,90,14,62,27,68,11,127]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends h.ExtHostSearch{constructor(w,d,u,a){super(w,u,a);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new C.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const w=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new C.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(c.Schemas.file,new A.SearchService)}registerInternalFileSearchProvider(w,d){const u=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(w)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(w,d,u,a){const t=(0,h.reviveQuery)(u);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,d,t,a):super.$provideFileSearchResults(w,d,u,a)}doInternalFileSearch(w,d,u,a){const t=i=>{if((0,D.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(w,d,i.map(o=>y.URI.file(o.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,a)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,d){return new m.NativeTextSearchManager(w,d)}};E=je([Ue(0,T.IExtHostRpcService),Ue(1,b.IExtHostInitDataService),Ue(2,k.IURITransformerService),Ue(3,P.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[129],pe([0,1,288,120,289,3,101,7,48,28,6,25,102,16,9]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(p){this.socket=p}dispose(){this.socket.destroy()}onData(p){const S=f=>p(k.VSBuffer.wrap(f));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer)}catch(S){if(S.code==="EPIPE")return;(0,h.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((p,S)=>{if(this.socket.bufferSize===0){p();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),p()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=m;var E;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var g;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(g||(g={}));class w extends T.Disposable{constructor(p,S,f,v){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=v,S?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",I=>{console.error(I),(0,h.onUnexpectedError)(I),this._onClose.fire()}),this._zlibInflate.on("data",I=>{this._pendingInflateData.push(I)}),f&&(this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",I=>{console.error(I),(0,h.onUnexpectedError)(I),this._onClose.fire()}),this._zlibDeflate.on("data",I=>{this._pendingDeflateData.push(I)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(I=>this._acceptChunk(I))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(k.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,S){let f=2;p.byteLength<126?f+=0:p.byteLength<2**16?f+=2:f+=8;const v=k.VSBuffer.alloc(f);if(S?v.writeUInt8(194,0):v.writeUInt8(130,0),p.byteLength<126)v.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){v.writeUInt8(126,1);let I=1;v.writeUInt8(p.byteLength>>>8&255,++I),v.writeUInt8(p.byteLength>>>0&255,++I)}else{v.writeUInt8(127,1);let I=1;v.writeUInt8(0,++I),v.writeUInt8(0,++I),v.writeUInt8(0,++I),v.writeUInt8(0,++I),v.writeUInt8(p.byteLength>>>24&255,++I),v.writeUInt8(p.byteLength>>>16&255,++I),v.writeUInt8(p.byteLength>>>8&255,++I),v.writeUInt8(p.byteLength>>>0&255,++I)}this._totalOutgoingWireBytes+=v.byteLength+p.byteLength,this.socket.write(k.VSBuffer.concat([v,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),v=(S.readUInt8(0)&128)>>>7,I=S.readUInt8(1),L=(I&128)>>>7,x=I&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),f=S.readUInt8(1),v=(f&128)>>>7;let I=f&127,L=1;I===126?I=S.readUInt8(++L)*2**8+S.readUInt8(++L):I===127&&(I=S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L));let x=0;v&&(x=S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L)),this._state.state=3,this._state.readLen=I,this._state.mask=x}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);d(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const f=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=f.length,this._onData.fire(k.VSBuffer.wrap(f))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function d(l,p){if(p!==0){let S=l.byteLength>>>2;for(let Z=0;Z<S;Z++){const z=l.readUInt32BE(Z*4);l.writeUInt32BE(z^p,Z*4)}let f=S*4,v=l.byteLength-f;const I=p>>>24&255,L=p>>>16&255,x=p>>>8&255;v>=1&&l.writeUInt8(l.readUInt8(f)^I,f),v>=2&&l.writeUInt8(l.readUInt8(f+1)^L,f+1),v>=3&&l.writeUInt8(l.readUInt8(f+2)^x,f+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function a(){const l=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):p=(0,A.join)((0,C.tmpdir)(),`vscode-ipc-${l}.sock`),i(p),p}e.createRandomIPCHandle=a;function t(l,p,S){const f=(0,_.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${S}-${p}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${S}-${p}.sock`):v=(0,A.join)(l,`${S}-${p}.sock`),i(v),v}e.createStaticIPCHandle=t;function i(l){const p=u[c.platform];typeof p=="number"&&l.length>=p&&console.warn(`WARNING: IPC handle "${l}" is longer than ${p} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{constructor(p){super(o.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const S=P.Event.fromNodeEventEmitter(p,"connection");return P.Event.map(S,f=>({protocol:new b.Protocol(new m(f)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function s(l){return new Promise((p,S)=>{const f=(0,y.createServer)();f.on("error",S),f.listen(l,()=>{f.removeListener("error",S),p(new o(f))})})}e.serve=s;function r(l,p){return new Promise((S,f)=>{const v=(0,y.createConnection)(l,()=>{v.removeListener("error",f),S(b.Client.fromSocket(new m(v),p))});v.once("error",f)})}e.connect=r}),define(ge[276],pe([0,1,129,268,37,51,2,115,13]),function(Y,e,_,y,R,P,D,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(b,h,c){this._commands=b,this.logService=h,this._ipcHandlePath=c,this._server=y.createServer((m,E)=>this.onRequest(m,E)),this.setup().catch(m=>(h.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch(b){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,h){const c=[];b.setEncoding("utf8"),b.on("data",m=>c.push(m)),b.on("end",()=>{const m=JSON.parse(c.join(""));switch(m.type){case"open":this.open(m,h);break;case"openExternal":this.openExternal(m,h);break;case"status":this.getStatus(m,h);break;case"command":this.runCommand(m,h).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(m,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${m.type}`,E=>{E&&this.logService.error(E)}),h.end();break}})}open(b,h){let{fileURIs:c,folderURIs:m,forceNewWindow:E,diffMode:g,addMode:w,forceReuseWindow:d,gotoLineMode:u,waitMarkerFilePath:a}=b;const t=[];if(Array.isArray(m))for(const i of m)try{t.push({folderUri:D.URI.parse(i)})}catch(o){}if(Array.isArray(c))for(const i of c)try{(0,A.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:D.URI.parse(i)}):t.push({fileUri:D.URI.parse(i)})}catch(o){}if(t.length){const i=a?D.URI.file(a):void 0,s={forceNewWindow:E,diffMode:g,addMode:w,gotoLineMode:u,forceReuseWindow:d,preferNewWindow:!d&&!i&&!w,waitMarkerFileURI:i};this._commands.executeCommand("_files.windowOpen",t,s)}h.writeHead(200),h.end()}async openExternal(b,h){for(const c of b.uris){const m=D.URI.parse(c),E=m.scheme==="file"?m:c;await this._commands.executeCommand("_remoteCLI.openExternal",E)}h.writeHead(200),h.end()}async manageExtensions(b,h){console.log("server: manageExtensions");try{const c=g=>g==null?void 0:g.map(w=>/\.vsix$/i.test(w)?D.URI.parse(w):w),m={list:b.list,install:c(b.install),uninstall:c(b.uninstall),force:b.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",m,{allowTunneling:!0});h.writeHead(200),h.write(E)}catch(c){h.writeHead(500),h.write(String(c))}h.end()}async getStatus(b,h){try{const c=await this._commands.executeCommand("_issues.getSystemStatus");h.writeHead(200),h.write(c),h.end()}catch(c){h.writeHead(500),h.write(String(c),m=>{m&&this.logService.error(m)}),h.end()}}async runCommand(b,h){try{const{command:c,args:m}=b,E=await this._commands.executeCommand(c,...m);h.writeHead(200),h.write(JSON.stringify(E),g=>{g&&this.logService.error(g)}),h.end()}catch(c){h.writeHead(500),h.write(String(c),m=>{m&&this.logService.error(m)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let T=class extends n{constructor(b,h){super(b,h,(0,_.createRandomIPCHandle)())}};T=je([Ue(0,P.IExtHostCommands),Ue(1,C.ILogService)],T),e.CLIServer=T}),define(ge[277],pe([0,1,67,264,258,5,267,42,249,2,11,8,276,99]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends R.RequireInterceptor{_installInterceptor(){const g=this,w=Y.__$__nodeRequire("module"),d=w._load;w._load=function(a,t,i){for(let o of g._alternatives){let s=o(a);if(s){a=s;break}}return g._factories.has(a)?g._factories.get(a).load(a,n.URI.file((0,h.realpathSync)(t.filename)),o=>d.apply(this,[o,t,i])):d.apply(this,arguments)}}}class m extends A.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const g=this._instaService.invokeFunction(y.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(b.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,g,this._registry).install(),_.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const u=process.send,a=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(a.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,w,d){if(w.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let u=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{g&&_.mark(`code/extHost/willLoadExtensionCode/${g.value}`),u=Y.__$__nodeRequire(w.fsPath)}catch(a){return Promise.reject(a)}finally{g&&_.mark(`code/extHost/didLoadExtensionCode/${g.value}`),d.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const w in g){const d=g[w];d===null?delete process.env[w]:process.env[w]=d}}}e.ExtHostExtensionService=m}),define(ge[278],pe([0,1,78,250,261,260,259,275,277,222,251,45,42,64,68,66,35,50,13]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m,E,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(b.IExtHostExtensionService,C.ExtHostExtensionService),(0,_.registerSingleton)(w.ILogService,n.ExtHostLogService),(0,_.registerSingleton)(k.IExtHostDebugService,D.ExtHostDebugService),(0,_.registerSingleton)(h.IExtHostOutputService,y.ExtHostOutputService2),(0,_.registerSingleton)(c.IExtHostSearch,A.NativeExtHostSearch),(0,_.registerSingleton)(m.IExtHostTask,P.ExtHostTask),(0,_.registerSingleton)(E.IExtHostTerminalService,R.ExtHostTerminalService),(0,_.registerSingleton)(g.IExtHostTunnelService,T.ExtHostTunnelService)}),define(ge[279],pe([0,1,120,290,67,16,102,129,183,220,262,25,97,26,99,17,265,278]),function(Y,e,_,y,R,P,D,A,C,n,T,k,b,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const E=y(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=Y.__$__nodeRequire("module"),s=o._load;o._load=function(r){if(r==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const g=process.exit.bind(process);function w(o){process.exit=function(s){if(o)g(s);else{const r=new Error("An extension called process.exit() and this was prevented.");console.warn(r.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let d=function(o){g()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,s)=>{let r=null,l=setTimeout(()=>{s(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,S=3e5,f=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),p),v=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),S);process.on("message",(L,x)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const Z=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let z;if(L.skipWebSocketFrames)z=new A.NodeSocket(x);else{const B=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));z=new A.WebSocketNodeSocket(new A.NodeSocket(x),L.permessageDeflate,B,!1)}r?(f.cancel(),v.cancel(),r.beginAcceptReconnection(z,Z),r.endAcceptReconnection()):(clearTimeout(l),r=new D.PersistentProtocol(z,Z),r.onDidDispose(()=>d("renderer disconnected")),o(r),r.onSocketClose(()=>{f.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;f.isScheduled()&&v.schedule()}});const I={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(I)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,r)=>{const l=_.createConnection(o,()=>{l.removeListener("error",r),s(new D.PersistentProtocol(new A.NodeSocket(l)))});l.once("error",r)})}}async function a(){const o=await u();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(s=>{(0,n.isMessageOfType)(s,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||o.send(s)}drain(){return o.drain()}}}function t(o){return new Promise(s=>{const r=o.onMessage(l=>{r.dispose();const p=JSON.parse(l.toString()),S=p.commit,f=C.default.commit;S&&f&&S!==f&&g(55);const v=[];process.on("unhandledRejection",(x,Z)=>{v.push(Z),setTimeout(()=>{const z=v.indexOf(Z);z>=0&&Z.catch(B=>{v.splice(z,1),console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),(0,P.onUnexpectedError)(x)})},1e3)}),process.on("rejectionHandled",x=>{const Z=v.indexOf(x);Z>=0&&v.splice(Z,1)}),process.on("uncaughtException",function(x){(0,P.onUnexpectedError)(x)});let I=0;setInterval(function(){try{process.kill(p.parentPid,0),I=0}catch(x){x&&x.code==="EPERM"?(I++,I>=3&&d(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):d(`parent process ${p.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let L;try{L=Y.__$__nodeRequire("native-watchdog"),L.start(p.parentPid)}catch(x){(0,P.onUnexpectedError)(x)}o.send((0,n.createMessageOfType)(0)),s({protocol:o,initData:p})});o.send((0,n.createMessageOfType)(1))})}async function i(){R.mark("code/extHost/willConnectToRenderer");const o=await a();R.mark("code/extHost/didConnectToRenderer");const s=await t(o);R.mark("code/extHost/didWaitForInitData");const{initData:r}=s;w(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const l=new class{exit(v){g(v)}exists(v){return(0,h.exists)(v)}realpath(v){return(0,c.realpath)(v)}};let p=null;if(r.remote.authority&&E.uriTransformerPath)try{const v=Y.__$__nodeRequire(E.uriTransformerPath)(r.remote.authority);p=new b.URITransformer(v)}catch(f){console.error(f)}const S=new T.ExtensionHostMain(s.protocol,r,l,p);d=f=>S.terminate(f)}e.startExtensionHostProcess=i}),define(ge[291],pe([0,1,279]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4b1e9ac57ab3cc942ab9bff09967bf3238a7910/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
