/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/process","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(oe){for(var e=[],b=0,S=oe.length;b<S;b++)e[b]=we[oe[b]];return e};define(we[43],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(S,T){if(!S)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=b}),define(we[51],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function S(A){const C=[];for(let _ in A)b.call(A,_)&&C.push(A[_]);return C}e.values=S;function T(A,C){for(let _ in A)if(b.call(A,_)&&C({key:_,value:A[_]},function(){delete A[_]})===!1)return}e.forEach=T;function P(A,C){const _=Object.create(null);for(const f of A){const s=C(f);let h=_[s];h||(h=_[s]=[]),h.push(f)}return _}e.groupBy=P;function y(A){const C=Object.create(null);return A&&A.forEach((_,f)=>{C[f]=_}),C}e.fromMap=y;function k(A,C){const _=[],f=[];for(let s of A)C.has(s)||_.push(s);for(let s of C)A.has(s)||f.push(s);return{removed:_,added:f}}e.diffSets=k;function E(A,C){const _=[],f=[];for(let[s,h]of A)C.has(s)||_.push(h);for(let[s,h]of C)A.has(s)||f.push(h);return{removed:_,added:f}}e.diffMaps=E;class n{constructor(){this.map=new Map}add(C,_){let f=this.map.get(C);f||(f=new Set,this.map.set(C,f)),f.add(_)}delete(C,_){const f=this.map.get(C);!f||(f.delete(_),f.size===0&&this.map.delete(C))}forEach(C,_){const f=this.map.get(C);!f||f.forEach(_)}}e.SetMap=n}),define(we[44],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(E){return(n,A,C)=>{let _=null,f=null;if(typeof C.value=="function"?(_="value",f=C.value):typeof C.get=="function"&&(_="get",f=C.get),!f)throw new Error("not supported");C[_]=E(f,A)}}e.createDecorator=b;let S=0;function T(){const E=`$memoize${S++}`;let n;const A=function(_,f,s){let h=null,p=null;if(typeof s.value=="function"?(h="value",p=s.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(h="get",p=s.get),!p)throw new Error("not supported");const m=`${E}:${f}`;s[h]=function(...v){return n=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,v)}),this[m]}};return A.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(E)===0&&delete n[C]})},A}e.createMemoizer=T;function P(E,n,A){return T()(E,n,A)}e.memoize=P;function y(E,n,A){return b((C,_)=>{const f=`$debounce$${_}`,s=`$debounce$result$${_}`;return function(...h){this[s]||(this[s]=A?A():void 0),clearTimeout(this[f]),n&&(this[s]=n(this[s],...h),h=[this[s]]),this[f]=setTimeout(()=>{C.apply(this,h),this[s]=A?A():void 0},E)}})}e.debounce=y;function k(E,n,A){return b((C,_)=>{const f=`$throttle$timer$${_}`,s=`$throttle$result$${_}`,h=`$throttle$lastRun$${_}`,p=`$throttle$pending$${_}`;return function(...m){if(this[s]||(this[s]=A?A():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...m)),!this[p]){const v=this[h]+E;v<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[s]]),this[s]=A?A():void 0):(this[p]=!0,this[f]=setTimeout(()=>{this[p]=!1,this[h]=Date.now(),C.apply(this,[this[s]]),this[s]=A?A():void 0},v-Date.now()))}}})}e.throttle=k}),define(we[10],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function S(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=S;function T(o){E(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=T;function P(o){E(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=P;function y(o){if(o instanceof Error){let{name:t,message:r}=o;const l=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:l}}return o}e.transformErrorForSerialization=y;const k="Canceled";function E(o){return o instanceof Error&&o.name===k&&o.message===k}e.isPromiseCanceledError=E;class n extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=n;function A(){const o=new Error(k);return o.name=o.message,o}e.canceled=A;function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=C;function _(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=_;function f(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function s(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=h;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function d(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function c(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=c}),define(we[15],Ee([0,1,10]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function S(L,$=0){return L[L.length-(1+$)]}e.tail=S;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function P(L,$,U=(G,N)=>G===N){if(L===$)return!0;if(!L||!$||L.length!==$.length)return!1;for(let G=0,N=L.length;G<N;G++)if(!U(L[G],$[G]))return!1;return!0}e.equals=P;function y(L,$,U){let G=0,N=L.length-1;for(;G<=N;){const Z=(G+N)/2|0,ne=U(L[Z],$);if(ne<0)G=Z+1;else if(ne>0)N=Z-1;else return Z}return-(G+1)}e.binarySearch=y;function k(L,$){let U=0,G=L.length;if(G===0)return 0;for(;U<G;){const N=Math.floor((U+G)/2);$(L[N])?G=N:U=N+1}return U}e.findFirstInSorted=k;function E(L,$,U){if(L=L|0,L>=$.length)throw new TypeError("invalid index");let G=$[Math.floor($.length*Math.random())],N=[],Z=[],ne=[];for(let re of $){const ye=U(re,G);ye<0?N.push(re):ye>0?Z.push(re):ne.push(re)}return L<N.length?E(L,N,U):L<N.length+ne.length?ne[0]:E(L-(N.length+ne.length),Z,U)}e.quickSelect=E;function n(L,$){const U=[];let G;for(const N of L.slice(0).sort($))!G||$(G[0],N)!==0?(G=[N],U.push(G)):G.push(N);return U}e.groupBy=n;function A(L,$,U){const G=[];function N(re,ye,Ae){if(!(ye===0&&Ae.length===0)){const Be=G[G.length-1];Be&&Be.start+Be.deleteCount===re?(Be.deleteCount+=ye,Be.toInsert.push(...Ae)):G.push({start:re,deleteCount:ye,toInsert:Ae})}}let Z=0,ne=0;for(;;){if(Z===L.length){N(Z,0,$.slice(ne));break}if(ne===$.length){N(Z,L.length-Z,[]);break}const re=L[Z],ye=$[ne],Ae=U(re,ye);Ae===0?(Z+=1,ne+=1):Ae<0?(N(Z,1,[]),Z+=1):Ae>0&&(N(Z,0,[ye]),ne+=1)}return G}e.sortedDiff=A;function C(L,$,U){const G=A(L,$,U),N=[],Z=[];for(const ne of G)N.push(...L.slice(ne.start,ne.start+ne.deleteCount)),Z.push(...ne.toInsert);return{removed:N,added:Z}}e.delta=C;function _(L,$,U){if(U===0)return[];const G=L.slice(0,U).sort($);return s(L,$,G,U,L.length),G}e.top=_;function f(L,$,U,G,N){return U===0?Promise.resolve([]):new Promise((Z,ne)=>{(async()=>{const re=L.length,ye=L.slice(0,U).sort($);for(let Ae=U,Be=Math.min(U+G,re);Ae<re;Ae=Be,Be=Math.min(Be+G,re)){if(Ae>U&&await new Promise(Re=>setTimeout(Re)),N&&N.isCancellationRequested)throw(0,b.canceled)();s(L,$,ye,Ae,Be)}return ye})().then(Z,ne)})}e.topAsync=f;function s(L,$,U,G,N){for(const Z=U.length;G<N;G++){const ne=L[G];if($(ne,U[Z-1])<0){U.pop();const re=k(U,ye=>$(ne,ye)<0);U.splice(re,0,ne)}}}function h(L){return L.filter($=>!!$)}e.coalesce=h;function p(L){let $=0;for(let U=0;U<L.length;U++)L[U]&&(L[$]=L[U],$+=1);L.length=$}e.coalesceInPlace=p;function m(L,$,U){L.splice(U,0,L.splice($,1)[0])}e.move=m;function v(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=v;function d(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=d;function c(L,$){if(!$)return L.filter((G,N)=>L.indexOf(G)===N);const U=Object.create(null);return L.filter(G=>{const N=$(G);return U[N]?!1:(U[N]=!0,!0)})}e.distinct=c;function o(L){const $=new Set;return L.filter(U=>$.has(U)?!1:($.add(U),!0))}e.distinctES6=o;function t(L){const $=Object.create(null);return U=>{const G=L(U);return $[G]?!1:($[G]=!0,!0)}}e.uniqueFilter=t;function r(L,$){for(let U=L.length-1;U>=0;U--){const G=L[U];if($(G))return U}return-1}e.lastIndex=r;function l(L,$){return L.length>0?L[0]:$}e.firstOrDefault=l;function a(L,$,U=(G,N)=>G===N){let G=0;for(let N=0,Z=Math.min(L.length,$.length);N<Z&&U(L[N],$[N]);N++)G++;return G}e.commonPrefixLength=a;function i(L){return[].concat(...L)}e.flatten=i;function u(L,$){let U=typeof $=="number"?L:0;typeof $=="number"?U=L:(U=0,$=L);const G=[];if(U<=$)for(let N=U;N<$;N++)G.push(N);else for(let N=U;N>$;N--)G.push(N);return G}e.range=u;function D(L,$,U){return L.reduce((G,N)=>(G[$(N)]=U?U(N):N,G),Object.create(null))}e.index=D;function R(L,$){return L.push($),()=>g(L,$)}e.insert=R;function g(L,$){const U=L.indexOf($);if(U>-1)return L.splice(U,1),$}e.remove=g;function w(L,$,U){const G=L.slice(0,$),N=L.slice($);return G.concat(U,N)}e.arrayInsert=w;function I(L,$){let U;if(typeof $=="number"){let G=$;U=()=>{const N=Math.sin(G++)*179426549;return N-Math.floor(N)}}else U=Math.random;for(let G=L.length-1;G>0;G-=1){const N=Math.floor(U()*(G+1)),Z=L[G];L[G]=L[N],L[N]=Z}}e.shuffle=I;function F(L,$){const U=L.indexOf($);U>-1&&(L.splice(U,1),L.unshift($))}e.pushToStart=F;function B(L,$){const U=L.indexOf($);U>-1&&(L.splice(U,1),L.push($))}e.pushToEnd=B;function le(L,$){return Array.isArray(L)?L.map($):$(L)}e.mapArrayOrNot=le;function H(L){return Array.isArray(L)?L:[L]}e.asArray=H;function z(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=z;function K(L,$){for(const U of L){const G=$(U);if(G!==void 0)return G}}e.mapFind=K}),define(we[52],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(S){const T=this;let P=!1,y;return function(){return P||(P=!0,y=S.apply(T,arguments)),y}}e.once=b}),define(we[53],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(we[54],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(S){function T(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}S.is=T;const P=Object.freeze([]);function y(){return P}S.empty=y;function*k(o){yield o}S.single=k;function E(o){return o||P}S.from=E;function n(o){return!o||o[Symbol.iterator]().next().done===!0}S.isEmpty=n;function A(o){return o[Symbol.iterator]().next().value}S.first=A;function C(o,t){for(const r of o)if(t(r))return!0;return!1}S.some=C;function _(o,t){for(const r of o)if(t(r))return r}S.find=_;function*f(o,t){for(const r of o)t(r)&&(yield r)}S.filter=f;function*s(o,t){for(const r of o)yield t(r)}S.map=s;function*h(...o){for(const t of o)for(const r of t)yield r}S.concat=h;function*p(o){for(const t of o)for(const r of t)yield r}S.concatNested=p;function m(o,t,r){let l=r;for(const a of o)l=t(l,a);return l}S.reduce=m;function*v(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}S.slice=v;function d(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const l=o[Symbol.iterator]();for(let a=0;a<t;a++){const i=l.next();if(i.done)return[r,S.empty()];r.push(i.value)}return[r,{[Symbol.iterator](){return l}}]}S.consume=d;function c(o,t,r=(l,a)=>l===a){const l=o[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const i=l.next(),u=a.next();if(i.done!==u.done)return!1;if(i.done)return!0;if(!r(i.value,u.value))return!1}}S.equals=c})(b=e.Iterable||(e.Iterable={}))}),define(we[45],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(t,r=!1){let l=0,a=t.length,i="",u=0,D=16,R=0;function g(z){let K=0,L=0;for(;K<z;){const $=t.charCodeAt(l);if($>=48&&$<=57)L=L*16+$-48;else if($>=65&&$<=70)L=L*16+$-65+10;else if($>=97&&$<=102)L=L*16+$-97+10;else break;l++,K++}return K<z&&(L=-1),L}function w(z){l=z,i="",u=0,D=16,R=0}function I(){const z=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&n(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&n(t.charCodeAt(l)))for(l++;l<t.length&&n(t.charCodeAt(l));)l++;else return R=3,t.substring(z,l);let K=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&n(t.charCodeAt(l))){for(l++;l<t.length&&n(t.charCodeAt(l));)l++;K=l}else R=3;return t.substring(z,K)}function F(){let z="",K=l;for(;;){if(l>=a){z+=t.substring(K,l),R=2;break}const L=t.charCodeAt(l);if(L===34){z+=t.substring(K,l),l++;break}if(L===92){if(z+=t.substring(K,l),l++,l>=a){R=2;break}switch(t.charCodeAt(l++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const U=g(4);U>=0?z+=String.fromCharCode(U):R=4;break;default:R=5}K=l;continue}if(L>=0&&L<=31)if(E(L)){z+=t.substring(K,l),R=2;break}else R=6;l++}return z}function B(){if(i="",R=0,u=l,l>=a)return u=a,D=17;let z=t.charCodeAt(l);if(k(z)){do l++,i+=String.fromCharCode(z),z=t.charCodeAt(l);while(k(z));return D=15}if(E(z))return l++,i+=String.fromCharCode(z),z===13&&t.charCodeAt(l)===10&&(l++,i+=`
`),D=14;switch(z){case 123:return l++,D=1;case 125:return l++,D=2;case 91:return l++,D=3;case 93:return l++,D=4;case 58:return l++,D=6;case 44:return l++,D=5;case 34:return l++,i=F(),D=10;case 47:const K=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<a&&!E(t.charCodeAt(l));)l++;return i=t.substring(K,l),D=12}if(t.charCodeAt(l+1)===42){l+=2;const L=a-1;let $=!1;for(;l<L;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,$=!0;break}l++}return $||(l++,R=1),i=t.substring(K,l),D=13}return i+=String.fromCharCode(z),l++,D=16;case 45:if(i+=String.fromCharCode(z),l++,l===a||!n(t.charCodeAt(l)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=I(),D=11;default:for(;l<a&&le(z);)l++,z=t.charCodeAt(l);if(u!==l){switch(i=t.substring(u,l),i){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return i+=String.fromCharCode(z),l++,D=16}}function le(z){if(k(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:w,getPosition:()=>l,scan:r?H:B,getToken:()=>D,getTokenValue:()=>i,getTokenOffset:()=>u,getTokenLength:()=>l-u,getTokenError:()=>R}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,r){const l=[],a=new Object;let i;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function R(g,w,I,F){u.value=g,u.offset=w,u.length=I,u.type=F,u.colonOffset=void 0,i=u}try{d(t,{onObjectBegin:(g,w)=>{if(r<=g)throw a;i=void 0,D=r>g,l.push("")},onObjectProperty:(g,w,I)=>{if(r<w||(R(g,w,I,"property"),l[l.length-1]=g,r<=w+I))throw a},onObjectEnd:(g,w)=>{if(r<=g)throw a;i=void 0,l.pop()},onArrayBegin:(g,w)=>{if(r<=g)throw a;i=void 0,l.push(0)},onArrayEnd:(g,w)=>{if(r<=g)throw a;i=void 0,l.pop()},onLiteralValue:(g,w,I)=>{if(r<w||(R(g,w,I,o(g)),r<=w+I))throw a},onSeparator:(g,w,I)=>{if(r<=w)throw a;if(g===":"&&i&&i.type==="property")i.colonOffset=w,D=!1,i=void 0;else if(g===","){const F=l[l.length-1];typeof F=="number"?l[l.length-1]=F+1:(D=!0,l[l.length-1]=""),i=void 0}}})}catch(g){if(g!==a)throw g}return{path:l,previousNode:i,isAtPropertyKey:D,matches:g=>{let w=0;for(let I=0;w<g.length&&I<l.length;I++)if(g[w]===l[I]||g[w]==="*")w++;else if(g[w]!=="**")return!1;return w===g.length}}}e.getLocation=C;function _(t,r=[],l=P.DEFAULT){let a=null,i=[];const u=[];function D(g){Array.isArray(i)?i.push(g):a!==null&&(i[a]=g)}return d(t,{onObjectBegin:()=>{const g={};D(g),u.push(i),i=g,a=null},onObjectProperty:g=>{a=g},onObjectEnd:()=>{i=u.pop()},onArrayBegin:()=>{const g=[];D(g),u.push(i),i=g,a=null},onArrayEnd:()=>{i=u.pop()},onLiteralValue:D,onError:(g,w,I)=>{r.push({error:g,offset:w,length:I})}},l),i[0]}e.parse=_;function f(t,r=[],l=P.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(g){a.type==="property"&&(a.length=g-a.offset,a=a.parent)}function u(g){return a.children.push(g),g}d(t,{onObjectBegin:g=>{a=u({type:"object",offset:g,length:-1,parent:a,children:[]})},onObjectProperty:(g,w,I)=>{a=u({type:"property",offset:w,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:g,offset:w,length:I,parent:a})},onObjectEnd:(g,w)=>{a.length=g+w-a.offset,a=a.parent,i(g+w)},onArrayBegin:(g,w)=>{a=u({type:"array",offset:g,length:-1,parent:a,children:[]})},onArrayEnd:(g,w)=>{a.length=g+w-a.offset,a=a.parent,i(g+w)},onLiteralValue:(g,w,I)=>{u({type:o(g),offset:w,length:I,parent:a,value:g}),i(w+I)},onSeparator:(g,w,I)=>{a.type==="property"&&(g===":"?a.colonOffset=w:g===","&&i(w))},onError:(g,w,I)=>{r.push({error:g,offset:w,length:I})}},l);const R=a.children[0];return R&&delete R.parent,R}e.parseTree=f;function s(t,r){if(!!t){let l=t;for(let a of r)if(typeof a=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let i=!1;for(const u of l.children)if(Array.isArray(u.children)&&u.children[0].value===a){l=u.children[1],i=!0;break}if(!i)return}else{const i=a;if(l.type!=="array"||i<0||!Array.isArray(l.children)||i>=l.children.length)return;l=l.children[i]}return l}}e.findNodeAtLocation=s;function h(t){if(!t.parent||!t.parent.children)return[];const r=h(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;r.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&r.push(l)}return r}e.getNodePath=h;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let l of t.children){const a=l.children[1];a&&(r[l.children[0].value]=p(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,r,l=!1){return r>=t.offset&&r<t.offset+t.length||l&&r===t.offset+t.length}e.contains=m;function v(t,r,l=!1){if(m(t,r,l)){const a=t.children;if(Array.isArray(a))for(let i=0;i<a.length&&a[i].offset<=r;i++){const u=v(a[i],r,l);if(u)return u}return t}}e.findNodeAtOffset=v;function d(t,r,l=P.DEFAULT){const a=y(t,!1);function i(ye){return ye?()=>ye(a.getTokenOffset(),a.getTokenLength()):()=>!0}function u(ye){return ye?Ae=>ye(Ae,a.getTokenOffset(),a.getTokenLength()):()=>!0}const D=i(r.onObjectBegin),R=u(r.onObjectProperty),g=i(r.onObjectEnd),w=i(r.onArrayBegin),I=i(r.onArrayEnd),F=u(r.onLiteralValue),B=u(r.onSeparator),le=i(r.onComment),H=u(r.onError),z=l&&l.disallowComments,K=l&&l.allowTrailingComma;function L(){for(;;){const ye=a.scan();switch(a.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:z||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ye){case 12:case 13:z?$(10):le();break;case 16:$(1);break;case 15:case 14:break;default:return ye}}}function $(ye,Ae=[],Be=[]){if(H(ye),Ae.length+Be.length>0){let Re=a.getToken();for(;Re!==17;){if(Ae.indexOf(Re)!==-1){L();break}else if(Be.indexOf(Re)!==-1)break;Re=L()}}}function U(ye){const Ae=a.getTokenValue();return ye?F(Ae):R(Ae),L(),!0}function G(){switch(a.getToken()){case 11:let ye=0;try{ye=JSON.parse(a.getTokenValue()),typeof ye!="number"&&($(2),ye=0)}catch(Ae){$(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function N(){return a.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),a.getToken()===6?(B(":"),L(),re()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Z(){D(),L();let ye=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ye||$(4,[],[]),B(","),L(),a.getToken()===2&&K)break}else ye&&$(6,[],[]);N()||$(4,[],[2,5]),ye=!0}return g(),a.getToken()!==2?$(7,[2],[]):L(),!0}function ne(){w(),L();let ye=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ye||$(4,[],[]),B(","),L(),a.getToken()===4&&K)break}else ye&&$(6,[],[]);re()||$(4,[],[4,5]),ye=!0}return I(),a.getToken()!==4?$(8,[4],[]):L(),!0}function re(){switch(a.getToken()){case 3:return ne();case 1:return Z();case 10:return U(!0);default:return G()}}return L(),a.getToken()===17?l.allowEmptyContent?!0:($(4,[],[]),!1):re()?(a.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=d;function c(t,r){let l=y(t),a=[],i,u=0,D;do switch(D=l.getPosition(),i=l.scan(),i){case 12:case 13:case 17:u!==D&&a.push(t.substring(u,D)),r!==void 0&&a.push(l.getTokenValue().replace(/[^\r\n]/g,r)),u=l.getPosition();break}while(i!==17);return a.join("")}e.stripComments=c;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(we[103],Ee([0,1,45]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function S(E,n,A){let C,_,f,s,h;if(n){for(s=n.offset,h=s+n.length,f=s;f>0&&!k(E,f-1);)f--;let u=h;for(;u<E.length&&!k(E,u);)u++;_=E.substring(f,u),C=P(_,A)}else _=E,C=0,f=0,s=0,h=E.length;const p=y(A,E);let m=!1,v=0,d;A.insertSpaces?d=T(" ",A.tabSize||4):d="	";const c=(0,b.createScanner)(_,!1);let o=!1;function t(){return p+T(d,C+v)}function r(){let u=c.scan();for(m=!1;u===15||u===14;)m=m||u===14,u=c.scan();return o=u===16||c.getTokenError()!==0,u}const l=[];function a(u,D,R){!o&&D<h&&R>s&&E.substring(D,R)!==u&&l.push({offset:D,length:R-D,content:u})}let i=r();if(i!==17){const u=c.getTokenOffset()+f,D=T(d,C);a(D,f,u)}for(;i!==17;){let u=c.getTokenOffset()+c.getTokenLength()+f,D=r(),R="";for(;!m&&(D===12||D===13);){const w=c.getTokenOffset()+f;a(" ",u,w),u=c.getTokenOffset()+c.getTokenLength()+f,R=D===12?t():"",D=r()}if(D===2)i!==1&&(v--,R=t());else if(D===4)i!==3&&(v--,R=t());else{switch(i){case 3:case 1:v++,R=t();break;case 5:case 12:R=t();break;case 13:m?R=t():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(o=!0);break;case 16:o=!0;break}m&&(D===12||D===13)&&(R=t())}const g=c.getTokenOffset()+f;a(R,u,g),i=D}return l}e.format=S;function T(E,n){let A="";for(let C=0;C<n;C++)A+=E;return A}function P(E,n){let A=0,C=0;const _=n.tabSize||4;for(;A<E.length;){const f=E.charAt(A);if(f===" ")C++;else if(f==="	")C+=_;else break;A++}return Math.floor(C/_)}function y(E,n){for(let A=0;A<n.length;A++){const C=n.charAt(A);if(C==="\r")return A+1<n.length&&n.charAt(A+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=y;function k(E,n){return`\r
`.indexOf(E.charAt(n))!==-1}e.isEOL=k}),define(we[104],Ee([0,1,45,103]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,A,C){return P(n,A,void 0,C)}e.removeProperty=T;function P(n,A,C,_,f){const s=A.slice(),h=[],p=(0,b.parseTree)(n,h);let m,v;for(;s.length>0&&(v=s.pop(),m=(0,b.findNodeAtLocation)(p,s),m===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,b.findNodeAtLocation)(m,[v]);if(d!==void 0)if(C===void 0){if(!d.parent)throw new Error("Malformed AST");const c=m.children.indexOf(d.parent);let o,t=d.parent.offset+d.parent.length;if(c>0){const r=m.children[c-1];o=r.offset+r.length}else o=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(n,{offset:o,length:t-o,content:""},_)}else return y(n,{offset:d.offset,length:d.length,content:JSON.stringify(C)},_);else{if(C===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,o=f?f(m.children.map(r=>r.children[0].value)):m.children.length;let t;if(o>0){const r=m.children[o-1];t={offset:r.offset+r.length,length:0,content:","+c}}else m.children.length===0?t={offset:m.offset+1,length:0,content:c}:t={offset:m.offset+1,length:0,content:c+","};return y(n,t,_)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(C!==void 0){const d=`${JSON.stringify(C)}`;let c;if(m.children.length===0||v===0)c={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const o=v===-1||v>m.children.length?m.children.length:v,t=m.children[o-1];c={offset:t.offset+t.length,length:0,content:","+d}}return y(n,c,_)}else{const d=v,c=m.children[d];let o;if(m.children.length===1)o={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const t=m.children[d-1],r=t.offset+t.length,l=m.offset+m.length;o={offset:r,length:l-2-r,content:""}}else o={offset:c.offset,length:m.children[d+1].offset-c.offset,content:""};return y(n,o,_)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(n,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(C)},_)}}e.setProperty=P;function y(n,A,C){let _=k(n,A),f=A.offset,s=A.offset+A.content.length;if(A.length===0||A.content.length===0){for(;f>0&&!(0,S.isEOL)(_,f-1);)f--;for(;s<_.length&&!(0,S.isEOL)(_,s);)s++}const h=(0,S.format)(_,{offset:f,length:s-f},C);for(let m=h.length-1;m>=0;m--){const v=h[m];_=k(_,v),f=Math.min(f,v.offset),s=Math.max(s,v.offset+v.length),s+=v.content.length-v.length}const p=n.length-(_.length-s)-f;return[{offset:f,length:p,content:_.substring(f,s)}]}e.withFormatting=y;function k(n,A){return n.substring(0,A.offset)+A.content+n.substring(A.offset+A.length)}e.applyEdit=k;function E(n,A){let C=A.slice(0).sort((f,s)=>{const h=f.offset-s.offset;return h===0?f.length-s.length:h}),_=n.length;for(let f=C.length-1;f>=0;f--){let s=C[f];if(s.offset+s.length<=_)n=k(n,s);else throw new Error("Overlapping edit");_=s.offset}return n}e.applyEdits=E}),define(we[105],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new b(()=>T(this.getValue()))}}e.Lazy=b}),define(we[6],Ee([0,1,52,54]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function y(d){P=d}if(e.setDisposableTracker=y,T){const d="__is_disposable_tracked__";P=new class{trackDisposable(c){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[d]||console.log(o)},3e3)}markTracked(c){if(c&&c!==h.None)try{c[d]=!0}catch(o){}}}}function k(d){!P||P.markTracked(d)}function E(d){return P&&P.trackDisposable(d),d}e.trackDisposable=E;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function A(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=A;function C(d){if(S.Iterable.is(d)){let c=[];for(const o of d)if(o){k(o);try{o.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(d)?[]:d}else if(d)return k(d),d.dispose(),d}e.dispose=C;function _(...d){return d.forEach(k),f(()=>C(d))}e.combinedDisposable=_;function f(d){const c=E({dispose:()=>{k(c),d()}});return c}e.toDisposable=f;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return k(c),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new s,E(this)}dispose(){k(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var o;this._isDisposed||c===this._value||((o=this._value)===null||o===void 0||o.dispose(),c&&k(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,k(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(c,...o){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...o)},this.references.set(c,t));const{object:r}=t,l=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:r,dispose:l}}}e.ReferenceCollection=m;class v{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=v}),define(we[46],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(P){this.element=P,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class S{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const k=new b(P);if(this._first===b.Undefined)this._first=k,this._last=k;else if(y){const n=this._last;this._last=k,k.prev=n,n.next=k}else{const n=this._first;this._first=k,k.next=n,n.prev=k}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(k))}}shift(){if(this._first!==b.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==b.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==b.Undefined&&P.next!==b.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===b.Undefined&&P.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):P.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):P.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==b.Undefined;)yield P.element,P=P.next}}e.LinkedList=S}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(x,ie){for(var ce=0;ce<ie.length;ce++){var j=ie[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(x,j.key,j)}}function e(x,ie,ce){return ie&&oe(x.prototype,ie),ce&&oe(x,ce),x}function b(x,ie){if(!!x){if(typeof x=="string")return S(x,ie);var ce=Object.prototype.toString.call(x).slice(8,-1);if(ce==="Object"&&x.constructor&&(ce=x.constructor.name),ce==="Map"||ce==="Set")return Array.from(x);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return S(x,ie)}}function S(x,ie){(ie==null||ie>x.length)&&(ie=x.length);for(var ce=0,j=new Array(ie);ce<ie;ce++)j[ce]=x[ce];return j}function T(x,ie){var ce;if(typeof Symbol=="undefined"||x[Symbol.iterator]==null){if(Array.isArray(x)||(ce=b(x))||ie&&x&&typeof x.length=="number"){ce&&(x=ce);var j=0;return function(){return j>=x.length?{done:!0}:{done:!1,value:x[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=x[Symbol.iterator](),ce.next.bind(ce)}function P(x){var ie={exports:{}};return x(ie,ie.exports),ie.exports}var y=P(function(x){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){x.exports.defaults=j}x.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),k=/[&<>"']/,E=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(ie){return C[ie]};function f(x,ie){if(ie){if(k.test(x))return x.replace(E,_)}else if(n.test(x))return x.replace(A,_);return x}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(x){return x.replace(s,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(x,ie){x=x.source||x,ie=ie||"";var ce={replace:function(Y,se){return se=se.source||se,se=se.replace(p,"$1"),x=x.replace(Y,se),ce},getRegex:function(){return new RegExp(x,ie)}};return ce}var v=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(x,ie,ce){if(x){var j;try{j=decodeURIComponent(h(ce)).replace(v,"").toLowerCase()}catch(Y){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!d.test(ce)&&(ce=a(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(Y){return null}return ce}var o={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(x,ie){o[" "+x]||(t.test(x)?o[" "+x]=x+"/":o[" "+x]=R(x,"/",!0)),x=o[" "+x];var ce=x.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:x.replace(r,"$1")+ie:ie.charAt(0)==="/"?ce?ie:x.replace(l,"$1")+ie:x+ie}var i={exec:function(){}};function u(x){for(var ie=1,ce,j;ie<arguments.length;ie++){ce=arguments[ie];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(x[j]=ce[j])}return x}function D(x,ie){var ce=x.replace(/\|/g,function(se,fe,ve){for(var $e=!1,Ne=fe;--Ne>=0&&ve[Ne]==="\\";)$e=!$e;return $e?"|":" |"}),j=ce.split(/ \|/),Y=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;Y<j.length;Y++)j[Y]=j[Y].trim().replace(/\\\|/g,"|");return j}function R(x,ie,ce){var j=x.length;if(j===0)return"";for(var Y=0;Y<j;){var se=x.charAt(j-Y-1);if(se===ie&&!ce)Y++;else if(se!==ie&&ce)Y++;else break}return x.substr(0,j-Y)}function g(x,ie){if(x.indexOf(ie[1])===-1)return-1;for(var ce=x.length,j=0,Y=0;Y<ce;Y++)if(x[Y]==="\\")Y++;else if(x[Y]===ie[0])j++;else if(x[Y]===ie[1]&&(j--,j<0))return Y;return-1}function w(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(x,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=x),ie>>=1,x+=x;return ce+x}var F={escape:f,unescape:h,edit:m,cleanUrl:c,resolveUrl:a,noopTest:i,merge:u,splitCells:D,rtrim:R,findClosingBracket:g,checkSanitizeDeprecation:w,repeatString:I},B=y.defaults,le=F.rtrim,H=F.splitCells,z=F.escape,K=F.findClosingBracket;function L(x,ie,ce){var j=ie.href,Y=ie.title?z(ie.title):null,se=x[1].replace(/\\([\[\]])/g,"$1");return x[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:Y,text:se}:{type:"image",raw:ce,href:j,title:Y,text:z(se)}}function $(x,ie){var ce=x.match(/^(\s+)(?:```)/);if(ce===null)return ie;var j=ce[1];return ie.split(`
`).map(function(Y){var se=Y.match(/^\s+/);if(se===null)return Y;var fe=se[0];return fe.length>=j.length?Y.slice(j.length):Y}).join(`
`)}var U=function(){function x(ce){this.options=ce||B}var ie=x.prototype;return ie.space=function(j){var Y=this.rules.block.newline.exec(j);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},ie.code=function(j){var Y=this.rules.block.code.exec(j);if(Y){var se=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?se:le(se,`
`)}}},ie.fences=function(j){var Y=this.rules.block.fences.exec(j);if(Y){var se=Y[0],fe=$(se,Y[3]||"");return{type:"code",raw:se,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},ie.heading=function(j){var Y=this.rules.block.heading.exec(j);if(Y){var se=Y[2].trim();if(/#$/.test(se)){var fe=le(se,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(se=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:se}}},ie.nptable=function(j){var Y=this.rules.block.nptable.exec(j);if(Y){var se={type:"table",header:H(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(se.header.length===se.align.length){var fe=se.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(se.align[ve])?se.align[ve]="right":/^ *:-+: *$/.test(se.align[ve])?se.align[ve]="center":/^ *:-+ *$/.test(se.align[ve])?se.align[ve]="left":se.align[ve]=null;for(fe=se.cells.length,ve=0;ve<fe;ve++)se.cells[ve]=H(se.cells[ve],se.header.length);return se}}},ie.hr=function(j){var Y=this.rules.block.hr.exec(j);if(Y)return{type:"hr",raw:Y[0]}},ie.blockquote=function(j){var Y=this.rules.block.blockquote.exec(j);if(Y){var se=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:se}}},ie.list=function(j){var Y=this.rules.block.list.exec(j);if(Y){var se=Y[0],fe=Y[2],ve=fe.length>1,$e={type:"list",raw:se,ordered:ve,start:ve?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=Y[0].match(this.rules.block.item),Ve=!1,Qe,Ze,ct,st,me,he,ue,Q,Ie=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Pe=0;Pe<Ie;Pe++){if(Qe=Ne[Pe],se=Qe,Pe!==Ie-1){if(st=this.rules.block.listItemStart.exec(Ne[Pe+1]),this.options.pedantic?st[1].length>ct[1].length:st[1].length>ct[0].length||st[1].length>3){Ne.splice(Pe,2,Ne[Pe]+`
`+Ne[Pe+1]),Pe--,Ie--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==fe[fe.length-1]:ve===(st[2].length===1))&&(me=Ne.slice(Pe+1).join(`
`),$e.raw=$e.raw.substring(0,$e.raw.length-me.length),Pe=Ie-1);ct=st}Ze=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(Ze-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),he=Ve||/\n\n(?!\s*$)/.test(Qe),Pe!==Ie-1&&(Ve=Qe.charAt(Qe.length-1)===`
`,he||(he=Ve)),he&&($e.loose=!0),this.options.gfm&&(ue=/^\[[ xX]\] /.test(Qe),Q=void 0,ue&&(Q=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:se,task:ue,checked:Q,loose:he,text:Qe})}return $e}},ie.html=function(j){var Y=this.rules.block.html.exec(j);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):z(Y[0]):Y[0]}},ie.def=function(j){var Y=this.rules.block.def.exec(j);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var se=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:se,raw:Y[0],href:Y[2],title:Y[3]}}},ie.table=function(j){var Y=this.rules.block.table.exec(j);if(Y){var se={type:"table",header:H(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=Y[0];var fe=se.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(se.align[ve])?se.align[ve]="right":/^ *:-+: *$/.test(se.align[ve])?se.align[ve]="center":/^ *:-+ *$/.test(se.align[ve])?se.align[ve]="left":se.align[ve]=null;for(fe=se.cells.length,ve=0;ve<fe;ve++)se.cells[ve]=H(se.cells[ve].replace(/^ *\| *| *\| *$/g,""),se.header.length);return se}}},ie.lheading=function(j){var Y=this.rules.block.lheading.exec(j);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},ie.paragraph=function(j){var Y=this.rules.block.paragraph.exec(j);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},ie.text=function(j){var Y=this.rules.block.text.exec(j);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},ie.escape=function(j){var Y=this.rules.inline.escape.exec(j);if(Y)return{type:"escape",raw:Y[0],text:z(Y[1])}},ie.tag=function(j,Y,se){var fe=this.rules.inline.tag.exec(j);if(fe)return!Y&&/^<a /i.test(fe[0])?Y=!0:Y&&/^<\/a>/i.test(fe[0])&&(Y=!1),!se&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?se=!0:se&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(se=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:Y,inRawBlock:se,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]):fe[0]}},ie.link=function(j){var Y=this.rules.inline.link.exec(j);if(Y){var se=Y[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var fe=le(se.slice(0,-1),"\\");if((se.length-fe.length)%2==0)return}else{var ve=K(Y[2],"()");if(ve>-1){var $e=Y[0].indexOf("!")===0?5:4,Ne=$e+Y[1].length+ve;Y[2]=Y[2].substring(0,ve),Y[0]=Y[0].substring(0,Ne).trim(),Y[3]=""}}var Ve=Y[2],Qe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Qe=Ze[3])}else Qe=Y[3]?Y[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(se)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),L(Y,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},Y[0])}},ie.reflink=function(j,Y){var se;if((se=this.rules.inline.reflink.exec(j))||(se=this.rules.inline.nolink.exec(j))){var fe=(se[2]||se[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var ve=se[0].charAt(0);return{type:"text",raw:ve,text:ve}}return L(se,fe,se[0])}},ie.emStrong=function(j,Y,se){se===void 0&&(se="");var fe=this.rules.inline.emStrong.lDelim.exec(j);if(!!fe&&!(fe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ve=fe[1]||fe[2]||"";if(!ve||ve&&(se===""||this.rules.inline.punctuation.exec(se))){var $e=fe[0].length-1,Ne,Ve,Qe=$e,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,Y=Y.slice(-1*j.length+$e);(fe=ct.exec(Y))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Qe+=Ve;continue}else if((fe[5]||fe[6])&&$e%3&&!(($e+Ve)%3)){Ze+=Ve;continue}if(Qe-=Ve,!(Qe>0)){if(Qe+Ze-Ve<=0&&!Y.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Qe+Ze)),Math.min($e,Ve)%2)return{type:"em",raw:j.slice(0,$e+fe.index+Ve+1),text:j.slice(1,$e+fe.index+Ve)};if(Math.min($e,Ve)%2==0)return{type:"strong",raw:j.slice(0,$e+fe.index+Ve+1),text:j.slice(2,$e+fe.index+Ve-1)}}}}}},ie.codespan=function(j){var Y=this.rules.inline.code.exec(j);if(Y){var se=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(se),ve=/^ /.test(se)&&/ $/.test(se);return fe&&ve&&(se=se.substring(1,se.length-1)),se=z(se,!0),{type:"codespan",raw:Y[0],text:se}}},ie.br=function(j){var Y=this.rules.inline.br.exec(j);if(Y)return{type:"br",raw:Y[0]}},ie.del=function(j){var Y=this.rules.inline.del.exec(j);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},ie.autolink=function(j,Y){var se=this.rules.inline.autolink.exec(j);if(se){var fe,ve;return se[2]==="@"?(fe=z(this.options.mangle?Y(se[1]):se[1]),ve="mailto:"+fe):(fe=z(se[1]),ve=fe),{type:"link",raw:se[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},ie.url=function(j,Y){var se;if(se=this.rules.inline.url.exec(j)){var fe,ve;if(se[2]==="@")fe=z(this.options.mangle?Y(se[0]):se[0]),ve="mailto:"+fe;else{var $e;do $e=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while($e!==se[0]);fe=z(se[0]),se[1]==="www."?ve="http://"+fe:ve=fe}return{type:"link",raw:se[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},ie.inlineText=function(j,Y,se){var fe=this.rules.inline.text.exec(j);if(fe){var ve;return Y?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]):fe[0]:ve=z(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},x}(),G=F.noopTest,N=F.edit,Z=F.merge,ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:G,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=N(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ne.item=N(ne.item,"gm").replace(/bull/g,ne.bullet).getRegex(),ne.listItemStart=N(/^( *)(bull)/).replace("bull",ne.bullet).getRegex(),ne.list=N(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=N(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=N(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=N(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=Z({},ne),ne.gfm=Z({},ne.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.nptable=N(ne.gfm.nptable).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.table=N(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=Z({},ne.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:N(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=N(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=N(ne._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=N(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=N(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=N(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=N(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=N(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=N(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=N(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=N(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=Z({},re),re.pedantic=Z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=Z({},re.normal,{escape:N(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=N(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=Z({},re.gfm,{br:N(re.br).replace("{2,}","*").getRegex(),text:N(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:ne,inline:re},Ae=y.defaults,Be=ye.block,Re=ye.inline,xe=F.repeatString;function W(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(x){var ie="",ce,j,Y=x.length;for(ce=0;ce<Y;ce++)j=x.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var J=function(){function x(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Ae,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:Be.normal,inline:Re.normal};this.options.pedantic?(j.block=Be.pedantic,j.inline=Re.pedantic):this.options.gfm&&(j.block=Be.gfm,this.options.breaks?j.inline=Re.breaks:j.inline=Re.gfm),this.tokenizer.rules=j}x.lex=function(j,Y){var se=new x(Y);return se.lex(j)},x.lexInline=function(j,Y){var se=new x(Y);return se.inlineTokens(j)};var ie=x.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,Y,se){Y===void 0&&(Y=[]),se===void 0&&(se=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var fe,ve,$e,Ne;j;){if(fe=this.tokenizer.space(j)){j=j.substring(fe.raw.length),fe.type&&Y.push(fe);continue}if(fe=this.tokenizer.code(j)){j=j.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.nptable(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(j)){j=j.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],se),Y.push(fe);continue}if(fe=this.tokenizer.list(j)){for(j=j.substring(fe.raw.length),$e=fe.items.length,ve=0;ve<$e;ve++)fe.items[ve].tokens=this.blockTokens(fe.items[ve].text,[],!1);Y.push(fe);continue}if(fe=this.tokenizer.html(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(se&&(fe=this.tokenizer.def(j))){j=j.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(se&&(fe=this.tokenizer.paragraph(j))){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.text(j)){j=j.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):Y.push(fe);continue}if(j){var Ve="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return Y},ie.inline=function(j){var Y,se,fe,ve,$e,Ne,Ve=j.length;for(Y=0;Y<Ve;Y++)switch(Ne=j[Y],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ve=Ne.header.length,se=0;se<ve;se++)Ne.tokens.header[se]=[],this.inlineTokens(Ne.header[se],Ne.tokens.header[se]);for(ve=Ne.cells.length,se=0;se<ve;se++)for($e=Ne.cells[se],Ne.tokens.cells[se]=[],fe=0;fe<$e.length;fe++)Ne.tokens.cells[se][fe]=[],this.inlineTokens($e[fe],Ne.tokens.cells[se][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ve=Ne.items.length,se=0;se<ve;se++)this.inline(Ne.items[se].tokens);break}}return j},ie.inlineTokens=function(j,Y,se,fe){Y===void 0&&(Y=[]),se===void 0&&(se=!1),fe===void 0&&(fe=!1);var ve,$e,Ne=j,Ve,Qe,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Qe||(Ze=""),Qe=!1,ve=this.tokenizer.escape(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.tag(j,se,fe)){j=j.substring(ve.raw.length),se=ve.inLink,fe=ve.inRawBlock;var st=Y[Y.length-1];st&&ve.type==="text"&&st.type==="text"?(st.raw+=ve.raw,st.text+=ve.text):Y.push(ve);continue}if(ve=this.tokenizer.link(j)){j=j.substring(ve.raw.length),ve.type==="link"&&(ve.tokens=this.inlineTokens(ve.text,[],!0,fe)),Y.push(ve);continue}if(ve=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(ve.raw.length);var me=Y[Y.length-1];ve.type==="link"?(ve.tokens=this.inlineTokens(ve.text,[],!0,fe),Y.push(ve)):me&&ve.type==="text"&&me.type==="text"?(me.raw+=ve.raw,me.text+=ve.text):Y.push(ve);continue}if(ve=this.tokenizer.emStrong(j,Ne,Ze)){j=j.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],se,fe),Y.push(ve);continue}if(ve=this.tokenizer.codespan(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.br(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.del(j)){j=j.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],se,fe),Y.push(ve);continue}if(ve=this.tokenizer.autolink(j,q)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(!se&&(ve=this.tokenizer.url(j,q))){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.inlineText(j,fe,W)){j=j.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(Ze=ve.raw.slice(-1)),Qe=!0,$e=Y[Y.length-1],$e&&$e.type==="text"?($e.raw+=ve.raw,$e.text+=ve.text):Y.push(ve);continue}if(j){var he="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return Y},e(x,null,[{key:"rules",get:function(){return{block:Be,inline:Re}}}]),x}(),ae=y.defaults,ge=F.cleanUrl,De=F.escape,Le=function(){function x(ce){this.options=ce||ae}var ie=x.prototype;return ie.code=function(j,Y,se){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var ve=this.options.highlight(j,fe);ve!=null&&ve!==j&&(se=!0,j=ve)}return j=j.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(se?j:De(j,!0))+`</code></pre>
`:"<pre><code>"+(se?j:De(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,Y,se,fe){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+fe.slug(se)+'">'+j+"</h"+Y+`>
`:"<h"+Y+">"+j+"</h"+Y+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,Y,se){var fe=Y?"ol":"ul",ve=Y&&se!==1?' start="'+se+'"':"";return"<"+fe+ve+`>
`+j+"</"+fe+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Y+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,Y){var se=Y.header?"th":"td",fe=Y.align?"<"+se+' align="'+Y.align+'">':"<"+se+">";return fe+j+"</"+se+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,Y,se){if(j=ge(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<a href="'+De(j)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+se+"</a>",fe},ie.image=function(j,Y,se){if(j=ge(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<img src="'+j+'" alt="'+se+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},ie.text=function(j){return j},x}(),pe=function(){function x(){}var ie=x.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,Y,se){return""+se},ie.image=function(j,Y,se){return""+se},ie.br=function(){return""},x}(),Ce=function(){function x(){this.seen={}}var ie=x.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,Y){var se=j,fe=0;if(this.seen.hasOwnProperty(se)){fe=this.seen[j];do fe++,se=j+"-"+fe;while(this.seen.hasOwnProperty(se))}return Y||(this.seen[j]=fe,this.seen[se]=0),se},ie.slug=function(j,Y){Y===void 0&&(Y={});var se=this.serialize(j);return this.getNextSafeSlug(se,Y.dryrun)},x}(),Te=y.defaults,Ue=F.unescape,be=function(){function x(ce){this.options=ce||Te,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}x.parse=function(j,Y){var se=new x(Y);return se.parse(j)},x.parseInline=function(j,Y){var se=new x(Y);return se.parseInline(j)};var ie=x.prototype;return ie.parse=function(j,Y){Y===void 0&&(Y=!0);var se="",fe,ve,$e,Ne,Ve,Qe,Ze,ct,st,me,he,ue,Q,Ie,Pe,et,Ge,rt,lt=j.length;for(fe=0;fe<lt;fe++)switch(me=j[fe],me.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(me.tokens),me.depth,Ue(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(ct="",Ze="",Ne=me.header.length,ve=0;ve<Ne;ve++)Ze+=this.renderer.tablecell(this.parseInline(me.tokens.header[ve]),{header:!0,align:me.align[ve]});for(ct+=this.renderer.tablerow(Ze),st="",Ne=me.cells.length,ve=0;ve<Ne;ve++){for(Qe=me.tokens.cells[ve],Ze="",Ve=Qe.length,$e=0;$e<Ve;$e++)Ze+=this.renderer.tablecell(this.parseInline(Qe[$e]),{header:!1,align:me.align[$e]});st+=this.renderer.tablerow(Ze)}se+=this.renderer.table(ct,st);continue}case"blockquote":{st=this.parse(me.tokens),se+=this.renderer.blockquote(st);continue}case"list":{for(he=me.ordered,ue=me.start,Q=me.loose,Ne=me.items.length,st="",ve=0;ve<Ne;ve++)Pe=me.items[ve],et=Pe.checked,Ge=Pe.task,Ie="",Pe.task&&(rt=this.renderer.checkbox(et),Q?Pe.tokens.length>0&&Pe.tokens[0].type==="text"?(Pe.tokens[0].text=rt+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=rt+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:rt}):Ie+=rt),Ie+=this.parse(Pe.tokens,Q),st+=this.renderer.listitem(Ie,Ge,et);se+=this.renderer.list(st,he,ue);continue}case"html":{se+=this.renderer.html(me.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(st=me.tokens?this.parseInline(me.tokens):me.text;fe+1<lt&&j[fe+1].type==="text";)me=j[++fe],st+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);se+=Y?this.renderer.paragraph(st):st;continue}default:{var Je='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return se},ie.parseInline=function(j,Y){Y=Y||this.renderer;var se="",fe,ve,$e=j.length;for(fe=0;fe<$e;fe++)switch(ve=j[fe],ve.type){case"escape":{se+=Y.text(ve.text);break}case"html":{se+=Y.html(ve.text);break}case"link":{se+=Y.link(ve.href,ve.title,this.parseInline(ve.tokens,Y));break}case"image":{se+=Y.image(ve.href,ve.title,ve.text);break}case"strong":{se+=Y.strong(this.parseInline(ve.tokens,Y));break}case"em":{se+=Y.em(this.parseInline(ve.tokens,Y));break}case"codespan":{se+=Y.codespan(ve.text);break}case"br":{se+=Y.br();break}case"del":{se+=Y.del(this.parseInline(ve.tokens,Y));break}case"text":{se+=Y.text(ve.text);break}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return se},x}(),Ke=F.merge,V=F.checkSanitizeDeprecation,X=F.escape,_e=y.getDefaults,Me=y.changeDefaults,He=y.defaults;function Oe(x,ie,ce){if(typeof x=="undefined"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=Ke({},Oe.defaults,ie||{}),V(ie),ce){var j=ie.highlight,Y;try{Y=J.lex(x,ie)}catch($e){return ce($e)}var se=function(Ne){var Ve;if(!Ne)try{Ve=be.parse(Y,ie)}catch(Qe){Ne=Qe}return ie.highlight=j,Ne?ce(Ne):ce(null,Ve)};if(!j||j.length<3||(delete ie.highlight,!Y.length))return se();var fe=0;Oe.walkTokens(Y,function($e){$e.type==="code"&&(fe++,setTimeout(function(){j($e.text,$e.lang,function(Ne,Ve){if(Ne)return se(Ne);Ve!=null&&Ve!==$e.text&&($e.text=Ve,$e.escaped=!0),fe--,fe===0&&se()})},0))}),fe===0&&se();return}try{var ve=J.lex(x,ie);return ie.walkTokens&&Oe.walkTokens(ve,ie.walkTokens),be.parse(ve,ie)}catch($e){if($e.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X($e.message+"",!0)+"</pre>";throw $e}}Oe.options=Oe.setOptions=function(x){return Ke(Oe.defaults,x),Me(Oe.defaults),Oe},Oe.getDefaults=_e,Oe.defaults=He,Oe.use=function(x){var ie=Ke({},x);if(x.renderer&&function(){var j=Oe.defaults.renderer||new Le,Y=function(ve){var $e=j[ve];j[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=x.renderer[ve].apply(j,Ve);return Ze===!1&&(Ze=$e.apply(j,Ve)),Ze}};for(var se in x.renderer)Y(se);ie.renderer=j}(),x.tokenizer&&function(){var j=Oe.defaults.tokenizer||new U,Y=function(ve){var $e=j[ve];j[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=x.tokenizer[ve].apply(j,Ve);return Ze===!1&&(Ze=$e.apply(j,Ve)),Ze}};for(var se in x.tokenizer)Y(se);ie.tokenizer=j}(),x.walkTokens){var ce=Oe.defaults.walkTokens;ie.walkTokens=function(j){x.walkTokens(j),ce&&ce(j)}}Oe.setOptions(ie)},Oe.walkTokens=function(x,ie){for(var ce=T(x),j;!(j=ce()).done;){var Y=j.value;switch(ie(Y),Y.type){case"table":{for(var se=T(Y.tokens.header),fe;!(fe=se()).done;){var ve=fe.value;Oe.walkTokens(ve,ie)}for(var $e=T(Y.tokens.cells),Ne;!(Ne=$e()).done;)for(var Ve=Ne.value,Qe=T(Ve),Ze;!(Ze=Qe()).done;){var ct=Ze.value;Oe.walkTokens(ct,ie)}break}case"list":{Oe.walkTokens(Y.items,ie);break}default:Y.tokens&&Oe.walkTokens(Y.tokens,ie)}}},Oe.parseInline=function(x,ie){if(typeof x=="undefined"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");ie=Ke({},Oe.defaults,ie||{}),V(ie);try{var ce=J.lexInline(x,ie);return ie.walkTokens&&Oe.walkTokens(ce,ie.walkTokens),be.parseInline(ce,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X(j.message+"",!0)+"</pre>";throw j}},Oe.Parser=be,Oe.parser=be.parse,Oe.Renderer=Le,Oe.TextRenderer=pe,Oe.Lexer=J,Oe.lexer=J.lex,Oe.Tokenizer=U,Oe.Slugger=Ce,Oe.parse=Oe;var Xe=Oe;return Xe}),define(we[78],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,k,E){return Math.min(Math.max(y,k),E)}e.clamp=b;function S(y,k){return(k+y%k)%k}e.rot=S;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function oe(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function y(E){P.push(E,Date.now())}function k(){const E=[];for(let n=0;n<P.length;n+=2)E.push({name:P[n],startTime:P[n+1]});return E}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(T+y.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function b(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=b(S))})(),define(we[21],Ee([0,1]),function(oe,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let T=!1,P=!1,y=!1,k=!1,E=!1,n=!1,A=!1,C,_=S,f,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof process!="undefined"?h=process:typeof e.globals.vscode!="undefined"&&(h=e.globals.vscode.process);const p=typeof((b=h==null?void 0:h.versions)===null||b===void 0?void 0:b.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=p&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=h==null?void 0:h.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)s=navigator.userAgent,T=s.indexOf("Windows")>=0,P=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=s.indexOf("Linux")>=0,n=!0,C=navigator.language,_=C;else if(typeof h=="object"){T=h.platform==="win32",P=h.platform==="darwin",y=h.platform==="linux",k=y&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,C=S,_=S;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const i=JSON.parse(a),u=i.availableLanguages["*"];C=i.locale,_=u||S,f=i._translationsConfigFile}catch(i){}E=!0}else console.error("Unable to resolve platform.");var m;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function v(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let d=0;P?d=1:T?d=3:y&&(d=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=y,e.isLinuxSnap=k,e.isNative=E,e.isWeb=n,e.isIOS=A,e.platform=d,e.userAgent=s,e.language=_;var c;(function(a){function i(){return e.language}a.value=i;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=u;function D(){return e.language==="en"}a.isDefault=D})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeSetImmediateId)for(let g=0,w=u.length;g<w;g++){const I=u[g];if(I.id===R.data.vscodeSetImmediateId){u.splice(g,1),I.callback();return}}});let D=0;return R=>{const g=++D;u.push({id:g,callback:R}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const i=Promise.resolve();return u=>i.then(u)}();var o;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||A?2:T?1:3;let t=!0,r=!1;function l(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(we[32],Ee([0,1,21]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let S;if(typeof process!="undefined")S={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}};else if(typeof b.globals.vscode!="undefined"){const T=b.globals.vscode.process;S={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(P){return(0,b.setImmediate)(P)}}}else S={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(T){return(0,b.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.platform=S.platform,e.nextTick=S.nextTick}),define(we[11],Ee([0,1,32]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const S=65,T=97,P=90,y=122,k=46,E=47,n=92,A=58,C=63;class _ extends Error{constructor(c,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const l=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${l} ${r} of type ${o}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,c){if(typeof d!="string")throw new _(c,"string",d)}function s(d){return d===E||d===n}function h(d){return d===E}function p(d){return d>=S&&d<=P||d>=T&&d<=y}function m(d,c,o,t){let r="",l=0,a=-1,i=0,u=0;for(let D=0;D<=d.length;++D){if(D<d.length)u=d.charCodeAt(D);else{if(t(u))break;u=E}if(t(u)){if(!(a===D-1||i===1))if(i===2){if(r.length<2||l!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const R=r.lastIndexOf(o);R===-1?(r="",l=0):(r=r.slice(0,R),l=r.length-1-r.lastIndexOf(o)),a=D,i=0;continue}else if(r.length!==0){r="",l=0,a=D,i=0;continue}}c&&(r+=r.length>0?`${o}..`:"..",l=2)}else r.length>0?r+=`${o}${d.slice(a+1,D)}`:r=d.slice(a+1,D),l=D-a-1;a=D,i=0}else u===k&&i!==-1?++i:i=-1}return r}function v(d,c){if(c===null||typeof c!="object")throw new _("pathObject","Object",c);const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${d}${t}`:t}e.win32={resolve(...d){let c="",o="",t=!1;for(let r=d.length-1;r>=-1;r--){let l;if(r>=0){if(l=d[r],f(l,"path"),l.length===0)continue}else c.length===0?l=b.cwd():(l=b.env[`=${c}`]||b.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===n)&&(l=`${c}\\`));const a=l.length;let i=0,u="",D=!1;const R=l.charCodeAt(0);if(a===1)s(R)&&(i=1,D=!0);else if(s(R))if(D=!0,s(l.charCodeAt(1))){let g=2,w=g;for(;g<a&&!s(l.charCodeAt(g));)g++;if(g<a&&g!==w){const I=l.slice(w,g);for(w=g;g<a&&s(l.charCodeAt(g));)g++;if(g<a&&g!==w){for(w=g;g<a&&!s(l.charCodeAt(g));)g++;(g===a||g!==w)&&(u=`\\\\${I}\\${l.slice(w,g)}`,i=g)}}}else i=1;else p(R)&&l.charCodeAt(1)===A&&(u=l.slice(0,2),i=2,a>2&&s(l.charCodeAt(2))&&(D=!0,i=3));if(u.length>0)if(c.length>0){if(u.toLowerCase()!==c.toLowerCase())continue}else c=u;if(t){if(c.length>0)break}else if(o=`${l.slice(i)}\\${o}`,t=D,D&&c.length>0)break}return o=m(o,!t,"\\",s),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(d){f(d,"path");const c=d.length;if(c===0)return".";let o=0,t,r=!1;const l=d.charCodeAt(0);if(c===1)return h(l)?"\\":d;if(s(l))if(r=!0,s(d.charCodeAt(1))){let i=2,u=i;for(;i<c&&!s(d.charCodeAt(i));)i++;if(i<c&&i!==u){const D=d.slice(u,i);for(u=i;i<c&&s(d.charCodeAt(i));)i++;if(i<c&&i!==u){for(u=i;i<c&&!s(d.charCodeAt(i));)i++;if(i===c)return`\\\\${D}\\${d.slice(u)}\\`;i!==u&&(t=`\\\\${D}\\${d.slice(u,i)}`,o=i)}}}else o=1;else p(l)&&d.charCodeAt(1)===A&&(t=d.slice(0,2),o=2,c>2&&s(d.charCodeAt(2))&&(r=!0,o=3));let a=o<c?m(d.slice(o),!r,"\\",s):"";return a.length===0&&!r&&(a="."),a.length>0&&s(d.charCodeAt(c-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(d){f(d,"path");const c=d.length;if(c===0)return!1;const o=d.charCodeAt(0);return s(o)||c>2&&p(o)&&d.charCodeAt(1)===A&&s(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let c,o;for(let l=0;l<d.length;++l){const a=d[l];f(a,"path"),a.length>0&&(c===void 0?c=o=a:c+=`\\${a}`)}if(c===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&s(o.charCodeAt(0))){++r;const l=o.length;l>1&&s(o.charCodeAt(1))&&(++r,l>2&&(s(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<c.length&&s(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(d,c){if(f(d,"from"),f(c,"to"),d===c)return"";const o=e.win32.resolve(d),t=e.win32.resolve(c);if(o===t||(d=o.toLowerCase(),c=t.toLowerCase(),d===c))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===n;)r++;let l=d.length;for(;l-1>r&&d.charCodeAt(l-1)===n;)l--;const a=l-r;let i=0;for(;i<c.length&&c.charCodeAt(i)===n;)i++;let u=c.length;for(;u-1>i&&c.charCodeAt(u-1)===n;)u--;const D=u-i,R=a<D?a:D;let g=-1,w=0;for(;w<R;w++){const F=d.charCodeAt(r+w);if(F!==c.charCodeAt(i+w))break;F===n&&(g=w)}if(w!==R){if(g===-1)return t}else{if(D>R){if(c.charCodeAt(i+w)===n)return t.slice(i+w+1);if(w===2)return t.slice(i+w)}a>R&&(d.charCodeAt(r+w)===n?g=w:w===2&&(g=3)),g===-1&&(g=0)}let I="";for(w=r+g+1;w<=l;++w)(w===l||d.charCodeAt(w)===n)&&(I+=I.length===0?"..":"\\..");return i+=g,I.length>0?`${I}${t.slice(i,u)}`:(t.charCodeAt(i)===n&&++i,t.slice(i,u))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const c=e.win32.resolve(d);if(c.length<=2)return d;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const o=c.charCodeAt(2);if(o!==C&&o!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return d},dirname(d){f(d,"path");const c=d.length;if(c===0)return".";let o=-1,t=0;const r=d.charCodeAt(0);if(c===1)return s(r)?d:".";if(s(r)){if(o=t=1,s(d.charCodeAt(1))){let i=2,u=i;for(;i<c&&!s(d.charCodeAt(i));)i++;if(i<c&&i!==u){for(u=i;i<c&&s(d.charCodeAt(i));)i++;if(i<c&&i!==u){for(u=i;i<c&&!s(d.charCodeAt(i));)i++;if(i===c)return d;i!==u&&(o=t=i+1)}}}}else p(r)&&d.charCodeAt(1)===A&&(o=c>2&&s(d.charCodeAt(2))?3:2,t=o);let l=-1,a=!0;for(let i=c-1;i>=t;--i)if(s(d.charCodeAt(i))){if(!a){l=i;break}}else a=!1;if(l===-1){if(o===-1)return".";l=o}return d.slice(0,l)},basename(d,c){c!==void 0&&f(c,"ext"),f(d,"path");let o=0,t=-1,r=!0,l;if(d.length>=2&&p(d.charCodeAt(0))&&d.charCodeAt(1)===A&&(o=2),c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let a=c.length-1,i=-1;for(l=d.length-1;l>=o;--l){const u=d.charCodeAt(l);if(s(u)){if(!r){o=l+1;break}}else i===-1&&(r=!1,i=l+1),a>=0&&(u===c.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=i))}return o===t?t=i:t===-1&&(t=d.length),d.slice(o,t)}for(l=d.length-1;l>=o;--l)if(s(d.charCodeAt(l))){if(!r){o=l+1;break}}else t===-1&&(r=!1,t=l+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let c=0,o=-1,t=0,r=-1,l=!0,a=0;d.length>=2&&d.charCodeAt(1)===A&&p(d.charCodeAt(0))&&(c=t=2);for(let i=d.length-1;i>=c;--i){const u=d.charCodeAt(i);if(s(u)){if(!l){t=i+1;break}continue}r===-1&&(l=!1,r=i+1),u===k?o===-1?o=i:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||r===-1||a===0||a===1&&o===r-1&&o===t+1?"":d.slice(o,r)},format:v.bind(null,"\\"),parse(d){f(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const o=d.length;let t=0,r=d.charCodeAt(0);if(o===1)return s(r)?(c.root=c.dir=d,c):(c.base=c.name=d,c);if(s(r)){if(t=1,s(d.charCodeAt(1))){let g=2,w=g;for(;g<o&&!s(d.charCodeAt(g));)g++;if(g<o&&g!==w){for(w=g;g<o&&s(d.charCodeAt(g));)g++;if(g<o&&g!==w){for(w=g;g<o&&!s(d.charCodeAt(g));)g++;g===o?t=g:g!==w&&(t=g+1)}}}}else if(p(r)&&d.charCodeAt(1)===A){if(o<=2)return c.root=c.dir=d,c;if(t=2,s(d.charCodeAt(2))){if(o===3)return c.root=c.dir=d,c;t=3}}t>0&&(c.root=d.slice(0,t));let l=-1,a=t,i=-1,u=!0,D=d.length-1,R=0;for(;D>=t;--D){if(r=d.charCodeAt(D),s(r)){if(!u){a=D+1;break}continue}i===-1&&(u=!1,i=D+1),r===k?l===-1?l=D:R!==1&&(R=1):l!==-1&&(R=-1)}return i!==-1&&(l===-1||R===0||R===1&&l===i-1&&l===a+1?c.base=c.name=d.slice(a,i):(c.name=d.slice(a,l),c.base=d.slice(a,i),c.ext=d.slice(l,i))),a>0&&a!==t?c.dir=d.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let c="",o=!1;for(let t=d.length-1;t>=-1&&!o;t--){const r=t>=0?d[t]:b.cwd();f(r,"path"),r.length!==0&&(c=`${r}/${c}`,o=r.charCodeAt(0)===E)}return c=m(c,!o,"/",h),o?`/${c}`:c.length>0?c:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===E,o=d.charCodeAt(d.length-1)===E;return d=m(d,!c,"/",h),d.length===0?c?"/":o?"./":".":(o&&(d+="/"),c?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===E},join(...d){if(d.length===0)return".";let c;for(let o=0;o<d.length;++o){const t=d[o];f(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(d,c){if(f(d,"from"),f(c,"to"),d===c||(d=e.posix.resolve(d),c=e.posix.resolve(c),d===c))return"";const o=1,t=d.length,r=t-o,l=1,a=c.length-l,i=r<a?r:a;let u=-1,D=0;for(;D<i;D++){const g=d.charCodeAt(o+D);if(g!==c.charCodeAt(l+D))break;g===E&&(u=D)}if(D===i)if(a>i){if(c.charCodeAt(l+D)===E)return c.slice(l+D+1);if(D===0)return c.slice(l+D)}else r>i&&(d.charCodeAt(o+D)===E?u=D:D===0&&(u=0));let R="";for(D=o+u+1;D<=t;++D)(D===t||d.charCodeAt(D)===E)&&(R+=R.length===0?"..":"/..");return`${R}${c.slice(l+u)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===E;let o=-1,t=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===E){if(!t){o=r;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":d.slice(0,o)},basename(d,c){c!==void 0&&f(c,"ext"),f(d,"path");let o=0,t=-1,r=!0,l;if(c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let a=c.length-1,i=-1;for(l=d.length-1;l>=0;--l){const u=d.charCodeAt(l);if(u===E){if(!r){o=l+1;break}}else i===-1&&(r=!1,i=l+1),a>=0&&(u===c.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=i))}return o===t?t=i:t===-1&&(t=d.length),d.slice(o,t)}for(l=d.length-1;l>=0;--l)if(d.charCodeAt(l)===E){if(!r){o=l+1;break}}else t===-1&&(r=!1,t=l+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let c=-1,o=0,t=-1,r=!0,l=0;for(let a=d.length-1;a>=0;--a){const i=d.charCodeAt(a);if(i===E){if(!r){o=a+1;break}continue}t===-1&&(r=!1,t=a+1),i===k?c===-1?c=a:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||t===-1||l===0||l===1&&c===t-1&&c===o+1?"":d.slice(c,t)},format:v.bind(null,"/"),parse(d){f(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const o=d.charCodeAt(0)===E;let t;o?(c.root="/",t=1):t=0;let r=-1,l=0,a=-1,i=!0,u=d.length-1,D=0;for(;u>=t;--u){const R=d.charCodeAt(u);if(R===E){if(!i){l=u+1;break}continue}a===-1&&(i=!1,a=u+1),R===k?r===-1?r=u:D!==1&&(D=1):r!==-1&&(D=-1)}if(a!==-1){const R=l===0&&o?1:l;r===-1||D===0||D===1&&r===a-1&&r===l+1?c.base=c.name=d.slice(R,a):(c.name=d.slice(R,r),c.base=d.slice(R,a),c.ext=d.slice(r,a))}return l>0?c.dir=d.slice(0,l-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],Ee([0,1,21]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const S=b.globals.performance&&typeof b.globals.performance.now=="function";class T{constructor(y){this._highResolution=S&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=T}),define(we[3],Ee([0,1,10,52,6,46,55]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(m){m.None=()=>T.Disposable.None;function v(H){return(z,K=null,L)=>{let $=!1,U;return U=H(G=>{if(!$)return U?U.dispose():$=!0,z.call(K,G)},null,L),$&&U.dispose(),U}}m.once=v;function d(H,z){return a((K,L=null,$)=>H(U=>K.call(L,z(U)),null,$))}m.map=d;function c(H,z){return a((K,L=null,$)=>H(U=>{z(U),K.call(L,U)},null,$))}m.forEach=c;function o(H,z){return a((K,L=null,$)=>H(U=>z(U)&&K.call(L,U),null,$))}m.filter=o;function t(H){return H}m.signal=t;function r(...H){return(z,K=null,L)=>(0,T.combinedDisposable)(...H.map($=>$(U=>z.call(K,U),null,L)))}m.any=r;function l(H,z,K){let L=K;return d(H,$=>(L=z(L,$),L))}m.reduce=l;function a(H){let z;const K=new _({onFirstListenerAdd(){z=H(K.fire,K)},onLastListenerRemove(){z.dispose()}});return K.event}m.snapshot=a;function i(H,z,K=100,L=!1,$){let U,G,N,Z=0;const ne=new _({leakWarningThreshold:$,onFirstListenerAdd(){U=H(re=>{Z++,G=z(G,re),L&&!N&&(ne.fire(G),G=void 0),clearTimeout(N),N=setTimeout(()=>{const ye=G;G=void 0,N=void 0,(!L||Z>1)&&ne.fire(ye),Z=0},K)})},onLastListenerRemove(){U.dispose()}});return ne.event}m.debounce=i;function u(H){const z=new Date().getTime();return d(v(H),K=>new Date().getTime()-z)}m.stopwatch=u;function D(H){let z=!0,K;return o(H,L=>{const $=z||L!==K;return z=!1,K=L,$})}m.latch=D;function R(H,z=!1,K=[]){let L=K.slice(),$=H(N=>{L?L.push(N):G.fire(N)});const U=()=>{L&&L.forEach(N=>G.fire(N)),L=null},G=new _({onFirstListenerAdd(){$||($=H(N=>G.fire(N)))},onFirstListenerDidAdd(){L&&(z?setTimeout(U):U())},onLastListenerRemove(){$&&$.dispose(),$=null}});return G.event}m.buffer=R;class g{constructor(z){this.event=z}map(z){return new g(d(this.event,z))}forEach(z){return new g(c(this.event,z))}filter(z){return new g(o(this.event,z))}reduce(z,K){return new g(l(this.event,z,K))}latch(){return new g(D(this.event))}debounce(z,K=100,L=!1,$){return new g(i(this.event,z,K,L,$))}on(z,K,L){return this.event(z,K,L)}once(z,K,L){return v(this.event)(z,K,L)}}function w(H){return new g(H)}m.chain=w;function I(H,z,K=L=>L){const L=(...N)=>G.fire(K(...N)),$=()=>H.on(z,L),U=()=>H.removeListener(z,L),G=new _({onFirstListenerAdd:$,onLastListenerRemove:U});return G.event}m.fromNodeEventEmitter=I;function F(H,z,K=L=>L){const L=(...N)=>G.fire(K(...N)),$=()=>H.addEventListener(z,L),U=()=>H.removeEventListener(z,L),G=new _({onFirstListenerAdd:$,onLastListenerRemove:U});return G.event}m.fromDOMEventEmitter=F;function B(H){const z=new _;let K=!1;return H.then(void 0,()=>null).then(()=>{K?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),K=!0,z.event}m.fromPromise=B;function le(H){return new Promise(z=>v(H)(z))}m.toPromise=le})(k=e.Event||(e.Event={}));class E{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${E._idPool++}`}start(v){this._stopWatch=new y.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let n=-1;function A(m){const v=n;return n=m,{dispose(){n=v}}}e.setGlobalLeakWarningThreshold=A;class C{constructor(v,d=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let d=n;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||v<d)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(c)||0;if(this._stacks.set(c,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,r=0;for(const[l,a]of this._stacks)(!t||r<a)&&(t=l,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class _{constructor(v){var d;this._disposed=!1,this._options=v,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(v,d,c)=>{var o;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(d?[v,d]:v);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,d);const l=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let a;return a={dispose:()=>{l&&l(),a.dispose=_._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof T.DisposableStore?c.add(a):Array.isArray(c)&&c.push(a),a}),this._event}fire(v){var d,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,v]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,b.onUnexpectedError)(r)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var v,d,c;(v=this._listeners)===null||v===void 0||v.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=_,_._noop=function(){};class f extends _{constructor(v){super(v);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=v==null?void 0:v.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=f;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new _({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const d={event:v,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const c=()=>{this.hasListeners&&this.unhook(d);const o=this.events.indexOf(d);this.events.splice(o,1)};return(0,T.toDisposable)((0,S.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(d=>this.emitter.fire(d))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class h{constructor(){this.buffers=[]}wrapEvent(v){return(d,c,o)=>v(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>d.call(c,t)):d.call(c,t)},void 0,o)}bufferEvents(v){const d=[];this.buffers.push(d);const c=v();return this.buffers.pop(),d.forEach(o=>o()),c}}e.EventBufferer=h;class p{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new _({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(we[20],Ee([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const S=Object.freeze(function(k,E){const n=setTimeout(k.bind(E),0);return{dispose(){clearTimeout(n)}}});var T;(function(k){function E(n){return n===k.None||n===k.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}k.isCancellationToken=E,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?S:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(we[37],Ee([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class S{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(A){const C=this._icons.get(A.id);C?A.description?C.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new S;e.iconRegistry=T;function P(n,A){return new y(n,A)}e.registerCodicon=P;class y{constructor(A,C,_){this.id=A,this.definition=C,this.description=_,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function k(n,A){const C=["codicon","codicon-"+n];return A&&C.push("codicon-modifier-"+A),C}e.getClassNamesArray=k;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(s){if(s instanceof y)return["codicon","codicon-"+s.id];const h=A.exec(s.id);if(!h)return C(y.error);let[,p,m]=h;const v=["codicon","codicon-"+p];return m&&v.push("codicon-modifier-"+m.substr(1)),v}n.asClassNameArray=C;function _(s){return C(s).join(" ")}n.asClassName=_;function f(s){return"."+C(s).join(".")}n.asCSSSelector=f})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(we[106],Ee([0,1,10,6]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(p){const m=p;return m&&[m.on,m.pause,m.resume,m.destroy].every(v=>typeof v=="function")}e.isReadableStream=T;function P(p){const m=p;return m&&T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean"}e.isReadableBufferedStream=P;function y(p,m){return new k(p,m)}e.newWriteableStream=y;class k{constructor(m,v){this.reducer=m,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(v=>v(m))}emitError(m){this.listeners.error.length===0?(0,b.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(v=>v(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,v){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(m,v){if(!this.state.destroyed){let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const c=d.indexOf(v);c>=0&&d.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(p,m){const v=[];let d;for(;(d=p.read())!==null;)v.push(d);return m(v)}e.consumeReadable=E;function n(p,m,v){const d=[];let c;for(;(c=p.read())!==null&&d.length<v;)d.push(c);return c===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof c!="undefined"){const o=c;return c=void 0,o}return p.read()}}}e.peekReadable=n;function A(p,m){return new Promise((v,d)=>{const c=[];C(p,{onData:o=>{m&&c.push(o)},onError:o=>{m?d(o):v(void 0)},onEnd:()=>{v(m?m(c):void 0)}})})}e.consumeStream=A;function C(p,m){p.on("error",v=>m.onError(v)),p.on("end",()=>m.onEnd()),p.on("data",v=>m.onData(v))}e.listenStream=C;function _(p,m){return new Promise((v,d)=>{const c=new S.DisposableStore,o=[],t=a=>{if(o.push(a),o.length>m)return c.dispose(),p.pause(),v({stream:p,buffer:o,ended:!1})},r=a=>d(a),l=()=>v({stream:p,buffer:o,ended:!0});c.add((0,S.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),c.add((0,S.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),c.add((0,S.toDisposable)(()=>p.removeListener("data",t))),p.on("data",t)})}e.peekStream=_;function f(p,m){const v=y(m);return v.end(p),v}e.toStream=f;function s(p){let m=!1;return{read:()=>m?null:(m=!0,p)}}e.toReadable=s;function h(p,m,v){const d=y(v);return C(p,{onData:c=>d.write(m.data(c)),onError:c=>d.error(m.error?m.error(c):c),onEnd:()=>d.end()}),d}e.transform=h}),define(we[8],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=b;const S=/{(\d+)}/g;function T(x,...ie){return ie.length===0?x:x.replace(S,function(ce,j){const Y=parseInt(j,10);return isNaN(Y)||Y<0||Y>=ie.length?ce:ie[Y]})}e.format=T;function P(x){return x.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function y(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(x,ie){let ce=0;const j=ie.charCodeAt(0);for(let Y=x.length-1;Y>=0;Y--)x.charCodeAt(Y)===j&&ce++;return ce}e.count=k;function E(x,ie,ce="\u2026"){return x.length<=ie?x:`${x.substr(0,ie)}${ce}`}e.truncate=E;function n(x,ie=" "){const ce=A(x,ie);return C(ce,ie)}e.trim=n;function A(x,ie){if(!x||!ie)return x;const ce=ie.length;if(ce===0||x.length===0)return x;let j=0;for(;x.indexOf(ie,j)===j;)j=j+ce;return x.substring(j)}e.ltrim=A;function C(x,ie){if(!x||!ie)return x;const ce=ie.length,j=x.length;if(ce===0||j===0)return x;let Y=j,se=-1;for(;se=x.lastIndexOf(ie,Y-1),!(se===-1||se+ce!==Y);){if(se===0)return"";Y=se}return x.substring(0,Y)}e.rtrim=C;function _(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=_;function f(x){return x.replace(/\*/g,"")}e.stripWildcards=f;function s(x,ie,ce={}){if(!x)throw new Error("Cannot create regex from empty string");ie||(x=y(x)),ce.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(x,j)}e.createRegExp=s;function h(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function p(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=m;function v(x){return x.split(/\r\n|\r|\n/)}e.splitLines=v;function d(x){for(let ie=0,ce=x.length;ie<ce;ie++){const j=x.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=d;function c(x,ie=0,ce=x.length){for(let j=ie;j<ce;j++){const Y=x.charCodeAt(j);if(Y!==32&&Y!==9)return x.substring(ie,j)}return x.substring(ie,ce)}e.getLeadingWhitespace=c;function o(x,ie=x.length-1){for(let ce=ie;ce>=0;ce--){const j=x.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function t(x,ie){return x<ie?-1:x>ie?1:0}e.compare=t;function r(x,ie,ce=0,j=x.length,Y=0,se=ie.length){for(;ce<j&&Y<se;ce++,Y++){let $e=x.charCodeAt(ce),Ne=ie.charCodeAt(Y);if($e<Ne)return-1;if($e>Ne)return 1}const fe=j-ce,ve=se-Y;return fe<ve?-1:fe>ve?1:0}e.compareSubstring=r;function l(x,ie){return a(x,ie,0,x.length,0,ie.length)}e.compareIgnoreCase=l;function a(x,ie,ce=0,j=x.length,Y=0,se=ie.length){for(;ce<j&&Y<se;ce++,Y++){let $e=x.charCodeAt(ce),Ne=ie.charCodeAt(Y);if($e!==Ne){const Ve=$e-Ne;if(!(Ve===32&&u(Ne))&&!(Ve===-32&&u($e)))return i($e)&&i(Ne)?Ve:r(x.toLowerCase(),ie.toLowerCase(),ce,j,Y,se)}}const fe=j-ce,ve=se-Y;return fe<ve?-1:fe>ve?1:0}e.compareSubstringIgnoreCase=a;function i(x){return x>=97&&x<=122}e.isLowerAsciiLetter=i;function u(x){return x>=65&&x<=90}e.isUpperAsciiLetter=u;function D(x){return i(x)||u(x)}function R(x,ie){return x.length===ie.length&&g(x,ie)}e.equalsIgnoreCase=R;function g(x,ie,ce=x.length){for(let j=0;j<ce;j++){const Y=x.charCodeAt(j),se=ie.charCodeAt(j);if(Y!==se){if(D(Y)&&D(se)){const fe=Math.abs(Y-se);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(Y).toLowerCase()!==String.fromCharCode(se).toLowerCase())return!1}}return!0}function w(x,ie){const ce=ie.length;return ie.length>x.length?!1:g(x,ie,ce)}e.startsWithIgnoreCase=w;function I(x,ie){let ce,j=Math.min(x.length,ie.length);for(ce=0;ce<j;ce++)if(x.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return j}e.commonPrefixLength=I;function F(x,ie){let ce,j=Math.min(x.length,ie.length);const Y=x.length-1,se=ie.length-1;for(ce=0;ce<j;ce++)if(x.charCodeAt(Y-ce)!==ie.charCodeAt(se-ce))return ce;return j}e.commonSuffixLength=F;function B(x){return 55296<=x&&x<=56319}e.isHighSurrogate=B;function le(x){return 56320<=x&&x<=57343}e.isLowSurrogate=le;function H(x,ie){return(x-55296<<10)+(ie-56320)+65536}e.computeCodePoint=H;function z(x,ie,ce){const j=x.charCodeAt(ce);if(B(j)&&ce+1<ie){const Y=x.charCodeAt(ce+1);if(le(Y))return H(j,Y)}return j}e.getNextCodePoint=z;function K(x,ie){const ce=x.charCodeAt(ie-1);if(le(ce)&&ie>1){const j=x.charCodeAt(ie-2);if(B(j))return H(j,ce)}return ce}function L(x,ie){const ce=Oe.getInstance(),j=ie,Y=x.length,se=z(x,Y,ie);ie+=se>=65536?2:1;let fe=ce.getGraphemeBreakType(se);for(;ie<Y;){const ve=z(x,Y,ie),$e=ce.getGraphemeBreakType(ve);if(Me(fe,$e))break;ie+=ve>=65536?2:1,fe=$e}return ie-j}e.nextCharLength=L;function $(x,ie){const ce=Oe.getInstance(),j=ie,Y=K(x,ie);ie-=Y>=65536?2:1;let se=ce.getGraphemeBreakType(Y);for(;ie>0;){const fe=K(x,ie),ve=ce.getGraphemeBreakType(fe);if(Me(ve,se))break;ie-=fe>=65536?2:1,se=ve}return j-ie}e.prevCharLength=$;function U(x,ie){const ce=Oe.getInstance(),j=x.length,Y=ie,se=z(x,j,ie),fe=ce.getGraphemeBreakType(se);ie+=se>=65536?2:1;let ve=fe;for(;ie<j;){const Ne=z(x,j,ie),Ve=ce.getGraphemeBreakType(Ne);if(Me(ve,Ve))break;ie+=Ne>=65536?2:1,ve=Ve}const $e=ie;for(ie=Y,ve=fe;ie>0;){const Ne=K(x,ie),Ve=ce.getGraphemeBreakType(Ne);if(Me(Ve,ve))break;ie-=Ne>=65536?2:1,ve=Ve}return[ie,$e]}function G(x,ie){return ie>0&&le(x.charCodeAt(ie))?U(x,ie-1):U(x,ie)}e.getCharContainingOffset=G;function N(x){const ie=x.length;let ce=0,j=0;for(;j<ie;){const fe=z(x,ie,j);j+=fe>=65536?2:1,fe<128?ce+=1:fe<2048?ce+=2:fe<65536?ce+=3:ce+=4}const Y=new Uint8Array(ce);j=0;let se=0;for(;j<ie;){const fe=z(x,ie,j);j+=fe>=65536?2:1,fe<128?Y[se++]=fe:fe<2048?(Y[se++]=192|(fe&1984)>>>6,Y[se++]=128|(fe&63)>>>0):fe<65536?(Y[se++]=224|(fe&61440)>>>12,Y[se++]=128|(fe&4032)>>>6,Y[se++]=128|(fe&63)>>>0):(Y[se++]=240|(fe&1835008)>>>18,Y[se++]=128|(fe&258048)>>>12,Y[se++]=128|(fe&4032)>>>6,Y[se++]=128|(fe&63)>>>0)}return Y}e.encodeUTF8=N;function Z(x){const ie=x.byteLength,ce=[];let j=0;for(;j<ie;){const Y=x[j];let se;if(Y>=240&&j+3<ie?se=(x[j++]&7)<<18>>>0|(x[j++]&63)<<12>>>0|(x[j++]&63)<<6>>>0|(x[j++]&63)<<0>>>0:Y>=224&&j+2<ie?se=(x[j++]&15)<<12>>>0|(x[j++]&63)<<6>>>0|(x[j++]&63)<<0>>>0:Y>=192&&j+1<ie?se=(x[j++]&31)<<6>>>0|(x[j++]&63)<<0>>>0:se=x[j++],se>=0&&se<=55295||se>=57344&&se<=65535)ce.push(String.fromCharCode(se));else if(se>=65536&&se<=1114111){const fe=se-65536,ve=55296+((fe&1047552)>>>10),$e=56320+((fe&1023)>>>0);ce.push(String.fromCharCode(ve)),ce.push(String.fromCharCode($e))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=Z;const ne=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(x){return ne.test(x)}e.containsRTL=re;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(x){return ye.test(x)}e.containsEmoji=Ae;const Be=/^[\t\n\r\x20-\x7E]*$/;function Re(x){return Be.test(x)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=xe;function W(x){for(let ie=0,ce=x.length;ie<ce;ie++)if(q(x.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=W;function q(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=q;function J(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=J;function ae(x,ie){if(x.length<ie)return x;const ce=/\b/g;let j=0;for(;ce.test(x)&&!(x.length-ce.lastIndex<ie);)j=ce.lastIndex,ce.lastIndex+=1;return x.substring(j).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function pe(x){return x&&(x=x.replace(ge,""),x=x.replace(De,""),x=x.replace(Le,"")),x}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Te(x){return Ce(x)?x.substr(1):x}e.stripUTF8BOM=Te;function Ue(x,ie){if(!x||!ie||x.length<ie.length)return!1;const ce=ie.length,j=x.toLowerCase();let Y=0,se=-1;for(;Y<ce;){const fe=j.indexOf(ie[Y],se+1);if(fe<0)return!1;se=fe,Y++}return!0}e.fuzzyContains=Ue;function be(x,ie=!1){return x?(ie&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=be;function Ke(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=Ke;function V(x,ie=1){if(ie===0)return"";let ce=-1;do ce=x.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?x:(x[ce-1]==="\r"&&ce--,x.substr(0,ce))}e.getNLines=V;function X(x){const ie=90-65+1;return x=x%(2*ie),x<ie?String.fromCharCode(97+x):String.fromCharCode(65+x-ie)}e.singleLetterHash=X;function _e(x){return Oe.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=_e;function Me(x,ie){return x===0?ie!==5&&ie!==7:x===2&&ie===3?!1:x===4||x===2||x===3||ie===4||ie===2||ie===3?!0:!(x===8&&(ie===8||ie===9||ie===11||ie===12)||(x===11||x===9)&&(ie===9||ie===10)||(x===12||x===10)&&ie===10||ie===5||ie===13||ie===7||x===1||x===13&&ie===14||x===6&&ie===6)}e.breakBetweenGraphemeBreakType=Me;var He;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Xe()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,j=ce.length/3;let Y=1;for(;Y<=j;)if(ie<ce[3*Y])Y=2*Y;else if(ie>ce[3*Y+1])Y=2*Y+1;else return ce[3*Y+2];return 0}}Oe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[26],Ee([0,1,8,106]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,E;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return T?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return T&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,u){return!((u==null?void 0:u.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(i)):P?(k||(k=new TextEncoder),new n(k.encode(i))):new n(b.encodeUTF8(i))}static concat(i,u){if(typeof u=="undefined"){u=0;for(let g=0,w=i.length;g<w;g++)u+=i[g].byteLength}const D=n.alloc(u);let R=0;for(let g=0,w=i.length;g<w;g++){const I=i[g];D.set(I,R),R+=I.byteLength}return D}toString(){return T?this.buffer.toString():y?(E||(E=new TextDecoder),E.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(i,u){return new n(this.buffer.subarray(i,u))}set(i,u){i instanceof n?this.buffer.set(i.buffer,u):this.buffer.set(i,u)}readUInt32BE(i){return _(this.buffer,i)}writeUInt32BE(i,u){f(this.buffer,i,u)}readUInt32LE(i){return s(this.buffer,i)}writeUInt32LE(i,u){h(this.buffer,i,u)}readUInt8(i){return p(this.buffer,i)}writeUInt8(i,u){m(this.buffer,i,u)}}e.VSBuffer=n;function A(a,i){return a[i+0]<<0>>>0|a[i+1]<<8>>>0}e.readUInt16LE=A;function C(a,i,u){a[u+0]=i&255,i=i>>>8,a[u+1]=i&255}e.writeUInt16LE=C;function _(a,i){return a[i]*2**24+a[i+1]*2**16+a[i+2]*2**8+a[i+3]}e.readUInt32BE=_;function f(a,i,u){a[u+3]=i,i=i>>>8,a[u+2]=i,i=i>>>8,a[u+1]=i,i=i>>>8,a[u]=i}e.writeUInt32BE=f;function s(a,i){return a[i+0]<<0>>>0|a[i+1]<<8>>>0|a[i+2]<<16>>>0|a[i+3]<<24>>>0}e.readUInt32LE=s;function h(a,i,u){a[u+0]=i&255,i=i>>>8,a[u+1]=i&255,i=i>>>8,a[u+2]=i&255,i=i>>>8,a[u+3]=i&255}e.writeUInt32LE=h;function p(a,i){return a[i]}e.readUInt8=p;function m(a,i,u){a[u]=i}e.writeUInt8=m;function v(a){return S.consumeReadable(a,i=>n.concat(i))}e.readableToBuffer=v;function d(a){return S.toReadable(a)}e.bufferToReadable=d;function c(a){return S.consumeStream(a,i=>n.concat(i))}e.streamToBuffer=c;async function o(a){return a.ended?n.concat(a.buffer):n.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=o;function t(a){return S.toStream(a,i=>n.concat(i))}e.bufferToStream=t;function r(a){return S.transform(a,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=r;function l(a){return S.newWriteableStream(i=>n.concat(i),a)}e.newWriteableBufferStream=l}),define(we[56],Ee([0,1,8]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function S(m){return T(m,0)}e.hash=S;function T(m,v){switch(typeof m){case"object":return m===null?P(349,v):Array.isArray(m)?E(m,v):n(m,v);case"string":return k(m,v);case"boolean":return y(m,v);case"number":return P(m,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=T;function P(m,v){return(v<<5)-v+m|0}function y(m,v){return P(m?433:863,v)}function k(m,v){v=P(149417,v);for(let d=0,c=m.length;d<c;d++)v=P(m.charCodeAt(d),v);return v}e.stringHash=k;function E(m,v){return v=P(104579,v),m.reduce((d,c)=>T(c,d),v)}function n(m,v){return v=P(181387,v),Object.keys(m).sort().reduce((d,c)=>(d=k(c,d),T(m[c],d)),v)}class A{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=T(v,this._value),this._value}}e.Hasher=A;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function _(m,v,d=32){const c=d-v,o=~((1<<c)-1);return(m<<v|(o&m)>>>c)>>>0}function f(m,v=0,d=m.byteLength,c=0){for(let o=0;o<d;o++)m[v+o]=c}function s(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function h(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):s((m>>>0).toString(16),v/4)}e.toHexString=h;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d!==0){const c=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,l;for(t!==0?(r=t,l=-1,t=0):(r=v.charCodeAt(0),l=0);;){let a=r;if(b.isHighSurrogate(r))if(l+1<d){const i=v.charCodeAt(l+1);b.isLowSurrogate(i)?(l++,a=b.computeCodePoint(r,i)):a=65533}else{t=r;break}else b.isLowSurrogate(r)&&(a=65533);if(o=this._push(c,o,a),l++,l<d)r=v.charCodeAt(l);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(v,d,c){return c<128?v[d++]=c:c<2048?(v[d++]=192|(c&1984)>>>6,v[d++]=128|(c&63)>>>0):c<65536?(v[d++]=224|(c&61440)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0):(v[d++]=240|(c&1835008)>>>18,v[d++]=128|(c&258048)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,d=this._buffDV;for(let D=0;D<64;D+=4)v.setUint32(D,d.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)v.setUint32(D,_(v.getUint32(D-12,!1)^v.getUint32(D-32,!1)^v.getUint32(D-56,!1)^v.getUint32(D-64,!1),1),!1);let c=this._h0,o=this._h1,t=this._h2,r=this._h3,l=this._h4,a,i,u;for(let D=0;D<80;D++)D<20?(a=o&t|~o&r,i=1518500249):D<40?(a=o^t^r,i=1859775393):D<60?(a=o&t|o&r|t&r,i=2400959708):(a=o^t^r,i=3395469782),u=_(c,5)+a+l+i+v.getUint32(D*4,!1)&4294967295,l=r,r=t,t=_(o,30),o=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[47],Ee([0,1,8]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var S;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(S||(S={})),function(T){const P="error",y="warning",k="warn",E="info";function n(A){return A?b.equalsIgnoreCase(P,A)?T.Error:b.equalsIgnoreCase(y,A)||b.equalsIgnoreCase(k,A)?T.Warning:b.equalsIgnoreCase(E,A)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(S||(S={})),e.default=S}),define(we[12],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(i){return Array.isArray(i)}e.isArray=b;function S(i){return typeof i=="string"}e.isString=S;function T(i){return Array.isArray(i)&&i.every(u=>S(u))}e.isStringArray=T;function P(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=P;function y(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=y;function k(i){return i===!0||i===!1}e.isBoolean=k;function E(i){return typeof i=="undefined"}e.isUndefined=E;function n(i){return!A(i)}e.isDefined=n;function A(i){return E(i)||i===null}e.isUndefinedOrNull=A;function C(i,u){if(!i)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=C;function _(i){if(A(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=_;function f(...i){const u=[];for(let D=0;D<i.length;D++){const R=i[D];if(A(R))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);u.push(R)}return u}e.assertAllDefined=f;const s=Object.prototype.hasOwnProperty;function h(i){if(!P(i))return!1;for(let u in i)if(s.call(i,u))return!1;return!0}e.isEmptyObject=h;function p(i){return typeof i=="function"}e.isFunction=p;function m(...i){return i.length>0&&i.every(p)}e.areFunctions=m;function v(i,u){const D=Math.min(i.length,u.length);for(let R=0;R<D;R++)d(i[R],u[R])}e.validateConstraints=v;function d(i,u){if(S(u)){if(typeof i!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(p(u)){try{if(i instanceof u)return}catch(D){}if(!A(i)&&i.constructor===u||u.length===1&&u.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function c(i){let u=[],D=Object.getPrototypeOf(i);for(;Object.prototype!==D;)u=u.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return u}e.getAllPropertyNames=c;function o(i){const u=[];for(const D of c(i))typeof i[D]=="function"&&u.push(D);return u}e.getAllMethodNames=o;function t(i,u){const D=g=>function(){const w=Array.prototype.slice.call(arguments,0);return u(g,w)};let R={};for(const g of i)R[g]=D(g);return R}e.createProxyObject=t;function r(i){return i===null?void 0:i}e.withNullAsUndefined=r;function l(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=l;function a(i){return class{constructor(){return new Proxy({},{get(u,D){if(u[D])return u[D];throw new Error(`Not Implemented: ${i}->${String(D)}`)}})}}}e.NotImplementedProxy=a}),define(we[38],Ee([0,1,21,8,11,12]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(r){return r===47||r===92}e.isPathSeparator=y;function k(r){return r.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function E(r,l=T.posix.sep){if(!r)return"";const a=r.length,i=r.charCodeAt(0);if(y(i)){if(y(r.charCodeAt(1))&&!y(r.charCodeAt(2))){let D=3;const R=D;for(;D<a&&!y(r.charCodeAt(D));D++);if(R!==D&&!y(r.charCodeAt(D+1))){for(D+=1;D<a;D++)if(y(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,l)}}return l}else if(p(i)&&r.charCodeAt(1)===58)return y(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(y(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=E;function n(r){if(!b.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let a=2;const i=a;for(;a<r.length&&(l=r.charCodeAt(a),l!==92);a++);return!(i===a||(l=r.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,l=b.isWindows){const a=l?A:C;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||l&&_.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function s(r,l,a){const i=r===l;return!a||i?i:!r||!l?!1:(0,S.equalsIgnoreCase)(r,l)}e.isEqual=s;function h(r,l,a,i=T.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(a){if(!(0,S.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let D=l.length;return l.charAt(l.length-1)===i&&D--,r.charAt(D)===i}return l.charAt(l.length-1)!==i&&(l+=i),r.indexOf(l)===0}e.isEqualOrParent=h;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function m(r,l){return b.isWindows&&r.endsWith(":")&&(r+=T.sep),(0,T.isAbsolute)(r)||(r=(0,T.join)(l,r)),r=(0,T.normalize)(r),b.isWindows?(r=(0,S.rtrim)(r,T.sep),r.endsWith(":")&&(r+=T.sep)):(r=(0,S.rtrim)(r,T.sep),r||(r=T.sep)),r}e.sanitizeFilePath=m;function v(r){const l=(0,T.normalize)(r);return b.isWindows?r.length>3?!1:d(l)&&(r.length===2||l.charCodeAt(2)===92):l===T.posix.sep}e.isRootOrDriveLetter=v;function d(r){return b.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function c(r){return d(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,l,a){return l.length>r.length?-1:r===l?0:(a&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=o;function t(r){const l=r.split(":");let a,i,u;if(l.forEach(D=>{const R=Number(D);(0,P.isNumber)(R)?i===void 0?i=R:u===void 0&&(u=R):a=a?[a,D].join(":"):D}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:i!==void 0?i:void 0,column:u!==void 0?u:i!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[23],Ee([0,1,12]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function S(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const h=Array.isArray(s)?[]:{};return Object.keys(s).forEach(p=>{s[p]&&typeof s[p]=="object"?h[p]=S(s[p]):h[p]=s[p]}),h}e.deepClone=S;function T(s){if(!s||typeof s!="object")return s;const h=[s];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const m in p)if(P.call(p,m)){const v=p[m];typeof v=="object"&&!Object.isFrozen(v)&&h.push(v)}}return s}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function y(s,h){return k(s,h,new Set)}e.cloneAndChange=y;function k(s,h,p){if((0,b.isUndefinedOrNull)(s))return s;const m=h(s);if(typeof m!="undefined")return m;if((0,b.isArray)(s)){const v=[];for(const d of s)v.push(k(d,h,p));return v}if((0,b.isObject)(s)){if(p.has(s))throw new Error("Cannot clone recursive data-structure");p.add(s);const v={};for(let d in s)P.call(s,d)&&(v[d]=k(s[d],h,p));return p.delete(s),v}return s}function E(s,h,p=!0){return(0,b.isObject)(s)?((0,b.isObject)(h)&&Object.keys(h).forEach(m=>{m in s?p&&((0,b.isObject)(s[m])&&(0,b.isObject)(h[m])?E(s[m],h[m],p):s[m]=h[m]):s[m]=h[m]}),s):h}e.mixin=E;function n(s,h){if(s===h)return!0;if(s==null||h===null||h===void 0||typeof s!=typeof h||typeof s!="object"||Array.isArray(s)!==Array.isArray(h))return!1;let p,m;if(Array.isArray(s)){if(s.length!==h.length)return!1;for(p=0;p<s.length;p++)if(!n(s[p],h[p]))return!1}else{const v=[];for(m in s)v.push(m);v.sort();const d=[];for(m in h)d.push(m);if(d.sort(),!n(v,d))return!1;for(p=0;p<v.length;p++)if(!n(s[v[p]],h[v[p]]))return!1}return!0}e.equals=n;function A(s){const h=new Set;return JSON.stringify(s,(p,m)=>{if((0,b.isObject)(m)||Array.isArray(m)){if(h.has(m))return"[Circular]";h.add(m)}return m})}e.safeStringify=A;function C(s,h,p){const m=h(s);return typeof m=="undefined"?p:m}e.getOrDefault=C;function _(s,h){const p=Object.create(null);return!s||!h||Object.keys(h).forEach(v=>{const d=s[v],c=h[v];n(d,c)||(p[v]=c)}),p}e.distinct=_;function f(s,h){const p=h.toLowerCase(),m=Object.keys(s).find(v=>v.toLowerCase()===p);return m?s[m]:s[h]}e.getCaseInsensitive=f}),define(we[79],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function S(P){return P<0?0:P>255?255:P|0}e.toUint8=S;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(we[2],Ee([0,1,21,11]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function k(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(l,a){return!l&&!a?"file":l}function n(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const A="",C="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(a,i,u,D,R,g=!1){typeof a=="object"?(this.scheme=a.scheme||A,this.authority=a.authority||A,this.path=a.path||A,this.query=a.query||A,this.fragment=a.fragment||A):(this.scheme=E(a,g),this.authority=i||A,this.path=n(this.scheme,u||A),this.query=D||A,this.fragment=R||A,k(this,g))}static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:i,authority:u,path:D,query:R,fragment:g}=a;return i===void 0?i=this.scheme:i===null&&(i=A),u===void 0?u=this.authority:u===null&&(u=A),D===void 0?D=this.path:D===null&&(D=A),R===void 0?R=this.query:R===null&&(R=A),g===void 0?g=this.fragment:g===null&&(g=A),i===this.scheme&&u===this.authority&&D===this.path&&R===this.query&&g===this.fragment?this:new h(i,u,D,R,g)}static parse(a,i=!1){const u=_.exec(a);return u?new h(u[2]||A,r(u[4]||A),r(u[5]||A),r(u[7]||A),r(u[9]||A),i):new h(A,A,A,A,A)}static file(a){let i=A;if(b.isWindows&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const u=a.indexOf(C,2);u===-1?(i=a.substring(2),a=C):(i=a.substring(2,u),a=a.substring(u)||C)}return new h("file",i,a,A,A)}static from(a){return new h(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...i){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return b.isWindows&&a.scheme==="file"?u=f.file(S.win32.join(d(a,!0),...i)).path:u=S.posix.join(a.path,...i),a.with({path:u})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const i=new h(a);return i._formatted=a.external,i._fsPath=a._sep===s?a.fsPath:null,i}}else return a}}e.URI=f;const s=b.isWindows?1:void 0;class h extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=s),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(l,a){let i,u=-1;for(let D=0;D<l.length;D++){const R=l.charCodeAt(D);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||a&&R===47)u!==-1&&(i+=encodeURIComponent(l.substring(u,D)),u=-1),i!==void 0&&(i+=l.charAt(D));else{i===void 0&&(i=l.substr(0,D));const g=p[R];g!==void 0?(u!==-1&&(i+=encodeURIComponent(l.substring(u,D)),u=-1),i+=g):u===-1&&(u=D)}}return u!==-1&&(i+=encodeURIComponent(l.substring(u))),i!==void 0?i:l}function v(l){let a;for(let i=0;i<l.length;i++){const u=l.charCodeAt(i);u===35||u===63?(a===void 0&&(a=l.substr(0,i)),a+=p[u]):a!==void 0&&(a+=l[i])}return a!==void 0?a:l}function d(l,a){let i;return l.authority&&l.path.length>1&&l.scheme==="file"?i=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?i=l.path.substr(1):i=l.path[1].toLowerCase()+l.path.substr(2):i=l.path,b.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=d;function c(l,a){const i=a?v:m;let u="",{scheme:D,authority:R,path:g,query:w,fragment:I}=l;if(D&&(u+=D,u+=":"),(R||D==="file")&&(u+=C,u+=C),R){let F=R.indexOf("@");if(F!==-1){const B=R.substr(0,F);R=R.substr(F+1),F=B.indexOf(":"),F===-1?u+=i(B,!1):(u+=i(B.substr(0,F),!1),u+=":",u+=i(B.substr(F+1),!1)),u+="@"}R=R.toLowerCase(),F=R.indexOf(":"),F===-1?u+=i(R,!1):(u+=i(R.substr(0,F),!1),u+=R.substr(F))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const F=g.charCodeAt(1);F>=65&&F<=90&&(g=`/${String.fromCharCode(F+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const F=g.charCodeAt(0);F>=65&&F<=90&&(g=`${String.fromCharCode(F+32)}:${g.substr(2)}`)}u+=i(g,!0)}return w&&(u+="?",u+=i(w,!1)),I&&(u+="#",u+=a?I:m(I,!1)),u}function o(l){try{return decodeURIComponent(l)}catch(a){return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(l){return l.match(t)?l.replace(t,a=>o(a)):l}}),define(we[22],Ee([0,1,2,8]),function(oe,e,b,S){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(c,o,t){let r=c.get(o);return r===void 0&&(r=t,c.set(o,r)),r}e.getOrSet=y;function k(c){const o=[];return c.forEach((t,r)=>{o.push(`${r} => ${t}`)}),`Map(${c.size}) {${o.join(", ")}}`}e.mapToString=k;function E(c){const o=[];return c.forEach(t=>{o.push(t)}),`Set(${c.size}) {${o.join(", ")}}`}e.setToString=E;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,S.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class C{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,S.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var _;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(_||(_={}));class f{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,S.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,S.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,S.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,S.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class h{constructor(o){this._iter=o}static forUris(o=()=>!1){return new h(new f(o))}static forPaths(){return new h(new C)}static forStrings(){return new h(new n)}static forConfigKeys(){return new h(new A)}clear(){this._root=void 0}set(o,t){const r=this._iter.reset(o);let l;for(this._root||(this._root=new s,this._root.segment=r.value()),l=this._root;;){const i=r.cmp(l.segment);if(i>0)l.left||(l.left=new s,l.left.segment=r.value()),l=l.left;else if(i<0)l.right||(l.right=new s,l.right.segment=r.value()),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new s,l.mid.segment=r.value()),l=l.mid;else break}const a=l.value;return l.value=t,l.key=o,a}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const l=t.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const r=this._iter.reset(o),l=[];let a=this._root;for(;a;){const i=r.cmp(a.segment);if(i>0)l.push([1,a]),a=a.left;else if(i<0)l.push([-1,a]),a=a.right;else if(r.hasNext())r.next(),l.push([0,a]),a=a.mid;else{for(t?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;l.length>0&&a.isEmpty();){let[u,D]=l.pop();switch(u){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}a=D}break}}}findSubstr(o){const t=this._iter.reset(o);let r=this._root,l;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const l=t.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(o){for(const[t,r]of this)o(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=h;class p{constructor(o,t){this[T]="ResourceMap",o instanceof p?(this.map=new Map(o.map),this.toKey=t!=null?t:p.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:p.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[r,l]of this.map)o(l,b.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield b.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[b.URI.parse(o[0]),o[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[b.URI.parse(o[0]),o[1]]}}e.ResourceMap=p,p.defaultToKey=c=>c.toString();var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class v{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const r=this._map.get(o);if(!!r)return t!==0&&this.touch(r,t),r.value}set(o,t,r=0){let l=this._map.get(o);if(l)l.value=t,r!==0&&this.touch(l,r);else{switch(l={key:o,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(o,l),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const r=this._state;let l=this._head;for(;l;){if(t?o.bind(t)(l.value,l.key,this):o(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,t=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.key,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return l}values(){const o=this,t=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.value,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return l}entries(){const o=this,t=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:[r.key,r.value],done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return l}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>o;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,r=o.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const r=o.next,l=o.previous;o===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const r=o.next,l=o.previous;o===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,r)=>{o.push([r,t])}),o}fromJSON(o){this.clear();for(const[t,r]of o)this.set(t,r)}}e.LinkedMap=v;class d extends v{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(we[107],Ee([0,1,22,8]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...pe){return function(Ce,Te){for(let Ue=0,be=pe.length;Ue<be;Ue++){const Ke=pe[Ue](Ce,Te);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(pe,Ce,Te){if(!Te||Te.length<Ce.length)return null;let Ue;return pe?Ue=S.startsWithIgnoreCase(Te,Ce):Ue=Te.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(pe,Ce){const Te=Ce.toLowerCase().indexOf(pe.toLowerCase());return Te===-1?null:[{start:Te,end:Te+pe.length}]}e.matchesContiguousSubString=y;function k(pe,Ce){return E(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=k;function E(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]===Ce[Ue]){let be=null;return(be=E(pe,Ce,Te+1,Ue+1))?m({start:Ue,end:Ue+1},be):null}return E(pe,Ce,Te,Ue+1)}function n(pe){return 97<=pe&&pe<=122}function A(pe){return 65<=pe&&pe<=90}e.isUpper=A;function C(pe){return 48<=pe&&pe<=57}function _(pe){return pe===32||pe===9||pe===10||pe===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>f.add(pe.charCodeAt(0)));function s(pe){return _(pe)||f.has(pe)}function h(pe,Ce){return pe===Ce||s(pe)&&s(Ce)}function p(pe){return n(pe)||A(pe)||C(pe)}function m(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function v(pe,Ce){for(let Te=Ce;Te<pe.length;Te++){const Ue=pe.charCodeAt(Te);if(A(Ue)||C(Ue)||Te>0&&!p(pe.charCodeAt(Te-1)))return Te}return pe.length}function d(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]!==Ce[Ue].toLowerCase())return null;{let be=null,Ke=Ue+1;for(be=d(pe,Ce,Te+1,Ue+1);!be&&(Ke=v(Ce,Ke))<Ce.length;)be=d(pe,Ce,Te+1,Ke),Ke++;return be===null?null:m({start:Ue,end:Ue+1},be)}}function c(pe){let Ce=0,Te=0,Ue=0,be=0,Ke=0;for(let He=0;He<pe.length;He++)Ke=pe.charCodeAt(He),A(Ke)&&Ce++,n(Ke)&&Te++,p(Ke)&&Ue++,C(Ke)&&be++;const V=Ce/pe.length,X=Te/pe.length,_e=Ue/pe.length,Me=be/pe.length;return{upperPercent:V,lowerPercent:X,alphaPercent:_e,numericPercent:Me}}function o(pe){const{upperPercent:Ce,lowerPercent:Te}=pe;return Te===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Te,alphaPercent:Ue,numericPercent:be}=pe;return Te>.2&&Ce<.8&&Ue>.6&&be<.2}function r(pe){let Ce=0,Te=0,Ue=0,be=0;for(let Ke=0;Ke<pe.length;Ke++)Ue=pe.charCodeAt(Ke),A(Ue)&&Ce++,n(Ue)&&Te++,_(Ue)&&be++;return(Ce===0||Te===0)&&be===0?pe.length<=30:Ce<=5}function l(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(pe)||Ce.length>60)return null;const Te=c(Ce);if(!t(Te)){if(!o(Te))return null;Ce=Ce.toLowerCase()}let Ue=null,be=0;for(pe=pe.toLowerCase();be<Ce.length&&(Ue=d(pe,Ce,0,be))===null;)be=v(Ce,be+1);return Ue}e.matchesCamelCase=l;function a(pe,Ce,Te=!1){if(!Ce||Ce.length===0)return null;let Ue=null,be=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(Ue=i(pe,Ce,0,be,Te))===null;)be=u(Ce,be+1);return Ue}e.matchesWords=a;function i(pe,Ce,Te,Ue,be){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(h(pe.charCodeAt(Te),Ce.charCodeAt(Ue))){let Ke=null,V=Ue+1;if(Ke=i(pe,Ce,Te+1,Ue+1,be),!be)for(;!Ke&&(V=u(Ce,V))<Ce.length;)Ke=i(pe,Ce,Te+1,V,be),V++;return Ke===null?null:m({start:Ue,end:Ue+1},Ke)}else return null}function u(pe,Ce){for(let Te=Ce;Te<pe.length;Te++)if(s(pe.charCodeAt(Te))||Te>0&&s(pe.charCodeAt(Te-1)))return Te;return pe.length}const D=T(e.matchesPrefix,l,y),R=T(e.matchesPrefix,l,k),g=new b.LRUCache(1e4);function w(pe,Ce,Te=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let Ue=g.get(pe);Ue||(Ue=new RegExp(S.convertSimple2RegExpPattern(pe),"i"),g.set(pe,Ue));const be=Ue.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Te?R(pe,Ce):D(pe,Ce)}e.matchesFuzzy=w;function I(pe,Ce){const Te=W(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Te?B(Te):null}e.matchesFuzzy2=I;function F(pe,Ce,Te,Ue,be,Ke){const V=Math.min(13,pe.length);for(;Te<V;Te++){const X=W(pe,Ce,Te,Ue,be,Ke,!1);if(X)return X}return[0,Ke]}e.anyScore=F;function B(pe){if(typeof pe=="undefined")return[];const Ce=[],Te=pe[1];for(let Ue=pe.length-1;Ue>1;Ue--){const be=pe[Ue]+Te,Ke=Ce[Ce.length-1];Ke&&Ke.end===be?Ke.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=B;const le=128;function H(){const pe=[],Ce=[];for(let Te=0;Te<=le;Te++)Ce[Te]=0;for(let Te=0;Te<=le;Te++)pe.push(Ce.slice(0));return pe}function z(pe){const Ce=[];for(let Te=0;Te<=pe;Te++)Ce[Te]=0;return Ce}const K=z(2*le),L=z(2*le),$=H(),U=H(),G=H(),N=!1;function Z(pe,Ce,Te,Ue,be){function Ke(X,_e,Me=" "){for(;X.length<_e;)X=Me+X;return X}let V=` |   |${Ue.split("").map(X=>Ke(X,3)).join("|")}
`;for(let X=0;X<=Te;X++)X===0?V+=" |":V+=`${Ce[X-1]}|`,V+=pe[X].slice(0,be+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return V}function ne(pe,Ce,Te,Ue){pe=pe.substr(Ce),Te=Te.substr(Ue),console.log(Z(U,pe,pe.length,Te,Te.length)),console.log(Z(G,pe,pe.length,Te,Te.length)),console.log(Z($,pe,pe.length,Te,Te.length))}function re(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Te=pe.codePointAt(Ce);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!S.isEmojiImprecise(Te)}}function ye(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ae(pe,Ce,Te){return Ce[pe]!==Te[pe]}function Be(pe,Ce,Te,Ue,be,Ke,V=!1){for(;Ce<Te&&be<Ke;)pe[Ce]===Ue[be]&&(V&&(K[Ce]=be),Ce+=1),be+=1;return Ce===Te}e.isPatternInWord=Be;var Re;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var xe;(function(pe){pe.Default=[-100,0];function Ce(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}pe.isDefault=Ce})(xe=e.FuzzyScore||(e.FuzzyScore={}));function W(pe,Ce,Te,Ue,be,Ke,V){const X=pe.length>le?le:pe.length,_e=Ue.length>le?le:Ue.length;if(!(Te>=X||Ke>=_e||X-Te>_e-Ke)&&!!Be(Ce,Te,X,be,Ke,_e,!0)){q(X,_e,Te,Ke,Ce,be);let Me=1,He=1,Oe=Te,Xe=Ke;const x=[!1];for(Me=1,Oe=Te;Oe<X;Me++,Oe++){const se=K[Oe],fe=L[Oe],ve=Oe+1<X?L[Oe+1]:_e;for(He=se-Ke+1,Xe=se;Xe<ve;He++,Xe++){let $e=Number.MIN_SAFE_INTEGER,Ne=!1;Xe<=fe&&($e=J(pe,Ce,Oe,Te,Ue,be,Xe,_e,Ke,$[Me-1][He-1]===0,x));let Ve=0;$e!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=$e+U[Me-1][He-1]);const Qe=Xe>se,Ze=Qe?U[Me][He-1]+($[Me][He-1]>0?-5:0):0,ct=Xe>se+1&&$[Me][He-1]>0,st=ct?U[Me][He-2]+($[Me][He-2]>0?-5:0):0;if(ct&&(!Qe||st>=Ze)&&(!Ne||st>=Ve))U[Me][He]=st,G[Me][He]=3,$[Me][He]=0;else if(Qe&&(!Ne||Ze>=Ve))U[Me][He]=Ze,G[Me][He]=2,$[Me][He]=0;else if(Ne)U[Me][He]=Ve,G[Me][He]=1,$[Me][He]=$[Me-1][He-1]+1;else throw new Error("not possible")}}if(N&&ne(pe,Te,Ue,Ke),!(!x[0]&&!V)){Me--,He--;const ie=[U[Me][He],Ke];let ce=0,j=0;for(;Me>=1;){let se=He;do{const fe=G[Me][se];if(fe===3)se=se-2;else if(fe===2)se=se-1;else break}while(se>=1);ce>1&&Ce[Te+Me-1]===be[Ke+He-1]&&!Ae(se+Ke-1,Ue,be)&&ce+1>$[Me][se]&&(se=He),se===He?ce++:ce=1,j||(j=se),Me--,He=se-1,ie.push(He)}_e===X&&(ie[0]+=2);const Y=j-X;return ie[0]-=Y,ie}}}e.fuzzyScore=W;function q(pe,Ce,Te,Ue,be,Ke){let V=pe-1,X=Ce-1;for(;V>=Te&&X>=Ue;)be[V]===Ke[X]&&(L[V]=X,V--),X--}function J(pe,Ce,Te,Ue,be,Ke,V,X,_e,Me,He){if(Ce[Te]!==Ke[V])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return V===Te-Ue?Oe=pe[Te]===be[V]?7:5:Ae(V,be,Ke)&&(V===0||!Ae(V-1,be,Ke))?(Oe=pe[Te]===be[V]?7:5,Xe=!0):re(Ke,V)&&(V===0||!re(Ke,V-1))?Oe=5:(re(Ke,V-1)||ye(Ke,V-1))&&(Oe=5,Xe=!0),Oe>1&&Te===Ue&&(He[0]=!0),Xe||(Xe=Ae(V,be,Ke)||re(Ke,V-1)||ye(Ke,V-1)),Te===Ue?V>_e&&(Oe-=Xe?3:5):Me?Oe+=Xe?2:0:Oe+=Xe?0:1,V+1===X&&(Oe-=Xe?3:5),Oe}function ae(pe,Ce,Te,Ue,be,Ke,V){return De(pe,Ce,Te,Ue,be,Ke,!0,V)}e.fuzzyScoreGracefulAggressive=ae;function ge(pe,Ce,Te,Ue,be,Ke,V){return De(pe,Ce,Te,Ue,be,Ke,!1,V)}e.fuzzyScoreGraceful=ge;function De(pe,Ce,Te,Ue,be,Ke,V,X){let _e=W(pe,Ce,Te,Ue,be,Ke,X);if(_e&&!V)return _e;if(pe.length>=3){const Me=Math.min(7,pe.length-1);for(let He=Te+1;He<Me;He++){const Oe=Le(pe,He);if(Oe){const Xe=W(Oe,Oe.toLowerCase(),Te,Ue,be,Ke,X);Xe&&(Xe[0]-=3,(!_e||Xe[0]>_e[0])&&(_e=Xe))}}}return _e}function Le(pe,Ce){if(!(Ce+1>=pe.length)){const Te=pe[Ce],Ue=pe[Ce+1];if(Te!==Ue)return pe.slice(0,Ce)+Ue+Te+pe.slice(Ce+2)}}}),define(we[108],Ee([0,1,37,107,8]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${P.source}`,"g");function k(h){return h.replace(y,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=k;const E=new RegExp(`\\\\${P.source}`,"g");function n(h){return h.replace(E,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=n;const A=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function C(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(A,(p,m,v,d)=>v?p:m||d||"")}e.stripIcons=C;function _(h){const p=h.indexOf(e.iconStartMarker);return p===-1?{text:h}:f(h,p)}e.parseLabelWithIcons=_;function f(h,p){const m=[];let v="";function d(u){if(u){v+=u;for(const D of u)m.push(t)}}let c=-1,o="",t=0,r,l,a=p;const i=h.length;for(d(h.substr(0,p));a<i;)r=h[a],l=h[a+1],r===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(c=a,d(o),o=e.iconStartMarker,a++):r===")"&&c!==-1?(t+=a-c+1,c=-1,o=""):c!==-1?/^[a-z0-9\-]$/i.test(r)?o+=r:(d(o),c=-1,o=""):d(r),a++;return d(o),{text:v,iconOffsets:m}}function s(h,p,m=!1){const{text:v,iconOffsets:d}=p;if(!d||d.length===0)return(0,S.matchesFuzzy)(h,v,m);const c=(0,T.ltrim)(v," "),o=v.length-c.length,t=(0,S.matchesFuzzy)(h,c,m);if(t)for(const r of t){const l=d[r.start+o]+o;r.start+=l,r.end+=l}return t}e.matchesFuzzyIconAware=s}),define(we[80],Ee([0,1,15,108,10]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",p=!1){var m,v;if(this.value=h,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(v=p.supportThemeIcons)!==null&&v!==void 0?v:!1)}appendText(h,p=0){return this.value+=C(this.supportThemeIcons?(0,S.escapeIcons)(h):h).replace(/([ \t]+)/g,(m,v)=>"&nbsp;".repeat(v.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function k(s){return E(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function E(s){return s instanceof y?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function n(s,h){return!s&&!h?!0:!s||!h?!1:Array.isArray(s)&&Array.isArray(h)?(0,b.equals)(s,h,A):E(s)&&E(h)?A(s,h):!1}e.markedStringsEquals=n;function A(s,h){return s===h?!0:!s||!h?!1:s.value===h.value&&s.isTrusted===h.isTrusted&&s.supportThemeIcons===h.supportThemeIcons}function C(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function _(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=_;function f(s){const h=[],p=s.split("|").map(v=>v.trim());s=p[0];const m=p[1];if(m){const v=/height=(\d+)/.exec(m),d=/width=(\d+)/.exec(m),c=v?v[1]:"",o=d?d[1]:"",t=isFinite(parseInt(o)),r=isFinite(parseInt(c));t&&h.push(`width="${o}"`),r&&h.push(`height="${c}"`)}return{href:s,dimensions:h}}e.parseHrefAndDimensions=f}),define(we[57],Ee([0,1,26,8,2]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,k)}e.stringify=P;function y(n){let A=JSON.parse(n);return A=E(A),A}e.parse=y;function k(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,S.regExpFlags)(A)}:A}function E(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof b.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=E(n[C],A+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=E(n[C],A+1))}return n}e.revive=E}),define(we[16],Ee([0,1,2,21]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.vscodeWebviewResource="vscode-webview-resource",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,n,A){this._hosts[E]=n,this._ports[E]=A}setConnectionToken(E,n){this._connectionTokens[E]=n}rewrite(E){if(this._delegate)return this._delegate(E);const n=E.authority;let A=this._hosts[n];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const C=this._ports[n],_=this._connectionTokens[n];let f=`path=${encodeURIComponent(E.path)}`;return typeof _=="string"&&(f+=`&tkn=${encodeURIComponent(_)}`),b.URI.from({scheme:S.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${A}:${C}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new P;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,n,A){const C=this.toUri(E,n);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):S.isNative&&(A||S.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(E,n){const A=this.toUri(E,n);return A.scheme===T.vscodeFileResource?A.with({scheme:T.file,authority:A.authority!==this.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(E,n){return b.URI.isUri(E)?E:b.URI.parse(n.toUrl(E))}}e.FileAccess=new y}),define(we[24],Ee([0,1,38,11,2,8,16,21]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(f){return(0,T.uriToFsPath)(f,!0)}e.originalFSPath=E;class n{constructor(s){this._ignorePathCasing=s}compare(s,h,p=!1){return s===h?0:(0,P.compare)(this.getComparisonKey(s,p),this.getComparisonKey(h,p))}isEqual(s,h,p=!1){return s===h?!0:!s||!h?!1:this.getComparisonKey(s,p)===this.getComparisonKey(h,p)}getComparisonKey(s,h=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,h,p=!1){if(s.scheme===h.scheme){if(s.scheme===y.Schemas.file)return b.isEqualOrParent(E(s),E(h),this._ignorePathCasing(s))&&s.query===h.query&&(p||s.fragment===h.fragment);if((0,e.isEqualAuthority)(s.authority,h.authority))return b.isEqualOrParent(s.path,h.path,this._ignorePathCasing(s),"/")&&s.query===h.query&&(p||s.fragment===h.fragment)}return!1}joinPath(s,...h){return T.URI.joinPath(s,...h)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return S.posix.basename(s.path)}extname(s){return S.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let h;return s.scheme===y.Schemas.file?h=T.URI.file(S.dirname(E(s))).path:(h=S.posix.dirname(s.path),s.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),h="/")),s.with({path:h})}normalizePath(s){if(!s.path.length)return s;let h;return s.scheme===y.Schemas.file?h=T.URI.file(S.normalize(E(s))).path:h=S.posix.normalize(s.path),s.with({path:h})}relativePath(s,h){if(!(s.scheme!==h.scheme||!(0,e.isEqualAuthority)(s.authority,h.authority))){if(s.scheme===y.Schemas.file){const v=S.relative(E(s),E(h));return k.isWindows?b.toSlashes(v):v}let p=s.path||"/",m=h.path||"/";if(this._ignorePathCasing(s)){let v=0;for(const d=Math.min(p.length,m.length);v<d&&!(p.charCodeAt(v)!==m.charCodeAt(v)&&p.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);p=m.substr(0,v)+p.substr(v)}return S.posix.relative(p,m)}}resolvePath(s,h){if(s.scheme===y.Schemas.file){const p=T.URI.file(S.resolve(E(s),h));return s.with({authority:p.authority,path:p.path})}return h.indexOf("/")===-1&&(h=b.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),s.with({path:S.posix.resolve(s.path,h)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,h){return s===h||(0,P.equalsIgnoreCase)(s,h)}hasTrailingPathSeparator(s,h=S.sep){if(s.scheme===y.Schemas.file){const p=E(s);return p.length>b.getRoot(p).length&&p[p.length-1]===h}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,h=S.sep){return(0,e.hasTrailingPathSeparator)(s,h)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,h=S.sep){let p=!1;if(s.scheme===y.Schemas.file){const m=E(s);p=m!==void 0&&m.length===b.getRoot(m).length&&m[m.length-1]===h}else{h="/";const m=s.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,h)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(f,s){const h=[];for(let p=0;p<f.length;p++){const m=s(f[p]);f.some((v,d)=>d===p?!1:(0,e.isEqualOrParent)(m,s(v)))||h.push(f[p])}return h}e.distinctParents=A;var C;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function s(h){const p=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,o]=d.split(":");c&&o&&p.set(c,o)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&p.set(f.META_DATA_MIME,v),p}f.parseMetaData=s})(C=e.DataUri||(e.DataUri={}));function _(f,s,h){if(s){let p=f.path;return p&&p[0]!==S.posix.sep&&(p=S.posix.sep+p),f.with({scheme:h,authority:s,path:p})}return f.with({scheme:h})}e.toLocalResource=_}),define(we[13],Ee([0,1,20,10,3,6,46,24]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(U){return!!U&&typeof U.then=="function"}e.isThenable=E;function n(U){const G=new b.CancellationTokenSource,N=U(G.token),Z=new Promise((ne,re)=>{G.token.onCancellationRequested(()=>{re((0,S.canceled)())}),Promise.resolve(N).then(ye=>{G.dispose(),ne(ye)},ye=>{G.dispose(),re(ye)})});return new class{cancel(){G.cancel()}then(ne,re){return Z.then(ne,re)}catch(ne){return this.then(void 0,ne)}finally(ne){return Z.finally(ne)}}}e.createCancelablePromise=n;function A(U,G,N){return Promise.race([U,new Promise(Z=>G.onCancellationRequested(()=>Z(N)))])}e.raceCancellation=A;async function C(U){let G=-1;const N=U.map((ne,re)=>ne.then(ye=>(G=re,ye))),Z=await Promise.race(N);return U.forEach((ne,re)=>{re!==G&&ne.cancel()}),Z}e.raceCancellablePromises=C;function _(U,G,N){let Z;const ne=setTimeout(()=>{Z==null||Z(void 0),N==null||N()},G);return Promise.race([U.finally(()=>clearTimeout(ne)),new Promise(re=>Z=re)])}e.raceTimeout=_;function f(U){return new Promise((G,N)=>{const Z=U();E(Z)?Z.then(G,N):G(Z)})}e.asPromise=f;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(N,N).then(Z)})}return new Promise((N,Z)=>{this.queuedPromise.then(N,Z)})}return this.activePromise=G(),new Promise((N,Z)=>{this.activePromise.then(ne=>{this.activePromise=null,N(ne)},ne=>{this.activePromise=null,Z(ne)})})}}e.Throttler=s;class h{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=h;class p{constructor(){this.promiseMap=new Map}queue(G,N){var Z;const re=((Z=this.promiseMap.get(G))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(G)===re&&this.promiseMap.delete(G)});return this.promiseMap.set(G,re),re}}e.SequencerByKey=p;class m{constructor(G){this.defaultDelay=G,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,N=this.defaultDelay){return this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,ne)=>{this.doResolve=Z,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,S.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class v{constructor(G){this.delayer=new m(G),this.throttler=new s}trigger(G,N){return this.delayer.trigger(()=>this.throttler.queue(G),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class d{constructor(){this._isOpen=!1,this._promise=new Promise((G,N)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class c extends d{constructor(G){super();this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function o(U,G){return G?new Promise((N,Z)=>{const ne=setTimeout(N,U);G.onCancellationRequested(()=>{clearTimeout(ne),Z((0,S.canceled)())})}):n(N=>o(U,N))}e.timeout=o;function t(U,G=0){const N=setTimeout(U,G);return(0,P.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=t;function r(U){return U.then(void 0,G=>{})}e.ignoreErrors=r;function l(U){const G=[];let N=0;const Z=U.length;function ne(){return N<Z?U[N++]():null}function re(ye){ye!=null&&G.push(ye);const Ae=ne();return Ae?Ae.then(re):Promise.resolve(G)}return Promise.resolve(null).then(re)}e.sequence=l;function a(U,G=Z=>!!Z,N=null){let Z=0;const ne=U.length,re=()=>{if(Z>=ne)return Promise.resolve(N);const ye=U[Z++];return Promise.resolve(ye()).then(Be=>G(Be)?Promise.resolve(Be):re())};return re()}e.first=a;function i(U,G=Z=>!!Z,N=null){if(U.length===0)return Promise.resolve(N);let Z=U.length;const ne=()=>{var re,ye;Z=-1;for(const Ae of U)(ye=(re=Ae).cancel)===null||ye===void 0||ye.call(re)};return new Promise((re,ye)=>{for(const Ae of U)Ae.then(Be=>{--Z>=0&&G(Be)?(ne(),re(Be)):Z===0&&re(N)}).catch(Be=>{--Z>=0&&(ne(),ye(Be))})})}e.firstParallel=i;class u{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(G){return this._size++,new Promise((N,Z)=>{this.outstandingPromises.push({factory:G,c:N,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const N=G.factory();N.then(G.c,G.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class D extends u{constructor(){super(1)}}e.Queue=D;class R{constructor(){this.queues=new Map}queueFor(G,N=k.extUri){const Z=N.getComparisonKey(G);let ne=this.queues.get(Z);return ne||(ne=new D,T.Event.once(ne.onFinished)(()=>{ne==null||ne.dispose(),this.queues.delete(Z)}),this.queues.set(Z,ne)),ne}dispose(){this.queues.forEach(G=>G.dispose()),this.queues.clear()}}e.ResourceQueue=R;class g{constructor(G,N){this._token=-1,typeof G=="function"&&typeof N=="number"&&this.setIfNotSet(G,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},N)}setIfNotSet(G,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},N))}}e.TimeoutTimer=g;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,N){this.cancel(),this._token=setInterval(()=>{G()},N)}}e.IntervalTimer=w;class I{constructor(G,N){this.timeoutToken=-1,this.runner=G,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class F extends I{constructor(G,N){super(G,N);this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner&&this.runner(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=G=>{const N=setTimeout(()=>G(U));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout(N))}}}}else e.runWhenIdle=(U,G)=>{const N=requestIdleCallback(U,typeof G=="number"?{timeout:G}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(N))}}}}();class B{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function le(U,G,N){let Z;for(let ne=0;ne<N;ne++)try{return await U()}catch(re){Z=re,await o(G)}throw Z}e.retry=le;class H{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var G;(G=this._pending)===null||G===void 0||G.cancel()}setPending(G,N,Z){return this._pending={taskId:G,cancel:()=>Z==null?void 0:Z(),promise:N},N.then(()=>this.donePending(G),()=>this.donePending(G)),N}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let N,Z;const ne=new Promise((re,ye)=>{N=re,Z=ye});this._next={run:G,promise:ne,promiseResolve:N,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=H;class z{constructor(G){this.interval=G,this.lastIncrementTime=0,this.value=0}increment(){const G=Date.now();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,N)=>{this.completeCallback=G,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(G){return new Promise(N=>{this.completeCallback(G),this.resolved=!0,N()})}error(G){return new Promise(N=>{this.errorCallback(G),this.rejected=!0,N()})}cancel(){new Promise(G=>{this.errorCallback((0,S.canceled)()),this.rejected=!0,G()})}}e.DeferredPromise=K;class L extends T.Emitter{async fireAsync(G,N,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const ne of this._listeners)this._asyncDeliveryQueue.push([ne,G]);for(;this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[ne,re]=this._asyncDeliveryQueue.shift(),ye=[],Ae=Object.assign(Object.assign({},re),{waitUntil:Be=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Be=Z(Be,typeof ne=="function"?ne:ne[0])),ye.push(Be)}});try{typeof ne=="function"?ne.call(void 0,Ae):ne[0].call(ne[1],Ae)}catch(Be){(0,S.onUnexpectedError)(Be);continue}Object.freeze(ye),await $.settled(ye).catch(Be=>(0,S.onUnexpectedError)(Be))}}}}e.AsyncEmitter=L;var $;(function(U){async function G(re){return typeof Promise.allSettled=="function"?N(re):Z(re)}U.allSettled=G;async function N(re){return Promise.allSettled(re)}async function Z(re){return Promise.all(re.map(ye=>ye.then(Ae=>({status:"fulfilled",value:Ae}),Ae=>({status:"rejected",reason:Ae}))))}async function ne(re){let ye;const Ae=await Promise.all(re.map(Be=>Be.then(Re=>Re,Re=>{ye||(ye=Re)})));if(typeof ye!="undefined")throw ye;return Ae}U.settled=ne})($=e.Promises||(e.Promises={}))}),define(we[109],Ee([0,1,11,13]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new S.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),P=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(c,o,t=!1){const r=c||"",l=o||"",a=T.value.collator.compare(r,l);return T.value.collatorIsNumeric&&a===0&&r!==l?r<l?-1:1:a}e.compareFileNames=k;function E(c,o){const t=P.value.collator;return c=c||"",o=o||"",h(t,c,o)}e.compareFileNamesDefault=E;function n(c,o,t=!1){t||(c=c&&c.toLowerCase(),o=o&&o.toLowerCase());const[r,l]=f(c),[a,i]=f(o);return r!==a?r<a?-1:1:l===i?0:l<i?-1:1}e.noIntlCompareFileNames=n;function A(c,o){const[t,r]=f(c),[l,a]=f(o);let i=T.value.collator.compare(r,a);if(i===0){if(T.value.collatorIsNumeric&&r!==a)return r<a?-1:1;if(i=T.value.collator.compare(t,l),T.value.collatorIsNumeric&&i===0&&t!==l)return t<l?-1:1}return i}e.compareFileExtensions=A;function C(c,o){c=c||"",o=o||"";const t=s(c),r=s(o),l=P.value.collator,a=y.value.collator;let i;return i=h(a,t,r),i!==0?i:h(l,c,o)}e.compareFileExtensionsDefault=C;const _=/^(.*?)(\.([^.]*))?$/;function f(c,o=!1){const t=c?_.exec(c):[];let r=[t&&t[1]||"",t&&t[3]||""];return o&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function s(c){const o=c?_.exec(c):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function h(c,o,t){let r=c.compare(o,t);return r!==0?r:o.length!==t.length?o.length<t.length?-1:1:0}function p(c,o,t=!1){return t||(c=c&&c.toLowerCase(),o=o&&o.toLowerCase()),c===o?0:c<o?-1:1}function m(c,o,t=!1){const r=c.split(b.sep),l=o.split(b.sep),a=r.length-1,i=l.length-1;let u,D;for(let R=0;;R++){if(u=a===R,D=i===R,u&&D)return k(r[R],l[R],t);if(u)return-1;if(D)return 1;const g=p(r[R],l[R],t);if(g!==0)return g}}e.comparePaths=m;function v(c,o,t){const r=c.toLowerCase(),l=o.toLowerCase(),a=d(c,o,t);if(a)return a;const i=r.endsWith(t),u=l.endsWith(t);if(i!==u)return i?-1:1;const D=k(r,l);return D!==0?D:r.localeCompare(l)}e.compareAnything=v;function d(c,o,t){const r=c.toLowerCase(),l=o.toLowerCase(),a=r.startsWith(t),i=l.startsWith(t);if(a!==i)return a?-1:1;if(a&&i){if(r.length<l.length)return-1;if(r.length>l.length)return 1}return 0}e.compareByPrefix=d}),define(we[28],Ee([0,1,8,38,11,22,13]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const E="**",n="/",A="[/\\\\]",C="[^/\\\\]",_=/\//g;function f(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}|${A}${C}+)*?`}}function s(N,Z){if(!N)return[];const ne=[];let re=!1,ye=!1,Ae="";for(const Be of N){switch(Be){case Z:if(!re&&!ye){ne.push(Ae),Ae="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ae+=Be}return Ae&&ne.push(Ae),ne}e.splitGlobAware=s;function h(N){if(!N)return"";let Z="";const ne=s(N,n);if(ne.every(re=>re===E))Z=".*";else{let re=!1;ne.forEach((ye,Ae)=>{if(ye===E){re||(Z+=f(2),re=!0);return}let Be=!1,Re="",xe=!1,W="";for(const q of ye){if(q!=="}"&&Be){Re+=q;continue}if(xe&&(q!=="]"||!W)){let J;q==="-"?J=q:(q==="^"||q==="!")&&!W?J="^":q===n?J="":J=b.escapeRegExpCharacters(q),W+=J;continue}switch(q){case"{":Be=!0;continue;case"[":xe=!0;continue;case"}":Z+=`(?:${s(Re,",").map(ge=>h(ge)).join("|")})`,Be=!1,Re="";break;case"]":Z+="["+W+"]",xe=!1,W="";break;case"?":Z+=C;continue;case"*":Z+=f(1);continue;default:Z+=b.escapeRegExpCharacters(q)}}Ae<ne.length-1&&(ne[Ae+1]!==E||Ae+2<ne.length)&&(Z+=A),re=!1})}return Z}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),r=function(){return!1},l=function(){return null};function a(N,Z){if(!N)return l;let ne;typeof N!="string"?ne=N.pattern:ne=N,ne=ne.trim();const re=`${ne}_${!!Z.trimForExclusions}`;let ye=t.get(re);if(ye)return i(ye,N);let Ae;if(p.test(ne)){const Be=ne.substr(4);ye=function(Re,xe){return typeof Re=="string"&&Re.endsWith(Be)?ne:null}}else(Ae=m.exec(u(ne,Z)))?ye=D(Ae[1],ne):(Z.trimForExclusions?d:v).test(ne)?ye=R(ne,Z):(Ae=c.exec(u(ne,Z)))?ye=g(Ae[1].substr(1),ne,!0):(Ae=o.exec(u(ne,Z)))?ye=g(Ae[1],ne,!1):ye=w(ne);return t.set(re,ye),i(ye,N)}function i(N,Z){return typeof Z=="string"?N:function(ne,re){return S.isEqualOrParent(ne,Z.base)?N(T.relative(Z.base,ne),re):null}}function u(N,Z){return Z.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function D(N,Z){const ne=`/${N}`,re=`\\${N}`,ye=function(Be,Re){return typeof Be!="string"?null:Re?Re===N?Z:null:Be===N||Be.endsWith(ne)||Be.endsWith(re)?Z:null},Ae=[N];return ye.basenames=Ae,ye.patterns=[Z],ye.allBasenames=Ae,ye}function R(N,Z){const ne=G(N.slice(1,-1).split(",").map(Re=>a(Re,Z)).filter(Re=>Re!==l),N),re=ne.length;if(!re)return l;if(re===1)return ne[0];const ye=function(Re,xe){for(let W=0,q=ne.length;W<q;W++)if(ne[W](Re,xe))return N;return null},Ae=ne.find(Re=>!!Re.allBasenames);Ae&&(ye.allBasenames=Ae.allBasenames);const Be=ne.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function g(N,Z,ne){const re=T.sep===T.posix.sep,ye=re?N:N.replace(_,T.sep),Ae=T.sep+ye,Be=T.posix.sep+N,Re=ne?function(xe,W){return typeof xe=="string"&&(xe===ye||xe.endsWith(Ae)||!re&&(xe===N||xe.endsWith(Be)))?Z:null}:function(xe,W){return typeof xe=="string"&&(xe===ye||!re&&xe===N)?Z:null};return Re.allPaths=[(ne?"*/":"./")+N],Re}function w(N){try{const Z=new RegExp(`^${h(N)}$`);return function(ne){return Z.lastIndex=0,typeof ne=="string"&&Z.test(ne)?N:null}}catch(Z){return l}}function I(N,Z,ne){return!N||typeof Z!="string"?!1:F(N)(Z,void 0,ne)}e.match=I;function F(N,Z={}){if(!N)return r;if(typeof N=="string"||z(N)){const ne=a(N,Z);if(ne===l)return r;const re=function(ye,Ae){return!!ne(ye,Ae)};return ne.allBasenames&&(re.allBasenames=ne.allBasenames),ne.allPaths&&(re.allPaths=ne.allPaths),re}return $(N,Z)}e.parse=F;function B(N){if(!!N){let Z;return ne=>(Z||(Z=(N()||Promise.resolve([])).then(re=>re?H(re):{})),Z.then(re=>!!re[ne]))}}e.hasSiblingPromiseFn=B;function le(N){if(!!N){let Z;return ne=>{if(!Z){const re=N();Z=re?H(re):{}}return!!Z[ne]}}}e.hasSiblingFn=le;function H(N){const Z={};for(const ne of N)Z[ne]=!0;return Z}function z(N){const Z=N;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=z;function K(N){return N.allBasenames||[]}e.getBasenameTerms=K;function L(N){return N.allPaths||[]}e.getPathTerms=L;function $(N,Z){const ne=G(Object.getOwnPropertyNames(N).map(Re=>U(Re,N[Re],Z)).filter(Re=>Re!==l)),re=ne.length;if(!re)return l;if(!ne.some(Re=>!!Re.requiresSiblings)){if(re===1)return ne[0];const Re=function(q,J){for(let ae=0,ge=ne.length;ae<ge;ae++){const De=ne[ae](q,J);if(De)return De}return null},xe=ne.find(q=>!!q.allBasenames);xe&&(Re.allBasenames=xe.allBasenames);const W=ne.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return W.length&&(Re.allPaths=W),Re}const ye=function(Re,xe,W){let q;for(let J=0,ae=ne.length;J<ae;J++){const ge=ne[J];ge.requiresSiblings&&W&&(xe||(xe=T.basename(Re)),q||(q=xe.substr(0,xe.length-T.extname(Re).length)));const De=ge(Re,xe,q,W);if(De)return De}return null},Ae=ne.find(Re=>!!Re.allBasenames);Ae&&(ye.allBasenames=Ae.allBasenames);const Be=ne.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function U(N,Z,ne){if(Z===!1)return l;const re=a(N,ne);if(re===l)return l;if(typeof Z=="boolean")return re;if(Z){const ye=Z.when;if(typeof ye=="string"){const Ae=(Be,Re,xe,W)=>{if(!W||!re(Be,Re))return null;const q=ye.replace("$(basename)",xe),J=W(q);return(0,y.isThenable)(J)?J.then(ae=>ae?N:null):J?N:null};return Ae.requiresSiblings=!0,Ae}}return re}function G(N,Z){const ne=N.filter(Re=>!!Re.basenames);if(ne.length<2)return N;const re=ne.reduce((Re,xe)=>{const W=xe.basenames;return W?Re.concat(W):Re},[]);let ye;if(Z){ye=[];for(let Re=0,xe=re.length;Re<xe;Re++)ye.push(Z)}else ye=ne.reduce((Re,xe)=>{const W=xe.patterns;return W?Re.concat(W):Re},[]);const Ae=function(Re,xe){if(typeof Re!="string")return null;if(!xe){let q;for(q=Re.length;q>0;q--){const J=Re.charCodeAt(q-1);if(J===47||J===92)break}xe=Re.substr(q)}const W=re.indexOf(xe);return W!==-1?ye[W]:null};Ae.basenames=re,Ae.patterns=ye,Ae.allBasenames=re;const Be=N.filter(Re=>!Re.basenames);return Be.push(Ae),Be}}),define(we[58],Ee([0,1,2,11,8,16,21,24,38]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(a,i,u){if(typeof a=="string"&&(a=b.URI.file(a)),u){const R=u.getWorkspaceFolder(a);if(R){const g=u.getWorkspace().folders.length>1;let w;if((0,k.isEqual)(R.uri,a)?w="":w=(0,k.relativePath)(R.uri,a),g){const I=R.name?R.name:(0,k.basename)(R.uri);w=w?I+" \u2022 "+w:I}return w}}if(a.scheme!==P.Schemas.file&&a.scheme!==P.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,E.hasDriveLetter)(a.fsPath))return(0,S.normalize)(C(a.fsPath));let D=(0,S.normalize)(a.fsPath);return!y.isWindows&&(i==null?void 0:i.userHome)&&(D=f(D,i.userHome.fsPath)),D}e.getPathLabel=n;function A(a){if(!!a){typeof a=="string"&&(a=b.URI.file(a));const i=(0,k.basename)(a)||(a.scheme===P.Schemas.file?a.fsPath:a.path);return y.isWindows&&(0,E.isRootOrDriveLetter)(i)?C(i):i}}e.getBaseLabel=A;function C(a){return(0,E.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=C;let _=Object.create(null);function f(a,i){if(y.isWindows||!a||!i)return a;let u=_.original===i?_.normalized:void 0;return u||(u=`${(0,T.rtrim)(i,S.posix.sep)}${S.posix.sep}`,_={original:i,normalized:u}),(y.isLinux?a.startsWith(u):(0,T.startsWithIgnoreCase)(a,u))&&(a=`~/${a.substr(u.length)}`),a}e.tildify=f;function s(a,i){return a.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=s;const h="\u2026",p="\\\\",m="~";function v(a,i=S.sep){const u=new Array(a.length);let D=!1;for(let R=0;R<a.length;R++){let g=a[R];if(g===""){u[R]=`.${i}`;continue}if(!g){u[R]=g;continue}D=!0;let w="";g.indexOf(p)===0?(w=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(i)===0?(w=g.substr(0,g.indexOf(i)+i.length),g=g.substr(g.indexOf(i)+i.length)):g.indexOf(m)===0&&(w=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length));const I=g.split(i);for(let F=1;D&&F<=I.length;F++)for(let B=I.length-F;D&&B>=0;B--){D=!1;let le=I.slice(B,B+F).join(i);for(let H=0;!D&&H<a.length;H++)if(H!==R&&a[H]&&a[H].indexOf(le)>-1){const z=B+F===I.length,K=B>0&&a[H].indexOf(i)>-1?i+le:le,L=a[H].endsWith(K);D=!z||L}if(!D){let H="";(I[0].endsWith(":")||w!=="")&&(B===1&&(B=0,F++,le=I[0]+i+le),B>0&&(H=I[0]+i),H=w+H),B>0&&(H=H+h+i),H=H+le,B+F<I.length&&(H=H+i+h),u[R]=H}}D&&(u[R]=g)}return u}e.shorten=v;var d;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function c(a,i=Object.create(null)){const u=[];let D=!1,R="";for(const g of a)if(g==="$"||D&&g==="{")R&&u.push({value:R,type:d.TEXT}),R="",D=!0;else if(g==="}"&&D){const w=i[R];if(typeof w=="string")w.length&&u.push({value:w,type:d.VARIABLE});else if(w){const I=u[u.length-1];(!I||I.type!==d.SEPARATOR)&&u.push({value:w.label,type:d.SEPARATOR})}R="",D=!1}else R+=g;return R&&!D&&u.push({value:R,type:d.TEXT}),u.filter((g,w)=>{if(g.type===d.SEPARATOR){const I=u[w-1],F=u[w+1];return[I,F].every(B=>B&&(B.type===d.VARIABLE||B.type===d.TEXT)&&B.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=c;function o(a,i){return y.isMacintosh||i?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):a.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(a,i){return y.isMacintosh||i?a.replace(/\(&&\w\)|&&/g,""):y.isWindows?a.replace(/&&|&/g,u=>u==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function l(a){const i=a.indexOf("/")!==-1?S.posix:S.win32,u=i.basename(a),D=i.dirname(a);return u.length?{name:u,parentPath:D}:{name:D,parentPath:""}}e.splitName=l}),define(we[110],Ee([0,1,2]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(A){return A.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const _=this._uriTransformer.transformIncoming(C);return _===C?C:S(b.URI.from(_))}transformOutgoing(C){const _=this._uriTransformer.transformOutgoing(C);return _===C?C:S(b.URI.from(_))}transformOutgoingURI(C){const _=this._uriTransformer.transformOutgoing(C);return _===C?C:b.URI.from(_)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,C,_){if(!A||_>200)return null;if(typeof A=="object"){if(A instanceof b.URI)return C.transformOutgoing(A);for(let f in A)if(Object.hasOwnProperty.call(A,f)){const s=P(A[f],C,_+1);s!==null&&(A[f]=s)}}return null}function y(A,C){const _=P(A,C,0);return _===null?A:_}e.transformOutgoingURIs=y;function k(A,C,_,f){if(!A||f>200)return null;if(typeof A=="object"){if(A.$mid===1)return _?b.URI.revive(C.transformIncoming(A)):C.transformIncoming(A);for(let s in A)if(Object.hasOwnProperty.call(A,s)){const h=k(A[s],C,_,f+1);h!==null&&(A[s]=h)}}return null}function E(A,C){const _=k(A,C,!1,0);return _===null?A:_}e.transformIncomingURIs=E;function n(A,C){const _=k(A,C,!0,0);return _===null?A:_}e.transformAndReviveIncomingURIs=n}),define(we[29],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(E){return b.test(E)}e.isUUID=S;const T=new Uint8Array(16),P=[];for(let E=0;E<256;E++)P.push(E.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(E){for(let n=0;n<E.length;n++)E[n]=Math.floor(Math.random()*256);return E};function k(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let E=0,n="";return n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n}e.generateUuid=k}),define(we[81],Ee([0,1,79]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class S{constructor(k){let E=(0,b.toUint8)(k);this._defaultValue=E,this._asciiMap=S._createAsciiMap(E),this._map=new Map}static _createAsciiMap(k){let E=new Uint8Array(256);for(let n=0;n<256;n++)E[n]=k;return E}set(k,E){let n=(0,b.toUint8)(E);k>=0&&k<256?this._asciiMap[k]=n:this._map.set(k,n)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=S;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new S(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=P}),define(we[111],Ee([0,1,81]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var S;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(S=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends b.CharacterClassifier{constructor(k){super(0);for(let E=0,n=k.length;E<n;E++)this.set(k.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(y){let k={};return E=>(k.hasOwnProperty(E)||(k[E]=y(E)),k[E])}e.getMapForWordSeparators=P(y=>new T(y))}),define(we[39],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new b(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return b.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return b.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return b.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let y=T.lineNumber|0,k=P.lineNumber|0;if(y===k){let E=T.column|0,n=P.column|0;return E-n}return y-k}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new b(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=b}),define(we[33],Ee([0,1,39]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class S{constructor(P,y,k,E){P>k||P===k&&y>E?(this.startLineNumber=k,this.startColumn=E,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=k,this.endColumn=E)}isEmpty(){return S.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return S.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}containsRange(P){return S.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return S.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return S.plusRange(this,P)}static plusRange(P,y){let k,E,n,A;return y.startLineNumber<P.startLineNumber?(k=y.startLineNumber,E=y.startColumn):y.startLineNumber===P.startLineNumber?(k=y.startLineNumber,E=Math.min(y.startColumn,P.startColumn)):(k=P.startLineNumber,E=P.startColumn),y.endLineNumber>P.endLineNumber?(n=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(n=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(n=P.endLineNumber,A=P.endColumn),new S(k,E,n,A)}intersectRanges(P){return S.intersectRanges(this,P)}static intersectRanges(P,y){let k=P.startLineNumber,E=P.startColumn,n=P.endLineNumber,A=P.endColumn,C=y.startLineNumber,_=y.startColumn,f=y.endLineNumber,s=y.endColumn;return k<C?(k=C,E=_):k===C&&(E=Math.max(E,_)),n>f?(n=f,A=s):n===f&&(A=Math.min(A,s)),k>n||k===n&&E>A?null:new S(k,E,n,A)}equalsRange(P){return S.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(P){return new b.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(P){return new b.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new S(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new S(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(P){return new S(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new S(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new S(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const n=P.startLineNumber|0,A=y.startLineNumber|0;if(n===A){const C=P.startColumn|0,_=y.startColumn|0;if(C===_){const f=P.endLineNumber|0,s=y.endLineNumber|0;if(f===s){const h=P.endColumn|0,p=y.endColumn|0;return h-p}return f-s}return C-_}return n-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=S}),define(we[112],Ee([0,1,39,33]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends S.Range{constructor(k,E,n,A){super(k,E,n,A);this.selectionStartLineNumber=k,this.selectionStartColumn=E,this.positionLineNumber=n,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return P.selectionsEqual(this,k)}static selectionsEqual(k,E){return k.selectionStartLineNumber===E.selectionStartLineNumber&&k.selectionStartColumn===E.selectionStartColumn&&k.positionLineNumber===E.positionLineNumber&&k.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,k,E):new P(k,E,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,E){return this.getDirection()===0?new P(k,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,k,E)}static fromPositions(k,E=k){return new P(k.lineNumber,k.column,E.lineNumber,E.column)}static liftSelection(k){return new P(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,E){if(k&&!E||!k&&E)return!1;if(!k&&!E)return!0;if(k.length!==E.length)return!1;for(let n=0,A=k.length;n<A;n++)if(!this.selectionsEqual(k[n],E[n]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,E,n,A,C){return C===0?new P(k,E,n,A):new P(n,A,k,E)}}e.Selection=P}),define(we[82],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var S;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(S=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class E{constructor(s,h){this.range=s,this.matches=h}}e.FindMatch=E;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class C{constructor(s,h,p,m,v,d){this.identifier=s,this.range=h,this.text=p,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=v,this._isTracked=d}}e.ValidAnnotatedEditOperation=C;class _{constructor(s,h,p){this.reverseEdits=s,this.changes=h,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=_}),define(we[113],Ee([0,1,8,111,39,33,82]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class E{constructor(d,c,o,t){this.searchString=d,this.isRegex=c,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=n(this.searchString):d=this.searchString.indexOf(`
`)>=0;let c=null;try{c=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let o=!this.isRegex&&!d;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new A(c,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=E;function n(v){if(!v||v.length===0)return!1;for(let d=0,c=v.length;d<c;d++)if(v.charCodeAt(d)===92){if(d++,d>=c)break;const t=v.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class A{constructor(d,c,o){this.regex=d,this.wordSeparators=c,this.simpleSearch=o}}e.SearchData=A;function C(v,d,c){if(!c)return new y.FindMatch(v,null);let o=[];for(let t=0,r=d.length;t<r;t++)o[t]=d[t];return new y.FindMatch(v,o)}e.createFindMatch=C;class _{constructor(d){let c=[],o=0;for(let t=0,r=d.length;t<r;t++)d.charCodeAt(t)===10&&(c[o++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(d){const c=this._lineFeedsOffsets;let o=0,t=c.length-1;if(t===-1||d<=c[0])return 0;for(;o<t;){const r=o+((t-o)/2>>0);c[r]>=d?t=r-1:c[r+1]>=d?(o=r,t=r):o=r+1}return o+1}}class f{static findMatches(d,c,o,t,r){const l=c.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(d,o,new m(l.wordSeparators,l.regex),t,r):this._doFindMatchesLineByLine(d,o,l,t,r):[]}static _getMultilineMatchRange(d,c,o,t,r,l){let a,i=0;t?(i=t.findLineFeedCountBeforeOffset(r),a=c+r+i):a=c+r;let u;if(t){let w=t.findLineFeedCountBeforeOffset(r+l.length)-i;u=a+l.length+w}else u=a+l.length;const D=d.getPositionAt(a),R=d.getPositionAt(u);return new P.Range(D.lineNumber,D.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(d,c,o,t,r){const l=d.getOffsetAt(c.getStartPosition()),a=d.getValueInRange(c,1),i=d.getEOL()===`\r
`?new _(a):null,u=[];let D=0,R;for(o.reset(0);R=o.next(a);)if(u[D++]=C(this._getMultilineMatchRange(d,l,a,i,R.index,R[0]),R,t),D>=r)return u;return u}static _doFindMatchesLineByLine(d,c,o,t,r){const l=[];let a=0;if(c.startLineNumber===c.endLineNumber){const u=d.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return a=this._findMatchesInLine(o,u,c.startLineNumber,c.startColumn-1,a,l,t,r),l}const i=d.getLineContent(c.startLineNumber).substring(c.startColumn-1);a=this._findMatchesInLine(o,i,c.startLineNumber,c.startColumn-1,a,l,t,r);for(let u=c.startLineNumber+1;u<c.endLineNumber&&a<r;u++)a=this._findMatchesInLine(o,d.getLineContent(u),u,0,a,l,t,r);if(a<r){const u=d.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);a=this._findMatchesInLine(o,u,c.endLineNumber,0,a,l,t,r)}return l}static _findMatchesInLine(d,c,o,t,r,l,a,i){const u=d.wordSeparators;if(!a&&d.simpleSearch){const g=d.simpleSearch,w=g.length,I=c.length;let F=-w;for(;(F=c.indexOf(g,F+w))!==-1;)if((!u||p(u,c,I,F,w))&&(l[r++]=new y.FindMatch(new P.Range(o,F+1+t,o,F+1+w+t),null),r>=i))return r;return r}const D=new m(d.wordSeparators,d.regex);let R;D.reset(0);do if(R=D.next(c),R&&(l[r++]=C(new P.Range(o,R.index+1+t,o,R.index+1+R[0].length+t),R,a),r>=i))return r;while(R);return r}static findNextMatch(d,c,o,t){const r=c.parseSearchRequest();if(!r)return null;const l=new m(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(d,o,l,t):this._doFindNextMatchLineByLine(d,o,l,t)}static _doFindNextMatchMultiline(d,c,o,t){const r=new T.Position(c.lineNumber,1),l=d.getOffsetAt(r),a=d.getLineCount(),i=d.getValueInRange(new P.Range(r.lineNumber,r.column,a,d.getLineMaxColumn(a)),1),u=d.getEOL()===`\r
`?new _(i):null;o.reset(c.column-1);let D=o.next(i);return D?C(this._getMultilineMatchRange(d,l,i,u,D.index,D[0]),D,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(d,new T.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(d,c,o,t){const r=d.getLineCount(),l=c.lineNumber,a=d.getLineContent(l),i=this._findFirstMatchInLine(o,a,l,c.column,t);if(i)return i;for(let u=1;u<=r;u++){const D=(l+u-1)%r,R=d.getLineContent(D+1),g=this._findFirstMatchInLine(o,R,D+1,1,t);if(g)return g}return null}static _findFirstMatchInLine(d,c,o,t,r){d.reset(t-1);const l=d.next(c);return l?C(new P.Range(o,l.index+1,o,l.index+1+l[0].length),l,r):null}static findPreviousMatch(d,c,o,t){const r=c.parseSearchRequest();if(!r)return null;const l=new m(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(d,o,l,t):this._doFindPreviousMatchLineByLine(d,o,l,t)}static _doFindPreviousMatchMultiline(d,c,o,t){const r=this._doFindMatchesMultiline(d,new P.Range(1,1,c.lineNumber,c.column),o,t,10*k);if(r.length>0)return r[r.length-1];const l=d.getLineCount();return c.lineNumber!==l||c.column!==d.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(d,new T.Position(l,d.getLineMaxColumn(l)),o,t):null}static _doFindPreviousMatchLineByLine(d,c,o,t){const r=d.getLineCount(),l=c.lineNumber,a=d.getLineContent(l).substring(0,c.column-1),i=this._findLastMatchInLine(o,a,l,t);if(i)return i;for(let u=1;u<=r;u++){const D=(r+l-u-1)%r,R=d.getLineContent(D+1),g=this._findLastMatchInLine(o,R,D+1,t);if(g)return g}return null}static _findLastMatchInLine(d,c,o,t){let r=null,l;for(d.reset(0);l=d.next(c);)r=C(new P.Range(o,l.index+1,o,l.index+1+l[0].length),l,t);return r}}e.TextModelSearch=f;function s(v,d,c,o,t){if(o===0)return!0;const r=d.charCodeAt(o-1);if(v.get(r)!==0||r===13||r===10)return!0;if(t>0){const l=d.charCodeAt(o);if(v.get(l)!==0)return!0}return!1}function h(v,d,c,o,t){if(o+t===c)return!0;const r=d.charCodeAt(o+t);if(v.get(r)!==0||r===13||r===10)return!0;if(t>0){const l=d.charCodeAt(o+t-1);if(v.get(l)!==0)return!0}return!1}function p(v,d,c,o,t){return s(v,d,c,o,t)&&h(v,d,c,o,t)}e.isValidMatch=p;class m{constructor(d,c){this._wordSeparators=d,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const c=d.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(o=this._searchRegex.exec(d),!o))return null;const t=o.index,r=o[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){b.getNextCodePoint(d,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||p(this._wordSeparators,d,c,t,r))return o}while(o);return null}}e.Searcher=m}),define(we[83],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)k.indexOf(n)>=0||(E+="\\"+n);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=b();function S(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let n="g";k.ignoreCase&&(n+="i"),k.multiline&&(n+="m"),k.unicode&&(n+="u"),E=new RegExp(k.source,n)}return E.lastIndex=0,E}e.ensureValidWordDefinition=S;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(k,E,n,A,C=T){if(n.length>C.maxLen){let p=k-C.maxLen/2;return p<0?p=0:A+=p,n=n.substring(p,k+C.maxLen/2),P(k,E,n,A,C)}const _=Date.now(),f=k-1-A;let s=-1,h=null;for(let p=1;!(Date.now()-_>=C.timeBudget);p++){const m=f-C.windowSize*p;E.lastIndex=Math.max(0,m);const v=y(E,n,f,s);if(!v&&h||(h=v,m<=0))break;s=m}if(h){let p={word:h[0],startColumn:A+1+h.index,endColumn:A+1+h.index+h[0].length};return E.lastIndex=0,p}return null}e.getWordAtText=P;function y(k,E,n,A){let C;for(;C=k.exec(E);){const _=C.index||0;if(_<=n&&k.lastIndex>=n)return C;if(A>0&&_>A)return null}return null}}),define(we[114],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class S{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let E=0,n=k.notIn.length;E<n;E++)switch(k.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=S;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of k)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=T;function P(y,k,E){y.has(k)?y.get(k).push(E):y.set(k,[E])}}),define(we[59],Ee([0,1,28,11]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,y,k,E){if(Array.isArray(P)){let n=0;for(const A of P){const C=T(A,y,k,E);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof P=="string")return E?P==="*"?5:P===k?10:0:0;if(P){const{language:n,pattern:A,scheme:C,hasAccessToAllModels:_}=P;if(!E&&!_)return 0;let f=0;if(C)if(C===y.scheme)f=10;else if(C==="*")f=5;else return 0;if(n)if(n===k)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(A){let s;if(typeof A=="string"?s=A:s=Object.assign(Object.assign({},A),{base:(0,S.normalize)(A.base)}),s===y.fsPath||(0,b.match)(s,y.fsPath))f=10;else return 0}return f}else return 0}}e.score=T}),define(we[115],Ee([0,1,81]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var S;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(S=e.State||(e.State={}));class T{constructor(s,h,p){const m=new Uint8Array(s*h);for(let v=0,d=s*h;v<d;v++)m[v]=p;this._data=m,this.rows=s,this.cols=h}get(s,h){return this._data[s*this.cols+h]}set(s,h,p){this._data[s*this.cols+h]=p}}e.Uint8Matrix=T;class P{constructor(s){let h=0,p=0;for(let v=0,d=s.length;v<d;v++){let[c,o,t]=s[v];o>h&&(h=o),c>p&&(p=c),t>p&&(p=t)}h++,p++;let m=new T(p,h,0);for(let v=0,d=s.length;v<d;v++){let[c,o,t]=s[v];m.set(c,o,t)}this._states=m,this._maxCharCode=h}nextState(s,h){return h<0||h>=this._maxCharCode?0:this._states.get(s,h)}}e.StateMachine=P;let y=null;function k(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var E;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let n=null;function A(){if(n===null){n=new b.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<f.length;h++)n.set(f.charCodeAt(h),1);const s=".,;";for(let h=0;h<s.length;h++)n.set(s.charCodeAt(h),2)}return n}class C{static _createLink(s,h,p,m,v){let d=v-1;do{const c=h.charCodeAt(d);if(s.get(c)!==2)break;d--}while(d>m);if(m>0){const c=h.charCodeAt(m-1),o=h.charCodeAt(d);(c===40&&o===41||c===91&&o===93||c===123&&o===125)&&d--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:d+2},url:h.substring(m,d+1)}}static computeLinks(s,h=k()){const p=A();let m=[];for(let v=1,d=s.getLineCount();v<=d;v++){const c=s.getLineContent(v),o=c.length;let t=0,r=0,l=0,a=1,i=!1,u=!1,D=!1,R=!1;for(;t<o;){let g=!1;const w=c.charCodeAt(t);if(a===13){let I;switch(w){case 40:i=!0,I=0;break;case 41:I=i?0:1;break;case 91:D=!0,u=!0,I=0;break;case 93:D=!1,I=u?0:1;break;case 123:R=!0,I=0;break;case 125:I=R?0:1;break;case 39:I=l===34||l===96?0:1;break;case 34:I=l===39||l===96?0:1;break;case 96:I=l===39||l===34?0:1;break;case 42:I=l===42?1:0;break;case 124:I=l===124?1:0;break;case 32:I=D?0:1;break;default:I=p.get(w)}I===1&&(m.push(C._createLink(p,c,v,r,t)),g=!0)}else if(a===12){let I;w===91?(u=!0,I=0):I=p.get(w),I===1?g=!0:a=13}else a=h.nextState(a,w),a===0&&(g=!0);g&&(a=1,i=!1,u=!1,R=!1,r=t+1,l=w),t++}a===13&&m.push(C._createLink(p,c,v,r,o))}return m}}e.LinkComputer=C;function _(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:C.computeLinks(f)}e.computeLinks=_}),define(we[116],Ee([0,1,3,6]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,S.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let E=null,n=!1;return this._promises.set(y,k.then(A=>{this._promises.delete(y),!(n||!A)&&(E=this.register(y,A))})),(0,S.toDisposable)(()=>{n=!0,E&&E.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const E=this._promises.get(y);return E?E.then(n=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(we[84],Ee([0,1,26,21]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function P(C){for(let _=0,f=C.length;_<f;_+=4){const s=C[_+0],h=C[_+1],p=C[_+2],m=C[_+3];C[_+0]=m,C[_+1]=p,C[_+2]=h,C[_+3]=s}}function y(C){const _=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return S.isLittleEndian()||P(_),b.VSBuffer.wrap(_)}function k(C){const _=C.buffer;if(S.isLittleEndian()||P(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const f=new Uint8Array(_.byteLength);return f.set(_),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function E(C){const _=new Uint32Array(n(C));let f=0;if(_[f++]=C.id,C.type==="full")_[f++]=1,_[f++]=C.data.length,_.set(C.data,f),f+=C.data.length;else{_[f++]=2,_[f++]=C.deltas.length;for(const s of C.deltas)_[f++]=s.start,_[f++]=s.deleteCount,s.data?(_[f++]=s.data.length,_.set(s.data,f),f+=s.data.length):_[f++]=0}return y(_)}e.encodeSemanticTokensDto=E;function n(C){let _=0;if(_+=1+1,C.type==="full")_+=1+C.data.length;else{_+=1,_+=(1+1+1)*C.deltas.length;for(const f of C.deltas)f.data&&(_+=f.data.length)}return _}function A(C){const _=k(C);let f=0;const s=_[f++];if(_[f++]===1){const v=_[f++],d=_.subarray(f,f+v);return f+=v,{id:s,type:"full",data:d}}const p=_[f++];let m=[];for(let v=0;v<p;v++){const d=_[f++],c=_[f++],o=_[f++];let t;o>0&&(t=_.subarray(f,f+o),f+=o),m[v]={start:d,deleteCount:c,data:t}}return{id:s,type:"delta",deltas:m}}e.decodeSemanticTokensDto=A}),define(we[85],Ee([0,1,79]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class S{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=S;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,b.toUint32)(y);const E=this.values,n=this.prefixSum,A=k.length;return A===0?!1:(this.values=new Uint32Array(E.length+A),this.values.set(E.subarray(0,y),0),this.values.set(E.subarray(y),y+A),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,b.toUint32)(y),k=(0,b.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,b.toUint32)(y),k=(0,b.toUint32)(k);const E=this.values,n=this.prefixSum;if(y>=E.length)return!1;let A=E.length-y;return k>=A&&(k=A),k===0?!1:(this.values=new Uint32Array(E.length-k),this.values.set(E.subarray(0,y),0),this.values.set(E.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let E=k;E<=y;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,E=this.values.length-1,n=0,A=0,C=0;for(;k<=E;)if(n=k+(E-k)/2|0,A=this.prefixSum[n],C=A-this.values[n],y<C)E=n-1;else if(y>=A)k=n+1;else break;return new S(n,y-C)}}e.PrefixSumComputer=T}),define(we[117],Ee([0,1,8,39,85]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(k,E,n,A){this._uri=k,this._lines=E,this._eol=n,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const E=k.changes;for(const n of E)this._acceptDeleteRange(n.range),this._acceptInsertText(new S.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,E=this._lines.length,n=new Uint32Array(E);for(let A=0;A<E;A++)n[A]=this._lines[A].length+k;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(k,E){this._lines[k]=E,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,E){if(E.length!==0){let n=(0,b.splitLines)(E);if(n.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}n[n.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]);let A=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(k.lineNumber+C-1,0,n[C]),A[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,A)}}}e.MirrorTextModel=P}),define(we[118],Ee([17,18]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(we[60],Ee([0,1,118,12,15]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,A){return A&&(n.stack||n.stacktrace)?b.localize(0,null,k(n),y(n.stack)||y(n.stacktrace)):k(n)}function y(n){return Array.isArray(n)?n.join(`
`):n}function k(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?b.localize(1,null,n.message):n.message||b.localize(2,null)}function E(n=null,A=!1){if(!n)return b.localize(3,null);if(Array.isArray(n)){const C=T.coalesce(n),_=E(C[0],A);return C.length>1?b.localize(4,null,_,C.length):_}if(S.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return P(C.error,A);if(C.exception)return P(C.exception,A)}return n.stack?P(n,A):n.message?n.message:b.localize(5,null)}e.toErrorMessage=E}),define(we[119],Ee([17,18]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(we[120],Ee([0,1,119,21,83]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,_e){this._values[X]=_e}}e.ValidatedEditorOptions=k;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class n{constructor(X,_e,Me,He){this.id=X,this.name=_e,this.defaultValue=Me,this.schema=He}compute(X,_e,Me){return Me}}class A{constructor(X,_e=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(X){return this.defaultValue}}class C{constructor(X,_e,Me,He){this.id=X,this.name=_e,this.defaultValue=Me,this.schema=He}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,_e,Me){return Me}}function _(V,X){return typeof V=="undefined"?X:V==="false"?!1:Boolean(V)}e.boolean=_;class f extends C{constructor(X,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Me),super(X,_e,Me,He)}validate(X){return _(X,this.defaultValue)}}class s extends C{constructor(X,_e,Me,He,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Me,Xe.minimum=He,Xe.maximum=Oe),super(X,_e,Me,Xe),this.minimum=He,this.maximum=Oe}static clampedInt(X,_e,Me,He){if(typeof X=="undefined")return _e;let Oe=parseInt(X,10);return isNaN(Oe)?_e:(Oe=Math.max(Me,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(X){return s.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class h extends C{constructor(X,_e,Me,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Me),super(X,_e,Me,Oe),this.validationFn=He}static clamp(X,_e,Me){return X<_e?_e:X>Me?Me:X}static float(X,_e){if(typeof X=="number")return X;if(typeof X=="undefined")return _e;const Me=parseFloat(X);return isNaN(Me)?_e:Me}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class p extends C{static string(X,_e){return typeof X!="string"?_e:X}constructor(X,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Me),super(X,_e,Me,He)}validate(X){return p.string(X,this.defaultValue)}}function m(V,X,_e){return typeof V!="string"||_e.indexOf(V)===-1?X:V}e.stringSet=m;class v extends C{constructor(X,_e,Me,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Me),super(X,_e,Me,Oe),this._allowedValues=He}validate(X){return m(X,this.defaultValue,this._allowedValues)}}class d extends n{constructor(X,_e,Me,He,Oe,Xe,x=void 0){typeof x!="undefined"&&(x.type="string",x.enum=Oe,x.default=He),super(X,_e,Me,x),this._allowedValues=Oe,this._convert=Xe}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,_e,Me){return Me===0?X.accessibilitySupport:Me}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:b.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{insertSpace:_(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:_(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function i(V){switch(V){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function u(V){switch(V){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class D extends A{constructor(){super(121,[60,29])}compute(X,_e,Me){const He=["monaco-editor"];return _e.get(29)&&He.push(_e.get(29)),X.extraEditorClassName&&He.push(X.extraEditorClassName),_e.get(60)==="default"?He.push("mouse-default"):_e.get(60)==="copy"&&He.push("mouse-copy"),_e.get(95)&&He.push("showUnused"),_e.get(119)&&He.push("showDeprecated"),He.join(" ")}}class R extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(X,_e,Me){return Me&&X.emptySelectionClipboard}}class g extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:b.localize(13,null),included:S.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:b.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{cursorMoveOnType:_(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:_(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":m(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:_(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:_(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:_(_e.loop,this.defaultValue.loop)}}}class w extends n{constructor(){super(39,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?w.OFF:X==="true"?w.ON:X:Boolean(X)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class I extends A{constructor(){super(38)}compute(X,_e,Me){return X.fontInfo}}class F extends C{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(X){let _e=h.float(X,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(_e,6,100)}compute(X,_e,Me){return X.fontInfo.fontSize}}class B extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(s.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class le extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]};super(45,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:b.localize(35,null)}})}validate(X){var _e,Me,He,Oe,Xe;if(!X||typeof X!="object")return this.defaultValue;const x=X;return{multiple:m(x.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=x.multipleDefinitions)!==null&&_e!==void 0?_e:m(x.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=x.multipleTypeDefinitions)!==null&&Me!==void 0?Me:m(x.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=x.multipleDeclarations)!==null&&He!==void 0?He:m(x.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=x.multipleImplementations)!==null&&Oe!==void 0?Oe:m(x.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=x.multipleReferences)!==null&&Xe!==void 0?Xe:m(x.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(x.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(x.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(x.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(x.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(x.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(48,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:b.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),delay:s.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:_(_e.sticky,this.defaultValue.sticky)}}}var z;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class K extends A{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(X,_e,Me){return K.computeLayout(_e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const _e=X.height/X.lineHeight,Me=X.scrollBeyondLastLine?_e-1:0,He=(X.viewLineCount+Me)/(X.pixelRatio*X.height),Oe=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Me,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(X,_e){const Me=X.outerWidth,He=X.outerHeight,Oe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=_e.stableMinimapLayoutInput,x=Xe&&X.outerHeight===Xe.outerHeight&&X.lineHeight===Xe.lineHeight&&X.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&X.pixelRatio===Xe.pixelRatio&&X.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&X.minimap.enabled===Xe.minimap.enabled&&X.minimap.side===Xe.minimap.side&&X.minimap.size===Xe.minimap.size&&X.minimap.showSlider===Xe.minimap.showSlider&&X.minimap.renderCharacters===Xe.minimap.renderCharacters&&X.minimap.maxColumn===Xe.minimap.maxColumn&&X.minimap.scale===Xe.minimap.scale&&X.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&X.isViewportWrapping===Xe.isViewportWrapping,ie=X.lineHeight,ce=X.typicalHalfwidthCharacterWidth,j=X.scrollBeyondLastLine,Y=X.minimap.renderCharacters;let se=Oe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const fe=X.minimap.maxColumn,ve=X.minimap.size,$e=X.minimap.side,Ne=X.verticalScrollbarWidth,Ve=X.viewLineCount,Qe=X.remainingWidth,Ze=X.isViewportWrapping,ct=Y?2:3;let st=Math.floor(Oe*He);const me=st/Oe;let he=!1,ue=!1,Q=ct*se,Ie=se/Oe,Pe=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:at,desiredRatio:Dt,minimapLineCount:gt}=K.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:j,height:He,lineHeight:ie,pixelRatio:Oe});if(Ve/gt>1)he=!0,ue=!0,se=1,Q=1,Ie=se/Oe;else{let wt=!1,Et=se+1;if(ve==="fit"){const mt=Math.ceil((Ve+at)*Q);Ze&&x&&Qe<=_e.stableFitRemainingWidth?(wt=!0,Et=_e.stableFitMaxMinimapScale):(wt=mt>st,Ze&&wt?(_e.stableMinimapLayoutInput=X,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ve==="fill"||wt){he=!0;const mt=se;Q=Math.min(ie*Oe,Math.max(1,Math.floor(1/Dt))),se=Math.min(Et,Math.max(1,Math.floor(Q/ct))),se>mt&&(Pe=Math.min(2,se/mt)),Ie=se/Oe/Pe,st=Math.ceil(Math.max(dt,Ve+at)*Q),Ze&&wt&&(_e.stableFitMaxMinimapScale=se)}}}const et=Math.floor(fe*Ie),Ge=Math.min(et,Math.max(0,Math.floor((Qe-Ne-2)*Ie/(ce+Ie)))+e.MINIMAP_GUTTER_WIDTH);let rt=Math.floor(Oe*Ge);const lt=rt/Oe;rt=Math.floor(rt*Pe);const Je=Y?1:2,it=$e==="left"?0:Me-Ge-Ne;return{renderMinimap:Je,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:he,minimapIsSampling:ue,minimapScale:se,minimapLineHeight:Q,minimapCanvasInnerWidth:rt,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:me}}static computeLayout(X,_e){const Me=_e.outerWidth|0,He=_e.outerHeight|0,Oe=_e.lineHeight|0,Xe=_e.lineNumbersDigitCount|0,x=_e.typicalHalfwidthCharacterWidth,ie=_e.maxDigitWidth,ce=_e.pixelRatio,j=_e.viewLineCount,Y=X.get(116),se=Y==="inherit"?X.get(115):Y,fe=se==="inherit"?X.get(111):se,ve=X.get(114),$e=X.get(2),Ne=_e.isDominatedByLongLines,Ve=X.get(44),Qe=X.get(54).renderType!==0,Ze=X.get(55),ct=X.get(89),st=X.get(59),me=X.get(87),he=me.verticalScrollbarSize,ue=me.verticalHasArrows,Q=me.arrowSize,Ie=me.horizontalScrollbarSize,Pe=X.get(52),et=X.get(33);let Ge;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const ht=parseFloat(Pe.substr(0,Pe.length-2));Ge=s.clampedInt(ht*x,0,0,1e3)}else Ge=s.clampedInt(Pe,0,0,1e3);et&&(Ge+=16);let rt=0;if(Qe){const ht=Math.max(Xe,Ze);rt=Math.round(ht*ie)}let lt=0;Ve&&(lt=Oe);let Je=0,it=Je+lt,dt=it+rt,at=dt+Ge;const Dt=Me-lt-rt-Ge;let gt=!1,Ct=!1,wt=-1;$e!==2&&(se==="inherit"&&Ne?(gt=!0,Ct=!0):fe==="on"||fe==="bounded"?Ct=!0:fe==="wordWrapColumn"&&(wt=ve));const Et=K._computeMinimapLayout({outerWidth:Me,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:x,pixelRatio:ce,scrollBeyondLastLine:ct,minimap:st,verticalScrollbarWidth:he,viewLineCount:j,remainingWidth:Dt,isViewportWrapping:Ct},_e.memory||new E);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Je+=Et.minimapWidth,it+=Et.minimapWidth,dt+=Et.minimapWidth,at+=Et.minimapWidth);const mt=Dt-Et.minimapWidth,Rt=Math.max(1,Math.floor((mt-he-2)/x)),Ft=ue?Q:0;return Ct&&(wt=Math.max(1,Rt),fe==="bounded"&&(wt=Math.min(wt,ve))),{width:Me,height:He,glyphMarginLeft:Je,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:rt,decorationsLeft:dt,decorationsWidth:Ge,contentLeft:at,contentWidth:mt,minimap:Et,viewportColumn:Rt,isWordWrapMinified:gt,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:he,horizontalScrollbarHeight:Ie,overviewRuler:{top:Ft,width:he,height:He-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=K;class L extends n{constructor(){const X={enabled:!0};super(51,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:b.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:_(X.enabled,this.defaultValue.enabled)}}}class $ extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:b.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class U extends s{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(X,_e,Me){return X.fontInfo.lineHeight}}class G extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:X.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:b.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),size:m(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(_e.side,this.defaultValue.side,["right","left"]),showSlider:m(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:_(_e.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(_e.scale,1,1,3),maxColumn:s.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(V){return V==="ctrlCmd"?S.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{top:s.clampedInt(_e.top,0,0,1e3),bottom:s.clampedInt(_e.bottom,0,0,1e3)}}}class ne extends n{constructor(){const X={enabled:!0,cycle:!1};super(70,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:b.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),cycle:_(_e.cycle,this.defaultValue.cycle)}}}class re extends A{constructor(){super(122)}compute(X,_e,Me){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:b.localize(58,null)},comments:{type:"boolean",default:X.comments,description:b.localize(59,null)},other:{type:"boolean",default:X.other,description:b.localize(60,null)}}}],default:X,description:b.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const _e=X,Me={other:_(_e.other,this.defaultValue.other),comments:_(_e.comments,this.defaultValue.comments),strings:_(_e.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Ae;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(X){let _e=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(_e=4,Me=X):X==="interval"?_e=3:X==="relative"?_e=2:X==="on"?_e=1:_e=0),{renderType:_e,renderFn:Me}}}function Re(V){const X=V.get(82);return X==="editable"?V.get(75):X!=="on"}e.filterValidationDecorations=Re;class xe extends n{constructor(){const X=[],_e={type:"number",description:b.localize(67,null)};super(86,"rulers",X,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:X,description:b.localize(69,null)})}validate(X){if(Array.isArray(X)){let _e=[];for(let Me of X)if(typeof Me=="number")_e.push({column:s.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const He=Me;_e.push({column:s.clampedInt(He.column,0,0,1e4),color:He.color})}return _e.sort((Me,He)=>Me.column-He.column),_e}return this.defaultValue}}function W(V,X){if(typeof V!="string")return X;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X,Me=s.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=s.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(_e.vertical,this.defaultValue.vertical),horizontal:W(_e.horizontal,this.defaultValue.horizontal),useShadows:_(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:_(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:_(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:_(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:_(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:s.clampedInt(_e.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:He,verticalSliderSize:s.clampedInt(_e.verticalSliderSize,He,0,1e3),scrollByPage:_(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class J extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:X.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{insertMode:m(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:_(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:_(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:_(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:_(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:_(_e.showIcons,this.defaultValue.showIcons),showStatusBar:_(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:_(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:_(_e.showMethods,this.defaultValue.showMethods),showFunctions:_(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:_(_e.showConstructors,this.defaultValue.showConstructors),showFields:_(_e.showFields,this.defaultValue.showFields),showVariables:_(_e.showVariables,this.defaultValue.showVariables),showClasses:_(_e.showClasses,this.defaultValue.showClasses),showStructs:_(_e.showStructs,this.defaultValue.showStructs),showInterfaces:_(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:_(_e.showModules,this.defaultValue.showModules),showProperties:_(_e.showProperties,this.defaultValue.showProperties),showEvents:_(_e.showEvents,this.defaultValue.showEvents),showOperators:_(_e.showOperators,this.defaultValue.showOperators),showUnits:_(_e.showUnits,this.defaultValue.showUnits),showValues:_(_e.showValues,this.defaultValue.showValues),showConstants:_(_e.showConstants,this.defaultValue.showConstants),showEnums:_(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:_(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:_(_e.showKeywords,this.defaultValue.showKeywords),showWords:_(_e.showWords,this.defaultValue.showWords),showColors:_(_e.showColors,this.defaultValue.showColors),showFiles:_(_e.showFiles,this.defaultValue.showFiles),showReferences:_(_e.showReferences,this.defaultValue.showReferences),showFolders:_(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:_(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:_(_e.showSnippets,this.defaultValue.showSnippets),showUsers:_(_e.showUsers,this.defaultValue.showUsers),showIssues:_(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:_(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends A{constructor(){super(123,[75])}compute(X,_e,Me){return _e.get(75)?!0:X.tabFocusMode}}var De;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Le(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends A{constructor(){super(125,[124])}compute(X,_e,Me){const He=_e.get(124);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:S.isMacintosh?Te:S.isLinux?Ue:Ce,fontWeight:"normal",fontSize:S.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var Ke;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingOvertype=6]="autoClosingOvertype",V[V.autoClosingQuotes=7]="autoClosingQuotes",V[V.autoIndent=8]="autoIndent",V[V.automaticLayout=9]="automaticLayout",V[V.autoSurround=10]="autoSurround",V[V.codeLens=11]="codeLens",V[V.codeLensFontFamily=12]="codeLensFontFamily",V[V.codeLensFontSize=13]="codeLensFontSize",V[V.colorDecorators=14]="colorDecorators",V[V.columnSelection=15]="columnSelection",V[V.comments=16]="comments",V[V.contextmenu=17]="contextmenu",V[V.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",V[V.cursorBlinking=19]="cursorBlinking",V[V.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",V[V.cursorStyle=21]="cursorStyle",V[V.cursorSurroundingLines=22]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",V[V.cursorWidth=24]="cursorWidth",V[V.disableLayerHinting=25]="disableLayerHinting",V[V.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",V[V.dragAndDrop=27]="dragAndDrop",V[V.emptySelectionClipboard=28]="emptySelectionClipboard",V[V.extraEditorClassName=29]="extraEditorClassName",V[V.fastScrollSensitivity=30]="fastScrollSensitivity",V[V.find=31]="find",V[V.fixedOverflowWidgets=32]="fixedOverflowWidgets",V[V.folding=33]="folding",V[V.foldingStrategy=34]="foldingStrategy",V[V.foldingHighlight=35]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=37]="fontFamily",V[V.fontInfo=38]="fontInfo",V[V.fontLigatures=39]="fontLigatures",V[V.fontSize=40]="fontSize",V[V.fontWeight=41]="fontWeight",V[V.formatOnPaste=42]="formatOnPaste",V[V.formatOnType=43]="formatOnType",V[V.glyphMargin=44]="glyphMargin",V[V.gotoLocation=45]="gotoLocation",V[V.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",V[V.hover=48]="hover",V[V.inDiffEditor=49]="inDiffEditor",V[V.letterSpacing=50]="letterSpacing",V[V.lightbulb=51]="lightbulb",V[V.lineDecorationsWidth=52]="lineDecorationsWidth",V[V.lineHeight=53]="lineHeight",V[V.lineNumbers=54]="lineNumbers",V[V.lineNumbersMinChars=55]="lineNumbersMinChars",V[V.linkedEditing=56]="linkedEditing",V[V.links=57]="links",V[V.matchBrackets=58]="matchBrackets",V[V.minimap=59]="minimap",V[V.mouseStyle=60]="mouseStyle",V[V.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=62]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",V[V.multiCursorModifier=64]="multiCursorModifier",V[V.multiCursorPaste=65]="multiCursorPaste",V[V.occurrencesHighlight=66]="occurrencesHighlight",V[V.overviewRulerBorder=67]="overviewRulerBorder",V[V.overviewRulerLanes=68]="overviewRulerLanes",V[V.padding=69]="padding",V[V.parameterHints=70]="parameterHints",V[V.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",V[V.quickSuggestions=73]="quickSuggestions",V[V.quickSuggestionsDelay=74]="quickSuggestionsDelay",V[V.readOnly=75]="readOnly",V[V.renameOnType=76]="renameOnType",V[V.renderControlCharacters=77]="renderControlCharacters",V[V.renderIndentGuides=78]="renderIndentGuides",V[V.renderFinalNewline=79]="renderFinalNewline",V[V.renderLineHighlight=80]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=82]="renderValidationDecorations",V[V.renderWhitespace=83]="renderWhitespace",V[V.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",V[V.roundedSelection=85]="roundedSelection",V[V.rulers=86]="rulers",V[V.scrollbar=87]="scrollbar",V[V.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=89]="scrollBeyondLastLine",V[V.scrollPredominantAxis=90]="scrollPredominantAxis",V[V.selectionClipboard=91]="selectionClipboard",V[V.selectionHighlight=92]="selectionHighlight",V[V.selectOnLineNumbers=93]="selectOnLineNumbers",V[V.showFoldingControls=94]="showFoldingControls",V[V.showUnused=95]="showUnused",V[V.snippetSuggestions=96]="snippetSuggestions",V[V.smartSelect=97]="smartSelect",V[V.smoothScrolling=98]="smoothScrolling",V[V.stickyTabStops=99]="stickyTabStops",V[V.stopRenderingLineAfter=100]="stopRenderingLineAfter",V[V.suggest=101]="suggest",V[V.suggestFontSize=102]="suggestFontSize",V[V.suggestLineHeight=103]="suggestLineHeight",V[V.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",V[V.suggestSelection=105]="suggestSelection",V[V.tabCompletion=106]="tabCompletion",V[V.tabIndex=107]="tabIndex",V[V.unusualLineTerminators=108]="unusualLineTerminators",V[V.useTabStops=109]="useTabStops",V[V.wordSeparators=110]="wordSeparators",V[V.wordWrap=111]="wordWrap",V[V.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=114]="wordWrapColumn",V[V.wordWrapOverride1=115]="wordWrapOverride1",V[V.wordWrapOverride2=116]="wordWrapOverride2",V[V.wrappingIndent=117]="wrappingIndent",V[V.wrappingStrategy=118]="wrappingStrategy",V[V.showDeprecated=119]="showDeprecated",V[V.inlineHints=120]="inlineHints",V[V.editorClassName=121]="editorClassName",V[V.pixelRatio=122]="pixelRatio",V[V.tabFocusMode=123]="tabFocusMode",V[V.layoutInfo=124]="layoutInfo",V[V.wrappingInfo=125]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:be(new v(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:be(new o),accessibilityPageSize:be(new s(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null),deprecationMessage:b.localize(115,null)})),ariaLabel:be(new p(4,"ariaLabel",b.localize(116,null))),autoClosingBrackets:be(new v(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(117,null),b.localize(118,null),""],description:b.localize(119,null)})),autoClosingOvertype:be(new v(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(120,null),""],description:b.localize(121,null)})),autoClosingQuotes:be(new v(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(122,null),b.localize(123,null),""],description:b.localize(124,null)})),autoIndent:be(new d(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)})),automaticLayout:be(new f(9,"automaticLayout",!1)),autoSurround:be(new v(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(131,null),b.localize(132,null),b.localize(133,null),""],description:b.localize(134,null)})),stickyTabStops:be(new f(99,"stickyTabStops",!1,{description:b.localize(135,null)})),codeLens:be(new f(11,"codeLens",!0,{description:b.localize(136,null)})),codeLensFontFamily:be(new p(12,"codeLensFontFamily","",{description:b.localize(137,null)})),codeLensFontSize:be(new s(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(138,null)})),colorDecorators:be(new f(14,"colorDecorators",!0,{description:b.localize(139,null)})),columnSelection:be(new f(15,"columnSelection",!1,{description:b.localize(140,null)})),comments:be(new t),contextmenu:be(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(18,"copyWithSyntaxHighlighting",!0,{description:b.localize(141,null)})),cursorBlinking:be(new d(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:b.localize(142,null)})),cursorSmoothCaretAnimation:be(new f(20,"cursorSmoothCaretAnimation",!1,{description:b.localize(143,null)})),cursorStyle:be(new d(21,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:b.localize(144,null)})),cursorSurroundingLines:be(new s(22,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(145,null)})),cursorSurroundingLinesStyle:be(new v(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(146,null),b.localize(147,null)],description:b.localize(148,null)})),cursorWidth:be(new s(24,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(149,null)})),disableLayerHinting:be(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:be(new f(27,"dragAndDrop",!0,{description:b.localize(150,null)})),emptySelectionClipboard:be(new R),extraEditorClassName:be(new p(29,"extraEditorClassName","")),fastScrollSensitivity:be(new h(30,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:b.localize(151,null)})),find:be(new g),fixedOverflowWidgets:be(new f(32,"fixedOverflowWidgets",!1)),folding:be(new f(33,"folding",!0,{description:b.localize(152,null)})),foldingStrategy:be(new v(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(153,null),b.localize(154,null)],description:b.localize(155,null)})),foldingHighlight:be(new f(35,"foldingHighlight",!0,{description:b.localize(156,null)})),unfoldOnClickAfterEndOfLine:be(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(157,null)})),fontFamily:be(new p(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(158,null)})),fontInfo:be(new I),fontLigatures2:be(new w),fontSize:be(new F),fontWeight:be(new B),formatOnPaste:be(new f(42,"formatOnPaste",!1,{description:b.localize(159,null)})),formatOnType:be(new f(43,"formatOnType",!1,{description:b.localize(160,null)})),glyphMargin:be(new f(44,"glyphMargin",!0,{description:b.localize(161,null)})),gotoLocation:be(new le),hideCursorInOverviewRuler:be(new f(46,"hideCursorInOverviewRuler",!1,{description:b.localize(162,null)})),highlightActiveIndentGuide:be(new f(47,"highlightActiveIndentGuide",!0,{description:b.localize(163,null)})),hover:be(new H),inDiffEditor:be(new f(49,"inDiffEditor",!1)),letterSpacing:be(new h(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>h.clamp(V,-5,20),{description:b.localize(164,null)})),lightbulb:be(new L),lineDecorationsWidth:be(new C(52,"lineDecorationsWidth",10)),lineHeight:be(new U),lineNumbers:be(new Be),lineNumbersMinChars:be(new s(55,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(56,"linkedEditing",!1,{description:b.localize(165,null)})),links:be(new f(57,"links",!0,{description:b.localize(166,null)})),matchBrackets:be(new v(58,"matchBrackets","always",["always","near","never"],{description:b.localize(167,null)})),minimap:be(new G),mouseStyle:be(new v(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new h(61,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:b.localize(168,null)})),mouseWheelZoom:be(new f(62,"mouseWheelZoom",!1,{markdownDescription:b.localize(169,null)})),multiCursorMergeOverlapping:be(new f(63,"multiCursorMergeOverlapping",!0,{description:b.localize(170,null)})),multiCursorModifier:be(new d(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[b.localize(171,null),b.localize(172,null)],markdownDescription:b.localize(173,null)})),multiCursorPaste:be(new v(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(174,null),b.localize(175,null)],markdownDescription:b.localize(176,null)})),occurrencesHighlight:be(new f(66,"occurrencesHighlight",!0,{description:b.localize(177,null)})),overviewRulerBorder:be(new f(67,"overviewRulerBorder",!0,{description:b.localize(178,null)})),overviewRulerLanes:be(new s(68,"overviewRulerLanes",3,0,3)),padding:be(new Z),parameterHints:be(new ne),peekWidgetDefaultFocus:be(new v(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(179,null),b.localize(180,null)],description:b.localize(181,null)})),definitionLinkOpensInPeek:be(new f(72,"definitionLinkOpensInPeek",!1,{description:b.localize(182,null)})),quickSuggestions:be(new ye),quickSuggestionsDelay:be(new s(74,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(183,null)})),readOnly:be(new f(75,"readOnly",!1)),renameOnType:be(new f(76,"renameOnType",!1,{description:b.localize(184,null),markdownDeprecationMessage:b.localize(185,null)})),renderControlCharacters:be(new f(77,"renderControlCharacters",!1,{description:b.localize(186,null)})),renderIndentGuides:be(new f(78,"renderIndentGuides",!0,{description:b.localize(187,null)})),renderFinalNewline:be(new f(79,"renderFinalNewline",!0,{description:b.localize(188,null)})),renderLineHighlight:be(new v(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(189,null)],description:b.localize(190,null)})),renderLineHighlightOnlyWhenFocus:be(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(191,null)})),renderValidationDecorations:be(new v(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new v(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(192,null),b.localize(193,null),b.localize(194,null),""],description:b.localize(195,null)})),revealHorizontalRightPadding:be(new s(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(85,"roundedSelection",!0,{description:b.localize(196,null)})),rulers:be(new xe),scrollbar:be(new q),scrollBeyondLastColumn:be(new s(88,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(197,null)})),scrollBeyondLastLine:be(new f(89,"scrollBeyondLastLine",!0,{description:b.localize(198,null)})),scrollPredominantAxis:be(new f(90,"scrollPredominantAxis",!0,{description:b.localize(199,null)})),selectionClipboard:be(new f(91,"selectionClipboard",!0,{description:b.localize(200,null),included:S.isLinux})),selectionHighlight:be(new f(92,"selectionHighlight",!0,{description:b.localize(201,null)})),selectOnLineNumbers:be(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:be(new v(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(202,null),b.localize(203,null)],description:b.localize(204,null)})),showUnused:be(new f(95,"showUnused",!0,{description:b.localize(205,null)})),showDeprecated:be(new f(119,"showDeprecated",!0,{description:b.localize(206,null)})),inlineHints:be(new $),snippetSuggestions:be(new v(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(207,null),b.localize(208,null),b.localize(209,null),b.localize(210,null)],description:b.localize(211,null)})),smartSelect:be(new ae),smoothScrolling:be(new f(98,"smoothScrolling",!1,{description:b.localize(212,null)})),stopRenderingLineAfter:be(new s(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new J),suggestFontSize:be(new s(102,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(213,null)})),suggestLineHeight:be(new s(103,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestOnTriggerCharacters:be(new f(104,"suggestOnTriggerCharacters",!0,{description:b.localize(215,null)})),suggestSelection:be(new v(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(216,null),b.localize(217,null),b.localize(218,null)],description:b.localize(219,null)})),tabCompletion:be(new v(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null)],description:b.localize(223,null)})),tabIndex:be(new s(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new v(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(224,null),b.localize(225,null),b.localize(226,null)],description:b.localize(227,null)})),useTabStops:be(new f(109,"useTabStops",!0,{description:b.localize(228,null)})),wordSeparators:be(new p(110,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:b.localize(229,null)})),wordWrap:be(new v(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(230,null),b.localize(231,null),b.localize(232,null),b.localize(233,null)],description:b.localize(234,null)})),wordWrapBreakAfterCharacters:be(new p(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new p(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new s(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(235,null)})),wordWrapOverride1:be(new v(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new v(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new d(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[b.localize(236,null),b.localize(237,null),b.localize(238,null),b.localize(239,null)],description:b.localize(240,null)})),wrappingStrategy:be(new v(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(241,null),b.localize(242,null)],description:b.localize(243,null)})),editorClassName:be(new D),pixelRatio:be(new re),tabFocusMode:be(new ge),layoutInfo:be(new K),wrappingInfo:be(new pe)}}),define(we[121],Ee([17,18]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[122],Ee([17,18]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(we[123],Ee([17,18]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(we[124],Ee([17,18]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],Ee([17,18]),function(oe,e){return oe.create("vs/platform/workspaces/common/workspaces",e)}),define(we[126],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[127],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(we[129],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(we[136],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[137],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[138],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[139],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[140],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var S;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(S=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[86],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(P,y=[],k=!1){this.ctor=P,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b;const S=(T,...P)=>new b(T,P);e.createSyncDescriptor=S}),define(we[61],Ee([0,1,86]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const S=[];function T(y,k,E){k instanceof b.SyncDescriptor||(k=new b.SyncDescriptor(k,[],E)),S.push([y,k])}e.registerSingleton=T;function P(){return S}e.getSingletonServiceDescriptors=P}),define(we[141],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=b;class S{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const k=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),E),E.incoming.set(this._hashFn(P),k)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let k=this._nodes.get(y);return k||(k=new b(P),this._nodes.set(y,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[y,k]of this._nodes)P.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=S}),define(we[4],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function E(n){return n[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=E})(b=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function S(k,E,n,A){E[b.DI_TARGET]===E?E[b.DI_DEPENDENCIES].push({id:k,index:n,optional:A}):(E[b.DI_DEPENDENCIES]=[{id:k,index:n,optional:A}],E[b.DI_TARGET]=E)}function T(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const E=function(n,A,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(E,n,C,!1)};return E.toString=()=>k,b.serviceIds.set(k,E),E}e.createDecorator=T;function P(k){return k}e.refineServiceDecorator=P;function y(k){return function(E,n,A){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");S(k,E,A,!0)}}e.optional=y}),define(we[142],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function S(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(we[143],Ee([0,1,3,56,6,22,78,59,142]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(_){return typeof _=="string"?!1:Array.isArray(_)?_.every(n):!!_.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(f,s){let h={selector:f,provider:s,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(h){let p=this._entries.indexOf(h);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const s=[];for(let h of this._entries)h._score>0&&s.push(h.provider);return s}ordered(f){const s=[];return this._orderedForEach(f,h=>s.push(h.provider)),s}orderedGroups(f){const s=[];let h,p;return this._orderedForEach(f,m=>{h&&p===m._score?h.push(m.provider):(p=m._score,h=[m.provider],s.push(h))}),s}_orderedForEach(f,s){if(!!f){this._updateScores(f);for(const h of this._entries)h._score>0&&s(h)}}_updateScores(f){let s={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let h of this._entries)if(h._score=(0,k.score)(h.selector,f.uri,f.getLanguageIdentifier().language,(0,E.shouldSynchronizeModel)(f)),n(h.selector)&&h._score>0){for(let p of this._entries)p._score=0;h._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(f,s){return f._score<s._score?1:f._score>s._score?-1:f._time<s._time?1:f._time>s._time?-1:0}}e.LanguageFeatureRegistry=A;class C{constructor(f,s,h=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=s,this.max=h,this._cache=new P.LRUCache(50,.7)}_key(f){return f.id+(0,S.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const s=this._key(f),h=this._cache.get(s);return this._clamp(h==null?void 0:h.value)}update(f,s){const h=this._key(f);let p=this._cache.get(h);return p||(p=new y.MovingAverage,this._cache.set(h,p)),p.update(s),this.get(f)}}e.LanguageFeatureRequestDelays=C}),define(we[62],Ee([0,1,2,33,143,116,37]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class E{constructor(w,I){this.language=w,this.id=I}}e.LanguageIdentifier=E;var n;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var A;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var C;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let I=this.getForeground(w),F="mtk"+I,B=this.getFontStyle(w);return B&1&&(F+=" mtki"),B&2&&(F+=" mtkb"),B&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(w,I){const F=this.getForeground(w),B=this.getFontStyle(w);let le=`color: ${I[F]};`;return B&1&&(le+="font-style: italic;"),B&2&&(le+="font-weight: bold;"),B&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=f;var s;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(w){const I=g[w];let F=I&&y.iconRegistry.get(I);return F||(console.info("No codicon found for CompletionItemKind "+w),F=y.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(w,I){let F=g[w];return typeof F=="undefined"&&!I&&(F=9),F}}();var h;(function(g){g[g.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(g){return g&&b.URI.isUri(g.uri)&&S.Range.isIRange(g.range)&&(S.Range.isIRange(g.originSelectionRange)||S.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=o;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var l;(function(g){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function F(H){return w.get(H)}g.fromString=F;function B(H){return I.get(H)}g.toString=B;function le(H,z){const K=I.get(H);let L=K&&y.iconRegistry.get("symbol-"+K);return L||(console.info("No codicon found for SymbolKind "+H),L=y.Codicon.symbolProperty),`${z?"inline":"block"} ${L.classNames}`}g.toCssClassName=le})(l=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(w){this.value=w}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var i;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var D;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(D=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var R;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[144],Ee([0,1,6,12,4,3,46,54]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(E,n){if(!E)throw new Error("invalid command");if(typeof E=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:E,handler:n})}if(E.description){const s=[];for(let p of E.description.args)s.push(p.constraint);const h=E.handler;E.handler=function(p,...m){return(0,S.validateConstraints)(m,s),h(p,...m)}}const{id:A}=E;let C=this._commands.get(A);C||(C=new y.LinkedList,this._commands.set(A,C));let _=C.unshift(E),f=(0,b.toDisposable)(()=>{_();const s=this._commands.get(A);(s==null?void 0:s.isEmpty())&&this._commands.delete(A)});return this._onDidRegisterCommand.fire(A),f}registerCommandAlias(E,n){return e.CommandsRegistry.registerCommand(E,(A,...C)=>A.get(e.ICommandService).executeCommand(n,...C))}getCommand(E){const n=this._commands.get(E);if(!(!n||n.isEmpty()))return k.Iterable.first(n)}getCommands(){const E=new Map;for(const n of this._commands.keys()){const A=this.getCommand(n);A&&E.set(n,A)}return E}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(we[63],Ee([0,1,8,4,21]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",P.indexOf("Edg/")>=0),y.set("isFirefox",P.indexOf("Firefox")>=0),y.set("isChrome",P.indexOf("Chrome")>=0),y.set("isSafari",P.indexOf("Safari")>=0),y.set("isIPad",P.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var E;(function(g){g[g.False=0]="False",g[g.True=1]="True",g[g.Defined=2]="Defined",g[g.Not=3]="Not",g[g.Equals=4]="Equals",g[g.NotEquals=5]="NotEquals",g[g.And=6]="And",g[g.Regex=7]="Regex",g[g.NotRegex=8]="NotRegex",g[g.Or=9]="Or",g[g.In=10]="In",g[g.NotIn=11]="NotIn",g[g.Greater=12]="Greater",g[g.GreaterEquals=13]="GreaterEquals",g[g.Smaller=14]="Smaller",g[g.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return _.INSTANCE}static has(w){return f.create(w)}static equals(w,I){return s.create(w,I)}static notEquals(w,I){return m.create(w,I)}static regex(w,I){return r.create(w,I)}static in(w,I){return h.create(w,I)}static not(w){return v.create(w)}static and(...w){return a.create(w)}static or(...w){return i.create(w)}static greater(w,I){return d.create(w,I)}static less(w,I){return o.create(w,I)}static deserialize(w,I=!1){if(!!w)return this._deserializeOrExpression(w,I)}static _deserializeOrExpression(w,I){let F=w.split("||");return i.create(F.map(B=>this._deserializeAndExpression(B,I)))}static _deserializeAndExpression(w,I){let F=w.split("&&");return a.create(F.map(B=>this._deserializeOne(B,I)))}static _deserializeOne(w,I){if(w=w.trim(),w.indexOf("!=")>=0){let F=w.split("!=");return m.create(F[0].trim(),this._deserializeValue(F[1],I))}if(w.indexOf("==")>=0){let F=w.split("==");return s.create(F[0].trim(),this._deserializeValue(F[1],I))}if(w.indexOf("=~")>=0){let F=w.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],I))}if(w.indexOf(" in ")>=0){let F=w.split(" in ");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const F=w.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const F=w.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const F=w.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const F=w.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(w)?v.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,I){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let F=/^'([^']*)'$/.exec(w);return F?F[1].trim():w}static _deserializeRegexValue(w,I){if((0,b.isFalsyOrWhitespace)(w)){if(I)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=w.indexOf("/"),B=w.lastIndexOf("/");if(F===B||F<0){if(I)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let le=w.slice(F+1,B),H=w[B+1]==="i"?"i":"";try{return new RegExp(le,H)}catch(z){if(I)throw new Error(`bad regexp-value '${w}', parse error: ${z}`);return console.warn(`bad regexp-value '${w}', parse error: ${z}`),null}}}e.ContextKeyExpr=n;function A(g,w){return g.cmp(w)}class C{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class _{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class f{constructor(w){this.key=w,this.type=2}static create(w){const I=y.get(w);return typeof I=="boolean"?I?_.INSTANCE:C.INSTANCE:new f(w)}cmp(w){return w.type!==this.type?this.type-w.type:D(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return v.create(this.key)}}e.ContextKeyDefinedExpr=f;class s{constructor(w,I){this.key=w,this.value=I,this.type=4}static create(w,I){if(typeof I=="boolean")return I?f.create(w):v.create(w);const F=y.get(w);return typeof F=="boolean"?I===(F?"true":"false")?_.INSTANCE:C.INSTANCE:new s(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class h{constructor(w,I){this.key=w,this.valueKey=I,this.type=10}static create(w,I){return new h(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const I=w.getValue(this.valueKey),F=w.getValue(this.key);return Array.isArray(I)?I.indexOf(F)>=0:typeof F=="string"&&typeof I=="object"&&I!==null?k.call(I,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=h;class p{constructor(w){this._actual=w,this.type=11}static create(w){return new p(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new p(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(w,I){this.key=w,this.value=I,this.type=5}static create(w,I){if(typeof I=="boolean")return I?v.create(w):f.create(w);const F=y.get(w);return typeof F=="boolean"?I===(F?"true":"false")?C.INSTANCE:_.INSTANCE:new m(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class v{constructor(w){this.key=w,this.type=3}static create(w){const I=y.get(w);return typeof I=="boolean"?I?C.INSTANCE:_.INSTANCE:new v(w)}cmp(w){return w.type!==this.type?this.type-w.type:D(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=v;class d{constructor(w,I){this.key=w,this.value=I,this.type=12}static create(w,I){return new d(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class c{constructor(w,I){this.key=w,this.value=I,this.type=13}static create(w,I){return new c(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class o{constructor(w,I){this.key=w,this.value=I,this.type=14}static create(w,I){return new o(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(w,I){this.key=w,this.value=I,this.type=15}static create(w,I){return new t(w,I)}cmp(w){return w.type!==this.type?this.type-w.type:R(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(w,I){this.key=w,this.regexp=I,this.type=7}static create(w,I){return new r(w,I)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const I=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return I<F?-1:I>F?1:0}equals(w){if(w.type===this.type){const I=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return this.key===w.key&&I===F}return!1}evaluate(w){let I=w.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=r;class l{constructor(w){this._actual=w,this.type=8}static create(w){return new l(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new l(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class a{constructor(w){this.expr=w,this.type=6}static create(w){return a._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let I=0,F=this.expr.length;I<F;I++){const B=A(this.expr[I],w.expr[I]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].equals(w.expr[I]))return!1;return!0}return!1}evaluate(w){for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].evaluate(w))return!1;return!0}static _normalizeArr(w){const I=[];let F=!1;for(const B of w)if(!!B){if(B.type===1){F=!0;continue}if(B.type===0)return C.INSTANCE;if(B.type===6){I.push(...B.expr);continue}I.push(B)}if(I.length===0&&F)return _.INSTANCE;if(I.length!==0){if(I.length===1)return I[0];for(I.sort(A);I.length>1;){const B=I[I.length-1];if(B.type!==9)break;I.pop();const le=I.pop(),H=i.create(B.expr.map(z=>a.create([z,le])));H&&(I.push(H),I.sort(A))}return I.length===1?I[0]:new a(I)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let I of this.expr)w.push(...I.keys());return w}map(w){return new a(this.expr.map(I=>I.map(w)))}negate(){let w=[];for(let I of this.expr)w.push(I.negate());return i.create(w)}}e.ContextKeyAndExpr=a;class i{constructor(w){this.expr=w,this.type=9}static create(w){const I=i._normalizeArr(w);if(I.length!==0)return I.length===1?I[0]:new i(I)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let I=0,F=this.expr.length;I<F;I++){const B=A(this.expr[I],w.expr[I]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].equals(w.expr[I]))return!1;return!0}return!1}evaluate(w){for(let I=0,F=this.expr.length;I<F;I++)if(this.expr[I].evaluate(w))return!0;return!1}static _normalizeArr(w){let I=[],F=!1;if(w){for(let B=0,le=w.length;B<le;B++){const H=w[B];if(!!H){if(H.type===0){F=!0;continue}if(H.type===1)return[_.INSTANCE];if(H.type===9){I=I.concat(H.expr);continue}I.push(H)}}if(I.length===0&&F)return[C.INSTANCE];I.sort(A)}return I}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let I of this.expr)w.push(...I.keys());return w}map(w){return new i(this.expr.map(I=>I.map(w)))}negate(){let w=[];for(let F of this.expr)w.push(F.negate());const I=F=>F.type===9?F.expr:[F];for(;w.length>1;){const F=w.shift(),B=w.shift(),le=[];for(const H of I(F))for(const z of I(B))le.push(n.and(H,z));w.unshift(n.or(...le))}return w[0]}}e.ContextKeyOrExpr=i;class u extends f{constructor(w,I,F){super(w);this.key=w,this._defaultValue=I,typeof F=="object"?u._info.push(Object.assign(Object.assign({},F),{key:w})):F!==!0&&u._info.push({key:w,description:F,type:I!=null?typeof I:void 0})}static all(){return u._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(w){return n.equals(this.key,w)}notEqualsTo(w){return n.notEquals(this.key,w)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function D(g,w){return g<w?-1:g>w?1:0}function R(g,w,I,F){return g<I?-1:g>I?1:w<F?-1:w>F?1:0}}),define(we[145],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],Ee([0,1,8,4]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class y{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,C){if(typeof A=="undefined"||A===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof A=="string"||typeof C=="string"){let _=typeof A=="string"?A:A.value,f=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(_,f)}return A._lower===C._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=y;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function E(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[146],Ee([0,1,8,25]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(f,s){return f.uuid&&s.uuid?f.uuid===s.uuid:f.id===s.id?!0:(0,b.compareIgnoreCase)(f.id,s.id)===0}e.areSameExtensions=T;class P{constructor(s,h){this.version=h,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=P;function y(f,s){return`${f}.${s}`}e.getExtensionId=y;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function E(f,s){return k(y(f,s))}e.getGalleryExtensionId=E;function n(f,s){const h=[],p=m=>{for(const v of h)if(v.some(d=>T(s(d),s(m))))return v;return null};for(const m of f){const v=p(m);v?v.push(m):h.push([m])}return h}e.groupByExtension=n;function A(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function C(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function _(f){const s=new Set;for(const h of f)h.malicious&&s.add(h.id.id);return s}e.getMaliciousExtensionsSet=_}),define(we[64],Ee([0,1,122,11,2,4,8,12,22]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var A;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var C;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=_;function f(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=f;function s(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function h(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=h;var p;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(z,K){super(z);this.code=K}}e.FileSystemProviderError=m;function v(H,z){const K=new m(H.toString(),z);return c(K,z),K}e.createFileSystemProviderError=v;function d(H){return H||v((0,b.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=d;function c(H,z){return H.name=z?`${z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=c;function o(H){if(!H)return p.Unknown;if(H instanceof m)return H.code;const z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!z)return p.Unknown;switch(z[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=o;function t(H){if(H instanceof D)return H.fileOperationResult;switch(o(H)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(z,K,L){this.resource=z,this.operation=K,this.target=L}isOperation(z){return this.operation===z}}e.FileOperationEvent=l;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class i{constructor(z,K){this.ignorePathCasing=K,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const L of z)switch(L.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(z,...K){return this.doContains(z,{includeChildren:!1},...K)}affects(z,...K){return this.doContains(z,{includeChildren:!0},...K)}doContains(z,K,...L){var $,U,G,N,Z,ne;if(!z)return!1;const re=L.length>0;return!!((!re||L.includes(1))&&((($=this.added)===null||$===void 0?void 0:$.get(z))||K.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(z)))||(!re||L.includes(0))&&(((G=this.updated)===null||G===void 0?void 0:G.get(z))||K.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(z)))||(!re||L.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(z))||K.includeChildren&&((ne=this.deleted)===null||ne===void 0?void 0:ne.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const K=[],L=z===1?this.added:z===0?this.updated:this.deleted;if(L)for(const[,$]of L)K.push($);return K}filter(z){return new i(this.changes.filter(K=>z(K)),this.ignorePathCasing)}}e.FileChangesEvent=i;function u(H,z,K){return!H||!z||H===z||z.length>H.length?!1:(z.charAt(z.length-1)!==S.sep&&(z+=S.sep),K?(0,y.startsWithIgnoreCase)(H,z):H.indexOf(z)===0)}e.isParent=u;class D extends Error{constructor(z,K,L){super(z);this.fileOperationResult=K,this.options=L}static isFileOperationError(z){return z instanceof Error&&!(0,k.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=D;var R;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var g;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(g=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=w;async function I(H,z){if(!z.canHandleResource(T.URI.from({scheme:H.scheme})))return new Promise(K=>{const L=z.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===H.scheme&&$.added&&(L.dispose(),K())})})}e.whenProviderRegistered=I,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(z){return(0,k.isNumber)(z)||(z=0),z<F.KB?(0,b.localize)(1,null,z.toFixed(0)):z<F.MB?(0,b.localize)(2,null,(z/F.KB).toFixed(2)):z<F.GB?(0,b.localize)(3,null,(z/F.MB).toFixed(2)):z<F.TB?(0,b.localize)(4,null,(z/F.GB).toFixed(2)):(0,b.localize)(5,null,(z/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function le(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=le}),define(we[65],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...T){this._entries=new Map;for(let[P,y]of T)this.set(P,y)}set(T,P){const y=this._entries.get(T);return this._entries.set(T,P),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=b}),define(we[147],Ee([0,1,10,141,86,4,65,13]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class n extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class A{constructor(s=new y.ServiceCollection,h=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=h,this._parent=p,this._services.set(P.IInstantiationService,this)}createChild(s){return new A(s,this._strict,this)}invokeFunction(s,...h){let p=_.traceInvocation(s),m=!1;try{return s({get:(d,c)=>{if(m)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(d,p);if(!o&&c!==P.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return o}},...h)}finally{m=!0,p.stop()}}createInstance(s,...h){let p,m;return s instanceof T.SyncDescriptor?(p=_.traceCreation(s.ctor),m=this._createInstance(s.ctor,s.staticArguments.concat(h),p)):(p=_.traceCreation(s),m=this._createInstance(s,h,p)),p.stop(),m}_createInstance(s,h=[],p){let m=P._util.getServiceDependencies(s).sort((c,o)=>c.index-o.index),v=[];for(const c of m){let o=this._getOrCreateServiceInstance(c.id,p);if(!o&&this._strict&&!c.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`);v.push(o)}let d=m.length>0?m[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${s.name} at position ${d+1} conflicts with ${h.length} static arguments`);let c=d-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,d)}return new s(...[...h,...v])}_setServiceInstance(s,h){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,h);else if(this._parent)this._parent._setServiceInstance(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let h=this._services.get(s);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):h}_getOrCreateServiceInstance(s,h){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,h.branch(s,!0)):(h.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,h,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,h,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,h,p){const m=new S.Graph(c=>c.id.toString());let v=0;const d=[{id:s,desc:h,_trace:p}];for(;d.length;){const c=d.pop();if(m.lookupOrInsertNode(c),v++>1e3)throw new n(m);for(let o of P._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${s} depends on ${o.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const r={id:o.id,desc:t,_trace:c._trace.branch(o.id,!0)};m.insertEdge(c,r),d.push(r)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new n(m);break}for(const{data:o}of c){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}m.removeNode(o)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,h,p=[],m,v){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(h,p,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,h,p,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(s,h=[],p,m){if(p){const v=new k.IdleValue(()=>this._createInstance(s,h,m));return new Proxy(Object.create(null),{get(d,c){if(c in d)return d[c];let o=v.value,t=o[c];return typeof t!="function"||(t=t.bind(o),d[c]=t),t},set(d,c,o){return v.value[c]=o,!0}})}else return this._createInstance(s,h,m)}}e.InstantiationService=A;var C;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(C||(C={}));class _{constructor(s,h){this.type=s,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return E?new _(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(s){return E?new _(0,s.name):_._None}branch(s,h){let p=new _(2,s.toString());return this._dep.push([s,h,p]),p}stop(){let s=Date.now()-this._start;_._totals+=s;let h=!1;function p(v,d){let c=[],o=new Array(v+1).join("	");for(const[t,r,l]of d._dep)if(r&&l){h=!0,c.push(`${o}CREATES -> ${t}`);let a=p(v+1,l);a&&c.push(a)}else c.push(`${o}uses -> ${t}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(s>2||h)&&console.log(m.join(`
`))}}_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(we[19],Ee([0,1,4,6,21,3,60]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function k(){return new Date().toISOString()}var E;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class n extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class A extends n{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(E.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(E.Error,this.format(r))}else this.log(E.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let r=0;r<o.length;r++){let l=o[r];if(typeof l=="object")try{l=JSON.stringify(l)}catch(a){}t+=(r>0?" ":"")+l}return t}}e.AbstractMessageLogger=A;class C extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}debug(o,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}info(o,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}warn(o,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,o,...t):console.warn(`[main ${k()}]`,o,...t))}error(o,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,o,...t):console.error(`[main ${k()}]`,o,...t))}critical(o,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,o,...t):console.error(`[main ${k()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class _ extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=_;class f extends n{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,y.toErrorMessage)(o,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class s extends n{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const r of this.logServices)r.trace(o,...t)}debug(o,...t){for(const r of this.logServices)r.debug(o,...t)}info(o,...t){for(const r of this.logServices)r.info(o,...t)}warn(o,...t){for(const r of this.logServices)r.warn(o,...t)}error(o,...t){for(const r of this.logServices)r.error(o,...t)}critical(o,...t){for(const r of this.logServices)r.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=s;class h extends S.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=h;class p{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(o){}getLevel(){return E.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=p;function m(c){if(c.verbose)return E.Trace;if(typeof c.logLevel=="string"){const o=v(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function v(c){switch(c){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=v;function d(c){switch(c){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=d}),define(we[87],Ee([0,1,4,123,47]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function n(s,h){return h-s}E.compare=n;const A=Object.create(null);A[E.Error]=(0,S.localize)(0,null),A[E.Warning]=(0,S.localize)(1,null),A[E.Info]=(0,S.localize)(2,null);function C(s){return A[s]||""}E.toString=C;function _(s){switch(s){case T.default.Error:return E.Error;case T.default.Warning:return E.Warning;case T.default.Info:return E.Info;case T.default.Ignore:return E.Hint}}E.fromSeverity=_;function f(s){switch(s){case E.Error:return T.default.Error;case E.Warning:return T.default.Warning;case E.Info:return T.default.Info;case E.Hint:return T.default.Ignore}}E.toSeverity=f}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(E){const n="";function A(_){return C(_,!0)}E.makeKey=A;function C(_,f){let s=[n];return _.source?s.push(_.source.replace("\xA6","\\\xA6")):s.push(n),_.code?typeof _.code=="string"?s.push(_.code.replace("\xA6","\\\xA6")):s.push(_.code.value.replace("\xA6","\\\xA6")):s.push(n),_.severity!==void 0&&_.severity!==null?s.push(y.toString(_.severity)):s.push(n),_.message&&f?s.push(_.message.replace("\xA6","\\\xA6")):s.push(n),_.startLineNumber!==void 0&&_.startLineNumber!==null?s.push(_.startLineNumber.toString()):s.push(n),_.startColumn!==void 0&&_.startColumn!==null?s.push(_.startColumn.toString()):s.push(n),_.endLineNumber!==void 0&&_.endLineNumber!==null?s.push(_.endLineNumber.toString()):s.push(n),_.endColumn!==void 0&&_.endColumn!==null?s.push(_.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}E.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[148],Ee([0,1,47,4,3]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,S.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new E,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=k;class E{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=E});var je=this&&this.__decorate||function(oe,e,b,S){var T=arguments.length,P=T<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,b):S,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(oe,e,b,S);else for(var k=oe.length-1;k>=0;k--)(y=oe[k])&&(P=(T<3?y(P):T>3?y(e,b,P):y(e,b))||P);return T>3&&P&&Object.defineProperty(e,b,P),P},qe=this&&this.__param||function(oe,e){return function(b,S){e(b,S,oe)}};define(we[149],Ee([0,1,4,20,6,13]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let E=class extends T.Disposable{constructor(C,_){super();this.deferred=new P.DeferredPromise,_.withProgress(C,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};E=je([qe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class n extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const _=++this.currentOperationId,f=new S.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:f.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,12,43]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,k){S.ok(b.isString(y)),S.ok(b.isObject(k)),S.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(we[88],Ee([0,1,30,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,n){this.schemasById[T(E)]=n,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;b.Registry.add(e.Extensions.JSONContribution,y)}),define(we[66],Ee([0,1,121,3,30,12,88]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=T.Registry.as(y.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,v=!0){this.registerConfigurations([m],v)}registerConfigurations(m,v=!0){const d=[];m.forEach(c=>{d.push(...this.validateAndRegisterProperties(c,v)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(m){const v=[],d=c=>{if(c.properties)for(const o in c.properties)v.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,c.properties[o]);c.allOf&&c.allOf.forEach(o=>d(o))};for(const c of m){d(c);const o=this.configurationContributors.indexOf(c);o!==-1&&this.configurationContributors.splice(o,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(m){const v=[],d=[];for(const c of m)for(const o in c)if(v.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),c[o]);const t={type:"object",default:this.defaultValues[o],description:b.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};d.push(C(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=c[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(m){const v=[];for(const d of m)for(const c in d)if(v.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const v of m)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,v=!0,d=3){d=P.isUndefinedOrNull(m.scope)?d:m.scope;let c=[],o=m.properties;if(o)for(let r in o){if(v&&s(r)){delete o[r];continue}const l=o[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:l.scope=P.isUndefinedOrNull(l.scope)?d:l.scope,o[r].hasOwnProperty("included")&&!o[r].included){this.excludedConfigurationProperties[r]=o[r],delete o[r];continue}else this.configurationProperties[r]=o[r];!o[r].deprecationMessage&&o[r].markdownDeprecationMessage&&(o[r].deprecationMessage=o[r].markdownDeprecationMessage),c.push(r)}let t=m.allOf;if(t)for(let r of t)c.push(...this.validateAndRegisterProperties(r,v,d));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const v=d=>{let c=d.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let o=d.allOf;o&&o.forEach(v)};v(m)}updateSchema(m,v){switch(e.allSettings.properties[m]=v,v.scope){case 1:e.applicationSettings.properties[m]=v;break;case 2:e.machineSettings.properties[m]=v;break;case 6:e.machineOverridableSettings.properties[m]=v;break;case 3:e.windowSettings.properties[m]=v;break;case 4:e.resourceSettings.properties[m]=v;break;case 5:e.resourceSettings.properties[m]=v,this.resourceLanguageSettingsSchema.properties[m]=v;break}}removeFromSchema(m,v){switch(delete e.allSettings.properties[m],v.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const v=`[${m}]`,d={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,d),e.allSettings.properties[v]=d,e.applicationSettings.properties[v]=d,e.machineSettings.properties[v]=d,e.machineOverridableSettings.properties[v]=d,e.windowSettings.properties[v]=d,e.resourceSettings.properties[v]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,v){let d=this.defaultValues[m];P.isUndefined(d)&&(d=v.default),P.isUndefined(d)&&(d=_(v.type)),v.default=d}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function C(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=C;function _(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const f=new n;T.Registry.add(e.Extensions.Configuration,f);function s(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?b.localize(5,null,p):f.getConfigurationProperties()[p]!==void 0?b.localize(6,null,p):null:b.localize(4,null)}e.validateProperty=s;function h(){const p=[],m=f.getConfigurationProperties();for(const v of Object.keys(m))p.push([v,m[v].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=h}),define(we[89],Ee([0,1,23,12,2,30,4,66]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function E(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.isConfigurationOverrides=E;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function A(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=A;function C(r,l){const a=l?r?l.keys.filter(I=>r.keys.indexOf(I)===-1):[...l.keys]:[],i=r?l?r.keys.filter(I=>l.keys.indexOf(I)===-1):[...r.keys]:[],u=[];if(l&&r){for(const I of r.keys)if(l.keys.indexOf(I)!==-1){const F=m(r.contents,I),B=m(l.contents,I);b.equals(F,B)||u.push(I)}}const D=[],R=I=>{const F={};for(const B of I)for(const le of B.identifiers)F[o(le)]=B;return F},g=l?R(l.overrides):{},w=r?R(r.overrides):{};if(Object.keys(g).length)for(const I of a){const F=g[I];F&&D.push([(0,k.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(w).length)for(const I of i){const F=w[I];F&&D.push([(0,k.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(g).length&&Object.keys(w).length)for(const I of u){const F=w[I],B=g[I];if(F&&B){const le=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});D.push([(0,k.overrideIdentifierFromKey)(I),[...le.added,...le.removed,...le.updated]])}}return{added:a,removed:i,updated:u,overrides:D}}e.compare=C;function _(r,l){const a=[];for(const i of Object.keys(r))if(k.OVERRIDE_PROPERTY_PATTERN.test(i)){const u={};for(const D in r[i])u[D]=r[i][D];a.push({identifiers:[(0,k.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(u),contents:f(u,l)})}return a}e.toOverrides=_;function f(r,l){const a=Object.create(null);for(let i in r)s(a,i,r[i],l);return a}e.toValuesTree=f;function s(r,l,a,i){const u=l.split("."),D=u.pop();let R=r;for(let g=0;g<u.length;g++){let w=u[g],I=R[w];switch(typeof I){case"undefined":I=R[w]=Object.create(null);break;case"object":break;default:i(`Ignoring ${l} as ${u.slice(0,g+1).join(".")} is ${JSON.stringify(I)}`);return}R=I}if(typeof R=="object"&&R!==null)try{R[D]=a}catch(g){i(`Ignoring ${l} as ${u.join(".")} is ${JSON.stringify(R)}`)}else i(`Ignoring ${l} as ${u.join(".")} is ${JSON.stringify(R)}`)}e.addToValueTree=s;function h(r,l){const a=l.split(".");p(r,a)}e.removeFromValueTree=h;function p(r,l){const a=l.shift();if(l.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const i=r[a];typeof i=="object"&&!Array.isArray(i)&&(p(i,l),Object.keys(i).length===0&&delete r[a])}}function m(r,l,a){function i(R,g){let w=R;for(const I of g){if(typeof w!="object"||w===null)return;w=w[I]}return w}const u=l.split("."),D=i(r,u);return typeof D=="undefined"?a:D}e.getConfigurationValue=m;function v(r,l,a){Object.keys(l).forEach(i=>{i!=="__proto__"&&(i in r?S.isObject(r[i])&&S.isObject(l[i])?v(r[i],l[i],a):a&&(r[i]=l[i]):r[i]=l[i])})}e.merge=v;function d(){const r=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=d;function c(){const r=Object.create(null),l=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let a in l){let i=l[a].default;s(r,a,i,u=>console.error(`Conflict in default settings: ${u}`))}return r}e.getDefaultValues=c;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,l,a){const i=r.inspect(l),u=r.inspect(a);return typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:i.defaultValue}e.getMigratedSettingValue=t}),define(we[150],Ee([0,1,45,22,15,12,23,2,66,89,30,6,3]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],l=[]){this._contents=t,this._keys=r,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const l=this.getContentsForOverrideIdentifer(r);return l?t?(0,n.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let l={};for(const a of T.distinct([...Object.keys(this.contents),...Object.keys(r)])){let i=this.contents[a],u=r[a];u&&(typeof i=="object"&&typeof u=="object"?(i=y.deepClone(i),this.mergeContents(i,u)):i=u),l[a]=i}return new f(l,this.keys,this.overrides)}merge(...t){const r=y.deepClone(this.contents),l=y.deepClone(this.overrides),a=[...this.keys];for(const i of t){this.mergeContents(r,i.contents);for(const u of i.overrides){const[D]=l.filter(R=>T.equals(R.identifiers,u.identifiers));D?this.mergeContents(D.contents,u.contents):l.push(y.deepClone(u))}for(const u of i.keys)a.indexOf(u)===-1&&a.push(u)}return new f(r,a,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const l of Object.keys(r)){if(l in t&&P.isObject(t[l])&&P.isObject(r[l])){this.mergeContents(t[l],r[l]);continue}t[l]=y.deepClone(r[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let l=0;l<r;l++)t.indexOf(this.keys[l])===0&&(r=l);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class s extends f{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),l=[];for(const a of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(a)&&l.push({identifiers:[(0,E.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,n.toValuesTree)(t[a],i=>console.error(`Conflict in default settings file: ${i}`))});super(t,r,l)}}e.DefaultConfigurationModel=s;class h{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},l=null,a=[],i=[],u=[];function D(g){Array.isArray(a)?a.push(g):l&&(a[l]=g)}let R={onObjectBegin:()=>{let g={};D(g),i.push(a),a=g,l=null},onObjectProperty:g=>{l=g},onObjectEnd:()=>{a=i.pop()},onArrayBegin:()=>{let g=[];D(g),i.push(a),a=g,l=null},onArrayEnd:()=>{a=i.pop()},onLiteralValue:D,onError:(g,w,I)=>{u.push({error:g,offset:w,length:I})}};if(t)try{b.visit(t,R),r=a[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return r}doParseRaw(t){if(this._scopes){const i=A.Registry.as(E.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,i,!0,this._scopes)}const r=(0,n.toValuesTree)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`)),l=Object.keys(t),a=(0,n.toOverrides)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`));return{contents:r,keys:l,overrides:a}}filterByScope(t,r,l,a){const i={};for(let u in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(u)&&l)i[u]=this.filterByScope(t[u],r,!1,a);else{const D=this.getScope(u,r);(D===void 0||a.indexOf(D)!==-1)&&(i[u]=t[u])}return i}getScope(t,r){const l=r[t];return l?typeof l.scope!="undefined"?l.scope:3:void 0}}e.ConfigurationModelParser=h;class p extends C.Disposable{constructor(t,r,l,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(_.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=p;class m{constructor(t,r,l=new f,a=new f,i=new S.ResourceMap,u=new f,D=new S.ResourceMap,R=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=i,this._memoryConfiguration=u,this._memoryConfigurationByResource=D,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(t,r,l){return this.getConsolidateConfigurationModel(r,l).getValue(t)}updateValue(t,r,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new f,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,l){const a=this.getConsolidateConfigurationModel(r,l),i=this.getFolderConfigurationModelForResource(r.resource,l),u=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,D=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),R=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),I=l?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=i?r.overrideIdentifier?i.freeze().override(r.overrideIdentifier).getValue(t):i.freeze().getValue(t):void 0,B=r.overrideIdentifier?u.override(r.overrideIdentifier).getValue(t):u.getValue(t),le=a.getValue(t),H=T.distinct(T.flatten(a.overrides.map(z=>z.identifiers))).filter(z=>a.getOverrideValue(t,z)!==void 0);return{defaultValue:D,userValue:R,userLocalValue:g,userRemoteValue:w,workspaceValue:I,workspaceFolderValue:F,memoryValue:B,value:le,default:D!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:i==null?void 0:i.freeze().getValue(t),override:r.overrideIdentifier?i==null?void 0:i.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:u.getValue(t),override:r.overrideIdentifier?u.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const l=r.filter(a=>E.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const i=(0,E.overrideIdentifierFromKey)(a),u=this._defaultConfiguration.getKeysForOverrideIdentifier(i),D=t.getKeysForOverrideIdentifier(i),R=[...D.filter(g=>u.indexOf(g)===-1),...u.filter(g=>D.indexOf(g)===-1),...u.filter(g=>!y.equals(this._defaultConfiguration.override(i).getValue(g),t.override(i).getValue(g)))];return[i,R]});return this.updateDefaultConfiguration(t),{keys:r,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:l,removed:a,overrides:i}=(0,n.compare)(this.localUserConfiguration,t),u=[...r,...l,...a];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:i}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:l,removed:a,overrides:i}=(0,n.compare)(this.remoteUserConfiguration,t);let u=[...r,...l,...a];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:i}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:l,removed:a,overrides:i}=(0,n.compare)(this.workspaceConfiguration,t);let u=[...r,...l,...a];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:i}}compareAndUpdateFolderConfiguration(t,r){const l=this.folderConfigurations.get(t),{added:a,updated:i,removed:u,overrides:D}=(0,n.compare)(l,r);let R=[...a,...i,...u];return(R.length||!l)&&this.updateFolderConfiguration(t,r),{keys:R,overrides:D}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:a,removed:i,overrides:u}=(0,n.compare)(r,void 0);return{keys:[...l,...a,...i],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let l=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},r){let l=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const i=this._memoryConfigurationByResource.get(t);i&&(l=l.merge(i))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=l.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=l}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const l=r.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:l,overrides:a,keys:i}=this._folderConfigurations.get(r);return t.push([r,{contents:l,overrides:a,keys:i}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),i=t.folders.reduce((u,D)=>(u.set(k.URI.revive(D[0]),this.parseConfigurationModel(D[1])),u),new S.ResourceMap);return new m(r,l,new f,a,i,new f,new S.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const a of o)a.keys.forEach(i=>t.add(i)),a.overrides.forEach(([i,u])=>{const D=(0,S.getOrSet)(r,i,new Set);u.forEach(R=>D.add(R))});const l=[];return r.forEach((a,i)=>l.push([i,[...a.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=v;class d{constructor(t,r,l,a){this.change=t,this.previous=r,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const i=new Set;t.keys.forEach(D=>i.add(D)),t.overrides.forEach(([,D])=>D.forEach(R=>i.add(R))),this.affectedKeys=[...i.values()];const u=new f;this.affectedKeys.forEach(D=>u.setValue(D,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!y.equals(a,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let l=(0,n.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(t=t[a],!t)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=d;class c extends d{constructor(t,r,l,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=l,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c}),define(we[90],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var S;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(y,k=S.Unknown,E){super(y);this._message=y,this._code=k,this._detail=E,this.isHandled=k===S.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(y){return y instanceof T&&y._code===S.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof T&&y._code===S.NoResolverFound}static isHandled(y){return y instanceof T&&y.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[91],Ee([0,1,16]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function S(P){return P.scheme===b.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=S;function T(P){if(!!P){const y=P.indexOf("+");return y<0?P:P.substr(0,y)}}e.getRemoteName=T}),define(we[151],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,y=5){let k;return k=P(E=>{const n=typeof E=="string"?E:E.data;let A=this._terminalBufferMap.get(T);if(A){A.data.push(n);return}const C=setTimeout(()=>this._flushBuffer(T),y);A={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this._flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,A)}),k}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}_flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=b}),define(we[152],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(we[153],Ee([0,1,4,6,30,3,152,37]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var E;(function(p){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function n(p){return{id:p}}e.themeColorFromId=n;var A;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||E.isThemeColor(t.color))}p.isThemeIcon=m;const v=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const r=v.exec(t);if(!!r){let[,l]=r;return{id:l}}}p.fromString=d;function c(t,r){let l=t.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),r&&(l=`${l}~${r}`),{id:l}}p.modify=c;function o(t,r){var l,a;return t.id===r.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((a=r.color)===null||a===void 0?void 0:a.id)}p.isEqual=o,p.asClassNameArray=k.CSSIcon.asClassNameArray,p.asClassName=k.CSSIcon.asClassName,p.asCSSSelector=k.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,S.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new _;T.Registry.add(e.Extensions.ThemingContribution,f);function s(p){return f.onColorThemeChange(p)}e.registerThemingParticipant=s;class h extends S.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(we[154],Ee([0,1,30,153,3,124,88,13,37]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${E.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,v,d,c){const o=this.iconsById[m];if(o){if(d&&!o.description){o.description=d,this.iconSchema.properties[m].markdownDescription=`${d} $(${m})`;const l=this.iconReferenceSchema.enum.indexOf(m);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=d),this._onDidChange.fire()}return o}let t={id:m,description:d,defaults:v,deprecationMessage:c};this.iconsById[m]=t;let r={$ref:"#/definitions/icons"};return c&&(r.deprecationMessage=c),d&&(r.markdownDescription=`${d}: $(${m})`),this.iconSchema.properties[m]=r,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const v=this.iconReferenceSchema.enum.indexOf(m);v!==-1&&(this.iconReferenceSchema.enum.splice(v,1),this.iconReferenceSchema.enumDescriptions.splice(v,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,v){const d=this.iconFontsById[m];if(d)return d;let c={id:m,definition:v};return this.iconFontsById[m]=c,this._onDidChange.fire(),c}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(o,t)=>o.id.localeCompare(t.id),v=o=>{for(;S.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of c.filter(t=>!!t.description).sort(m))d.push(`|<i class="${v(o)}"></i>|${o.id}|${S.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const o of c.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(m))d.push(`|<i class="${v(o)}"></i>|${o.id}|`);return d.join(`
`)}}const A=new n;b.Registry.add(e.Extensions.IconContribution,A);function C(p,m,v,d){return A.registerIcon(p,m,v,d)}e.registerIcon=C;function _(){return A}e.getIconRegistry=_;function f(){for(const p of E.iconRegistry.all)A.registerIcon(p.id,p.definition,p.description);E.iconRegistry.onDidRegister(p=>A.registerIcon(p.id,p.definition,p.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let s=b.Registry.as(y.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,A.getIconSchema());const h=new k.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);A.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=C("widget-close",E.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",E.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",E.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=S.ThemeIcon.modify(E.Codicon.sync,"spin")}),define(we[48],Ee([0,1,2,24,4,22]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(_){_[_.EMPTY=1]="EMPTY",_[_.FOLDER=2]="FOLDER",_[_.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(_){const f=_;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=k;function E(_){const f=_;return!!(f&&typeof f=="object"&&b.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=E;class n{constructor(f,s,h,p){this._id=f,this._configuration=h,this._ignorePathCasing=p,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class A{constructor(f,s){this.raw=s,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,S.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function C(_){return new A({uri:_,index:0,name:(0,S.basenameOrAuthority)(_)},{uri:_.toString()})}e.toWorkspaceFolder=C}),define(we[155],Ee([0,1,4,125,48,2,21,11,24,104,45,16,58,38,91]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(K){return(typeof K=="string"?(0,k.extname)(K):(0,E.extname)(K))===h}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function m(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function v(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=v;function d(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=d;function c(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=c;function o(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function r(K){const L=K;if(L==null?void 0:L.uri)return{id:L.id,uri:P.URI.revive(L.uri)};const $=K;if($==null?void 0:$.configPath)return{id:$.id,configPath:P.URI.revive($.configPath)};if(K==null?void 0:K.id)return{id:K.id}}e.reviveIdentifier=r;function l(K,L){return E.extUriBiasedIgnorePathCase.isEqualOrParent(K,L.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function a(K){return i(K)||u(K)}e.isStoredWorkspaceFolder=a;function i(K){const L=K;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=i;function u(K){const L=K;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=u;function D(K,L,$,U,G=!y.isWindows,N){if(K.scheme!==U.scheme)return{name:$,uri:K.toString(!0)};let Z=L?void 0:N.relativePath(U,K);if(Z!==void 0)Z.length===0?Z=".":y.isWindows&&K.scheme===C.Schemas.file&&!G&&(Z=Z.replace(/\//g,"\\"));else if(K.scheme===C.Schemas.file)Z=K.fsPath,y.isWindows&&(Z=(0,_.normalizeDriveLetter)(Z),G&&(Z=(0,f.toSlashes)(Z)));else{if(!N.isEqualAuthority(K.authority,U.authority))return{name:$,uri:K.toString(!0)};Z=K.path}return{name:$,path:Z}}e.getStoredWorkspaceFolder=D;function R(K,L,$){let U=[],G=new Set;const N=$.dirname(L);for(let Z of K){let ne=null;if(i(Z))Z.path&&(ne=$.resolvePath(N,Z.path));else if(u(Z))try{ne=P.URI.parse(Z.uri),ne.path[0]!=="/"&&(ne=ne.with({path:"/"+ne.path}))}catch(re){console.warn(re)}if(ne){let re=$.getComparisonKey(ne);if(!G.has(re)){G.add(re);const ye=Z.name||$.basenameOrAuthority(ne);U.push(new T.WorkspaceFolder({uri:ne,name:ye,index:U.length},Z))}}}return U}e.toWorkspaceFolders=R;function g(K,L,$,U,G){let N=w(L,K);const Z=G.dirname(L),ne=G.dirname(U),re=[],ye=I(N.folders);for(const xe of N.folders){const W=i(xe)?G.resolvePath(Z,xe.path):P.URI.parse(xe.uri);let q;$?q=!1:q=!i(xe)||(0,k.isAbsolute)(xe.path),re.push(D(W,q,xe.name,ne,ye,G))}const Ae={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Be=n.setProperty(K,["folders"],re,Ae);let Re=n.applyEdits(K,Be);return N.remoteAuthority===(0,s.getRemoteAuthority)(U)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Ae))),Re}e.rewriteWorkspaceFileForNewLocation=g;function w(K,L){let $=A.parse(L);if($&&Array.isArray($.folders))$.folders=$.folders.filter(U=>a(U));else throw new Error(`${K} looks like an invalid workspace file.`);return $}function I(K){return y.isWindows?K.some(L=>i(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function F(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function B(K){return typeof K.folderUri=="string"}function le(K){return typeof K.fileUri=="string"}function H(K,L){const $={workspaces:[],files:[]};if(K){const U=function(N,Z){for(let ne=0;ne<N.length;ne++)try{Z(N[ne],ne)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(N[ne])}: ${re.toString()}. Skip entry.`)}},G=K;if(Array.isArray(G.entries))U(G.entries,N=>{const Z=N.label,ne=N.remoteAuthority;F(N)?$.workspaces.push({label:Z,remoteAuthority:ne,workspace:{id:N.workspace.id,configPath:P.URI.parse(N.workspace.configPath)}}):B(N)?$.workspaces.push({label:Z,remoteAuthority:ne,folderUri:P.URI.parse(N.folderUri)}):le(N)&&$.files.push({label:Z,remoteAuthority:ne,fileUri:P.URI.parse(N.fileUri)})});else{const N=K;Array.isArray(N.workspaces3)&&U(N.workspaces3,(Z,ne)=>{const re=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[ne]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?$.workspaces.push({label:re,workspace:{id:Z.id,configPath:P.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&$.workspaces.push({label:re,folderUri:P.URI.parse(Z)})}),Array.isArray(N.files2)&&U(N.files2,(Z,ne)=>{const re=Array.isArray(N.fileLabels)&&N.fileLabels[ne]||void 0;typeof Z=="string"&&$.files.push({label:re,fileUri:P.URI.parse(Z)})})}}return $}e.restoreRecentlyOpened=H;function z(K){const L={entries:[]};for(const $ of K.workspaces)v($)?L.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):L.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of K.files)L.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return L}e.toStoreData=z}),define(we[92],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(we[156],Ee([0,1,2,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(k=>({name:k.name,group:k.group,resource:b.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(we[49],Ee([0,1,16,4]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(we[157],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class b{constructor(P,y,k){this._id=P,this._shared=y,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(E=>(this._value=E,this)),this._storageListener=this._storage.onDidChangeStorage(E=>{E.shared===this._shared&&E.key===this._id&&(this._value=E.value)})}get whenReady(){return this._init}get(P,y){let k=this._value[P];return typeof k=="undefined"&&(k=y),k}update(P,y){return this._value[P]=y,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=b;class S extends b{constructor(P,y){super(P.identifier.value,!0,y);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=S}),define(we[14],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class S{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=S});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[158],Ee([0,1,25,3]),function(oe,e,b,S){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(k,E){T.set(this,void 0),this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(k.identifier),tt(this,T,E),We(this,T).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(k){return We(this,T).get(this._id,k)}store(k,E){return We(this,T).store(this._id,k,E)}delete(k){return We(this,T).delete(this._id,k)}}e.ExtensionSecrets=P,T=new WeakMap}),define(we[93],Ee([0,1,4,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new S.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(we[67],Ee([0,1,4,3,14]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(k){function E(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public}}k.fromApiTunnel=E;function n(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.public}}k.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(E){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,n){return{dispose:()=>{}}}async $providePortAttributes(E,n,A,C,_){return[]}async $forwardPort(E,n){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([qe(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[7],Ee([0,1,15,10,80,22,12,2,29,64,90]),function(oe,e,b,S,T,P,y,k,E,n,A){"use strict";var C,_,f,s,h,p,m,v,d,c,o,t,r,l,a,i;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function u(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let D=f=class{constructor(M){C.set(this,void 0),tt(this,C,M)}static from(...M){let te=M;return new f(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof We(this,C)=="function"&&(We(this,C).call(this),tt(this,C,void 0))}};C=new WeakMap,D=f=je([u],D),e.Disposable=D;let R=s=class{constructor(M,te){if(M<0)throw(0,S.illegalArgument)("line must be non-negative");if(te<0)throw(0,S.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Se=1;Se<M.length;Se++){const ze=M[Se];ze.isBefore(te)&&(te=ze)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Se=1;Se<M.length;Se++){const ze=M[Se];ze.isAfter(te)&&(te=ze)}return te}static isPosition(M){if(!M)return!1;if(M instanceof s)return!0;let{line:te,character:Se}=M;return typeof te=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,S.illegalArgument)();let Se;return typeof M=="undefined"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&te===0?this:new s(this.line+Se,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,S.illegalArgument)();let Se;return typeof M=="undefined"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Se===this.line&&te===this.character?this:new s(Se,te)}toJSON(){return{line:this.line,character:this.character}}};R=s=je([u],R),e.Position=R;let g=h=class{constructor(M,te,Se,ze){let Ye,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ye=new R(M,te),nt=new R(Se,ze)):M instanceof R&&te instanceof R&&(Ye=M,nt=te),!Ye||!nt)throw new Error("Invalid arguments");Ye.isBefore(nt)?(this._start=Ye,this._end=nt):(this._start=nt,this._end=Ye)}static isRange(M){return M instanceof h?!0:M?R.isPosition(M.start)&&R.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof h?this.contains(M._start)&&this.contains(M._end):M instanceof R?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=R.Max(M.start,this._start),Se=R.Min(M.end,this._end);if(!te.isAfter(Se))return new h(te,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=R.Min(M.start,this._start),Se=R.Max(M.end,this.end);return new h(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,S.illegalArgument)();let Se;return M?R.isPosition(M)?Se=M:(Se=M.start||this.start,te=M.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new h(Se,te)}toJSON(){return[this.start,this.end]}};g=h=je([u],g),e.Range=g;let w=p=class extends g{constructor(M,te,Se,ze){let Ye,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ye=new R(M,te),nt=new R(Se,ze)):M instanceof R&&te instanceof R&&(Ye=M,nt=te),!Ye||!nt)throw new Error("Invalid arguments");super(Ye,nt);this._anchor=Ye,this._active=nt}static isSelection(M){return M instanceof p?!0:M?g.isRange(M)&&R.isPosition(M.anchor)&&R.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};w=p=je([u],w),e.Selection=w;class I{constructor(M,te,Se){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,S.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,S.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=I;class F extends Error{constructor(M,te=A.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M);this._message=M,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype)}static NotAvailable(M,te){return new F(M,A.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new F(M,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=F;var B;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var le;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=m=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof m?!0:M?g.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new m(M,te)}static insert(M,te){return m.replace(new g(M,M),te)}static delete(M){return m.replace(M,"")}static setEndOfLine(M){const te=new m(new g(new R(0,0),new R(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!g.isRange(M))throw(0,S.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,S.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,S.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};H=m=je([u],H),e.TextEdit=H;var z;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(z=e.FileEditType||(e.FileEditType={}));let K=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Se,ze){this._edits.push({_type:1,from:M,to:te,options:Se,metadata:ze})}createFile(M,te,Se){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Se})}deleteFile(M,te,Se){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(M,te,Se){this._edits.push({_type:3,metadata:Se,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Se,ze,Ye){(te!==Se||ze.length>0)&&this._edits.push({_type:5,uri:M,index:te,count:Se-te,cells:ze,metadata:Ye})}replaceNotebookCellOutput(M,te,Se,ze){this._editNotebookCellOutput(M,te,!1,Se,ze)}appendNotebookCellOutput(M,te,Se,ze){this._editNotebookCellOutput(M,te,!0,Se,ze)}replaceNotebookCellOutputItems(M,te,Se,ze,Ye){this._editNotebookCellOutputItems(M,te,Se,!1,ze,Ye)}appendNotebookCellOutputItems(M,te,Se,ze,Ye){this._editNotebookCellOutputItems(M,te,Se,!0,ze,Ye)}_editNotebookCellOutputItems(M,te,Se,ze,Ye,nt){this._edits.push({_type:6,metadata:nt,uri:M,index:te,outputId:Se,append:ze,newOutputItems:Ye})}_editNotebookCellOutput(M,te,Se,ze,Ye){this._edits.push({_type:4,metadata:Ye,uri:M,index:te,append:Se,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(M,te,Se,ze){this._edits.push({_type:3,metadata:ze,uri:M,edit:{editType:3,index:te,metadata:Se}})}replace(M,te,Se,ze){this._edits.push({_type:2,uri:M,edit:new H(te,Se),metadata:ze})}insert(M,te,Se,ze){this.replace(M,new g(te,te),Se,ze)}delete(M,te,Se){this.replace(M,te,"",Se)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:M,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===M.toString()&&(this._edits[Se]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===M.toString()&&te.push(Se.edit);return te}entries(){const M=new P.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=M.get(te.uri);Se||(Se=[te.uri,[]],M.set(te.uri,Se)),Se[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};K=je([u],K),e.WorkspaceEdit=K;let L=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Se=new v;Se._tabstop=this._tabstop,M(Se),this._tabstop=Se._tabstop,M=Se.value}else M=v._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Se=M.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Se=new v;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};L=v=je([u],L),e.SnippetString=L;var $;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=d=class{constructor(M,te){if(this.uri=M,te)if(te instanceof g)this.range=te;else if(te instanceof R)this.range=new g(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof d?!0:M?g.isRange(M.range)&&k.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=d=je([u],G),e.Location=G;let N=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&g.isRange(M.location.range)&&k.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};N=je([u],N),e.DiagnosticRelatedInformation=N;let Z=class{constructor(M,te,Se=U.Error){if(!g.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Se}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,b.equals)(M.tags,te.tags)&&(0,b.equals)(M.relatedInformation,te.relatedInformation,N.isEqual)}};Z=je([u],Z),e.Diagnostic=Z;let ne=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,T.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=te}};ne=je([u],ne),e.Hover=ne;var re;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ye=class{constructor(M,te=re.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:re[this.kind]}}};ye=je([u],ye),e.DocumentHighlight=ye;var Ae;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var Be;(function(O){O[O.Deprecated=1]="Deprecated"})(Be=e.SymbolTag||(e.SymbolTag={}));let Re=c=class{constructor(M,te,Se,ze,Ye){this.name=M,this.kind=te,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),ze instanceof G?this.location=ze:Se instanceof g&&(this.location=new G(ze,Se)),c.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};Re=c=je([u],Re),e.SymbolInformation=Re;let xe=o=class{constructor(M,te,Se,ze,Ye){this.name=M,this.detail=te,this.kind=Se,this.range=ze,this.selectionRange=Ye,this.children=[],o.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(o.validate)}};xe=o=je([u],xe),e.DocumentSymbol=xe;var W;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(W=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(M,te){this.title=M,this.kind=te}};q=je([u],q),e.CodeAction=q;let J=t=class{constructor(M){this.value=M}append(M){return new t(this.value?this.value+t.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+t.sep)}};J.sep=".",J=t=je([u],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let ae=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([u],ae),e.SelectionRange=ae;class ge{constructor(M,te,Se,ze,Ye,nt){this.kind=M,this.name=te,this.detail=Se,this.uri=ze,this.range=Ye,this.selectionRange=nt}}e.CallHierarchyItem=ge;class De{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=De;class Le{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=Le;let pe=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};pe=je([u],pe),e.CodeLens=pe;let Ce=r=class{constructor(M,te=!1){_.set(this,void 0),tt(this,_,new T.MarkdownString(M,{supportThemeIcons:te}))}static isMarkdownString(M){return M instanceof r?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return We(this,_).value}set value(M){We(this,_).value=M}get isTrusted(){return We(this,_).isTrusted}set isTrusted(M){We(this,_).isTrusted=M}get supportThemeIcons(){return We(this,_).supportThemeIcons}appendText(M){return We(this,_).appendText(M),this}appendMarkdown(M){return We(this,_).appendMarkdown(M),this}appendCodeblock(M,te){return We(this,_).appendCodeblock(te!=null?te:"",M),this}};_=new WeakMap,Ce=r=je([u],Ce),e.MarkdownString=Ce;let Te=class{constructor(M,te){this.label=M,this.documentation=te}};Te=je([u],Te),e.ParameterInformation=Te;let Ue=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};Ue=je([u],Ue),e.SignatureInformation=Ue;let be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};be=je([u],be),e.SignatureHelp=be;var Ke;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var V;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(V=e.InlineHintKind||(e.InlineHintKind={}));let X=class{constructor(M,te,Se){this.text=M,this.range=te,this.kind=Se}};X=je([u],X),e.InlineHint=X;var _e;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Me=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(O){O[O.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=je([u],Oe),e.CompletionItem=Oe;let Xe=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};Xe=je([u],Xe),e.CompletionList=Xe;var x;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(x=e.ViewColumn||(e.ViewColumn={}));var ie;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(ie=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ce;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var j;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(j=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Y;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var fe;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(te){switch(te){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(M,te){if(te&&!k.URI.isUri(te))throw(0,S.illegalArgument)("target");if(!g.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.target=te}};ve=je([u],ve),e.DocumentLink=ve;let $e=class{constructor(M,te,Se,ze){this.red=M,this.green=te,this.blue=Se,this.alpha=ze}};$e=je([u],$e),e.Color=$e;let Ne=class{constructor(M,te){if(te&&!(te instanceof $e))throw(0,S.illegalArgument)("color");if(!g.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.color=te}};Ne=je([u],Ne),e.ColorInformation=Ne;let Ve=class{constructor(M){if(!M||typeof M!="string")throw(0,S.illegalArgument)("label");this.label=M}};Ve=je([u],Ve),e.ColorPresentation=Ve;var Qe;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ct;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(ct=e.TaskRevealKind||(e.TaskRevealKind={}));var st;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(st=e.TaskPanelKind||(e.TaskPanelKind={}));let me=l=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,S.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};me.Clean=new l("clean","Clean"),me.Build=new l("build","Build"),me.Rebuild=new l("rebuild","Rebuild"),me.Test=new l("test","Test"),me=l=je([u],me),e.TaskGroup=me;function he(O){let M="";for(let te=0;te<O.length;te++)M+=O[te].replace(/,/g,",,")+",";return M}let ue=class{constructor(M,te,Se){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return he(M)}};ue=je([u],ue),e.ProcessExecution=ue;let Q=class{constructor(M,te,Se){if(this._args=[],Array.isArray(te)){if(!M)throw(0,S.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M,this._args=te,this._options=Se}else{if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return he(M)}};Q=je([u],Q),e.ShellExecution=Q;var Ie;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Ie=e.ShellQuoting||(e.ShellQuoting={}));var Pe;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Pe=e.TaskScope||(e.TaskScope={}));class et{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,E.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=et;let Ge=a=class{constructor(M,te,Se,ze,Ye,nt){this.__deprecated=!1,this._definition=this.definition=M;let ot;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=ze,ot=Ye,this.__deprecated=!0):te===Pe.Global||te===Pe.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ye,ot=nt):(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ye,ot=nt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:a.ProcessType,id:this._execution.computeId()}:this._execution instanceof Q?this._definition={type:a.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:a.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:a.EmptyType,id:(0,E.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,S.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,S.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(a.EmptyType===te||a.ProcessType===te||a.ShellType===te||a.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=a=je([u],Ge),e.Task=Ge;var rt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(M,te=Je.None){this.collapsibleState=te,k.URI.isUri(M)?this.resourceUri=M:this.label=M}};lt=je([u],lt),e.TreeItem=lt;var Je;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Je=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let it=class{constructor(M,te){this.id=M,this.color=te}};it=je([u],it),e.ThemeIcon=it,it.File=new it("file"),it.Folder=new it("folder");let dt=class{constructor(M){this.id=M}};dt=je([u],dt),e.ThemeColor=dt;var at;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(at=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(M,te){if(typeof M!="string"&&(!M||!k.URI.isUri(M)&&!k.URI.isUri(M.uri)))throw(0,S.illegalArgument)("base");if(typeof te!="string")throw(0,S.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=k.URI.file(M),this.base=M):k.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};Dt=je([u],Dt),e.RelativePattern=Dt;let gt=class{constructor(M,te,Se,ze){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,E.generateUuid)()),this._id}};gt=je([u],gt),e.Breakpoint=gt;let Ct=class extends gt{constructor(M,te,Se,ze,Ye){super(te,Se,ze,Ye);if(M===null)throw(0,S.illegalArgument)("location");this.location=M}};Ct=je([u],Ct),e.SourceBreakpoint=Ct;let wt=class extends gt{constructor(M,te,Se,ze,Ye){super(te,Se,ze,Ye);this.functionName=M}};wt=je([u],wt),e.FunctionBreakpoint=wt;let Et=class extends gt{constructor(M,te,Se,ze,Ye,nt,ot){super(ze,Ye,nt,ot);if(!te)throw(0,S.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Se}};Et=je([u],Et),e.DataBreakpoint=Et;let mt=class{constructor(M,te,Se){this.command=M,this.args=te||[],this.options=Se}};mt=je([u],mt),e.DebugAdapterExecutable=mt;let Rt=class{constructor(M,te){this.port=M,this.host=te}};Rt=je([u],Rt),e.DebugAdapterServer=Rt;let Ft=class{constructor(M){this.path=M}};Ft=je([u],Ft),e.DebugAdapterNamedPipeServer=Ft;let ht=class{constructor(M){this.implementation=M}};ht=je([u],ht),e.DebugAdapterInlineImplementation=ht;let yt=class{constructor(M,te){this.range=M,this.expression=te}};yt=je([u],yt),e.EvaluatableExpression=yt;let Ut=class{constructor(M,te){this.range=M,this.text=te}};Ut=je([u],Ut),e.InlineValueText=Ut;let $t=class{constructor(M,te,Se=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Se}};$t=je([u],$t),e.InlineValueVariableLookup=$t;let Lt=class{constructor(M,te){this.range=M,this.expression=te}};Lt=je([u],Lt),e.InlineValueEvaluatableExpression=Lt;let ut=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};ut=je([u],ut),e.InlineValueContext=ut;var ln;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(ln=e.FileChangeType||(e.FileChangeType={}));let It=i=class extends Error{constructor(M,te=n.FileSystemProviderErrorCode.Unknown,Se){var ze;super(k.URI.isUri(M)?M.toString(!0):M);this.code=(ze=Se==null?void 0:Se.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,i.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(M){return new i(M,n.FileSystemProviderErrorCode.FileExists,i.FileExists)}static FileNotFound(M){return new i(M,n.FileSystemProviderErrorCode.FileNotFound,i.FileNotFound)}static FileNotADirectory(M){return new i(M,n.FileSystemProviderErrorCode.FileNotADirectory,i.FileNotADirectory)}static FileIsADirectory(M){return new i(M,n.FileSystemProviderErrorCode.FileIsADirectory,i.FileIsADirectory)}static NoPermissions(M){return new i(M,n.FileSystemProviderErrorCode.NoPermissions,i.NoPermissions)}static Unavailable(M){return new i(M,n.FileSystemProviderErrorCode.Unavailable,i.Unavailable)}};It=i=je([u],It),e.FileSystemError=It;let At=class{constructor(M,te,Se){this.start=M,this.end=te,this.kind=Se}};At=je([u],At),e.FoldingRange=At;var Yt;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(Yt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var un;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Xt;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(Xt=e.CommentMode||(e.CommentMode={}));class cn{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=cn;function Zt(O){return typeof O=="undefined"||(0,y.isStringArray)(O)}class Pt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Se=M.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Se=M.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Se,ze,Ye){if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(M,te,Se,ze,Ye);if(g.isRange(M)&&typeof te=="string"&&Zt(Se))return this._push(M,te,Se);throw(0,S.illegalArgument)()}_push(M,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=M.start.line,Ye=M.start.character,nt=M.end.character-M.start.character,ot=this._tokenTypeStrToInt.get(te);let pt=0;if(Se)for(const vt of Se){if(!this._tokenModifierStrToInt.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this._tokenModifierStrToInt.get(vt);pt|=1<<_t>>>0}this._pushEncoded(ze,Ye,nt,ot,pt)}_pushEncoded(M,te,Se,ze,Ye){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const pt=this._data.length/5|0;let vt=0,_t=0;for(let bt=0;bt<pt;bt++){let St=this._data[5*bt],Qt=this._data[5*bt+1];St===0?(St=vt,Qt+=_t):St+=vt,this._data[5*bt]=St,this._data[5*bt+1]=Qt,vt=St,_t=Qt}}let nt=M,ot=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ye,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Se=M.length/5|0;for(let ot=0;ot<Se;ot++)te[ot]=ot;te.sort((ot,pt)=>{const vt=M[5*ot],_t=M[5*pt];if(vt===_t){const bt=M[5*ot+1],St=M[5*pt+1];return bt-St}return vt-_t});const ze=new Uint32Array(M.length);let Ye=0,nt=0;for(let ot=0;ot<Se;ot++){const pt=5*te[ot],vt=M[pt+0],_t=M[pt+1],bt=M[pt+2],St=M[pt+3],Qt=M[pt+4],Sn=vt-Ye,In=Sn===0?_t-nt:_t,Jt=5*ot;ze[Jt+0]=Sn,ze[Jt+1]=In,ze[Jt+2]=bt,ze[Jt+3]=St,ze[Jt+4]=Qt,Ye=vt,nt=_t}return ze}build(M){return this._dataIsSortedAndDeltaEncoded?new Bt(new Uint32Array(this._data),M):new Bt(Pt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Pt;class Bt{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Bt;class xt{constructor(M,te,Se){this.start=M,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=xt;class Ht{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=Ht;var dn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var hn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(hn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let kt=class{constructor(){}};kt.Back={iconPath:new it("arrow-left")},kt=je([u],kt),e.QuickInputButtons=kt;var fn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(fn=e.ExtensionKind||(e.ExtensionKind={}));class mn{constructor(M,te,Se){this.badge=M,this.tooltip=te,this.color=Se}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=mn;let zt=class{constructor(M){this.kind=M}};zt=je([u],zt),e.ColorTheme=zt;var gn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(gn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(M,te){if(M<0)throw(0,S.illegalArgument)("start must be positive");if(te<M)throw(0,S.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=te}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=Vt;class Wt{constructor(M,te,Se,ze,Ye,nt,ot,pt,vt,_t,bt){this.editable=M,this.breakpointMargin=te,this.hasExecutionOrder=Se,this.executionOrder=ze,this.runState=Ye,this.runStartTime=nt,this.statusMessage=ot,this.lastRunDuration=pt,this.inputCollapsed=vt,this.outputCollapsed=_t,this.custom=bt}with(M){let{editable:te,breakpointMargin:Se,hasExecutionOrder:ze,executionOrder:Ye,runState:nt,runStartTime:ot,statusMessage:pt,lastRunDuration:vt,inputCollapsed:_t,outputCollapsed:bt,custom:St}=M;return te===void 0?te=this.editable:te===null&&(te=void 0),Se===void 0?Se=this.breakpointMargin:Se===null&&(Se=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.executionOrder:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.runStartTime:ot===null&&(ot=void 0),pt===void 0?pt=this.statusMessage:pt===null&&(pt=void 0),vt===void 0?vt=this.lastRunDuration:vt===null&&(vt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),St===void 0?St=this.custom:St===null&&(St=void 0),te===this.editable&&Se===this.breakpointMargin&&ze===this.hasExecutionOrder&&Ye===this.executionOrder&&nt===this.runState&&ot===this.runStartTime&&pt===this.statusMessage&&vt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&St===this.custom?this:new Wt(te,Se,ze,Ye,nt,ot,pt,vt,_t,bt,St)}}e.NotebookCellMetadata=Wt;class Mt{constructor(M=!0,te=!0,Se=!0,ze={},Ye=en.Idle,nt=!0){this.editable=M,this.cellEditable=te,this.cellHasExecutionOrder=Se,this.custom=ze,this.runState=Ye,this.trusted=nt}with(M){let{editable:te,cellEditable:Se,cellHasExecutionOrder:ze,custom:Ye,runState:nt,trusted:ot}=M;return te===void 0?te=this.editable:te===null&&(te=void 0),Se===void 0?Se=this.cellEditable:Se===null&&(Se=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.custom:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),te===this.editable&&Se===this.cellEditable&&ze===this.cellHasExecutionOrder&&Ye===this.custom&&nt===this.runState&&ot===this.trusted?this:new Mt(te,Se,ze,Ye,nt,ot)}}e.NotebookDocumentMetadata=Mt;class jt{constructor(M,te,Se,ze,Ye){this.kind=M,this.source=te,this.language=Se,this.outputs=ze!=null?ze:[],this.metadata=Ye}}e.NotebookCellData=jt;class Fe{constructor(M,te){this.cells=M,this.metadata=te!=null?te:new Mt}}e.NotebookData=Fe;class Ot{constructor(M,te,Se){this.mime=M,this.value=te,this.metadata=Se}static isNotebookCellOutputItem(M){return M instanceof Ot}}e.NotebookCellOutputItem=Ot;class qt{constructor(M,te,Se){this.outputs=M,typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,E.generateUuid)(),this.metadata=te!=null?te:Se)}}e.NotebookCellOutput=qt;var ft;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var pn;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle",O[O.Success=3]="Success",O[O.Error=4]="Error"})(pn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var en;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(en=e.NotebookRunState||(e.NotebookRunState={}));var tn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Kt=class{constructor(M,te){this.label=M,this.timestamp=te}};Kt=je([u],Kt),e.TimelineItem=Kt;var vn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var _n;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(_n=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class rn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=rn;var wn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(wn=e.TestResult||(e.TestResult={}));var sn;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(sn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class En{constructor(M,te){this.label=te,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:M,enumerable:!0,writable:!1})}}e.TestItem=En;class yn{constructor(M){this.state=M,this.messages=[]}}e.TestState=yn;class Gt{constructor(M){this.message=M,this.severity=sn.Error}static diff(M,te,Se){const ze=new Gt(M);return ze.expectedOutput=te,ze.actualOutput=Se,ze}}e.TestMessage=Gt;var ee;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ee=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var de;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unknown=2]="Unknown"})(de=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ke;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(ke=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[94],Ee([0,1,43,16,8,117,83,7,15]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function A(s,h){h?n.set(s,h):n.delete(s)}e.setWordDefinitionFor=A;function C(s){return n.get(s)}e.getWordDefinitionFor=C;class _ extends P.MirrorTextModel{constructor(h,p,m,v,d,c,o,t){super(p,m,v,d);this._proxy=h,this._languageId=c,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,E.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===S.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(p){return p?h._getTextInRange(p):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(p){return h._lineAt(p)},offsetAt(p){return h._offsetAt(p)},positionAt(p){return h._positionAt(p)},validateRange(p){return h._validateRange(p)},validatePosition(p){return h._validatePosition(p)},getWordRangeAtPosition(p,m){return h._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,b.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,b.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const p=this._validateRange(h);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,v=p.start.line,d=p.end.line,c=[];c.push(this._lines[v].substring(p.start.character));for(let o=v+1;o<d;o++)c.push(this._lines[o]);return c.push(this._lines[d].substring(0,p.end.character)),c.join(m)}_lineAt(h){let p;if(h instanceof k.Position?p=h.line:typeof h=="number"&&(p=h),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new f(p,this._lines[p],p===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(h),m=this._lines[p.index].length;return new k.Position(p.index,Math.min(p.remainder,m))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const p=this._validatePosition(h.start),m=this._validatePosition(h.end);return p===h.start&&m===h.end?h:new k.Range(p.line,p.character,m.line,m.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:p,character:m}=h,v=!1;if(p<0)p=0,m=0,v=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,v=!0;else{const d=this._lines[p].length;m<0?(m=0,v=!0):m>d&&(m=d,v=!0)}return v?new k.Position(p,m):h}_getWordRangeAtPosition(h,p){const m=this._validatePosition(h);if(!p)p=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const v=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[m.line],0);if(v)return new k.Range(m.line,v.startColumn-1,m.line,v.endColumn-1)}}e.ExtHostDocumentData=_;class f{constructor(h,p,m){this._line=h,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[159],Ee([0,1,7,3,85,6,59,22,2,29]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(_,f,s,h){this._notebook=s,this._selector=h,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(m=>{const v=this._cellUris.get(m.document.uri);v!==void 0&&(this._cellLengths.changeValue(v,this._cells[v].document.getText().length+1),this._cellLines.changeValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(_.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const _=[],f=[];for(const s of this._notebook.cells)s.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),_.push(s.document.getText().length+1),f.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(_)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(_){var f,s;if(!_){let d="";for(const c of this._cells)d+=c.document.getText()+`
`;return d=d.slice(0,-1),d}if(_.isEmpty)return"";const h=this.locationAt(_.start),p=this.locationAt(_.end),m=this._cells[(f=this._cellUris.get(h.uri))!==null&&f!==void 0?f:-1],v=this._cells[(s=this._cellUris.get(p.uri))!==null&&s!==void 0?s:-1];if(!m||!v)return"";if(m===v)return m.document.getText(new b.Range(h.range.start,p.range.end));{const d=m.document.getText(new b.Range(h.range.start,new b.Position(m.document.lineCount,0))),c=v.document.getText(new b.Range(new b.Position(0,0),p.range.end));return d+`
`+c}}offsetAt(_){const f=this._cellLines.getIndexOf(_.line),s=this._cellLengths.getAccumulatedValue(f.index-1),h=this._cells[f.index].document.offsetAt(_.with(f.remainder));return s+h}positionAt(_){if(typeof _=="number"){const s=this._cellLengths.getIndexOf(_),h=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(h)}const f=this._cellUris.get(_.uri);if(f!==void 0){const s=this._cellLines.getAccumulatedValue(f-1);return new b.Position(s+_.range.start.line,_.range.start.character)}return new b.Position(0,0)}locationAt(_){b.Range.isRange(_)||(_=new b.Range(_,_));const f=this._cellLines.getIndexOf(_.start.line);let s=f;_.isEmpty||(s=this._cellLines.getIndexOf(_.end.line));const h=new b.Position(f.remainder,_.start.character),p=new b.Position(s.remainder,_.end.character),m=new b.Range(h,p),v=this._cells[f.index];return new b.Location(v.document.uri,v.document.validateRange(m))}contains(_){return this._cellUris.has(_)}validateRange(_){const f=this.validatePosition(_.start),s=this.validatePosition(_.end);return _.with(f,s)}validatePosition(_){const f=this._cellLines.getIndexOf(_.line),s=new b.Position(f.remainder,_.character),h=this._cells[f.index].document.validatePosition(s),p=this._cellLines.getAccumulatedValue(f.index-1);return new b.Position(p+h.line,h.character)}}e.ExtHostNotebookConcatDocument=A}),define(we[160],Ee([0,1,7,14,3]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(k){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let E=k==="light"?b.ColorThemeKind.Light:k==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([qe(0,S.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(we[68],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class S{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=S}),define(we[69],Ee([0,1,2]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function S(P,y,k){const E=P.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",y);return b.URI.parse(E)}e.asWebviewUri=S;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(we[161],Ee([0,1,3,6,69,29]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(E,n,A){this._proxy=E,this._editors=n,this._initData=A,this._handlePool=0,this._disposables=new S.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const _ of this._insets.values())C.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,n,A,C,_){let f;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===E){f=c;break}if(!f)throw new Error("not a visible editor");const s=this,h=this._handlePool++,p=new b.Emitter,m=new b.Emitter,v=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,T.asWebviewUri)(s._initData,this._uuid,c)}get cspSource(){return s._initData.webviewCspSource}set options(c){this._options=c,s._proxy.$setOptions(h,c)}get options(){return this._options}set html(c){this._html=c,s._proxy.$setHtml(h,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return s._proxy.$postMessage(h,c)}},d=new class{constructor(){this.editor=E,this.line=n,this.height=A,this.webview=v,this.onDidDispose=m.event}dispose(){s._insets.has(h)&&(s._insets.delete(h),s._proxy.$disposeEditorInset(h),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,f.id,f.value.document.uri,n+1,A,C||{},_.identifier,_.extensionLocation),this._insets.set(h,{editor:E,inset:d,onDidReceiveMessage:p}),d}$onDidDispose(E){const n=this._insets.get(E);n&&n.inset.dispose()}$onDidReceiveMessage(E,n){const A=this._insets.get(E);A&&A.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=y}),define(we[162],Ee([0,1,3,63,135,4,6,22,30,15,51,23,37,154]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",_.Codicon.window,(0,T.localize)(0,null));var s;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var h;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(i){switch(i){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(i){return`viewContainer.${i}.enabled`}e.getEnabledViewContainerContextKey=m;class v extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(u,D,R){var g;const w=this.get(u.id);if(w)return w;const I=u;return I.openCommandActionDescriptor=(R==null?void 0:R.donotRegisterOpenCommand)?void 0:(g=I.openCommandActionDescriptor)!==null&&g!==void 0?g:{id:I.id},(0,k.getOrSet)(this.viewContainers,D,[]).push(I),(R==null?void 0:R.isDefault)&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:D}),I}deregisterViewContainer(u){for(const D of this.viewContainers.keys()){const R=this.viewContainers.get(D),g=R==null?void 0:R.indexOf(u);if(g!==-1){R==null||R.splice(g,1),R.length===0&&this.viewContainers.delete(D),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:D});return}}}get(u){return this.all.filter(D=>D.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(D=>this.getViewContainers(D).filter(R=>(R==null?void 0:R.id)===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(D=>this.getViewContainerLocation(D)===u)}}E.Registry.add(s.ViewContainersRegistry,new v);var d;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function c(i,u){var D,R,g,w;const I=(D=i.group)!==null&&D!==void 0?D:d.More,F=(R=u.group)!==null&&R!==void 0?R:d.More;return I!==F?I.localeCompare(F):((g=i.order)!==null&&g!==void 0?g:5)-((w=u.order)!==null&&w!==void 0?w:5)}class o extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(u,D){this.registerViews2([{views:u,viewContainer:D}])}registerViews2(u){u.forEach(({views:D,viewContainer:R})=>this.addViews(D,R)),this._onViewsRegistered.fire(u)}deregisterViews(u,D){const R=this.removeViews(u,D);R.length&&this._onViewsDeregistered.fire({views:R,viewContainer:D})}moveViews(u,D){for(const R of this._views.keys())if(R!==D){const g=this.removeViews(u,R);g.length&&(this.addViews(g,D),this._onDidChangeContainer.fire({views:g,from:R,to:D}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const D of this._viewContainers){const R=(this._views.get(D)||[]).filter(g=>g.id===u)[0];if(R)return R}return null}getViewContainer(u){for(const D of this._viewContainers)if((this._views.get(D)||[]).filter(g=>g.id===u)[0])return D;return null}registerViewWelcomeContent(u,D){return this._viewWelcomeContents.add(u,D),this._onDidChangeViewWelcomeContent.fire(u),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(u,D),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,D){const R=new Map;for(const[g,w]of D)this._viewWelcomeContents.add(u,w),R.set(g,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(u,w),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),R}getViewWelcomeContent(u){const D=[];return this._viewWelcomeContents.forEach(u,R=>D.push(R)),D.sort(c)}addViews(u,D){let R=this._views.get(D);R||(R=[],this._views.set(D,R),this._viewContainers.push(D));for(const g of u){if(this.getView(g.id)!==null)throw new Error((0,T.localize)(1,null,g.id));R.push(g)}}removeViews(u,D){const R=this._views.get(D);if(!R)return[];const g=[],w=[];for(const I of R)u.includes(I)?g.push(I):w.push(I);return g.length&&(w.length?this._views.set(D,w):(this._views.delete(D),this._viewContainers.splice(this._viewContainers.indexOf(D),1))),g}}E.Registry.add(s.ViewsRegistry,new o),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new S.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(i){return`view.${i}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var r;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(u,D){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,u),this._hasResolve=!!D,this.resolve=async R=>{var g,w;if(D&&!this.resolved){const I=await D(R);I&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:I.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:I.command)}R.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(we[163],Ee([0,1,2,144,155,19,145,162]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function E(h){return(p,...m)=>h(p.get(S.ICommandService),...m)}class n{static execute(p,m){const v={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return p.executeCommand("_files.newWindow",v)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",S.CommandsRegistry.registerCommand({id:n.ID,handler:E(n.execute),description:{description:"Opens an new window",args:[]}}),S.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,p){return h.get(T.IWorkspacesService).removeRecentlyOpened([p])});class A{static execute(p,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?b.URI.parse(m):b.URI.file(m):m=b.URI.revive(m),p.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=A,A.ID="vscode.removeFromRecentlyOpened",S.CommandsRegistry.registerCommand(A.ID,E(A.execute));class C{static execute(p,m){const v=typeof m=="string"?{extensionId:m}:m;return p.executeCommand("workbench.action.openIssueReporter",v)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",S.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,p){const m=h.get(T.IWorkspacesService);let v;const d=p.uri,c=p.label,o=p.remoteAuthority;return p.type==="workspace"?v={workspace:await m.getWorkspaceIdentifier(d),label:c,remoteAuthority:o}:p.type==="folder"?v={folderUri:d,label:c,remoteAuthority:o}:v={fileUri:d,label:c,remoteAuthority:o},m.addRecentlyOpened([v])}),S.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(T.IWorkspacesService).getRecentlyOpened()}),S.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,p){const m=h.get(P.ILogService),v=h.get(y.IEnvironmentService);v.isExtensionDevelopment&&!!v.extensionTestsLocationURI&&m.setLevel(p)}),S.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(P.ILogService).getLevel()}),S.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,p){const m=h.get(k.IViewDescriptorService),v=m.getViewContainerById(p.destinationId);if(!!v){for(const d of p.viewIds){const c=m.getViewDescriptorById(d);(c==null?void 0:c.canMoveView)&&m.moveViewsToContainer([c],v,k.ViewVisibilityState.Default)}await h.get(k.IViewsService).openViewContainer(v.id,!0)}});class _{static execute(p,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=_,_.ID="vscode.moveViews",S.CommandsRegistry.registerCommand({id:_.ID,handler:E(_.execute),description:{description:"Move Views",args:[]}});class f{static execute(p,m){return p.executeCommand("_workbench.open",m)}}f.ID="vscode.open",S.CommandsRegistry.registerCommand(f.ID,E(f.execute));class s{static execute(p,m,v,d,c){return p.executeCommand("_workbench.diff",[m,v,d])}}s.ID="vscode.diff",S.CommandsRegistry.registerCommand(s.ID,E(s.execute))}),define(we[164],Ee([0,1,3,13,136]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,E,n,A){const C={command:k};if(E&&Object.keys(E).length>0&&(C.arguments=E),this.internalSend("request",C),typeof A=="number"){const _=setTimeout(()=>{clearTimeout(_);const f=this.pendingRequests.get(C.seq);if(f){this.pendingRequests.delete(C.seq);const s={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,A,k)};f(s)}},A)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,E){return k.type!=="event"||E.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,S.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const E=k,n=this.pendingRequests.get(E.request_seq);n&&(this.pendingRequests.delete(E.request_seq),n(E));break}}}internalSend(k,E){E.type=k,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((E,n)=>k.set(n,E)),await(0,S.timeout)(500),k.forEach((E,n)=>{E({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(we[165],Ee([0,1,8,2,11,23,16]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function E(r,l,a){return r.replace(k,function(i,u){return l&&u.length>0&&u[0]!=="_"?i:a&&a.hasOwnProperty(u)?a[u]:i})}e.formatPII=E;function n(r){const l={};for(const a of Object.keys(r))a.startsWith("!")||(l[a]=r[a]);return l}e.filterExceptionsFromTelemetry=n;function A(r){return r.configuration.request==="attach"&&!C(r)}e.isSessionAttach=A;function C(r){let l=r.configuration.type;if(!!l)return l==="vslsShare"&&(l=r.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(l,"extensionhost")||(0,b.equalsIgnoreCase)(l,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function _(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=_;function f(r,l,a){let i,u=0,D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=D.exec(r);){let g=R.index+1,w=g+R[0].length;if(g<=l&&w>=a){i=R[0],u=g;break}}if(i){let g=/\w+/g,w=null;for(;(w=g.exec(i))&&!(w.index+1+u+w[0].length>=a););w&&(i=i.substring(0,g.lastIndex))}return i?{start:u,end:u+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(r){return!!(r&&r.match(s))}e.isUri=h;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(h(r.path))return S.URI.parse(r.path);if((0,T.isAbsolute)(r.path))return S.URI.file(r.path)}return r.path}function m(r){if(typeof r.path=="object"){const l=S.URI.revive(r.path);if(l)return l.scheme===y.Schemas.file?l.fsPath:l.toString()}return r.path}function v(r,l){const a=l?p:m,i=(0,P.deepClone)(r);return c(i,(u,D)=>{u&&D&&(D.path=a(D))}),i}e.convertToDAPaths=v;function d(r,l){const a=l?p:m,i=(0,P.deepClone)(r);return c(i,(u,D)=>{!u&&D&&(D.path=a(D))}),i}e.convertToVSCPaths=d;function c(r,l){switch(r.type){case"event":const a=r;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break;case"request":const i=r;switch(i.command){case"setBreakpoints":l(!0,i.arguments.source);break;case"breakpointLocations":l(!0,i.arguments.source);break;case"source":l(!0,i.arguments.source);break;case"gotoTargets":l(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(D=>l(!1,D));break;default:break}break;case"response":const u=r;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(D=>l(!1,D.source));break;case"loadedSources":u.body.sources.forEach(D=>l(!1,D));break;case"scopes":u.body.scopes.forEach(D=>l(!1,D.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(D=>l(!1,D.source));break;case"setBreakpoints":u.body.breakpoints.forEach(D=>l(!1,D.source));break;default:break}break}}function o(r){return r.filter(l=>{var a;return!((a=l.presentation)===null||a===void 0?void 0:a.hidden)}).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):t(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=o;function t(r,l){return typeof r!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:r-l}}),define(we[70],Ee([0,1,28,16,11,21,63]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(I){I[I.Markdown=1]="Markdown",I[I.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},runState:E.Idle,trusted:!0};var n;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle",I[I.Success=3]="Success",I[I.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var A;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.CellClearOutput=3]="CellClearOutput",I[I.CellsClearOutput=4]="CellsClearOutput",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.Unknown=12]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.OutputsSplice=6]="OutputsSplice",I[I.Move=7]="Move",I[I.Unknown=8]="Unknown",I[I.CellContent=9]="CellContent",I[I.OutputItems=10]="OutputItems"})(_=e.CellEditType||(e.CellEditType={}));function f(I){const F=s.parse(I);return F?F.notebook.toString():I.toString()}e.getCellUndoRedoComparisonKey=f;var s;(function(I){I.scheme=S.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function B(K,L){return K.with({scheme:I.scheme,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==S.Schemas.file?K.scheme:""}`})}I.generate=B;function le(K){if(K.scheme===I.scheme){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}}}I.parse=le;function H(K,L){return K.with({scheme:S.Schemas.vscodeNotebookCellMetadata,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==S.Schemas.file?K.scheme:""}`})}I.generateCellMetadataUri=H;function z(K){if(K.scheme===S.Schemas.vscodeNotebookCellMetadata){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}}}I.parseCellMetadataUri=z})(s=e.CellUri||(e.CellUri={}));const h=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(I){var F,B;return(B=(F=h.get(I))===null||F===void 0?void 0:F.alwaysSecure)!==null&&B!==void 0?B:!1}e.mimeTypeIsAlwaysSecure=p;function m(I){var F,B;return(B=(F=h.get(I))===null||F===void 0?void 0:F.supportedByCore)!==null&&B!==void 0?B:!1}e.mimeTypeSupportedByCore=m;function v(I){var F,B;return(B=(F=h.get(I))===null||F===void 0?void 0:F.mergeable)!==null&&B!==void 0?B:!1}e.mimeTypeIsMergeable=v;function d(I,F){return P.isWindows&&(I=I.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),b.match(I,F)}function c(I,F,B){let le=0;for(let H=0;H<F.length;H++){if(d(F[H],I))return le;le++}for(let H=0;H<B.length;H++){if(d(B[H],I))return le;le++}return le}function o(I,F,B){return I.sort((le,H)=>c(le,F,B)-c(H,F,B))}e.sortMimeTypes=o;function t(I,F,B,le=(H,z)=>H===z){const H=[];function z($,U,G){if(!(U===0&&G.length===0)){const N=H[H.length-1];N&&N.start+N.deleteCount===$?(N.deleteCount+=U,N.toInsert.push(...G)):H.push({start:$,deleteCount:U,toInsert:G})}}let K=0,L=0;for(;;){if(K===I.length){z(K,0,F.slice(L));break}if(L===F.length){z(K,I.length-K,[]);break}const $=I[K],U=F[L];if(le($,U)){K+=1,L+=1;continue}B(U)?(z(K,1,[]),K+=1):(z(K,0,[U]),L+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new y.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var r;(function(I){I.default="default",I.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(I){const F=I;return!!((typeof F.include=="string"||b.isRelativePattern(F.include))&&(typeof F.exclude=="string"||b.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=l;function a(I,F,B){if(Array.isArray(I.viewType)&&I.viewType.indexOf(F)>=0||I.viewType===F)return!0;if(I.filenamePattern){let le=l(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,H=l(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(b.match(le,(0,T.basename)(B.fsPath).toLowerCase()))return!(H&&b.match(H,(0,T.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class i{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let B=0;B<this.textModel.cells.length;B++)F[B]=this.textModel.cells[B].getHashValue();return F}}e.CellSequence=i,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var u;(function(I){I[I.LEFT=0]="LEFT",I[I.RIGHT=1]="RIGHT"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function D(I){I.sort((B,le)=>B-le);const F=I.shift();return F===void 0?[]:I.reduce(function(B,le){return le<=B[0][1]?B[0][1]=le+1:B.unshift([le,le+1]),B},[[F,F+1]]).reverse().map(B=>({start:B[0],end:B[1]}))}e.cellIndexesToRanges=D;function R(I){return I.reduce((B,le)=>{for(let H=le.start;H<le.end;H++)B.push(H);return B},[])}e.cellRangesToIndexes=R;function g(I){const F=I.sort((le,H)=>le.start-H.start),B=F[0];return B?F.reduce((le,H)=>{const z=le[le.length-1];return z.end>=H.start?z.end=Math.max(z.end,H.end):le.push(H),le},[B]):[]}e.reduceRanges=g;function w(I,F){return F.start>=I.start&&F.end<=I.end}e.cellRangeContains=w}),define(we[166],Ee([0,1,138,4,63]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,S.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[167],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=b;function S(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=S}),define(we[168],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var b;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",y[y.DeltaRootsComplete=4]="DeltaRootsComplete"})(b=e.TestDiffOpType||(e.TestDiffOpType={}));const S=(y,k)=>`${y}:${k.toString()}`;e.getTestSubscriptionKey=S;class T{add(k){}update(k){}remove(k,E){}complete(){}}e.IncrementalChangeCollector=T;class P{constructor(){this.items=new Map,this.roots=new Set}apply(k){const E=this.createChangeCollector();for(const n of k)switch(n[0]){case 0:{const A=n[1];if(A.parent){if(this.items.has(A.parent)){const C=this.items.get(A.parent);C.children.add(A.item.extId);const _=this.createItem(A,C);this.items.set(A.item.extId,_),E.add(_)}}else{this.roots.add(A.item.extId);const C=this.createItem(A);this.items.set(A.item.extId,C),E.add(C)}break}case 1:{const A=n[1],C=this.items.get(A.item.extId);C&&(Object.assign(C.item,A.item),E.update(C));break}case 2:{const A=this.items.get(n[1]);if(!A)break;A.parent?this.items.get(A.parent).children.delete(A.item.extId):this.roots.delete(A.item.extId);const C=[[n[1]]];for(;C.length;)for(const _ of C.pop()){const f=this.items.get(_);f&&(C.push(f.children),this.items.delete(_),E.remove(f,f!==A))}break}case 3:this.updateBusyProviders(n[1]);break;case 4:this.updatePendingRoots(n[1]);break}E.complete()}updateBusyProviders(k){}updatePendingRoots(k){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=P}),define(we[169],Ee([0,1,11,32,12,23,21,58,139]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,_,f){if(this._contributedVariables=new Map,this._context=C,this._labelService=_,f)if(y.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(f).forEach(h=>{s[h.toLowerCase()]=f[h]})}else this._envVariables=f}resolve(C,_){return this.recursiveResolve(C?C.uri:void 0,_)}resolveAnyBase(C,_,f,s){const h=P.deepClone(_);return y.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(C?C.uri:void 0,h,f,s)}resolveAny(C,_,f){return this.resolveAnyBase(C,_,f)}resolveAnyMap(C,_,f){const s=new Map;return{newConfig:this.resolveAnyBase(C,_,f,s),resolvedVariables:s}}resolveWithInteractionReplace(C,_,f,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,_,f,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,_){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,_)}recursiveResolve(C,_,f,s){if(T.isString(_))return this.resolveString(C,_,f,s);if(T.isArray(_))return _.map(h=>this.recursiveResolve(C,h,f,s));if(T.isObject(_)){let h=Object.create(null);return Object.keys(_).forEach(p=>{const m=this.resolveString(C,p,f,s);h[m]=this.recursiveResolve(C,_[p],f,s)}),h}return _}resolveString(C,_,f,s){return _.replace(n.VARIABLE_REGEXP,(p,m)=>{if(m.includes(n.VARIABLE_LHS))return p;let v=this.evaluateSingleVariable(p,m,C,f);return s&&s.set(m,v),v})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,_,f,s){let h;const p=_.split(":");p.length>1&&(_=p[0],h=p[1]);const m=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,E.localize)(0,null,C))},v=()=>{const c=m();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,E.localize)(1,null,C,b.basename(c)))},d=()=>{if(h){const c=this._context.getFolderUri(h);if(c)return c;throw new Error((0,E.localize)(2,null,C,h))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,C)):new Error((0,E.localize)(4,null,C))};switch(_){case"env":if(h){if(this._envVariables){const c=this._envVariables[y.isWindows?h.toLowerCase():h];if(T.isString(c))return c}return""}throw new Error((0,E.localize)(5,null,C));case"config":if(h){const c=this._context.getConfigurationValue(f,h);if(T.isUndefinedOrNull(c))throw new Error((0,E.localize)(6,null,C,h));if(T.isObject(c))throw new Error((0,E.localize)(7,null,C,h));return c}throw new Error((0,E.localize)(8,null,C));case"command":return this.resolveFromMap(C,h,s,"command");case"input":return this.resolveFromMap(C,h,s,"input");default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return f||h?(0,k.normalizeDriveLetter)(this.fsPath(d())):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(d()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,E.localize)(9,null,C));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,E.localize)(10,null,C));case"file":return m();case"fileWorkspaceFolder":return v();case"relativeFile":return f||h?b.relative(this.fsPath(d()),m()):m();case"relativeFileDirname":const t=b.dirname(m());if(f||h){const i=b.relative(this.fsPath(d()),t);return i.length===0?".":i}return t;case"fileDirname":return b.dirname(m());case"fileExtname":return b.extname(m());case"fileBasename":return b.basename(m());case"fileBasenameNoExtension":const r=b.basename(m());return r.slice(0,r.length-b.extname(r).length);case"fileDirnameBasename":return b.basename(b.dirname(m()));case"execPath":const l=this._context.getExecPath();return l||C;case"execInstallFolder":const a=this._context.getAppRoot();return a||C;case"pathSeparator":return b.sep;default:try{const i=h?`${_}:${h}`:_;return this.resolveFromMap(C,i,s,void 0)}catch(i){return C}}}}resolveFromMap(C,_,f,s){if(_&&f){const h=s===void 0?f[_]:f[s+":"+_];if(typeof h=="string")return h;throw new Error((0,E.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[170],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var S;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var T;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var y;(function(_){_[_.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var E;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.EDITOR_OPEN=2]="EDITOR_OPEN",_[_.EDITOR_CLOSE=3]="EDITOR_CLOSE",_[_.EDITOR_MOVE=4]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=6]="EDITOR_LABEL",_[_.EDITOR_PIN=7]="EDITOR_PIN",_[_.EDITOR_STICKY=8]="EDITOR_STICKY",_[_.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var A;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function C(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(we[171],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],Ee([0,1,62,7,140,2,33,80,87,171,12,224,57,23,15,70]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(me){function he(Q){const{selectionStartLineNumber:Ie,selectionStartColumn:Pe,positionLineNumber:et,positionColumn:Ge}=Q,rt=new S.Position(Ie-1,Pe-1),lt=new S.Position(et-1,Ge-1);return new S.Selection(rt,lt)}me.to=he;function ue(Q){const{anchor:Ie,active:Pe}=Q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}me.from=ue})(p=e.Selection||(e.Selection={}));var m;(function(me){function he(Q){if(!!Q){const{start:Ie,end:Pe}=Q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}}me.from=he;function ue(Q){if(!!Q){const{startLineNumber:Ie,startColumn:Pe,endLineNumber:et,endColumn:Ge}=Q;return new S.Range(Ie-1,Pe-1,et-1,Ge-1)}}me.to=ue})(m=e.Range||(e.Range={}));var v;(function(me){function he(ue){switch(ue){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}me.to=he})(v=e.TokenType||(e.TokenType={}));var d;(function(me){function he(Q){return new S.Position(Q.lineNumber-1,Q.column-1)}me.to=he;function ue(Q){return{lineNumber:Q.line+1,column:Q.character+1}}me.from=ue})(d=e.Position||(e.Position={}));var c;(function(me){function he(Q){switch(Q){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}me.from=he;function ue(Q){switch(Q){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}me.to=ue})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(me){function he(Q){let Ie;return Q.code&&((0,A.isString)(Q.code)||(0,A.isNumber)(Q.code)?Ie=String(Q.code):Ie={value:String(Q.code.value),target:Q.code.target}),Object.assign(Object.assign({},m.from(Q.range)),{message:Q.message,source:Q.source,code:Ie,severity:r.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(t.from),tags:Array.isArray(Q.tags)?(0,s.coalesce)(Q.tags.map(c.from)):void 0})}me.from=he;function ue(Q){var Ie;const Pe=new S.Diagnostic(m.to(Q),Q.message,r.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,A.isString)(Q.code)?Q.code:(Ie=Q.code)===null||Ie===void 0?void 0:Ie.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(t.to),Pe.tags=Q.tags&&(0,s.coalesce)(Q.tags.map(c.to)),Pe}me.to=ue})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function he(Q){return Object.assign(Object.assign({},m.from(Q.location.range)),{message:Q.message,resource:Q.location.uri})}me.from=he;function ue(Q){return new S.DiagnosticRelatedInformation(new S.Location(Q.resource,m.to(Q)),Q.message)}me.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(me){function he(Q){switch(Q){case S.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}me.from=he;function ue(Q){switch(Q){case E.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}me.to=ue})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(me){function he(Q){return typeof Q=="number"&&Q>=S.ViewColumn.One?Q-1:Q===S.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}me.from=he;function ue(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ue})(l=e.ViewColumn||(e.ViewColumn={}));function a(me){return typeof me.range!="undefined"}function i(me){return me.length===0?!0:!!a(me[0])}e.isDecorationOptionsArr=i;var u;(function(me){function he(Ge){return Ge.map(me.from)}me.fromMany=he;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let rt;if(ue(Ge)){const{language:dt,value:at}=Ge;rt={value:"```"+dt+`
`+at+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const lt=Object.create(null);rt.uris=lt;const Je=dt=>{try{let at=P.URI.parse(dt,!0);at=at.with({query:Ie(at.query,lt)}),lt[dt]=at}catch(at){}return""},it=new C.Renderer;return it.link=Je,it.image=dt=>Je(k.parseHrefAndDimensions(dt).href),C(rt.value,{renderer:it}),rt}me.from=Q;function Ie(Ge,rt){if(!Ge)return Ge;let lt;try{lt=(0,_.parse)(Ge)}catch(it){}if(!lt)return Ge;let Je=!1;return lt=(0,f.cloneAndChange)(lt,it=>{if(P.URI.isUri(it)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=it,Je=!0,dt}else return}),Je?JSON.stringify(lt):Ge}function Pe(Ge){const rt=new S.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}me.to=Pe;function et(Ge){if(!!Ge)return typeof Ge=="string"?Ge:me.from(Ge)}me.fromStrict=et})(u=e.MarkdownString||(e.MarkdownString={}));function D(me){return i(me)?me.map(he=>({range:m.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?u.fromMany(he.hoverMessage):he.hoverMessage?u.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):me.map(he=>({range:m.from(he)}))}e.fromRangeOrRangeWithMessage=D;function R(me){return typeof me=="undefined"?me:typeof me=="string"?P.URI.file(me):me}e.pathOrURIToURI=R;var g;(function(me){function he(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?R(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}me.from=he})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(me){function he(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var I;(function(me){function he(ue){if(typeof ue=="undefined")return ue;switch(ue){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=he})(I=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(me){function he(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?I.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?w.from(ue.light):void 0,dark:ue.dark?w.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(me){function he(Q){return{text:Q.newText,eol:Q.newEol&&X.from(Q.newEol),range:m.from(Q.range)}}me.from=he;function ue(Q){const Ie=new S.TextEdit(m.to(Q.range),Q.text);return Ie.newEol=typeof Q.eol=="undefined"?void 0:X.to(Q.eol),Ie}me.to=ue})(B=e.TextEdit||(e.TextEdit={}));var le;(function(me){function he(Q,Ie,Pe){var et,Ge,rt;const lt={edits:[]};if(Q instanceof S.WorkspaceEdit)for(let Je of Q._allEntries())if(Je._type===1)lt.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const it=Ie==null?void 0:Ie.getDocument(Je.uri);lt.edits.push({_type:2,resource:Je.uri,edit:B.from(Je.edit),modelVersionId:it==null?void 0:it.version,metadata:Je.metadata})}else Je._type===3?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(et=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Je._type===4?(Je.newOutputs&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(ve.from)}}),Je.newMetadata&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:3,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(Ge=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(se.from)}}):Je._type===6&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:10,index:Je.index,outputId:Je.outputId,items:((rt=Je.newOutputItems)===null||rt===void 0?void 0:rt.map(fe.from))||[],append:Je.append}});return lt}me.from=he;function ue(Q){const Ie=new S.WorkspaceEdit;for(const Pe of Q.edits)Pe.edit?Ie.replace(P.URI.revive(Pe.resource),m.to(Pe.edit.range),Pe.edit.text):Ie.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Ie}me.to=ue})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(me){const he=Object.create(null);he[S.SymbolKind.File]=0,he[S.SymbolKind.Module]=1,he[S.SymbolKind.Namespace]=2,he[S.SymbolKind.Package]=3,he[S.SymbolKind.Class]=4,he[S.SymbolKind.Method]=5,he[S.SymbolKind.Property]=6,he[S.SymbolKind.Field]=7,he[S.SymbolKind.Constructor]=8,he[S.SymbolKind.Enum]=9,he[S.SymbolKind.Interface]=10,he[S.SymbolKind.Function]=11,he[S.SymbolKind.Variable]=12,he[S.SymbolKind.Constant]=13,he[S.SymbolKind.String]=14,he[S.SymbolKind.Number]=15,he[S.SymbolKind.Boolean]=16,he[S.SymbolKind.Array]=17,he[S.SymbolKind.Object]=18,he[S.SymbolKind.Key]=19,he[S.SymbolKind.Null]=20,he[S.SymbolKind.EnumMember]=21,he[S.SymbolKind.Struct]=22,he[S.SymbolKind.Event]=23,he[S.SymbolKind.Operator]=24,he[S.SymbolKind.TypeParameter]=25;function ue(Ie){return typeof he[Ie]=="number"?he[Ie]:6}me.from=ue;function Q(Ie){for(const Pe in he)if(he[Pe]===Ie)return Number(Pe);return S.SymbolKind.Property}me.to=Q})(H=e.SymbolKind||(e.SymbolKind={}));var z;(function(me){function he(Q){switch(Q){case S.SymbolTag.Deprecated:return 1}}me.from=he;function ue(Q){switch(Q){case 1:return S.SymbolTag.Deprecated}}me.to=ue})(z=e.SymbolTag||(e.SymbolTag={}));var K;(function(me){function he(Q){return{name:Q.name,kind:H.from(Q.kind),tags:Q.tags&&Q.tags.map(z.from),containerName:Q.containerName,location:N.from(Q.location)}}me.from=he;function ue(Q){const Ie=new S.SymbolInformation(Q.name,H.to(Q.kind),Q.containerName,N.to(Q.location));return Ie.tags=Q.tags&&Q.tags.map(z.to),Ie}me.to=ue})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(me){function he(Q){var Ie,Pe;const et={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:m.from(Q.range),selectionRange:m.from(Q.selectionRange),kind:H.from(Q.kind),tags:(Pe=(Ie=Q.tags)===null||Ie===void 0?void 0:Ie.map(z.from))!==null&&Pe!==void 0?Pe:[]};return Q.children&&(et.children=Q.children.map(he)),et}me.from=he;function ue(Q){const Ie=new S.DocumentSymbol(Q.name,Q.detail,H.to(Q.kind),m.to(Q.range),m.to(Q.selectionRange));return(0,s.isNonEmptyArray)(Q.tags)&&(Ie.tags=Q.tags.map(z.to)),Q.children&&(Ie.children=Q.children.map(ue)),Ie}me.to=ue})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(me){function he(ue){const Q=new S.CallHierarchyItem(H.to(ue.kind),ue.name,ue.detail||"",P.URI.revive(ue.uri),m.to(ue.range),m.to(ue.selectionRange));return Q._sessionId=ue._sessionId,Q._itemId=ue._itemId,Q}me.to=he})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(me){function he(ue){return new S.CallHierarchyIncomingCall($.to(ue.from),ue.fromRanges.map(Q=>m.to(Q)))}me.to=he})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(me){function he(ue){return new S.CallHierarchyOutgoingCall($.to(ue.to),ue.fromRanges.map(Q=>m.to(Q)))}me.to=he})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var N;(function(me){function he(Q){return{range:Q.range&&m.from(Q.range),uri:Q.uri}}me.from=he;function ue(Q){return new S.Location(P.URI.revive(Q.uri),m.to(Q.range))}me.to=ue})(N=e.location||(e.location={}));var Z;(function(me){function he(Q){const Ie=Q,Pe=Q;return{originSelectionRange:Ie.originSelectionRange?m.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Pe.uri,range:m.from(Ie.targetRange?Ie.targetRange:Pe.range),targetSelectionRange:Ie.targetSelectionRange?m.from(Ie.targetSelectionRange):void 0}}me.from=he;function ue(Q){return{targetUri:P.URI.revive(Q.uri),targetRange:m.to(Q.range),targetSelectionRange:Q.targetSelectionRange?m.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?m.to(Q.originSelectionRange):void 0}}me.to=ue})(Z=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(me){function he(Q){return{range:m.from(Q.range),contents:u.fromMany(Q.contents)}}me.from=he;function ue(Q){return new S.Hover(Q.contents.map(u.to),m.to(Q.range))}me.to=ue})(ne=e.Hover||(e.Hover={}));var re;(function(me){function he(Q){return{range:m.from(Q.range),expression:Q.expression}}me.from=he;function ue(Q){return new S.EvaluatableExpression(m.to(Q.range),Q.expression)}me.to=ue})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(me){function he(Q){if(Q instanceof S.InlineValueText)return{type:"text",range:m.from(Q.range),text:Q.text};if(Q instanceof S.InlineValueVariableLookup)return{type:"variable",range:m.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}me.from=he;function ue(Q){switch(Q.type){case"text":return{range:m.to(Q.range),text:Q.text};case"variable":return{range:m.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:m.to(Q.range),expression:Q.expression}}}me.to=ue})(ye=e.InlineValue||(e.InlineValue={}));var Ae;(function(me){function he(Q){return{frameId:Q.frameId,stoppedLocation:m.from(Q.stoppedLocation)}}me.from=he;function ue(Q){return new S.InlineValueContext(Q.frameId,m.to(Q.stoppedLocation))}me.to=ue})(Ae=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(me){function he(Q){return{range:m.from(Q.range),kind:Q.kind}}me.from=he;function ue(Q){return new S.DocumentHighlight(m.to(Q.range),Q.kind)}me.to=ue})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(me){function he(ue){switch(ue){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}me.to=he})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(me){function he(ue){return{triggerKind:Re.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}me.to=he})(xe=e.CompletionContext||(e.CompletionContext={}));var W;(function(me){function he(Q){switch(Q){case S.CompletionItemTag.Deprecated:return 1}}me.from=he;function ue(Q){switch(Q){case 1:return S.CompletionItemTag.Deprecated}}me.to=ue})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(me){const he=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function ue(Pe){var et;return(et=he.get(Pe))!==null&&et!==void 0?et:9}me.from=ue;const Q=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ie(Pe){var et;return(et=Q.get(Pe))!==null&&et!==void 0?et:S.CompletionItemKind.Property}me.to=Ie})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(me){function he(ue,Q){var Ie;const Pe=new S.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Pe.label2=ue.label),Pe.insertText=ue.insertText,Pe.kind=q.to(ue.kind),Pe.tags=(Ie=ue.tags)===null||Ie===void 0?void 0:Ie.map(W.to),Pe.detail=ue.detail,Pe.documentation=k.isMarkdownString(ue.documentation)?u.to(ue.documentation):ue.documentation,Pe.sortText=ue.sortText,Pe.filterText=ue.filterText,Pe.preselect=ue.preselect,Pe.commitCharacters=ue.commitCharacters,y.Range.isIRange(ue.range)?Pe.range=m.to(ue.range):typeof ue.range=="object"&&(Pe.range={inserting:m.to(ue.range.insert),replacing:m.to(ue.range.replace)}),Pe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Pe.insertText=new S.SnippetString(ue.insertText):(Pe.insertText=ue.insertText,Pe.textEdit=Pe.range instanceof S.Range?new S.TextEdit(Pe.range,Pe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ue.additionalTextEdits.map(et=>B.to(et))),Pe.command=Q&&ue.command?Q.fromInternal(ue.command):void 0,Pe}me.to=he})(J=e.CompletionItem||(e.CompletionItem={}));var ae;(function(me){function he(Q){return{label:Q.label,documentation:Q.documentation?u.fromStrict(Q.documentation):void 0}}me.from=he;function ue(Q){return{label:Q.label,documentation:k.isMarkdownString(Q.documentation)?u.to(Q.documentation):Q.documentation}}me.to=ue})(ae=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(me){function he(Q){return{label:Q.label,documentation:Q.documentation?u.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ae.from):[],activeParameter:Q.activeParameter}}me.from=he;function ue(Q){return{label:Q.label,documentation:k.isMarkdownString(Q.documentation)?u.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ae.to):[],activeParameter:Q.activeParameter}}me.to=ue})(ge=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(me){function he(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ge.from):[]}}me.from=he;function ue(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ge.to):[]}}me.to=ue})(De=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(me){function he(Q){var Ie;return{text:Q.text,range:m.from(Q.range),kind:pe.from((Ie=Q.kind)!==null&&Ie!==void 0?Ie:S.InlineHintKind.Other),description:Q.description&&u.fromStrict(Q.description),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}me.from=he;function ue(Q){const Ie=new S.InlineHint(Q.text,m.to(Q.range),pe.to(Q.kind));return Ie.whitespaceAfter=Q.whitespaceAfter,Ie.whitespaceBefore=Q.whitespaceBefore,Ie.description=k.isMarkdownString(Q.description)?u.to(Q.description):Q.description,Ie}me.to=ue})(Le=e.InlineHint||(e.InlineHint={}));var pe;(function(me){function he(Q){return Q}me.from=he;function ue(Q){return Q}me.to=ue})(pe=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(me){function he(Q){return{range:m.from(Q.range),url:Q.target,tooltip:Q.tooltip}}me.from=he;function ue(Q){let Ie;if(Q.url)try{Ie=typeof Q.url=="string"?P.URI.parse(Q.url,!0):P.URI.revive(Q.url)}catch(Pe){}return new S.DocumentLink(m.to(Q.range),Ie)}me.to=ue})(Ce=e.DocumentLink||(e.DocumentLink={}));var Te;(function(me){function he(Q){const Ie=new S.ColorPresentation(Q.label);return Q.textEdit&&(Ie.textEdit=B.to(Q.textEdit)),Q.additionalTextEdits&&(Ie.additionalTextEdits=Q.additionalTextEdits.map(Pe=>B.to(Pe))),Ie}me.to=he;function ue(Q){return{label:Q.label,textEdit:Q.textEdit?B.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ie=>B.from(Ie)):void 0}}me.from=ue})(Te=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(me){function he(Q){return new S.Color(Q[0],Q[1],Q[2],Q[3])}me.to=he;function ue(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}me.from=ue})(Ue=e.Color||(e.Color={}));var be;(function(me){function he(Q){return{range:m.from(Q.range)}}me.from=he;function ue(Q){return new S.SelectionRange(m.to(Q.range))}me.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(me){function he(ue){switch(ue){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}me.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(me){function he(Q){switch(Q){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}me.from=he;function ue(Q){switch(Q){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}me.to=ue})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(me){function he(Q){if(Q===S.EndOfLine.CRLF)return 1;if(Q===S.EndOfLine.LF)return 0}me.from=he;function ue(Q){if(Q===1)return S.EndOfLine.CRLF;if(Q===0)return S.EndOfLine.LF}me.to=ue})(X=e.EndOfLine||(e.EndOfLine={}));var _e;(function(me){function he(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=he})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(me){function he(ue){const Q={start:ue.start+1,end:ue.end+1};return ue.kind&&(Q.kind=He.from(ue.kind)),Q}me.from=he})(Me=e.FoldingRange||(e.FoldingRange={}));var He;(function(me){function he(ue){if(ue)switch(ue){case S.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}me.from=he})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(me){function he(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?m.from(ue.selection):void 0,override:typeof ue.override=="boolean"?T.EditorOverride.DISABLED:void 0}}me.from=he})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(me){function he(Q){return Q instanceof S.RelativePattern||typeof Q=="string"?Q:ue(Q)?new S.RelativePattern(Q.base,Q.pattern):Q}me.from=he;function ue(Q){const Ie=Q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var x;(function(me){function he(ue){if(ue){if(Array.isArray(ue))return ue.map(he);if(typeof ue=="string")return ue;{const Q=ue;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Xe.from(Q.pattern),exclusive:Q.exclusive}}}else return}me.from=he})(x=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(me){function he(Q){return{start:Q.start,end:Q.end}}me.from=he;function ue(Q){return new S.NotebookCellRange(Q.start,Q.end)}me.to=ue})(ie=e.NotebookCellRange||(e.NotebookCellRange={}));var ce;(function(me){function he(ue){return new S.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.hasExecutionOrder,ue.executionOrder,ue.runState,ue.runStartTime,ue.statusMessage,ue.lastRunDuration,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}me.to=he})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(me){function he(Q){return Q}me.from=he;function ue(Q){return new S.NotebookDocumentMetadata(Q.editable,Q.cellEditable,Q.cellHasExecutionOrder,Q.custom,Q.runState,Q.trusted)}me.to=ue})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Y;(function(me){function he(Q){switch(Q){case S.NotebookCellKind.Markdown:return h.CellKind.Markdown;case S.NotebookCellKind.Code:default:return h.CellKind.Code}}me.from=he;function ue(Q){switch(Q){case h.CellKind.Markdown:return S.NotebookCellKind.Markdown;case h.CellKind.Code:default:return S.NotebookCellKind.Code}}me.to=ue})(Y=e.NotebookCellKind||(e.NotebookCellKind={}));var se;(function(me){function he(ue){return{cellKind:Y.from(ue.kind),language:ue.language,source:ue.source,metadata:ue.metadata,outputs:ue.outputs?ue.outputs.map(ve.from):[]}}me.from=he})(se=e.NotebookCellData||(e.NotebookCellData={}));var fe;(function(me){function he(Q){return{mime:Q.mime,value:Q.value,metadata:Q.metadata}}me.from=he;function ue(Q){return new S.NotebookCellOutputItem(Q.mime,Q.value,Q.metadata)}me.to=ue})(fe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ve;(function(me){function he(Q){return{outputId:Q.id,outputs:Q.outputs.map(fe.from),metadata:Q.metadata}}me.from=he;function ue(Q){const Ie=Q.outputs.map(fe.to);return new S.NotebookCellOutput(Ie,Q.outputId,Q.metadata)}me.to=ue})(ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(me){function he(Pe){if(Pe!=null){if(Pe instanceof S.RelativePattern||typeof Pe=="string")return Pe;if(Ie(Pe))return new S.RelativePattern(Pe.base,Pe.pattern);if(Q(Pe))return{include:Xe.from(Pe.include)||void 0,exclude:Xe.from(Pe.exclude)||void 0}}}me.from=he;function ue(Pe){return typeof Pe=="string"?Pe:Ie(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}me.to=ue;function Q(Pe){const et=Pe,Ge=Xe.from(et.include);if(!(Ge&&Ge instanceof S.RelativePattern||typeof Ge=="string"))return!1;const rt=Xe.from(et.exclude);return!!(rt&&rt instanceof S.RelativePattern||typeof rt=="string")}function Ie(Pe){const et=Pe;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(me){function he(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?g.from(ue.top):void 0}}me.from=he})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ve;(function(me){function he(Q){return{state:Q.state,duration:Q.duration,messages:Q.messages.map(Qe.from)}}me.from=he;function ue(Q){const Ie=new S.TestState(Q.state);return Ie.duration=Q.duration,Ie.messages=Q.messages.map(Qe.to),Ie}me.to=ue})(Ve=e.TestState||(e.TestState={}));var Qe;(function(me){function he(Q){return{message:u.fromStrict(Q.message)||"",severity:Q.severity,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?N.from(Q.location):void 0}}me.from=he;function ue(Q){const Ie=new S.TestMessage(typeof Q.message=="string"?Q.message:u.to(Q.message));return Ie.severity=Q.severity,Ie.actualOutput=Q.actualOutput,Ie.expectedOutput=Q.expectedOutput,Ie}me.to=ue})(Qe=e.TestMessage||(e.TestMessage={}));var Ze;(function(me){function he(Ie){var Pe,et;return{extId:Ie.id,label:Ie.label,location:Ie.location?N.from(Ie.location):void 0,debuggable:(Pe=Ie.debuggable)!==null&&Pe!==void 0?Pe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}me.from=he;function ue(Ie){return{id:Ie.extId,label:Ie.label,location:Ie.location&&N.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)}),debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}me.toPlainShallow=ue;function Q(Ie){const Pe=new S.TestItem(Ie.extId,Ie.label);return Ie.location&&(Pe.location=N.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)})),Pe.debuggable=Ie.debuggable,Pe.description=Ie.description,Pe.runnable=Ie.runnable,Pe}me.toShallow=Q})(Ze=e.TestItem||(e.TestItem={}));var ct;(function(me){function he(Ie,Pe){var et,Ge,rt;const lt={completedAt:Pe.completedAt,id:Ie,items:[]},Je=[[null,Pe.results]];for(;Je.length;){const[it,dt]=Je.pop();for(const at of dt){const Dt={children:(Ge=(et=at.children)===null||et===void 0?void 0:et.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:at.result.state,item:Ze.from(at),state:Ve.from(at.result),retired:void 0,parent:(rt=it==null?void 0:it.item.extId)!==null&&rt!==void 0?rt:null,providerId:"",direct:!it};lt.items.push(Dt),at.children&&Je.push([Dt,at.children])}}return lt}me.from=he;const ue=(Ie,Pe)=>Object.assign(Object.assign({},Ze.toPlainShallow(Ie.item)),{result:Ve.to(Ie.state),children:Ie.children.map(et=>Pe.get(et)).filter(A.isDefined).map(et=>ue(et,Pe))});function Q(Ie){const Pe=[],et=new Map;for(const Ge of Ie.items)et.set(Ge.item.extId,Ge),Ge.direct&&Pe.push(Ge);return{completedAt:Ie.completedAt,results:Pe.map(Ge=>ue(Ge,et))}}me.to=Q})(ct=e.TestResults||(e.TestResults={}));var st;(function(me){function he(ue){switch(ue){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}me.to=he})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[172],Ee([0,1,2,10,7,9,46]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(n,A,C,_={timeout:1500,errors:3}){this._logService=n,this._documents=A,this._mainThreadBulkEdits=C,this._thresholds=_,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(A,C,_)=>{const s={dispose:this._callbacks.push([A,C,n])};return Array.isArray(_)&&_.push(s),s}}async $participateInSave(n,A){const C=b.URI.revive(n);let _=!1;const f=setTimeout(()=>_=!0,this._thresholds.timeout),s=[];try{for(let h of[...this._callbacks]){if(_)break;const p=this._documents.getDocument(C),m=await this._deliverEventAsyncAndBlameBadListeners(h,{document:p,reason:P.TextDocumentSaveReason.to(A)});s.push(m)}}finally{clearTimeout(f)}return s}_deliverEventAsyncAndBlameBadListeners([n,A,C],_){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,A,_).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const h=this._badListeners.get(n);this._badListeners.set(n,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,A,C,_){const f=[],s=Date.now(),{document:h,reason:p}=_,{version:m}=h,v=Object.freeze({document:h,reason:p,waitUntil(d){if(Object.isFrozen(f))throw(0,S.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{A.apply(C,[v])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,c)=>{const o=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(o),d(t)}).catch(t=>{clearTimeout(o),c(t)})}).then(d=>{const c={edits:[]};for(const o of d)if(Array.isArray(o)&&o.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:r,range:l}of o)c.edits.push({_type:2,resource:h.uri,edit:{range:l&&P.Range.from(l),text:t,eol:r&&P.EndOfLine.from(r)}});if(c.edits.length!==0)return m===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(we[173],Ee([0,1,3,13,28,2,9,7]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(C,_,f,s,h){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,f&&(this._config+=1),s&&(this._config+=2),h&&(this._config+=4);const p=(0,T.parse)(_),m=C(v=>{if(!f)for(let d of v.created){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!s)for(let d of v.changed){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidChange.fire(c)}if(!h)for(let d of v.deleted){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,_,f){this._logService=_,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,_,f,s){return new E(this._onFileSystemEvent.event,C,_,f,s)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,_){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(f=>P.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,_){return(f,s,h)=>{const p=function(v){f.call(s,v)};return p.extension=C,_.event(p,void 0,h)}}async $onWillRunFileOperation(C,_,f,s){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},f,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(h=>P.URI.revive(h.target))},f,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(h=>P.URI.revive(h.target))},f,s)}}async _fireWillEvent(C,_,f,s){const h=new Set,p=[];if(await C.fireAsync(_,s,async(v,d)=>{var c;const o=Date.now(),t=await Promise.resolve(v);t instanceof k.WorkspaceEdit&&(p.push(t),h.add((c=d.extension.displayName)!==null&&c!==void 0?c:d.extension.identifier.value)),Date.now()-o>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!s.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let v of p){let{edits:d}=y.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(d)}return{edit:m,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=n}),define(we[174],Ee([0,1,3,6,16,23,2,9,70]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class n{constructor(f,s,h,p){this.start=f,this.deletedCount=s,this.deletedItems=h,this.items=p}static asApiEvents(f){return f.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(h=>h.cell)}))}}class A{constructor(f,s,h){var p;this._notebook=f,this._extHostDocument=s,this._cellData=h,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(k.NotebookCellOutput.to),this._metadata=k.NotebookCellMetadata.to((p=h.metadata)!==null&&p!==void 0?p:{})}static asModelAddData(f,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:f}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const f=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata}})}return this._cell}setOutputs(f){this._outputs=f.map(k.NotebookCellOutput.to)}setOutputItems(f,s,h){const p=h.map(k.NotebookCellOutputItem.to),m=this._outputs.find(v=>v.id===f);m&&(s||(m.outputs.length=0),m.outputs.push(...p))}setMetadata(f){this._metadata=k.NotebookCellMetadata.to(f)}}e.ExtHostCell=A;class C extends S.Disposable{constructor(f,s,h,p,m,v,d){super();this._proxy=f,this._textDocumentsAndEditors=s,this._textDocuments=h,this._emitter=p,this._viewType=m,this._metadata=v,this.uri=d,this.handle=C._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,S.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const f=this;this._notebook=Object.freeze({get uri(){return f.uri},get version(){return f._versionId},get fileName(){return f.uri.fsPath},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===T.Schemas.untitled},get cells(){return f._cells.map(s=>s.cell)},get metadata(){return f._metadata},set metadata(s){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return f._save()}})}return this._notebook}updateBackup(f){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,s){this._versionId=f.versionId,this._isDirty=s;for(const h of f.rawEvents)h.kind===E.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(h.changes,!0),h.kind===E.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===E.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===E.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===E.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===E.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===E.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(h.index,h.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,s){if(!this._disposed){const h=[],p=[],m=[];f.reverse().forEach(v=>{var d;const o=v[2].map(l=>{const a=new A(this,this._textDocumentsAndEditors,l);if(s||p.push(A.asModelAddData(this.notebookDocument,l)),!this._cellDisposableMapping.has(a.handle)){const i=new S.DisposableStore;i.add(a),this._cellDisposableMapping.set(a.handle,i)}return a});for(let l=v[0];l<v[0]+v[1];l++)(d=this._cellDisposableMapping.get(this._cells[l].handle))===null||d===void 0||d.dispose(),this._cellDisposableMapping.delete(this._cells[l].handle);const t=new n(v[0],v[1],[],o),r=this._cells.splice(v[0],v[1],...o);for(let l of r)m.push(l.uri),t.deletedItems.push(l.cell);h.push(t)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:m}),s||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(h)}))}}_moveCell(f,s){const h=this._cells.splice(f,1);this._cells.splice(s,0,...h);const p=[new n(f,1,h.map(m=>m.cell),[]),new n(s,0,[],h)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(p)}))}_setCellOutputs(f,s){const h=this._cells[f];h.setOutputs(s),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[h.cell]}))}_setCellOutputItems(f,s,h,p){const m=this._cells[f];m.setOutputItems(s,h,p),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[m.cell]}))}_changeCellLanguage(f,s){const h=this._cells[f];h.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(h.uri,s)}_changeCellMetadata(f,s){const h=this._cells[f];h.setMetadata(s||{}),this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:h.cell}))}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(s=>s.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=C,C._handlePool=0}),define(we[175],Ee([0,1,3,7,9]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:E,metadata:n})}replaceCellOutput(E,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:E,outputs:n.map(A=>T.NotebookCellOutput.from(A))})}replaceCells(E,n,A){this._throwIfFinalized(),!(E===n&&A.length===0)&&this._collectedEdits.push({editType:1,index:E,count:n-E,cells:A.map(T.NotebookCellData.from)})}}class y{constructor(E,n,A,C,_,f,s){this.id=E,this._viewType=n,this._proxy=A,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=f,this._visibleRanges=_,this._viewColumn=s}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.notebookDocument},get selection(){var n;const A=E._selections[0];return A&&((n=E.notebookData.getCellFromIndex(A.start))===null||n===void 0?void 0:n.cell)},get selections(){return E._selections},get visibleRanges(){return E._visibleRanges},revealRange(n,A){E._proxy.$tryRevealRange(E.id,T.NotebookCellRange.from(n),A!=null?A:S.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},get onDidDispose(){return E.onDidDispose},edit(n){const A=new P(this.document.version);return n(A),E._applyEdit(A.finalize())},get kernel(){return E._kernel},setDecorations(n,A){return E.setDecorations(n,A)}}}return this._editor}_acceptKernel(E){this._kernel=E}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const n=[];let A=-1;for(let C=0;C<E.cellEdits.length;C++){if(A<0){n.push(E.cellEdits[C]),A++;continue}const f=n[A];if(f.editType===1&&E.cellEdits[C].editType===1){const s=E.cellEdits[C];if(s.editType!==5&&f.index===s.index){f.cells.push(...E.cellEdits[C].cells),f.count+=E.cellEdits[C].count;continue}}n.push(E.cellEdits[C]),A++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,E.documentVersionId,n)}setDecorations(E,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return n.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(n),E.key)}}e.ExtHostNotebookEditor=y}),define(we[176],Ee([0,1,9,149,130,20,44]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,_,f){const s=this._handles++,{title:h,location:p,cancellable:m}=_,v=(0,T.localize)(0,null,C.displayName||C.name);return this._proxy.$startProgress(s,{location:b.ProgressLocation.from(p),title:h,source:v,cancellable:m},C),this._withProgress(s,f,!!m)}_withProgress(C,_,f){let s;f&&(s=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,s));const h=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),s&&s.dispose()};let p;try{p=_(new n(this._proxy,C),f&&s?s.token:P.CancellationToken.None)}catch(m){throw h(C),m}return p.then(m=>h(C),m=>h(C)),p}$acceptProgressCanceled(C){const _=this._mapHandleToCancellationSource.get(C);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function E(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class n extends S.Progress{constructor(C,_){super(f=>this.throttledReport(f));this._proxy=C,this._handle=_}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,y.throttle)(100,(A,C)=>E(A,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(we[95],Ee([0,1,43,10,53,9,7]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(_,f){const s=k._Keys.nextId();_.$registerTextEditorDecorationType(s,P.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){_.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class E{constructor(_,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,f){this._throwIfFinalized();let s=null;if(_ instanceof y.Position)s=new y.Range(_,_);else if(_ instanceof y.Range)s=_;else throw new Error("Unrecognized location");this._pushEdit(s,f,!1)}insert(_,f){this._throwIfFinalized(),this._pushEdit(new y.Range(_,_),f,!0)}delete(_){this._throwIfFinalized();let f=null;if(_ instanceof y.Range)f=_;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(_,f,s){const h=this._document.validateRange(_);this._collectedEdits.push({range:h,text:f,forceMoveMarkers:s})}setEndOfLine(_){if(this._throwIfFinalized(),_!==y.EndOfLine.LF&&_!==y.EndOfLine.CRLF)throw(0,S.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=E;class n{constructor(_,f,s,h){this._proxy=_,this._id=f,this._accept(s),this._logService=h;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const f=Math.floor(_);return f>0?f:null}if(typeof _=="string"){const f=parseInt(_,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(_){const f=this._validateTabSize(_);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const f=this._validateInsertSpaces(_);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(_)})))}assign(_){const f={};let s=!1;if(typeof _.tabSize!="undefined"){const h=this._validateTabSize(_.tabSize);h==="auto"?(s=!0,f.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,s=!0,f.tabSize=h)}if(typeof _.insertSpaces!="undefined"){const h=this._validateInsertSpaces(_.insertSpaces);h==="auto"?(s=!0,f.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,s=!0,f.insertSpaces=h)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,s=!0,f.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,s=!0,f.lineNumbers=P.TextEditorLineNumbersStyle.from(_.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(_){_.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class A{constructor(_,f,s,h,p,m,v,d){this.id=_,this._proxy=f,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new n(this._proxy,this.id,m,s),this._visibleRanges=v,this._viewColumn=d;const c=this;this.value=Object.freeze({get document(){return h.getValue()},set document(o){throw(0,S.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(o){if(!(o instanceof y.Selection))throw(0,S.illegalArgument)("selection");c._selections=[o],c._trySetSelection()},get selections(){return c._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof y.Selection)))throw(0,S.illegalArgument)("selections");c._selections=o,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(o){throw(0,S.readonly)("visibleRanges")},get options(){return c._options.value},set options(o){c._disposed||c._options.assign(o)},get viewColumn(){return c._viewColumn},set viewColumn(o){throw(0,S.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(h.getValue(),t);return o(r),c._applyEdit(r)},insertSnippet(o,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=c._selections.map(a=>P.Range.from(a));else if(t instanceof y.Position){const{lineNumber:a,column:i}=P.Position.from(t);l=[{startLineNumber:a,startColumn:i,endLineNumber:a,endColumn:i}]}else if(t instanceof y.Range)l=[P.Range.from(t)];else{l=[];for(const a of t)if(a instanceof y.Range)l.push(P.Range.from(a));else{const{lineNumber:i,column:u}=P.Position.from(a);l.push({startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u})}}return f.$tryInsertSnippet(_,o.value,l,r)},setDecorations(o,t){const r=t.length===0;r&&!c._hasDecorationsForKey.has(o.key)||(r?c._hasDecorationsForKey.delete(o.key):c._hasDecorationsForKey.add(o.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return f.$trySetDecorations(_,o.key,P.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let a=0,i=t.length;a<i;a++){const u=t[a];l[4*a]=u.start.line+1,l[4*a+1]=u.start.character+1,l[4*a+2]=u.end.line+1,l[4*a+3]=u.end.character+1}return f.$trySetDecorationsFast(_,o.key,l)}}))},revealRange(o,t){c._runOnProxy(()=>f.$tryRevealRange(_,P.Range.from(o),t||y.TextEditorRevealType.Default))},show(o){f.$tryShowEditor(_,P.ViewColumn.from(o))},hide(){f.$tryHideEditor(_)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,b.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,b.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,b.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,b.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const f=_.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const s=f.edits.map(p=>p.range);s.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=s.length-1;p<m;p++){const v=s[p].end;if(s[p+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=f.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,h,{setEndOfLine:typeof f.setEndOfLine=="number"?P.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=A}),define(we[177],Ee([0,1,133,24,2,3,6,13,7,12,15,9,20]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(p,m){if((0,n.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let v;return Array.isArray(p.highlights)&&(v=p.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),v=v.length?v:void 0),{label:p.label,highlights:v}}}class s{constructor(m,v,d){this._proxy=m,this.commands=v,this.logService=d,this.treeViews=new Map;function c(o){return o&&o.$treeViewId&&o.$treeItemHandle}v.registerArgumentProcessor({processArgument:o=>c(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>c(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(m,v,d){const c=this.createTreeView(m,{treeDataProvider:v},d);return{dispose:()=>c.dispose()}}createTreeView(m,v,d){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany}),o=this.createExtHostTreeView(m,v,d);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,r)=>o.reveal(t,r),dispose:async()=>{await c,this.treeViews.delete(m),o.dispose()}}}$getChildren(m,v){const d=this.treeViews.get(m);return d?d.getChildren(v):Promise.reject(new Error((0,b.localize)(0,null,m)))}async $hasResolve(m){const v=this.treeViews.get(m);if(!v)throw new Error((0,b.localize)(1,null,m));return v.hasResolve}$resolve(m,v,d){const c=this.treeViews.get(m);if(!c)throw new Error((0,b.localize)(2,null,m));return c.resolveTreeItem(v,d)}$setExpanded(m,v,d){const c=this.treeViews.get(m);if(!c)throw new Error((0,b.localize)(3,null,m));c.setExpanded(v,d)}$setSelection(m,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,b.localize)(4,null,m));d.setSelection(v)}$setVisible(m,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,b.localize)(5,null,m));d.setVisible(v)}createExtHostTreeView(m,v,d){const c=new h(m,v,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(m,c),c}convertArgument(m){const v=this.treeViews.get(m.$treeViewId);return v?v.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=s;class h extends y.Disposable{constructor(m,v,d,c,o,t){super();if(this.viewId=m,this.proxy=d,this.commands=c,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const i of t.contributes.views[a])i.id===m&&(this._title=i.name);this.dataProvider=v.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let r,l;this._register(P.Event.debounce(this._onDidChangeData.event,(a,i)=>(a||(a={message:!1,elements:[]}),i.element!==!1&&(r||(r=new Promise(u=>l=u),this.refreshPromise=this.refreshPromise.then(()=>r)),a.elements.push(i.element)),i.message&&(a.message=!0),a),200,!0)(({message:a,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=l;return r=null,this.refresh(i).then(()=>u())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,n.isUndefinedOrNull)(m))}getChildren(m){const v=m?this.getExtensionElement(m):void 0;if(m&&!v)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(m);return(d?Promise.resolve(d):this.fetchChildrenNodes(v)).then(c=>c.map(o=>o.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,v){v=v||{select:!0,focus:!1};const d=(0,n.isUndefinedOrNull)(v.select)?!0:v.select,c=(0,n.isUndefinedOrNull)(v.focus)?!1:v.focus,o=(0,n.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(l=>l.item)},{select:d,focus:c,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:c,expand:o})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,v){const d=this.getExtensionElement(m);d&&(v?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(m){(0,A.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,v){var d;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(m);if(c){const o=this.nodes.get(c);if(o){const t=(d=await this.dataProvider.resolveTreeItem(o.extensionItem,c,v))!==null&&d!==void 0?d:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(v=>v?this.resolveUnknownParentChain(v).then(d=>this.resolveTreeNode(v,d[d.length-1]).then(c=>(d.push(c),d))):Promise.resolve([]))}resolveParent(m){const v=this.nodes.get(m);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,v){const d=this.nodes.get(m);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(c=>this.createHandle(m,c,v,!0)).then(c=>this.getChildren(v?v.item.handle:void 0).then(()=>{const o=this.getExtensionElement(c);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(m){if(m){let v;if(typeof m=="string"){const d=this.getExtensionElement(m);v=d?this.nodes.get(d):void 0}else v=m;return v&&v.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const v=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=m?this.nodes.get(m):void 0,c=await this.dataProvider.getChildren(m);if(v.token.isCancellationRequested)return[];const o=await Promise.all((0,A.coalesce)(c||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,d):null}));return v.token.isCancellationRequested?[]:(0,A.coalesce)(o)}finally{v.dispose()}}refresh(m){if(m.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(m);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const v=new Set;for(const c of m){const o=this.nodes.get(c);if(o&&!v.has(o.item.handle)){let t=o;for(;t&&t.parent&&!v.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&v.add(o.item.handle)}}const d=[];return v.forEach(c=>{const o=this.elements.get(c);if(o){const t=this.nodes.get(o);t&&(!t.parent||!v.has(t.parent.item.handle))&&d.push(c)}}),d}refreshHandles(m){const v={};return Promise.all(m.map(d=>this.refreshNode(d).then(c=>{c&&(v[d]=c.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(m){const v=this.getExtensionElement(m);if(v){const d=this.nodes.get(v);if(d)return this.clearChildren(v),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(c=>{if(c){const o=this.createTreeNode(v,c,d.parent);return this.updateNodeCache(v,o,d,d.parent),d.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,v,d){const c=this.createTreeNode(m,v,d);if(v.id&&this.elements.has(c.item.handle))throw new Error((0,b.localize)(6,null,v.id));return this.addNodeToCache(m,c),this.addNodeToParentCache(c,d),c}getTooltip(m){return E.MarkdownString.isMarkdownString(m)?C.MarkdownString.from(m):m}getCommand(m,v){return v?this.commands.toInternal(v,m):void 0}createTreeNode(m,v,d){const c=new y.DisposableStore,o=this.createHandle(m,v,d),t=this.getLightIconPath(v);return{item:{handle:o,parentHandle:d?d.item.handle:void 0,label:f(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(c,v.command),contextValue:v.contextValue,icon:t,iconDark:this.getDarkIconPath(v)||t,themeIcon:this.getThemeIcon(v),collapsibleState:(0,n.isUndefinedOrNull)(v.collapsibleState)?E.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation},extensionItem:v,parent:d,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(m){return m.iconPath instanceof E.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:v,label:d,resourceUri:c},o,t){if(v)return`${h.ID_HANDLE_PREFIX}/${v}`;const r=f(d,this.extension),l=o?o.item.handle:h.LABEL_HANDLE_PREFIX;let a=r?r.label:c?(0,S.basename)(c):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const i=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,u=this.getChildrenNodes(o)||[];let D,R=0;do{if(D=`${l}/${R}:${a}`,t||!this.elements.has(D)||i===D)break;R++}while(R<=u.length);return D}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof E.ThemeIcon))return typeof m.iconPath=="string"||T.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof E.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return T.URI.isUri(m)?m:T.URI.file(m)}addNodeToCache(m,v){this.elements.set(v.item.handle,m),this.nodes.set(m,v)}updateNodeCache(m,v,d,c){this.elements.delete(v.item.handle),this.nodes.delete(m),v.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(m,v);const o=this.getChildrenNodes(c)||[],t=o.filter(r=>r.item.handle===d.item.handle)[0];t&&o.splice(o.indexOf(t),1,v)}addNodeToParentCache(m,v){v?(v.children||(v.children=[]),v.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const v=this.nodes.get(m);if(v){if(v.children)for(const d of v.children){const c=this.elements.get(d.item.handle);c&&this.clear(c)}v.children=void 0}}else this.clearAll()}clear(m){const v=this.nodes.get(m);if(v){if(v.children)for(const d of v.children){const c=this.elements.get(d.item.handle);c&&this.clear(c)}this.nodes.delete(m),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(we[178],Ee([0,1,15,13,44,9]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Set}getTestById(s){return(0,b.mapFind)(this.testIdsToInternal,h=>{const p=h.get(s);return p&&[h,p]})}createForHierarchy(s=()=>{}){return new n(this.createIdMap(),s)}createIdMap(){const s=new E;return this.testIdsToInternal.add(s),{object:s,dispose:()=>this.testIdsToInternal.delete(s)}}}e.OwnedTestCollection=y;var k;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(k=e.TestPosition||(e.TestPosition={}));class E{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const h=this.map.get(s);return h?(this.map.delete(s),this._roots.delete(h),!0):!1}get(s){return this.map.get(s)}comparePositions(s,h){const p=typeof s=="string"?this.map.get(s):s,m=typeof h=="string"?this.map.get(h):h;if(!p||!m)return 0;if(p===m)return 3;for(let v=this.map.get(m.parent);v;v=this.map.get(v.parent))if(v===p)return 1;for(let v=this.map.get(p.parent);v;v=this.map.get(v.parent))if(v===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=E;class n{constructor(s,h){this.testIdToInternal=s,this.publishDiff=h,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new S.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(s,h){this.addItem(s,h,null),this.debounceSendDiff.schedule()}getTestByReference(s){return this.testItemToInternal.get(s)}onItemChange(s,h){const p=this.testItemToInternal.get(s);if(!p){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(s,h,p.parent),this.debounceSendDiff.schedule()}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){this.diff.push(s),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(s,h,p){let m=this.testItemToInternal.get(s);if(m)m.previousEquals(s)||(m.item=P.TestItem.from(s),m.previousEquals=_(s),this.diff.push([1,{parent:p,providerId:h,item:m.item}]));else{if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);m={actual:s,parent:p,item:P.TestItem.from(s),providerId:h,previousChildren:new Set,previousEquals:_(s)},this.testIdToInternal.object.add(m),this.testItemToInternal.set(s,m),this.diff.push([0,{parent:p,providerId:h,item:m.item}])}if(s.children){const v=m.previousChildren,d=new Set;for(const c of s.children){const o=this.testIdToInternal.object.get(c.id);o&&o.actual!==c&&this.removeItembyId(c.id);const t=this.addItem(c,h,m.item.extId);v.delete(t.item.extId),d.add(t.item.extId)}for(const c of v)this.removeItembyId(c);m.previousChildren=d}return m}removeItembyId(s){this.diff.push([2,s]);const h=[this.testIdToInternal.object.get(s)];for(;h.length;){const p=h.pop();if(!!p){this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const m of p.previousChildren)h.push(this.testIdToInternal.object.get(m))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}je([(0,T.throttle)(200)],n.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=n;const C=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),_=f=>{const s=[];for(const h of C)s.push(f[h]);return h=>{for(let p=0;p<C.length;p++)if(s[p]!==h[C[p]])return!1;return!0}}}),define(we[179],Ee([0,1,25,3,11]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class y{constructor(A){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let C of A.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(A)}}keepOnly(A){const C=new Set;A.forEach(_=>C.add(b.ExtensionIdentifier.toKey(_))),this._extensionDescriptions=this._extensionDescriptions.filter(_=>C.has(b.ExtensionIdentifier.toKey(_.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,C){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const _=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(_.map(f=>f.identifier)),C.length>0){const f=new Set;C.forEach(s=>f.add(b.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!f.has(b.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(_)}static _findLoopingExtensions(A){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const v=C.getArcs(p);for(let d=0;d<v.length;d++)if(!m.has(v[d]))return!1;return!0}getNodes(){return this._nodesArr}};let _=new Map;for(let p of A){const m=b.ExtensionIdentifier.toKey(p.identifier);if(_.set(m,p),p.extensionDependencies)for(let v of p.extensionDependencies){const d=b.ExtensionIdentifier.toKey(v);C.addArc(m,d)}}let f=new Set;C.getNodes().filter(p=>C.getArcs(p).length===0).forEach(p=>f.add(p));let s=C.getNodes().filter(p=>!f.has(p)),h;do{h=!1;for(let p=0;p<s.length;p++){const m=s[p];C.hasOnlyGoodArcs(m,f)&&(s.splice(p,1),p--,f.add(m),h=!0)}}while(h);return s.map(p=>_.get(p))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const C=this._activationMap.get(A);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(A));return C||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(k||(k={}));function E(n,A){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,_=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(C!==_)return C-_;const f=T.posix.basename(n.extensionLocation.path),s=T.posix.basename(A.extensionLocation.path);return f<s?-1:f>s?1:0}}),define(we[180],Ee([0,1,26]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(k){const E=b.VSBuffer.alloc(1);switch(k){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=P;function y(k,E){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=y}),define(we[34],Ee([0,1,3,2,4,25,146]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(c){this.dependency=c}}e.MissingDependencyError=k;var E;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(c,o,t,r){this.codeLoadingTime=c,this.activateCallTime=o,this.activateResolvedTime=t,this.activationReason=r}}e.ActivationTimes=n;class A{constructor(c,o){this.description=c,this.value=o}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var C;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function _(d){d.enableProposedApi||f(d)}e.checkProposedApiEnabled=_;function f(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=f;function s(d){var c;((c=d.workspaceTrust)===null||c===void 0?void 0:c.required)||h(d)}e.checkRequiresWorkspaceTrust=s;function h(d){throw new Error(`[${d.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=h;function p(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=p;function m(d){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=m;class v{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(c,o){}_activateById(c,o){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,o,t,r,l){}_onExtensionRuntimeError(c,o){}_onExtensionHostExit(c){}}e.NullExtensionService=v}),define(we[181],Ee([0,1,128,25,34,19]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(h,p,m,v){this.startup=h,this.codeLoadingTime=p,this.activateCallTime=m,this.activateResolvedTime=v}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class E{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,p){return h===-1||p===-1?-1:p-h}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class n{constructor(h,p,m,v,d,c){this.activationFailed=h,this.activationFailedError=p,this.activationTimes=m,this.module=v,this.exports=d,this.subscriptions=c}}e.ActivatedExtension=n;class A extends n{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class C extends n{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class _ extends n{constructor(h){super(!0,h,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let f=class{constructor(h,p,m,v,d){this._logService=d,this._registry=h,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(S.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,m.forEach(c=>this._hostExtensionsMap.set(S.ExtensionIdentifier.toKey(c),c)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const p=S.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(p)}getActivatedExtension(h){const p=S.ExtensionIdentifier.toKey(h),m=this._activatedExtensions.get(p);if(!m)throw new Error("Extension `"+h.value+"` is not known or not activated");return m}activateByEvent(h,p){if(this._alreadyActivatedEvents[h])return y;const m=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(m.map(v=>({id:v.identifier,reason:{startup:p,extensionId:v.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,p){const m=this._registry.getExtensionDescription(h);if(!m)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:m.identifier,reason:p}])}_handleActivateRequest(h,p,m){if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(h.id))){p[S.ExtensionIdentifier.toKey(h.id)]=h;return}const v=this._registry.getExtensionDescription(h.id);if(!v){this._host.onExtensionActivationError(h.id,new T.MissingDependencyError(h.id.value));const o=new Error(`Unknown dependency '${h.id.value}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(h.id),new _(o));return}const d=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let c=!0;for(let o=0,t=d.length;o<t;o++){const r=d[o];if(!this._resolvedExtensionsSet.has(S.ExtensionIdentifier.toKey(r))){const l=this._activatedExtensions.get(S.ExtensionIdentifier.toKey(r));if(!(l&&!l.activationFailed)){if(l&&l.activationFailed){this._host.onExtensionActivationError(v.identifier,b.localize(0,null,v.displayName||v.identifier.value,r));const u=new Error(`Dependency ${r} failed to activate`);u.detail=l.activationFailedError,this._activatedExtensions.set(S.ExtensionIdentifier.toKey(v.identifier),new _(u));return}if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(r))){c=!1,p[S.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(S.ExtensionIdentifier.toKey(r)),reason:h.reason};continue}const a=this._registry.getExtensionDescription(r);if(a){c=!1,p[S.ExtensionIdentifier.toKey(r)]={id:a.identifier,reason:h.reason};continue}this._host.onExtensionActivationError(v.identifier,new T.MissingDependencyError(r));const i=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(v.identifier),new _(i));return}}}c?p[S.ExtensionIdentifier.toKey(v.identifier)]=h:m.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(d=>!this._activatedExtensions.has(S.ExtensionIdentifier.toKey(d.id))),h.length===0))return Promise.resolve(void 0);const p=Object.create(null),m=[];for(let d=0,c=h.length;d<c;d++)this._handleActivateRequest(h[d],p,m);for(let d=0,c=m.length;d<c;d++){const o=S.ExtensionIdentifier.toKey(m[d].id);p[o]&&delete p[o]}const v=Object.keys(p).map(d=>p[d]);return m.length===0?Promise.all(v.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(v).then(d=>this._activateExtensions(m))}_activateExtension(h,p){const m=S.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const v=this._activatingExtensions.get(m);if(v)return v;const d=this._host.actualActivateExtension(h,p).then(void 0,c=>(this._host.onExtensionActivationError(h,b.localize(1,null,h.value,c.message)),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(c),new _(c))).then(c=>{this._activatedExtensions.set(m,c),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,d),d}};f=je([qe(4,P.ILogService)],f),e.ExtensionsActivator=f}),define(we[182],Ee([0,1,10]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class S{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,y)=>{this._actualOk=P,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,b.onUnexpectedError)(P))}then(P,y){return this._ensureActual().then(P,y)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=S}),define(we[96],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(E,n){this.isMain=E,this.sid=n,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const S=[];function T(k){const E=new b(!0,k);return S[E.nid]=E,E}e.createMainContextProxyIdentifier=T;function P(k){const E=new b(!1,k);return S[E.nid]=E,E}e.createExtHostContextProxyIdentifier=P;function y(k){return S[k].sid}e.getStringIdentifierForProxy=y}),define(we[5],Ee([0,1,2,96,57]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(E=e.CellKind||(e.CellKind={}));var n;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var _;(function(d){d.name="$ident";function c(t,r){return Object.defineProperty(t,d.name,{value:r,enumerable:!0}),t}d.mixin=c;function o(t){return t[d.name]}d.of=o})(_=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(c){return c._id=f._n++,c}}e.IdObject=f,f._n=0;var s;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(d){if(d&&d.edits)for(const c of d.edits)typeof c.resource=="object"?c.resource=b.URI.revive(c.resource):(c.newUri=b.URI.revive(c.newUri),c.oldUri=b.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,T.revive)(c.metadata));return d}e.reviveWorkspaceEditDto=m;var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[71],Ee([0,1,5,3,4]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(k){this._onDidChangePassword=new S.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,E){return this._proxy.$getPassword(k,E)}store(k,E,n){return this._proxy.$setPassword(k,E,n)}delete(k,E){return this._proxy.$deletePassword(k,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(we[72],Ee([0,1,4,19,5,14]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(T.MainContext.MainThreadTelemetry)}report(E,n,A){const C=this.getUsageKey(E,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:E}))}getUsageKey(E,n){return`${E}-${n.identifier.value}`}};y=je([qe(0,P.IExtHostRpcService),qe(1,S.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,E,n){}})}),define(we[183],Ee([0,1,3,5,7,25]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(S.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,n,A,C={}){const _=P.ExtensionIdentifier.toKey(E.identifier),f=this._inFlightRequests.get(_)||[],s=A.sort().join(" ");let h=f.find(p=>p.scopes===s);if(h)return h.result;{const p=this._getSession(E,_,n,A,C);h={scopes:s,result:p},f.push(h),this._inFlightRequests.set(_,f);try{await p}finally{const m=f.findIndex(v=>v.scopes===s);m>-1&&(f.splice(m),this._inFlightRequests.set(_,f))}return p}}async _getSession(E,n,A,C,_={}){await this._proxy.$ensureProvider(A);const f=E.displayName||E.name;return this._proxy.$getSession(A,C,n,f,_)}async removeSession(E,n){const A=this._authenticationProviders.get(E);return A?A.provider.removeSession(n):this._proxy.$removeSession(E,n)}registerAuthenticationProvider(E,n,A,C){var _;if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:n,provider:A,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===E)||this._providers.push({id:E,label:n});const f=A.onDidChangeSessions(s=>{var h,p,m;this._proxy.$sendDidChangeSessions(E,{added:(h=s.added)!==null&&h!==void 0?h:[],changed:(p=s.changed)!==null&&p!==void 0?p:[],removed:(m=s.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(E,n,(_=C==null?void 0:C.supportsMultipleAccounts)!==null&&_!==void 0?_:!1),new T.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(E);const s=this._providers.findIndex(h=>h.id===E);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,n){return this._onDidChangeSessions.fire({provider:{id:E,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,n){return E.forEach(A=>{this._providers.some(C=>C.id===A.id)||this._providers.push(A)}),n.forEach(A=>{const C=this._providers.findIndex(_=>_.id===A.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(we[184],Ee([0,1,5,14,9]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(k,E){this._extHostDocumentsAndEditors=E,this._proxy=k.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const E=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};P=je([qe(0,S.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(we[185],Ee([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class S{constructor(P){const y=P.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=S}),define(we[73],Ee([0,1,12,7,9,23,5,15,19,57,33,39,2,6,4,14]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=r,this.converter=new m(this,l=>{const a=this._apiCommands.get(l);return(a==null?void 0:a.result)===d.Void?a:void 0},r),this._argumentProcessors=[{processArgument(l){return(0,n.revive)(l)}},{processArgument(l){return(0,P.cloneAndChange)(l,function(a){if(A.Range.isIRange(a))return T.Range.to(a);if(C.Position.isIPosition(a))return T.Position.to(a);if(A.Range.isIRange(a.range)&&_.URI.isUri(a.uri))return T.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...l)=>{const a=t.args.map((u,D)=>{if(!u.validate(l[D]))throw new Error(`Invalid argument '${u.name}' when running '${t.id}', received: ${l[D]}`);return u.convert(l[D])}),i=await this.executeCommand(t.internalId,...a);return t.result.convert(i,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new S.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,l,a,i){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:l,thisArg:a,description:i}),t&&this._proxy.$registerCommand(r),new S.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,l){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const a=(0,P.cloneAndChange)(r,function(i){if(i instanceof S.Position)return T.Position.from(i);if(i instanceof S.Range)return T.Range.from(i);if(i instanceof S.Location)return T.location.from(i);if(!Array.isArray(i))return i});try{const i=await this._proxy.$executeCommand(t,a,l);return(0,n.revive)(i)}catch(i){if(i instanceof Error&&i.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw i}}}async _executeContributedCommand(t,r){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:a,thisArg:i,description:u}=l;if(u)for(let D=0;D<u.args.length;D++)try{(0,b.validateConstraint)(r[D],u.args[D].constraint)}catch(R){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${u.args[D].name}' - ${u.args[D].description}`)}try{return await a.apply(i,r)}catch(D){if(t===this.converter.delegatingCommandId){const R=this.converter.getActualCommand(...r);R&&(t=R.command)}throw this._logService.error(D,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(l=>this._argumentProcessors.reduce((a,i)=>i.processArgument(a),l)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(l=>l[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,l]of this._commands){let{description:a}=l;a&&(t[r]=a)}return Promise.resolve(t)}};p=je([qe(0,h.IExtHostRpcService),qe(1,E.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class m{constructor(t,r,l){this._commands=t,this._lookupApiCommand=r,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const a=this._lookupApiCommand(t.command);if(a)l.id=a.internalId,l.arguments=a.args.map((i,u)=>i.convert(t.arguments&&t.arguments[u]));else if((0,k.isNonEmptyArray)(t.arguments)){const i=++this._cachIdPool;this._cache.set(i,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(i),this._logService.trace("CommandsConverter#DISPOSE",i)})),l.$ident=i,l.id=this.delegatingCommandId,l.arguments=[i],this._logService.trace("CommandsConverter#CREATE",t.command,i)}return l}}fromInternal(t){const r=y.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class v{constructor(t,r,l,a){this.name=t,this.description=r,this.validate=l,this.convert=a}optional(){return new v(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new v(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=v,v.Uri=new v("uri","Uri of a text document",o=>_.URI.isUri(o),o=>o),v.Position=new v("position","A position in a text document",o=>S.Position.isPosition(o),T.Position.from),v.Range=new v("range","A range in a text document",o=>S.Range.isRange(o),T.Range.from),v.Selection=new v("selection","A selection in a text document",o=>S.Selection.isSelection(o),T.Selection.from),v.Number=new v("number","",o=>typeof o=="number",o=>o),v.String=new v("string","",o=>typeof o=="string",o=>o),v.CallHierarchyItem=new v("item","A call hierarchy item",o=>o instanceof S.CallHierarchyItem,T.CallHierarchyItem.to);class d{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=d,d.Void=new d("no result",o=>o);class c{constructor(t,r,l,a,i){this.id=t,this.internalId=r,this.description=l,this.args=a,this.result=i}}e.ApiCommand=c}),define(we[186],Ee([0,1,6,9,7,62,73,163,15,84]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",_(S.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,h)=>{if(!(0,E.isFalsyOrEmpty)(s)){class p extends T.SymbolInformation{static to(v){const d=new p(v.name,S.SymbolKind.to(v.kind),v.containerName||"",new T.Location(h[0],S.Range.to(v.range)));return d.detail=v.detail,d.range=d.location.range,d.selectionRange=S.Range.to(v.selectionRange),d.children=v.children?v.children.map(p.to):[],d}}return s.map(p.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(S.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(S.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new y.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(S.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(S.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(S.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(h=>T.Position.isPosition(h)),s=>s.map(S.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(h=>{let p;for(const m of h.reverse())p=new T.SelectionRange(S.Range.to(m),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const h=[];if(Array.isArray(s))for(let p of s)h.push(...p[1].map(S.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return S.WorkspaceEdit.to(s)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(S.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const h=(0,n.decodeSemanticTokensDto)(s);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const h=(0,n.decodeSemanticTokensDto)(s);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,h,p)=>{if(!s)return new T.CompletionList([]);const m=s.suggestions.map(v=>S.CompletionItem.to(v,p));return new T.CompletionList(m,s.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return S.SignatureHelp.to(s)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,h,p)=>_(m=>new T.CodeLens(S.Range.to(m.range),m.command&&p.fromInternal(m.command)))(s))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?S.Selection.from(s):S.Range.from(s)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,h,p)=>_(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const v=new T.CodeAction(m.title,m.kind?new T.CodeActionKind(m.kind):void 0);return m.edit&&(v.edit=S.WorkspaceEdit.to(m.edit)),m.command&&(v.command=p.fromInternal(m.command)),v.isPreferred=m.isPreferred,v}})(s))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(h=>new T.ColorInformation(S.Range.to(h.range),S.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,S.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:S.Range.from(s.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(S.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(S.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(h=>S.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(S.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)]).optional()],y.ApiCommandResult.Void)];class C{constructor(h){this._disposables=new b.DisposableStore,this._commands=h}static register(h){return A.forEach(h.registerApiCommand,h),new C(h).registerCommands()}registerCommands(){const h=p=>(...m)=>p(this._commands,...m);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,h(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(k.OpenIssueReporter.ID,h(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(h,p,m){const v=this._commands.registerCommand(!1,h,p,this,m);this._disposables.add(v)}}e.ExtHostApiCommands=C;function _(s){return h=>{if(Array.isArray(h))return h.map(s)}}function f(s){if(!!Array.isArray(s)){const h=[];for(const p of s)P.isLocationLink(p)?h.push(S.DefinitionLink.to(p)):h.push(S.location.to(p));return h}}}),define(we[187],Ee([0,1,13,44,3,6,2,62,25,9,7,5]),function(oe,e,b,S,T,P,y,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class _{constructor(c,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const l=this._commentControllers.get(r.handle);return l||r}else if(r&&r.$mid===7){const l=this._commentControllers.get(r.commentControlHandle);if(!l)return r;const a=l.getCommentThread(r.commentThreadHandle);return a||r}else if(r&&r.$mid===8){const l=this._commentControllers.get(r.thread.commentControlHandle);if(!l)return r;const a=l.getCommentThread(r.thread.commentThreadHandle);return a?{thread:a,text:r.text}:r}else if(r&&r.$mid===9){const l=this._commentControllers.get(r.thread.commentControlHandle);if(!l)return r;const a=l.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let i=r.commentUniqueId,u=a.getCommentByUniqueId(i);return u||r}else if(r&&r.$mid===10){const l=this._commentControllers.get(r.thread.commentControlHandle);if(!l)return r;const a=l.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let i=r.text,u=r.commentUniqueId,D=a.getCommentByUniqueId(u);return D?(D.body=i,D):r}return r}})}createCommentController(c,o,t){const r=_.handlePool++,l=new s(c,r,this._proxy,o,t);this._commentControllers.set(l.handle,l);const a=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(c.identifier))||[];return a.push(l),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(c.identifier),a),l}$createCommentThreadTemplate(c,o,t){const r=this._commentControllers.get(c);!r||r.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(c,o,t){const r=this._commentControllers.get(c);!r||r.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(c,o){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(c,o,t){const r=this._commentControllers.get(c);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(y.URI.revive(o));return(0,b.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(l,t)).then(a=>a?a.map(i=>n.Range.from(i)):void 0)}$toggleReaction(c,o,t,r,l){const a=this._commentControllers.get(c);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const i=a.getCommentThread(o);if(i){const u=i.getCommentByUniqueId(r.uniqueIdInThread);if(a!==void 0&&u&&a.reactionHandler)return a.reactionHandler(u,m(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=_,_.handlePool=0;class f{constructor(c,o,t,r,l,a,i){this._proxy=c,this._commentController=o,this._id=t,this._uri=r,this._range=l,this._comments=a,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),i),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};c("range")&&(o.range=n.Range.from(this._range)),c("label")&&(o.label=this.label),c("contextValue")&&(o.contextValue=this.contextValue),c("comments")&&(o.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(o.collapseState=v(this._collapseState)),c("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(c){for(let o of this._commentsMap){let t=o[0],r=o[1];if(c===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class s{constructor(c,o,t,r,l){this._extension=c,this._handle=o,this._proxy=t,this._id=r,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,o,t,r){if(typeof c=="string"){const l=new f(this._proxy,this,c,o,t,r,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new f(this._proxy,this,void 0,c,o,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(c,o){const t=new f(this._proxy,this,void 0,y.URI.revive(c),n.Range.to(o),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,o){let t=this._threads.get(c);t&&(t.range=n.Range.to(o))}$deleteCommentThread(c){let o=this._threads.get(c);o&&o.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(d,c,o,t){let r=t.get(o);r||(r=++d.commentHandle,t.set(o,r));const l=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(o.body),userName:o.author.name,userIconPath:l,label:o.label,commentReactions:o.reactions?o.reactions.map(a=>p(a)):void 0}}function p(d){return{label:d.label,iconPath:d.iconPath?n.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function m(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function v(d){if(d!==void 0)switch(d){case A.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(we[97],Ee([0,1,2,5,7,4,14,19,15,8,11]),function(oe,e,b,S,T,P,y,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class on{constructor(f,s){this._logService=s,this._provider=new Map,this._proxy=f.getProxy(S.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const h=on._handlePool++;this._provider.set(h,{provider:f,extensionId:s}),this._proxy.$registerDecorationProvider(h,s.value);const p=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(h,null);return}let v=(0,E.asArray)(m);if(v.length<=on._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,v.length);const d=v.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,E.groupBy)(d,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let o=[];e:for(let t of c){let r;for(let l of t){let a=(0,A.dirname)(l.uri.path);if(r!==a&&(r=a,o.push(l.uri)>=on._maxEventSize))break e}}this._proxy.$onDidChange(h,o)});return new T.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(f,s,h){if(!this._provider.has(f))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:v}=this._provider.get(f);return await Promise.all(s.map(async d=>{try{const{uri:c,id:o}=d,t=await Promise.resolve(m.provideFileDecoration(b.URI.revive(c),h));if(!t)return;try{T.FileDecoration.validate(t),p[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${v.value}': ${r}`)}}catch(c){this._logService.error(c)}})),p}};C._handlePool=0,C._maxEventSize=250,C=je([qe(0,y.IExtHostRpcService),qe(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(we[188],Ee([0,1,127,87,2,5,7,9,3,19,22]),function(oe,e,b,S,T,P,y,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(s,h,p,m,v){this._name=s,this._owner=h,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=v,this._isDisposed=!1,this._data=new A.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,h){if(!s){this.clear();return}this._checkDisposed();let p=[];if(T.URI.isUri(s)){if(!h){this.delete(s);return}this._data.set(s,h.slice()),p=[s]}else if(Array.isArray(s)){p=[];let v;s=[...s].sort(C._compareIndexedTuplesByUri);for(const d of s){const[c,o]=d;if((!v||c.toString()!==v.toString())&&(v&&this._data.get(v).length===0&&this._data.delete(v),v=c,p.push(c),this._data.set(c,[])),o){const t=this._data.get(c);t&&t.push(...o)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let v of p){let d=[];const c=this._data.get(v);if(c)if(c.length>this._maxDiagnosticsPerFile){d=[];const o=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of c)if(r.severity===o[t]&&d.push(k.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;d.push({severity:S.MarkerSeverity.Info,message:(0,b.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=c.map(o=>k.Diagnostic.from(o));m.push([v,d])}this._proxy.$changeMany(this._owner,m)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,h){this._checkDisposed();for(let p of this._data.keys())s.apply(h,[p,this.get(p),this])}get(s){this._checkDisposed();const h=this._data.get(s);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,h){return s[0].toString()<h[0].toString()?-1:s[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=C;let _=class Nt{constructor(s,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,Nt._debouncer,50),Nt._mapper),this._proxy=s.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(s,h){return s?s.concat(h):h}static _mapper(s){const h=[],p=new Set;for(const m of s)typeof m=="string"?p.has(m)||(p.add(m),h.push(T.URI.parse(m))):p.has(m.toString())||(p.add(m.toString()),h.push(m));return Object.freeze(h),{uris:h}}createDiagnosticCollection(s,h){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:v,_logService:d}=this,c=new class{$changeMany(r,l){m.$changeMany(r,l),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,r,l.length===0?"CLEARING":l)}$clear(r){m.$clear(r),d.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,r)}dispose(){m.dispose()}};let o;if(!h)h="_generated_diagnostic_collection_name_#"+Nt._idPool++,o=h;else if(!p.has(h))o=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do o=h+Nt._idPool++;while(p.has(o))}return new class extends C{constructor(){super(h,o,Nt._maxDiagnosticsPerFile,c,v);p.set(o,this)}dispose(){super.dispose(),p.delete(o)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const h=new Map,p=[];for(const m of this._collections.values())m.forEach((v,d)=>{let c=h.get(v.toString());typeof c=="undefined"&&(c=p.length,h.set(v.toString(),c),p.push([v,[]])),p[c][1]=p[c][1].concat(...d)});return p}}_getDiagnostics(s){let h=[];for(let p of this._collections.values())p.has(s)&&(h=h.concat(p.get(s)));return h}$acceptMarkersChange(s){if(!this._mirrorCollection){const h="_generated_mirror",p=new C(h,h,Nt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,p),this._mirrorCollection=p}for(const[h,p]of s)this._mirrorCollection.set(T.URI.revive(h),p.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=je([qe(1,n.ILogService)],_),e.ExtHostDiagnostics=_}),define(we[189],Ee([0,1,2,5]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(S.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(E=>b.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?b.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(we[190],Ee([0,1,10,2,7,5,16,20,8]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,_,f){this._documentsAndEditors=_,this._logService=f,this._documentContentProviders=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,_){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,_),this._proxy.$registerTextContentProvider(f,C);let s;return typeof _.onDidChange=="function"&&(s=_.onDidChange(h=>{if(h.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(f,h).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(h);if(!!m){const v=(0,E.splitLines)(p);if(!m.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,p)}}},b.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(C,_){const f=this._documentContentProviders.get(C);return f?Promise.resolve(f.provideTextDocumentContent(S.URI.revive(_),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(we[191],Ee([0,1,3,6,2,5,94,9,12,23]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(_,f){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new S.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const h of s)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const h of s)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!!_){const f=this._documentsAndEditors.getDocument(_);if(f)return f}}getDocument(_){const f=this.getDocumentData(_);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${_}'`);return f.document}ensureDocumentData(_){const f=this._documentsAndEditors.getDocument(_);if(f)return Promise.resolve(f);let s=this._documentLoader.get(_.toString());return s||(s=this._proxy.$tryOpenDocument(_).then(h=>{this._documentLoader.delete(_.toString());const p=T.URI.revive(h);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(p))},h=>(this._documentLoader.delete(_.toString()),Promise.reject(h))),this._documentLoader.set(_.toString(),s)),s}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(f=>T.URI.revive(f))}$acceptModelModeChanged(_,f){const s=T.URI.revive(_),h=this._documentsAndEditors.getDocument(s);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(_){const f=T.URI.revive(_),s=this._documentsAndEditors.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(_,f){const s=T.URI.revive(_),h=this._documentsAndEditors.getDocument(s);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(_,f,s){const h=T.URI.revive(_),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),p.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:p.document,contentChanges:f.changes.map(m=>({range:k.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(_,f){(0,y.setWordDefinitionFor)(_,f)}}e.ExtHostDocuments=A}),define(we[40],Ee([0,1,43,3,6,2,4,5,94,14,95,9,19,22,16,54,105]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(c,o){this._extHostRpc=c,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new S.Emitter,this._onDidRemoveDocuments=new S.Emitter,this._onDidChangeVisibleTextEditors=new S.Emitter,this._onDidChangeActiveTextEditor=new S.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const o=[],t=[],r=[];if(c.removedDocuments)for(const l of c.removedDocuments){const a=P.URI.revive(l),i=this._documents.get(a);(i==null?void 0:i.unref())&&(this._documents.delete(a),o.push(i.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const a=P.URI.revive(l.uri);let i=this._documents.get(a);if(i&&a.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);i||(i=new m(new E.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),a,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(a,i),t.push(i.value)),i.ref()}if(c.removedEditors)for(const l of c.removedEditors){const a=this._editors.get(l);this._editors.delete(l),a&&r.push(a)}if(c.addedEditors)for(const l of c.addedEditors){const a=P.URI.revive(l.documentUri);b.ok(this._documents.has(a),`document '${a}' does not exist`),b.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const i=this._documents.get(a).value,u=new A.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>i.document),l.selections.map(C.Selection.to),l.options,l.visibleRanges.map(D=>C.Range.to(D)),typeof l.editorPosition=="number"?C.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,u)}c.newActiveEditor!==void 0&&(b.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,T.dispose)(o),(0,T.dispose)(r),c.removedDocuments&&this._onDidRemoveDocuments.fire(o),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var o;return(o=this._documents.get(c))===null||o===void 0?void 0:o.value}allDocuments(){return h.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return c?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};v=je([qe(0,n.IExtHostRpcService),qe(1,_.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[192],Ee([0,1,2,5,6,7,9,115,8,26]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const s=this._schemes.indexOf(f);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),s=[];let h,p,m=14,v=14;for(const d of f){let c=h?(0,E.commonPrefixLength)(h,d):0;for(c===0?p=1:p=v;c<d.length;c++)c+1===d.length?(m=v,v=9):v+=1,s.push([p,d.toUpperCase().charCodeAt(c),v]),s.push([p,d.toLowerCase().charCodeAt(c),v]),p=v;h=d,v=m}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(f){this._initStateMachine();const s=[],h=k.LinkComputer.computeLinks({getLineContent(p){return f.lineAt(p-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const p of h){const m=y.DocumentLink.to(p);m.target&&s.push(m)}return s}}class C{constructor(f,s){this._extHostLanguageFeatures=s,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(S.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,s,h,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(m,h);let v=2;p.isCaseSensitive&&(v+=1024),p.isReadonly&&(v+=2048),typeof h.copy=="function"&&(v+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(v+=4),this._proxy.$registerFileSystemProvider(m,s,v).catch(c=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${s}`),console.error(c)});const d=h.onDidChangeFile(c=>{const o=[];for(const t of c){let{uri:r,type:l}=t;if(r.scheme===s){let a;switch(l){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:a})}}this._proxy.$onFileSystemChange(m,o)});return(0,T.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(f){const{type:s,ctime:h,mtime:p,size:m}=f;return{type:s,ctime:h,mtime:p,size:m}}$stat(f,s){return Promise.resolve(this._getFsProvider(f).stat(b.URI.revive(s))).then(C._asIStat)}$readdir(f,s){return Promise.resolve(this._getFsProvider(f).readDirectory(b.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this._getFsProvider(f).readFile(b.URI.revive(s))).then(h=>n.VSBuffer.wrap(h))}$writeFile(f,s,h,p){return Promise.resolve(this._getFsProvider(f).writeFile(b.URI.revive(s),h.buffer,p))}$delete(f,s,h){return Promise.resolve(this._getFsProvider(f).delete(b.URI.revive(s),h))}$rename(f,s,h,p){return Promise.resolve(this._getFsProvider(f).rename(b.URI.revive(s),b.URI.revive(h),p))}$copy(f,s,h,p){const m=this._getFsProvider(f);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(b.URI.revive(s),b.URI.revive(h),p))}$mkdir(f,s){return Promise.resolve(this._getFsProvider(f).createDirectory(b.URI.revive(s)))}$watch(f,s,h,p){const m=this._getFsProvider(f).watch(b.URI.revive(h),p);this._watches.set(s,m)}$unwatch(f,s){const h=this._watches.get(s);h&&(h.dispose(),this._watches.delete(s))}$open(f,s,h){const p=this._getFsProvider(f);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(b.URI.revive(s),h))}$close(f,s){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(s))}$read(f,s,h,p){const m=this._getFsProvider(f);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const v=n.VSBuffer.alloc(p);return Promise.resolve(m.read(s,h,v.buffer,0,p)).then(d=>v.slice(0,d))}$write(f,s,h,p){const m=this._getFsProvider(f);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(s,h,p.buffer,0,p.byteLength))}_getFsProvider(f){const s=this._fsProvider.get(f);if(!s){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return s}}e.ExtHostFileSystem=C}),define(we[74],Ee([0,1,5,64,7,26,4,14,49]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(C,_){const f=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return f.$stat(s).catch(Tt._handleError)},readDirectory(s){return f.$readdir(s).catch(Tt._handleError)},createDirectory(s){return f.$mkdir(s).catch(Tt._handleError)},async readFile(s){return f.$readFile(s).then(h=>h.buffer).catch(Tt._handleError)},writeFile(s,h){return f.$writeFile(s,P.VSBuffer.wrap(h)).catch(Tt._handleError)},delete(s,h){return f.$delete(s,Object.assign({recursive:!1,useTrash:!1},h)).catch(Tt._handleError)},rename(s,h,p){return f.$rename(s,h,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},copy(s,h,p){return f.$copy(s,h,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},isWritableFileSystem(s){const h=_.getCapabilities(s);if(typeof h=="number")return!(h&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case S.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case S.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case S.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case S.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};n=je([qe(0,k.IExtHostRpcService),qe(1,E.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(we[193],Ee([0,1,6,5]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(S.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(we[194],Ee([0,1,2,23,9,7,13,5,8,33,15,12,112,6,84,53,92,55,10]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(W,q){this._documents=W,this._provider=q}provideDocumentSymbols(W,q){const J=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(J,q)).then(ae=>{if(!(0,A.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(T.DocumentSymbol.from):d._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(W){var q;W=W.slice(0).sort((ge,De)=>{let Le=ge.location.range.start.compareTo(De.location.range.start);return Le===0&&(Le=De.location.range.end.compareTo(ge.location.range.end)),Le});const J=[],ae=[];for(const ge of W){const De={name:ge.name||"!!MISSING: name!!",kind:T.SymbolKind.from(ge.kind),tags:((q=ge.tags)===null||q===void 0?void 0:q.map(T.SymbolTag.from))||[],detail:"",containerName:ge.containerName,range:T.Range.from(ge.location.range),selectionRange:T.Range.from(ge.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),J.push(De);break}const Le=ae[ae.length-1];if(n.Range.containsRange(Le.range,De.range)&&!n.Range.equalsRange(Le.range,De.range)){Le.children&&Le.children.push(De),ae.push(De);break}ae.pop()}}return J}}class c{constructor(W,q,J){this._documents=W,this._commands=q,this._provider=J,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,q){const J=this._documents.getDocument(W),ae=await this._provider.provideCodeLenses(J,q);if(!(!ae||q.isCancellationRequested)){const ge=this._cache.add(ae),De=new f.DisposableStore;this._disposables.set(ge,De);const Le={cacheId:ge,lenses:[]};for(let pe=0;pe<ae.length;pe++)Le.lenses.push({cacheId:[ge,pe],range:T.Range.from(ae[pe].range),command:this._commands.toInternal(ae[pe].command,De)});return Le}}async resolveCodeLens(W,q){var J;const ae=W.cacheId&&this._cache.get(...W.cacheId);if(!!ae){let ge;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?ge=ae:ge=await this._provider.resolveCodeLens(ae,q),ge||(ge=ae),!q.isCancellationRequested){const De=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!De)return W.command=this._commands.toInternal((J=ge.command)!==null&&J!==void 0?J:c._badCmd,De),W}}}releaseCodeLenses(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(xe){return Array.isArray(xe)?xe.map(T.DefinitionLink.from):xe?[T.DefinitionLink.from(xe)]:[]}class t{constructor(W,q){this._documents=W,this._provider=q}provideDefinition(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(ae,ge,J)).then(o)}}class r{constructor(W,q){this._documents=W,this._provider=q}provideDeclaration(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(ae,ge,J)).then(o)}}class l{constructor(W,q){this._documents=W,this._provider=q}provideImplementation(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(ae,ge,J)).then(o)}}class a{constructor(W,q){this._documents=W,this._provider=q}provideTypeDefinition(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(ae,ge,J)).then(o)}}class i{constructor(W,q){this._documents=W,this._provider=q}provideHover(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(ae,ge,J)).then(De=>{if(!(!De||(0,A.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(ge)),De.range||(De.range=new P.Range(ge,ge)),T.Hover.from(De)})}}class u{constructor(W,q){this._documents=W,this._provider=q}provideEvaluatableExpression(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,ge,J)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class D{constructor(W,q){this._documents=W,this._provider=q}provideInlineValues(W,q,J,ae){const ge=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlineValues(ge,T.Range.to(q),T.InlineValueContext.to(J),ae)).then(De=>{if(Array.isArray(De))return De.map(Le=>T.InlineValue.from(Le))})}}class R{constructor(W,q){this._documents=W,this._provider=q}provideDocumentHighlights(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(ae,ge,J)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class g{constructor(W,q){this._documents=W,this._provider=q}provideLinkedEditingRanges(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,ge,J)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,A.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class w{constructor(W,q){this._documents=W,this._provider=q}provideReferences(W,q,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(ge,De,J,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(T.location.from)})}}class I{constructor(W,q,J,ae,ge,De,Le){this._documents=W,this._commands=q,this._diagnostics=J,this._provider=ae,this._logService=ge,this._extension=De,this._apiDeprecation=Le,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,q,J,ae){const ge=this._documents.getDocument(W),De=_.Selection.isISelection(q)?T.Selection.to(q):T.Range.to(q),Le=[];for(const Ce of this._diagnostics.getDiagnostics(W))if(De.intersection(Ce.range)&&Le.push(Ce)>I._maxCodeActionsPerFile)break;const pe={diagnostics:Le,only:J.only?new P.CodeActionKind(J.only):void 0,triggerKind:T.CodeActionTriggerKind.to(J.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(ge,De,pe,ae)).then(Ce=>{var Te;if(!(!(0,A.isNonEmptyArray)(Ce)||ae.isCancellationRequested)){const Ue=this._cache.add(Ce),be=new f.DisposableStore;this._disposables.set(Ue,be);const Ke=[];for(let V=0;V<Ce.length;V++){const X=Ce[V];!X||(I._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,be)})):(pe.only&&(X.kind?pe.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Ue,V],title:X.title,command:X.command&&this._commands.toInternal(X.command,be),diagnostics:X.diagnostics&&X.diagnostics.map(T.Diagnostic.from),edit:X.edit&&T.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Te=X.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:Ue,actions:Ke}}})}async resolveCodeAction(W,q){var J;const[ae,ge]=W,De=this._cache.get(ae,ge);if(!(!De||I._isCommand(De))&&!!this._provider.resolveCodeAction){const Le=(J=await this._provider.resolveCodeAction(De,q))!==null&&J!==void 0?J:De;return(Le==null?void 0:Le.edit)?T.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}I._maxCodeActionsPerFile=1e3;class F{constructor(W,q){this._documents=W,this._provider=q}provideDocumentFormattingEdits(W,q,J){const ae=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,q,J)).then(ge=>{if(Array.isArray(ge))return ge.map(T.TextEdit.from)})}}class B{constructor(W,q){this._documents=W,this._provider=q}provideDocumentRangeFormattingEdits(W,q,J,ae){const ge=this._documents.getDocument(W),De=T.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ge,De,J,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(T.TextEdit.from)})}}class le{constructor(W,q){this._documents=W,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,q,J,ae,ge){const De=this._documents.getDocument(W),Le=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Le,J,ae,ge)).then(pe=>{if(Array.isArray(pe))return pe.map(T.TextEdit.from)})}}class H{constructor(W,q){this._provider=W,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,q){const J=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(W,q)).then(ae=>{if((0,A.isNonEmptyArray)(ae)){for(const ge of ae)if(!!ge){if(!ge.name){this._logService.warn("INVALID SymbolInformation, lacks name",ge);continue}const De=k.IdObject.mixin(T.WorkspaceSymbol.from(ge));this._symbolCache.set(De._id,ge),J.symbols.push(De)}}}).then(()=>(J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J))}async resolveWorkspaceSymbol(W,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const J=this._symbolCache.get(W._id);if(J){const ae=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(J,q));return ae&&(0,S.mixin)(W,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(W){const q=this._resultCache.get(W);if(q){for(let[J,ae]=q;J<=ae;J++)this._symbolCache.delete(J);this._resultCache.delete(W)}}}class z{constructor(W,q,J){this._documents=W,this._provider=q,this._logService=J}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,q,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(ge,De,J,ae)).then(Le=>{if(!!Le)return T.WorkspaceEdit.from(Le)},Le=>{const pe=z._asMessage(Le);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation(W,q,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(W),ge=T.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(ae,ge,J)).then(De=>{let Le,pe;if(P.Range.isRange(De)?(Le=De,pe=ae.getText(De)):(0,C.isObject)(De)&&(Le=De.range,pe=De.placeholder),!!Le){if(Le.start.line>ge.line||Le.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Le),text:pe}}},De=>{const Le=z._asMessage(De);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class K{constructor(W,q){this.resultId=W,this.tokens=q}}class L{constructor(W,q){this._documents=W,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,q,J){const ae=this._documents.getDocument(W),ge=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>ge&&typeof ge.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,ge.resultId,J):this._provider.provideDocumentSemanticTokens(ae,J)).then(De=>(ge&&this._previousResults.delete(q),De?(De=L._fixProvidedSemanticTokens(De),this._send(L._convertToEdits(ge,De),De)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return L._isSemanticTokens(W)?L._isCorrectSemanticTokens(W)?W:new P.SemanticTokens(new Uint32Array(W.data),W.resultId):L._isSemanticTokensEdits(W)?L._isCorrectSemanticTokensEdits(W)?W:new P.SemanticTokensEdits(W.edits.map(q=>new P.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const q of W.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,q){if(!L._isSemanticTokens(q)||!W||!W.tokens)return q;const J=W.tokens,ae=J.length,ge=q.data,De=ge.length;let Le=0;const pe=Math.min(ae,De);for(;Le<pe&&J[Le]===ge[Le];)Le++;if(Le===ae&&Le===De)return new P.SemanticTokensEdits([],q.resultId);let Ce=0;const Te=pe-Le;for(;Ce<Te&&J[ae-Ce-1]===ge[De-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Le,deleteCount:ae-Le-Ce,data:ge.subarray(Le,De-Ce)}],q.resultId)}_send(W,q){if(L._isSemanticTokens(W)){const J=this._nextResultId++;return this._previousResults.set(J,new K(W.resultId,W.data)),(0,s.encodeSemanticTokensDto)({id:J,type:"full",data:W.data})}if(L._isSemanticTokensEdits(W)){const J=this._nextResultId++;return L._isSemanticTokens(q)?this._previousResults.set(J,new K(q.resultId,q.data)):this._previousResults.set(J,new K(W.resultId)),(0,s.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(W.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class ${constructor(W,q){this._documents=W,this._provider=q}provideDocumentRangeSemanticTokens(W,q,J){const ae=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(q),J)).then(ge=>ge?this._send(ge):null)}_send(W){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=$;class U{constructor(W,q,J,ae,ge){this._documents=W,this._commands=q,this._provider=J,this._apiDeprecation=ae,this._extension=ge,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,q,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(q),Le=ge.getWordRangeAtPosition(De)||new P.Range(De,De),pe=Le.with({end:De}),Ce=new m.StopWatch(!0),Te=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(ge,De,ae,T.CompletionContext.to(J)));if(!!Te&&!ae.isCancellationRequested){const Ue=Array.isArray(Te)?new P.CompletionList(Te):Te,be=U.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(be,Ke);const V=[],X={x:be,b:V,a:{replace:T.Range.from(Le),insert:T.Range.from(pe)},c:Ue.isIncomplete||void 0,d:Ce.elapsed()};for(let _e=0;_e<Ue.items.length;_e++){const Me=Ue.items[_e],He=this._convertCompletionItem(Me,[be,_e],pe,Le);V.push(He)}return X}}async resolveCompletionItem(W,q){if(typeof this._provider.resolveCompletionItem=="function"){const J=this._cache.get(...W);if(!!J){const ae=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(J,q));if(!!ae)return this._convertCompletionItem(ae,W)}}}releaseCompletionItems(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,q,J,ae){var ge;const De=this._disposables.get(q[0]);if(!De)throw Error("DisposableStore is missing...");const Le={x:q,a:(ge=W.label)!==null&&ge!==void 0?ge:"",o:W.label2,b:W.kind!==void 0?T.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(T.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(W.command,De)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=W.textEdit.newText):typeof W.insertText=="string"?Le.h=W.insertText:W.insertText instanceof P.SnippetString&&(Le.h=W.insertText.value,Le.i|=4);let pe;return W.textEdit?pe=W.textEdit.range:W.range&&(pe=W.range),P.Range.isRange(pe)?Le.j=T.Range.from(pe):pe&&(!(J==null?void 0:J.isEqual(pe.inserting))||!(ae==null?void 0:ae.isEqual(pe.replacing)))&&(Le.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Le}}class G{constructor(W,q){this._documents=W,this._provider=q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(W,q,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(q),Le=this.reviveContext(J);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(ge,De,ae,Le)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},T.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(W){let q;if(W.activeSignatureHelp){const J=T.SignatureHelp.to(W.activeSignatureHelp),ae=this._cache.get(W.activeSignatureHelp.id,0);ae?(q=ae,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return Object.assign(Object.assign({},W),{activeSignatureHelp:q})}releaseSignatureHelp(W){this._cache.delete(W)}}class N{constructor(W,q){this._documents=W,this._provider=q}provideInlineHints(W,q,J){const ae=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(q),J)).then(ge=>ge?{hints:ge.map(T.InlineHint.from)}:void 0)}}class Z{constructor(W,q){this._documents=W,this._provider=q,this._cache=new p.Cache("DocumentLink")}provideLinks(W,q){const J=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(J,q)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const ge=this._cache.add(ae),De={links:[],id:ge};for(let Le=0;Le<ae.length;Le++){const pe=T.DocumentLink.from(ae[Le]);pe.cacheId=[ge,Le],De.links.push(pe)}return De}}})}resolveLink(W,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const J=this._cache.get(...W);return J?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(J,q)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class ne{constructor(W,q){this._documents=W,this._provider=q}provideColors(W,q){const J=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(J,q)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(W,q,J){const ae=this._documents.getDocument(W),ge=T.Range.to(q.range),De=T.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:ge},J)).then(Le=>{if(!!Array.isArray(Le))return Le.map(T.ColorPresentation.from)})}}class re{constructor(W,q){this._documents=W,this._provider=q}provideFoldingRanges(W,q,J){const ae=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(ae,q,J)).then(ge=>{if(!!Array.isArray(ge))return ge.map(T.FoldingRange.from)})}}class ye{constructor(W,q,J){this._documents=W,this._provider=q,this._logService=J}provideSelectionRanges(W,q,J){const ae=this._documents.getDocument(W),ge=q.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(ae,ge,J)).then(De=>{if(!(0,A.isNonEmptyArray)(De))return[];if(De.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let pe=0;pe<ge.length;pe++){const Ce=[];Le.push(Ce);let Te=ge[pe],Ue=De[pe];for(;;){if(!Ue.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(Ue)),!Ue.parent)break;Te=Ue.range,Ue=Ue.parent}}return Le})}}class Ae{constructor(W,q){this._documents=W,this._provider=q,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(W,q,J){const ae=this._documents.getDocument(W),ge=T.Position.to(q),De=await this._provider.prepareCallHierarchy(ae,ge,J);if(!!De){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(De)?De.map(pe=>this._cacheAndConvertItem(Le,pe)):[this._cacheAndConvertItem(Le,De)]}}async provideCallsTo(W,q,J){const ae=this._itemFromCache(W,q);if(!ae)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(ae,J);if(!!ge)return ge.map(De=>({from:this._cacheAndConvertItem(W,De.from),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}async provideCallsFrom(W,q,J){const ae=this._itemFromCache(W,q);if(!ae)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(ae,J);if(!!ge)return ge.map(De=>({to:this._cacheAndConvertItem(W,De.to),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,q){var J;const ae=this._cache.get(W),ge={_sessionId:W,_itemId:ae.size.toString(36),name:q.name,detail:q.detail,kind:T.SymbolKind.from(q.kind),uri:q.uri,range:T.Range.from(q.range),selectionRange:T.Range.from(q.selectionRange),tags:(J=q.tags)===null||J===void 0?void 0:J.map(T.SymbolTag.from)};return ae.set(ge._itemId,q),ge}_itemFromCache(W,q){const J=this._cache.get(W);return J==null?void 0:J.get(q)}}class Be{constructor(W,q){this.adapter=W,this.extension=q}}class Re{constructor(W,q,J,ae,ge,De,Le){this._adapter=new Map,this._uriTransformer=q,this._proxy=W.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ae,this._diagnostics=ge,this._logService=De,this._apiDeprecation=Le}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:T.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new P.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Re._handlePool++}_withAdapter(W,q,J,ae,ge=!1){const De=this._adapter.get(W);if(!De)return Promise.resolve(ae);if(De.adapter instanceof q){let Le;De.extension&&(Le=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${q.name}'`));const pe=J(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),Te=>{ge&&Te instanceof v.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Te))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,q){const J=this._nextHandle();return this._adapter.set(J,new Be(W,q)),J}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,q,J,ae){const ge=this._addNewAdapter(new d(this._documents,J),W),De=ae&&ae.label||Re._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(q),De),this._createDisposable(ge)}$provideDocumentSymbols(W,q,J){return this._withAdapter(W,d,ae=>ae.provideDocumentSymbols(b.URI.revive(q),J),void 0)}registerCodeLensProvider(W,q,J){const ae=this._nextHandle(),ge=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Be(new c(this._documents,this._commands.converter,J),W)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(q),ge);let De=this._createDisposable(ae);if(ge!==void 0){const Le=J.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideCodeLenses(W,q,J){return this._withAdapter(W,c,ae=>ae.provideCodeLenses(b.URI.revive(q),J),void 0)}$resolveCodeLens(W,q,J){return this._withAdapter(W,c,ae=>ae.resolveCodeLens(q,J),void 0)}$releaseCodeLenses(W,q){this._withAdapter(W,c,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(W,q,J){const ae=this._addNewAdapter(new t(this._documents,J),W);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideDefinition(W,q,J,ae){return this._withAdapter(W,t,ge=>ge.provideDefinition(b.URI.revive(q),J,ae),[])}registerDeclarationProvider(W,q,J){const ae=this._addNewAdapter(new r(this._documents,J),W);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideDeclaration(W,q,J,ae){return this._withAdapter(W,r,ge=>ge.provideDeclaration(b.URI.revive(q),J,ae),[])}registerImplementationProvider(W,q,J){const ae=this._addNewAdapter(new l(this._documents,J),W);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideImplementation(W,q,J,ae){return this._withAdapter(W,l,ge=>ge.provideImplementation(b.URI.revive(q),J,ae),[])}registerTypeDefinitionProvider(W,q,J){const ae=this._addNewAdapter(new a(this._documents,J),W);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideTypeDefinition(W,q,J,ae){return this._withAdapter(W,a,ge=>ge.provideTypeDefinition(b.URI.revive(q),J,ae),[])}registerHoverProvider(W,q,J,ae){const ge=this._addNewAdapter(new i(this._documents,J),W);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(q)),this._createDisposable(ge)}$provideHover(W,q,J,ae){return this._withAdapter(W,i,ge=>ge.provideHover(b.URI.revive(q),J,ae),void 0)}registerEvaluatableExpressionProvider(W,q,J,ae){const ge=this._addNewAdapter(new u(this._documents,J),W);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(q)),this._createDisposable(ge)}$provideEvaluatableExpression(W,q,J,ae){return this._withAdapter(W,u,ge=>ge.provideEvaluatableExpression(b.URI.revive(q),J,ae),void 0)}registerInlineValuesProvider(W,q,J,ae){const ge=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new D(this._documents,J),W);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(q),ge);let Le=this._createDisposable(De);if(ge!==void 0){const pe=J.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(ge));Le=P.Disposable.from(Le,pe)}return Le}$provideInlineValues(W,q,J,ae,ge){return this._withAdapter(W,D,De=>De.provideInlineValues(b.URI.revive(q),J,ae,ge),void 0)}registerDocumentHighlightProvider(W,q,J){const ae=this._addNewAdapter(new R(this._documents,J),W);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideDocumentHighlights(W,q,J,ae){return this._withAdapter(W,R,ge=>ge.provideDocumentHighlights(b.URI.revive(q),J,ae),void 0)}registerLinkedEditingRangeProvider(W,q,J){const ae=this._addNewAdapter(new g(this._documents,J),W);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideLinkedEditingRanges(W,q,J,ae){return this._withAdapter(W,g,async ge=>{const De=await ge.provideLinkedEditingRanges(b.URI.revive(q),J,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Re._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(W,q,J){const ae=this._addNewAdapter(new w(this._documents,J),W);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideReferences(W,q,J,ae,ge){return this._withAdapter(W,w,De=>De.provideReferences(b.URI.revive(q),J,ae,ge),void 0)}registerCodeActionProvider(W,q,J,ae){var ge,De;const Le=new f.DisposableStore,pe=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,J,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(q),{providedKinds:(ge=ae==null?void 0:ae.providedCodeActionKinds)===null||ge===void 0?void 0:ge.map(Ce=>Ce.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Re._extLabel(W),Boolean(J.resolveCodeAction)),Le.add(this._createDisposable(pe)),Le}$provideCodeActions(W,q,J,ae,ge){return this._withAdapter(W,I,De=>De.provideCodeActions(b.URI.revive(q),J,ae,ge),void 0)}$resolveCodeAction(W,q,J){return this._withAdapter(W,I,ae=>ae.resolveCodeAction(q,J),void 0)}$releaseCodeActions(W,q){this._withAdapter(W,I,J=>Promise.resolve(J.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(W,q,J){const ae=this._addNewAdapter(new F(this._documents,J),W);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(q),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(W,q,J,ae){return this._withAdapter(W,F,ge=>ge.provideDocumentFormattingEdits(b.URI.revive(q),J,ae),void 0)}registerDocumentRangeFormattingEditProvider(W,q,J){const ae=this._addNewAdapter(new B(this._documents,J),W);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(q),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(W,q,J,ae,ge){return this._withAdapter(W,B,De=>De.provideDocumentRangeFormattingEdits(b.URI.revive(q),J,ae,ge),void 0)}registerOnTypeFormattingEditProvider(W,q,J,ae){const ge=this._addNewAdapter(new le(this._documents,J),W);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(q),ae,W.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(W,q,J,ae,ge,De){return this._withAdapter(W,le,Le=>Le.provideOnTypeFormattingEdits(b.URI.revive(q),J,ae,ge,De),void 0)}registerWorkspaceSymbolProvider(W,q){const J=this._addNewAdapter(new H(q,this._logService),W);return this._proxy.$registerNavigateTypeSupport(J),this._createDisposable(J)}$provideWorkspaceSymbols(W,q,J){return this._withAdapter(W,H,ae=>ae.provideWorkspaceSymbols(q,J),{symbols:[]})}$resolveWorkspaceSymbol(W,q,J){return this._withAdapter(W,H,ae=>ae.resolveWorkspaceSymbol(q,J),void 0)}$releaseWorkspaceSymbols(W,q){this._withAdapter(W,H,J=>J.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(W,q,J){const ae=this._addNewAdapter(new z(this._documents,J,this._logService),W);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(q),z.supportsResolving(J)),this._createDisposable(ae)}$provideRenameEdits(W,q,J,ae,ge){return this._withAdapter(W,z,De=>De.provideRenameEdits(b.URI.revive(q),J,ae,ge),void 0)}$resolveRenameLocation(W,q,J,ae){return this._withAdapter(W,z,ge=>ge.resolveRenameLocation(b.URI.revive(q),J,ae),void 0)}registerDocumentSemanticTokensProvider(W,q,J,ae){const ge=this._nextHandle(),De=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ge,new Be(new L(this._documents,J),W)),this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(q),ae,De);let Le=this._createDisposable(ge);if(De){const pe=J.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Le=P.Disposable.from(Le,pe)}return Le}$provideDocumentSemanticTokens(W,q,J,ae){return this._withAdapter(W,L,ge=>ge.provideDocumentSemanticTokens(b.URI.revive(q),J,ae),null,!0)}$releaseDocumentSemanticTokens(W,q){this._withAdapter(W,L,J=>J.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(W,q,J,ae){const ge=this._addNewAdapter(new $(this._documents,J),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(q),ae),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(W,q,J,ae){return this._withAdapter(W,$,ge=>ge.provideDocumentRangeSemanticTokens(b.URI.revive(q),J,ae),null,!0)}registerCompletionItemProvider(W,q,J,ae){const ge=this._addNewAdapter(new U(this._documents,this._commands.converter,J,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(ge,this._transformDocumentSelector(q),ae,U.supportsResolving(J),`${W.identifier.value}(${ae.join("")})`),this._createDisposable(ge)}$provideCompletionItems(W,q,J,ae,ge){return this._withAdapter(W,U,De=>De.provideCompletionItems(b.URI.revive(q),J,ae,ge),void 0)}$resolveCompletionItem(W,q,J){return this._withAdapter(W,U,ae=>ae.resolveCompletionItem(q,J),void 0)}$releaseCompletionItems(W,q){this._withAdapter(W,U,J=>J.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(W,q,J,ae){const ge=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new G(this._documents,J),W);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(q),ge),this._createDisposable(De)}$provideSignatureHelp(W,q,J,ae,ge){return this._withAdapter(W,G,De=>De.provideSignatureHelp(b.URI.revive(q),J,ae,ge),void 0)}$releaseSignatureHelp(W,q){this._withAdapter(W,G,J=>J.releaseSignatureHelp(q),void 0)}registerInlineHintsProvider(W,q,J){const ae=typeof J.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new N(this._documents,J),W);this._proxy.$registerInlineHintsProvider(ge,this._transformDocumentSelector(q),ae);let De=this._createDisposable(ge);if(ae!==void 0){const Le=J.onDidChangeInlineHints(pe=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Le)}return De}$provideInlineHints(W,q,J,ae){return this._withAdapter(W,N,ge=>ge.provideInlineHints(b.URI.revive(q),J,ae),void 0)}registerDocumentLinkProvider(W,q,J){const ae=this._addNewAdapter(new Z(this._documents,J),W);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(q),typeof J.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(W,q,J){return this._withAdapter(W,Z,ae=>ae.provideLinks(b.URI.revive(q),J),void 0)}$resolveDocumentLink(W,q,J){return this._withAdapter(W,Z,ae=>ae.resolveLink(q,J),void 0)}$releaseDocumentLinks(W,q){this._withAdapter(W,Z,J=>J.releaseLinks(q),void 0)}registerColorProvider(W,q,J){const ae=this._addNewAdapter(new ne(this._documents,J),W);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideDocumentColors(W,q,J){return this._withAdapter(W,ne,ae=>ae.provideColors(b.URI.revive(q),J),[])}$provideColorPresentations(W,q,J,ae){return this._withAdapter(W,ne,ge=>ge.provideColorPresentations(b.URI.revive(q),J,ae),void 0)}registerFoldingRangeProvider(W,q,J){const ae=this._nextHandle(),ge=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Be(new re(this._documents,J),W)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(q),ge);let De=this._createDisposable(ae);if(ge!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideFoldingRanges(W,q,J,ae){return this._withAdapter(W,re,ge=>ge.provideFoldingRanges(b.URI.revive(q),J,ae),void 0)}registerSelectionRangeProvider(W,q,J){const ae=this._addNewAdapter(new ye(this._documents,J,this._logService),W);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$provideSelectionRanges(W,q,J,ae){return this._withAdapter(W,ye,ge=>ge.provideSelectionRanges(b.URI.revive(q),J,ae),[])}registerCallHierarchyProvider(W,q,J){const ae=this._addNewAdapter(new Ae(this._documents,J),W);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(q)),this._createDisposable(ae)}$prepareCallHierarchy(W,q,J,ae){return this._withAdapter(W,Ae,ge=>Promise.resolve(ge.prepareSession(b.URI.revive(q),J,ae)),void 0)}$provideCallHierarchyIncomingCalls(W,q,J,ae){return this._withAdapter(W,Ae,ge=>ge.provideCallsTo(q,J,ae),void 0)}$provideCallHierarchyOutgoingCalls(W,q,J,ae){return this._withAdapter(W,Ae,ge=>ge.provideCallsFrom(q,J,ae),void 0)}$releaseCallHierarchy(W,q){this._withAdapter(W,Ae,J=>Promise.resolve(J.releaseSession(q)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,E.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Re._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Re._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Re._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Re._serializeRegExp(W.beforeText),afterText:W.afterText?Re._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Re._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Re._serializeOnEnterRule)}setLanguageConfiguration(W,q,J){let{wordPattern:ae}=J;if(ae&&(0,E.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(q,ae):this._documents.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const ge=this._nextHandle(),De={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Re._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Re._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Re._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,q,De),this._createDisposable(ge)}$setWordDefinitions(W){for(const q of W)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(we[195],Ee([0,1,5,9,7]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(k,E){this._proxy=k.getProxy(b.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,E){await this._proxy.$changeLanguage(k,E);const n=this._documents.getDocumentData(k);if(!n)throw new Error(`document '${k.toString}' NOT found`);return n.document}async tokenAtPosition(k,E){var n;const A=k.version,C=S.Position.from(E),_=await this._proxy.$tokensAtPosition(k.uri,C),f={type:T.StandardTokenType.Other,range:(n=k.getWordRangeAtPosition(E))!==null&&n!==void 0?n:new T.Range(E.line,E.character,E.line,E.character)};if(!_)return f;const s={range:S.Range.to(_.range),type:S.TokenType.to(_.type)};return!s.range.contains(E)||A!==k.version?f:s}}e.ExtHostLanguages=P}),define(we[196],Ee([0,1,5,19,34]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(k){return k&&k.title}let y=class{constructor(E,n){this._logService=n,this._proxy=E.getProxy(b.MainContext.MainThreadMessageService)}showMessage(E,n,A,C,_){const f={extension:E};let s;typeof C=="string"||P(C)?s=[C,..._]:(f.modal=C&&C.modal,f.useCustom=C&&C.useCustom,s=_),f.useCustom&&(0,T.checkProposedApiEnabled)(E);const h=[];for(let p=0;p<s.length;p++){const m=s[p];if(typeof m=="string")h.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:v,isCloseAffordance:d}=m;h.push({title:v,isCloseAffordance:!!d,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(n,A,f,h).then(p=>{if(typeof p=="number")return s[p]})}};y=je([qe(1,S.ILogService)],y),e.ExtHostMessageService=y}),define(we[197],Ee([0,1,20,3,6,2,29,5,9,7,69,70,22,174,175,53,12,56]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class v extends T.Disposable{constructor(i,u,D,R,g){super();this._editorId=i,this.uri=u,this._proxy=D,this._webviewInitData=R,this.document=g,this._onDidReceiveDocumentMessage=new S.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:w=>this._proxy.$postMessage(this._editorId,void 0,w),asWebviewUri:w=>this._asWebviewUri(w)}}onDidReceiveMessage(i,u){var D;this._onDidReceiveDocumentMessage.fire(u),i!==void 0&&((D=this._rendererIdToEmitters.get(i))===null||D===void 0||D.fire(u))}getRendererComm(i){const u=new S.Emitter;return this._rendererIdToEmitters.set(i,u),{editorId:this._editorId,onDidReceiveMessage:u.event,postMessage:D=>this._proxy.$postMessage(this._editorId,i,D),asWebviewUri:D=>this._asWebviewUri(D)}}_asWebviewUri(i){return(0,A.asWebviewUri)(this._webviewInitData,this._editorId,i)}}class d extends T.Disposable{constructor(i,u,D,R){super();this._proxy=i,this._handle=u,this._extension=D,this._provider=R,this._kernelToFriendlyId=new _.ResourceMap,this._friendlyIdToKernel=new _.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(g=>{const w=g==null?void 0:g.uri;this._proxy.$onNotebookKernelChange(this._handle,w)}))}async provideKernels(i,u){const D=await this._provider.provideKernels(i.notebookDocument,u)||[],R=new Map;let g=0;const w=new Set,I=this._kernelToFriendlyId.get(i.uri),F=D.map(le=>{let H=I==null?void 0:I.get(le);return H===void 0&&(le.id&&w.has(le.id)?H=`${this._extension.identifier.value}_${le.id}_${g++}`:H=`${this._extension.identifier.value}_${le.id||y.generateUuid()}`),R.set(le,H),{id:le.id,friendlyId:H,label:le.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:le.description,detail:le.detail,isPreferred:le.isPreferred,preloads:le.preloads,supportedLanguages:le.supportedLanguages}});this._kernelToFriendlyId.set(i.uri,R);const B=new Map;return R.forEach((le,H)=>{B.set(le,H)}),this._friendlyIdToKernel.set(i.uri,B),F}getKernelByFriendlyId(i,u){var D;return(D=this._friendlyIdToKernel.get(i))===null||D===void 0?void 0:D.get(u)}async resolveNotebook(i,u,D,R){var g;const w=(g=this._friendlyIdToKernel.get(u.uri))===null||g===void 0?void 0:g.get(i);if(w&&this._provider.resolveKernel)return this._provider.resolveKernel(w,u.notebookDocument,D,R)}async executeNotebook(i,u,D){var R;const g=(R=this._friendlyIdToKernel.get(u.uri))===null||R===void 0?void 0:R.get(i);if(!!g)return c(D?w=>g.executeCell(u.notebookDocument,D.cell,w):w=>g.executeAllCells(u.notebookDocument,w))}async cancelNotebook(i,u,D){var R;const g=(R=this._friendlyIdToKernel.get(u.uri))===null||R===void 0?void 0:R.get(i);if(!!g)return D?g.cancelCellExecution(u.notebookDocument,D.cell):g.cancelAllCellsExecution(u.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;async function c(a){const i=new b.CancellationTokenSource;try{await a(i.token)}finally{i.dispose()}}class o{constructor(i,u){const D=o._Keys.nextId();i.$registerNotebookEditorDecorationType(D,E.NotebookDecorationRenderOptions.from(u)),this.value={key:D,dispose(){i.$removeNotebookEditorDecorationType(D)}}}}e.NotebookEditorDecorationType=o,o._Keys=new h.IdGenerator("NotebookEditorDecorationType");class t{constructor(i,u,D,R,g,w,I){this._textDocumentsAndEditors=D,this._textDocuments=R,this._webviewInitData=g,this.logService=w,this._extensionStoragePaths=I,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new S.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new S.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new S.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new S.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new S.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new S.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new S.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new S.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new S.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=i.getProxy(k.MainContext.MainThreadNotebook),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:F=>{var B;if(F&&F.$mid===12){const le=(B=F.notebookEditor)===null||B===void 0?void 0:B.notebookUri,H=F.cell.handle,z=this._documents.get(le),K=z==null?void 0:z.getCell(H);if(K)return K.cell}return F}})}get activeNotebookEditor(){var i;return(i=this._activeNotebookEditor)===null||i===void 0?void 0:i.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(i=>i.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(i){return this._documents.get(i)}_getNotebookDocument(i){const u=this._documents.get(i);if(!u)throw new Error(`NO notebook document for '${i}'`);return u}_getProviderData(i){const u=this._notebookContentProviders.get(i);if(!u)throw new Error(`NO provider for '${i}'`);return u}registerNotebookContentProvider(i,u,D,R){var g,w,I;if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:i,provider:D});let F;D.onDidChangeNotebookContentOptions&&(F=D.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(u,D.options)}));const B=(g=R==null?void 0:R.viewOptions)===null||g===void 0?void 0:g.filenamePattern.map(le=>E.NotebookExclusiveDocumentPattern.from(le)).filter(le=>le!==void 0);return((w=R==null?void 0:R.viewOptions)===null||w===void 0?void 0:w.filenamePattern)&&!B&&console.warn(`Notebook content provider view options file name pattern is invalid ${(I=R==null?void 0:R.viewOptions)===null||I===void 0?void 0:I.filenamePattern}`),this._proxy.$registerNotebookProvider({id:i.identifier,location:i.extensionLocation,description:i.description},u,{transientOutputs:(R==null?void 0:R.transientOutputs)||!1,transientMetadata:(R==null?void 0:R.transientMetadata)||{},viewOptions:(R==null?void 0:R.viewOptions)&&B?{displayName:R.viewOptions.displayName,filenamePattern:B,exclusive:R.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{F==null||F.dispose(),this._notebookContentProviders.delete(u),this._proxy.$unregisterNotebookProvider(u)})}registerNotebookKernelProvider(i,u,D){const R=t._notebookKernelProviderHandlePool++,g=new d(this._proxy,R,i,D);return this._notebookKernelProviders.set(R,g),this._proxy.$registerNotebookKernelProvider({id:i.identifier,location:i.extensionLocation,description:i.description},R,{viewType:u.viewType,filenamePattern:u.filenamePattern?E.NotebookExclusiveDocumentPattern.from(u.filenamePattern):void 0}),new n.Disposable(()=>{g.dispose(),this._notebookKernelProviders.delete(R),this._proxy.$unregisterNotebookKernelProvider(R)})}createNotebookEditorDecorationType(i){return new o(this._proxy,i).value}async openNotebookDocument(i){const u=this._documents.get(i);if(u)return u.notebookDocument;const D=await this._proxy.$tryOpenDocument(i),R=this._documents.get(P.URI.revive(D));return(0,p.assertIsDefined)(R==null?void 0:R.notebookDocument)}_withAdapter(i,u,D){const R=this._documents.get(P.URI.revive(u));if(!R)return[];const g=this._notebookKernelProviders.get(i);return g?D(g,R):[]}async showNotebookDocument(i,u){var D;P.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let R;typeof u=="object"?R={position:E.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:u.selection&&E.NotebookCellRange.from(u.selection),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:R={preserveFocus:!1};const g=await this._proxy.$tryShowNotebookDocument(i.uri,i.viewType,R),w=g&&((D=this._editors.get(g))===null||D===void 0?void 0:D.editor);if(w)return w.editor;throw g?new Error(`Could NOT open editor for "${i.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.toString()}".`)}async $provideNotebookKernels(i,u,D){return this._withAdapter(i,u,(R,g)=>R.provideKernels(g,D))}async $resolveNotebookKernel(i,u,D,R,g){await this._withAdapter(i,D,async(w,I)=>{const F=this._webviewComm.get(u);F&&await w.resolveNotebook(R,I,F.contentProviderComm,g)})}async $resolveNotebookEditor(i,u,D){const R=this._notebookContentProviders.get(i),g=P.URI.revive(u),w=this._documents.get(g);if(!(!w||!R)){let I=this._webviewComm.get(D);I||(I=new v(D,g,this._proxy,this._webviewInitData,w),this._webviewComm.set(D,I)),!!R.provider.resolveNotebook&&await R.provider.resolveNotebook(w.notebookDocument,I.contentProviderComm)}}async $executeNotebookKernelFromProvider(i,u,D,R){await this._withAdapter(i,u,async(g,w)=>{const I=R!==void 0?w.getCell(R):void 0;return g.executeNotebook(D,w,I)})}async $cancelNotebookKernelFromProvider(i,u,D,R){await this._withAdapter(i,u,async(g,w)=>{const I=R!==void 0?w.getCell(R):void 0;return g.cancelNotebook(D,w,I)})}async $openNotebook(i,u,D,R,g){const{provider:w}=this._getProviderData(i),I=await w.openNotebook(P.URI.revive(u),{backupId:D,untitledDocumentData:g==null?void 0:g.buffer},R);return{metadata:E.NotebookDocumentMetadata.from(I.metadata),cells:I.cells.map(E.NotebookCellData.from)}}async $saveNotebook(i,u,D){const R=this._getNotebookDocument(P.URI.revive(u)),{provider:g}=this._getProviderData(i);return await g.saveNotebook(R.notebookDocument,D),!0}async $saveNotebookAs(i,u,D,R){const g=this._getNotebookDocument(P.URI.revive(u)),{provider:w}=this._getProviderData(i);return await w.saveNotebookAs(P.URI.revive(D),g.notebookDocument,R),!0}async $backupNotebook(i,u,D){var R;const g=this._getNotebookDocument(P.URI.revive(u)),w=this._getProviderData(i),I=(R=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&R!==void 0?R:this._extensionStoragePaths.globalValue(w.extension),F=String((0,m.hash)([g.uri.toString(),this._backupIdPool++])),B=P.URI.joinPath(I,F),le=await w.provider.backupNotebook(g.notebookDocument,{destination:B},D);return g.updateBackup(le),le.id}$acceptNotebookActiveKernelChange(i){i.providerHandle!==void 0&&this._withAdapter(i.providerHandle,i.uri,async(u,D)=>{const R=i.kernelFriendlyId?u.getKernelByFriendlyId(P.URI.revive(i.uri),i.kernelFriendlyId):void 0;this._editors.forEach(g=>{g.editor.notebookData===D&&g.editor._acceptKernel(R)}),this._onDidChangeActiveNotebookKernel.fire({document:D.notebookDocument,kernel:R})})}$onDidReceiveMessage(i,u,D){var R;(R=this._webviewComm.get(i))===null||R===void 0||R.onDidReceiveMessage(u,D)}$acceptModelChanged(i,u,D){this._getNotebookDocument(P.URI.revive(i)).acceptModelChanged(u,D)}$acceptDirtyStateChanged(i,u){const D=this._getNotebookDocument(P.URI.revive(i));D.acceptModelChanged({rawEvents:[],versionId:D.notebookDocument.version},u)}$acceptModelSaved(i){const u=this._getNotebookDocument(P.URI.revive(i));this._onDidSaveNotebookDocument.fire(u.notebookDocument)}$acceptEditorPropertiesChanged(i,u){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",i,u);const D=this._editors.get(i);if(!D)throw new Error(`unknown text editor: ${i}`);u.visibleRanges&&D.editor._acceptVisibleRanges(u.visibleRanges.ranges.map(E.NotebookCellRange.to)),u.selections&&D.editor._acceptSelections(u.selections.selections.map(E.NotebookCellRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.editor.editor,visibleRanges:D.editor.editor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.editor.editor,selections:D.editor.editor.selections}))}$acceptDocumentPropertiesChanged(i,u){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",i.path,u);const D=this._getNotebookDocument(P.URI.revive(i));D.acceptDocumentPropertiesChanged(u),u.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.notebookDocument})}_createExtHostEditor(i,u,D){var R;const g=i.uri;let w=this._webviewComm.get(u);w||(w=new v(u,g,this._proxy,this._webviewInitData,i),this._webviewComm.set(u,w));const I=new s.ExtHostNotebookEditor(u,i.notebookDocument.viewType,this._proxy,i,D.visibleRanges.map(E.NotebookCellRange.to),D.selections.map(E.NotebookCellRange.to),typeof D.viewColumn=="number"?E.ViewColumn.to(D.viewColumn):void 0);(R=this._editors.get(u))===null||R===void 0||R.editor.dispose(),this._editors.set(u,{editor:I})}$acceptDocumentAndEditorsDelta(i){var u,D,R,g;let w=!1;if(i.removedDocuments)for(const F of i.removedDocuments){const B=P.URI.revive(F),le=this._documents.get(B);le&&(le.dispose(),this._documents.delete(B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:le.notebookDocument.cells.map(H=>H.document.uri)}),this._onDidCloseNotebookDocument.fire(le.notebookDocument));for(const H of this._editors.values())H.editor.notebookData.uri.toString()===B.toString()&&(H.editor.dispose(),this._editors.delete(H.editor.id),w=!0)}if(i.addedDocuments){const F=[];for(const B of i.addedDocuments){const le=P.URI.revive(B.uri),H=B.viewType;if(this._documents.has(le))throw new Error(`adding EXISTING notebook ${le}`);const z=this,K=new f.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){z._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){z._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){z._onDidChangeCellMetadata.fire(L)}},H,B.metadata?E.NotebookDocumentMetadata.to(B.metadata):new n.NotebookDocumentMetadata,le);K.acceptModelChanged({versionId:B.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,B.cells]]}]},!1),F.push(...B.cells.map(L=>f.ExtHostCell.asModelAddData(K.notebookDocument,L))),(u=this._documents.get(le))===null||u===void 0||u.dispose(),this._documents.set(le,K),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this._onDidOpenNotebookDocument.fire(K.notebookDocument)}}if(i.addedEditors)for(const F of i.addedEditors){if(this._editors.has(F.id))return;const B=P.URI.revive(F.documentUri),le=this._documents.get(B);le&&(this._createExtHostEditor(le,F.id,F),w=!0)}const I=[];if(i.removedEditors)for(const F of i.removedEditors){const B=this._editors.get(F);B&&(w=!0,this._editors.delete(F),((D=this._activeNotebookEditor)===null||D===void 0?void 0:D.id)===B.editor.id&&(this._activeNotebookEditor=void 0),I.push(B))}if(w&&I.forEach(F=>{F.editor.dispose()}),i.visibleEditors){this._visibleNotebookEditors=i.visibleEditors.map(B=>this._editors.get(B).editor).filter(B=>!!B);const F=new Set;this._visibleNotebookEditors.forEach(B=>F.add(B.id));for(const B of this._editors.values()){const le=F.has(B.editor.id);B.editor._acceptVisibility(le)}this._visibleNotebookEditors=[...this._editors.values()].map(B=>B.editor).filter(B=>B.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}i.newActiveEditor===null?this._activeNotebookEditor=void 0:i.newActiveEditor&&(this._activeNotebookEditor=(R=this._editors.get(i.newActiveEditor))===null||R===void 0?void 0:R.editor),i.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.editor)}createNotebookCellStatusBarItemInternal(i,u,D){const R=new r(this._proxy,this._commandsConverter,i,u,D),g=C.CellUri.parse(i.document.uri);if(g){const w=this._documents.get(g.notebook);if(w){const I=w.getCell(g.handle);I&&S.Event.once(I.onDidDispose)(()=>R.dispose())}}return R}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends T.Disposable{constructor(i,u,D,R,g){super();this._proxy=i,this._commands=u,this._cell=D,this._priority=g,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=R!=null?R:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=l(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(i){this._alignment=i,this.update()}get priority(){return this._priority}set priority(i){this._priority=i,this.update()}get text(){return this._text}set text(i){this._text=i,this.update()}get tooltip(){return this._tooltip}set tooltip(i){this._tooltip=i,this.update()}get command(){var i;return(i=this._command)===null||i===void 0?void 0:i.fromApi}set command(i){var u;((u=this._command)===null||u===void 0?void 0:u.fromApi)!==i&&(this._internalCommandRegistration.clear(),typeof i=="string"?this._command={fromApi:i,internal:this._commands.toInternal({title:"",command:i},this._internalCommandRegistration)}:i?this._command={fromApi:i,internal:this._commands.toInternal(i,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(i){this._accessibilityInformation=i,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var i;if(!this._isDisposed){const u={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(i=this._command)===null||i===void 0?void 0:i.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,u)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function l(a){return Object.freeze({cell:a.cell,get alignment(){return a.alignment},set alignment(i){a.alignment=i},get priority(){return a.priority},set priority(i){a.priority=i},get text(){return a.text},set text(i){a.text=i},get tooltip(){return a.tooltip},set tooltip(i){a.tooltip=i},get command(){return a.command},set command(i){a.command=i},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i},show(){a.show()},hide(){a.hide()},dispose(){a.dispose()}})}}),define(we[98],Ee([0,1,5,3,6,26,4,14]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends T.Disposable{constructor(s,h,p,m){super();this._onDidAppend=this._register(new S.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=m,this._id=m.$register(this.name,h,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?P.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(h=>this._proxy.$clear(h,s))}show(s,h){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:h)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class n extends E{constructor(s,h){super(s,!1,void 0,h)}append(s){super.append(s),this._id.then(h=>this._proxy.$append(h,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class A extends E{constructor(s,h,p){super(s,!0,h,p)}append(s){throw new Error("Not supported")}}class C{constructor(s,h){this.name=s,this._channel=h}append(s){this._channel.then(h=>h.append(s))}appendLine(s){this._channel.then(h=>h.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,h){this._channel.then(p=>p.show(s,h))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=C;let _=class{constructor(s){this._proxy=s.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,h){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new A(s,h,this._proxy)}};_=je([qe(0,k.IExtHostRpcService)],_),e.ExtHostOutputService=_,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(we[198],Ee([0,1,13,20,3,6,5,2,7,10,15,47]),function(oe,e,b,S,T,P,y,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(f,s,h){const p=f.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(a,i){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=i}showQuickPick(a,i,u,D=S.CancellationToken.None){this._onDidSelectItem=void 0;const R=Promise.resolve(a),g=++this._instances,w=p.$show(g,{title:u==null?void 0:u.title,placeHolder:u==null?void 0:u.placeHolder,matchOnDescription:u==null?void 0:u.matchOnDescription,matchOnDetail:u==null?void 0:u.matchOnDetail,ignoreFocusLost:u==null?void 0:u.ignoreFocusOut,canPickMany:u==null?void 0:u.canPickMany},D),I={},F=w.then(()=>I);return Promise.race([F,R]).then(B=>{if(B!==I)return R.then(le=>{const H=[];for(let z=0;z<le.length;z++){const K=le[z];let L,$,U,G,N;typeof K=="string"?L=K:(L=K.label,$=K.description,U=K.detail,G=K.picked,N=K.alwaysShow),H.push({label:L,description:$,handle:z,detail:U,picked:G,alwaysShow:N})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{u.onDidSelectItem(le[z])}),p.$setItems(g,H),w.then(z=>{if(typeof z=="number")return le[z];if(Array.isArray(z))return z.map(K=>le[K])})})}).then(void 0,B=>{if(!(0,n.isPromiseCanceledError)(B))return p.$setError(g,B),Promise.reject(B)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,i=S.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,p.$input(a,typeof this._validateInput=="function",i).then(void 0,u=>{if(!(0,n.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(a){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,i=S.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!u){const D=await this._workspace.getWorkspaceFolders2();if(!!D)return D.find(R=>R.uri.toString()===u.uri.toString())}}createQuickPick(a,i){const u=new t(a,i,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(a){const i=new r(a,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}$onDidChangeValue(a,i){const u=this._sessions.get(a);u&&u._fireDidChangeValue(i)}$onDidAccept(a){const i=this._sessions.get(a);i&&i._fireDidAccept()}$onDidChangeActive(a,i){const u=this._sessions.get(a);u instanceof t&&u._fireDidChangeActive(i)}$onDidChangeSelection(a,i){const u=this._sessions.get(a);u instanceof t&&u._fireDidChangeSelection(i)}$onDidTriggerButton(a,i){const u=this._sessions.get(a);u&&u._fireDidTriggerButton(i)}$onDidHide(a){const i=this._sessions.get(a);i&&i._fireDidHide()}}class v{constructor(a,i){this._extensionId=a,this._onDidDispose=i,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((i,u)=>{const D=i===E.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(D,i)}),this.update({buttons:a.map((i,u)=>({iconPath:d(i.iconPath),tooltip:i.tooltip,handle:i===E.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const i=this._handlesToButtons.get(a);i&&this._onDidTriggerButtonEmitter.fire(i)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(a){if(!this._disposed){for(const i of Object.keys(a)){const u=a[i];this._pendingUpdate[i]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function d(l){if(l instanceof E.ThemeIcon)return{id:l.id};const a=o(l),i=c(l);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof i=="string"?k.URI.file(i):i}}function c(l){return typeof l=="object"&&"light"in l?l.light:l}function o(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends v{constructor(a,i,u){super(a,u);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((i,u)=>{this._handlesToItems.set(u,i),this._itemsToHandles.set(i,u)}),this.update({items:a.map((i,u)=>({label:i.label,description:i.description,handle:u,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(i=>this._itemsToHandles.has(i)),this.update({activeItems:this._activeItems.map(i=>this._itemsToHandles.get(i))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(i=>this._itemsToHandles.has(i)),this.update({selectedItems:this._selectedItems.map(i=>this._itemsToHandles.get(i))})}_fireDidChangeActive(a){const i=(0,A.coalesce)(a.map(u=>this._handlesToItems.get(u)));this._activeItems=i,this._onDidChangeActiveEmitter.fire(i)}_fireDidChangeSelection(a){const i=(0,A.coalesce)(a.map(u=>this._handlesToItems.get(u)));this._selectedItems=i,this._onDidChangeSelectionEmitter.fire(i)}}class r extends v{constructor(a,i){super(a,i);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?C.default.Error:C.default.Ignore})}}return new m(s,h)}e.createExtHostQuickOpen=_}),define(we[199],Ee([0,1,2,3,44,6,13,5,15,109,19,25,34]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?b.URI.file(a.iconPath):a.iconPath}function s(a,i){if(!a.iconPath&&!i.iconPath)return 0;if(a.iconPath){if(!i.iconPath)return 1}else return-1;const u=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,D=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath;return(0,n.comparePaths)(u,D)}function h(a,i){let u=0;if(a.strikeThrough!==i.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==i.faded)return a.faded?1:-1;if(a.tooltip!==i.tooltip)return(a.tooltip||"").localeCompare(i.tooltip||"");if(u=s(a,i),u!==0)return u;if(a.light&&i.light)u=s(a.light,i.light);else{if(a.light)return 1;if(i.light)return-1}if(u!==0)return u;if(a.dark&&i.dark)u=s(a.dark,i.dark);else{if(a.dark)return 1;if(i.dark)return-1}return u}function p(a,i){if(a.command!==i.command)return a.command<i.command?-1:1;if(a.title!==i.title)return a.title<i.title?-1:1;if(a.tooltip!==i.tooltip){if(a.tooltip!==void 0&&i.tooltip!==void 0)return a.tooltip<i.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(a.arguments===i.arguments)return 0;if(a.arguments)if(i.arguments){if(a.arguments.length!==i.arguments.length)return a.arguments.length-i.arguments.length}else return 1;else return-1;for(let u=0;u<a.arguments.length;u++){const D=a.arguments[u],R=i.arguments[u];if(D!==R)return D<R?-1:1}return 0}function m(a,i){let u=(0,n.comparePaths)(a.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(u!==0)return u;if(a.command&&i.command)u=p(a.command,i.command);else{if(a.command)return 1;if(i.command)return-1}if(u!==0)return u;if(a.decorations&&i.decorations)u=h(a.decorations,i.decorations);else{if(a.decorations)return 1;if(i.decorations)return-1}return u}function v(a,i){for(let u=0;u<a.length;u++)if(a[u]!==i[u])return!1;return!0}function d(a,i){return a.command===i.command&&a.title===i.title&&a.tooltip===i.tooltip&&(a.arguments&&i.arguments?v(a.arguments,i.arguments):a.arguments===i.arguments)}function c(a,i){return(0,E.equals)(a,i,d)}class o{constructor(i,u,D){this._extension=i,this._proxy=u,this._sourceControlHandle=D,this._value="",this._onDidChange=new S.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(i){this._proxy.$setInputBoxValue(this._sourceControlHandle,i),this.updateValue(i)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(i){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,i),this._placeholder=i}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(i){if((0,_.checkProposedApiEnabled)(this._extension),i&&typeof i!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=i,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!i)}get visible(){return this._visible}set visible(i){i=!!i,this._visible!==i&&(this._visible=i,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,i))}$onInputBoxValueChange(i){this.updateValue(i)}updateValue(i){this._value=i,this._onDidChange.fire(i)}}e.ExtHostSCMInputBox=o;class t{constructor(i,u,D,R,g){this._proxy=i,this._commands=u,this._sourceControlHandle=D,this._id=R,this._label=g,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new S.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new S.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(i){this._label=i,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,i)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(i){this._hideWhenEmpty=i,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(i){this._resourceStates=[...i],this._onDidUpdateResourceStates.fire()}getResourceState(i){return this._resourceStatesMap.get(i)}$executeResourceCommand(i,u){const D=this._resourceStatesCommandsMap.get(i);return D?(0,y.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],u)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var i;const u=[...this._resourceStates].sort(m),R=(0,E.sortedDiff)(this._resourceSnapshot,u,m).map(I=>{const F=I.toInsert.map(B=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,B);const H=B.resourceUri,z=f(B.decorations),K=B.decorations&&f(B.decorations.light)||z,L=B.decorations&&f(B.decorations.dark)||z,$=[];let U;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ye=new P.DisposableStore;U=this._commands.converter.toInternal(B.command,ye),this._resourceStatesDisposablesMap.set(le,ye)}else this._resourceStatesCommandsMap.set(le,B.command);K&&$.push(K),L&&L.toString()!==(K==null?void 0:K.toString())&&$.push(L);const G=B.decorations&&B.decorations.tooltip||"",N=B.decorations&&!!B.decorations.strikeThrough,Z=B.decorations&&!!B.decorations.faded,ne=B.contextValue||"";return{rawResource:[le,H,$,G,N,Z,ne,U],handle:le}});return{start:I.start,deleteCount:I.deleteCount,toInsert:F}}),g=R.map(({start:I,deleteCount:F,toInsert:B})=>[I,F,B.map(le=>le.rawResource)]),w=R.reverse();for(const{start:I,deleteCount:F,toInsert:B}of w){const le=B.map(z=>z.handle),H=this._handlesSnapshot.splice(I,F,...le);for(const z of H)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(i=this._resourceStatesDisposablesMap.get(z))===null||i===void 0||i.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=u,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(i,u,D,R,g,w){this._proxy=u,this._commands=D,this._id=R,this._label=g,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new S.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(i,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,R,g,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(i){this._count!==i&&(this._count=i,this._proxy.$updateSourceControl(this.handle,{count:i}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(i){this._quickDiffProvider=i,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!i})}get commitTemplate(){return this._commitTemplate}set commitTemplate(i){i!==this._commitTemplate&&(this._commitTemplate=i,this._proxy.$updateSourceControl(this.handle,{commitTemplate:i}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(i){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=i;const u=this._commands.converter.toInternal(i,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:u})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(i){if(!(this._statusBarCommands&&i&&c(this._statusBarCommands,i))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=i;const u=(i||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:u})}}get selected(){return this._selected}createResourceGroup(i,u){const D=new t(this._proxy,this._commands,this.handle,i,u),R=S.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,R),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const i=[],u=[];for(const[D,R]of this.createdResourceGroups){R.dispose();const g=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});S.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),g.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),i.push([D.handle,D.id,D.label,D.features]);const w=D._takeResourceStateSnapshot();w.length>0&&u.push([D.handle,w]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,i,u),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const i=[];this.updatedResourceGroups.forEach(u=>{const D=u._takeResourceStateSnapshot();D.length!==0&&i.push([u.handle,D])}),i.length>0&&this._proxy.$spliceResourceStates(this.handle,i),this.updatedResourceGroups.clear()}getResourceGroup(i){return this._groups.get(i)}setSelectionState(i){this._selected=i,this._onDidChangeSelection.fire(i)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(i=>i.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,T.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let l=class Dn{constructor(i,u,D){this._commands=u,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new S.Emitter,this._proxy=i.getProxy(k.MainContext.MainThreadSCM),this._telemetry=i.getProxy(k.MainContext.MainThreadTelemetry),u.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const g=this._sourceControls.get(R.sourceControlHandle);if(!g)return R;const w=g.getResourceGroup(R.groupHandle);return w?w.getResourceState(R.handle):R}else if(R&&R.$mid===4){const g=this._sourceControls.get(R.sourceControlHandle);return g?g.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const g=this._sourceControls.get(R.handle);return g||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(i,u,D,R){this.logService.trace("ExtHostSCM#createSourceControl",i.identifier.value,u,D,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const g=Dn._handlePool++,w=new r(i,this._proxy,this._commands,u,D,R);this._sourceControls.set(g,w);const I=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return I.push(w),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),I),w}getLastInputBox(i){this.logService.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const u=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(i.identifier)),D=u&&u[u.length-1];return D&&D.inputBox}$provideOriginalResource(i,u,D){const R=b.URI.revive(u);this.logService.trace("ExtHostSCM#$provideOriginalResource",i,R.toString());const g=this._sourceControls.get(i);return!g||!g.quickDiffProvider||!g.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>g.quickDiffProvider.provideOriginalResource(R,D)).then(w=>w||null)}$onInputBoxValueChange(i,u){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",i);const D=this._sourceControls.get(i);return D&&D.inputBox.$onInputBoxValueChange(u),Promise.resolve(void 0)}$executeResourceCommand(i,u,D,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",i,u,D);const g=this._sourceControls.get(i);if(!g)return Promise.resolve(void 0);const w=g.getResourceGroup(u);return w?w.$executeResourceCommand(D,R):Promise.resolve(void 0)}$validateInput(i,u,D){this.logService.trace("ExtHostSCM#$validateInput",i);const R=this._sourceControls.get(i);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>R.inputBox.validateInput(u,D)).then(g=>g?Promise.resolve([g.message,g.type]):Promise.resolve(void 0))}$setSelectedSourceControl(i){var u,D;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&((u=this._sourceControls.get(i))===null||u===void 0||u.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((D=this._sourceControls.get(this._selectedSourceControlHandle))===null||D===void 0||D.setSelectionState(!1)),this._selectedSourceControlHandle=i,Promise.resolve(void 0)}};l._handlePool=0,l=je([qe(2,A.ILogService)],l),e.ExtHostSCM=l});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[200],Ee([0,1,7,5,131,6]),function(oe,e,b,S,T,P){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class E{constructor(_,f,s,h,p=b.StatusBarAlignment.Left,m,v){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,y,_),tt(this,k,f),this._id=E.ID_GEN++,this._statusId=s,this._statusName=h,this._alignment=p,this._priority=m,this._accessibilityInformation=v}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var _;return(_=this._command)===null||_===void 0?void 0:_.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!E.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:We(this,k).toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:We(this,k).toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,y).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var _;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=E.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,y).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(_=this._command)===null||_===void 0?void 0:_.internal,f,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=E,y=new WeakMap,k=new WeakMap,E.ID_GEN=0,E.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(_){this._messages=[],this._item=_.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const f={message:_};return this._messages.unshift(f),this._update(),new b.Disposable(()=>{const s=this._messages.indexOf(f);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(_,f){this._proxy=_.getProxy(S.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(_,f,s,h,p){return new E(this._proxy,this._commands,_,f,s,h,p)}setStatusBarMessage(_,f){const s=this._statusMessage.setMessage(_);let h;return typeof f=="number"?h=setTimeout(()=>s.dispose(),f):typeof f!="undefined"&&f.then(()=>s.dispose(),()=>s.dispose()),new b.Disposable(()=>{s.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=A}),define(we[75],Ee([0,1,5,3,4]),function(oe,e,b,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(k){this._onDidChangeStorage=new S.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,E){this._proxy.$registerExtensionStorageKeysToSync(k,E)}getValue(k,E,n){return this._proxy.$getValue(k,E).then(A=>A||n)}setValue(k,E,n){return this._proxy.$setValue(k,E,n)}$acceptValue(k,E,n){this._onDidChangeStorage.fire({shared:k,key:E,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(we[76],Ee([0,1,4,27,19,74,2]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let k=class{constructor(n,A,C){var _;this._logService=A,this._extHostFileSystem=C,this._workspace=(_=n.workspace)!==null&&_!==void 0?_:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,A);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(_){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=y.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(n){if(this._value)return y.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return y.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};k=je([qe(0,S.IExtHostInitDataService),qe(1,T.ILogService),qe(2,P.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(we[41],Ee([0,1,3,5,4,2,14,6,7,132,10,167,20,29,151]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class h{constructor(t,r,l,a){this._proxy=t,this._id=r,this._creationOptions=l,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(u=>this._pidPromiseComplete=u);const i=this;this.value={get name(){return i._name||""},get processId(){return i._pidPromise},get creationOptions(){return i._creationOptions},get exitStatus(){return i._exitStatus},sendText(u,D=!0){i._checkDisposed(),i._proxy.$sendText(i._id,u,D)},show(u){i._checkDisposed(),i._proxy.$show(i._id,u)},hide(){i._checkDisposed(),i._proxy.$hide(i._id)},dispose(){i._disposed||(i._disposed=!0,i._proxy.$dispose(i._id))},get dimensions(){if(!(i._cols===void 0||i._rows===void 0))return{columns:i._cols,rows:i._rows}}}}async create(t,r,l,a,i,u,D,R,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:l,env:a,waitOnExit:i,strictEnv:u,hideFromUser:D,isFeatureTerminal:R,isExtensionOwnedTerminal:g})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,v=class extends k.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=r.getProxy(S.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new h(this._proxy,(0,f.generateUuid)(),t,t.name),l=new p(t.pty);return r.createExtensionTerminal().then(a=>{const i=this._setupExtHostProcessListeners(a,l);this._terminalProcessDisposables[a]=i}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new p(r),i=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=i}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:r})}async $acceptTerminalDimensions(t,r,l){const a=this._getTerminalById(t);a&&a.setDimensions(r,l)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,l){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(r,l)}async $acceptTerminalTitleChange(t,r){const l=this._getTerminalById(t);l&&(l.name=r)}async $acceptTerminalClosed(t,r){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const a=this._terminals.splice(l,1)[0];a.setExitCode(r),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,r,l,a){if(r){const D=this._getTerminalObjectIndexById(this._terminals,r);if(D!==null){this._terminals[D]._id=t,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const i={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:P.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},u=new h(this._proxy,t,i,l);this._terminals.push(u),this._onDidOpenTerminal.fire(u.value),u.isOpen=!0}async $acceptTerminalProcessId(t,r){const l=this._getTerminalById(t);l&&l._setProcessId(r)}async $startExtensionTerminal(t,r){const l=this._getTerminalById(t);if(!l)return{message:(0,n.localize)(0,null,t)};l.isOpen||await new Promise(i=>{const u=this.onDidOpenTerminal(async D=>{D===l.value&&(u.dispose(),i())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const l=new k.DisposableStore;l.add(r.onProcessReady(i=>this._proxy.$sendProcessReady(t,i.pid,i.cwd))),l.add(r.onProcessTitleChanged(i=>this._proxy.$sendProcessTitle(t,i))),this._bufferer.startBuffering(t,r.onProcessData),l.add(r.onProcessExit(i=>this._onProcessExit(t,i))),r.onProcessOverrideDimensions&&l.add(r.onProcessOverrideDimensions(i=>this._proxy.$sendOverrideDimensions(t,i))),this._terminalProcesses.set(t,r);const a=this._extensionTerminalAwaitingStart[t];return a&&r instanceof p&&(r.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,r){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(r)}$acceptProcessResize(t,r,l){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(r,l)}catch(i){if(i.code!=="EPIPE"&&i.code!=="ERR_IPC_CHANNEL_CLOSED")throw i}}$acceptProcessShutdown(t,r){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const i=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,i);const u=[],D={terminal:l.value,line:r},R=[];for(const I of this._linkProviders)R.push(new Promise(async F=>{i.token.onCancellationRequested(()=>F({provider:I,links:[]}));const B=await I.provideTerminalLinks(D,i.token)||[];i.token.isCancellationRequested||F({provider:I,links:B})}));const g=await Promise.all(R);if(i.token.isCancellationRequested)return[];const w=new Map;for(const I of g)I&&I.links.length>0&&u.push(...I.links.map(F=>{const B={id:m++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return w.set(B.id,{provider:I.provider,link:F}),B}));return this._terminalLinkCache.set(t,w),u}$activateLink(t,r){var l;const a=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(r);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const l=this._getTerminalObjectIndexById(t,r);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,r){let l=null;return t.some((a,i)=>a._id===r?(l=i,!0):!1),l}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new d,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const l=(0,C.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const l=r[0],a=new d(r[1]);this._setEnvironmentVariableCollection(l,a)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};v=je([qe(1,y.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:E.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const l=this.map.get(t);(!l||l.value!==r.value||l.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((l,a)=>t.call(r,a,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let c=class extends v{constructor(t){super(!1,t)}createTerminal(t,r,l){throw new A.NotSupportedError}createTerminalFromOptions(t){throw new A.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new A.NotSupportedError}$getAvailableProfiles(t){throw new A.NotSupportedError}async $getDefaultShellAndArgs(t){throw new A.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};c=je([qe(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(we[201],Ee([0,1,3,15,5,95,9,7]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(A,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const C=this._extHostDocumentsAndEditors.allEditors();return A?C:C.map(_=>_.value)}async showTextDocument(A,C,_){let f;typeof C=="number"?f={position:y.ViewColumn.from(C),preserveFocus:_}:typeof C=="object"?f={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:f={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(A.uri,f),h=s&&this._extHostDocumentsAndEditors.getEditor(s);if(h)return h.value;throw s?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A){return new P.TextEditorDecorationType(this._proxy,A).value}$acceptEditorPropertiesChanged(A,C){const _=this._extHostDocumentsAndEditors.getEditor(A);if(!_)throw new Error("unknown text editor");if(C.options&&_._acceptOptions(C.options),C.selections){const f=C.selections.selections.map(y.Selection.to);_._acceptSelections(f)}if(C.visibleRanges){const f=S.coalesce(C.visibleRanges.map(y.Range.to));_._acceptVisibleRanges(f)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const f=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),s=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:s,kind:f})}if(C.visibleRanges){const f=S.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:f})}}$acceptEditorPositionData(A){for(const C in A){const _=this._extHostDocumentsAndEditors.getEditor(C);if(!_)throw new Error("Unknown text editor");const f=y.ViewColumn.to(A[C]);_.value.viewColumn!==f&&(_._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:f}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=E});var an=this&&this.__rest||function(oe,e){var b={};for(var S in oe)Object.prototype.hasOwnProperty.call(oe,S)&&e.indexOf(S)<0&&(b[S]=oe[S]);if(oe!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(oe);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(oe,S[T])&&(b[S[T]]=oe[S[T]]);return b};define(we[202],Ee([0,1,2,4,5,6,7]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,S.createDecorator)("IExtHostTimeline");class k{constructor(A,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:_=>{var f,s;if(_&&_.$mid===11){const h=_.uri===void 0?void 0:b.URI.revive(_.uri);return(s=(f=this._itemsBySourceAndUriMap.get(_.source))===null||f===void 0?void 0:f.get(E(h)))===null||s===void 0?void 0:s.get(_.handle)}return _}})}async $getTimeline(A,C,_,f,s){const h=this._providers.get(A);return h==null?void 0:h.provideTimeline(b.URI.revive(C),_,f,s)}registerTimelineProvider(A,C,_,f){const s=new P.DisposableStore,h=this.convertTimelineItem(C.id,f,s).bind(this);let p;C.onDidChange&&(p=C.onDidChange(v=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},v),{id:C.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:A,onDidChange:void 0,async provideTimeline(v,d,c,o){var t;(o==null?void 0:o.resetCache)&&(s.clear(),(t=m.get(C.id))===null||t===void 0||t.clear());const r=await C.provideTimeline(v,d,c);if(r!=null){const l=h(v,o);return Object.assign(Object.assign({},r),{source:C.id,items:r.items.map(l)})}},dispose(){var v;for(const d of m.values())(v=d.get(C.id))===null||v===void 0||v.clear();p==null||p.dispose(),s.dispose()}}))}convertTimelineItem(A,C,_){return(f,s)=>{let h;if(s==null?void 0:s.cacheResults){let p=this._itemsBySourceAndUriMap.get(A);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(A,p));const m=E(f);h=p.get(m),h===void 0&&(h=new Map,p.set(m,h))}return p=>{var m,v;const{iconPath:d}=p,c=an(p,["iconPath"]),o=`${A}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;h==null||h.set(o,p);let t,r,l;return p.iconPath&&(d instanceof y.ThemeIcon?l={id:d.id}:b.URI.isUri(d)?(t=d,r=d):{light:t,dark:r}=d),Object.assign(Object.assign({},c),{id:(v=c.id)!==null&&v!==void 0?v:void 0,handle:o,source:A,command:p.command?C.toInternal(p.command,_):void 0,icon:t,iconDark:r,themeIcon:l,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{var _;for(const f of this._itemsBySourceAndUriMap.values())(_=f.get(A.id))===null||_===void 0||_.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=k;function E(n){return n==null?void 0:n.toString()}}),define(we[203],Ee([0,1,6,16,2,5]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,n,A,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const _=C.schemes.find(f=>!y.supportedSchemes.has(f));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,A),this._proxy.$registerUriOpener(n,C.schemes,E,C.label),(0,b.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(E,n,A){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener with id: ${E}`);const _=T.URI.revive(n);return C.canOpenExternalUri(_,A)}async $openUri(E,n,A){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener id: '${E}'`);return C.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([S.Schemas.http,S.Schemas.https])}),define(we[204],Ee([0,1,5,2,6,10,25]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(n,A){if(this.handles.has(y.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(n)),this.handlers.set(C,A),this._proxy.$registerUriHandler(C,n),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,A){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(S.URI.revive(A))}catch(_){(0,P.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(n){return S.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[50],Ee([0,1,3,2,69,5]),function(oe,e,b,S,T,P){"use strict";var y,k,E,n,A,C,_,f,s,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class m{constructor(l,a,i,u,D,R,g){y.set(this,void 0),k.set(this,void 0),E.set(this,void 0),n.set(this,void 0),A.set(this,void 0),C.set(this,void 0),_.set(this,""),f.set(this,void 0),s.set(this,!1),h.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new b.Emitter),this._onDidDispose=We(this,p).event,tt(this,y,l),tt(this,k,a),tt(this,f,i),tt(this,n,u),tt(this,A,D),tt(this,C,R),tt(this,E,g)}dispose(){tt(this,s,!0),We(this,p).fire(),We(this,p).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,h,!0),(0,T.asWebviewUri)(We(this,n),We(this,y),l)}get cspSource(){return We(this,n).webviewCspSource.replace("{{uuid}}",We(this,y))}get html(){return this.assertNotDisposed(),We(this,_)}set html(l){this.assertNotDisposed(),We(this,_)!==l&&(tt(this,_,l),!We(this,h)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,h,!0),We(this,E).report("Webview vscode-resource: uris",We(this,C),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,k).$setHtml(We(this,y),l))}get options(){return this.assertNotDisposed(),We(this,f)}set options(l){this.assertNotDisposed(),We(this,k).$setOptions(We(this,y),c(We(this,C),We(this,A),l)),tt(this,f,l)}async postMessage(l){return We(this,s)?!1:We(this,k).$postMessage(We(this,y),l)}assertNotDisposed(){if(We(this,s))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,y=new WeakMap,k=new WeakMap,E=new WeakMap,n=new WeakMap,A=new WeakMap,C=new WeakMap,_=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap;class v{constructor(l,a,i,u,D){this.initData=a,this.workspace=i,this._logService=u,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=l.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(l,a){const i=this.getWebview(l);i&&i._onMessageEmitter.fire(a)}$onMissingCsp(l,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,a,i){const u=new m(l,this._webviewProxy,o(a),this.initData,this.workspace,i,this._deprecationService);return this._webviews.set(l,u),u._onDidDispose(()=>{this._webviews.delete(l)}),u}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=v;function d(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=d;function c(r,l,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||t(r,l)}}e.serializeWebviewOptions=c;function o(r){var l;return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:(l=r.localResourceRoots)===null||l===void 0?void 0:l.map(a=>S.URI.from(a))}}e.reviveOptions=o;function t(r,l){return[...((l==null?void 0:l.getWorkspaceFolders())||[]).map(a=>a.uri),r.extensionLocation]}}),define(we[205],Ee([0,1,20,56,6,16,24,2,9,50,92,5,7]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class s{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,l){const a=this.key(t,r.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const i=new f(r,l);return this._documents.set(a,i),i}delete(t,r){const l=this.key(t,r.uri);this._documents.delete(l)}key(t,r){return`${t}@@@${r}`}}var h;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(h||(h={}));class p{constructor(){this._providers=new Map}addTextProvider(t,r,l){return this.add(0,t,r,l)}addCustomProvider(t,r,l){return this.add(1,t,r,l)}get(t){return this._providers.get(t)}add(t,r,l,a){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:l,provider:a}),new _.Disposable(()=>this._providers.delete(r))}}class m{constructor(t,r,l,a,i){this._extHostDocuments=r,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=i,this._editorProviders=new p,this._documents=new s,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,l,a){const i=new T.DisposableStore;return v(l)?(i.add(this._editorProviders.addTextProvider(r,t,l)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor})):(i.add(this._editorProviders.addCustomProvider(r,t,l)),this.supportEditing(l)&&i.add(l.onDidChangeCustomDocument(u=>{const D=this.getCustomDocumentEntry(r,u.document.uri);if(d(u)){const R=D.addEdit(u);this._proxy.$onDidEdit(u.document.uri,r,R,u.label)}else this._proxy.$onContentChange(u.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument)),_.Disposable.from(i,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,l,a,i){var u;const D=this._editorProviders.get(r);if(!D)throw new Error(`No provider found for '${r}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${r}'`);const R=k.URI.revive(t),g=await D.provider.openCustomDocument(R,{backupId:l,untitledDocumentData:a==null?void 0:a.buffer},i);let w;return this.supportEditing(D.provider)&&this._extensionStoragePaths&&(w=(u=this._extensionStoragePaths.workspaceValue(D.extension))!==null&&u!==void 0?u:this._extensionStoragePaths.globalValue(D.extension)),this._documents.add(r,g,w),{editable:this.supportEditing(D.provider)}}async $disposeCustomDocument(t,r){const l=this._editorProviders.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const a=k.URI.revive(t),{document:i}=this.getCustomDocumentEntry(r,a);this._documents.delete(r,i),i.dispose()}async $resolveWebviewEditor(t,r,l,a,i,u){const D=this._editorProviders.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const R=E.ViewColumn.to(i),g=this._extHostWebview.createNewWebview(r,a.webviewOptions,D.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(r,l,a.title,R,a.panelOptions,g),I=k.URI.revive(t);switch(D.type){case 1:{const{document:F}=this.getCustomDocumentEntry(l,I);return D.provider.resolveCustomEditor(F,w,u)}case 0:{const F=this._extHostDocuments.getDocument(I);return D.provider.resolveCustomTextEditor(F,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,l){this.getCustomDocumentEntry(r,t).disposeEdits(l)}async $onMoveCustomEditor(t,r,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const i=this._extHostWebviewPanels.getWebviewPanel(t);if(!i)throw new Error("No webview found");const u=k.URI.revive(r),D=this._extHostDocuments.getDocument(u);await a.provider.moveCustomTextEditor(D,i,b.CancellationToken.None)}async $undo(t,r,l,a){return this.getCustomDocumentEntry(r,t).undo(l,a)}async $redo(t,r,l,a){return this.getCustomDocumentEntry(r,t).redo(l,a)}async $revert(t,r,l){const a=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(t,r,l){const a=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(t,r,l,a){const i=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(i.document,k.URI.revive(l),a)}async $backup(t,r,l){const a=this.getCustomDocumentEntry(r,t),u=await this.getCustomEditorProvider(r).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(u),u.id}getCustomDocumentEntry(t,r){const l=this._documents.get(t,k.URI.revive(r));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const r=this._editorProviders.get(t),l=r==null?void 0:r.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function v(o){return typeof o.resolveCustomTextEditor=="function"}function d(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function c(o){const t=o.scheme===P.Schemas.file||o.scheme===P.Schemas.untitled?o.fsPath:o.toString();return(0,S.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[206],Ee([0,1,3,6,2,29,9,50,5,7]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";var A,C,_,f,s,h,p,m,v,d,c,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends S.Disposable{constructor(u,D,R,g,w,I,F){super();A.set(this,void 0),C.set(this,void 0),_.set(this,void 0),f.set(this,void 0),s.set(this,void 0),h.set(this,void 0),p.set(this,void 0),m.set(this,void 0),v.set(this,!0),d.set(this,!0),c.set(this,!1),o.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,o).event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=We(this,t).event,tt(this,A,u),tt(this,C,D),tt(this,_,R),tt(this,s,I),tt(this,m,w),tt(this,h,g),tt(this,f,F)}dispose(){We(this,c)||(tt(this,c,!0),We(this,o).fire(),We(this,C).$disposeWebview(We(this,A)),We(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,f)}get viewType(){return this.assertNotDisposed(),We(this,_)}get title(){return this.assertNotDisposed(),We(this,h)}set title(u){this.assertNotDisposed(),We(this,h)!==u&&(tt(this,h,u),We(this,C).$setTitle(We(this,A),u))}get iconPath(){return this.assertNotDisposed(),We(this,p)}set iconPath(u){this.assertNotDisposed(),We(this,p)!==u&&(tt(this,p,u),We(this,C).$setIconPath(We(this,A),T.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return We(this,s)}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,m)=="number"&&We(this,m)<0))return We(this,m)}get active(){return this.assertNotDisposed(),We(this,d)}get visible(){return this.assertNotDisposed(),We(this,v)}_updateViewState(u){We(this,c)||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,d,u.active),tt(this,v,u.visible),tt(this,m,u.viewColumn),We(this,t).fire({webviewPanel:this}))}reveal(u,D){this.assertNotDisposed(),We(this,C).$reveal(We(this,A),{viewColumn:u?y.ViewColumn.from(u):void 0,preserveFocus:!!D})}assertNotDisposed(){if(We(this,c))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,_=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap,m=new WeakMap,v=new WeakMap,d=new WeakMap,c=new WeakMap,o=new WeakMap,t=new WeakMap;class l{constructor(u,D,R){this.webviews=D,this.workspace=R,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(u,D,R,g,w={}){const I=typeof g=="object"?g.viewColumn:g,F={viewColumn:y.ViewColumn.from(I),preserveFocus:typeof g=="object"&&!!g.preserveFocus},B=l.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(u),B,D,{title:R,panelOptions:a(w),webviewOptions:(0,k.serializeWebviewOptions)(u,this.workspace,w)},F);const le=this.webviews.createNewWebview(B,w,u);return this.createNewWebviewPanel(B,D,R,I,w,le)}$onDidChangeWebviewPanelViewStates(u){const D=Object.keys(u);D.sort((R,g)=>{const w=u[R],I=u[g];return w.active?1:I.active?-1:+w.visible-+I.visible});for(const R of D){const g=this.getWebviewPanel(R);if(!!g){const w=u[R];g._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(u){const D=this.getWebviewPanel(u);D==null||D.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,D,R){if(this._serializers.has(D))throw new Error(`Serializer for '${D}' already registered`);return this._serializers.set(D,{serializer:R,extension:u}),this._proxy.$registerSerializer(D),new n.Disposable(()=>{this._serializers.delete(D),this._proxy.$unregisterSerializer(D)})}async $deserializeWebviewPanel(u,D,R,g){const w=this._serializers.get(D);if(!w)throw new Error(`No serializer found for '${D}'`);const{serializer:I,extension:F}=w,B=this.webviews.createNewWebview(u,R.webviewOptions,F),le=this.createNewWebviewPanel(u,D,R.title,g,R.panelOptions,B);await I.deserializeWebviewPanel(le,R.state)}createNewWebviewPanel(u,D,R,g,w,I){const F=new r(u,this._proxy,D,R,g,w,I);return this._webviewPanels.set(u,F),F}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=l;function a(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[207],Ee([0,1,3,6,50,5,7]),function(oe,e,b,S,T,P,y){"use strict";var k,E,n,A,C,_,f,s,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends S.Disposable{constructor(c,o,t,r,l,a){super();k.set(this,void 0),E.set(this,void 0),n.set(this,void 0),A.set(this,void 0),C.set(this,!1),_.set(this,void 0),f.set(this,void 0),s.set(this,void 0),h.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=We(this,h).event,p.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,p).event,tt(this,n,t),tt(this,f,r),tt(this,k,c),tt(this,E,o),tt(this,A,l),tt(this,_,a)}dispose(){We(this,C)||(tt(this,C,!0),We(this,p).fire(),We(this,A).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,f)}set title(c){this.assertNotDisposed(),We(this,f)!==c&&(tt(this,f,c),We(this,E).$setWebviewViewTitle(We(this,k),c))}get description(){return this.assertNotDisposed(),We(this,s)}set description(c){this.assertNotDisposed(),We(this,s)!==c&&(tt(this,s,c),We(this,E).$setWebviewViewDescription(We(this,k),c))}get visible(){return We(this,_)}get webview(){return We(this,A)}get viewType(){return We(this,n)}_setVisible(c){c===We(this,_)||We(this,C)||(tt(this,_,c),We(this,h).fire())}show(c){this.assertNotDisposed(),We(this,E).$show(We(this,k),!!c)}assertNotDisposed(){if(We(this,C))throw new Error("Webview is disposed")}}k=new WeakMap,E=new WeakMap,n=new WeakMap,A=new WeakMap,C=new WeakMap,_=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap;class v{constructor(c,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,o,t,r){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(c),o,r),new y.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(c,o,t,r,l){const a=this._viewProviders.get(o);if(!a)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:u}=a,D=this._extHostWebview.createNewWebview(c,{},u),R=new m(c,this._proxy,o,t,D,!0);this._webviewViews.set(c,R),await i.resolveWebviewView(R,{state:r},l)}async $onDidChangeWebviewViewVisibility(c,o){this.getWebviewView(c)._setVisible(o)}async $disposeWebviewView(c){const o=this.getWebviewView(c);this._webviewViews.delete(c),o.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const o=this._webviewViews.get(c);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=v}),define(we[99],Ee([0,1,3,5,2,16,8,4,14]),function(oe,e,b,S,T,P,y,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Cn{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Cn.InitialState,this._proxy=C.getProxy(S.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,_){let f;if(typeof C=="string"){f=C;try{C=T.URI.parse(C)}catch(s){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,f,_)}async asExternalUri(C,_){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const f=await this._proxy.$asExternalUri(C,_);return T.URI.from(f)}};n.InitialState={focused:!0},n=je([qe(0,E.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(we[208],Ee([0,1,19,5,27,14]),function(oe,e,b,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends b.AbstractLogger{constructor(E,n){super();this._proxy=E.getProxy(S.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(E){this.setLevel(E)}trace(E,...n){this.getLevel()<=b.LogLevel.Trace&&this._proxy.$log(this._logFile,b.LogLevel.Trace,Array.from(arguments))}debug(E,...n){this.getLevel()<=b.LogLevel.Debug&&this._proxy.$log(this._logFile,b.LogLevel.Debug,Array.from(arguments))}info(E,...n){this.getLevel()<=b.LogLevel.Info&&this._proxy.$log(this._logFile,b.LogLevel.Info,Array.from(arguments))}warn(E,...n){this.getLevel()<=b.LogLevel.Warning&&this._proxy.$log(this._logFile,b.LogLevel.Warning,Array.from(arguments))}error(E,...n){this.getLevel()<=b.LogLevel.Error&&this._proxy.$log(this._logFile,b.LogLevel.Error,Array.from(arguments))}critical(E,...n){this.getLevel()<=b.LogLevel.Critical&&this._proxy.$log(this._logFile,b.LogLevel.Critical,Array.from(arguments))}flush(){}};y=je([qe(0,P.IExtHostRpcService),qe(1,T.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(we[209],Ee([0,1,13,20,10,3,6,110,182,96,26]),function(oe,e,b,S,T,P,y,k,E,n,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function _(a,i){try{return JSON.stringify(a,i)}catch(u){return"null"}}function f(a,i){return JSON.stringify(a,i)}function s(a){return a?(i,u)=>u&&u.$mid===1?a.transformOutgoing(u):u:null}var h;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},v=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(i,u=null,D=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=i,this._logger=u,this._uriTransformer=D,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,g=n.ProxyIdentifier.count;R<g;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(i=>{this._pendingRPCReplies[i].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(i){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(i){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(i){this._responsiveState!==i&&(this._responsiveState=i,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(i){return this._uriTransformer?(0,k.transformIncomingURIs)(i,this._uriTransformer):i}getProxy(i){const{nid:u,sid:D}=i;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,D)),this._proxies[u]}_createProxy(i,u){let D={get:(R,g)=>(typeof g=="string"&&!R[g]&&g.charCodeAt(0)===36&&(R[g]=(...w)=>this._remoteCall(i,g,w)),g===d?u:R[g])};return new Proxy(Object.create(null),D)}set(i,u){return this._locals[i.nid]=u,u}assertRegistered(i){for(let u=0,D=i.length;u<D;u++){const R=i[u];if(!this._locals[R.nid])throw new Error(`Missing actor ${R.sid} (isMain: ${R.isMain})`)}}_receiveOneMessage(i){if(!this._isDisposed){const u=i.byteLength,D=o.read(i,0),R=D.readUInt8(),g=D.readUInt32();switch(R){case 1:case 2:{let{rpcId:w,method:I,args:F}=t.deserializeRequestJSONArgs(D);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(u,g,w,I,F,R===2);break}case 3:case 4:{let{rpcId:w,method:I,args:F}=t.deserializeRequestMixedArgs(D);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(u,g,w,I,F,R===4);break}case 5:{this._logger&&this._logger.logIncoming(u,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(u,g);break}case 7:{this._receiveReply(u,g,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(D);this._uriTransformer&&(w=(0,k.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(u,g,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(D);this._receiveReply(u,g,w);break}case 10:{let w=t.deserializeReplyErrError(D);this._uriTransformer&&(w=(0,k.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(u,g,w);break}case 11:{this._receiveReplyErr(u,g,void 0);break}default:console.error("received unexpected message"),console.error(i)}}}_receiveRequest(i,u,D,R,g,w){this._logger&&this._logger.logIncoming(i,u,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(D)}.${R}(`,g);const I=String(u);let F,B;if(w){const H=new S.CancellationTokenSource;g.push(H.token),F=this._invokeHandler(D,R,g),B=()=>H.cancel()}else F=this._invokeHandler(D,R,g),B=m;this._cancelInvokedHandlers[I]=B;const le=t.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(le.byteLength,u,1,"ack"),this._protocol.send(le),F.then(H=>{delete this._cancelInvokedHandlers[I];const z=t.serializeReplyOK(u,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,u,1,"reply:",H),this._protocol.send(z)},H=>{delete this._cancelInvokedHandlers[I];const z=t.serializeReplyErr(u,H);this._logger&&this._logger.logOutgoing(z.byteLength,u,1,"replyErr:",H),this._protocol.send(z)})}_receiveCancel(i,u){this._logger&&this._logger.logIncoming(i,u,1,"receiveCancel");const D=String(u);this._cancelInvokedHandlers[D]&&this._cancelInvokedHandlers[D]()}_receiveReply(i,u,D){this._logger&&this._logger.logIncoming(i,u,0,"receiveReply:",D);const R=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(R)){const g=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],g.resolveOk(D)}}_receiveReplyErr(i,u,D){this._logger&&this._logger.logIncoming(i,u,0,"receiveReplyErr:",D);const R=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(R)){const g=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let w;D&&(D.$isError?(w=new Error,w.name=D.name,w.message=D.message,w.stack=D.stack):w=D),g.resolveErr(w)}}_invokeHandler(i,u,D){try{return Promise.resolve(this._doInvokeHandler(i,u,D))}catch(R){return Promise.reject(R)}}_doInvokeHandler(i,u,D){const R=this._locals[i];if(!R)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(i));let g=R[u];if(typeof g!="function")throw new Error("Unknown method "+u+" on actor "+(0,n.getStringIdentifierForProxy)(i));return g.apply(R,D)}_remoteCall(i,u,D){if(this._isDisposed)return Promise.reject(T.canceled());let R=null;if(D.length>0&&S.CancellationToken.isCancellationToken(D[D.length-1])&&(R=D.pop()),R&&R.isCancellationRequested)return Promise.reject(T.canceled());const g=t.serializeRequestArguments(D,this._uriReplacer),w=++this._lastMessageId,I=String(w),F=new E.LazyPromise;R&&R.onCancellationRequested(()=>{const le=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(le.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[I]=F,this._onWillSendRequest(w);const B=t.serializeRequest(w,i,u,g,!!R);return this._logger&&this._logger.logOutgoing(B.byteLength,w,0,`request: ${(0,n.getStringIdentifierForProxy)(i)}.${u}(`,D),this._protocol.send(B),F}}e.RPCProtocol=c,C=v,c.UNRESPONSIVE_TIME=3*1e3;class o{constructor(i,u){this._buff=i,this._offset=u}static alloc(i,u,D){let R=new o(A.VSBuffer.alloc(D+1+4),0);return R.writeUInt8(i),R.writeUInt32(u),R}static read(i,u){return new o(i,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(i){this._buff.writeUInt8(i,this._offset),this._offset+=1}readUInt8(){const i=this._buff.readUInt8(this._offset);return this._offset+=1,i}writeUInt32(i){this._buff.writeUInt32BE(i,this._offset),this._offset+=4}readUInt32(){const i=this._buff.readUInt32BE(this._offset);return this._offset+=4,i}static sizeShortString(i){return 1+i.byteLength}writeShortString(i){this._buff.writeUInt8(i.byteLength,this._offset),this._offset+=1,this._buff.set(i,this._offset),this._offset+=i.byteLength}readShortString(){const i=this._buff.readUInt8(this._offset);this._offset+=1;const D=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,D}static sizeLongString(i){return 4+i.byteLength}writeLongString(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readLongString(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,D}writeBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}static sizeVSBuffer(i){return 4+i.byteLength}writeVSBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readVSBuffer(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+i);return this._offset+=i,u}static sizeMixedArray(i,u){let D=0;D+=1;for(let R=0,g=i.length;R<g;R++){const w=i[R],I=u[R];switch(D+=1,I){case 1:D+=this.sizeLongString(w);break;case 2:D+=this.sizeVSBuffer(w);break;case 3:break}}return D}writeMixedArray(i,u){this._buff.writeUInt8(i.length,this._offset),this._offset+=1;for(let D=0,R=i.length;D<R;D++){const g=i[D];switch(u[D]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const i=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(i);for(let D=0;D<i;D++)switch(this.readUInt8()){case 1:u[D]=this.readLongString();break;case 2:u[D]=this.readVSBuffer();break;case 3:u[D]=void 0;break}return u}}class t{static _arrayContainsBufferOrUndefined(i){for(let u=0,D=i.length;u<D;u++)if(i[u]instanceof A.VSBuffer||typeof i[u]=="undefined")return!0;return!1}static serializeRequestArguments(i,u){if(this._arrayContainsBufferOrUndefined(i)){let D=[],R=[];for(let g=0,w=i.length;g<w;g++){const I=i[g];I instanceof A.VSBuffer?(D[g]=I,R[g]=2):typeof I=="undefined"?(D[g]=A.VSBuffer.alloc(0),R[g]=3):(D[g]=A.VSBuffer.fromString(f(I,u)),R[g]=1)}return{type:"mixed",args:D,argsType:R}}return{type:"simple",args:f(i,u)}}static serializeRequest(i,u,D,R,g){return R.type==="mixed"?this._requestMixedArgs(i,u,D,R.args,R.argsType,g):this._requestJSONArgs(i,u,D,R.args,g)}static _requestJSONArgs(i,u,D,R,g){const w=A.VSBuffer.fromString(D),I=A.VSBuffer.fromString(R);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(w),F+=o.sizeLongString(I);let B=o.alloc(g?2:1,i,F);return B.writeUInt8(u),B.writeShortString(w),B.writeLongString(I),B.buffer}static deserializeRequestJSONArgs(i){const u=i.readUInt8(),D=i.readShortString(),R=i.readLongString();return{rpcId:u,method:D,args:JSON.parse(R)}}static _requestMixedArgs(i,u,D,R,g,w){const I=A.VSBuffer.fromString(D);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(I),F+=o.sizeMixedArray(R,g);let B=o.alloc(w?4:3,i,F);return B.writeUInt8(u),B.writeShortString(I),B.writeMixedArray(R,g),B.buffer}static deserializeRequestMixedArgs(i){const u=i.readUInt8(),D=i.readShortString(),R=i.readMixedArray(),g=new Array(R.length);for(let w=0,I=R.length;w<I;w++){const F=R[w];typeof F=="string"?g[w]=JSON.parse(F):g[w]=F}return{rpcId:u,method:D,args:g}}static serializeAcknowledged(i){return o.alloc(5,i,0).buffer}static serializeCancel(i){return o.alloc(6,i,0).buffer}static serializeReplyOK(i,u,D){return typeof u=="undefined"?this._serializeReplyOKEmpty(i):u instanceof A.VSBuffer?this._serializeReplyOKVSBuffer(i,u):this._serializeReplyOKJSON(i,_(u,D))}static _serializeReplyOKEmpty(i){return o.alloc(7,i,0).buffer}static _serializeReplyOKVSBuffer(i,u){let D=0;D+=o.sizeVSBuffer(u);let R=o.alloc(8,i,D);return R.writeVSBuffer(u),R.buffer}static deserializeReplyOKVSBuffer(i){return i.readVSBuffer()}static _serializeReplyOKJSON(i,u){const D=A.VSBuffer.fromString(u);let R=0;R+=o.sizeLongString(D);let g=o.alloc(9,i,R);return g.writeLongString(D),g.buffer}static deserializeReplyOKJSON(i){const u=i.readLongString();return JSON.parse(u)}static serializeReplyErr(i,u){return u?this._serializeReplyErrEror(i,u):this._serializeReplyErrEmpty(i)}static _serializeReplyErrEror(i,u){const D=A.VSBuffer.fromString(_(T.transformErrorForSerialization(u),null));let R=0;R+=o.sizeLongString(D);let g=o.alloc(10,i,R);return g.writeLongString(D),g.buffer}static deserializeReplyErrError(i){const u=i.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(i){return o.alloc(11,i,0).buffer}}var r;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var l;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(l||(l={}))}),define(we[210],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const b=function(P){const y=k=>{self.removeEventListener("message",y);const E=k.data;Object.defineProperties(self,{postMessage:{value(n,A){E.postMessage(n,A)}},onmessage:{get(){return E.onmessage},set(n){E.onmessage=n}}}),E.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",y)}.toString();class S extends EventTarget{constructor(P,y,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${b})('${y}'))`,n=new Blob([E],{type:"application/javascript"}),A=URL.createObjectURL(n),C=new MessageChannel,_=A,f={type:"_newWorker",id:_,port:C.port2,url:A,options:k};P(f,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:_};C.port1.postMessage(s),URL.revokeObjectURL(A),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(s){C.port1.onmessage=s}},onmessageerror:{get(){return C.port1.onmessageerror},set(s){C.port1.onmessageerror=s}}}),C.port1.addEventListener("messageerror",s=>{const h=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(h)}),C.port1.addEventListener("message",s=>{const h=new MessageEvent("message",{data:s.data});this.dispatchEvent(h)}),C.port1.start()}}e.NestedWorker=S}),define(we[211],Ee([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(we[212],Ee([0,1,16,11,21,2,4,211]),function(oe,e,b,S,T,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let E=class{constructor(A,C){this.localUserHome=A,this.remoteAgentService=C,this.resolveOS=(async()=>{const _=await this.remoteAgentService.getEnvironment();return(_==null?void 0:_.os)||T.OS})(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(_==null?void 0:_.userHome)||A})()}async userHome(A){return(A==null?void 0:A.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(A=>A===1?S.win32:S.posix)}async fileURI(A){let C="";if(await this.resolveOS===1&&(A=A.replace(/\\/g,"/")),A[0]==="/"&&A[1]==="/"){const f=A.indexOf("/",2);f===-1?(C=A.substring(2),A="/"):(C=A.substring(2,f),A=A.substring(f)||"/")}return P.URI.from({scheme:b.Schemas.file,authority:C,path:A,query:"",fragment:""})}};E=je([qe(1,k.IRemoteAgentService)],E),e.AbstractPathService=E}),define(we[42],Ee([0,1,15,28,23,38,8,4,11,10]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",C=" characters skipped \u27EB",_=(A.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var f;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function h(L){return!!L.preview}e.resultIsMatch=h;function p(L){return!!L.resource}e.isFileMatch=p;function m(L){return!!L.message}e.isProgressMessage=m;var v;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(v=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor($){this.resource=$,this.results=[]}}e.FileMatch=d;class c{constructor($,U,G){this.ranges=U;const N=Array.isArray(U)?U:[U];if(G&&G.matchLines===1&&o(N)){$=(0,y.getNLines)($,G.matchLines);let Z="",ne=0,re=0;const ye=Math.floor(G.charsPerLine/5),Ae=[];for(const Be of N){const Re=Math.max(Be.startColumn-ye,0),xe=Be.startColumn+G.charsPerLine;if(Re>re+ye+_){const W=A+(Re-re)+C;Z+=W+$.slice(Re,xe),ne+=Re-(re+W.length)}else Z+=$.slice(re,xe);Ae.push(new r(0,Be.startColumn-ne,Be.endColumn-ne)),re=xe}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const Z=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:$,matches:(0,b.mapArrayOrNot)(U,ne=>new t(ne.startLineNumber-Z,ne.startColumn,ne.endLineNumber-Z,ne.endColumn))}}}}e.TextSearchMatch=c;function o(L){const $=L[0].startLineNumber;for(const U of L)if(U.startLineNumber!==$||U.endLineNumber!==$)return!1;return!0}class t{constructor($,U,G,N){this.startLineNumber=$,this.startColumn=U,this.endLineNumber=G,this.endColumn=N}}e.SearchRange=t;class r extends t{constructor($,U,G){super($,U,$,G)}}e.OneLineRange=r;var l;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function a(L,$=!0){const U=L&&L.files&&L.files.exclude,G=$&&L&&L.search&&L.search.exclude;if(!(!U&&!G)){if(!U||!G)return U||G;let N=Object.create(null);return N=T.mixin(N,T.deepClone(U)),N=T.mixin(N,T.deepClone(G),!0),N}}e.getExcludes=a;function i(L,$){return L.excludePattern&&S.match(L.excludePattern,$)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&S.match(L.includePattern,$)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(U=>{const G=U.folder.fsPath;if(P.isEqualOrParent($,G)){const N=E.relative(G,$);return!U.includePattern||!!S.match(U.includePattern,N)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var u;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor($,U){super($);this.code=U}}e.SearchError=D;function R(L){const $=L.message;if((0,n.isPromiseCanceledError)(L))return new D($,u.canceled);try{const U=JSON.parse($);return new D(U.message,U.code)}catch(U){return new D($,u.other)}}e.deserializeSearchError=R;function g(L){const $={message:L.message,code:L.code};return new Error(JSON.stringify($))}e.serializeSearchError=g;function w(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=w;function I(L){return L.type==="success"}e.isSerializedSearchSuccess=I;function F(L){return!!L.path}e.isSerializedFileMatch=F;function B(L,$){const U=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(U,$)}e.isFilePatternMatch=B;class le{constructor($){this.path=$,this.results=[]}addMatch($){this.results.push($)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function H(L,$){const U=Object.assign(Object.assign({},L||{}),$||{});return Object.keys(U).filter(G=>{const N=U[G];return typeof N=="boolean"&&N})}e.resolvePatternsForProvider=H;class z{constructor($,U){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},$.excludePattern||{}),U.excludePattern||{}),this._parsedExcludeExpression=S.parse(this._excludeExpression);let G=$.includePattern;U.includePattern&&(G?G=Object.assign(Object.assign({},G),U.includePattern):G=U.includePattern),G&&(this._parsedIncludeExpression=S.parse(G))}includedInQuerySync($,U,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression($,U,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression($,U,G))}includedInQuery($,U,G){return Promise.resolve(this._parsedExcludeExpression($,U,G)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression($,U,G)).then(ne=>!!ne):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=z;function K(L){for(const $ in L)if(typeof L[$]!="boolean")return!0;return!1}}),define(we[31],Ee([0,1,15,13,20,3,22,16,78,24,8,12,2,134,4,19,148,48,49,27,14,7,42,5]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d,c,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(I,F,B){return new n.ExtUri(le=>D(le,B)).isEqual(I,F)}function a(I,F,B){return l(I.uri,F.uri,B)?0:(0,A.compare)(I.uri.toString(),F.uri.toString())}function i(I,F,B){return I.index!==F.index?I.index<F.index?-1:1:l(I.uri,F.uri,B)?(0,A.compare)(I.name,F.name):(0,A.compare)(I.uri.toString(),F.uri.toString())}function u(I,F,B,le){const H=I.slice(0).sort((K,L)=>B(K,L,le)),z=F.slice(0).sort((K,L)=>B(K,L,le));return(0,b.delta)(H,z,(K,L)=>B(K,L,le))}function D(I,F){const B=F.getCapabilities(I.scheme);return!(B&&B&1024)}class R extends m.Workspace{constructor(F,B,le,H,z,K){super(F,le.map(L=>new m.WorkspaceFolder(L)),H,K);this._name=B,this._isUntitled=z,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(K),le.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,B,le,H){if(!F)return{workspace:null,added:[],removed:[]};const{id:z,name:K,folders:L,configuration:$,isUntitled:U}=F,G=[],N=B;B?L.forEach((ye,Ae)=>{const Be=_.URI.revive(ye.uri),Re=R._findFolder(le||B,Be,H);Re?(Re.name=ye.name,Re.index=ye.index,G.push(Re)):G.push({uri:Be,name:ye.name,index:Ae})}):G.push(...L.map(({uri:ye,name:Ae,index:Be})=>({uri:_.URI.revive(ye),name:Ae,index:Be}))),G.sort((ye,Ae)=>ye.index<Ae.index?-1:1);const Z=new R(z,K,G,$?_.URI.revive($):null,!!U,ye=>D(ye,H)),{added:ne,removed:re}=u(N?N.workspaceFolders:[],Z.workspaceFolders,a,H);return{workspace:Z,added:ne,removed:re}}static _findFolder(F,B,le){for(let H=0;H<F.folders.length;H++){const z=F.workspaceFolders[H];if(l(z.uri,B,le))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,B){return B&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let g=class{constructor(F,B,le,H){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unknown,this._logService=H,this._extHostFileSystemInfo=le,this._requestIdProvider=new E.Counter,this._barrier=new S.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const z=B.workspace;this._confirmedWorkspace=z?new R(z.id,z.name,[],z.configuration?_.URI.revive(z.configuration):null,!!z.isUntitled,K=>D(K,le)):void 0}$initializeWorkspace(F,B){this._workspaceTrustState=B,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:k.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,le,...H){const z=[];if(Array.isArray(H)&&H.forEach(G=>{_.URI.isUri(G.uri)&&!z.some(N=>l(N.uri,G.uri,this._extHostFileSystemInfo))&&z.push({uri:G.uri,name:G.name||(0,n.basenameOrAuthority)(G.uri)})}),this._unconfirmedWorkspace||[B,le].some(G=>typeof G!="number"||G<0)||le===0&&z.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+le>K.length)return!1;const L=K.slice(0);L.splice(B,le,...z.map(G=>({uri:G.uri,name:G.name||(0,n.basenameOrAuthority)(G.uri),index:void 0})));for(let G=0;G<L.length;G++){const N=L[G];if(L.some((Z,ne)=>ne!==G&&l(N.uri,Z.uri,this._extHostFileSystemInfo)))return!1}L.forEach((G,N)=>G.index=N);const{added:$,removed:U}=u(K,L,i,this._extHostFileSystemInfo);if($.length===0&&U.length===0)return!1;if(this._proxy){const G=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(G,B,le,z).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,f.localize)(0,null,G,N.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,B){let le,H="";if(typeof F=="string"?(le=_.URI.file(F),H=F):typeof F!="undefined"&&(le=F,H=F.fsPath),!le)return H;const z=this.getWorkspaceFolder(le,!0);if(!z)return H;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let K=(0,n.relativePath)(z.uri,le);return B&&z.name&&(K=`${z.name}/${K}`),K}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:le,removed:H}=R.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:le,removed:H}))}findFiles(F,B,le,H,z=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let K;if(B===null?K=!1:B&&(typeof B=="string"?K=B:K=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:$}=w(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(K),(0,C.withUndefinedAsNull)(le),z).then(U=>Array.isArray(U)?U.map(G=>_.URI.revive(G)):[])}async findTextInFiles(F,B,le,H,z=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),L=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:$,folder:U}=w(B.include),G=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,N={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:L,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:$,excludePattern:G},Z=!1;if(this._activeSearchCallbacks[K]=ne=>{if(!Z){const re=_.URI.revive(ne.resource);ne.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?le({uri:re,preview:{text:ye.preview.text,matches:(0,b.mapArrayOrNot)(ye.preview.matches,Ae=>new o.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))},ranges:(0,b.mapArrayOrNot)(ye.ranges,Ae=>new o.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))}):le({uri:re,text:ye.text,lineNumber:ye.lineNumber})})}},z.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(U),N,K,z);return delete this._activeSearchCallbacks[K],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[K],ne}}$handleTextSearchResult(F,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};g=je([qe(0,c.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,v.IExtHostFileSystemInfo),qe(3,h.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function w(I){let F,B;return I&&(typeof I=="string"?F=I:(F=I.pattern,B=I.baseFolder||_.URI.file(I.base))),{includePattern:F,folder:B}}}),define(we[35],Ee([0,1,23,3,31,5,7,150,66,12,13,4,14,19,2]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(r,l){if(l){const a=l.split(".");let i=r;for(let u=0;i&&u<a.length;u++)i=i[a[u]];return i}}function p(r){return r instanceof s.URI}function m(r){return r&&r.uri instanceof s.URI&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function d(r){return r&&r.uri instanceof s.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(p(r))return{resource:r};if(m(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(v(r))return{overrideIdentifier:r.languageId};if(d(r))return{resource:r.uri};if(r===null)return{resource:null}}let o=class{constructor(l,a,i){this._proxy=l.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=i,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,a){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(l,a))}};o=je([qe(0,_.IExtHostRpcService),qe(1,T.IExtHostWorkspace),qe(2,f.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(l,a,i,u){this._onDidChangeConfiguration=new S.Emitter,this._proxy=l,this._logService=u,this._extHostWorkspace=a,this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,a){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,i))}getConfiguration(l,a,i){const u=c(a)||{},D=this._toReadonlyValue(l?h(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,u,i==null?void 0:i.identifier);function R(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(w){return typeof h(D,w)!="undefined"},get:(w,I)=>{this._validateConfigurationAccess(l?`${l}.${w}`:w,u,i==null?void 0:i.identifier);let F=h(D,w);if(typeof F=="undefined")F=I;else{let B;const le=(H,z)=>{let K;const L=()=>{B=B||(0,b.deepClone)(D),K=K||h(B,z)};return(0,n.isObject)(H)?new Proxy(H,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return L(),()=>K;if(B)return K=K||h(B,z),K[U];const G=$[U];return typeof U=="string"?le(G,`${z}.${U}`):G},set:($,U,G)=>(L(),K&&(K[U]=G),!0),deleteProperty:($,U)=>(L(),K&&delete K[U],!0),defineProperty:($,U,G)=>(L(),K&&Object.defineProperty(K,U,G),!0)}):H};F=le(F,w)}return F},update:(w,I,F,B)=>{w=l?`${l}.${w}`:w;const le=R(F);return I!==void 0?this._proxy.$updateConfigurationOption(le,w,I,u,B):this._proxy.$removeConfigurationOption(le,w,u,B)},inspect:w=>{var I,F,B,le,H,z,K,L;w=l?`${l}.${w}`:w;const $=(0,b.deepClone)(this._configuration.inspect(w,u,this._extHostWorkspace.workspace));if($)return{key:w,defaultValue:(I=$.default)===null||I===void 0?void 0:I.value,globalValue:(F=$.user)===null||F===void 0?void 0:F.value,workspaceValue:(B=$.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(le=$.workspaceFolder)===null||le===void 0?void 0:le.value,defaultLanguageValue:(H=$.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(z=$.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(K=$.workspace)===null||K===void 0?void 0:K.override,workspaceFolderLanguageValue:(L=$.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:$.overrideIdentifiers}}};return typeof D=="object"&&(0,b.mixin)(g,D,!1),Object.freeze(g)}_toReadonlyValue(l){const a=i=>(0,n.isObject)(i)?new Proxy(i,{get:(u,D)=>a(u[D]),set:(u,D,R)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(u,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(u,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return a(l)}_validateConfigurationAccess(l,a,i){const u=E.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),D=i?`[${i.value}] `:"";if(u===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){(a==null?void 0:a.resource)&&this._logService.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,a){const i=new k.ConfigurationChangeEvent(l,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,D)=>i.affectsConfiguration(u,c(D))})}_toMap(l){return l.reduce((a,i)=>(a.set(i[0],i[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[100],Ee([0,1,2,13,3,5,7,31,40,35,20,41,14,27,4,16,21,19,72,166,10]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d,c){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function z(L){if(L!=null)return L}H.from=z;function K(L){if(L!=null)return L}H.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(H){function z(L){if(L!=null)return L}H.from=z;function K(L){if(L!=null)return L}H.to=K})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(H){function z(L){if(L!=null)return L}H.from=z;function K(L){if(L!=null)return L}H.to=K})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(H){function z($){if($){const U=$;return U&&!!U.process}else return!1}H.is=z;function K($){if($!=null){const U={process:$.process,args:$.args};return $.options&&(U.options=l.from($.options)),U}}H.from=K;function L($){if($!=null)return new y.ProcessExecution($.process,$.args,$.options)}H.to=L})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(H){function z(L){if(L!=null)return L}H.from=z;function K(L){if(L!=null)return L}H.to=K})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(H){function z($){if($){const U=$;return U&&(!!U.commandLine||!!U.command)}else return!1}H.is=z;function K($){if($!=null){const U={};return $.commandLine!==void 0?U.commandLine=$.commandLine:(U.command=$.command,U.args=$.args),$.options&&(U.options=i.from($.options)),U}}H.from=K;function L($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new y.ShellExecution($.commandLine,$.options):new y.ShellExecution($.command,$.args?$.args:[],$.options)}H.to=L})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(H){function z($){if($){let U=$;return U&&U.customExecution==="customExecution"}else return!1}H.is=z;function K($){return{customExecution:"customExecution"}}H.from=K;function L($,U){return U.get($)}H.to=L})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var R;(function(H){function z(K,L){let $;return K.scope!==void 0&&typeof K.scope!="number"?$=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&L&&L.workspaceFile?$=L.workspaceFile:$=d.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:$}}H.from=z})(R=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(H){function z($,U){if($==null)return[];const G=[];for(let N of $){const Z=K(N,U);Z&&G.push(Z)}return G}H.fromMany=z;function K($,U){if($!=null){let G;$.execution instanceof y.ProcessExecution?G=a.from($.execution):$.execution instanceof y.ShellExecution?G=u.from($.execution):$.execution&&$.execution instanceof y.CustomExecution&&(G=D.from($.execution));const N=t.from($.definition);let Z;if($.scope?typeof $.scope=="number"?Z=$.scope:Z=$.scope.uri:Z=y.TaskScope.Workspace,!(!N||!Z)){const ne=$.group?$.group.id:void 0;return{_id:$._id,definition:N,name:$.name,source:{extensionId:U.identifier.value,label:$.source,scope:Z},execution:G,isBackground:$.isBackground,group:ne,presentationOptions:r.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}}}H.from=K;async function L($,U,G){if($!=null){let N;a.is($.execution)?N=a.to($.execution):u.is($.execution)?N=u.to($.execution):D.is($.execution)&&(N=D.to($._id,G));const Z=t.to($.definition);let ne;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ne=$.source.scope:ne=await U.resolveWorkspaceFolder(b.URI.revive($.source.scope)):ne=y.TaskScope.Workspace),!(!Z||!ne)){const re=new y.Task(Z,ne,$.name,$.source.label,N,$.problemMatchers);return $.isBackground!==void 0&&(re.isBackground=$.isBackground),$.group!==void 0&&(re.group=y.TaskGroup.from($.group)),$.presentationOptions&&(re.presentationOptions=r.to($.presentationOptions)),$._id&&(re._id=$._id),$.detail&&(re.detail=$.detail),re}}}H.to=L})(g=e.TaskDTO||(e.TaskDTO={}));var w;(function(H){function z(L){return L}H.from=z;function K(L){if(!!L)return Object.assign(Object.create(null),L)}H.to=K})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(z,K,L){this._id=K,this._task=L,o.set(this,void 0),tt(this,o,z)}get task(){return this._task}terminate(){We(this,o).terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}o=new WeakMap;var F;(function(H){function z(K){return{id:K._id,task:void 0}}H.from=z})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,K,L,$,U,G,N,Z){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=z.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=$,this._configurationService=U,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=N,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,K,L){if(!L)return new y.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:K,provider:L,extension:z}),this._proxy.$registerTaskProvider($,K),new y.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(z,K){this._proxy.$registerTaskSystem(z,K)}fetchTasks(z){return this._proxy.$fetchTasks(w.from(z)).then(async K=>{const L=[];for(let $ of K){const U=await g.to($,this._workspaceProvider,this._providedCustomExecutions2);U&&L.push(U)}return L})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(K=>z.push(K)),z}terminateTask(z){if(!(z instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,K,L){const $=this._providedCustomExecutions2.get(z.id);if($){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,$),this._terminalService.attachPtyToTerminal(K,await $.callback(L))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const K=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const K=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:K,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const K=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:z.exitCode})}$provideTasks(z,K){const L=this._handlers.get(z);if(!L)return Promise.reject(new Error("no handler found"));const $=[],U=(0,S.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(G=>this.provideTasksInternal(K,$,L,G));return new Promise(G=>{U.then(N=>{Promise.all($).then(()=>{G(N)})})})}async $resolveTask(z,K){const L=this._handlers.get(z);if(!L)return Promise.reject(new Error("no handler found"));if(K.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${L.type}].`);const $=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const U=await L.provider.resolveTask($,A.CancellationToken.None);if(!!U){this.checkDeprecation(U,L);const G=g.from(U,L.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(G.execution)&&await this.addCustomExecution(G,U,!0),await this.resolveTaskInternal(G)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,K,L){const $=await this._proxy.$createTaskId(z);!L&&!this._providedCustomExecutions2.has($)&&this._notProvidedCustomExecutions.add($),this._providedCustomExecutions2.set($,K.execution)}async getTaskExecution(z,K){if(typeof z=="string"){const U=this._taskExecutionPromises.get(z);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let L=this._taskExecutionPromises.get(z.id);if(L)return L;const $=new Promise(async(U,G)=>{const N=K||await g.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);N?U(new I(this,z.id,N)):G("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,$),$.then(U=>(this._taskExecutions.set(z.id,U),U),U=>Promise.reject(U))}checkDeprecation(z,K){z._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let L=this._notProvidedCustomExecutions.values(),$=L.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=L.next()}};B=je([qe(0,_.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,k.IExtHostWorkspace),qe(3,E.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,C.IExtHostTerminalService),qe(6,m.ILogService),qe(7,v.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let le=class extends B{constructor(z,K,L,$,U,G,N,Z){super(z,K,L,$,U,G,N,Z);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(z,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const L=g.from(K,z);if(L===void 0)throw new Error("Task is not valid");if(D.is(L.execution))await this.addCustomExecution(L,K,!1);else throw new c.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),K);return this._proxy.$executeTask(L).catch(U=>{throw new Error(U)}),$}provideTasksInternal(z,K,L,$){const U=[];if($)for(let G of $){this.checkDeprecation(G,L),(!G.definition||!z[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const N=g.from(G,L.extension);N&&D.is(N.execution)?(U.push(N),K.push(this.addCustomExecution(N,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:L.extension}}async resolveTaskInternal(z){if(D.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,K){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,K,L){}};le=je([qe(0,_.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,k.IExtHostWorkspace),qe(3,E.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,C.IExtHostTerminalService),qe(6,m.ILogService),qe(7,v.IExtHostApiDeprecationService)],le),e.WorkerExtHostTask=le,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)},an=this&&this.__rest||function(oe,e){var b={};for(var S in oe)Object.prototype.hasOwnProperty.call(oe,S)&&e.indexOf(S)<0&&(b[S]=oe[S]);if(oe!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(oe);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(oe,S[T])&&(b[S[T]]=oe[S[T]]);return b};define(we[213],Ee([0,1,15,13,20,3,52,6,23,12,2,29,5,40,14,9,7,31,178,168]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d){"use strict";var c,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(w,I)=>`${w}:${I.toString()}`;let r=class{constructor(I,F,B){this.documents=F,this.workspace=B,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(_.MainContext.MainThreadTesting),this.workspaceObservers=new R(this.proxy),this.textDocumentObservers=new g(this.proxy,F)}registerTestProvider(I){const F=(0,C.generateUuid)();this.providers.set(F,I),this.proxy.$registerTestProvider(F);const B=[...this.testSubscriptions.keys()];return setTimeout(()=>{var le;for(const H of B)(le=this.testSubscriptions.get(H))===null||le===void 0||le.subscribeFn(F,I)},0),new p.Disposable(()=>{this.providers.delete(F),this.proxy.$unregisterTestProvider(F)})}createTextDocumentTestObserver(I){return this.textDocumentObservers.checkout(I.uri)}createWorkspaceTestObserver(I){return this.workspaceObservers.checkout(I.uri)}async runTests(I,F=T.CancellationToken.None){const B=le=>le.map(this.getInternalTestForReference,this).filter(n.isDefined).map(H=>({providerId:H.providerId,testId:H.item.extId}));await this.proxy.$runTests({exclude:I.exclude?B(I.exclude).map(le=>le.testId):void 0,tests:B(I.tests),debug:I.debug},F)}publishExtensionProvidedResults(I,F){this.proxy.$publishExtensionProvidedResults(h.TestResults.from((0,C.generateUuid)(),I),F)}$publishTestResults(I){this.results=Object.freeze(I.map(F=>(0,E.deepFreeze)(h.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(I,F){const B=A.URI.revive(F),le=t(I,B);if(!this.testSubscriptions.has(le)){const H=new T.CancellationTokenSource;let z;if(I===1){let U=this.documents.getDocument(B);if(!U){const G=new k.DisposableStore;U=await new Promise(N=>{G.add((0,S.disposableTimeout)(()=>N(void 0),5e3)),G.add(this.documents.onDidAddDocuments(Z=>{const ne=Z.find(re=>re.document.uri.toString()===B.toString());ne&&N(ne)}))}).finally(()=>G.dispose())}if(U){const G=await this.workspace.getWorkspaceFolder2(B,!1);z=N=>N.provideDocumentTestHierarchy?N.provideDocumentTestHierarchy(U.document,H.token):this.createDefaultDocumentTestHierarchy(N,U.document,G,H.token)}}else{const U=await this.workspace.getWorkspaceFolder2(B,!1);U&&(z=G=>G.provideWorkspaceTestHierarchy(U,H.token))}if(!!z){const K=async(U,G)=>{var N;try{$.pushDiff([3,1]);const Z=await z(G);if(!Z){$.pushDiff([3,-1]);return}$.addRoot(Z.root,U),Promise.resolve(Z.discoveredInitialTests).then(()=>$.pushDiff([3,-1])),Z.onDidChangeTest(ne=>$.onItemChange(ne,U)),(N=Z.onDidInvalidateTest)===null||N===void 0||N.call(Z,ne=>{const re=$.getTestByReference(ne);re?this.proxy.$retireTest(re.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(Z){console.error(Z)}},L=new k.DisposableStore,$=L.add(this.ownedTests.createForHierarchy(U=>this.proxy.$publishDiff(I,F,U)));L.add((0,k.toDisposable)(()=>H.dispose(!0)));for(const[U,G]of this.providers)K(U,G);$.pushDiff([4,-1]),this.testSubscriptions.set(le,{store:L,collection:$,subscribeFn:K})}}}$unsubscribeFromTests(I,F){var B;const le=A.URI.revive(F),H=t(I,le);(B=this.testSubscriptions.get(H))===null||B===void 0||B.store.dispose(),this.testSubscriptions.delete(H)}$acceptDiff(I,F,B){I===1?this.textDocumentObservers.acceptDiff(A.URI.revive(F),B):this.workspaceObservers.acceptDiff(A.URI.revive(F),B)}async $runTestsForProvider(I,F){const B=this.providers.get(I.providerId);if(!!B){const le=I.ids.map(z=>{var K;return(K=this.ownedTests.getTestById(z))===null||K===void 0?void 0:K[1]}).filter(n.isDefined),H=I.excludeExtIds.map(z=>this.ownedTests.getTestById(z)).filter(n.isDefined).filter(([z,K])=>le.some(L=>z.comparePositions(L,K)===1));if(!!le.length)try{await B.runTests({setState:(z,K)=>{for(const[L,$]of H){const U=L.comparePositions($,z.id);if(U===1||U===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(I.runId,z.id,h.TestState.from(K))},tests:le.map(z=>l.unwrap(z.actual)),exclude:H.map(([,z])=>l.unwrap(z.actual)),debug:I.debug},F);for(const{collection:z}of this.testSubscriptions.values())z.flushDiff();return}catch(z){throw console.error(z),z}}}$lookupTest(I){const F=this.ownedTests.getTestById(I.testId);if(!F)return Promise.resolve(void 0);const B=F[1],{actual:le,previousChildren:H,previousEquals:z}=B,K=an(B,["actual","previousChildren","previousEquals"]);return Promise.resolve(K)}flushCollectionDiffs(){for(const{collection:I}of this.testSubscriptions.values())I.flushDiff()}getInternalTestForReference(I){var F,B;return(B=(F=this.workspaceObservers.getMirroredTestDataByReference(I))!==null&&F!==void 0?F:(0,b.mapFind)(this.testSubscriptions.values(),le=>le.collection.getTestByReference(I)))!==null&&B!==void 0?B:this.textDocumentObservers.getMirroredTestDataByReference(I)}async createDefaultDocumentTestHierarchy(I,F,B,le){var H;if(!!B){const z=await I.provideWorkspaceTestHierarchy(B,le);if(!!z){const K=new P.Emitter;(H=z.onDidInvalidateTest)===null||H===void 0||H.call(z,$=>{const U=l.getWrapperForTestItem($,F);U.hasNodeMatchingFilter&&K.fire(U)});const L=new P.Emitter;return z.onDidChangeTest($=>{const U=l.getWrapperForTestItem($,F);if(U.hasNodeMatchingFilter){if(U.reset(),U.hasNodeMatchingFilter){L.fire(U);return}L.fire(U.visibleParent);return}const N=U.visibleParent;U.reset(),!!U.hasNodeMatchingFilter&&(N.reset(),L.fire(N))}),le.onCancellationRequested(()=>{l.removeFilter(F),L.dispose()}),{root:l.getWrapperForTestItem(z.root,F),discoveredInitialTests:z.discoveredInitialTests,onDidInvalidateTest:K.event,onDidChangeTest:L.event}}}}};r=je([qe(0,s.IExtHostRpcService),qe(1,f.IExtHostDocumentsAndEditors),qe(2,m.IExtHostWorkspace)],r),e.ExtHostTesting=r;class l{constructor(I,F,B){this.actual=I,this.filterDocument=F,this.parent=B,this.getWrappedChildren()}static removeFilter(I){this.wrapperMap.delete(I)}static getWrapperForTestItem(I,F,B){let le=this.wrapperMap.get(F);if(le==null?void 0:le.has(I))return le.get(I);le||(le=new WeakMap,this.wrapperMap.set(F,le));const H=new l(I,F,B);return le.set(I,H),H}static unwrap(I){return I instanceof l?I.actual:I}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(I=>I.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var I;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((I=this.actual.location)===null||I===void 0?void 0:I.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(F=>F.hasNodeMatchingFilter)),this.matchesFilter}reset(){var I;this!==this.visibleParent&&((I=this.parent)===null||I===void 0||I.reset()),this.matchesFilter=void 0}getWrappedChildren(){var I;return((I=this.actual.children)===null||I===void 0?void 0:I.map(F=>l.getWrapperForTestItem(F,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=l,l.wrapperMap=new WeakMap;class a extends d.IncrementalChangeCollector{constructor(I,F){super();this.collection=I,this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlainShallow(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{collection:I,added:F,updated:B,removed:le}=this;return{get added(){return[...F].map(I.getPublicTestItem,I)},get updated(){return[...B].map(I.getPublicTestItem,I)},get removed(){return[...le].map(I.getPublicTestItem,I)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(I){let F=[];for(const B of I){const le=this.items.get(B);le&&F.push(this.getPublicTestItem(le))}return F}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,F){return Object.assign(Object.assign({},I),{revived:h.TestItem.toPlainShallow(I.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new a(this,this.changeEmitter)}getPublicTestItem(I){return I.wrapped||(I.wrapped=new u(I,this)),I.wrapped}}e.MirroredTestCollection=i;class u{constructor(I,F){c.set(this,void 0),o.set(this,void 0),tt(this,c,I),tt(this,o,F)}get id(){return We(this,c).revived.id}get label(){return We(this,c).revived.label}get description(){return We(this,c).revived.description}get location(){return We(this,c).revived.location}get runnable(){var I;return(I=We(this,c).revived.runnable)!==null&&I!==void 0?I:!0}get debuggable(){var I;return(I=We(this,c).revived.debuggable)!==null&&I!==void 0?I:!1}get children(){return We(this,o).getAllAsTestItem(We(this,c).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(F=>F.toJSON()),providerId:We(this,c).providerId,testId:this.id}}}c=new WeakMap,o=new WeakMap;class D{constructor(){this.resources=new Map}checkout(I){var F,B;const le=I.toString(),H=(F=this.resources.get(le))!==null&&F!==void 0?F:this.createObserverData(I);return(B=H.pendingDeletion)===null||B===void 0||B.dispose(),H.observers++,{onDidChangeTest:H.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return H.tests.rootTestItems},dispose:(0,y.once)(()=>{--H.observers||(H.pendingDeletion=this.eventuallyDispose(I))})}}getMirroredTestDataByReference(I){for(const{tests:F}of this.resources.values()){const B=F.getMirroredTestDataByReference(I);if(B)return B}}eventuallyDispose(I){return(0,S.disposableTimeout)(()=>this.unlisten(I),10*1e3)}createObserverData(I){const F=new i,B=this.listen(I,H=>F.apply(H)),le={observers:0,tests:F,listener:B};return this.resources.set(I.toString(),le),le}unlisten(I){var F;const B=I.toString(),le=this.resources.get(B);le&&(le.observers=-1,(F=le.pendingDeletion)===null||F===void 0||F.dispose(),le.listener.dispose(),this.resources.delete(B))}}class R extends D{constructor(I){super();this.proxy=I,this.diffListeners=new Map}acceptDiff(I,F){var B;(B=this.diffListeners.get(I.toString()))===null||B===void 0||B(F)}listen(I,F){this.proxy.$subscribeToDiffs(0,I);const B=I.toString();return this.diffListeners.set(B,F),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,I),this.diffListeners.delete(B)})}}class g extends D{constructor(I,F){super();this.proxy=I,this.documents=F,this.diffListeners=new Map}acceptDiff(I,F){var B;(B=this.diffListeners.get(I.toString()))===null||B===void 0||B(F)}listen(I,F){if(!this.documents.getDocument(I))return new p.Disposable(()=>{});const le=I.toString();return this.diffListeners.set(le,F),this.proxy.$subscribeToDiffs(1,I),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,I),this.diffListeners.delete(le)})}}}),define(we[214],Ee([0,1,15,51,28,58,22,16,11,24,8,12,2,113,137,89,48,170,212,42]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(R,g,w,I){this.configurationService=R,this.workspaceContextService=g,this.editorGroupsService=w,this.pathService=I}text(R,g,w={}){R=this.getContentPattern(R,w);const I=this.configurationService.getValue(),F=g&&g.some(le=>!this.configurationService.getValue({resource:le}).search.useRipgrep),B=this.commonQuery(g==null?void 0:g.map(p.toWorkspaceFolder),w);return Object.assign(Object.assign({},B),{type:2,contentPattern:R,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(R,g){const w=this.configurationService.getValue();R.isRegExp&&(R.pattern=R.pattern.replace(/\r?\n/g,"\\n"));const I=Object.assign(Object.assign({},R),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(R,g)&&(I.isCaseSensitive=!0),this.isMultiline(R)&&(I.isMultiline=!0),I}file(R,g={}){const w=this.commonQuery(R,g);return Object.assign(Object.assign({},w),{type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey})}handleIncludeExclude(R,g){return R?(R=Array.isArray(R)?R.map(a):a(R),g?this.parseSearchPaths(R):{pattern:t(...Array.isArray(R)?R:[R])}):{}}commonQuery(R=[],g={}){const w=this.handleIncludeExclude(g.includePattern,g.expandPatterns),I=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),F=R.length>1,B=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,g,I)):R.map(z=>this.getFolderQueryForRoot(z,g,I,F))).filter(z=>!!z),le={_reason:g._reason,folderQueries:B,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:I.pattern,includePattern:w.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const K=b.coalesce(b.flatten(this.editorGroupsService.groups.map($=>$.editors.map(U=>U.resource)))).filter($=>(0,d.pathIncludedInQuery)(le,$.fsPath)),L=this.commonQueryFromFileList(K);return Object.assign(Object.assign({},le),L)}const H=g.extraFileResources&&g.extraFileResources.filter(z=>(0,d.pathIncludedInQuery)(le,z.fsPath));return le.extraFileResources=H&&H.length?H:void 0,le}commonQueryFromFileList(R){const g=[],w=new y.ResourceMap,I={};let F=!1;return R.forEach(B=>{var le,H;if(B.scheme!==k.Schemas.walkThrough)if((0,n.isAbsolutePath)(B)){const K=(H=(le=this.workspaceContextService.getWorkspaceFolder(B))===null||le===void 0?void 0:le.uri)!==null&&H!==void 0?H:B.with({path:E.dirname(B.fsPath)});let L=w.get(K);L||(F=!0,L={folder:K,includePattern:{}},g.push(L),w.set(K,L));const $=E.relative(K.fsPath,B.fsPath);(0,C.assertIsDefined)(L.includePattern)[$.replace(/\\/g,"/")]=!0}else B.fsPath&&(F=!0,I[B.fsPath]=!0)}),{folderQueries:g,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(R,g){if(g.isSmartCase){if(R.isRegExp){if(A.containsUppercaseCharacter(R.pattern,!0))return!0}else if(A.containsUppercaseCharacter(R.pattern))return!0}return!!R.isCaseSensitive}isMultiline(R){return R.isMultiline||R.isRegExp&&(0,f.isMultilineRegexSource)(R.pattern)||R.pattern.indexOf(`
`)>=0?!0:!!R.isMultiline}parseSearchPaths(R){const g=L=>E.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),I=(Array.isArray(R)?R:r(R)).map(L=>{const $=this.pathService.resolvedUserHome;return $?(0,P.untildify)(L,$.scheme===k.Schemas.file?$.fsPath:$.path):L}),F=S.groupBy(I,L=>g(L)?"searchPaths":"exprSegments"),B=(F.exprSegments||[]).map(L=>A.rtrim(L,"/")).map(L=>A.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),l(L))),le={},H=this.expandSearchPathPatterns(F.searchPaths||[]);H&&H.length&&(le.searchPaths=H);const z=b.flatten(B),K=t(...z);return K&&(le.pattern=K),le}getExcludesForFolder(R,g){return g.disregardExcludeSettings?void 0:(0,d.getExcludes)(R,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(R){if(!R||!R.length)return[];const g=b.flatten(R.map(I=>{let{pathPortion:F,globPortion:B}=o(I);B&&(B=i(B));const le=this.expandOneSearchPath(F);return b.flatten(le.map(H=>this.resolveOneSearchPathPattern(H,B)))})),w=new Map;return g.forEach(I=>{const F=I.searchPath.toString(),B=w.get(F);B?I.pattern&&(B.pattern=B.pattern||{},B.pattern[I.pattern]=!0):w.set(F,{searchPath:I.searchPath,pattern:I.pattern?t(I.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(R){if(E.isAbsolute(R)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==k.Schemas.file?[{searchPath:g[0].uri.with({path:R})}]:[{searchPath:_.URI.file(E.normalize(R))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(R=a(R),R.startsWith("../")||R===".."){const I=E.posix.resolve(g.path,R);return[{searchPath:g.with({path:I})}]}const w=i(R);return[{searchPath:g,pattern:w}]}else{if(R==="./"||R===".\\")return[];{const g=R.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(g){const w=g[1],I=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===w);if(I.length)return I.map(F=>{const B=g[2];return{searchPath:F.uri,pattern:B&&i(B)}});{const F=s.localize(0,null,w);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(R,g){const w=R.pattern&&g?`${R.pattern}/${g}`:R.pattern||g,I=[{searchPath:R.searchPath,pattern:w}];return w&&!w.endsWith("**")&&I.push({searchPath:R.searchPath,pattern:w+"/**"}),I}getFolderQueryForSearchPath(R,g,w){const I=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(R.searchPath),g,w,!1);return I?Object.assign(Object.assign({},I),{includePattern:R.pattern}):null}getFolderQueryForRoot(R,g,w,I){let F;const B=_.URI.isUri(R)?R:R.uri;if(w.searchPaths){const L=w.searchPaths.filter($=>(0,n.isEqual)($.searchPath,B))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const le=this.configurationService.getValue({resource:B}),H=this.getExcludesForFolder(le,g),z=Object.assign(Object.assign({},H||{}),F||{}),K=_.URI.isUri(R)?(0,n.basename)(R):R.name;return{folder:B,folderName:I?K:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:le.files&&le.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!le.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!le.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!le.search.followSymlinks}}};c=je([qe(0,h.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,v.IPathService)],c),e.QueryBuilder=c;function o(D){const R=D.match(/[\*\{\}\(\)\[\]\?]/);if(R){const g=R.index,w=D.substr(0,g).match(/[/|\\][^/\\]*$/);if(w){let I=D.substr(0,w.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:D.substr((w.index||0)+1)}}}return{pathPortion:D}}function t(...D){return D.length?D.reduce((R,g)=>(R[g]=!0,R),Object.create(null)):void 0}function r(D){return T.splitGlobAware(D,",").map(R=>R.trim()).filter(R=>!!R.length)}function l(D){return[`**/${D}/**`,`**/${D}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function a(D){return D.replace(/\\/g,"/")}function i(D){return a(D).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(D,R){D=b.distinct(D,I=>I.toString());const g=[],w=R.getWorkspace();return D&&D.forEach(I=>{let F;if(R.getWorkbenchState()===2)F=(0,n.relativePath)(w.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const B=R.getWorkspaceFolder(I);if(B){const le=B.name;if(w.folders.filter(z=>z.name===le).length===1){const z=(0,n.relativePath)(B.uri,I);z===""?F=`./${B.name}`:F=`./${B.name}/${z}`}else F=I.fsPath}}F&&g.push(F)}),g}e.resolveResourcesForSearchIncludes=u}),define(we[215],Ee([0,1,24,2,20,10,4,214,42,48]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function C(h,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const v=[],d=[];for(const a of m)if(/^workspaceContains:/.test(a)){const i=a.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||h.forceUsingSearch?d.push(i):v.push(i)}if(v.length===0&&d.length===0)return Promise.resolve(void 0);let c;const o=new Promise((a,i)=>{c=a}),t=a=>c({activationEvent:a}),r=Promise.all(v.map(a=>_(h,a,t))).then(()=>{}),l=f(h,p.identifier,d,t);return Promise.all([r,l]).then(()=>{c(void 0)}),o}e.checkActivateWorkspaceContainsExtension=C;async function _(h,p,m){for(const v of h.folders)if(await h.exists(b.joinPath(S.URI.revive(v),p))){m(`workspaceContains:${p}`);return}}async function f(h,p,m,v){if(m.length===0)return Promise.resolve(void 0);const d=new T.CancellationTokenSource,c=h.checkExists(h.folders,m,d.token),o=setTimeout(async()=>{d.cancel(),v(`workspaceContainsTimeout:${m.join(",")}`)},A);let t=!1;try{t=await c}catch(r){P.isPromiseCanceledError(r)||P.onUnexpectedError(r)}d.dispose(),clearTimeout(o),t&&v(`workspaceContains:${m.join(",")}`)}function s(h,p,m,v){const d=h.get(y.IInstantiationService),c=h.get(E.ISearchService),t=d.createInstance(k.QueryBuilder).file(p.map(r=>(0,n.toWorkspaceFolder)(S.URI.revive(r))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(t,v).then(r=>!!r.limitHit,r=>P.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(oe,e,b){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,b),b},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[36],Ee([0,1,129,11,77,24,13,6,22,2,19,5,35,181,75,31,34,179,10,25,16,26,157,7,90,4,27,76,14,65,67,41,3,215,71,158]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d,c,o,t,r,l,a,i,u,D,R,g,w,I,F,B,le){"use strict";var H,z,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let L=class kn extends k.Disposable{constructor(N,Z,ne,re,ye,Ae,Be,Re,xe,W){super();this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=ne,this._initData=Be,this._extHostWorkspace=re,this._extHostConfiguration=ye,this._logService=Ae,this._extHostTunnelService=xe,this._extHostTerminalService=W,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=N.createChild(new R.ServiceCollection([s.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const q=new Set;this._initData.hostExtensions.forEach(J=>q.add(d.ExtensionIdentifier.toKey(J))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(J,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(J,ae)},actualActivateExtension:async(J,ae)=>{if(q.has(d.ExtensionIdentifier.toKey(J)))return await this._mainThreadExtensionsProxy.$activateExtension(J,ae),new f.HostExtension;const ge=this._registry.getExtensionDescription(J);return this._activateExtension(ge,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){v.onUnexpectedError(N)}}async deactivateAll(){let N=[];try{N=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,Z){return this._activator.activateByEvent(N,Z)}_activateById(N,Z){return this._activator.activateById(N,Z)}activateByIdWithErrors(N,Z){return this._activateById(N,Z).then(()=>{const ne=this._activator.getActivatedExtension(N);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=E.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(re=>N.set(n.URI.file(re).fsPath,ne))});this._extensionPathIndex=Promise.all(Z).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return Z;const ne=this._activator.getActivatedExtension(N);if(!ne)return Z;try{typeof ne.module.deactivate=="function"&&(Z=Promise.resolve(ne.module.deactivate()).then(void 0,re=>Promise.resolve(void 0)))}catch(re){}try{(0,k.dispose)(ne.subscriptions)}catch(re){}return Z}async _activateExtension(N,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,Z).then(ne=>{const re=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,Z),this._logExtensionActivationTimes(N,Z,"success",re),ne},ne=>{throw this._logExtensionActivationTimes(N,Z,"failure"),ne})}_logExtensionActivationTimes(N,Z,ne,re){const ye=$(N,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),re||{}),{outcome:ne}))}_doActivateExtension(N,Z){const ne=$(N,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const re=this._getEntryPoint(N);if(!re)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new f.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,P.joinPath)(N.extensionLocation,re),ye),this._loadExtensionContext(N)]).then(Ae=>(T.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),kn._callActivate(this._logService,N.identifier,Ae[0],Ae[1],ye))).then(Ae=>(T.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),Ae))}_loadExtensionContext(N){const Z=new t.ExtensionGlobalMemento(N,this._storage),ne=new t.ExtensionMemento(N.identifier.value,!1,this._storage),re=new le.ExtensionSecrets(N,this._secretState),ye=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ae=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([Z.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Re;return Object.freeze({globalState:Z,workspaceState:ne,secrets:re,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(xe){return S.join(N.extensionLocation.fsPath,xe)},get storagePath(){var xe;return(xe=Be._storagePath.workspaceValue(N))===null||xe===void 0?void 0:xe.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(N).fsPath},get logPath(){return S.join(Be._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return n.URI.joinPath(Be._initData.logsLocation,N.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(N)},get globalStorageUri(){return Be._storagePath.globalValue(N)},get extensionMode(){return ye},get extension(){return(0,p.checkProposedApiEnabled)(N),Re===void 0&&(Re=new U(this,N.identifier,N,Ae)),Re},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(N),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,Z,ne,re,ye){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,Z,ne,re,ye).then(Ae=>new f.ActivatedExtension(!1,null,ye.build(),ne,Ae,re.subscriptions))}static _callActivateOptional(N,Z,ne,re,ye){if(typeof ne.activate=="function")try{ye.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Ae=typeof global=="object"?global:self,Be=ne.activate.apply(Ae,[re]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Be).then(Re=>(ye.activateResolveStop(),Re))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(ne)}_activateOneStartupFinished(N,Z){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:Z}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const Z of N.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(N,Z)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Z),re=Promise.all([N,ne]).then(()=>{});return Promise.race([re,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(N,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,Z){if(!this.isActivated(Z.identifier)){const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={folders:N.map(Ae=>Ae.uri),forceUsingSearch:ne,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Be,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Be,Re)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(re,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}}async $extensionTestsExecute(){await this._readyToRunExtensions.wait();try{return this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:Z}=this._initData.environment;if(!N||!Z||Z.scheme!==c.Schemas.file)throw new Error(b.localize(0,null));const ne=(0,P.originalFSPath)(Z),re=await this._loadCommonJSModule(null,Z,new f.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(b.localize(1,null,ne));return new Promise((ye,Ae)=>{const Be=(xe,W)=>{xe?Ae(xe):ye(typeof W=="number"&&W>0?1:0)},Re=re.run(ne,Be);Re&&Re.then&&Re.then(()=>{ye(0)}).catch(xe=>{Ae(xe.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,Z){return this._resolvers[N]=Z,(0,k.toDisposable)(()=>{delete this._resolvers[N]})}async $resolveAuthority(N,Z){const ne=N.indexOf("+");if(ne===-1)throw new Error("Not an authority that can be resolved!");const re=N.substr(0,ne);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1);const ye=this._resolvers[re];if(!ye)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${re}`);const Ae=await ye.resolve(N,{resolveAttempt:Z});T.mark(`code/extHost/didResolveAuthorityOK/${re}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const Be={authority:N,host:Ae.host,port:Ae.port,connectionToken:Ae.connectionToken},Re={extensionHostEnv:Ae.extensionHostEnv};return{type:"ok",value:{authority:Be,options:Re,tunnelInformation:{environmentTunnels:Ae.environmentTunnels}}}}catch(Ae){if(T.mark(`code/extHost/didResolveAuthorityError/${re}`),Ae instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Ae._code,message:Ae._message,detail:Ae._detail}};throw Ae}}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,Z){return Z===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(N,!1))}async $activate(N,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,Z),!0):!1}async $deltaExtensions(N,Z){N.forEach(re=>re.extensionLocation=n.URI.revive(re.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Z.map(async re=>{const ye=this._registry.getExtensionDescription(re);if(!!ye){const Ae=await this._hostUtils.realpath(ye.extensionLocation.fsPath);ne.delete(n.URI.file(Ae).fsPath)}})),await Promise.all(N.map(async re=>{const ye=await this._hostUtils.realpath(re.extensionLocation.fsPath);ne.set(n.URI.file(ye).fsPath,re)})),this._registry.deltaExtensions(N,Z),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let Z=o.VSBuffer.alloc(N),ne=Math.random()%256;for(let re=0;re<N;re++)Z.writeUInt8(ne,re);return Z}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};L=je([qe(0,a.IInstantiationService),qe(1,e.IHostUtils),qe(2,D.IExtHostRpcService),qe(3,h.IExtHostWorkspace),qe(4,_.IExtHostConfiguration),qe(5,A.ILogService),qe(6,i.IExtHostInitDataService),qe(7,u.IExtensionStoragePaths),qe(8,g.IExtHostTunnelService),qe(9,w.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function $(G,N){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class U{constructor(N,Z,ne,re){H.set(this,void 0),z.set(this,void 0),K.set(this,void 0),tt(this,H,N),tt(this,z,Z),tt(this,K,ne.identifier),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=S.normalize((0,P.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=re}get isActive(){return We(this,H).isActivated(We(this,K))}get exports(){if(this.packageJSON.api!=="none")return We(this,H).getExtensionExports(We(this,K))}activate(){return We(this,H).activateByIdWithErrors(We(this,K),{startup:!1,extensionId:We(this,z),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,H=new WeakMap,z=new WeakMap,K=new WeakMap}),define(we[101],Ee([0,1,11,2,3,13,5,7,164,31,36,40,169,35,165,14,4,12,32]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let d=class{constructor(u,D,R,g,w){this._workspaceService=D,this._extensionService=R,this._editorsService=g,this._configurationService=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=u.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(F=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,D){const R=u;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let g=`debug:${encodeURIComponent(R.path||"")}`,w="?";return D&&(g+=`${w}session=${encodeURIComponent(D.id)}`,w="&"),g+=`${w}ref=${R.sourceReference}`,S.URI.parse(g)}else{if(R.path)return S.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const D=[];for(const R of u.getAllExtensionDescriptions())if(R.contributes){const g=R.contributes.debuggers;if(g&&g.length>0)for(const w of g)(0,s.isDebuggerMainContribution)(w)&&D.push(w.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(D=>u.push(D)),u}addBreakpoints(u){this.startBreakpoints();const D=u.filter(w=>{const I=w.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,w),!0)});this.fireBreakpointChanges(D,[],[]);const R=[],g=new Map;for(const w of D)if(w instanceof k.SourceBreakpoint){let I=g.get(w.location.uri.toString());I||(I={type:"sourceMulti",uri:w.location.uri,lines:[]},g.set(w.location.uri.toString(),I),R.push(I)),I.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof k.FunctionBreakpoint&&R.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(u){this.startBreakpoints();const D=u.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],D,[]);const R=D.filter(I=>I instanceof k.SourceBreakpoint).map(I=>I.id),g=D.filter(I=>I instanceof k.FunctionBreakpoint).map(I=>I.id),w=D.filter(I=>I instanceof k.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(R,g,w)}startDebugging(u,D,R){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,D,{parentSessionID:R.parentSession?R.parentSession.id:void 0,repl:R.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,D,R){if(!D)return new k.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:g,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,R,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,g),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(u,D,R){if(!R)return new k.Disposable(()=>{});if(!this.definesDebugType(u,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:g,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,g),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(u,D){if(!D)return new k.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:R,factory:D}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==D)})}async $runInTerminal(u,D){return Promise.resolve(void 0)}async $substituteVariables(u,D){if(!this._variableResolver){const[w,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,I)}let R;const g=await this.getFolder(u);return g&&(R={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(R,D)}createDebugAdapter(u,D){if(u.type==="implementation")return new l(u.implementation)}createSignService(){}async $startDASession(u,D){const R=this,g=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const I=this.convertToDto(w),F=this.createDebugAdapter(I,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const B=F;return this._debugAdapters.set(u,B),this.getDebugAdapterTrackers(g).then(le=>(le&&this._debugAdaptersTrackers.set(u,le),B.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const z=H,K={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(z.arguments.value);K.body={signature:L},B.sendResponse(K)}else throw new Error("no signer")}catch(L){K.success=!1,K.message=L.message,B.sendResponse(K)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(H),H=(0,s.convertToVSCPaths)(H,!0),R._debugServiceProxy.$acceptDAMessage(u,H)}),B.onError(H=>{le&&le.onError&&le.onError(H),this._debugServiceProxy.$acceptDAError(u,H.name,H.message,H.stack)}),B.onExit(H=>{le&&le.onExit&&le.onExit((0,m.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,m.withNullAsUndefined)(H),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),B.startSession()))})}$sendDAMessage(u,D){D=(0,s.convertToDAPaths)(D,!1);const R=this._debugAdaptersTrackers.get(u);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(D);const g=this._debugAdapters.get(u);g&&g.sendMessage(D)}$stopDASession(u){const D=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),D&&D.onWillStopSession&&D.onWillStopSession();const R=this._debugAdapters.get(u);return this._debugAdapters.delete(u),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const D=[],R=[],g=[];if(u.added)for(const w of u.added){const I=w.id;if(I&&!this._breakpoints.has(I)){let F;if(w.type==="function")F=new k.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")F=new k.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const B=S.URI.revive(w.uri);F=new k.SourceBreakpoint(new k.Location(B,new k.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}F._id=I,this._breakpoints.set(I,F),D.push(F)}}if(u.removed)for(const w of u.removed){const I=this._breakpoints.get(w);I&&(this._breakpoints.delete(w),R.push(I))}if(u.changed){for(const w of u.changed)if(w.id){const I=this._breakpoints.get(w.id);if(I){if(I instanceof k.FunctionBreakpoint&&w.type==="function"){const F=I;F.enabled=w.enabled,F.condition=w.condition,F.hitCondition=w.hitCondition,F.logMessage=w.logMessage,F.functionName=w.functionName}else if(I instanceof k.SourceBreakpoint&&w.type==="source"){const F=I;F.enabled=w.enabled,F.condition=w.condition,F.hitCondition=w.hitCondition,F.logMessage=w.logMessage,F.location=new k.Location(S.URI.revive(w.uri),new k.Position(w.line,w.character))}g.push(I)}}}this.fireBreakpointChanges(D,R,g)}$provideDebugConfigurations(u,D,R){return(0,P.asPromise)(async()=>{const g=this.getConfigProviderByHandle(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(D);return g.provideDebugConfigurations(w,R)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(u,D,R,g){return(0,P.asPromise)(async()=>{const w=this.getConfigProviderByHandle(u);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(D);return w.resolveDebugConfiguration(I,R,g)})}$resolveDebugConfigurationWithSubstitutedVariables(u,D,R,g){return(0,P.asPromise)(async()=>{const w=this.getConfigProviderByHandle(u);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(D);return w.resolveDebugConfigurationWithSubstitutedVariables(I,R,g)})}async $provideDebugAdapter(u,D){const R=this.getAdapterDescriptorFactoryByHandle(u);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(D);return this.getAdapterDescriptor(R,g).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(u){const D=await this.getSession(u);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(u){const D=await this.getSession(u);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,D){const R=await this.getSession(u);R&&R._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(u,D){const g={session:await this.getSession(u),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(u){if(u instanceof k.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof k.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const D=this._adapterFactories.filter(R=>R.type===u);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(u){const D=this._adapterFactories.filter(R=>R.handle===u);if(D.length>0)return D[0].factory}getConfigProviderByHandle(u){const D=this._configProviders.filter(R=>R.handle===u);if(D.length>0)return D[0].provider}definesDebugType(u,D){if(u.contributes){const R=u.contributes.debuggers;if(R&&R.length>0){for(const g of R)if(g.label&&g.type&&g.type===D)return!0}}return!1}getDebugAdapterTrackers(u){const R=u.configuration.type,g=this._trackerFactories.filter(w=>w.type===R||w.type==="*").map(w=>(0,P.asPromise)(()=>w.factory.createDebugAdapterTracker(u)).then(I=>I,I=>null));return Promise.race([Promise.all(g).then(w=>{const I=w.filter(F=>!!F);if(I.length>0)return new r(I)}),new Promise((w,I)=>{const F=setTimeout(()=>{clearTimeout(F),I(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(u,D){const R=D.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new k.DebugAdapterServer(R));if(u){const w=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>u.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,w))).then(I=>{if(I)return I})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,g))}daExecutableFromPackage(u,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,D,R){(u.length>0||D.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:D,changed:R}))}async getSession(u){if(u)if(typeof u=="string"){const D=this._debugSessions.get(u);if(D)return D}else{let D=this._debugSessions.get(u.id);if(!D){const R=await this.getFolder(u.folderUri);D=new c(this._debugServiceProxy,u.id,u.type,u.name,R,u.configuration),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(u){if(u){const D=S.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};d=je([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,C.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class c{constructor(u,D,R,g,w,I){this._debugServiceProxy=u,this._id=D,this._type=R,this._name=g,this._workspaceFolder=w,this._configuration=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,D)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=c;class o{constructor(u){this.value=Object.freeze({append(D){u.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=o;class t extends _.AbstractVariableResolverService{constructor(u,D,R,g){super({getFolderUri:w=>{const I=u.filter(F=>F.name===w);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(w,I)=>R.getConfiguration(void 0,w).get(I),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(D){const w=D.activeEditor();if(w)return b.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(D&&g){const w=D.activeEditor();if(w){const I=g.getWorkspaceFolder(w.document.uri);if(I)return b.normalize(I.uri.fsPath)}}},getSelectedText:()=>{if(D){const w=D.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(D){const w=D.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,v.env)}}e.ExtHostVariableResolverService=t;class r{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(D=>D.onError?D.onError(u):void 0)}onExit(u,D){this.trackers.forEach(R=>R.onExit?R.onExit(u,D):void 0)}}class l extends E.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(u,D,R,g,w){super(u,D,R,g,w)}createVariableResolver(u,D,R){return new t(u,D,R)}};a=je([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,C.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(we[216],Ee([0,1,77,2,5,35,34,25,14,27,4,36,32,19]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(d,c,o,t,r,l,a){this._apiFactory=d,this._extensionRegistry=c,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=l,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,c,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,c,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let c of d.nodeModuleName)this._factories.set(c,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(c=>d.alternativeModuleName(c))}};s=je([qe(2,A.IInstantiationService),qe(3,P.IExtHostConfiguration),qe(4,C.IExtHostExtensionService),qe(5,n.IExtHostInitDataService),qe(6,f.ILogService)],s),e.RequireInterceptor=s;class h{constructor(d,c,o,t,r){this._apiFactory=d,this._extensionPaths=c,this._extensionRegistry=o,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,c){const o=this._extensionPaths.findSubstr(c.fsPath);if(o){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,l)=>t+=`	${l} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(d,c){this.nodeModuleName="keytar";const{environment:o}=c,t=d.getProxy(T.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;_.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,l)=>t.$getPassword(r,l),setPassword:(r,l,a)=>t.$setPassword(r,l,a),deletePassword:(r,l)=>t.$deletePassword(r,l),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(d,c){return this._impl}alternativeModuleName(d){const c=d.length;if(!(c<=7||!this.alternativeNames)){const o=c-7;if((d.charAt(o)==="/"||d.charAt(o)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};p=je([qe(0,E.IExtHostRpcService),qe(1,n.IExtHostInitDataService)],p);let m=class{constructor(d,c,o){this._extensionPaths=d,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(T.MainContext.MainThreadTelemetry);const t=o.getProxy(T.MainContext.MainThreadWindow);this._impl=(r,l)=>{const a=S.URI.parse(r);return l?this.callOriginal(r,l):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,r,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,r,{}):this.callOriginal(r,l)}}load(d,c,o){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(d),this._impl}callOriginal(d,c){return this.sendNoForwardTelemetry(),this._original(d,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([qe(2,E.IExtHostRpcService)],m)}),define(we[217],Ee([0,1,13,10,77,6,2,5,209,19,61,65,27,147,14,68,36,41]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(c,o,t,r){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new E.RPCProtocol(c,null,r);o=v._transform(o,l);const a=new C.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());a.set(_.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(l)),a.set(h.IURITransformerService,new h.URITransformerService(r)),a.set(p.IHostUtils,t);const i=new f.InstantiationService(a,!0),u=i.invokeFunction(w=>w.get(m.IExtHostTerminalService));this._disposables.add(u),this._logService=i.invokeFunction(w=>w.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=i.invokeFunction(w=>w.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const D=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(I,F)=>{let B="",le,H;for(const z of F)B+=`
	at ${z.toString()}`,H=z.getFileName(),!le&&H&&(le=w.findSubstr(H));return D.set(I,le),`${I.name||"Error"}: ${I.message||""}${B}`}});const R=l.getProxy(k.MainContext.MainThreadExtensionService),g=l.getProxy(k.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(w=>{const I=S.transformErrorForSerialization(w),F=D.get(w);F?R.$onExtensionRuntimeError(F.identifier,I):g.$onUnexpectedError(I)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),S.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,o){c.extensions.forEach(r=>r.extensionLocation=y.URI.revive(o.transformIncomingURIs(r.extensionLocation))),c.environment.appRoot=y.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(r=>y.URI.revive(o.transformIncomingURIs(r)))),c.environment.extensionTestsLocationURI=y.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(o.transformIncomingURIs(c.logFile)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=v}),define(we[218],Ee([0,1,11,20,60,28,24,55,42,32]),function(oe,e,b,S,T,P,y,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(f,s,h){this.config=f,this.provider=s,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&P.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&P.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const s=this.config.folderQueries||[];return new Promise((h,p)=>{const m=v=>{this.resultCount++,f(v)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const d=v.toString(),c=b.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,c)||this.matchFile(m,{base:v,basename:c})}),Promise.all(s.map(v=>this.searchInFolder(v,m))).then(v=>{h({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{p(new Error((0,T.toErrorMessage)(v)))})})}searchInFolder(f,s){const h=new S.CancellationTokenSource;return new Promise((p,m)=>{const v=this.getSearchOptionsForFolder(f),d=this.initDirectoryTree(),c=new E.QueryGlobTester(this.config,f),o=!c.hasSiblingExcludeClauses();let t;new Promise(r=>(0,n.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(h),t=k.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,h.token))).then(r=>{const l=t.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(i=>{const u=b.posix.relative(f.folder.path,i.path);if(o){const D=b.basename(i.path);this.matchFile(s,{base:f.folder,relativePath:u,basename:D});return}this.addDirectoryEntries(d,f.folder,u,s)}),this.activeCancellationTokens.delete(h),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,c,s),{providerTime:l,postProcessTime:a.elapsed()})}).then(r=>{h.dispose(),p(r)},r=>{h.dispose(),m(r)})})}getSearchOptionsForFolder(f){const s=(0,E.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),h=(0,E.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:h,includes:s,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},s,h,p){if(h===this.filePattern){const v=b.basename(this.filePattern);this.matchFile(p,{base:s,relativePath:this.filePattern,basename:v})}function m(v){const d=b.basename(v),c=b.dirname(v);let o=f[c];o||(o=f[c]=[],m(c)),o.push({base:s,relativePath:v,basename:d})}m(h)}matchDirectoryTree({rootEntries:f,pathToEntries:s},h,p){const m=this,v=this.filePattern;function d(c){const o=P.hasSiblingFn(()=>c.map(t=>t.basename));for(let t=0,r=c.length;t<r;t++){const l=c[t],{relativePath:a,basename:i}=l;if(!!h.includedInQuerySync(a,i,v!==i?o:void 0)){const u=s[a];if(u)d(u);else{if(a===v)continue;m.matchFile(p,l)}if(m.isLimitHit)break}}}d(f)}matchFile(f,s){(!this.includePattern||s.relativePath&&this.includePattern(s.relativePath,s.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(s))}}class C{constructor(){this.sessions=new Map}fileSearch(f,s,h,p){const m=this.getSessionTokenSource(f.cacheKey),v=new A(f,s,m&&m.token);let d=0;const c=o=>{d+=o.length,h(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(v,C.BATCH_SIZE,c,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:o.stats}}))}clearCache(f){const s=this.getSessionTokenSource(f);s&&s.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new S.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,s,h,p){p.onCancellationRequested(()=>{f.cancel()});const m=d=>{d&&(v.push(d),s>0&&v.length>=s&&(h(v),v=[]))};let v=[];return f.search(m).then(d=>(v.length&&h(v),d),d=>(v.length&&h(v),Promise.reject(d)))}}e.FileSearchManager=C,C.BATCH_SIZE=512}),define(we[219],Ee([0,1,11,15,20,60,24,28,2,42,32,16]),function(oe,e,b,S,T,P,y,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(d,c,o){this.query=d,this.provider=c,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,c){const o=this.query.folderQueries||[],t=new T.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((r,l)=>{this.collector=new s(d);let a=!1;const i=(u,D)=>{if(!a&&!this.isLimitHit){const R=this.resultSize(u);p(u)&&typeof this.query.maxResults=="number"&&this.resultCount+R>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const g=this.resultSize(u);this.resultCount+=g,(g>0||!p(u))&&this.collector.add(u,D)}};Promise.all(o.map((u,D)=>this.searchInFolder(u,R=>i(R,D),t.token))).then(u=>{t.dispose(),this.collector.flush();const D=u.some(R=>!!R&&!!R.limitHit);r({limitHit:this.isLimitHit||D,stats:{type:"textSearchProvider"}})},u=>{t.dispose();const D=(0,P.toErrorMessage)(u);l(new Error(D))})})}resultSize(d){return p(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,c){const o=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:o.slice(0,c),preview:{matches:t.slice(0,c),text:d.preview.text},uri:d.uri}}searchInFolder(d,c,o){const t=new n.QueryGlobTester(this.query,d),r=[],l={report:i=>{if(!!this.validateProviderResult(i)){const u=d.folder.scheme===C.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(i.uri))):void 0,D=y.relativePath(d.folder,i.uri);D&&r.push(t.includedInQuery(D,b.basename(D),u).then(R=>{R&&c(i)}))}}},a=this.getSearchOptionsForFolder(d);return new Promise(i=>(0,A.nextTick)(i)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),a,l,o)).then(i=>Promise.all(r).then(()=>i))}validateProviderResult(d){if(p(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const c=(0,n.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),o=(0,n.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:E.URI.from(d.folder),excludes:o,includes:c,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=_;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class s{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,c=>this.sendItems(c))}add(d,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=s;function h(v){return p(v)?{preview:{matches:(0,S.mapArrayOrNot)(v.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:v.preview.text},ranges:(0,S.mapArrayOrNot)(v.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function p(v){return!!v.preview}e.extensionResultIsMatch=p;class m{constructor(d,c){this.maxBatchSize=d,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,c){!d||this.addItemToBatch(d,c)}addItems(d,c){!d||this.addItemsToBatch(d,c)}addItemToBatch(d,c){this.batch.push(d),this.batchSize+=c,this.onUpdate()}addItemsToBatch(d,c){this.batch=this.batch.concat(d),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[102],Ee([0,1,6,5,4,218,14,68,19,2,219]),function(oe,e,b,S,T,P,y,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(h,p,m){this.extHostRpc=h,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(S.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,p){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(h,p){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(h,p,m,v){const d=_(m),c=this._fileSearchProvider.get(h);if(c)return this._fileSearchManager.fileSearch(d,c,o=>{this._proxy.$handleFileMatch(h,p,o.map(t=>t.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,p,m,v){const d=this._textSearchProvider.get(h);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const c=_(m);return this.createTextSearchManager(c,d).search(t=>this._proxy.$handleTextMatch(h,p,t),v)}createTextSearchManager(h,p){return new A.TextSearchManager(h,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};C=je([qe(0,y.IExtHostRpcService),qe(1,k.IURITransformerService),qe(2,E.ILogService)],C),e.ExtHostSearch=C;function _(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(f),extraFileResources:s.extraFileResources&&s.extraFileResources.map(h=>n.URI.revive(h))})}e.reviveQuery=_;function f(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}}),define(we[220],Ee([0,1,126,20,10,3,47,2,120,82,114,59,64,5,186,185,73,187,35,188,189,190,172,191,40,36,192,173,194,195,196,98,176,198,199,200,75,41,201,177,9,7,204,50,99,31,34,51,161,193,91,97,100,101,102,19,68,14,27,197,160,67,72,183,202,159,76,74,207,205,206,184,49,213,203,71,156,93]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d,c,o,t,r,l,a,i,u,D,R,g,w,I,F,B,le,H,z,K,L,$,U,G,N,Z,ne,re,ye,Ae,Be,Re,xe,W,q,J,ae,ge,De,Le,pe,Ce,Te,Ue,be,Ke,V,X,_e,Me,He,Oe,Xe,x,ie,ce,j,Y,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(ve){const $e=ve.get(Le.IExtHostInitDataService),Ne=ve.get(x.IExtHostFileSystemInfo),Ve=ve.get(_e.IExtHostConsumerFileSystem),Qe=ve.get(a.IExtHostExtensionService),Ze=ve.get(ne.IExtHostWorkspace),ct=ve.get(se.IExtHostTelemetry),st=ve.get(v.IExtHostConfiguration),me=ve.get(ge.IURITransformerService),he=ve.get(De.IExtHostRpcService),ue=ve.get(H.IExtHostStorage),Q=ve.get(X.IExtensionStoragePaths),Ie=ve.get(ae.ILogService),Pe=ve.get(Te.IExtHostTunnelService),et=ve.get(Ue.IExtHostApiDeprecationService),Ge=ve.get(Z.IExtHostWindow),rt=ve.get(j.IExtHostSecretState);he.set(f.ExtHostContext.ExtHostFileSystemInfo,Ne),he.set(f.ExtHostContext.ExtHostLogService,Ie),he.set(f.ExtHostContext.ExtHostWorkspace,Ze),he.set(f.ExtHostContext.ExtHostConfiguration,st),he.set(f.ExtHostContext.ExtHostExtensionService,Qe),he.set(f.ExtHostContext.ExtHostStorage,ue),he.set(f.ExtHostContext.ExtHostTunnelService,Pe),he.set(f.ExtHostContext.ExtHostWindow,Ge),he.set(f.ExtHostContext.ExtHostSecretState,rt),he.set(f.ExtHostContext.ExtHostTelemetry,ct);const lt=he.set(f.ExtHostContext.ExtHostDecorations,ve.get(xe.IExtHostDecorations)),Je=he.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ve.get(l.IExtHostDocumentsAndEditors)),it=he.set(f.ExtHostContext.ExtHostCommands,ve.get(p.IExtHostCommands)),dt=he.set(f.ExtHostContext.ExtHostTerminalService,ve.get(z.IExtHostTerminalService)),at=he.set(f.ExtHostContext.ExtHostDebugService,ve.get(q.IExtHostDebugService)),Dt=he.set(f.ExtHostContext.ExtHostSearch,ve.get(J.IExtHostSearch)),gt=he.set(f.ExtHostContext.ExtHostTask,ve.get(W.IExtHostTask)),Ct=he.set(f.ExtHostContext.ExtHostOutputService,ve.get(w.IExtHostOutputService)),wt=he.set(f.ExtHostContext.ExtHostEditorTabs,new Y.ExtHostEditorTabs),Et=he.set(f.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(he)),mt=he.set(f.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(he,Je)),Rt=he.set(f.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(he,Je,Ie)),Ft=he.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ie,mt,he.getProxy(f.MainContext.MainThreadBulkEdits))),ht=he.set(f.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,it,Je,mt,$e.environment,Ie,Q)),yt=he.set(f.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(he,Je)),Ut=he.set(f.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(he.getProxy(f.MainContext.MainThreadTreeViews),it,Ie)),$t=he.set(f.ExtHostContext.ExtHostEditorInsets,new Ae.ExtHostEditorInsets(he.getProxy(f.MainContext.MainThreadEditorInsets),yt,$e.environment)),Lt=he.set(f.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Ie)),ut=he.set(f.ExtHostContext.ExtHostLanguageFeatures,new D.ExtHostLanguageFeatures(he,me,mt,it,Lt,Ie,et)),ln=he.set(f.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(he,ut)),It=he.set(f.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(he,Ie,Je)),At=he.set(f.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(he,Ze,it)),Yt=he.set(f.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(he,it,Ie)),un=he.set(f.ExtHostContext.ExtHostComments,new m.ExtHostComments(he,it,mt)),Xt=he.set(f.ExtHostContext.ExtHostProgress,new I.ExtHostProgress(he.getProxy(f.MainContext.MainThreadProgress))),cn=he.set(f.ExtHostContext.ExtHosLabelService,new Be.ExtHostLabelService(he)),Zt=he.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Pt=he.set(f.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(he)),Bt=he.set(f.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,it)),xt=he.set(f.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(he,$e.environment,Ze,Ie,et)),Ht=he.set(f.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(he,xt,Ze)),dn=he.set(f.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(he,mt,Q,xt,Ht)),hn=he.set(f.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(he,xt)),kt=he.set(f.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(he,Je,Ze)),fn=he.set(f.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(he)),mn=(0,ye.values)(f.ExtHostContext);he.assertRegistered(mn);const zt=new Xe.ExtHostBulkEdits(he,Je),gn=new h.ExtHostClipboard(he),Vt=new g.ExtHostMessageService(he,Ie),Wt=new c.ExtHostDialogs(he),Mt=new le.ExtHostStatusBar(he,it.converter),jt=new R.ExtHostLanguages(he,mt);return s.ExtHostApiCommands.register(it),function(Fe,Ot,qt){const ft=function(){let ee=!Fe.isUnderDevelopment;function de(ke){ee||(Ie.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ke(O){if(Array.isArray(O))O.forEach(ke);else if(typeof O=="string")de(O);else{const M=O;typeof M.scheme=="undefined"&&de(O),!Fe.enableProposedApi&&typeof M.exclusive=="boolean"&&(0,re.throwProposedApiError)(Fe)}return O}}(),pn={getSession(ee,de,ke){return Pt.getSession(Fe,ee,de,ke)},get onDidChangeSessions(){return Pt.onDidChangeSessions},registerAuthenticationProvider(ee,de,ke,O){return Pt.registerAuthenticationProvider(ee,de,ke,O)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Fe),Pt.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Fe),Pt.providers},logout(ee,de){return(0,re.checkProposedApiEnabled)(Fe),Pt.removeSession(ee,de)}},en={registerCommand(ee,de,ke){return it.registerCommand(!0,ee,de,ke)},registerTextEditorCommand(ee,de,ke){return it.registerCommand(!0,ee,(...O)=>{const M=yt.getActiveTextEditor();if(!M){Ie.warn("Cannot execute "+ee+" because there is no active text editor.");return}return M.edit(te=>{de.apply(ke,[M,te,...O])}).then(te=>{te||Ie.warn("Edits from command "+ee+" were not applied.")},te=>{Ie.warn("An error occurred while running command "+ee,te)})})},registerDiffInformationCommand:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),it.registerCommand(!0,ee,async(...O)=>{const M=Je.activeEditor(!0);if(!M){Ie.warn("Cannot execute "+ee+" because there is no active text editor.");return}const te=await yt.getDiffInformation(M.id);de.apply(ke,[te,...O])})),executeCommand(ee,...de){return it.executeCommand(ee,...de)},getCommands(ee=!1){return it.getCommands(ee)}},tn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var ee,de;return(de=(ee=$e.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return gn.value},get shell(){return dt.getDefaultShell(!1,qt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,de){return Ge.openUri(ee,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ee){return ee.scheme===$e.environment.appUriScheme?Et.createAppUri(ee):Ge.asExternalUri(ee,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Re.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(tn);const nn=$e.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Kt={registerTestProvider(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.registerTestProvider(ee)},createDocumentTestObserver(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.createWorkspaceTestObserver(ee)},runTests(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.runTests(ee)},publishTestResult(ee,de=!0){return(0,re.checkProposedApiEnabled)(Fe),kt.publishExtensionProvidedResults(ee,de)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Fe),kt.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Fe),kt.results}},vn={getExtension(ee){const de=Ot.getExtensionDescription(ee);if(de)return new a.Extension(Qe,Fe.identifier,de,nn)},get all(){return Ot.getAllExtensionDescriptions().map(ee=>new a.Extension(Qe,Fe.identifier,ee,nn))},get onDidChange(){return Ot.onDidChange}},_n={createDiagnosticCollection(ee){return Lt.createDiagnosticCollection(Fe.identifier,ee)},get onDidChangeDiagnostics(){return Lt.onDidChangeDiagnostics},getDiagnostics:ee=>Lt.getDiagnostics(ee),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(ee,de){return jt.changeLanguage(ee.uri,de)},match(ee,de){return(0,C.score)($.LanguageSelector.from(ee),de.uri,de.languageId,!0)},registerCodeActionsProvider(ee,de,ke){return ut.registerCodeActionProvider(Fe,ft(ee),de,ke)},registerCodeLensProvider(ee,de){return ut.registerCodeLensProvider(Fe,ft(ee),de)},registerDefinitionProvider(ee,de){return ut.registerDefinitionProvider(Fe,ft(ee),de)},registerDeclarationProvider(ee,de){return ut.registerDeclarationProvider(Fe,ft(ee),de)},registerImplementationProvider(ee,de){return ut.registerImplementationProvider(Fe,ft(ee),de)},registerTypeDefinitionProvider(ee,de){return ut.registerTypeDefinitionProvider(Fe,ft(ee),de)},registerHoverProvider(ee,de){return ut.registerHoverProvider(Fe,ft(ee),de,Fe.identifier)},registerEvaluatableExpressionProvider(ee,de){return ut.registerEvaluatableExpressionProvider(Fe,ft(ee),de,Fe.identifier)},registerInlineValuesProvider(ee,de){return ut.registerInlineValuesProvider(Fe,ft(ee),de,Fe.identifier)},registerDocumentHighlightProvider(ee,de){return ut.registerDocumentHighlightProvider(Fe,ft(ee),de)},registerLinkedEditingRangeProvider(ee,de){return ut.registerLinkedEditingRangeProvider(Fe,ft(ee),de)},registerReferenceProvider(ee,de){return ut.registerReferenceProvider(Fe,ft(ee),de)},registerRenameProvider(ee,de){return ut.registerRenameProvider(Fe,ft(ee),de)},registerDocumentSymbolProvider(ee,de,ke){return ut.registerDocumentSymbolProvider(Fe,ft(ee),de,ke)},registerWorkspaceSymbolProvider(ee){return ut.registerWorkspaceSymbolProvider(Fe,ee)},registerDocumentFormattingEditProvider(ee,de){return ut.registerDocumentFormattingEditProvider(Fe,ft(ee),de)},registerDocumentRangeFormattingEditProvider(ee,de){return ut.registerDocumentRangeFormattingEditProvider(Fe,ft(ee),de)},registerOnTypeFormattingEditProvider(ee,de,ke,...O){return ut.registerOnTypeFormattingEditProvider(Fe,ft(ee),de,[ke].concat(O))},registerDocumentSemanticTokensProvider(ee,de,ke){return ut.registerDocumentSemanticTokensProvider(Fe,ft(ee),de,ke)},registerDocumentRangeSemanticTokensProvider(ee,de,ke){return ut.registerDocumentRangeSemanticTokensProvider(Fe,ft(ee),de,ke)},registerSignatureHelpProvider(ee,de,ke,...O){return typeof ke=="object"?ut.registerSignatureHelpProvider(Fe,ft(ee),de,ke):ut.registerSignatureHelpProvider(Fe,ft(ee),de,typeof ke=="undefined"?[]:[ke,...O])},registerCompletionItemProvider(ee,de,...ke){return ut.registerCompletionItemProvider(Fe,ft(ee),de,ke)},registerDocumentLinkProvider(ee,de){return ut.registerDocumentLinkProvider(Fe,ft(ee),de)},registerColorProvider(ee,de){return ut.registerColorProvider(Fe,ft(ee),de)},registerFoldingRangeProvider(ee,de){return ut.registerFoldingRangeProvider(Fe,ft(ee),de)},registerSelectionRangeProvider(ee,de){return ut.registerSelectionRangeProvider(Fe,ee,de)},registerCallHierarchyProvider(ee,de){return ut.registerCallHierarchyProvider(Fe,ee,de)},setLanguageConfiguration:(ee,de)=>ut.setLanguageConfiguration(Fe,ee,de),getTokenInformationAtPosition(ee,de){return(0,re.checkProposedApiEnabled)(Fe),jt.tokenAtPosition(ee,de)},registerInlineHintsProvider(ee,de){return(0,re.checkProposedApiEnabled)(Fe),ut.registerInlineHintsProvider(Fe,ee,de)}},bn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ee,de,ke){const O=await(k.URI.isUri(ee)?Promise.resolve(rn.openTextDocument(ee)):Promise.resolve(ee));return yt.showTextDocument(O,de,ke)},createTextEditorDecorationType(ee){return yt.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,de,ke){return yt.onDidChangeActiveTextEditor(ee,de,ke)},onDidChangeVisibleTextEditors(ee,de,ke){return yt.onDidChangeVisibleTextEditors(ee,de,ke)},onDidChangeTextEditorSelection(ee,de,ke){return yt.onDidChangeTextEditorSelection(ee,de,ke)},onDidChangeTextEditorOptions(ee,de,ke){return yt.onDidChangeTextEditorOptions(ee,de,ke)},onDidChangeTextEditorVisibleRanges(ee,de,ke){return yt.onDidChangeTextEditorVisibleRanges(ee,de,ke)},onDidChangeTextEditorViewColumn(ee,de,ke){return yt.onDidChangeTextEditorViewColumn(ee,de,ke)},onDidCloseTerminal(ee,de,ke){return dt.onDidCloseTerminal(ee,de,ke)},onDidOpenTerminal(ee,de,ke){return dt.onDidOpenTerminal(ee,de,ke)},onDidChangeActiveTerminal(ee,de,ke){return dt.onDidChangeActiveTerminal(ee,de,ke)},onDidChangeTerminalDimensions(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),dt.onDidChangeTerminalDimensions(ee,de,ke)},onDidWriteTerminalData(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),dt.onDidWriteTerminalData(ee,de,ke)},get state(){return Ge.state},onDidChangeWindowState(ee,de,ke){return Ge.onDidChangeWindowState(ee,de,ke)},showInformationMessage(ee,...de){return Vt.showMessage(Fe,y.default.Info,ee,de[0],de.slice(1))},showWarningMessage(ee,...de){return Vt.showMessage(Fe,y.default.Warning,ee,de[0],de.slice(1))},showErrorMessage(ee,...de){return Vt.showMessage(Fe,y.default.Error,ee,de[0],de.slice(1))},showQuickPick(ee,de,ke){return At.showQuickPick(ee,!!Fe.enableProposedApi,de,ke)},showWorkspaceFolderPick(ee){return At.showWorkspaceFolderPick(ee)},showInputBox(ee,de){return At.showInput(ee,de)},showOpenDialog(ee){return Wt.showOpenDialog(ee)},showSaveDialog(ee){return Wt.showSaveDialog(ee)},createStatusBarItem(ee,de){let ke,O,M,te;return ee&&typeof ee!="number"?(ke=ee.id,O=ee.name,M=ee.alignment,de=ee.priority,te=ee.accessibilityInformation):(ke=Fe.identifier.value,O=b.localize(0,null,Fe.displayName||Fe.name),M=ee),Mt.createStatusBarEntry(ke,O,M,de,te)},setStatusBarMessage(ee,de){return Mt.setStatusBarMessage(ee,de)},withScmProgress(ee){return et.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Xt.withProgress(Fe,{location:U.ProgressLocation.SourceControl},(de,ke)=>ee({report(O){}}))},withProgress(ee,de){return Xt.withProgress(Fe,ee,de)},createOutputChannel(ee){return Ct.createOutputChannel(ee)},createWebviewPanel(ee,de,ke,O){return Ht.createWebviewPanel(Fe,ee,de,ke,O)},createWebviewTextEditorInset(ee,de,ke,O){return(0,re.checkProposedApiEnabled)(Fe),$t.createWebviewEditorInset(ee,de,ke,O,Fe)},createTerminal(ee,de,ke){return typeof ee=="object"?"pty"in ee?dt.createExtensionTerminal(ee):dt.createTerminalFromOptions(ee):dt.createTerminal(ee,de,ke)},registerTerminalLinkProvider(ee){return dt.registerLinkProvider(ee)},registerTreeDataProvider(ee,de){return Ut.registerTreeDataProvider(ee,de,Fe)},createTreeView(ee,de){return Ut.createTreeView(ee,de,Fe)},registerWebviewPanelSerializer:(ee,de)=>Ht.registerWebviewPanelSerializer(Fe,ee,de),registerCustomEditorProvider:(ee,de,ke={})=>dn.registerCustomEditorProvider(Fe,ee,de,ke),registerFileDecorationProvider(ee){return lt.registerFileDecorationProvider(ee,Fe.identifier)},registerUriHandler(ee){return Et.registerUriHandler(Fe.identifier,ee)},createQuickPick(){return At.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return At.createInputBox(Fe.identifier)},get activeColorTheme(){return Zt.activeColorTheme},onDidChangeActiveColorTheme(ee,de,ke){return Zt.onDidChangeActiveColorTheme(ee,de,ke)},registerWebviewViewProvider(ee,de,ke){return hn.registerWebviewViewProvider(Fe,ee,de,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Fe),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookEditor(ee,de,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorSelection(ee,de,ke)},onDidChangeNotebookEditorVisibleRanges(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorVisibleRanges(ee,de,ke)},showNotebookDocument(ee,de){return(0,re.checkProposedApiEnabled)(Fe),ht.showNotebookDocument(ee,de)},registerExternalUriOpener(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),fn.registerExternalUriOpener(Fe.identifier,ee,de,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},rn={get rootPath(){return et.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(ee){throw T.readonly()},getWorkspaceFolder(ee){return Ze.getWorkspaceFolder(ee)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(ee){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(ee){throw T.readonly()},updateWorkspaceFolders:(ee,de,...ke)=>Ze.updateWorkspaceFolders(Fe,ee,de||0,...ke),onDidChangeWorkspaceFolders:function(ee,de,ke){return Ze.onDidChangeWorkspace(ee,de,ke)},asRelativePath:(ee,de)=>Ze.getRelativePath(ee,de),findFiles:(ee,de,ke,O)=>Ze.findFiles($.GlobPattern.from(ee),$.GlobPattern.from(de),ke,Fe.identifier,O),findTextInFiles:(ee,de,ke,O)=>{let M,te;return typeof de=="object"?(M=de,te=ke):(M={},te=de,O=ke),Ze.findTextInFiles(ee,M||{},te,Fe.identifier,O)},saveAll:ee=>Ze.saveAll(ee),applyEdit(ee){return zt.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,de,ke,O)=>It.createFileSystemWatcher($.GlobPattern.from(ee),de,ke,O),get textDocuments(){return mt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw T.readonly()},openTextDocument(ee){let de;const ke=ee;if(typeof ee=="string")de=Promise.resolve(k.URI.file(ee));else if(k.URI.isUri(ee))de=Promise.resolve(ee);else if(!ke||typeof ke=="object")de=mt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(O=>mt.ensureDocumentData(O).then(M=>M.document))},onDidOpenTextDocument:(ee,de,ke)=>mt.onDidAddDocument(ee,de,ke),onDidCloseTextDocument:(ee,de,ke)=>mt.onDidRemoveDocument(ee,de,ke),onDidChangeTextDocument:(ee,de,ke)=>mt.onDidChangeDocument(ee,de,ke),onDidSaveTextDocument:(ee,de,ke)=>mt.onDidSaveDocument(ee,de,ke),onWillSaveTextDocument:(ee,de,ke)=>Ft.getOnWillSaveTextDocumentEvent(Fe)(ee,de,ke),onDidChangeConfiguration:(ee,de,ke)=>qt.onDidChangeConfiguration(ee,de,ke),getConfiguration(ee,de){return de=arguments.length===1?void 0:de,qt.getConfiguration(ee,de,Fe)},registerTextDocumentContentProvider(ee,de){return Rt.registerTextDocumentContentProvider(ee,de)},registerTaskProvider:(ee,de)=>(et.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Fe,ee,de)),registerFileSystemProvider(ee,de,ke){return ln.registerFileSystemProvider(Fe.identifier,ee,de,ke)},get fs(){return Ve.value},registerFileSearchProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Dt.registerFileSearchProvider(ee,de)),registerTextSearchProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Dt.registerTextSearchProvider(ee,de)),registerRemoteAuthorityResolver:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Qe.registerRemoteAuthorityResolver(ee,de)),registerResourceLabelFormatter:ee=>((0,re.checkProposedApiEnabled)(Fe),cn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,de,ke)=>It.onDidCreateFile(ee,de,ke),onDidDeleteFiles:(ee,de,ke)=>It.onDidDeleteFile(ee,de,ke),onDidRenameFiles:(ee,de,ke)=>It.onDidRenameFile(ee,de,ke),onWillCreateFiles:(ee,de,ke)=>It.getOnWillCreateFileEvent(Fe)(ee,de,ke),onWillDeleteFiles:(ee,de,ke)=>It.getOnWillDeleteFileEvent(Fe)(ee,de,ke),onWillRenameFiles:(ee,de,ke)=>It.getOnWillRenameFileEvent(Fe)(ee,de,ke),openTunnel:ee=>((0,re.checkProposedApiEnabled)(Fe),Pe.openTunnel(Fe,ee).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,re.checkProposedApiEnabled)(Fe),Pe.getTunnels()},onDidChangeTunnels:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),Pe.onDidChangeTunnels(ee,de,ke)),registerPortAttributesProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Pe.registerPortsAttributesProvider(ee,de)),registerTimelineProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Bt.registerTimelineProvider(ee,de,Fe.identifier,it.converter)),get trustState(){return(0,re.checkProposedApiEnabled)(Fe),(0,re.checkRequiresWorkspaceTrust)(Fe),Ze.trustState},requireWorkspaceTrust:ee=>((0,re.checkProposedApiEnabled)(Fe),(0,re.checkRequiresWorkspaceTrust)(Fe),Ze.requireWorkspaceTrust(ee)),onDidChangeWorkspaceTrustState:(ee,de,ke)=>Ze.onDidChangeWorkspaceTrustState(ee,de,ke)},wn={get inputBox(){return et.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Fe)},createSourceControl(ee,de,ke){return Yt.createSourceControl(Fe,ee,de,ke)}},sn={createCommentController(ee,de){return un.createCommentController(Fe,ee,de)}},En={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(ee,de,ke){return at.onDidStartDebugSession(ee,de,ke)},onDidTerminateDebugSession(ee,de,ke){return at.onDidTerminateDebugSession(ee,de,ke)},onDidChangeActiveDebugSession(ee,de,ke){return at.onDidChangeActiveDebugSession(ee,de,ke)},onDidReceiveDebugSessionCustomEvent(ee,de,ke){return at.onDidReceiveDebugSessionCustomEvent(ee,de,ke)},onDidChangeBreakpoints(ee,de,ke){return at.onDidChangeBreakpoints(ee,de,ke)},registerDebugConfigurationProvider(ee,de,ke){return at.registerDebugConfigurationProvider(ee,de,ke||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,de){return at.registerDebugAdapterDescriptorFactory(Fe,ee,de)},registerDebugAdapterTrackerFactory(ee,de){return at.registerDebugAdapterTrackerFactory(ee,de)},startDebugging(ee,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(ee,de,{parentSession:ke}):at.startDebugging(ee,de,ke||{})},stopDebugging(ee){return at.stopDebugging(ee)},addBreakpoints(ee){return at.addBreakpoints(ee)},removeBreakpoints(ee){return at.removeBreakpoints(ee)},asDebugSourceUri(ee,de){return at.asDebugSourceUri(ee,de)}},yn={registerTaskProvider:(ee,de)=>gt.registerTaskProvider(Fe,ee,de),fetchTasks:ee=>gt.fetchTasks(ee),executeTask:ee=>gt.executeTask(Fe,ee),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(ee,de,ke)=>gt.onDidStartTask(ee,de,ke),onDidEndTask:(ee,de,ke)=>gt.onDidEndTask(ee,de,ke),onDidStartTaskProcess:(ee,de,ke)=>gt.onDidStartTaskProcess(ee,de,ke),onDidEndTaskProcess:(ee,de,ke)=>gt.onDidEndTaskProcess(ee,de,ke)},Gt={openNotebookDocument:ee=>((0,re.checkProposedApiEnabled)(Fe),ht.openNotebookDocument(ee)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Fe),ht.notebookDocuments.map(ee=>ee.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),ht.registerNotebookContentProvider(Fe,ee,de,ke)),registerNotebookKernelProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),ht.registerNotebookKernelProvider(Fe,ee,de)),createNotebookEditorDecorationType(ee){return(0,re.checkProposedApiEnabled)(Fe),ht.createNotebookEditorDecorationType(ee)},onDidChangeNotebookDocumentMetadata(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookDocumentMetadata(ee,de,ke)},onDidChangeNotebookCells(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookCells(ee,de,ke)},onDidChangeCellOutputs(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeCellOutputs(ee,de,ke)},onDidChangeCellMetadata(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeCellMetadata(ee,de,ke)},createConcatTextDocument(ee,de){return(0,re.checkProposedApiEnabled)(Fe),new V.ExtHostNotebookConcatDocument(ht,mt,ee,de)},createCellStatusBarItem(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.createNotebookCellStatusBarItemInternal(ee,de,ke)}};return{version:$e.version,authentication:pn,commands:en,comments:sn,debug:En,env:tn,extensions:vn,languages:_n,notebook:Gt,scm:wn,tasks:yn,test:Kt,window:bn,workspace:rn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:_.FileType,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,Hover:U.Hover,IndentAction:A.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:k.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlineHint:U.InlineHint,InlineHintKind:U.InlineHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookCellRange:U.NotebookCellRange,NotebookCellKind:U.NotebookCellKind,NotebookCellRunState:U.NotebookCellRunState,NotebookDocumentMetadata:U.NotebookDocumentMetadata,NotebookCellMetadata:U.NotebookCellMetadata,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRunState:U.NotebookRunState,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,LinkedEditingRanges:U.LinkedEditingRanges,TestItem:U.TestItem,TestState:U.TestState,TestResult:U.TestResult,TestMessage:U.TestMessage,TestMessageSeverity:U.TestMessageSeverity,WorkspaceTrustState:U.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(we[221],Ee([0,1,61,98,31,97,35,73,40,41,100,101,102,76,75,67,72,99,74,49,71,93]),function(oe,e,b,S,T,P,y,k,E,n,A,C,_,f,s,h,p,m,v,d,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,b.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,b.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(v.IExtHostConsumerFileSystem,v.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,b.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,b.registerSingleton)(S.IExtHostOutputService,S.ExtHostOutputService),(0,b.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,b.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,b.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,b.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,b.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,b.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,b.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,b.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,b.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(we[222],Ee([0,1,220,36,216,7,13,5]),function(oe,e,b,S,T,P,y,k){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(s){var h;const p=(h=self.trustedTypes)===null||h===void 0?void 0:h.createPolicy("TrustedFunctionWorkaround",{createScript:(v,...d)=>{d.forEach(r=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(r)))throw new Error("TrustedScripts only, please")});const c=d.slice(0,-1).join(","),o=d.pop().toString();return`(function anonymous(${c}) {
${o}
})`}});function m(...v){return p?self.eval(p.createScript("",...v)):new Function(...v)}s.create=m})(n||(n={}));class A extends T.RequireInterceptor{_installInterceptor(){}getModule(h,p){for(let m of this._alternatives){let v=m(h);if(v){h=v;break}}if(this._factories.has(h))return this._factories.get(h).load(h,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const h=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);f(h);const p=this._instaService.invokeFunction(b.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(h){return h.browser}async _loadCommonJSModule(h,p,m){var v,d,c,o,t,r,l,a;p=p.with({path:_(p.path,".js")}),h&&performance.mark(`code/extHost/willFetchExtensionCode/${h.value}`);const i=await fetch(p.toString(!0));if(h&&performance.mark(`code/extHost/didFetchExtensionCode/${h.value}`),i.status!==200)throw new Error(i.statusText);const u=await i.text(),D=`${p.toString(!0)}#vscode-extension`,R=`${u}
//# sourceURL=${D}`;let g;try{g=n.create((d=(v=C._ttpExtensionScripts)===null||v===void 0?void 0:v.createScript("module"))!==null&&d!==void 0?d:"module",(o=(c=C._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&o!==void 0?o:"exports",(r=(t=C._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(a=(l=C._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(R))!==null&&a!==void 0?a:R)}catch(B){throw h?console.error(`Loading code for extension ${h.value} failed: ${B.message}`):console.error(`Loading code failed: ${B.message}`),console.error(`${p.toString(!0)}${typeof B.line=="number"?` line ${B.line}`:""}${typeof B.column=="number"?` column ${B.column}`:""}`),console.error(B),B}const w={},I={exports:w},F=B=>{const le=this._fakeModules.getModule(B,p);if(le===void 0)throw new Error(`Cannot load module '${B}'`);return le};try{return m.codeLoadingStart(),h&&performance.mark(`code/extHost/willLoadExtensionCode/${h.value}`),g(I,w,F),I.exports!==w?I.exports:w}finally{h&&performance.mark(`code/extHost/didLoadExtensionCode/${h.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(h){throw new Error("Not supported")}async _waitForDebuggerAttachment(h=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+h;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=(E=self.trustedTypes)===null||E===void 0?void 0:E.createPolicy("ExtensionScripts",{createScript:s=>s});function _(s,h){return s.endsWith(h)?s:s+h}function f(s){h("info","log"),h("log","log"),h("warn","warn"),h("error","error");function h(v,d){console[v]=function(){s.$logExtensionHostMessage({type:"__$console",severity:d,arguments:m(arguments)})}}const p=1e5;function m(v){const d=[],c=[];if(v.length)for(let o=0;o<v.length;o++){if(typeof v[o]=="undefined")v[o]="undefined";else if(v[o]instanceof Error){const t=v[o];t.stack?v[o]=t.stack:v[o]=t.toString()}c.push(v[o])}try{const o=JSON.stringify(c,function(t,r){if(r&&typeof r=="object"){if(d.indexOf(r)!==-1)return"[Circular]";d.push(r)}return r});return o.length>p?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}}),define(we[223],Ee([0,1,61,19,36,222,208]),function(oe,e,b,S,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService),(0,b.registerSingleton)(S.ILogService,y.ExtHostLogService)}),define(we[225],Ee([0,1,26,3,180,217,210,11,77,221,223]),function(oe,e,b,S,T,P,y,k,E){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const A=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const C=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:v=>v}),m=self.Worker;Worker=function(v,d){const c=`importScripts('${v}');`;d=d||{},d.name=d.name||k.basename(v.toString());const o=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(o);return new m(p?p.createScriptURL(t):t,d)}}else self.Worker=class extends y.NestedWorker{constructor(p,m){super(C,p,Object.assign({name:k.basename(p.toString())},m))}};const _=new class{exit(p){A()}async exists(p){return!0}async realpath(p){return p}};class f{constructor(){const m=new MessageChannel,v=new S.Emitter;let d=!1;C(m.port2,[m.port2]),m.port1.onmessage=c=>{const{data:o}=c;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const t=b.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,T.isMessageOfType)(t,2)){d=!0,h("received terminate message from renderer");return}v.fire(t)},this.protocol={onMessage:v.event,send:c=>{if(!d){const o=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);m.port1.postMessage(o,[o])}}}}}function s(p){return new Promise(m=>{const v=p.onMessage(d=>{v.dispose();const c=JSON.parse(d.toString());p.send((0,T.createMessageOfType)(0)),m({protocol:p,initData:c})});p.send((0,T.createMessageOfType)(1))})}let h=p=>A();(function(){const m=new f;E.mark("code/extHost/willConnectToRenderer"),s(m.protocol).then(v=>{E.mark("code/extHost/didWaitForInitData");const d=new P.ExtensionHostMain(v.protocol,v.initData,_,null);h=c=>d.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4b1e9ac57ab3cc942ab9bff09967bf3238a7910/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
